package com.reign.gcld.battle.scene;

package ..deTemp.1740553494702;

import ast.gcldcore.fight.Fight;
import ast.gcldcore.fight.Tactic;
import ast.gcldcore.fight.TroopData;
import com.alibaba.fastjson.JSONObject;
import com.reign.framework.json.JsonBuilder;
import com.reign.framework.json.JsonDocument;
import com.reign.framework.json.State;
import com.reign.framework.netty.servlet.Group;
import com.reign.framework.netty.servlet.GroupManager;
import com.reign.framework.netty.servlet.Session;
import com.reign.framework.netty.util.WrapperUtil;
import com.reign.gcld.activity.domain.ActivityNpc;
import com.reign.gcld.activity.service.ActivityService;
import com.reign.gcld.asynchronousDB.manager.AsynchronousDBOperationManager;
import com.reign.gcld.asynchronousDB.operation.IAsynchronousDBOperation;
import com.reign.gcld.asynchronousDB.operation.basic.AsynchronousDBOperationAddGeneralExp;
import com.reign.gcld.asynchronousDB.operation.basic.AsynchronousDBOperationReduceGeneralHp;
import com.reign.gcld.asynchronousDB.operation.basic.AsynchronousDBOperationResetGeneralState;
import com.reign.gcld.battle.common.AttDef_B;
import com.reign.gcld.battle.common.BattleArmy;
import com.reign.gcld.battle.common.BattleDrop;
import com.reign.gcld.battle.common.BattleResult;
import com.reign.gcld.battle.common.BattleSceneLog;
import com.reign.gcld.battle.common.ErrorSceneLog;
import com.reign.gcld.battle.common.ManWangLingManager;
import com.reign.gcld.battle.common.ManWangLingObj;
import com.reign.gcld.battle.common.OccupyMineInfo;
import com.reign.gcld.battle.common.RoundInfo;
import com.reign.gcld.battle.common.RoundReward;
import com.reign.gcld.battle.common.SpecialGeneral;
import com.reign.gcld.battle.common.TacticInfo;
import com.reign.gcld.battle.common.TeamInfo;
import com.reign.gcld.battle.common.Terrain;
import com.reign.gcld.battle.common.UpdateExp;
import com.reign.gcld.battle.domain.BarbarainExpeditionArmy;
import com.reign.gcld.battle.domain.BarbarainPhantom;
import com.reign.gcld.battle.domain.ExpeditionArmy;
import com.reign.gcld.battle.domain.NationTaskExpeditionArmy;
import com.reign.gcld.battle.domain.PlayerArmy;
import com.reign.gcld.battle.domain.PlayerArmyExtra;
import com.reign.gcld.battle.domain.PlayerArmyReward;
import com.reign.gcld.battle.domain.PlayerBattleAttribute;
import com.reign.gcld.battle.domain.PlayerBattleReward;
import com.reign.gcld.battle.domain.PlayerGeneralMilitaryPhantom;
import com.reign.gcld.battle.domain.PlayerPower;
import com.reign.gcld.battle.domain.ScenarioNpc;
import com.reign.gcld.battle.domain.YellowTurbans;
import com.reign.gcld.battle.reward.RewardInfo;
import com.reign.gcld.battle.scene.BaseInfo;
import com.reign.gcld.battle.scene.Battle;
import com.reign.gcld.battle.scene.BattleAttacker;
import com.reign.gcld.battle.scene.BuilderFactory;
import com.reign.gcld.battle.scene.CampArmy;
import com.reign.gcld.battle.scene.CityBuilder;
import com.reign.gcld.battle.scene.CityNpcBuilder;
import com.reign.gcld.battle.scene.OneVsExtraBuilder;
import com.reign.gcld.battle.scene.OneVsRewardNpcBuilder;
import com.reign.gcld.battle.scene.PlayerInfo;
import com.reign.gcld.battle.service.BattleService;
import com.reign.gcld.battle.service.NewBattleManager;
import com.reign.gcld.catapult.common.CatapultUtil;
import com.reign.gcld.catapult.domain.PlayerCatapult;
import com.reign.gcld.catapult.domain.PlayerCatapultCarpart;
import com.reign.gcld.catapult.domain.PlayerCatapultDriver;
import com.reign.gcld.catapult.domain.PlayerCatapultElement;
import com.reign.gcld.chat.service.ChatType;
import com.reign.gcld.common.Configuration;
import com.reign.gcld.common.IDataGetter;
import com.reign.gcld.common.LocalMessages;
import com.reign.gcld.common.Players;
import com.reign.gcld.common.PushCommand;
import com.reign.gcld.common.log.Logger;
import com.reign.gcld.common.util.WebUtil;
import com.reign.gcld.event.common.BaiNianEvent;
import com.reign.gcld.general.common.GeneralUtils;
import com.reign.gcld.general.domain.PlayerGeneralEvoke;
import com.reign.gcld.general.domain.PlayerGeneralMilitary;
import com.reign.gcld.general.dto.GeneralMoveDto;
import com.reign.gcld.juben.common.JuBenDto;
import com.reign.gcld.juben.service.JuBenManager;
import com.reign.gcld.log.TimerLogger;
import com.reign.gcld.player.domain.Player;
import com.reign.gcld.player.domain.PlayerAttribute;
import com.reign.gcld.player.domain.PlayerResource;
import com.reign.gcld.player.dto.PlayerDto;
import com.reign.gcld.rank.service.RankService;
import com.reign.gcld.sdata.cache.FightStrategiesCache;
import com.reign.gcld.sdata.common.TerrainStrategySpecDto;
import com.reign.gcld.sdata.common.TroopTerrain;
import com.reign.gcld.sdata.domain.Armies;
import com.reign.gcld.sdata.domain.ArmiesExtra;
import com.reign.gcld.sdata.domain.ArmiesReward;
import com.reign.gcld.sdata.domain.Army;
import com.reign.gcld.sdata.domain.Barbarain;
import com.reign.gcld.sdata.domain.BuildingDrawing;
import com.reign.gcld.sdata.domain.Chargeitem;
import com.reign.gcld.sdata.domain.EfLv;
import com.reign.gcld.sdata.domain.EquipCoordinates;
import com.reign.gcld.sdata.domain.EquipJiaotao;
import com.reign.gcld.sdata.domain.EquipJitao;
import com.reign.gcld.sdata.domain.EquipProset;
import com.reign.gcld.sdata.domain.EquipSkillEffect;
import com.reign.gcld.sdata.domain.EvokeGeneral;
import com.reign.gcld.sdata.domain.FightRewardCoe;
import com.reign.gcld.sdata.domain.FightStragtegyCoe;
import com.reign.gcld.sdata.domain.FightStrategies;
import com.reign.gcld.sdata.domain.General;
import com.reign.gcld.sdata.domain.Items;
import com.reign.gcld.sdata.domain.KtSdmzS;
import com.reign.gcld.sdata.domain.Power;
import com.reign.gcld.sdata.domain.Tactic;
import com.reign.gcld.sdata.domain.Task;
import com.reign.gcld.sdata.domain.Troop;
import com.reign.gcld.sdata.domain.TroopConscribe;
import com.reign.gcld.sdata.domain.WorldCity;
import com.reign.gcld.sdata.domain.WorldPaidB;
import com.reign.gcld.silk.domain.PlayerEpic;
import com.reign.gcld.slave.common.SlaveInfo;
import com.reign.gcld.store.domain.StoreHouse;
import com.reign.gcld.strategics.domain.PlayerStrategics;
import com.reign.gcld.strategics.domain.PlayerStrategics1;
import com.reign.gcld.task.domain.PlayerTask;
import com.reign.gcld.task.message.TaskMessageHelper;
import com.reign.gcld.tavern.domain.PlayerTavern;
import com.reign.gcld.team.service.TeamManager;
import com.reign.gcld.tech.common.TechUtils;
import com.reign.gcld.warbeast.domain.PlayerWarBeast;
import com.reign.gcld.weapon.common.WeaponUtils;
import com.reign.gcld.world.domain.City;
import com.reign.gcld.world.service.CityService;
import com.reign.util.MessageFormatter;
import com.reign.util.Tuple;
import com.reign.util.random.RandomUtils;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.atomic.AtomicInteger;
import org.apache.commons.lang.StringUtils;

public abstract class Builder {
  int battleType;
  
  protected static final Logger timerLog = (Logger)new TimerLogger();
  
  public static final int WORLD_CITY_ATTACKER_TACTIC_HALF = 1;
  
  public static final int GUANYU_WUSHENFUTI_TACTIC_HALF = 2;
  
  public static final int GEM_SKILL_RENGXING_TACTIC_HALF = 3;
  
  public static final String REPORT_STATIC_NULL = "0|0|0|0|0|0";
  
  public Tuple<Boolean, String> attPermitCreate(IDataGetter dataGetter, int playerId, int defId) {
    Player player = dataGetter.getPlayerDao().read(playerId);
    Tuple<Boolean, String> tuple = new Tuple();
    tuple.left = Boolean.valueOf(false);
    if (defId > 0) {
      PlayerArmy playerArmy = dataGetter.getPlayerArmyDao().getPlayerArmy(player.getPlayerId().intValue(), defId);
      if (playerArmy == null || playerArmy.getAttackable().intValue() != 1) {
        tuple.right = LocalMessages.AMIES_CANNOT_ATTACKABLE;
        return tuple;
      } 
      Armies armies = (Armies)dataGetter.getArmiesCache().get(Integer.valueOf(defId));
      if (player.getPlayerLv().intValue() < armies.getLevel().intValue()) {
        tuple.right = MessageFormatter.format(LocalMessages.BATTLE_NO_ENOUGH_LEVEL, new Object[] { armies.getLevel() });
        return tuple;
      } 
      if (playerArmy.getPowerId().intValue() == 37 && playerArmy.getWinNum().intValue() <= 0 && playerArmy.getAttNum().intValue() <= 0) {
        PlayerBattleAttribute playerbatatt = dataGetter.getPlayerBattleAttributeDao().read(playerId);
        if (playerbatatt.getWhiteLine().intValue() < 0) {
          tuple.right = "需要搜集满3条线索才可以挑战";
          return tuple;
        } 
        PlayerPower playerpower = dataGetter.getPlayerPowerDao().getPlayerPower(playerId, 37);
        if (playerpower == null) {
          tuple.right = "需要搜集满3条线索才可以挑战";
          return tuple;
        } 
        String powerstr = playerpower.getPowerInfo();
        if (powerstr == null || powerstr.equals("")) {
          tuple.right = "需要搜集满3条线索才可以挑战";
          return tuple;
        } 
        String[] gezilist = powerstr.split("#");
        String[] gezitype = gezilist[0].split(",");
        String[] geziopen = gezilist[1].split(",");
        String[] gezistate = gezilist[2].split(",");
        int openneed = playerArmy.getArmyId().intValue() - 254 + 58;
        if (playerArmy.getArmyId().intValue() >= 259)
          openneed = playerArmy.getArmyId().intValue() - 259 + 58; 
        if (Integer.valueOf(gezistate[openneed - 1]).intValue() < 0 && Integer.valueOf(gezistate[openneed]).intValue() < 0) {
          tuple.right = "城池附近还有迷雾，清除后才可以攻打";
          return tuple;
        } 
      } 
    } 
    JuBenDto juBenDto = JuBenManager.getInstance().getByPid(playerId);
    if (juBenDto != null) {
      tuple.right = LocalMessages.IN_JUBEN_CANNT_BATTLE;
      return tuple;
    } 
    tuple.left = Boolean.valueOf(true);
    tuple.right = "";
    return tuple;
  }
  
  public Tuple<Boolean, byte[]> attPermitBack(IDataGetter dataGetter, int playerId, int defId, int generalId) {
    Tuple<Boolean, byte[]> tuple = new Tuple();
    Battle battle = null;
    Map<Integer, Battle> battles = NewBattleManager.getInstance().getBattleByPid(playerId);
    for (Map.Entry<Integer, Battle> entry : battles.entrySet()) {
      if (((Integer)entry.getKey()).intValue() == 1) {
        battle = entry.getValue();
        break;
      } 
      if (((Integer)entry.getKey()).intValue() == 2) {
        battle = entry.getValue();
        break;
      } 
      if (((Integer)entry.getKey()).intValue() == 11) {
        battle = entry.getValue();
        break;
      } 
      if (((Integer)entry.getKey()).intValue() == 12) {
        battle = entry.getValue();
        break;
      } 
    } 
    if (battle == null) {
      NewBattleManager.inPveBattle(playerId, false);
      tuple.right = JsonBuilder.getJson(State.FAIL, LocalMessages.BATTLE_NOT_EXIST);
      return tuple;
    } 
    JuBenDto juBenDto = JuBenManager.getInstance().getByPid(playerId);
    if (juBenDto != null) {
      tuple.right = JsonBuilder.getJson(State.FAIL, LocalMessages.IN_JUBEN_CANNT_BATTLE);
      return tuple;
    } 
    JsonDocument doc = new JsonDocument();
    doc.startObject();
    doc.createElement("battle", Boolean.valueOf(true));
    doc.createElement("battleId", battle.getBattleId());
    doc.createElement("side", Integer.valueOf(1));
    doc.endObject();
    tuple.left = Boolean.valueOf(true);
    tuple.right = JsonBuilder.getJson(State.SUCCESS, doc.toByte());
    return tuple;
  }
  
  public Battle existBattle(IDataGetter dataGetter, Player player, int defId) {
    return null;
  }
  
  public Tuple<Boolean, String> canCreateBattle(Player player, int defId, IDataGetter dataGetter) {
    Tuple<Boolean, String> tuple = new Tuple();
    tuple.left = Boolean.valueOf(false);
    Armies armies = (Armies)dataGetter.getArmiesCache().get(Integer.valueOf(defId));
    if (armies == null) {
      tuple.right = LocalMessages.T_COMM_10011;
      return tuple;
    } 
    PlayerArmy playerArmy = dataGetter.getPlayerArmyDao().getPlayerArmy(player.getPlayerId().intValue(), defId);
    if (playerArmy == null || playerArmy.getAttackable().intValue() != 1) {
      tuple.right = LocalMessages.AMIES_CANNOT_ATTACKABLE;
      return tuple;
    } 
    if (player.getPlayerLv().intValue() < armies.getLevel().intValue()) {
      tuple.right = MessageFormatter.format(LocalMessages.BATTLE_NO_ENOUGH_LEVEL, new Object[] { armies.getLevel() });
      return tuple;
    } 
    JuBenDto juBenDto = JuBenManager.getInstance().getByPid(player.getPlayerId().intValue());
    if (juBenDto != null) {
      tuple.right = LocalMessages.IN_JUBEN_CANNT_BATTLE;
      return tuple;
    } 
    tuple.left = Boolean.valueOf(true);
    return tuple;
  }
  
  public Tuple<Boolean, String> canJoinBattle(Player player, List<PlayerGeneralMilitary> pgmList, IDataGetter dataGetter, Battle bat) {
    Tuple<Boolean, String> tuple = new Tuple();
    tuple.left = Boolean.valueOf(false);
    int defId = bat.getDefBaseInfo().getId();
    Armies armies = (Armies)dataGetter.getArmiesCache().get(Integer.valueOf(defId));
    if (armies == null)
      tuple.right = LocalMessages.T_COMM_10011; 
    PlayerArmy playerArmy = dataGetter.getPlayerArmyDao().getPlayerArmy(player.getPlayerId().intValue(), defId);
    if (playerArmy == null || playerArmy.getAttackable().intValue() != 1) {
      tuple.right = LocalMessages.AMIES_CANNOT_ATTACKABLE;
      return tuple;
    } 
    if (player.getPlayerLv().intValue() < armies.getLevel().intValue()) {
      tuple.right = MessageFormatter.format(LocalMessages.BATTLE_NO_ENOUGH_LEVEL, new Object[] { armies.getLevel() });
      return tuple;
    } 
    if (bat.getAttBaseInfo().getId() != player.getPlayerId().intValue()) {
      tuple.right = LocalMessages.T_COMM_10012;
      return tuple;
    } 
    JuBenDto juBenDto = JuBenManager.getInstance().getByPid(player.getPlayerId().intValue());
    if (juBenDto != null) {
      tuple.right = LocalMessages.IN_JUBEN_CANNT_BATTLE;
      return tuple;
    } 
    tuple.left = Boolean.valueOf(true);
    return tuple;
  }
  
  public byte[] getOtherBatInfo(IDataGetter dataGetter, int defId, int playerId, int battleSide, PlayerBattleAttribute pba) {
    JsonDocument doc = new JsonDocument();
    doc.createElement("targetName", "");
    if (pba == null)
      pba = dataGetter.getPlayerBattleAttributeDao().read(playerId); 
    doc.createElement("freePhantomCount", pba.getVip3PhantomCount());
    return doc.toByte();
  }
  
  public int getBatInfo(IDataGetter dataGetter, int defId) {
    Armies armies = (Armies)dataGetter.getArmiesCache().get(Integer.valueOf(defId));
    return 100000 + armies.getPowerId().intValue();
  }
  
  public byte[] getRewardModeInfo(IDataGetter dataGetter, PlayerDto playerDto) {
    int playerId = playerDto.playerId;
    JsonDocument doc = new JsonDocument();
    PlayerBattleAttribute pba = dataGetter.getPlayerBattleAttributeDao().read(playerId);
    doc.createElement("cost1", ((Chargeitem)dataGetter.getChargeitemCache().get(Integer.valueOf(14))).getCost());
    doc.createElement("cost2", ((Chargeitem)dataGetter.getChargeitemCache().get(Integer.valueOf(15))).getCost());
    long time = pba.getSupportTime().getTime() - System.currentTimeMillis();
    doc.createElement("time", Long.valueOf((time > 0L) ? time : 0L));
    if (time > 0L) {
      doc.createElement("mode", pba.getType());
    } else {
      doc.createElement("mode", Integer.valueOf(0));
    } 
    return doc.toByte();
  }
  
  public byte[] getPrepareInfo(IDataGetter dataGetter, PlayerDto playerDto, int defId, Battle battle, int terrain) {
    int playerId = playerDto.playerId;
    JsonDocument doc = new JsonDocument();
    List<PlayerGeneralMilitary> pgmList = dataGetter.getPlayerGeneralMilitaryDao().getMilitaryList(playerId);
    Armies armies = (Armies)dataGetter.getArmiesCache().get(Integer.valueOf(defId));
    doc.createElement("name", armies.getName());
    doc.createElement("intro", armies.getIntro());
    doc.createElement("bat", Integer.valueOf(100000 + armies.getPowerId().intValue()));
    PlayerResource pr = dataGetter.getPlayerResourceDao().read(playerId);
    doc.createElement("food", armies.getFoodConsume());
    doc.createElement("color", Boolean.valueOf((pr.getFood().longValue() >= armies.getFoodConsume().intValue())));
    doc.appendJson(getAttTopLeft(dataGetter, playerId, battle));
    doc.appendJson(getDefTopRight(dataGetter, playerId, battle, armies.getChief().intValue()));
    doc.appendJson(getAttGenerals(dataGetter, playerId, pgmList, playerDto.forceId, terrain));
    doc.appendJson(getDefGenerals(dataGetter, playerId, armies, terrain));
    return doc.toByte();
  }
  
  public byte[] getAttTopLeft(IDataGetter dataGetter, int playerId, Battle battle) {
    JsonDocument doc = new JsonDocument();
    Player attPlayer = dataGetter.getPlayerDao().read(playerId);
    doc.createElement("playerId", attPlayer.getPlayerId());
    doc.createElement("playerName", attPlayer.getPlayerName());
    doc.createElement("playerPic", attPlayer.getPic());
    doc.createElement("playerLv", attPlayer.getPlayerLv());
    if (battle != null) {
      doc.createElement("playerForces", Integer.valueOf(battle.getAttBaseInfo().getNum()));
      doc.createElement("playerMaxForces", Integer.valueOf(battle.getAttBaseInfo().getAllNum()));
    } 
    return doc.toByte();
  }
  
  public byte[] getDefTopRight(IDataGetter dataGetter, int playerId, Battle battle, int armyId) {
    JsonDocument doc = new JsonDocument();
    Army army = (Army)dataGetter.getArmyCache().get(Integer.valueOf(armyId));
    General general = (General)dataGetter.getGeneralCache().get(army.getGeneralId());
    doc.createElement("npcId", army.getGeneralId());
    doc.createElement("npcName", general.getName());
    doc.createElement("npcPic", general.getPic());
    doc.createElement("npcLv", army.getGeneralLv());
    if (battle != null) {
      doc.createElement("npcForces", Integer.valueOf(battle.getDefBaseInfo().getNum()));
      doc.createElement("npcMaxForces", Integer.valueOf(battle.getDefBaseInfo().getAllNum()));
    } 
    return doc.toByte();
  }
  
  public byte[] getBattleTopInfo(IDataGetter dataGetter, PlayerDto playerDto, Battle battle) {
    JsonDocument doc = new JsonDocument();
    Armies armies = (Armies)dataGetter.getArmiesCache().get(Integer.valueOf(battle.getDefBaseInfo().getId()));
    doc.createElement("name", armies.getName());
    doc.createElement("intro", armies.getIntro());
    doc.createElement("bat", Integer.valueOf(100000 + armies.getPowerId().intValue()));
    doc.appendJson(getAttTopLeft(dataGetter, playerDto.playerId, battle));
    doc.appendJson(getDefTopRight(dataGetter, playerDto.playerId, battle, armies.getChief().intValue()));
    return doc.toByte();
  }
  
  public void reorderPGMList(IDataGetter dataGetter, List<PlayerGeneralMilitary> pgmList) {
    if (pgmList == null || pgmList.size() == 0)
      return; 
    int playerId = ((PlayerGeneralMilitary)pgmList.get(0)).getPlayerId().intValue();
    PlayerBattleAttribute pba = dataGetter.getPlayerBattleAttributeDao().read(playerId);
    String armiesBattleOrder = pba.getArmiesBattleOrder();
    if (armiesBattleOrder == null)
      return; 
    List<PlayerGeneralMilitary> pgmListNew = new ArrayList<>(pgmList.size());
    List<Integer> ids = new ArrayList<>(5);
    String[] split = armiesBattleOrder.split("#");
    for (int k = 0; k < split.length; k++) {
      String s = split[k];
      if (!s.equals(""))
        ids.add(Integer.valueOf(Integer.parseInt(s))); 
    } 
    PlayerGeneralMilitary pgm = null;
    for (Integer id : ids) {
      for (int i = 0; i < pgmList.size(); i++) {
        pgm = pgmList.get(i);
        int armyHp = pgm.getForces().intValue();
        int maxHp = dataGetter.getBattleDataCache().getMaxHp(pgm);
        if (pgm.getState().intValue() <= 1 && armyHp * 1.0D / maxHp >= 0.05D && pgm.getGeneralId().equals(id))
          pgmListNew.add(pgm); 
      } 
    } 
    for (PlayerGeneralMilitary temp : pgmListNew)
      pgmList.remove(temp); 
    for (PlayerGeneralMilitary temp : pgmList)
      pgmListNew.add(temp); 
    pgmList.clear();
    for (int j = 0; j < pgmListNew.size(); j++)
      pgmList.add(pgmListNew.get(j)); 
  }
  
  public byte[] getAttGenerals(IDataGetter dataGetter, int playerId, List<PlayerGeneralMilitary> pgmList, int forceId, int terrain) {
    // Byte code:
    //   0: aload_0
    //   1: aload_1
    //   2: aload_3
    //   3: invokevirtual reorderPGMList : (Lcom/reign/gcld/common/IDataGetter;Ljava/util/List;)V
    //   6: new com/reign/framework/json/JsonDocument
    //   9: dup
    //   10: invokespecial <init> : ()V
    //   13: astore #6
    //   15: aload #6
    //   17: ldc_w 'attGenerals'
    //   20: invokevirtual startArray : (Ljava/lang/String;)V
    //   23: lconst_0
    //   24: lstore #7
    //   26: new java/util/HashMap
    //   29: dup
    //   30: invokespecial <init> : ()V
    //   33: astore #9
    //   35: iconst_0
    //   36: istore #10
    //   38: goto -> 3323
    //   41: aload #6
    //   43: invokevirtual startObject : ()V
    //   46: aload_3
    //   47: iload #10
    //   49: invokeinterface get : (I)Ljava/lang/Object;
    //   54: checkcast com/reign/gcld/general/domain/PlayerGeneralMilitary
    //   57: astore #11
    //   59: aload_1
    //   60: invokeinterface getGeneralCache : ()Lcom/reign/gcld/sdata/cache/GeneralCache;
    //   65: aload #11
    //   67: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   70: invokevirtual get : (Ljava/lang/Object;)Ljava/lang/Object;
    //   73: checkcast com/reign/gcld/sdata/domain/General
    //   76: astore #12
    //   78: aload #6
    //   80: ldc_w 'index'
    //   83: iload #10
    //   85: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   88: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   91: aload #6
    //   93: ldc_w 'generalId'
    //   96: aload #11
    //   98: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   101: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   104: aload #6
    //   106: ldc_w 'generalName'
    //   109: aload #12
    //   111: invokevirtual getName : ()Ljava/lang/String;
    //   114: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   117: aload #6
    //   119: ldc_w 'generalLv'
    //   122: aload #11
    //   124: invokevirtual getLv : ()Ljava/lang/Integer;
    //   127: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   130: aload #12
    //   132: invokevirtual getName : ()Ljava/lang/String;
    //   135: astore #13
    //   137: iconst_0
    //   138: istore #14
    //   140: iload_2
    //   141: ifle -> 199
    //   144: aload #11
    //   146: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   149: invokevirtual intValue : ()I
    //   152: sipush #202
    //   155: if_icmpne -> 199
    //   158: aload_1
    //   159: invokeinterface getPlayerGeneralEvokeDao : ()Lcom/reign/gcld/general/dao/IPlayerGeneralEvokeDao;
    //   164: iload_2
    //   165: aload #11
    //   167: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   170: invokevirtual intValue : ()I
    //   173: invokeinterface getPlayerGeneralEvoke : (II)Lcom/reign/gcld/general/domain/PlayerGeneralEvoke;
    //   178: astore #15
    //   180: aload #15
    //   182: ifnull -> 199
    //   185: aload #15
    //   187: invokevirtual getShenJiang : ()Ljava/lang/Integer;
    //   190: invokevirtual intValue : ()I
    //   193: ifle -> 199
    //   196: iconst_1
    //   197: istore #14
    //   199: iconst_0
    //   200: istore #15
    //   202: aload #11
    //   204: invokevirtual getDeputyId : ()Ljava/lang/Integer;
    //   207: ifnull -> 358
    //   210: aload #11
    //   212: invokevirtual getDeputyId : ()Ljava/lang/Integer;
    //   215: invokevirtual intValue : ()I
    //   218: ifle -> 358
    //   221: aload_1
    //   222: invokeinterface getGeneralCache : ()Lcom/reign/gcld/sdata/cache/GeneralCache;
    //   227: aload #11
    //   229: invokevirtual getDeputyId : ()Ljava/lang/Integer;
    //   232: invokevirtual get : (Ljava/lang/Object;)Ljava/lang/Object;
    //   235: checkcast com/reign/gcld/sdata/domain/General
    //   238: astore #16
    //   240: aload #6
    //   242: ldc_w 'isChief'
    //   245: iconst_1
    //   246: invokestatic valueOf : (Z)Ljava/lang/Boolean;
    //   249: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   252: aload #6
    //   254: ldc_w 'deputyGeneralId'
    //   257: aload #11
    //   259: invokevirtual getDeputyId : ()Ljava/lang/Integer;
    //   262: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   265: aload #6
    //   267: ldc_w 'deputyPic'
    //   270: aload #16
    //   272: invokevirtual getPic : ()Ljava/lang/String;
    //   275: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   278: aload_1
    //   279: invokeinterface getPlayerGeneralMilitaryDao : ()Lcom/reign/gcld/general/dao/IPlayerGeneralMilitaryDao;
    //   284: iload_2
    //   285: aload #11
    //   287: invokevirtual getDeputyId : ()Ljava/lang/Integer;
    //   290: invokevirtual intValue : ()I
    //   293: invokeinterface getMilitary : (II)Lcom/reign/gcld/general/domain/PlayerGeneralMilitary;
    //   298: astore #17
    //   300: aload #17
    //   302: ifnull -> 318
    //   305: aload #17
    //   307: invokevirtual getForces : ()Ljava/lang/Integer;
    //   310: invokevirtual intValue : ()I
    //   313: istore #15
    //   315: goto -> 358
    //   318: invokestatic getInstance : ()Lcom/reign/gcld/battle/common/ErrorSceneLog;
    //   321: new java/lang/StringBuilder
    //   324: dup
    //   325: ldc_w '玩家：'
    //   328: invokespecial <init> : (Ljava/lang/String;)V
    //   331: iload_2
    //   332: invokevirtual append : (I)Ljava/lang/StringBuilder;
    //   335: ldc_w '的副将为空，副将id:'
    //   338: invokevirtual append : (Ljava/lang/String;)Ljava/lang/StringBuilder;
    //   341: aload #11
    //   343: invokevirtual getDeputyId : ()Ljava/lang/Integer;
    //   346: invokevirtual append : (Ljava/lang/Object;)Ljava/lang/StringBuilder;
    //   349: invokevirtual toString : ()Ljava/lang/String;
    //   352: invokevirtual appendErrorMsg : (Ljava/lang/String;)Lcom/reign/gcld/battle/common/ErrorSceneLog;
    //   355: invokevirtual flush : ()V
    //   358: aload #6
    //   360: ldc_w 'helperGeneralId'
    //   363: aload #11
    //   365: invokevirtual getHelpGeneral : ()Ljava/lang/Integer;
    //   368: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   371: aload #11
    //   373: invokevirtual getHelpGeneral : ()Ljava/lang/Integer;
    //   376: invokevirtual intValue : ()I
    //   379: ifle -> 588
    //   382: ldc_w 'sunshangxiang'
    //   385: astore #16
    //   387: sipush #3501
    //   390: istore #17
    //   392: aload #11
    //   394: invokevirtual getHelpGeneral : ()Ljava/lang/Integer;
    //   397: invokevirtual intValue : ()I
    //   400: sipush #403
    //   403: if_icmpne -> 419
    //   406: ldc_w 'huanggai'
    //   409: astore #16
    //   411: sipush #3604
    //   414: istore #17
    //   416: goto -> 551
    //   419: aload #11
    //   421: invokevirtual getHelpGeneral : ()Ljava/lang/Integer;
    //   424: invokevirtual intValue : ()I
    //   427: sipush #404
    //   430: if_icmpne -> 446
    //   433: ldc_w 'lvmeng'
    //   436: astore #16
    //   438: sipush #3701
    //   441: istore #17
    //   443: goto -> 551
    //   446: aload #11
    //   448: invokevirtual getHelpGeneral : ()Ljava/lang/Integer;
    //   451: invokevirtual intValue : ()I
    //   454: sipush #405
    //   457: if_icmpne -> 473
    //   460: ldc_w 'huangyueying2j'
    //   463: astore #16
    //   465: sipush #3002
    //   468: istore #17
    //   470: goto -> 551
    //   473: aload #11
    //   475: invokevirtual getHelpGeneral : ()Ljava/lang/Integer;
    //   478: invokevirtual intValue : ()I
    //   481: sipush #406
    //   484: if_icmpne -> 500
    //   487: ldc_w 'jiangweijx'
    //   490: astore #16
    //   492: sipush #1201
    //   495: istore #17
    //   497: goto -> 551
    //   500: aload #11
    //   502: invokevirtual getHelpGeneral : ()Ljava/lang/Integer;
    //   505: invokevirtual intValue : ()I
    //   508: sipush #407
    //   511: if_icmpne -> 527
    //   514: ldc_w 'diaochanjx2'
    //   517: astore #16
    //   519: sipush #1701
    //   522: istore #17
    //   524: goto -> 551
    //   527: aload #11
    //   529: invokevirtual getHelpGeneral : ()Ljava/lang/Integer;
    //   532: invokevirtual intValue : ()I
    //   535: sipush #277
    //   538: if_icmpne -> 551
    //   541: ldc_w 'liubei2'
    //   544: astore #16
    //   546: sipush #2601
    //   549: istore #17
    //   551: aload #6
    //   553: ldc_w 'helperpic'
    //   556: aload #16
    //   558: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   561: aload #6
    //   563: ldc_w 'helpGeneralCostFood'
    //   566: ldc_w 500000
    //   569: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   572: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   575: aload #6
    //   577: ldc_w 'helperTacticId'
    //   580: iload #17
    //   582: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   585: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   588: aload #6
    //   590: ldc_w 'quality'
    //   593: iload #14
    //   595: ifeq -> 603
    //   598: bipush #7
    //   600: goto -> 611
    //   603: aload #12
    //   605: invokevirtual getQuality : ()Ljava/lang/Integer;
    //   608: invokevirtual intValue : ()I
    //   611: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   614: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   617: aload_1
    //   618: invokeinterface getPlayerDao : ()Lcom/reign/gcld/player/dao/IPlayerDao;
    //   623: aload #11
    //   625: invokevirtual getPlayerId : ()Ljava/lang/Integer;
    //   628: invokevirtual intValue : ()I
    //   631: invokeinterface read : (I)Lcom/reign/gcld/player/domain/Player;
    //   636: astore #16
    //   638: aload_1
    //   639: invokeinterface getTroopCache : ()Lcom/reign/gcld/sdata/cache/TroopCache;
    //   644: aload #12
    //   646: invokevirtual getTroop : ()Ljava/lang/Integer;
    //   649: invokevirtual intValue : ()I
    //   652: aload #16
    //   654: invokevirtual getPlayerId : ()Ljava/lang/Integer;
    //   657: invokevirtual intValue : ()I
    //   660: invokevirtual getTroop : (II)Lcom/reign/gcld/sdata/domain/Troop;
    //   663: astore #17
    //   665: aload #17
    //   667: invokevirtual getTerrains : ()Ljava/util/Map;
    //   670: iload #5
    //   672: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   675: invokeinterface get : (Ljava/lang/Object;)Ljava/lang/Object;
    //   680: checkcast com/reign/gcld/sdata/common/TroopTerrain
    //   683: astore #18
    //   685: aload #18
    //   687: ifnull -> 730
    //   690: aload #18
    //   692: invokevirtual getAttEffect : ()I
    //   695: ifle -> 730
    //   698: aload #6
    //   700: ldc_w 'terrainAdd'
    //   703: aload #18
    //   705: invokevirtual getAttEffect : ()I
    //   708: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   711: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   714: aload #6
    //   716: ldc_w 'terrainQ'
    //   719: aload #18
    //   721: invokevirtual getAttQuality : ()I
    //   724: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   727: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   730: aload #11
    //   732: invokevirtual getPlayerId : ()Ljava/lang/Integer;
    //   735: invokevirtual intValue : ()I
    //   738: aload #11
    //   740: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   743: invokevirtual intValue : ()I
    //   746: invokestatic getGeneralMoveDto : (II)Lcom/reign/gcld/general/dto/GeneralMoveDto;
    //   749: astore #19
    //   751: aload #17
    //   753: invokevirtual getTsstList : ()Ljava/util/List;
    //   756: astore #20
    //   758: aload #20
    //   760: ifnull -> 943
    //   763: aload #20
    //   765: invokeinterface size : ()I
    //   770: ifle -> 943
    //   773: new java/util/LinkedList
    //   776: dup
    //   777: invokespecial <init> : ()V
    //   780: astore #21
    //   782: aload #20
    //   784: invokeinterface iterator : ()Ljava/util/Iterator;
    //   789: astore #23
    //   791: goto -> 850
    //   794: aload #23
    //   796: invokeinterface next : ()Ljava/lang/Object;
    //   801: checkcast com/reign/gcld/sdata/common/TerrainStrategySpecDto
    //   804: astore #22
    //   806: aload #22
    //   808: getfield terrainId : I
    //   811: iload #5
    //   813: if_icmpne -> 850
    //   816: aload #22
    //   818: getfield show : I
    //   821: iconst_1
    //   822: if_icmpeq -> 834
    //   825: aload #22
    //   827: getfield show : I
    //   830: iconst_3
    //   831: if_icmpne -> 850
    //   834: aload #21
    //   836: aload #22
    //   838: getfield strategyId : I
    //   841: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   844: invokeinterface add : (Ljava/lang/Object;)Z
    //   849: pop
    //   850: aload #23
    //   852: invokeinterface hasNext : ()Z
    //   857: ifne -> 794
    //   860: aload #21
    //   862: invokeinterface size : ()I
    //   867: ifle -> 943
    //   870: aload #6
    //   872: ldc_w 'tssList'
    //   875: invokevirtual startArray : (Ljava/lang/String;)V
    //   878: aload #20
    //   880: invokeinterface iterator : ()Ljava/util/Iterator;
    //   885: astore #23
    //   887: goto -> 928
    //   890: aload #23
    //   892: invokeinterface next : ()Ljava/lang/Object;
    //   897: checkcast com/reign/gcld/sdata/common/TerrainStrategySpecDto
    //   900: astore #22
    //   902: aload #6
    //   904: invokevirtual startObject : ()V
    //   907: aload #6
    //   909: ldc_w 'strategyId'
    //   912: aload #22
    //   914: getfield strategyId : I
    //   917: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   920: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   923: aload #6
    //   925: invokevirtual endObject : ()V
    //   928: aload #23
    //   930: invokeinterface hasNext : ()Z
    //   935: ifne -> 890
    //   938: aload #6
    //   940: invokevirtual endArray : ()V
    //   943: aload #6
    //   945: ldc_w 'troopId'
    //   948: aload #17
    //   950: invokevirtual getType : ()Ljava/lang/Integer;
    //   953: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   956: aload #6
    //   958: ldc_w 'troopType'
    //   961: aload #17
    //   963: invokevirtual getSerial : ()Ljava/lang/Integer;
    //   966: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   969: aload #11
    //   971: invokevirtual getForces : ()Ljava/lang/Integer;
    //   974: invokevirtual intValue : ()I
    //   977: i2l
    //   978: lstore #7
    //   980: aload_1
    //   981: invokeinterface getBattleDataCache : ()Lcom/reign/gcld/battle/service/BattleDataCache;
    //   986: aload #11
    //   988: invokevirtual getMaxHp : (Lcom/reign/gcld/general/domain/PlayerGeneralMilitary;)I
    //   991: istore #21
    //   993: aload #11
    //   995: invokevirtual getState : ()Ljava/lang/Integer;
    //   998: invokevirtual intValue : ()I
    //   1001: iconst_2
    //   1002: if_icmpne -> 1031
    //   1005: aload #6
    //   1007: ldc_w 'state'
    //   1010: iconst_2
    //   1011: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   1014: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   1017: aload #6
    //   1019: ldc_w 'reason'
    //   1022: getstatic com/reign/gcld/common/LocalMessages.BATTLE_INT_BATTLE_ARMY : Ljava/lang/String;
    //   1025: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   1028: goto -> 1334
    //   1031: aload #11
    //   1033: invokevirtual getState : ()Ljava/lang/Integer;
    //   1036: invokevirtual intValue : ()I
    //   1039: iconst_3
    //   1040: if_icmpne -> 1069
    //   1043: aload #6
    //   1045: ldc_w 'state'
    //   1048: iconst_3
    //   1049: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   1052: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   1055: aload #6
    //   1057: ldc_w 'reason'
    //   1060: getstatic com/reign/gcld/common/LocalMessages.BATTLE_INT_BATTLE_WORLD_CITY : Ljava/lang/String;
    //   1063: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   1066: goto -> 1334
    //   1069: aload_0
    //   1070: lload #7
    //   1072: l2d
    //   1073: iload #21
    //   1075: i2d
    //   1076: invokevirtual canJoinBattle : (DD)Z
    //   1079: ifne -> 1108
    //   1082: aload #6
    //   1084: ldc_w 'state'
    //   1087: iconst_4
    //   1088: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   1091: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   1094: aload #6
    //   1096: ldc_w 'reason'
    //   1099: getstatic com/reign/gcld/common/LocalMessages.BATTLE_INT_BATTLE_BLOOD_NO_ENOUGH : Ljava/lang/String;
    //   1102: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   1105: goto -> 1334
    //   1108: aload #11
    //   1110: invokevirtual getState : ()Ljava/lang/Integer;
    //   1113: invokevirtual intValue : ()I
    //   1116: iconst_4
    //   1117: if_icmpne -> 1146
    //   1120: aload #6
    //   1122: ldc_w 'state'
    //   1125: iconst_5
    //   1126: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   1129: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   1132: aload #6
    //   1134: ldc_w 'reason'
    //   1137: getstatic com/reign/gcld/common/LocalMessages.BATTLE_INT_BATTLE_OCCUPY : Ljava/lang/String;
    //   1140: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   1143: goto -> 1334
    //   1146: aload #11
    //   1148: invokevirtual getState : ()Ljava/lang/Integer;
    //   1151: invokevirtual intValue : ()I
    //   1154: bipush #10
    //   1156: if_icmpne -> 1186
    //   1159: aload #6
    //   1161: ldc_w 'state'
    //   1164: bipush #11
    //   1166: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   1169: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   1172: aload #6
    //   1174: ldc_w 'reason'
    //   1177: getstatic com/reign/gcld/common/LocalMessages.BATTLE_INT_BATTLE_CITY : Ljava/lang/String;
    //   1180: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   1183: goto -> 1334
    //   1186: aload #11
    //   1188: invokevirtual getState : ()Ljava/lang/Integer;
    //   1191: invokevirtual intValue : ()I
    //   1194: iconst_1
    //   1195: if_icmple -> 1225
    //   1198: aload #6
    //   1200: ldc_w 'state'
    //   1203: bipush #100
    //   1205: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   1208: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   1211: aload #6
    //   1213: ldc_w 'reason'
    //   1216: getstatic com/reign/gcld/common/LocalMessages.BATTLE_INT_BATTLE : Ljava/lang/String;
    //   1219: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   1222: goto -> 1334
    //   1225: invokestatic getInstance : ()Lcom/reign/gcld/team/service/TeamManager;
    //   1228: iload_2
    //   1229: aload #11
    //   1231: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1234: invokevirtual intValue : ()I
    //   1237: invokevirtual isJoinTeam : (II)Z
    //   1240: ifeq -> 1270
    //   1243: aload #6
    //   1245: ldc_w 'state'
    //   1248: bipush #10
    //   1250: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   1253: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   1256: aload #6
    //   1258: ldc_w 'reason'
    //   1261: getstatic com/reign/gcld/common/LocalMessages.BATTLE_IN_GROUP_ARMY : Ljava/lang/String;
    //   1264: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   1267: goto -> 1334
    //   1270: aload #19
    //   1272: ifnull -> 1322
    //   1275: aload #19
    //   1277: getfield cityState : I
    //   1280: bipush #22
    //   1282: if_icmpeq -> 1295
    //   1285: aload #19
    //   1287: getfield cityState : I
    //   1290: bipush #23
    //   1292: if_icmpne -> 1322
    //   1295: aload #6
    //   1297: ldc_w 'state'
    //   1300: bipush #12
    //   1302: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   1305: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   1308: aload #6
    //   1310: ldc_w 'reason'
    //   1313: getstatic com/reign/gcld/common/LocalMessages.GENTEAL_IN_CELL : Ljava/lang/String;
    //   1316: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   1319: goto -> 1334
    //   1322: aload #6
    //   1324: ldc_w 'state'
    //   1327: iconst_1
    //   1328: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   1331: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   1334: iconst_0
    //   1335: istore #22
    //   1337: aload #11
    //   1339: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1342: invokevirtual intValue : ()I
    //   1345: sipush #204
    //   1348: if_icmpne -> 1413
    //   1351: aload_1
    //   1352: invokeinterface getPlayerGeneralEvokeDao : ()Lcom/reign/gcld/general/dao/IPlayerGeneralEvokeDao;
    //   1357: iload_2
    //   1358: aload #11
    //   1360: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1363: invokevirtual intValue : ()I
    //   1366: invokeinterface getPlayerGeneralEvoke : (II)Lcom/reign/gcld/general/domain/PlayerGeneralEvoke;
    //   1371: astore #23
    //   1373: aload #23
    //   1375: ifnull -> 1413
    //   1378: aload #23
    //   1380: invokevirtual getEvokeSkillFinal : ()Ljava/lang/Integer;
    //   1383: invokevirtual intValue : ()I
    //   1386: ifle -> 1413
    //   1389: aload #23
    //   1391: invokevirtual getLegendInfo : ()Ljava/lang/String;
    //   1394: ifnull -> 1410
    //   1397: ldc ''
    //   1399: aload #23
    //   1401: invokevirtual getLegendInfo : ()Ljava/lang/String;
    //   1404: invokevirtual equals : (Ljava/lang/Object;)Z
    //   1407: ifeq -> 1413
    //   1410: iconst_1
    //   1411: istore #22
    //   1413: iload #14
    //   1415: ifeq -> 1424
    //   1418: ldc_w 'shenzhangfei'
    //   1421: goto -> 1429
    //   1424: aload #12
    //   1426: invokevirtual getPic : ()Ljava/lang/String;
    //   1429: astore #23
    //   1431: aload #11
    //   1433: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1436: invokevirtual intValue : ()I
    //   1439: bipush #103
    //   1441: if_icmpeq -> 1506
    //   1444: aload #11
    //   1446: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1449: invokevirtual intValue : ()I
    //   1452: sipush #277
    //   1455: if_icmpne -> 1462
    //   1458: iconst_1
    //   1459: goto -> 1463
    //   1462: iconst_0
    //   1463: aload #11
    //   1465: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1468: invokevirtual intValue : ()I
    //   1471: sipush #201
    //   1474: if_icmpne -> 1481
    //   1477: iconst_1
    //   1478: goto -> 1482
    //   1481: iconst_0
    //   1482: ior
    //   1483: aload #11
    //   1485: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1488: invokevirtual intValue : ()I
    //   1491: sipush #270
    //   1494: if_icmpne -> 1501
    //   1497: iconst_1
    //   1498: goto -> 1502
    //   1501: iconst_0
    //   1502: ior
    //   1503: ifeq -> 1650
    //   1506: aload_1
    //   1507: invokeinterface getPlayerGeneralEvokeDao : ()Lcom/reign/gcld/general/dao/IPlayerGeneralEvokeDao;
    //   1512: iload_2
    //   1513: aload #11
    //   1515: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1518: invokevirtual intValue : ()I
    //   1521: invokeinterface getPlayerGeneralEvoke : (II)Lcom/reign/gcld/general/domain/PlayerGeneralEvoke;
    //   1526: astore #24
    //   1528: aload #24
    //   1530: ifnull -> 1650
    //   1533: aload #24
    //   1535: invokevirtual getUnionEvoke : ()Ljava/lang/Integer;
    //   1538: invokevirtual intValue : ()I
    //   1541: ifle -> 1650
    //   1544: aload #11
    //   1546: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1549: invokevirtual intValue : ()I
    //   1552: bipush #103
    //   1554: if_icmpne -> 1565
    //   1557: ldc_w 'zhouyujx_zhugeliangjx'
    //   1560: astore #23
    //   1562: goto -> 1650
    //   1565: aload #11
    //   1567: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1570: invokevirtual intValue : ()I
    //   1573: sipush #277
    //   1576: if_icmpne -> 1587
    //   1579: ldc_w 'liuguanzhang'
    //   1582: astore #23
    //   1584: goto -> 1650
    //   1587: aload #11
    //   1589: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1592: invokevirtual intValue : ()I
    //   1595: sipush #201
    //   1598: if_icmpne -> 1609
    //   1601: ldc_w 'lvbudiaochanjx'
    //   1604: astore #23
    //   1606: goto -> 1650
    //   1609: aload #11
    //   1611: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1614: invokevirtual intValue : ()I
    //   1617: sipush #270
    //   1620: if_icmpne -> 1631
    //   1623: ldc_w 'xiahoudun_xiahouyuanjx1'
    //   1626: astore #23
    //   1628: goto -> 1650
    //   1631: aload #11
    //   1633: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1636: invokevirtual intValue : ()I
    //   1639: sipush #232
    //   1642: if_icmpne -> 1650
    //   1645: ldc_w 'xiahoudun_xiahouyuanjx1'
    //   1648: astore #23
    //   1650: aload_1
    //   1651: invokeinterface getPlayerGeneralEvokeDao : ()Lcom/reign/gcld/general/dao/IPlayerGeneralEvokeDao;
    //   1656: iload_2
    //   1657: aload #11
    //   1659: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1662: invokevirtual intValue : ()I
    //   1665: invokeinterface getPlayerGeneralEvoke : (II)Lcom/reign/gcld/general/domain/PlayerGeneralEvoke;
    //   1670: astore #24
    //   1672: aload #11
    //   1674: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1677: invokevirtual intValue : ()I
    //   1680: sipush #232
    //   1683: if_icmpne -> 1716
    //   1686: aload #24
    //   1688: invokevirtual getUnionEvoke : ()Ljava/lang/Integer;
    //   1691: invokevirtual intValue : ()I
    //   1694: ifle -> 1716
    //   1697: aload #11
    //   1699: invokevirtual getDeputyId : ()Ljava/lang/Integer;
    //   1702: invokevirtual intValue : ()I
    //   1705: sipush #274
    //   1708: if_icmpne -> 1716
    //   1711: ldc_w '南中之主'
    //   1714: astore #13
    //   1716: aload #11
    //   1718: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1721: invokevirtual intValue : ()I
    //   1724: sipush #201
    //   1727: if_icmpne -> 1760
    //   1730: aload #24
    //   1732: invokevirtual getUnionEvoke : ()Ljava/lang/Integer;
    //   1735: invokevirtual intValue : ()I
    //   1738: ifle -> 1760
    //   1741: aload #11
    //   1743: invokevirtual getDeputyId : ()Ljava/lang/Integer;
    //   1746: invokevirtual intValue : ()I
    //   1749: sipush #266
    //   1752: if_icmpne -> 1760
    //   1755: ldc_w '乱世眷侣'
    //   1758: astore #13
    //   1760: aload #11
    //   1762: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1765: invokevirtual intValue : ()I
    //   1768: sipush #270
    //   1771: if_icmpne -> 1804
    //   1774: aload #24
    //   1776: invokevirtual getUnionEvoke : ()Ljava/lang/Integer;
    //   1779: invokevirtual intValue : ()I
    //   1782: ifle -> 1804
    //   1785: aload #11
    //   1787: invokevirtual getDeputyId : ()Ljava/lang/Integer;
    //   1790: invokevirtual intValue : ()I
    //   1793: sipush #273
    //   1796: if_icmpne -> 1804
    //   1799: ldc_w '夏侯兄弟'
    //   1802: astore #13
    //   1804: aload #11
    //   1806: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1809: invokevirtual intValue : ()I
    //   1812: sipush #277
    //   1815: if_icmpne -> 1834
    //   1818: aload #24
    //   1820: invokevirtual getUnionEvoke : ()Ljava/lang/Integer;
    //   1823: invokevirtual intValue : ()I
    //   1826: ifle -> 1834
    //   1829: ldc_w '桃园之誓'
    //   1832: astore #13
    //   1834: aload #24
    //   1836: invokevirtual getUnionEvoke : ()Ljava/lang/Integer;
    //   1839: invokevirtual intValue : ()I
    //   1842: ifle -> 1877
    //   1845: aload #11
    //   1847: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1850: invokevirtual intValue : ()I
    //   1853: bipush #103
    //   1855: if_icmpne -> 1877
    //   1858: aload #11
    //   1860: invokevirtual getDeputyId : ()Ljava/lang/Integer;
    //   1863: invokevirtual intValue : ()I
    //   1866: sipush #269
    //   1869: if_icmpne -> 1877
    //   1872: ldc_w '赤壁奇谋'
    //   1875: astore #13
    //   1877: aload #24
    //   1879: ifnonnull -> 1903
    //   1882: aload #24
    //   1884: invokevirtual getLegendInfo : ()Ljava/lang/String;
    //   1887: ifnonnull -> 1903
    //   1890: aload #24
    //   1892: invokevirtual getLegendInfo : ()Ljava/lang/String;
    //   1895: ldc ''
    //   1897: invokevirtual equals : (Ljava/lang/Object;)Z
    //   1900: ifne -> 2865
    //   1903: getstatic java/lang/System.out : Ljava/io/PrintStream;
    //   1906: aload #24
    //   1908: invokevirtual println : (Ljava/lang/Object;)V
    //   1911: aload #24
    //   1913: invokevirtual getLegendInfo : ()Ljava/lang/String;
    //   1916: invokestatic parseObject : (Ljava/lang/String;)Lcom/alibaba/fastjson/JSONObject;
    //   1919: astore #25
    //   1921: aload #25
    //   1923: ldc_w 'chapterInfo'
    //   1926: invokevirtual get : (Ljava/lang/Object;)Ljava/lang/Object;
    //   1929: checkcast java/lang/String
    //   1932: astore #26
    //   1934: aload #26
    //   1936: ldc_w ':'
    //   1939: invokevirtual split : (Ljava/lang/String;)[Ljava/lang/String;
    //   1942: astore #27
    //   1944: aload #25
    //   1946: ldc_w 'chapterId'
    //   1949: invokevirtual getIntValue : (Ljava/lang/String;)I
    //   1952: istore #28
    //   1954: aload #11
    //   1956: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   1959: invokevirtual intValue : ()I
    //   1962: sipush #204
    //   1965: if_icmpne -> 2104
    //   1968: aload #27
    //   1970: iload #28
    //   1972: iconst_1
    //   1973: isub
    //   1974: aaload
    //   1975: iconst_0
    //   1976: invokevirtual charAt : (I)C
    //   1979: istore #29
    //   1981: iload #28
    //   1983: iconst_1
    //   1984: if_icmple -> 2039
    //   1987: iload #29
    //   1989: iconst_2
    //   1990: if_icmplt -> 2016
    //   1993: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName : [Ljava/lang/String;
    //   1996: iload #28
    //   1998: iconst_1
    //   1999: isub
    //   2000: aaload
    //   2001: astore #13
    //   2003: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic : [Ljava/lang/String;
    //   2006: iload #28
    //   2008: iconst_1
    //   2009: isub
    //   2010: aaload
    //   2011: astore #23
    //   2013: goto -> 2075
    //   2016: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName : [Ljava/lang/String;
    //   2019: iload #28
    //   2021: iconst_2
    //   2022: isub
    //   2023: aaload
    //   2024: astore #13
    //   2026: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic : [Ljava/lang/String;
    //   2029: iload #28
    //   2031: iconst_1
    //   2032: isub
    //   2033: aaload
    //   2034: astore #23
    //   2036: goto -> 2075
    //   2039: iload #29
    //   2041: iconst_2
    //   2042: if_icmplt -> 2068
    //   2045: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName : [Ljava/lang/String;
    //   2048: iload #28
    //   2050: iconst_1
    //   2051: isub
    //   2052: aaload
    //   2053: astore #13
    //   2055: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic : [Ljava/lang/String;
    //   2058: iload #28
    //   2060: iconst_1
    //   2061: isub
    //   2062: aaload
    //   2063: astore #23
    //   2065: goto -> 2075
    //   2068: aload #12
    //   2070: invokevirtual getName : ()Ljava/lang/String;
    //   2073: astore #13
    //   2075: getstatic java/lang/System.out : Ljava/io/PrintStream;
    //   2078: new java/lang/StringBuilder
    //   2081: dup
    //   2082: ldc_w '当前觉醒节点'
    //   2085: invokespecial <init> : (Ljava/lang/String;)V
    //   2088: aload #27
    //   2090: iload #28
    //   2092: iconst_1
    //   2093: isub
    //   2094: aaload
    //   2095: invokevirtual append : (Ljava/lang/String;)Ljava/lang/StringBuilder;
    //   2098: invokevirtual toString : ()Ljava/lang/String;
    //   2101: invokevirtual println : (Ljava/lang/String;)V
    //   2104: aload #11
    //   2106: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   2109: invokevirtual intValue : ()I
    //   2112: bipush #107
    //   2114: if_icmpne -> 2253
    //   2117: aload #27
    //   2119: iload #28
    //   2121: iconst_1
    //   2122: isub
    //   2123: aaload
    //   2124: iconst_0
    //   2125: invokevirtual charAt : (I)C
    //   2128: istore #29
    //   2130: iload #28
    //   2132: iconst_1
    //   2133: if_icmple -> 2188
    //   2136: iload #29
    //   2138: iconst_2
    //   2139: if_icmplt -> 2165
    //   2142: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName2 : [Ljava/lang/String;
    //   2145: iload #28
    //   2147: iconst_1
    //   2148: isub
    //   2149: aaload
    //   2150: astore #13
    //   2152: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic2 : [Ljava/lang/String;
    //   2155: iload #28
    //   2157: iconst_1
    //   2158: isub
    //   2159: aaload
    //   2160: astore #23
    //   2162: goto -> 2224
    //   2165: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName2 : [Ljava/lang/String;
    //   2168: iload #28
    //   2170: iconst_2
    //   2171: isub
    //   2172: aaload
    //   2173: astore #13
    //   2175: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic2 : [Ljava/lang/String;
    //   2178: iload #28
    //   2180: iconst_1
    //   2181: isub
    //   2182: aaload
    //   2183: astore #23
    //   2185: goto -> 2224
    //   2188: iload #29
    //   2190: iconst_2
    //   2191: if_icmplt -> 2217
    //   2194: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName2 : [Ljava/lang/String;
    //   2197: iload #28
    //   2199: iconst_1
    //   2200: isub
    //   2201: aaload
    //   2202: astore #13
    //   2204: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic2 : [Ljava/lang/String;
    //   2207: iload #28
    //   2209: iconst_1
    //   2210: isub
    //   2211: aaload
    //   2212: astore #23
    //   2214: goto -> 2224
    //   2217: aload #12
    //   2219: invokevirtual getName : ()Ljava/lang/String;
    //   2222: astore #13
    //   2224: getstatic java/lang/System.out : Ljava/io/PrintStream;
    //   2227: new java/lang/StringBuilder
    //   2230: dup
    //   2231: ldc_w '当前觉醒节点'
    //   2234: invokespecial <init> : (Ljava/lang/String;)V
    //   2237: aload #27
    //   2239: iload #28
    //   2241: iconst_1
    //   2242: isub
    //   2243: aaload
    //   2244: invokevirtual append : (Ljava/lang/String;)Ljava/lang/StringBuilder;
    //   2247: invokevirtual toString : ()Ljava/lang/String;
    //   2250: invokevirtual println : (Ljava/lang/String;)V
    //   2253: aload #11
    //   2255: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   2258: invokevirtual intValue : ()I
    //   2261: sipush #281
    //   2264: if_icmpne -> 2403
    //   2267: aload #27
    //   2269: iload #28
    //   2271: iconst_1
    //   2272: isub
    //   2273: aaload
    //   2274: iconst_0
    //   2275: invokevirtual charAt : (I)C
    //   2278: istore #29
    //   2280: iload #28
    //   2282: iconst_1
    //   2283: if_icmple -> 2338
    //   2286: iload #29
    //   2288: iconst_2
    //   2289: if_icmplt -> 2315
    //   2292: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName3 : [Ljava/lang/String;
    //   2295: iload #28
    //   2297: iconst_1
    //   2298: isub
    //   2299: aaload
    //   2300: astore #13
    //   2302: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic3 : [Ljava/lang/String;
    //   2305: iload #28
    //   2307: iconst_1
    //   2308: isub
    //   2309: aaload
    //   2310: astore #23
    //   2312: goto -> 2374
    //   2315: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName3 : [Ljava/lang/String;
    //   2318: iload #28
    //   2320: iconst_2
    //   2321: isub
    //   2322: aaload
    //   2323: astore #13
    //   2325: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic3 : [Ljava/lang/String;
    //   2328: iload #28
    //   2330: iconst_1
    //   2331: isub
    //   2332: aaload
    //   2333: astore #23
    //   2335: goto -> 2374
    //   2338: iload #29
    //   2340: iconst_2
    //   2341: if_icmplt -> 2367
    //   2344: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName3 : [Ljava/lang/String;
    //   2347: iload #28
    //   2349: iconst_1
    //   2350: isub
    //   2351: aaload
    //   2352: astore #13
    //   2354: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic3 : [Ljava/lang/String;
    //   2357: iload #28
    //   2359: iconst_1
    //   2360: isub
    //   2361: aaload
    //   2362: astore #23
    //   2364: goto -> 2374
    //   2367: aload #12
    //   2369: invokevirtual getName : ()Ljava/lang/String;
    //   2372: astore #13
    //   2374: getstatic java/lang/System.out : Ljava/io/PrintStream;
    //   2377: new java/lang/StringBuilder
    //   2380: dup
    //   2381: ldc_w '当前觉醒节点'
    //   2384: invokespecial <init> : (Ljava/lang/String;)V
    //   2387: aload #27
    //   2389: iload #28
    //   2391: iconst_1
    //   2392: isub
    //   2393: aaload
    //   2394: invokevirtual append : (Ljava/lang/String;)Ljava/lang/StringBuilder;
    //   2397: invokevirtual toString : ()Ljava/lang/String;
    //   2400: invokevirtual println : (Ljava/lang/String;)V
    //   2403: aload #11
    //   2405: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   2408: invokevirtual intValue : ()I
    //   2411: sipush #269
    //   2414: if_icmpne -> 2553
    //   2417: aload #27
    //   2419: iload #28
    //   2421: iconst_1
    //   2422: isub
    //   2423: aaload
    //   2424: iconst_0
    //   2425: invokevirtual charAt : (I)C
    //   2428: istore #29
    //   2430: iload #28
    //   2432: iconst_1
    //   2433: if_icmple -> 2488
    //   2436: iload #29
    //   2438: iconst_2
    //   2439: if_icmplt -> 2465
    //   2442: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName4 : [Ljava/lang/String;
    //   2445: iload #28
    //   2447: iconst_1
    //   2448: isub
    //   2449: aaload
    //   2450: astore #13
    //   2452: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic4 : [Ljava/lang/String;
    //   2455: iload #28
    //   2457: iconst_1
    //   2458: isub
    //   2459: aaload
    //   2460: astore #23
    //   2462: goto -> 2524
    //   2465: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName4 : [Ljava/lang/String;
    //   2468: iload #28
    //   2470: iconst_2
    //   2471: isub
    //   2472: aaload
    //   2473: astore #13
    //   2475: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic4 : [Ljava/lang/String;
    //   2478: iload #28
    //   2480: iconst_1
    //   2481: isub
    //   2482: aaload
    //   2483: astore #23
    //   2485: goto -> 2524
    //   2488: iload #29
    //   2490: iconst_2
    //   2491: if_icmplt -> 2517
    //   2494: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName4 : [Ljava/lang/String;
    //   2497: iload #28
    //   2499: iconst_1
    //   2500: isub
    //   2501: aaload
    //   2502: astore #13
    //   2504: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic4 : [Ljava/lang/String;
    //   2507: iload #28
    //   2509: iconst_1
    //   2510: isub
    //   2511: aaload
    //   2512: astore #23
    //   2514: goto -> 2524
    //   2517: aload #12
    //   2519: invokevirtual getName : ()Ljava/lang/String;
    //   2522: astore #13
    //   2524: getstatic java/lang/System.out : Ljava/io/PrintStream;
    //   2527: new java/lang/StringBuilder
    //   2530: dup
    //   2531: ldc_w '当前觉醒节点'
    //   2534: invokespecial <init> : (Ljava/lang/String;)V
    //   2537: aload #27
    //   2539: iload #28
    //   2541: iconst_1
    //   2542: isub
    //   2543: aaload
    //   2544: invokevirtual append : (Ljava/lang/String;)Ljava/lang/StringBuilder;
    //   2547: invokevirtual toString : ()Ljava/lang/String;
    //   2550: invokevirtual println : (Ljava/lang/String;)V
    //   2553: aload #11
    //   2555: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   2558: invokevirtual intValue : ()I
    //   2561: sipush #201
    //   2564: if_icmpne -> 2703
    //   2567: aload #27
    //   2569: iload #28
    //   2571: iconst_1
    //   2572: isub
    //   2573: aaload
    //   2574: iconst_0
    //   2575: invokevirtual charAt : (I)C
    //   2578: istore #29
    //   2580: iload #28
    //   2582: iconst_1
    //   2583: if_icmple -> 2638
    //   2586: iload #29
    //   2588: iconst_2
    //   2589: if_icmplt -> 2615
    //   2592: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName5 : [Ljava/lang/String;
    //   2595: iload #28
    //   2597: iconst_1
    //   2598: isub
    //   2599: aaload
    //   2600: astore #13
    //   2602: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic5 : [Ljava/lang/String;
    //   2605: iload #28
    //   2607: iconst_1
    //   2608: isub
    //   2609: aaload
    //   2610: astore #23
    //   2612: goto -> 2674
    //   2615: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName5 : [Ljava/lang/String;
    //   2618: iload #28
    //   2620: iconst_2
    //   2621: isub
    //   2622: aaload
    //   2623: astore #13
    //   2625: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic5 : [Ljava/lang/String;
    //   2628: iload #28
    //   2630: iconst_1
    //   2631: isub
    //   2632: aaload
    //   2633: astore #23
    //   2635: goto -> 2674
    //   2638: iload #29
    //   2640: iconst_2
    //   2641: if_icmplt -> 2667
    //   2644: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName5 : [Ljava/lang/String;
    //   2647: iload #28
    //   2649: iconst_1
    //   2650: isub
    //   2651: aaload
    //   2652: astore #13
    //   2654: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic5 : [Ljava/lang/String;
    //   2657: iload #28
    //   2659: iconst_1
    //   2660: isub
    //   2661: aaload
    //   2662: astore #23
    //   2664: goto -> 2674
    //   2667: aload #12
    //   2669: invokevirtual getName : ()Ljava/lang/String;
    //   2672: astore #13
    //   2674: getstatic java/lang/System.out : Ljava/io/PrintStream;
    //   2677: new java/lang/StringBuilder
    //   2680: dup
    //   2681: ldc_w '当前觉醒节点'
    //   2684: invokespecial <init> : (Ljava/lang/String;)V
    //   2687: aload #27
    //   2689: iload #28
    //   2691: iconst_1
    //   2692: isub
    //   2693: aaload
    //   2694: invokevirtual append : (Ljava/lang/String;)Ljava/lang/StringBuilder;
    //   2697: invokevirtual toString : ()Ljava/lang/String;
    //   2700: invokevirtual println : (Ljava/lang/String;)V
    //   2703: aload #11
    //   2705: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   2708: invokevirtual intValue : ()I
    //   2711: sipush #416
    //   2714: if_icmpne -> 2865
    //   2717: aload #27
    //   2719: iload #28
    //   2721: iconst_1
    //   2722: isub
    //   2723: aaload
    //   2724: iconst_0
    //   2725: invokevirtual charAt : (I)C
    //   2728: istore #29
    //   2730: iload #28
    //   2732: iconst_1
    //   2733: if_icmple -> 2788
    //   2736: iload #29
    //   2738: iconst_2
    //   2739: if_icmplt -> 2765
    //   2742: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName6 : [Ljava/lang/String;
    //   2745: iload #28
    //   2747: iconst_1
    //   2748: isub
    //   2749: aaload
    //   2750: astore #13
    //   2752: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic6 : [Ljava/lang/String;
    //   2755: iload #28
    //   2757: iconst_1
    //   2758: isub
    //   2759: aaload
    //   2760: astore #23
    //   2762: goto -> 2824
    //   2765: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName6 : [Ljava/lang/String;
    //   2768: iload #28
    //   2770: iconst_2
    //   2771: isub
    //   2772: aaload
    //   2773: astore #13
    //   2775: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic6 : [Ljava/lang/String;
    //   2778: iload #28
    //   2780: iconst_1
    //   2781: isub
    //   2782: aaload
    //   2783: astore #23
    //   2785: goto -> 2824
    //   2788: iload #29
    //   2790: iconst_2
    //   2791: if_icmplt -> 2817
    //   2794: getstatic com/reign/gcld/general/common/GeneralUtils.chapterName6 : [Ljava/lang/String;
    //   2797: iload #28
    //   2799: iconst_1
    //   2800: isub
    //   2801: aaload
    //   2802: astore #13
    //   2804: getstatic com/reign/gcld/general/common/GeneralUtils.chapterpic6 : [Ljava/lang/String;
    //   2807: iload #28
    //   2809: iconst_1
    //   2810: isub
    //   2811: aaload
    //   2812: astore #23
    //   2814: goto -> 2824
    //   2817: aload #12
    //   2819: invokevirtual getName : ()Ljava/lang/String;
    //   2822: astore #13
    //   2824: getstatic java/lang/System.out : Ljava/io/PrintStream;
    //   2827: new java/lang/StringBuilder
    //   2830: dup
    //   2831: ldc_w '当前觉醒节点'
    //   2834: invokespecial <init> : (Ljava/lang/String;)V
    //   2837: aload #27
    //   2839: iload #28
    //   2841: iconst_1
    //   2842: isub
    //   2843: aaload
    //   2844: invokevirtual append : (Ljava/lang/String;)Ljava/lang/StringBuilder;
    //   2847: invokevirtual toString : ()Ljava/lang/String;
    //   2850: invokevirtual println : (Ljava/lang/String;)V
    //   2853: goto -> 2865
    //   2856: astore #24
    //   2858: aload #12
    //   2860: invokevirtual getName : ()Ljava/lang/String;
    //   2863: astore #13
    //   2865: aload #6
    //   2867: ldc_w 'generalPic'
    //   2870: aload #23
    //   2872: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   2875: aload #6
    //   2877: ldc_w 'generalLv'
    //   2880: aload #11
    //   2882: invokevirtual getLv : ()Ljava/lang/Integer;
    //   2885: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   2888: aload #6
    //   2890: ldc_w 'generalName'
    //   2893: aload #13
    //   2895: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   2898: iload #22
    //   2900: ifeq -> 2951
    //   2903: aload #6
    //   2905: ldc_w 'armyHp'
    //   2908: lload #7
    //   2910: ldc2_w 3
    //   2913: ldiv
    //   2914: iload #15
    //   2916: i2l
    //   2917: ladd
    //   2918: invokestatic valueOf : (J)Ljava/lang/Long;
    //   2921: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   2924: aload #6
    //   2926: ldc_w 'armyHpMax'
    //   2929: aload_1
    //   2930: invokeinterface getBattleDataCache : ()Lcom/reign/gcld/battle/service/BattleDataCache;
    //   2935: aload #11
    //   2937: invokevirtual getMaxHp : (Lcom/reign/gcld/general/domain/PlayerGeneralMilitary;)I
    //   2940: iconst_3
    //   2941: idiv
    //   2942: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   2945: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   2948: goto -> 2990
    //   2951: aload #6
    //   2953: ldc_w 'armyHp'
    //   2956: lload #7
    //   2958: iload #15
    //   2960: i2l
    //   2961: ladd
    //   2962: invokestatic valueOf : (J)Ljava/lang/Long;
    //   2965: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   2968: aload #6
    //   2970: ldc_w 'armyHpMax'
    //   2973: aload_1
    //   2974: invokeinterface getBattleDataCache : ()Lcom/reign/gcld/battle/service/BattleDataCache;
    //   2979: aload #11
    //   2981: invokevirtual getMaxHp : (Lcom/reign/gcld/general/domain/PlayerGeneralMilitary;)I
    //   2984: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   2987: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   2990: iconst_0
    //   2991: istore #24
    //   2993: aload #11
    //   2995: invokevirtual getLordId : ()Ljava/lang/Integer;
    //   2998: ifnull -> 3015
    //   3001: aload #11
    //   3003: invokevirtual getLordId : ()Ljava/lang/Integer;
    //   3006: invokevirtual intValue : ()I
    //   3009: ifle -> 3015
    //   3012: iconst_1
    //   3013: istore #24
    //   3015: aload_1
    //   3016: invokeinterface getBattleDataCache : ()Lcom/reign/gcld/battle/service/BattleDataCache;
    //   3021: iload_2
    //   3022: aload #11
    //   3024: invokevirtual getGeneralId : ()Ljava/lang/Integer;
    //   3027: invokevirtual intValue : ()I
    //   3030: aload #17
    //   3032: aload #11
    //   3034: invokevirtual getLv : ()Ljava/lang/Integer;
    //   3037: invokevirtual intValue : ()I
    //   3040: iload #24
    //   3042: aload #11
    //   3044: invokevirtual getLordId : ()Ljava/lang/Integer;
    //   3047: invokevirtual intValue : ()I
    //   3050: invokevirtual getAttDefHp : (IILcom/reign/gcld/sdata/domain/Troop;III)Ljava/util/Map;
    //   3053: astore #9
    //   3055: aload #9
    //   3057: iconst_3
    //   3058: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   3061: invokeinterface get : (Ljava/lang/Object;)Ljava/lang/Object;
    //   3066: checkcast java/lang/Integer
    //   3069: invokevirtual intValue : ()I
    //   3072: istore #25
    //   3074: iload #25
    //   3076: i2l
    //   3077: aload #11
    //   3079: invokevirtual getForces : ()Ljava/lang/Integer;
    //   3082: invokevirtual intValue : ()I
    //   3085: i2l
    //   3086: lsub
    //   3087: lstore #26
    //   3089: lconst_0
    //   3090: lstore #28
    //   3092: aload_1
    //   3093: invokeinterface getGeneralService : ()Lcom/reign/gcld/general/service/IGeneralService;
    //   3098: aload #11
    //   3100: invokevirtual getPlayerId : ()Ljava/lang/Integer;
    //   3103: invokevirtual intValue : ()I
    //   3106: iload #4
    //   3108: aload #11
    //   3110: invokevirtual getLocationId : ()Ljava/lang/Integer;
    //   3113: invokevirtual intValue : ()I
    //   3116: aload #17
    //   3118: invokeinterface getOutput : (IIILcom/reign/gcld/sdata/domain/Troop;)Ljava/lang/Double;
    //   3123: invokevirtual doubleValue : ()D
    //   3126: dstore #30
    //   3128: lload #26
    //   3130: lconst_0
    //   3131: lcmp
    //   3132: ifle -> 3185
    //   3135: lload #26
    //   3137: l2d
    //   3138: dload #30
    //   3140: ddiv
    //   3141: d2l
    //   3142: lstore #28
    //   3144: invokestatic currentTimeMillis : ()J
    //   3147: aload #11
    //   3149: invokevirtual getUpdateForcesTime : ()Ljava/util/Date;
    //   3152: invokevirtual getTime : ()J
    //   3155: lsub
    //   3156: ldc2_w 1000
    //   3159: ldiv
    //   3160: lstore #32
    //   3162: lload #28
    //   3164: lload #32
    //   3166: lsub
    //   3167: ldc2_w 10
    //   3170: ladd
    //   3171: lstore #28
    //   3173: lload #28
    //   3175: lconst_0
    //   3176: lcmp
    //   3177: ifge -> 3185
    //   3180: ldc2_w 10
    //   3183: lstore #28
    //   3185: aload #6
    //   3187: ldc_w 'needTime'
    //   3190: lload #28
    //   3192: ldc2_w 1000
    //   3195: lmul
    //   3196: invokestatic valueOf : (J)Ljava/lang/Long;
    //   3199: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   3202: aload_1
    //   3203: invokeinterface getTacticCache : ()Lcom/reign/gcld/sdata/cache/TacticCache;
    //   3208: aload #12
    //   3210: invokevirtual getTacticId : ()Ljava/lang/Integer;
    //   3213: invokevirtual get : (Ljava/lang/Object;)Ljava/lang/Object;
    //   3216: checkcast com/reign/gcld/sdata/domain/Tactic
    //   3219: astore #32
    //   3221: aload #32
    //   3223: ifnull -> 3239
    //   3226: aload #6
    //   3228: ldc_w 'tacticName'
    //   3231: aload #32
    //   3233: invokevirtual getName : ()Ljava/lang/String;
    //   3236: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   3239: aload #12
    //   3241: invokevirtual getTacticId : ()Ljava/lang/Integer;
    //   3244: invokevirtual intValue : ()I
    //   3247: bipush #24
    //   3249: if_icmpne -> 3315
    //   3252: aload #6
    //   3254: ldc_w 'rbType'
    //   3257: iconst_3
    //   3258: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   3261: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   3264: aload #32
    //   3266: invokevirtual getReward : ()Lcom/reign/gcld/battle/reward/IReward;
    //   3269: aload_1
    //   3270: iload_2
    //   3271: aload #11
    //   3273: invokeinterface canReward : (Lcom/reign/gcld/common/IDataGetter;ILjava/lang/Object;)Lcom/reign/gcld/battle/reward/RewardInfo;
    //   3278: astore #33
    //   3280: aload #33
    //   3282: invokevirtual isCanReward : ()Z
    //   3285: ifeq -> 3303
    //   3288: aload #6
    //   3290: ldc_w 'canRb'
    //   3293: iconst_1
    //   3294: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   3297: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   3300: goto -> 3315
    //   3303: aload #6
    //   3305: ldc_w 'canRb'
    //   3308: iconst_0
    //   3309: invokestatic valueOf : (I)Ljava/lang/Integer;
    //   3312: invokevirtual createElement : (Ljava/lang/String;Ljava/lang/Object;)V
    //   3315: aload #6
    //   3317: invokevirtual endObject : ()V
    //   3320: iinc #10, 1
    //   3323: iload #10
    //   3325: aload_3
    //   3326: invokeinterface size : ()I
    //   3331: if_icmplt -> 41
    //   3334: aload #6
    //   3336: invokevirtual endArray : ()V
    //   3339: aload #6
    //   3341: invokevirtual toByte : ()[B
    //   3344: areturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #446	-> 0
    //   #447	-> 6
    //   #448	-> 15
    //   #449	-> 23
    //   #450	-> 26
    //   #451	-> 35
    //   #452	-> 41
    //   #453	-> 46
    //   #454	-> 59
    //   #455	-> 78
    //   #456	-> 91
    //   #457	-> 104
    //   #458	-> 117
    //   #459	-> 130
    //   #460	-> 137
    //   #461	-> 140
    //   #462	-> 158
    //   #463	-> 180
    //   #464	-> 196
    //   #467	-> 199
    //   #468	-> 202
    //   #469	-> 221
    //   #470	-> 240
    //   #471	-> 252
    //   #472	-> 265
    //   #473	-> 278
    //   #474	-> 300
    //   #475	-> 305
    //   #476	-> 315
    //   #478	-> 318
    //   #481	-> 358
    //   #482	-> 371
    //   #483	-> 382
    //   #484	-> 387
    //   #485	-> 392
    //   #486	-> 406
    //   #487	-> 411
    //   #488	-> 416
    //   #489	-> 419
    //   #490	-> 433
    //   #491	-> 438
    //   #492	-> 443
    //   #493	-> 446
    //   #494	-> 460
    //   #495	-> 465
    //   #496	-> 470
    //   #497	-> 473
    //   #498	-> 487
    //   #499	-> 492
    //   #500	-> 497
    //   #501	-> 500
    //   #502	-> 514
    //   #503	-> 519
    //   #504	-> 524
    //   #505	-> 527
    //   #506	-> 541
    //   #507	-> 546
    //   #509	-> 551
    //   #510	-> 561
    //   #511	-> 575
    //   #513	-> 588
    //   #514	-> 617
    //   #515	-> 638
    //   #516	-> 665
    //   #517	-> 685
    //   #518	-> 698
    //   #519	-> 714
    //   #521	-> 730
    //   #522	-> 751
    //   #523	-> 758
    //   #524	-> 773
    //   #525	-> 782
    //   #526	-> 806
    //   #527	-> 834
    //   #525	-> 850
    //   #530	-> 860
    //   #531	-> 870
    //   #532	-> 878
    //   #533	-> 902
    //   #534	-> 907
    //   #535	-> 923
    //   #532	-> 928
    //   #537	-> 938
    //   #540	-> 943
    //   #541	-> 956
    //   #542	-> 969
    //   #543	-> 980
    //   #544	-> 993
    //   #545	-> 1005
    //   #546	-> 1017
    //   #547	-> 1028
    //   #548	-> 1031
    //   #549	-> 1043
    //   #550	-> 1055
    //   #551	-> 1066
    //   #552	-> 1069
    //   #553	-> 1082
    //   #554	-> 1094
    //   #555	-> 1105
    //   #556	-> 1108
    //   #557	-> 1120
    //   #558	-> 1132
    //   #559	-> 1143
    //   #560	-> 1146
    //   #561	-> 1159
    //   #562	-> 1172
    //   #563	-> 1183
    //   #564	-> 1186
    //   #565	-> 1198
    //   #566	-> 1211
    //   #567	-> 1222
    //   #568	-> 1225
    //   #569	-> 1243
    //   #570	-> 1256
    //   #571	-> 1267
    //   #572	-> 1270
    //   #573	-> 1295
    //   #574	-> 1308
    //   #575	-> 1319
    //   #577	-> 1322
    //   #579	-> 1334
    //   #580	-> 1337
    //   #581	-> 1351
    //   #582	-> 1373
    //   #583	-> 1410
    //   #586	-> 1413
    //   #587	-> 1431
    //   #588	-> 1506
    //   #589	-> 1528
    //   #590	-> 1544
    //   #591	-> 1557
    //   #592	-> 1562
    //   #593	-> 1565
    //   #594	-> 1579
    //   #595	-> 1584
    //   #596	-> 1587
    //   #597	-> 1601
    //   #598	-> 1606
    //   #599	-> 1609
    //   #600	-> 1623
    //   #602	-> 1628
    //   #603	-> 1631
    //   #604	-> 1645
    //   #610	-> 1650
    //   #611	-> 1672
    //   #612	-> 1711
    //   #614	-> 1716
    //   #615	-> 1755
    //   #617	-> 1760
    //   #618	-> 1799
    //   #620	-> 1804
    //   #621	-> 1829
    //   #623	-> 1834
    //   #624	-> 1872
    //   #626	-> 1877
    //   #627	-> 1903
    //   #628	-> 1911
    //   #629	-> 1921
    //   #630	-> 1934
    //   #631	-> 1944
    //   #632	-> 1954
    //   #633	-> 1968
    //   #634	-> 1981
    //   #635	-> 1987
    //   #636	-> 1993
    //   #637	-> 2003
    //   #639	-> 2013
    //   #641	-> 2016
    //   #642	-> 2026
    //   #645	-> 2036
    //   #646	-> 2039
    //   #647	-> 2045
    //   #648	-> 2055
    //   #650	-> 2065
    //   #652	-> 2068
    //   #655	-> 2075
    //   #657	-> 2104
    //   #658	-> 2117
    //   #659	-> 2130
    //   #660	-> 2136
    //   #661	-> 2142
    //   #662	-> 2152
    //   #664	-> 2162
    //   #666	-> 2165
    //   #667	-> 2175
    //   #670	-> 2185
    //   #671	-> 2188
    //   #672	-> 2194
    //   #673	-> 2204
    //   #675	-> 2214
    //   #677	-> 2217
    //   #680	-> 2224
    //   #683	-> 2253
    //   #684	-> 2267
    //   #685	-> 2280
    //   #686	-> 2286
    //   #687	-> 2292
    //   #688	-> 2302
    //   #690	-> 2312
    //   #692	-> 2315
    //   #693	-> 2325
    //   #696	-> 2335
    //   #697	-> 2338
    //   #698	-> 2344
    //   #699	-> 2354
    //   #701	-> 2364
    //   #703	-> 2367
    //   #706	-> 2374
    //   #709	-> 2403
    //   #710	-> 2417
    //   #711	-> 2430
    //   #712	-> 2436
    //   #713	-> 2442
    //   #714	-> 2452
    //   #716	-> 2462
    //   #718	-> 2465
    //   #719	-> 2475
    //   #722	-> 2485
    //   #723	-> 2488
    //   #724	-> 2494
    //   #725	-> 2504
    //   #727	-> 2514
    //   #729	-> 2517
    //   #732	-> 2524
    //   #735	-> 2553
    //   #736	-> 2567
    //   #737	-> 2580
    //   #738	-> 2586
    //   #739	-> 2592
    //   #740	-> 2602
    //   #742	-> 2612
    //   #744	-> 2615
    //   #745	-> 2625
    //   #748	-> 2635
    //   #749	-> 2638
    //   #750	-> 2644
    //   #751	-> 2654
    //   #753	-> 2664
    //   #755	-> 2667
    //   #757	-> 2674
    //   #760	-> 2703
    //   #761	-> 2717
    //   #762	-> 2730
    //   #763	-> 2736
    //   #764	-> 2742
    //   #765	-> 2752
    //   #767	-> 2762
    //   #769	-> 2765
    //   #770	-> 2775
    //   #773	-> 2785
    //   #774	-> 2788
    //   #775	-> 2794
    //   #776	-> 2804
    //   #778	-> 2814
    //   #780	-> 2817
    //   #782	-> 2824
    //   #786	-> 2853
    //   #787	-> 2856
    //   #788	-> 2858
    //   #790	-> 2865
    //   #791	-> 2875
    //   #792	-> 2888
    //   #795	-> 2898
    //   #796	-> 2903
    //   #797	-> 2924
    //   #798	-> 2948
    //   #800	-> 2951
    //   #801	-> 2968
    //   #803	-> 2990
    //   #804	-> 2993
    //   #805	-> 3012
    //   #807	-> 3015
    //   #808	-> 3055
    //   #809	-> 3074
    //   #810	-> 3089
    //   #811	-> 3092
    //   #812	-> 3128
    //   #813	-> 3135
    //   #814	-> 3144
    //   #815	-> 3162
    //   #816	-> 3173
    //   #817	-> 3180
    //   #820	-> 3185
    //   #821	-> 3202
    //   #822	-> 3221
    //   #823	-> 3226
    //   #825	-> 3239
    //   #826	-> 3252
    //   #827	-> 3264
    //   #828	-> 3280
    //   #829	-> 3288
    //   #830	-> 3300
    //   #832	-> 3303
    //   #835	-> 3315
    //   #451	-> 3320
    //   #837	-> 3334
    //   #838	-> 3339
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	3345	0	this	Lcom/reign/gcld/battle/scene/Builder;
    //   0	3345	1	dataGetter	Lcom/reign/gcld/common/IDataGetter;
    //   0	3345	2	playerId	I
    //   0	3345	3	pgmList	Ljava/util/List;
    //   0	3345	4	forceId	I
    //   0	3345	5	terrain	I
    //   15	3330	6	doc	Lcom/reign/framework/json/JsonDocument;
    //   26	3319	7	armyHp	J
    //   35	3310	9	adhMap	Ljava/util/Map;
    //   38	3296	10	i	I
    //   59	3261	11	pgm	Lcom/reign/gcld/general/domain/PlayerGeneralMilitary;
    //   78	3242	12	general	Lcom/reign/gcld/sdata/domain/General;
    //   137	3183	13	generalName	Ljava/lang/String;
    //   140	3180	14	ishenjiang	Z
    //   180	19	15	pge	Lcom/reign/gcld/general/domain/PlayerGeneralEvoke;
    //   202	3118	15	fjarmynum	I
    //   240	118	16	generalfj	Lcom/reign/gcld/sdata/domain/General;
    //   300	58	17	fjpm	Lcom/reign/gcld/general/domain/PlayerGeneralMilitary;
    //   387	201	16	helperpic	Ljava/lang/String;
    //   392	196	17	helpertac	I
    //   638	2682	16	playerTemp	Lcom/reign/gcld/player/domain/Player;
    //   665	2655	17	troop	Lcom/reign/gcld/sdata/domain/Troop;
    //   685	2635	18	gTerrain	Lcom/reign/gcld/sdata/common/TroopTerrain;
    //   751	2569	19	gmd	Lcom/reign/gcld/general/dto/GeneralMoveDto;
    //   758	2562	20	tssList	Ljava/util/List;
    //   782	161	21	tssIds	Ljava/util/List;
    //   806	44	22	tss	Lcom/reign/gcld/sdata/common/TerrainStrategySpecDto;
    //   902	26	22	tss	Lcom/reign/gcld/sdata/common/TerrainStrategySpecDto;
    //   993	2327	21	maxHp	I
    //   1337	1983	22	jxzhaoyun	Z
    //   1373	40	23	pge2	Lcom/reign/gcld/general/domain/PlayerGeneralEvoke;
    //   1431	1889	23	generalpic	Ljava/lang/String;
    //   1528	122	24	pge3	Lcom/reign/gcld/general/domain/PlayerGeneralEvoke;
    //   1672	1181	24	pge_f	Lcom/reign/gcld/general/domain/PlayerGeneralEvoke;
    //   1921	932	25	legendobj	Lcom/alibaba/fastjson/JSONObject;
    //   1934	919	26	chapterstr	Ljava/lang/String;
    //   1944	909	27	chapterinfo	[Ljava/lang/String;
    //   1954	899	28	curChapter	I
    //   1981	123	29	chapter_node	I
    //   2130	123	29	chapter_node	I
    //   2280	123	29	chapter_node	I
    //   2430	123	29	chapter_node	I
    //   2580	123	29	chapter_node	I
    //   2730	123	29	chapter_node	I
    //   2858	7	24	e	Ljava/lang/NullPointerException;
    //   2993	327	24	isDeputy	I
    //   3074	246	25	forcesMax	I
    //   3089	231	26	needForces	J
    //   3092	228	28	needTime	J
    //   3128	192	30	secondForces	D
    //   3162	23	32	timeed	J
    //   3221	99	32	tactic	Lcom/reign/gcld/sdata/domain/Tactic;
    //   3280	35	33	ri	Lcom/reign/gcld/battle/reward/RewardInfo;
    // Local variable type table:
    //   start	length	slot	name	signature
    //   0	3345	3	pgmList	Ljava/util/List<Lcom/reign/gcld/general/domain/PlayerGeneralMilitary;>;
    //   35	3310	9	adhMap	Ljava/util/Map<Ljava/lang/Integer;Ljava/lang/Integer;>;
    //   758	2562	20	tssList	Ljava/util/List<Lcom/reign/gcld/sdata/common/TerrainStrategySpecDto;>;
    //   782	161	21	tssIds	Ljava/util/List<Ljava/lang/Integer;>;
    // Exception table:
    //   from	to	target	type
    //   1650	2853	2856	java/lang/NullPointerException
  }
  
  public boolean canJoinBattle(double armyHp, double maxHp) {
    return (armyHp * 1.0D / maxHp >= 0.05D);
  }
  
  public byte[] getDefGenerals(IDataGetter dataGetter, int playerId, Armies armies, int terrain) {
    JsonDocument doc = new JsonDocument();
    Integer[] defNpcs = armies.getArmiesId();
    doc.startArray("defGenerals");
    General general = null;
    Troop troop = null;
    TroopTerrain gTerrain = null;
    if (defNpcs != null && defNpcs.length > 0)
      for (int i = 0; i < defNpcs.length; i++) {
        int npc = defNpcs[i].intValue();
        if (npc > 0) {
          doc.startObject();
          Army armyCach = (Army)dataGetter.getArmyCache().get(Integer.valueOf(npc));
          general = (General)dataGetter.getGeneralCache().get(armyCach.getGeneralId());
          troop = (Troop)dataGetter.getTroopCache().get(general.getTroop());
          doc.createElement("generalId", armyCach.getGeneralId());
          doc.createElement("generalName", armyCach.getName());
          doc.createElement("att", Integer.valueOf(armyCach.getAtt()));
          doc.createElement("generalLv", armyCach.getGeneralLv());
          doc.createElement("troopId", troop.getType());
          doc.createElement("troopType", troop.getSerial());
          doc.createElement("generalPic", ((General)dataGetter.getGeneralCache().get(armyCach.getGeneralId())).getPic());
          boolean touguo = false;
          if (armyCach.getGeneralId().intValue() == 20291) {
            PlayerPower playerPowerdw = dataGetter.getPlayerPowerDao().getPlayerPower(playerId, 33);
            if (playerPowerdw != null) {
              String dwstr = playerPowerdw.getCCjxInfo();
              if (dwstr != null && !dwstr.equals("") && Integer.valueOf(dwstr).intValue() > 0)
                touguo = true; 
            } 
          } 
          if (armyCach.getGeneralId().intValue() == 3103001 || armyCach.getGeneralId().intValue() == 3105004) {
            doc.createElement("armyHp", Integer.valueOf(armyCach.getArmyHp().intValue() / 3));
          } else if (armyCach.getGeneralId().intValue() == 20291 && !touguo) {
            doc.createElement("armyHp", Integer.valueOf(33000000));
          } else {
            doc.createElement("armyHp", armyCach.getArmyHp());
          } 
          if (general.getTacticId().intValue() != 0) {
            Tactic tactic = (Tactic)dataGetter.getTacticCache().get(general.getTacticId());
            if (tactic != null)
              doc.createElement("tacticName", tactic.getName()); 
          } 
          List<TerrainStrategySpecDto> tssList = troop.getTsstList();
          if (tssList != null && tssList.size() > 0) {
            List<Integer> tssIds = new LinkedList<>();
            for (TerrainStrategySpecDto tss : tssList) {
              if (tss.terrainId == terrain && (tss.show == 2 || tss.show == 3))
                tssIds.add(Integer.valueOf(tss.strategyId)); 
            } 
            if (tssIds.size() > 0) {
              doc.startArray("tssList");
              for (TerrainStrategySpecDto tss : tssList) {
                doc.startObject();
                doc.createElement("strategyId", Integer.valueOf(tss.strategyId));
                doc.endObject();
              } 
              doc.endArray();
            } 
          } 
          gTerrain = (TroopTerrain)troop.getTerrains().get(Integer.valueOf(terrain));
          if (gTerrain != null && gTerrain.getDefEffect() > 0) {
            doc.createElement("terrainAdd", Integer.valueOf(gTerrain.getDefEffect()));
            doc.createElement("terrainQ", Integer.valueOf(gTerrain.getDefQuality()));
          } 
          doc.endObject();
        } 
      }  
    doc.startObject();
    Army army = (Army)dataGetter.getArmyCache().get(armies.getChief());
    general = (General)dataGetter.getGeneralCache().get(army.getGeneralId());
    troop = (Troop)dataGetter.getTroopCache().get(general.getTroop());
    doc.createElement("generalId", army.getGeneralId());
    doc.createElement("generalName", army.getName());
    doc.createElement("att", Integer.valueOf(army.getAtt()));
    doc.createElement("generalLv", army.getGeneralLv());
    doc.createElement("troopId", troop.getType());
    doc.createElement("troopType", troop.getSerial());
    doc.createElement("generalPic", general.getPic());
    doc.createElement("quality", general.getQuality());
    if (general.getTacticId().intValue() != 0) {
      Tactic tactic2 = (Tactic)dataGetter.getTacticCache().get(general.getTacticId());
      if (tactic2 != null)
        doc.createElement("tacticName", tactic2.getName()); 
    } 
    if (army.getGeneralId().intValue() == 3103001 || army.getGeneralId().intValue() == 3105004) {
      doc.createElement("armyHp", Integer.valueOf(army.getArmyHp().intValue() / 3));
      doc.createElement("armyHpMax", Integer.valueOf(army.getArmyHp().intValue() / 3));
    } else {
      doc.createElement("armyHp", army.getArmyHp());
      doc.createElement("armyHpMax", army.getArmyHp());
    } 
    gTerrain = (TroopTerrain)troop.getTerrains().get(Integer.valueOf(terrain));
    if (gTerrain != null && gTerrain.getDefEffect() > 0) {
      doc.createElement("terrainAdd", Integer.valueOf(gTerrain.getDefEffect()));
      doc.createElement("terrainQ", Integer.valueOf(gTerrain.getDefQuality()));
    } 
    List<TerrainStrategySpecDto> tssList2 = troop.getTsstList();
    if (tssList2 != null && tssList2.size() > 0) {
      List<Integer> tssIds2 = new LinkedList<>();
      for (TerrainStrategySpecDto tss2 : tssList2) {
        if (tss2.terrainId == terrain && (tss2.show == 2 || tss2.show == 3))
          tssIds2.add(Integer.valueOf(tss2.strategyId)); 
      } 
      if (tssIds2.size() > 0) {
        doc.startArray("tssList");
        for (TerrainStrategySpecDto tss2 : tssList2) {
          doc.startObject();
          doc.createElement("strategyId", Integer.valueOf(tss2.strategyId));
          doc.endObject();
        } 
        doc.endArray();
      } 
    } 
    doc.endObject();
    doc.endArray();
    return doc.toByte();
  }
  
  public Tuple<List<PlayerGeneralMilitary>, String> chooseGeneral(IDataGetter dataGetter, Player player, int defId, List<Integer> gIdList) {
    Tuple<List<PlayerGeneralMilitary>, String> tuple = new Tuple();
    Map<Integer, PlayerGeneralMilitary> pgmMap = dataGetter.getPlayerGeneralMilitaryDao().getMilitaryMap(player.getPlayerId().intValue());
    List<PlayerGeneralMilitary> chooseList = new ArrayList<>();
    for (int i = 0; i < gIdList.size(); i++) {
      PlayerGeneralMilitary pgm = pgmMap.get(gIdList.get(i));
      if (pgm != null && pgm.getIsDeputy().intValue() <= 0 && 
        pgm.getLordId().intValue() <= 0 && 
        pgm != null && pgm.getState().intValue() <= 1) {
        int maxHp = dataGetter.getBattleDataCache().getMaxHp(pgm);
        if (canJoinBattle(pgm.getForces().intValue() * 1.0D, maxHp) && !dataGetter.getWorldFarmService().isInFarmForbiddenOperation(pgm, false) && !TeamManager.getInstance().isJoinTeam(pgm.getPlayerId().intValue(), pgm.getGeneralId().intValue())) {
          GeneralMoveDto gmd = CityService.getGeneralMoveDto(pgm.getPlayerId().intValue(), pgm.getGeneralId().intValue());
          if (gmd != null) {
            if (gmd.cityState == 22)
              continue; 
            if (gmd.cityState == 23)
              continue; 
          } 
          chooseList.add(pgm);
        } 
      } 
      continue;
    } 
    if (chooseList.size() <= 0) {
      tuple.left = null;
      tuple.right = LocalMessages.GENEGAL_CANNOT_BATTLE;
      return tuple;
    } 
    tuple.left = chooseList;
    return tuple;
  }
  
  public Tuple<List<PlayerGeneralMilitary>, String> chooseAllGeneral(IDataGetter dataGetter, Player player, int defId, int battleSide) {
    Tuple<List<PlayerGeneralMilitary>, String> tuple = new Tuple();
    Map<Integer, PlayerGeneralMilitary> pgmMap = dataGetter.getPlayerGeneralMilitaryDao().getMilitaryMap(player.getPlayerId().intValue());
    List<PlayerGeneralMilitary> chooseList = new ArrayList<>();
    for (PlayerGeneralMilitary pgm : pgmMap.values()) {
      if (pgm == null)
        continue; 
      if (pgm.getState().intValue() > 1)
        continue; 
      int maxHp = dataGetter.getBattleDataCache().getMaxHp(pgm);
      if (!canJoinBattle(pgm.getForces().intValue() * 1.0D, maxHp))
        continue; 
      if (TeamManager.getInstance().isJoinTeam(pgm.getPlayerId().intValue(), pgm.getGeneralId().intValue()))
        continue; 
      GeneralMoveDto gmd = CityService.getGeneralMoveDto(pgm.getPlayerId().intValue(), pgm.getGeneralId().intValue());
      if (gmd != null) {
        if (gmd.cityState == 22)
          continue; 
        if (gmd.cityState == 23)
          continue; 
      } 
      chooseList.add(pgm);
    } 
    if (chooseList.size() <= 0) {
      tuple.left = null;
      tuple.right = LocalMessages.GENEGAL_CANNOT_BATTLE;
      return tuple;
    } 
    tuple.left = chooseList;
    return tuple;
  }
  
  public String getBattleId(IDataGetter dataGetter, Player player, int defId) {
    return NewBattleManager.getBattleId(this.battleType, player.getPlayerId().intValue(), defId);
  }
  
  public void initAttCamp(IDataGetter dataGetter, BattleAttacker battleAttacker, int defId, Battle bat) {
    if (battleAttacker.attPlayerId > 0) {
      int zdzsTech = dataGetter.getTechEffectCache().getTechEffect(battleAttacker.attPlayerId, 43);
      int autoStrategy = 0;
      if (zdzsTech > 0) {
        PlayerBattleAttribute pba = dataGetter.getPlayerBattleAttributeDao().read(battleAttacker.attPlayerId);
        autoStrategy = pba.getAutoStrategy().intValue();
      } else {
        autoStrategy = -1;
      } 
      bat.inBattlePlayers.put(Integer.valueOf(battleAttacker.attPlayerId), new PlayerInfo(battleAttacker.attPlayerId, true, autoStrategy));
    } 
    com.reign.gcld.battle.scene.Builder builder = BuilderFactory.getInstance().getBuilder(bat.getBattleType());
    List<PlayerGeneralMilitary> pgmList = battleAttacker.pgmList;
    Player player = battleAttacker.attPlayer;
    int attNum = 0;
    for (int i = 0; i < pgmList.size(); i++) {
      PlayerGeneralMilitary pgm = pgmList.get(i);
      CampArmy campArmy = copyArmyFromPlayerTable(player, pgm, dataGetter, builder.getGeneralState(), bat, 1);
      if (campArmy != null) {
        attNum += campArmy.getArmyHpOrg();
        bat.attCamp.add(campArmy);
      } 
    } 
    if (bat.attBaseInfo.getNum() + attNum < 0)
      ErrorSceneLog.getInstance().appendErrorMsg("兵力小于0,battle 784行"); 
    bat.attBaseInfo.setNum(bat.attBaseInfo.getNum() + attNum);
    bat.attBaseInfo.setAllNum(bat.attBaseInfo.getAllNum() + attNum);
    bat.attBaseInfo.setForceId(player.getForceId().intValue());
  }
  
  public static double getTerrainValue(int terrainType, Troop troop, int batSide, CampArmy campArmy) {
    if (troop == null || troop.getTerrains() == null)
      ErrorSceneLog.getInstance().appendErrorMsg("troop错误:terrainType:" + terrainType + ",Troop:" + troop); 
    TroopTerrain terrain = (TroopTerrain)troop.getTerrains().get(Integer.valueOf(terrainType));
    int effect = 0;
    if (terrain != null)
      if (batSide == 1) {
        effect = terrain.getAttEffect();
        campArmy.setTerrainQ(terrain.getAttQuality());
      } else {
        effect = terrain.getDefEffect();
        campArmy.setTerrainQ(terrain.getDefQuality());
      }  
    campArmy.setTerrain(effect / 100.0D);
    campArmy.terrainAdd = effect;
    return campArmy.getTerrain();
  }
  
  public static void getAttDefHp(IDataGetter dataGetter, CampArmy campArmy) {
    Troop troop = (Troop)dataGetter.getTroopCache().get(Integer.valueOf(campArmy.getTroopId()));
    if (troop == null)
      troop = dataGetter.getTroopCache().getTroopOfGeneral(campArmy.getTroopId()); 
    int att = dataGetter.getBattleDataCache().getAtt(campArmy.getPlayerId(), campArmy.getGeneralId(), troop, campArmy.getGeneralLv(), campArmy.getIsDeputy(), campArmy.getZhuJiangId());
    int def = dataGetter.getBattleDataCache().getDef(campArmy.getPlayerId(), campArmy.getGeneralId(), troop, campArmy.getGeneralLv(), campArmy.getIsDeputy(), campArmy.getZhuJiangId());
    int maxHp = dataGetter.getBattleDataCache().getMaxHp(campArmy.getPlayerId(), campArmy.getGeneralId(), troop, campArmy.getGeneralLv(), campArmy.getIsDeputy(), campArmy.getZhuJiangId());
    int column = dataGetter.getBattleDataCache().getColumNum(campArmy.getPlayerId());
    if (campArmy.getIsDeputy() > 0) {
      int fjbingli = maxHp;
      fjbingli = maxHp = fjbingli - fjbingli % 3;
      campArmy.setArmyHp(fjbingli);
      campArmy.setArmyHpOrg(fjbingli);
      column = 1;
    } 
    if (campArmy.getGeneralId() == 268 && campArmy.getIsJuexing() > 0)
      campArmy.setResistePercentage(Double.valueOf(0.2D)); 
    if (campArmy.getGeneralId() == 204 && campArmy.getChapterId() >= 3)
      campArmy.setResistePercentage(Double.valueOf(0.8D)); 
    if (campArmy.getGeneralId() == 107 && campArmy.getChapterId() >= 1)
      campArmy.setResistePercentage(Double.valueOf(0.8D)); 
    if (campArmy.getGeneralId() == 281 && campArmy.getChapterId() >= 1)
      campArmy.setResistePercentage(Double.valueOf(0.8D)); 
    if (campArmy.getGeneralId() == 269 && campArmy.getChapterId() >= 1)
      campArmy.setResistePercentage(Double.valueOf(0.8D)); 
    if (campArmy.getGeneralId() == 201 && campArmy.getChapterId() >= 1)
      campArmy.setResistePercentage(Double.valueOf(0.8D)); 
    if (campArmy.getGeneralId() == 416 && campArmy.getChapterId() >= 1)
      campArmy.setResistePercentage(Double.valueOf(0.8D)); 
    int remainder = maxHp % 3 * column;
    maxHp -= remainder;
    int troopHp = maxHp / column;
    campArmy.setTroopHp(troopHp);
    if (campArmy.getUnionState() > 0 || campArmy.getLegendEvoke()) {
      column++;
      if (campArmy.getArmyHp() >= maxHp && campArmy.getTacticVal() <= 0)
        campArmy.setTacticVal(1); 
      maxHp += troopHp;
      campArmy.setArmyHp(campArmy.getArmyHp() + troopHp);
      campArmy.setArmyHpOrg(campArmy.getArmyHpOrg() + troopHp);
    } 
    campArmy.setColumn(column);
    campArmy.setAttEffect(att);
    campArmy.setDefEffect(def);
    campArmy.setMaxForces(maxHp);
    List<StoreHouse> prosetList = dataGetter.getStoreHouseDao().getGeneralEquipList(campArmy.playerId, campArmy.generalId, 14);
    if (prosetList != null && prosetList.size() > 0) {
      if (prosetList.size() > 1)
        ErrorSceneLog.getInstance().appendErrorMsg("too many prosetList").appendPlayerId(campArmy.playerId).appendPlayerName(campArmy.playerName).appendGeneralId(campArmy.generalId).appendGeneralName(campArmy.generalName).appendClassName("Builder").appendMethodName("getAttDefHp").flush(); 
      StoreHouse proset = prosetList.get(0);
      EquipProset equipProset = dataGetter.getEquipCache().getEquipProsetByItemId(proset.getItemId().intValue());
      if (equipProset != null) {
        EquipCoordinates equipCoordinates = dataGetter.getEquipCache().getMainSuit(equipProset.getId().intValue());
        if (equipCoordinates != null) {
          int[] skills = { equipCoordinates.getPos1Skill().intValue(), equipCoordinates.getPos2Skill().intValue(), equipCoordinates.getPos3Skill().intValue(), equipCoordinates.getPos4Skill().intValue(), equipCoordinates.getPos5Skill().intValue(), equipCoordinates.getPos6Skill().intValue() };
          int lv = 5;
          int starNum = 4;
          for (int i = 0; i < skills.length; i++) {
            int skillId = skills[i];
            EquipSkillEffect equipSkillEffect = dataGetter.getEquipSkillEffectCache().getEquipSkillEffectByIdLV(skillId, 5);
            if (equipSkillEffect != null) {
              if (equipSkillEffect.getAttDef_B() != null) {
                AttDef_B attDef_B12 = campArmy.attDef_B, attDef_B = attDef_B12;
                attDef_B12.ATT_B += 4 * (equipSkillEffect.getAttDef_B()).ATT_B;
                AttDef_B attDef_B13 = campArmy.attDef_B, attDef_B2 = attDef_B13;
                attDef_B13.DEF_B += 4 * (equipSkillEffect.getAttDef_B()).DEF_B;
              } 
              campArmy.TACTIC_ATT += 4 * equipSkillEffect.getTACTIC_ATT();
              campArmy.TACTIC_DEF += 4 * equipSkillEffect.getTACTIC_DEF();
            } else {
              Player player = dataGetter.getPlayerDao().read(campArmy.playerId);
              ErrorSceneLog.getInstance().appendErrorMsg("equipSkillEffect is null.").append("skillId", Integer.valueOf(skillId)).append("lv", Integer.valueOf(5)).appendPlayerId(campArmy.playerId).appendPlayerName(player.getPlayerName()).appendGeneralId(campArmy.generalId).appendGeneralName(((General)dataGetter.getGeneralCache().get(Integer.valueOf(campArmy.generalId))).getName()).flush();
            } 
          } 
        } else {
          ErrorSceneLog.getInstance().appendErrorMsg("equipCoordinates is null.").append("equipProset.getId()", equipProset.getId()).append("proset.getVId()", proset.getVId()).appendPlayerId(campArmy.playerId).appendPlayerName(campArmy.playerName).appendGeneralId(campArmy.generalId).appendGeneralName(campArmy.generalName).appendClassName("Builder").appendMethodName("getAttDefHp").flush();
        } 
      } else {
        ErrorSceneLog.getInstance().appendErrorMsg("equipProset is null.").append("proset.getItemId()", proset.getItemId()).append("proset.getVId()", proset.getVId()).appendPlayerId(campArmy.playerId).appendPlayerName(campArmy.playerName).appendGeneralId(campArmy.generalId).appendGeneralName(campArmy.generalName).appendClassName("Builder").appendMethodName("getAttDefHp").flush();
      } 
    } 
    List<StoreHouse> shList = dataGetter.getStoreHouseDao().getGeneralEquipList(campArmy.playerId, campArmy.generalId, 10);
    for (StoreHouse psh : shList) {
      if (psh.getType().intValue() != 10)
        continue; 
      EquipCoordinates equipCoordinates2 = dataGetter.getEquipCache().getEquipCoordinateByItemId(psh.getItemId().intValue());
      if (equipCoordinates2 != null) {
        int[] skills2 = { equipCoordinates2.getPos1Skill().intValue(), equipCoordinates2.getPos2Skill().intValue(), equipCoordinates2.getPos3Skill().intValue(), equipCoordinates2.getPos4Skill().intValue(), equipCoordinates2.getPos5Skill().intValue(), equipCoordinates2.getPos6Skill().intValue() };
        int lv2 = 5;
        int starNum2 = 4;
        for (int j = 0; j < skills2.length; j++) {
          int skillId2 = skills2[j];
          EquipSkillEffect equipSkillEffect2 = dataGetter.getEquipSkillEffectCache().getEquipSkillEffectByIdLV(skillId2, 5);
          if (equipSkillEffect2 != null) {
            if (equipSkillEffect2.getAttDef_B() != null) {
              AttDef_B attDef_B14 = campArmy.attDef_B, attDef_B3 = attDef_B14;
              attDef_B14.ATT_B += 4 * (equipSkillEffect2.getAttDef_B()).ATT_B;
              AttDef_B attDef_B15 = campArmy.attDef_B, attDef_B4 = attDef_B15;
              attDef_B15.DEF_B += 4 * (equipSkillEffect2.getAttDef_B()).DEF_B;
            } 
            campArmy.TACTIC_ATT += 4 * equipSkillEffect2.getTACTIC_ATT();
            campArmy.TACTIC_DEF += 4 * equipSkillEffect2.getTACTIC_DEF();
          } else {
            Player player2 = dataGetter.getPlayerDao().read(campArmy.playerId);
            ErrorSceneLog.getInstance().appendErrorMsg("equipSkillEffect is null.").append("skillId", Integer.valueOf(skillId2)).append("lv", Integer.valueOf(5)).appendPlayerId(campArmy.playerId).appendPlayerName(player2.getPlayerName()).appendGeneralId(campArmy.generalId).appendGeneralName(((General)dataGetter.getGeneralCache().get(Integer.valueOf(campArmy.generalId))).getName()).flush();
          } 
        } 
        continue;
      } 
      Player player3 = dataGetter.getPlayerDao().read(campArmy.playerId);
      ErrorSceneLog.getInstance().appendErrorMsg("equipCoordinates is null.").append("StoreHouse", psh.getVId()).append("psh.getItemId()", psh.getItemId()).appendPlayerId(campArmy.playerId).appendPlayerName(player3.getPlayerName()).appendGeneralId(campArmy.generalId).appendGeneralName(((General)dataGetter.getGeneralCache().get(Integer.valueOf(campArmy.generalId))).getName()).flush();
    } 
    List<StoreHouse> jitaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(campArmy.playerId, campArmy.generalId, 25);
    if (jitaoList != null && jitaoList.size() > 0) {
      if (jitaoList.size() > 1)
        ErrorSceneLog.getInstance().appendErrorMsg("too many jitaoList").appendPlayerId(campArmy.playerId).appendPlayerName(campArmy.playerName).appendGeneralId(campArmy.generalId).appendGeneralName(campArmy.generalName).appendClassName("Builder").appendMethodName("getAttDefHp").flush(); 
      StoreHouse jitao = jitaoList.get(0);
      EquipProset equipProset2 = dataGetter.getEquipCache().getProsetBySuitId(jitao.getItemId().intValue());
      EquipJitao equipJitao = dataGetter.getEquipCache().getEquipJitaoById(jitao.getItemId().intValue());
      if (equipProset2 != null) {
        EquipCoordinates equipCoordinates3 = dataGetter.getEquipCache().getMainSuit(equipProset2.getId().intValue());
        if (equipCoordinates3 != null) {
          int[] skills3 = { equipCoordinates3.getPos1Skill().intValue(), equipCoordinates3.getPos2Skill().intValue(), equipCoordinates3.getPos3Skill().intValue(), equipCoordinates3.getPos4Skill().intValue(), equipCoordinates3.getPos5Skill().intValue(), equipCoordinates3.getPos6Skill().intValue() };
          int lv3 = 5;
          int starNum3 = 4;
          for (int k = 0; k < skills3.length; k++) {
            int skillId3 = skills3[k];
            EquipSkillEffect equipSkillEffect3 = dataGetter.getEquipSkillEffectCache().getEquipSkillEffectByIdLV(skillId3, 5);
            if (equipSkillEffect3 != null) {
              if (equipSkillEffect3.getAttDef_B() != null) {
                AttDef_B attDef_B16 = campArmy.attDef_B, attDef_B5 = attDef_B16;
                attDef_B16.ATT_B += 4 * (equipSkillEffect3.getAttDef_B()).ATT_B;
                AttDef_B attDef_B17 = campArmy.attDef_B, attDef_B6 = attDef_B17;
                attDef_B17.DEF_B += 4 * (equipSkillEffect3.getAttDef_B()).DEF_B;
              } 
              campArmy.TACTIC_ATT += 4 * equipSkillEffect3.getTACTIC_ATT();
              campArmy.TACTIC_DEF += 4 * equipSkillEffect3.getTACTIC_DEF();
            } else {
              Player player4 = dataGetter.getPlayerDao().read(campArmy.playerId);
              ErrorSceneLog.getInstance().appendErrorMsg("equipSkillEffect is null.").append("skillId", Integer.valueOf(skillId3)).append("lv", Integer.valueOf(5)).appendPlayerId(campArmy.playerId).appendPlayerName(player4.getPlayerName()).appendGeneralId(campArmy.generalId).appendGeneralName(((General)dataGetter.getGeneralCache().get(Integer.valueOf(campArmy.generalId))).getName()).flush();
            } 
          } 
          int skill1 = equipJitao.getPos1Skill().intValue();
          int skill2 = equipJitao.getPos2Skill().intValue();
          EquipSkillEffect equipSkillEffect4 = dataGetter.getEquipSkillEffectCache().getEquipSkillEffectByIdLV(skill1, 5);
          EquipSkillEffect equipSkillEffect5 = dataGetter.getEquipSkillEffectCache().getEquipSkillEffectByIdLV(skill2, 5);
          if (skill1 == 1) {
            AttDef_B attDef_B18 = campArmy.attDef_B;
            attDef_B18.ATT_B += (equipSkillEffect4.getAttDef_B()).ATT_B * 2;
          } else if (skill1 == 2) {
            AttDef_B attDef_B19 = campArmy.attDef_B;
            attDef_B19.DEF_B += (equipSkillEffect4.getAttDef_B()).DEF_B * 2;
          } else if (skill1 == 6) {
            campArmy.TACTIC_ATT += equipSkillEffect4.getTACTIC_ATT() * 2;
          } else if (skill1 == 7) {
            campArmy.TACTIC_DEF += equipSkillEffect4.getTACTIC_DEF() * 2;
          } 
          if (skill2 == 1) {
            AttDef_B attDef_B20 = campArmy.attDef_B;
            attDef_B20.ATT_B += (equipSkillEffect5.getAttDef_B()).ATT_B;
          } else if (skill2 == 2) {
            AttDef_B attDef_B21 = campArmy.attDef_B;
            attDef_B21.DEF_B += (equipSkillEffect5.getAttDef_B()).DEF_B;
          } else if (skill2 == 6) {
            campArmy.TACTIC_ATT += equipSkillEffect5.getTACTIC_ATT();
          } else if (skill2 == 7) {
            campArmy.TACTIC_DEF += equipSkillEffect5.getTACTIC_DEF();
          } 
        } else {
          ErrorSceneLog.getInstance().appendErrorMsg("equipCoordinates is null.").append("equipProset.getId()", equipProset2.getId()).append("proset.getVId()", jitao.getVId()).appendPlayerId(campArmy.playerId).appendPlayerName(campArmy.playerName).appendGeneralId(campArmy.generalId).appendGeneralName(campArmy.generalName).appendClassName("Builder").appendMethodName("getAttDefHp").flush();
        } 
      } else {
        ErrorSceneLog.getInstance().appendErrorMsg("equipjitao is null.").append("jitao.getItemId()", jitao.getItemId()).append("proset.getVId()", jitao.getVId()).appendPlayerId(campArmy.playerId).appendPlayerName(campArmy.playerName).appendGeneralId(campArmy.generalId).appendGeneralName(campArmy.generalName).appendClassName("Builder").appendMethodName("getAttDefHp").flush();
      } 
    } 
    List<StoreHouse> jiaotaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(campArmy.playerId, campArmy.generalId, 36);
    if (jiaotaoList != null && jiaotaoList.size() > 0) {
      if (jiaotaoList.size() > 1)
        ErrorSceneLog.getInstance().appendErrorMsg("too many jiaotaoList").appendPlayerId(campArmy.playerId).appendPlayerName(campArmy.playerName).appendGeneralId(campArmy.generalId).appendGeneralName(campArmy.generalName).appendClassName("Builder").appendMethodName("getAttDefHp").flush(); 
      StoreHouse jiaotao = jiaotaoList.get(0);
      EquipProset equipProset3 = dataGetter.getEquipCache().getProsetBySuitId(jiaotao.getItemId().intValue());
      EquipJiaotao equipJiaotao = dataGetter.getEquipCache().getEquipJiaotaoById(jiaotao.getItemId().intValue());
      if (equipProset3 != null) {
        EquipCoordinates equipCoordinates4 = dataGetter.getEquipCache().getMainSuit(equipProset3.getId().intValue());
        if (equipCoordinates4 != null) {
          int[] skills4 = { equipCoordinates4.getPos1Skill().intValue(), equipCoordinates4.getPos2Skill().intValue(), equipCoordinates4.getPos3Skill().intValue(), equipCoordinates4.getPos4Skill().intValue(), equipCoordinates4.getPos5Skill().intValue(), equipCoordinates4.getPos6Skill().intValue() };
          int lv4 = 5;
          int starNum4 = 4;
          for (int l = 0; l < skills4.length; l++) {
            int skillId4 = skills4[l];
            EquipSkillEffect equipSkillEffect6 = dataGetter.getEquipSkillEffectCache().getEquipSkillEffectByIdLV(skillId4, 5);
            if (equipSkillEffect6 != null) {
              if (equipSkillEffect6.getAttDef_B() != null) {
                AttDef_B attDef_B22 = campArmy.attDef_B, attDef_B7 = attDef_B22;
                attDef_B22.ATT_B += 4 * (equipSkillEffect6.getAttDef_B()).ATT_B;
                AttDef_B attDef_B23 = campArmy.attDef_B, attDef_B8 = attDef_B23;
                attDef_B23.DEF_B += 4 * (equipSkillEffect6.getAttDef_B()).DEF_B;
              } 
              campArmy.TACTIC_ATT += 4 * equipSkillEffect6.getTACTIC_ATT();
              campArmy.TACTIC_DEF += 4 * equipSkillEffect6.getTACTIC_DEF();
            } else {
              Player player5 = dataGetter.getPlayerDao().read(campArmy.playerId);
              ErrorSceneLog.getInstance().appendErrorMsg("equipSkillEffect is null.").append("skillId", Integer.valueOf(skillId4)).append("lv", Integer.valueOf(5)).appendPlayerId(campArmy.playerId).appendPlayerName(player5.getPlayerName()).appendGeneralId(campArmy.generalId).appendGeneralName(((General)dataGetter.getGeneralCache().get(Integer.valueOf(campArmy.generalId))).getName()).flush();
            } 
          } 
          int skill3 = equipJiaotao.getPos1Skill().intValue();
          int skill4 = equipJiaotao.getPos2Skill().intValue();
          EquipSkillEffect equipSkillEffect7 = dataGetter.getEquipSkillEffectCache().getEquipSkillEffectByIdLV(skill3, 5);
          EquipSkillEffect equipSkillEffect8 = dataGetter.getEquipSkillEffectCache().getEquipSkillEffectByIdLV(skill4, 5);
          if (skill3 == 1) {
            AttDef_B attDef_B24 = campArmy.attDef_B;
            attDef_B24.ATT_B += (equipSkillEffect7.getAttDef_B()).ATT_B * 4;
          } else if (skill3 == 2) {
            AttDef_B attDef_B25 = campArmy.attDef_B;
            attDef_B25.DEF_B += (equipSkillEffect7.getAttDef_B()).DEF_B * 4;
          } else if (skill3 == 6) {
            campArmy.TACTIC_ATT += equipSkillEffect7.getTACTIC_ATT() * 4;
          } else if (skill3 == 7) {
            campArmy.TACTIC_DEF += equipSkillEffect7.getTACTIC_DEF() * 4;
          } 
          if (skill4 == 1) {
            AttDef_B attDef_B26 = campArmy.attDef_B;
            attDef_B26.ATT_B += (equipSkillEffect8.getAttDef_B()).ATT_B * 3;
          } else if (skill4 == 2) {
            AttDef_B attDef_B27 = campArmy.attDef_B;
            attDef_B27.DEF_B += (equipSkillEffect8.getAttDef_B()).DEF_B * 3;
          } else if (skill4 == 6) {
            campArmy.TACTIC_ATT += equipSkillEffect8.getTACTIC_ATT() * 3;
          } else if (skill4 == 7) {
            campArmy.TACTIC_DEF += equipSkillEffect8.getTACTIC_DEF() * 3;
          } 
        } else {
          ErrorSceneLog.getInstance().appendErrorMsg("equipCoordinates is null.").append("equipProset.getId()", equipProset3.getId()).append("proset.getVId()", jiaotao.getVId()).appendPlayerId(campArmy.playerId).appendPlayerName(campArmy.playerName).appendGeneralId(campArmy.generalId).appendGeneralName(campArmy.generalName).appendClassName("Builder").appendMethodName("getAttDefHp").flush();
        } 
      } else {
        ErrorSceneLog.getInstance().appendErrorMsg("equipjiaotao is null.").append("jiaotao.getItemId()", jiaotao.getItemId()).append("proset.getVId()", jiaotao.getVId()).appendPlayerId(campArmy.playerId).appendPlayerName(campArmy.playerName).appendGeneralId(campArmy.generalId).appendGeneralName(campArmy.generalName).appendClassName("Builder").appendMethodName("getAttDefHp").flush();
      } 
    } 
    shList = dataGetter.getStoreHouseDao().getGeneralEquipList(campArmy.playerId, campArmy.generalId, 1);
    for (StoreHouse psh2 : shList) {
      if (psh2.getRefreshAttribute() != null && !psh2.getRefreshAttribute().isEmpty()) {
        String[] skills5 = psh2.getRefreshAttribute().split(";");
        for (int m = 0; m < skills5.length; m++) {
          String skill5 = skills5[m];
          String[] idLv = skill5.split(":");
          if (idLv.length == 2) {
            int id = Integer.parseInt(idLv[0]);
            int lv5 = Integer.parseInt(idLv[1]);
            EquipSkillEffect equipSkillEffect9 = dataGetter.getEquipSkillEffectCache().getEquipSkillEffectByIdLV(id, lv5);
            if (equipSkillEffect9 != null) {
              if (equipSkillEffect9.getAttDef_B() != null) {
                AttDef_B attDef_B28 = campArmy.attDef_B, attDef_B9 = attDef_B28;
                attDef_B28.ATT_B += (equipSkillEffect9.getAttDef_B()).ATT_B;
                AttDef_B attDef_B29 = campArmy.attDef_B, attDef_B10 = attDef_B29;
                attDef_B29.DEF_B += (equipSkillEffect9.getAttDef_B()).DEF_B;
              } 
              campArmy.TACTIC_ATT += equipSkillEffect9.getTACTIC_ATT();
              campArmy.TACTIC_DEF += equipSkillEffect9.getTACTIC_DEF();
            } else {
              Player player6 = dataGetter.getPlayerDao().read(campArmy.playerId);
              ErrorSceneLog.getInstance().appendErrorMsg("equipSkillEffect is null.").append("id", Integer.valueOf(id)).append("lv", Integer.valueOf(lv5)).appendPlayerId(campArmy.playerId).appendPlayerName(player6.getPlayerName()).appendGeneralId(campArmy.generalId).appendGeneralName(((General)dataGetter.getGeneralCache().get(Integer.valueOf(campArmy.generalId))).getName()).flush();
            } 
          } 
        } 
      } 
    } 
    Map<Integer, Float> ahMap = dataGetter.getBattleDataCache().getBingZhongAndTerrian(campArmy.getPlayerId(), campArmy.getGeneralId());
    if (ahMap != null && !ahMap.isEmpty()) {
      AttDef_B attDef_B30 = campArmy.attDef_B, attDef_B11 = attDef_B30;
      attDef_B30.ATT_B += ((Float)ahMap.get(Integer.valueOf(7))).intValue();
      AttDef_B attDef_B31 = attDef_B11;
      attDef_B31.DEF_B += ((Float)ahMap.get(Integer.valueOf(8))).intValue();
      campArmy.TACTIC_ATT += ((Float)ahMap.get(Integer.valueOf(9))).intValue();
      campArmy.TACTIC_DEF += ((Float)ahMap.get(Integer.valueOf(10))).intValue();
      campArmy.setBuBingDamage(((Float)ahMap.get(Integer.valueOf(1))).floatValue());
      campArmy.setGongBingDamage(((Float)ahMap.get(Integer.valueOf(2))).floatValue());
      campArmy.setQiBingDamage(((Float)ahMap.get(Integer.valueOf(3))).floatValue());
      campArmy.setPingYuanDamage(((Float)ahMap.get(Integer.valueOf(4))).intValue());
      campArmy.setShanDiDamage(((Float)ahMap.get(Integer.valueOf(5))).intValue());
      campArmy.setShuiYuDamage(((Float)ahMap.get(Integer.valueOf(6))).intValue());
      campArmy.setShanBiGailv(((Float)ahMap.get(Integer.valueOf(11))).intValue());
      campArmy.setYiXueGaiLv(((Float)ahMap.get(Integer.valueOf(12))).intValue());
      campArmy.setMianYiGaiLv(((Float)ahMap.get(Integer.valueOf(13))).intValue());
      campArmy.setBaoJiGaiLv(((Float)ahMap.get(Integer.valueOf(14))).intValue());
      campArmy.setYccyGaiLv(((Float)ahMap.get(Integer.valueOf(15))).intValue());
      campArmy.setFgyjBili(((Float)ahMap.get(Integer.valueOf(16))).intValue());
    } 
    if (campArmy.getPlayerId() < 0) {
      Map<Integer, String> ycbweffectMap = dataGetter.getBattleDataCache().getYcbwMap(campArmy.getPlayerId(), campArmy.getGeneralId());
      campArmy.zfbili += Integer.valueOf(ycbweffectMap.get(Integer.valueOf(17))).intValue();
    } 
    dataGetter.getBattleDataCache().getLegendSkill(campArmy.getPlayerId(), campArmy.getGeneralId(), campArmy.getLegendSkill());
  }
  
  public static void getAttDef(IDataGetter dataGetter, CampArmy campArmy) {
    Troop troop = (Troop)dataGetter.getTroopCache().get(Integer.valueOf(campArmy.getTroopId()));
    if (troop == null)
      troop = dataGetter.getTroopCache().getTroopOfGeneral(campArmy.getTroopId()); 
    int att = dataGetter.getBattleDataCache().getAtt(campArmy.getPlayerId(), campArmy.getGeneralId(), troop, campArmy.getGeneralLv(), campArmy.getIsDeputy(), campArmy.getZhuJiangId());
    int def = dataGetter.getBattleDataCache().getDef(campArmy.getPlayerId(), campArmy.getGeneralId(), troop, campArmy.getGeneralLv(), campArmy.getIsDeputy(), campArmy.getZhuJiangId());
    campArmy.setAttEffect(att);
    campArmy.setDefEffect(def);
  }
  
  public CampArmy copyArmyFromPlayerTable(Player player, PlayerGeneralMilitary pgm, IDataGetter dataGetter, int generalBattleType, Battle bat, int batSide) {
    CampArmy campArmy = new CampArmy();
    General general = (General)dataGetter.getGeneralCache().get(pgm.getGeneralId());
    campArmy.setSpecialGeneral(new SpecialGeneral((general.getGeneralSpecialInfo()).generalType, (general.getGeneralSpecialInfo()).param, (general.getGeneralSpecialInfo()).param2));
    campArmy.updateDB = true;
    campArmy.setPlayerLv(player.getPlayerLv().intValue());
    campArmy.setPlayerId(player.getPlayerId().intValue());
    campArmy.setPayTotal(player.getPayTotal().intValue());
    campArmy.setPlayerName(player.getPlayerName());
    campArmy.setZyMaxRow(true);
    campArmy.setForceId(player.getForceId().intValue());
    campArmy.setActivityAddExp(dataGetter.getActivityService().getAddBatValue(player.getPlayerId().intValue(), player.getPlayerLv().intValue()));
    PlayerBattleAttribute pba = dataGetter.getPlayerBattleAttributeDao().read(player.getPlayerId().intValue());
    campArmy.setSex(general.getSex().intValue());
    campArmy.setGeneralId(pgm.getGeneralId().intValue());
    campArmy.setGeneralLv(pgm.getLv().intValue());
    campArmy.setPgmVId(pgm.getVId().intValue());
    int addleader = (general.getLeader() == null) ? 0 : general.getLeader().intValue();
    addleader += dataGetter.getBattleDataCache().getGeneralEvokeLeader(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
    int addstr = (general.getStrength() == null) ? 0 : general.getStrength().intValue();
    addstr += dataGetter.getBattleDataCache().getGeneralEvokeStrength(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
    int horseaddleader = dataGetter.getBattleDataCache().getGeneralHorseLeader(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
    addleader += horseaddleader;
    addstr += horseaddleader;
    campArmy.setStrength(pgm.getStrength(Integer.valueOf(addstr)).intValue());
    campArmy.setLeader(pgm.getLeader(Integer.valueOf(addleader)).intValue());
    campArmy.setArmyName(general.getName());
    campArmy.setGeneralName(general.getName());
    campArmy.setGeneralPic(general.getPic());
    campArmy.setQuality(general.getQuality().intValue());
    campArmy.setTacicId(general.getTacticId().intValue());
    if (pgm.getDeputyId() != null && pgm.getDeputyId().intValue() > 0)
      campArmy.setDeputy(pgm.getDeputyId().intValue()); 
    if (pgm.getIsDeputy() != null && pgm.getIsDeputy().intValue() > 0)
      campArmy.setIsDeputy(1); 
    if (pgm.getLordId() != null && pgm.getLordId().intValue() > 0) {
      campArmy.setIsDeputy(1);
      campArmy.setZhuJiangId(pgm.getLordId().intValue());
    } 
    int troopid = general.getTroop().intValue();
    PlayerAttribute pa = dataGetter.getPlayerAttributeDao().read(player.getPlayerId().intValue());
    if (pa != null && pa.getMountRank().intValue() > 0)
      campArmy.setZuoQiSkill(pa.getMountRank().intValue()); 
    if (player.getMoonCard().intValue() > 0 && player.getMoonCardTime() != null && player.getMoonCardTime().after(new Date()))
      campArmy.setIsMoonCard(true); 
    boolean uniontroop = false;
    boolean legend_281 = false;
    PlayerGeneralEvoke pge = dataGetter.getPlayerGeneralEvokeDao().getPlayerGeneralEvoke(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
    if (pge != null) {
      if (pge.getEvokeSkillFinal().intValue() > 0 || pge.getUnionEvoke().intValue() > 0) {
        campArmy.setIsJuexing(1);
        if (pge.getGeneralId().intValue() == 402)
          campArmy.setMhxx(1); 
      } 
      if (pge.getEvokeSkillFinal().intValue() > 0 || pge.getUnionEvoke().intValue() > 0) {
        EvokeGeneral egr = dataGetter.getEvokeGeneralCache().getEvokeGeneral(pgm.getGeneralId().intValue());
        campArmy.setTacicId(egr.getTacticId().intValue());
        campArmy.setGeneralPic(egr.getPic());
        if (pge.getUnionEvoke().intValue() > 0 && pgm.getGeneralId().intValue() == 103 && pgm.getDeputyId().intValue() == 269) {
          campArmy.setTacicId(1321);
          campArmy.setGeneralName("赤壁奇谋");
          campArmy.setGeneralPic("zhouyujx_zhugeliangjx");
          campArmy.setUnionRank(pge.getUnionRank().intValue());
          campArmy.setDeputy(0);
          campArmy.setUnionState(1);
          uniontroop = true;
        } 
      } 
      int zsjqskill = dataGetter.getBattleDataCache().getGeneralZsjqSkillLevel(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
      campArmy.setZsJqSkillLevel(zsjqskill);
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 204) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic[curChapter - 1]);
        campArmy.setTacicId(4020401);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
      } 
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 107) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName2[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic2[curChapter - 1]);
        campArmy.setTacicId(4010701);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
      } 
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 281) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName3[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic3[curChapter - 1]);
        campArmy.setTacicId(4028101);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
        legend_281 = true;
      } 
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 269) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName4[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic4[curChapter - 1]);
        campArmy.setTacicId(4026901);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
        legend_281 = true;
      } 
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 201) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName5[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic5[curChapter - 1]);
        campArmy.setTacicId(4020101);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
      } 
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 416) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName6[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic6[curChapter - 1]);
        campArmy.setTacicId(9991309);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
      } 
      if (campArmy.getIsJuexing() <= 0 && pgm.getGeneralId().intValue() == 204)
        troopid = 34; 
      if (campArmy.getIsJuexing() > 0) {
        for (int k = 0; k < GeneralUtils.jxwulist.length; k++) {
          if (pgm.getGeneralId().intValue() == GeneralUtils.jxwulist[k].intValue()) {
            troopid = GeneralUtils.jxtroop[k].intValue();
            break;
          } 
        } 
        if (pgm.getGeneralId().intValue() == 204) {
          campArmy.setChiZhanFa(1);
          if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
            troopid = 122; 
        } 
        if (pgm.getGeneralId().intValue() == 107) {
          campArmy.setChiZhanFa(1);
          if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
            troopid = 127; 
        } 
        if (pgm.getGeneralId().intValue() == 281) {
          campArmy.setChiZhanFa(1);
          if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
            troopid = 128; 
        } 
        if (pgm.getGeneralId().intValue() == 269) {
          campArmy.setChiZhanFa(1);
          if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
            troopid = 143; 
        } 
        if (pgm.getGeneralId().intValue() == 201) {
          campArmy.setChiZhanFa(1);
          if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
            troopid = 149; 
        } 
        if (pgm.getGeneralId().intValue() == 416) {
          campArmy.setChiZhanFa(1);
          if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
            troopid = 881681; 
        } 
      } 
    } 
    if (uniontroop)
      troopid = 75; 
    if (pge != null) {
      if (pgm.getGeneralId().intValue() == 277 && pge.getUnionEvoke().intValue() > 0) {
        troopid = 80;
        campArmy.setTacicId(1755);
        campArmy.setGeneralPic("liuguanzhang");
        campArmy.setUnionRank(pge.getUnionRank().intValue());
        campArmy.setDeputy(0);
        campArmy.setUnionState(1);
      } 
      if (pgm.getGeneralId().intValue() == 202 && pge.getShenJiang().intValue() > 0) {
        troopid = 79;
        campArmy.setTacicId(3101);
      } 
      if (pgm.getGeneralId().intValue() == 201 && pge.getUnionEvoke().intValue() > 0 && pgm.getDeputyId().intValue() == 266) {
        troopid = 89;
        campArmy.setTacicId(1614);
        campArmy.setGeneralPic("lvbudiaochanjx");
        campArmy.setUnionRank(pge.getUnionRank().intValue());
        campArmy.setDeputy(0);
        campArmy.setUnionState(1);
        campArmy.setGeneralName("乱世眷侣");
      } 
      if (pgm.getGeneralId().intValue() == 270 && pge.getUnionEvoke().intValue() > 0 && pgm.getDeputyId().intValue() == 273) {
        troopid = 103;
        campArmy.setTacicId(1802);
        campArmy.setGeneralPic("xiahoudun_xiahouyuanjx1");
        campArmy.setUnionRank(pge.getUnionRank().intValue());
        campArmy.setDeputy(0);
        campArmy.setUnionState(1);
        campArmy.setGeneralName("夏侯兄弟");
      } 
      if (pgm.getGeneralId().intValue() == 232 && pge.getUnionEvoke().intValue() > 0 && pgm.getDeputyId().intValue() == 274) {
        troopid = 108;
        campArmy.setTacicId(3601);
        campArmy.setGeneralPic("nanzhongzhizhu");
        campArmy.setUnionRank(pge.getUnionRank().intValue());
        campArmy.setDeputy(0);
        campArmy.setUnionState(1);
        campArmy.setGeneralName("南中之主");
      } 
    } 
    StoreHouse generalTreasure = dataGetter.getStoreHouseDao().getByGeneralIdAndType(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 2, 3);
    if (generalTreasure != null) {
      int baowuid = generalTreasure.getItemId().intValue();
      if (pgm.getGeneralId().intValue() == 107 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1075)
        troopid = 881442; 
      if (pgm.getGeneralId().intValue() == 204 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1074)
        troopid = 881222; 
      if (pgm.getGeneralId().intValue() == 281 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1073)
        troopid = 881281; 
      if (pgm.getGeneralId().intValue() == 269 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1072)
        troopid = 881434; 
      if (pgm.getGeneralId().intValue() == 201 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1071)
        troopid = 881492; 
      if ((baowuid == 81 || generalTreasure.getPiFu().intValue() == 81) && pgm.getGeneralId().intValue() == 201 && (campArmy.getUnionState() <= 0 || pgm.getDeputyId().intValue() != 266)) {
        troopid = 87571;
      } else if ((baowuid == 82 || generalTreasure.getPiFu().intValue() == 82) && pgm.getGeneralId().intValue() == 267) {
        troopid = 87621;
      } else if ((baowuid == 83 || generalTreasure.getPiFu().intValue() == 83) && pgm.getGeneralId().intValue() == 211) {
        troopid = 87671;
      } else if ((baowuid == 84 || generalTreasure.getPiFu().intValue() == 84) && pgm.getGeneralId().intValue() == 275) {
        troopid = 87601;
      } else if ((baowuid == 85 || generalTreasure.getPiFu().intValue() == 85) && pgm.getGeneralId().intValue() == 103 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 269) {
        troopid = 87751;
      } else if ((baowuid == 86 || generalTreasure.getPiFu().intValue() == 86) && pgm.getGeneralId().intValue() == 277 && campArmy.getUnionState() > 0) {
        troopid = 87801;
      } else if ((baowuid == 87 || generalTreasure.getPiFu().intValue() == 87) && pgm.getGeneralId().intValue() == 224) {
        troopid = 87551;
      } else if ((baowuid == 113 || generalTreasure.getPiFu().intValue() == 113) && pgm.getGeneralId().intValue() == 201 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 266) {
        troopid = 87893;
        campArmy.setGeneralPic("lvbudiaochanjx2");
      } else if ((baowuid == 111 || generalTreasure.getPiFu().intValue() == 111) && pgm.getGeneralId().intValue() == 201 && (campArmy.getUnionState() <= 0 || pgm.getDeputyId().intValue() != 266)) {
        troopid = 87572;
      } else if ((baowuid == 112 || generalTreasure.getPiFu().intValue() == 112) && pgm.getGeneralId().intValue() == 266) {
        troopid = 87711;
      } else if ((baowuid == 116 || generalTreasure.getPiFu().intValue() == 116) && pgm.getGeneralId().intValue() == 103 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 269) {
        troopid = 88751;
      } 
      if (baowuid >= 1003) {
        campArmy.setTouXian(baowuid);
        campArmy.setTitle(baowuid);
        campArmy.setTitle1(WeaponUtils.kuangshipic1[baowuid - 1003]);
      } 
    } 
    if (pgm.getGeneralId().intValue() == 211) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 34) {
            troopid = 87672;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 281) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 66) {
            troopid = 88961;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 107) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 68) {
            troopid = 88781;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 277 && campArmy.getUnionState() > 0) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 65) {
            troopid = 88801;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 201 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 266) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 67) {
            troopid = 88891;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 270 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 273) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 69) {
            troopid = 881031;
            break;
          } 
          if (sh.getItemId().intValue() == 70) {
            troopid = 881032;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 232 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 274) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 71) {
            troopid = 881081;
            break;
          } 
          if (sh.getItemId().intValue() == 72) {
            troopid = 881082;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 204 && campArmy.getLegendEvoke()) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 73) {
            troopid = 881221;
            campArmy.setTacicId(4020402);
            break;
          } 
          if (sh.getItemId().intValue() == 74) {
            troopid = 881223;
            campArmy.setTacicId(4020403);
            break;
          } 
          if (sh.getItemId().intValue() == 121) {
            troopid = 881224;
            campArmy.setTacicId(4020403);
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 107 && campArmy.getLegendEvoke()) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 35) {
            troopid = 881273;
            campArmy.setTacicId(4010702);
            break;
          } 
          if (sh.getItemId().intValue() == 79) {
            troopid = 12730001;
            campArmy.setTacicId(4010702);
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 281 && campArmy.getLegendEvoke()) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 36) {
            troopid = 13830001;
            campArmy.setTacicId(4028101);
            break;
          } 
          if (sh.getItemId().intValue() == 80) {
            troopid = 13830002;
            campArmy.setTacicId(4028101);
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 269 && campArmy.getLegendEvoke()) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 40) {
            troopid = 14330001;
            campArmy.setTacicId(4026901);
            break;
          } 
          if (sh.getItemId().intValue() == 78) {
            troopid = 14330002;
            campArmy.setTacicId(4026901);
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 201 && campArmy.getLegendEvoke()) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 37) {
            troopid = 14930001;
            campArmy.setTacicId(4020101);
            break;
          } 
          if (sh.getItemId().intValue() == 81) {
            troopid = 881492;
            campArmy.setTacicId(4020101);
            break;
          } 
        }  
    } 
    Troop troop = dataGetter.getTroopCache().getTroop(troopid, player.getPlayerId().intValue());
    getTerrainValue(bat.terrainVal, troop, batSide, campArmy);
    campArmy.setTroopId(troop.getId().intValue());
    campArmy.setTroopSerial(troop.getSerial().intValue());
    campArmy.setTroopType(troop.getType().intValue());
    campArmy.setTroopName(troop.getName());
    campArmy.setBdEffect(pgm.getLv().intValue());
    Map<Integer, String> ycbweffectMap = dataGetter.getBattleDataCache().getYcbwMap(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
    campArmy.setPingKan(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(10))).intValue());
    campArmy.setPingKanDef(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(11))).intValue());
    campArmy.setYcbwHujia(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(12))).intValue());
    campArmy.setYcbwPojia(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(13))).intValue());
    campArmy.setKaiShan(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(14))).intValue());
    campArmy.setDingJun(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(15))).intValue());
    campArmy.setYbTx(ycbweffectMap.get(Integer.valueOf(19)));
    campArmy.setYubaoEffect(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(20))).intValue());
    campArmy.setLeader(campArmy.getLeader() + Integer.valueOf(ycbweffectMap.get(Integer.valueOf(4))).intValue());
    campArmy.setStrength(campArmy.getStrength() + Integer.valueOf(ycbweffectMap.get(Integer.valueOf(5))).intValue());
    int yubaonaijiu = Integer.valueOf(ycbweffectMap.get(Integer.valueOf(16))).intValue();
    if (pgm.getGodWeapon() != null && pgm.getGodWeapon().intValue() > 0)
      campArmy.setWsb(pgm.getGodWeapon().intValue()); 
    if (pgm.getGeneralId().intValue() == 280)
      campArmy.setJxType(49); 
    if (pgm.getCarId().intValue() > 0) {
      int carId = pgm.getCarId().intValue();
      PlayerCatapult pcp = dataGetter.getPlayerCatapultDao().getPlayerChariotById(player.getPlayerId().intValue(), carId);
      int realcarId = 0;
      if (pcp.getOpen().intValue() >= 2 && pcp.getRftState().intValue() > 2) {
        realcarId = CatapultUtil.gaojicar[carId - 1].intValue();
      } else {
        realcarId = CatapultUtil.carid[carId - 1].intValue();
      } 
      if (carId <= 10) {
        PlayerCatapultCarpart pccarpart = dataGetter.getPlayerCatapultCarpartDao().getByplayerIdAndCarId(player.getPlayerId().intValue(), carId);
        int armmode = 0;
        if (pccarpart != null) {
          campArmy.setCarArmed(true);
          if (pccarpart.getCarWeapon() != null && !pccarpart.getCarWeapon().equals("")) {
            armmode++;
            String[] weaponlist = pccarpart.getCarWeapon().split(":");
            String[] array;
            int length = (array = weaponlist).length;
            int i = 0;
            while (i < length) {
              String partstr = array[i];
              PlayerCatapultElement pcele = dataGetter.getPlayerCatapultElementDao().read(Integer.valueOf(partstr).intValue());
              if (pcele != null && pcele.getElementId().intValue() == 1) {
                campArmy.setLieYanHuiXiang(1);
                int chongzhubeishu = pcele.getRecast().intValue();
                if (chongzhubeishu > 2)
                  chongzhubeishu = 2; 
                campArmy.setLieyandamage(2000 * (pcele.getElementLevel().intValue() + chongzhubeishu * 10));
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 7) {
                campArmy.setIsFanShang(1);
                if (pcele.getElementLevel().intValue() >= 5) {
                  campArmy.setDuoChongShaRen(pcele.getElementLevel().intValue());
                  campArmy.setShaRenRecastNum(pcele.getRecast().intValue());
                  campArmy.setCarPoDunNum(0);
                } 
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 8) {
                campArmy.setsjznLevel(pcele.getElementLevel().intValue());
                campArmy.setsjznType(1);
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 9) {
                campArmy.setIsFlower(1);
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 11) {
                String damage = pcele.getElementAttribute().split("=")[1];
                campArmy.setFiveShuiDamage(campArmy.getFiveShuiDamage() + Integer.valueOf(damage).intValue());
                break;
              } 
              i++;
            } 
          } 
          if (pccarpart.getCarBody() != null && !pccarpart.getCarBody().equals(""))
            armmode++; 
          if (pccarpart.getCarBottom() != null && !pccarpart.getCarBottom().equals("")) {
            armmode++;
            String[] bottomlist = pccarpart.getCarBottom().split(":");
            String[] array2;
            for (int length2 = (array2 = bottomlist).length, j = 0; j < length2; j++) {
              String partstr = array2[j];
              PlayerCatapultElement pcele = dataGetter.getPlayerCatapultElementDao().read(Integer.valueOf(partstr).intValue());
              if (pcele != null && pcele.getElementId().intValue() == 3) {
                campArmy.setLonglin(1);
                break;
              } 
            } 
          } 
          if (pccarpart.getCarChuanDong() != null && !pccarpart.getCarChuanDong().equals("")) {
            armmode++;
            String[] chuandonglist = pccarpart.getCarChuanDong().split(":");
            String[] array3;
            for (int length3 = (array3 = chuandonglist).length, l = 0; l < length3; l++) {
              String cdstr = array3[l];
              PlayerCatapultElement pcele = dataGetter.getPlayerCatapultElementDao().read(Integer.valueOf(cdstr).intValue());
              if (pcele != null && pcele.getElementId().intValue() == 10) {
                campArmy.setIsFlower(1);
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 12) {
                String damage = pcele.getElementAttribute().split("=")[1];
                campArmy.setFiveShuiDamage(campArmy.getFiveShuiDamage() + Integer.valueOf(damage).intValue());
                break;
              } 
            } 
          } 
          if (pcp.getOpen().intValue() >= 2 && armmode >= 3)
            armmode++; 
          if (armmode <= 0)
            armmode = 1; 
          if (armmode >= 4)
            armmode = 4; 
          realcarId = CatapultUtil.armEquipcar[carId - 1][armmode - 1].intValue();
        } 
      } 
      List<PlayerCatapultDriver> cardriverList = dataGetter.getPlayerCatapultDriverDao().getDriverListByplayerIdAndCarId(player.getPlayerId().intValue(), carId);
      if (cardriverList != null && !cardriverList.isEmpty()) {
        int driverId = ((PlayerCatapultDriver)cardriverList.get(0)).getDriverId().intValue();
        campArmy.setCarQudong(driverId);
        if (driverId > 10000)
          driverId = CatapultUtil.driversId.length; 
        realcarId = CatapultUtil.drivewaiguan[driverId - 1].intValue();
      } 
      campArmy.setCarId(realcarId);
      campArmy.setCarModel(carId);
      if (carId == 2)
        campArmy.setDefence(1); 
      int hujia = CatapultUtil.getHujiaByCarIdAndLv(carId, pcp.getHujiaLv().intValue()) + campArmy.getYcbwHujia();
      int naijiu = CatapultUtil.getEnduranceByCarIdAndLv(carId, pcp.getHujiaLv().intValue()) + yubaonaijiu;
      campArmy.setBigGzNum(hujia);
      campArmy.setCarHp(hujia * naijiu);
      campArmy.setCarMaxHp(hujia * naijiu);
      campArmy.setAttcoe(CatapultUtil.getHuoliByCarIdAndLv(carId, pcp.getHuoliLv().intValue()));
      campArmy.setHujia(hujia * naijiu);
      if (carId == 4)
        if (pcp.getRftState().intValue() >= 3) {
          campArmy.setSiCheHuJia(hujia * naijiu);
          campArmy.setSiCheGeZi(hujia);
        } else {
          campArmy.setSiCheHuJia(3 * naijiu);
          campArmy.setSiCheGeZi(3);
        }  
      campArmy.setNaijiu(naijiu);
      String gzstr = pcp.getRftLv();
      if (gzstr != null && !gzstr.equals("")) {
        String[] rftlevel = gzstr.split(":");
        int totallevel = 0;
        String[] array4;
        for (int length4 = (array4 = rftlevel).length, n = 0; n < length4; n++) {
          String dj = array4[n];
          totallevel += Integer.valueOf(dj).intValue();
        } 
        campArmy.setCarGzLevel(totallevel);
      } 
      if (carId <= 2) {
        campArmy.setPojia(CatapultUtil.getPojiaByCarIdAndLv(carId, pcp.getPojiaLv().intValue()) + dataGetter.getBattleDataCache().getPlayerPojia(player.getPlayerId().intValue(), carId));
      } else {
        campArmy.setPojia(CatapultUtil.getPojiaByCarIdAndLv(carId, pcp.getPojiaLv().intValue()));
      } 
      if (carId == 1) {
        campArmy.setBaoji(CatapultUtil.getCoreByCarIdAndLv(carId, pcp.getCoreLv().intValue()));
      } else if (carId == 2) {
        campArmy.setQiangGong(CatapultUtil.getCoreByCarIdAndLv(carId, pcp.getCoreLv().intValue()));
      } else if (carId == 3) {
        campArmy.setXueLiang(CatapultUtil.getCoreByCarIdAndLv(carId, pcp.getCoreLv().intValue()));
      } 
      if (dataGetter.getPlayerCatapultDao().getOpen(player.getPlayerId().intValue(), carId).intValue() > 1)
        campArmy.setCatapultSkill(carId); 
    } 
    if (pgm != null) {
      StoreHouse sh2 = dataGetter.getStoreHouseDao().getByGeneralIdAndType(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 36, 36);
      if (sh2 != null)
        campArmy.setJueEquip(1); 
    } 
    int zhenbao = dataGetter.getSilkService().getPlayerSilkTreasureLevel(player.getPlayerId().intValue());
    campArmy.setTenZhenBao(zhenbao);
    if (zhenbao >= 10) {
      campArmy.setZbAllTimes(5);
      campArmy.setZbTimes(0);
    } 
    if (zhenbao >= 9) {
      campArmy.setJiuZhenbao(1);
      campArmy.setzfShield(2);
    } 
    if (zhenbao >= 7)
      campArmy.setQiZhenbao(2); 
    if (zhenbao >= 4)
      campArmy.setSiZhenbao(4000); 
    if (zhenbao >= 3)
      campArmy.setSanZhenbao(4000); 
    if (zhenbao >= 2)
      campArmy.setErZhenBao(4000); 
    if (pgm != null && pgm.getFormationId() != null && pgm.getFormationId().intValue() > 0) {
      campArmy.setFormationType(pgm.getFormationId().intValue());
      List baguabooks = dataGetter.getPlayerStrategicsBookDao().getFormationBooksUpLevel(player.getPlayerId().intValue(), pgm.getFormationId().intValue(), 10);
      if (baguabooks != null && !baguabooks.isEmpty())
        campArmy.setBaGuaLevel(baguabooks.size()); 
      PlayerStrategics ps = dataGetter.getPlayerStrategicsDao().getByPlayerIdAndFormationId(player.getPlayerId().intValue(), pgm.getFormationId().intValue());
      if (ps != null) {
        campArmy.setFormationLevel(ps.getFormationLevel().intValue());
        if (ps.getState().intValue() >= 3) {
          int hasbigskill = 1;
          int bz = 0;
          int uplv = 0;
          if (ps.getFormationLevel().intValue() >= 1000) {
            hasbigskill = 5;
            bz = 6;
            uplv = 3;
          } 
          if (ps.getFormationLevel().intValue() >= 800) {
            hasbigskill = 5;
            bz = 5;
            uplv = 2;
          } 
          if (ps.getFormationLevel().intValue() >= 600) {
            hasbigskill = 4;
            bz = 4;
            uplv = 2;
          } 
          if (ps.getFormationLevel().intValue() >= 400) {
            hasbigskill = 4;
            bz = 3;
            uplv = 1;
          } 
          if (ps.getFormationLevel().intValue() >= 200) {
            hasbigskill = 4;
            bz = 2;
            uplv = 1;
          } 
          if (ps.getFormationLevel().intValue() >= 80) {
            hasbigskill = 3;
          } else if (ps.getFormationLevel().intValue() >= 60) {
            hasbigskill = 2;
          } 
          campArmy.setHasbigFormationskill(hasbigskill);
          campArmy.setBzStatus(bz);
          campArmy.setIsZhenFaLvUp(uplv);
          if (ps.getFormationId().intValue() == 3)
            campArmy.setFyzShield(1); 
          if (ps.getFormationId().intValue() == 6)
            if (ps.getFormationLevel().intValue() >= 70) {
              campArmy.setFuBingNum(4);
            } else if (ps.getFormationLevel().intValue() >= 50) {
              campArmy.setFuBingNum(3);
            } else if (ps.getFormationLevel().intValue() >= 30) {
              campArmy.setFuBingNum(2);
            } else if (ps.getFormationLevel().intValue() >= 20) {
              campArmy.setFuBingNum(1);
            }  
        } 
      } 
    } 
    if (pgm != null && pgm.getFormationId1() != null && pgm.getFormationId1().intValue() > 0) {
      PlayerStrategics1 ps1 = dataGetter.getPlayerStrategicsDao1().getByPlayerIdAndforceId(player.getPlayerId().intValue(), pgm.getFormationId1().intValue());
      if (ps1 != null) {
        int bingfu = 0;
        if (ps1.getForceId().intValue() == 1 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 1; 
        if (ps1.getForceId().intValue() == 2 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 2; 
        if (ps1.getForceId().intValue() == 3 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 3; 
        if (ps1.getForceId().intValue() == 4 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 4; 
        if (ps1.getForceId().intValue() == 5 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 5; 
        campArmy.setBzStatus1(bingfu);
        campArmy.setFuBingNum1(1);
      } 
    } 
    List<StoreHouse> horselist = dataGetter.getStoreHouseDao().getHorseByGeneral(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
    if (horselist != null && !horselist.isEmpty()) {
      int horsetype = ((StoreHouse)horselist.get(0)).getItemId().intValue() - 4000;
      campArmy.setHorseType(horsetype);
      if (horsetype == 1)
        campArmy.setZsMyMa(1); 
    } 
    if (pgm.getHelpGeneral().intValue() == 402) {
      campArmy.setMeiXian(5);
      campArmy.setMeiXianUpper(4);
      if (pgm.getGeneralId().intValue() == 277 && campArmy.getUnionState() > 0) {
        campArmy.setMeiXian(4);
        campArmy.setMeiXianUpper(7);
      } 
      if (pgm.getGeneralId().intValue() == 416 && campArmy.getChapterId() > 0) {
        campArmy.setMeiXian(4);
        campArmy.setMeiXianUpper(7);
      } 
      if (campArmy.getHorseType() == 4) {
        campArmy.setMeiXianUpper(8);
        campArmy.setSsxMa(1);
      } 
    } 
    if (pgm.getHelpGeneral().intValue() > 0) {
      campArmy.setHelpGeneral(pgm.getHelpGeneral().intValue());
      PlayerGeneralEvoke helppge = dataGetter.getPlayerGeneralEvokeDao().getPlayerGeneralEvoke(player.getPlayerId().intValue(), pgm.getHelpGeneral().intValue());
      if (helppge != null && helppge.getEvokeSkillFinal().intValue() > 0) {
        campArmy.setHelpIsJuexing(1);
        if (pgm.getHelpGeneral().intValue() == 402)
          campArmy.setMhxx(1); 
      } 
      if (pgm.getHelpGeneral().intValue() == 403)
        campArmy.setHuangGaiZhanFa(1); 
      if (pgm.getHelpGeneral().intValue() == 404)
        campArmy.setBaiYi(1); 
    } 
    PlayerEpic playerepic = dataGetter.getPlayerEpicDao().getPlayerEpic(player.getPlayerId().intValue(), 1);
    if (playerepic != null && playerepic.getBigSkill().intValue() > 0)
      campArmy.setEpicLevel(1); 
    List<PlayerWarBeast> warbeastList = dataGetter.getPlayerWarBeastDao().getWarBeastListByplayerId(player.getPlayerId().intValue());
    if (warbeastList != null)
      campArmy.setYongYouBeast(true); 
    if (pgm.getState().intValue() == 1 || pgm.getAuto().intValue() == 1)
      campArmy.setInRecruit(true); 
    try {
      if (pgm.getIsDeputy().intValue() <= 0 && pgm.getLordId().intValue() <= 0)
        dataGetter.getPlayerGeneralMilitaryDao().updateStateCheck(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), generalBattleType); 
    } catch (Exception e) {
      ErrorSceneLog.getInstance().appendErrorMsg("Builder copyArmyFromPlayerTable 更改武将状态Exception").appendClassName("Builder").appendMethodName("copyArmyFromPlayerTable").append("PlayerId", player.getPlayerId()).append("GeneralId", pgm.getGeneralId()).flush();
      return null;
    } 
    campArmy.setUpdateDB(true);
    campArmy.setId(bat.campNum.getAndIncrement());
    if (campArmy.getPlayerId() > 0 && !campArmy.isPhantom)
      NewBattleManager.getInstance().joinBattle(bat, campArmy.getPlayerId(), new int[] { campArmy.getGeneralId() }); 
    dataGetter.getGeneralService().sendGmStateSet(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), this.battleType);
    int forces = pgm.getForces().intValue();
    int remainder = forces % 3;
    forces -= remainder;
    campArmy.setArmyHp(forces);
    campArmy.setArmyHpOrg(forces);
    getAttDefHp(dataGetter, campArmy);
    if (pba != null && pba.getSupportTime() != null && pba.getSupportTime().getTime() > System.currentTimeMillis())
      if (pba.getType().intValue() == 1) {
        campArmy.setRewardDoubleType(1);
        campArmy.setRewardDouble(1.5D);
      } else if (pba.getType().intValue() == 2) {
        campArmy.setRewardDoubleType(2);
        campArmy.setRewardDouble(2.0D);
      }  
    if (general.getTacticId().intValue() > 0 && pgm.getForces().intValue() >= campArmy.getMaxForces()) {
      campArmy.setTacticVal(1);
      if ((campArmy.getSpecialGeneral()).generalType == 7)
        campArmy.setTacticVal((int)(campArmy.getSpecialGeneral()).param); 
    } 
    if (batSide == 1) {
      campArmy.setStrategies((int[])troop.getStrategyMap().get(Integer.valueOf(bat.terrainVal)));
    } else {
      campArmy.setStrategies((int[])troop.getStrategyDefMap().get(Integer.valueOf(bat.terrainVal)));
    } 
    Map<Integer, CampArmy> generalmap = null;
    if (campArmy.getPlayerId() > 0 && !campArmy.isPhantom) {
      if (bat.getGeneralMap().containsKey(Integer.valueOf(campArmy.getPlayerId()))) {
        generalmap = (Map<Integer, CampArmy>)bat.getGeneralMap().get(Integer.valueOf(campArmy.getPlayerId()));
      } else {
        generalmap = new HashMap<>();
        bat.getGeneralMap().put(Integer.valueOf(campArmy.getPlayerId()), generalmap);
      } 
      generalmap.put(Integer.valueOf(campArmy.getGeneralId()), campArmy);
    } 
    return campArmy;
  }
  
  public CampArmy copyArmyFromPlayerTableForKfwd(Player player, PlayerGeneralMilitary pgm, IDataGetter dataGetter, int battleType, Battle bat, int batSide) {
    CampArmy campArmy = new CampArmy();
    General general = (General)dataGetter.getGeneralCache().get(pgm.getGeneralId());
    campArmy.updateDB = true;
    campArmy.setPlayerLv(player.getPlayerLv().intValue());
    campArmy.setPlayerId(player.getPlayerId().intValue());
    campArmy.setPayTotal(player.getPayTotal().intValue());
    campArmy.setPlayerName(player.getPlayerName());
    campArmy.setForceId(player.getForceId().intValue());
    campArmy.setActivityAddExp(dataGetter.getActivityService().getAddBatValue(player.getPlayerId().intValue(), player.getPlayerLv().intValue()));
    PlayerBattleAttribute pba = dataGetter.getPlayerBattleAttributeDao().read(player.getPlayerId().intValue());
    campArmy.setSex(general.getSex().intValue());
    campArmy.setGeneralId(pgm.getGeneralId().intValue());
    campArmy.setGeneralLv(pgm.getLv().intValue());
    campArmy.setPgmVId(pgm.getVId().intValue());
    campArmy.setStrength(pgm.getStrength(general.getStrength()).intValue());
    campArmy.setLeader(pgm.getLeader(general.getLeader()).intValue());
    campArmy.setArmyName(general.getName());
    campArmy.setGeneralName(general.getName());
    campArmy.setGeneralPic(general.getPic());
    campArmy.setQuality(general.getQuality().intValue());
    campArmy.setTacicId(general.getTacticId().intValue());
    if (pgm.getDeputyId() != null && pgm.getDeputyId().intValue() > 0)
      campArmy.setDeputy(pgm.getDeputyId().intValue()); 
    if (pgm.getIsDeputy() != null && pgm.getIsDeputy().intValue() > 0)
      campArmy.setIsDeputy(1); 
    if (pgm.getLordId() != null && pgm.getLordId().intValue() > 0) {
      campArmy.setIsDeputy(1);
      campArmy.setZhuJiangId(pgm.getLordId().intValue());
    } 
    int troopid = general.getTroop().intValue();
    PlayerAttribute pa = dataGetter.getPlayerAttributeDao().read(player.getPlayerId().intValue());
    if (pa != null && pa.getMountRank().intValue() > 0)
      campArmy.setZuoQiSkill(pa.getMountRank().intValue()); 
    if (player.getMoonCard().intValue() > 0 && player.getMoonCardTime() != null && player.getMoonCardTime().after(new Date()))
      campArmy.setIsMoonCard(true); 
    boolean uniontroop = false;
    boolean legend_281 = false;
    PlayerGeneralEvoke pge = dataGetter.getPlayerGeneralEvokeDao().getPlayerGeneralEvoke(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
    if (pge != null) {
      if (pge.getEvokeSkillFinal().intValue() > 0 || pge.getUnionEvoke().intValue() > 0) {
        campArmy.setIsJuexing(1);
        if (pge.getGeneralId().intValue() == 402)
          campArmy.setMhxx(1); 
      } 
      if (pge.getEvokeSkillFinal().intValue() > 0 || pge.getUnionEvoke().intValue() > 0) {
        EvokeGeneral egr = dataGetter.getEvokeGeneralCache().getEvokeGeneral(pgm.getGeneralId().intValue());
        campArmy.setTacicId(egr.getTacticId().intValue());
        campArmy.setGeneralPic(egr.getPic());
        if (pge.getUnionEvoke().intValue() > 0 && pgm.getGeneralId().intValue() == 103 && pgm.getDeputyId().intValue() == 269) {
          campArmy.setTacicId(1321);
          campArmy.setGeneralName("赤壁奇谋");
          campArmy.setGeneralPic("zhouyujx_zhugeliangjx");
          campArmy.setUnionRank(pge.getUnionRank().intValue());
          campArmy.setDeputy(0);
          campArmy.setUnionState(1);
          uniontroop = true;
        } 
      } 
      int zsjqskill = dataGetter.getBattleDataCache().getGeneralZsjqSkillLevel(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
      campArmy.setZsJqSkillLevel(zsjqskill);
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 204) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic[curChapter - 1]);
        campArmy.setTacicId(4020401);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
      } 
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 107) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName2[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic2[curChapter - 1]);
        campArmy.setTacicId(4010701);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
      } 
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 281) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName3[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic3[curChapter - 1]);
        campArmy.setTacicId(4028101);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
        legend_281 = true;
      } 
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 269) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName4[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic4[curChapter - 1]);
        campArmy.setTacicId(4026901);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
        legend_281 = true;
      } 
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 201) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName5[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic5[curChapter - 1]);
        campArmy.setTacicId(4020101);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
      } 
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 416) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName6[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic6[curChapter - 1]);
        campArmy.setTacicId(9991309);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
      } 
    } 
    if (campArmy.getIsJuexing() <= 0 && pgm.getGeneralId().intValue() == 204)
      troopid = 34; 
    if (campArmy.getIsJuexing() > 0) {
      for (int k = 0; k < GeneralUtils.jxwulist.length; k++) {
        if (pgm.getGeneralId().intValue() == GeneralUtils.jxwulist[k].intValue()) {
          troopid = GeneralUtils.jxtroop[k].intValue();
          break;
        } 
      } 
      if (pgm.getGeneralId().intValue() == 204) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 122; 
      } 
      if (pgm.getGeneralId().intValue() == 107) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 127; 
      } 
      if (pgm.getGeneralId().intValue() == 281) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 128; 
      } 
      if (pgm.getGeneralId().intValue() == 269) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 143; 
      } 
      if (pgm.getGeneralId().intValue() == 201) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 149; 
      } 
      if (pgm.getGeneralId().intValue() == 416) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 881681; 
      } 
    } 
    if (uniontroop)
      troopid = 75; 
    if (pge != null) {
      if (pgm.getGeneralId().intValue() == 277 && pge.getUnionEvoke().intValue() > 0) {
        troopid = 80;
        campArmy.setTacicId(1755);
        campArmy.setGeneralPic("liuguanzhang");
        campArmy.setUnionRank(pge.getUnionRank().intValue());
        campArmy.setDeputy(0);
        campArmy.setUnionState(1);
      } 
      if (pgm.getGeneralId().intValue() == 202 && pge.getShenJiang().intValue() > 0) {
        troopid = 79;
        campArmy.setTacicId(3101);
      } 
      if (pgm.getGeneralId().intValue() == 201 && pge.getUnionEvoke().intValue() > 0 && pgm.getDeputyId().intValue() == 266) {
        troopid = 89;
        campArmy.setTacicId(1614);
        campArmy.setGeneralPic("lvbudiaochanjx");
        campArmy.setUnionRank(pge.getUnionRank().intValue());
        campArmy.setDeputy(0);
        campArmy.setUnionState(1);
        campArmy.setGeneralName("乱世眷侣");
      } 
      if (pgm.getGeneralId().intValue() == 270 && pge.getUnionEvoke().intValue() > 0 && pgm.getDeputyId().intValue() == 273) {
        troopid = 103;
        campArmy.setTacicId(1802);
        campArmy.setGeneralPic("xiahoudun_xiahouyuanjx1");
        campArmy.setUnionRank(pge.getUnionRank().intValue());
        campArmy.setDeputy(0);
        campArmy.setUnionState(1);
        campArmy.setGeneralName("夏侯兄弟");
      } 
      if (pgm.getGeneralId().intValue() == 232 && pge.getUnionEvoke().intValue() > 0 && pgm.getDeputyId().intValue() == 274) {
        troopid = 108;
        campArmy.setTacicId(3601);
        campArmy.setGeneralPic("nanzhongzhizhu");
        campArmy.setUnionRank(pge.getUnionRank().intValue());
        campArmy.setDeputy(0);
        campArmy.setUnionState(1);
        campArmy.setGeneralName("南中之主");
      } 
    } 
    StoreHouse generalTreasure = dataGetter.getStoreHouseDao().getByGeneralIdAndType(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 2, 3);
    if (generalTreasure != null) {
      int baowuid = generalTreasure.getItemId().intValue();
      if (pgm.getGeneralId().intValue() == 107 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1075)
        troopid = 881442; 
      if (pgm.getGeneralId().intValue() == 204 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1074)
        troopid = 881222; 
      if (pgm.getGeneralId().intValue() == 281 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1073)
        troopid = 881281; 
      if (pgm.getGeneralId().intValue() == 269 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1072)
        troopid = 881434; 
      if (pgm.getGeneralId().intValue() == 201 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1071)
        troopid = 881492; 
      if ((baowuid == 81 || generalTreasure.getPiFu().intValue() == 81) && pgm.getGeneralId().intValue() == 201 && (campArmy.getUnionState() <= 0 || pgm.getDeputyId().intValue() != 266)) {
        troopid = 87571;
      } else if ((baowuid == 82 || generalTreasure.getPiFu().intValue() == 82) && pgm.getGeneralId().intValue() == 267) {
        troopid = 87621;
      } else if ((baowuid == 83 || generalTreasure.getPiFu().intValue() == 83) && pgm.getGeneralId().intValue() == 211) {
        troopid = 87671;
      } else if ((baowuid == 84 || generalTreasure.getPiFu().intValue() == 84) && pgm.getGeneralId().intValue() == 275) {
        troopid = 87601;
      } else if ((baowuid == 85 || generalTreasure.getPiFu().intValue() == 85) && pgm.getGeneralId().intValue() == 103 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 269) {
        troopid = 87751;
      } else if ((baowuid == 86 || generalTreasure.getPiFu().intValue() == 86) && pgm.getGeneralId().intValue() == 277 && campArmy.getUnionState() > 0) {
        troopid = 87801;
      } else if ((baowuid == 87 || generalTreasure.getPiFu().intValue() == 87) && pgm.getGeneralId().intValue() == 224) {
        troopid = 87551;
      } else if ((baowuid == 113 || generalTreasure.getPiFu().intValue() == 113) && pgm.getGeneralId().intValue() == 201 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 266) {
        troopid = 87893;
        campArmy.setGeneralPic("lvbudiaochanjx2");
      } else if ((baowuid == 111 || generalTreasure.getPiFu().intValue() == 111) && pgm.getGeneralId().intValue() == 201 && (campArmy.getUnionState() <= 0 || pgm.getDeputyId().intValue() != 266)) {
        troopid = 87572;
      } else if ((baowuid == 112 || generalTreasure.getPiFu().intValue() == 112) && pgm.getGeneralId().intValue() == 266) {
        troopid = 87711;
      } else if ((baowuid == 116 || generalTreasure.getPiFu().intValue() == 116) && pgm.getGeneralId().intValue() == 103 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 269) {
        troopid = 88751;
      } 
      if (baowuid >= 1003) {
        campArmy.setTouXian(baowuid);
        campArmy.setTitle(baowuid);
        campArmy.setTitle1(WeaponUtils.kuangshipic1[baowuid - 1003]);
      } 
    } 
    if (pgm.getGeneralId().intValue() == 211) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 34) {
            troopid = 87672;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 281) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 66) {
            troopid = 88961;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 107) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 68) {
            troopid = 88781;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 277 && campArmy.getUnionState() > 0) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 65) {
            troopid = 88801;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 201 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 266) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 67) {
            troopid = 88891;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 270 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 273) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 69) {
            troopid = 881031;
            break;
          } 
          if (sh.getItemId().intValue() == 70) {
            troopid = 881032;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 232 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 274) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 71) {
            troopid = 881081;
            break;
          } 
          if (sh.getItemId().intValue() == 72) {
            troopid = 881082;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 204 && campArmy.getLegendEvoke()) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 73) {
            troopid = 881221;
            campArmy.setTacicId(4020402);
            break;
          } 
          if (sh.getItemId().intValue() == 74) {
            troopid = 881223;
            campArmy.setTacicId(4020403);
            break;
          } 
          if (sh.getItemId().intValue() == 121) {
            troopid = 881224;
            campArmy.setTacicId(4020403);
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 107 && campArmy.getLegendEvoke()) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 35) {
            troopid = 881273;
            campArmy.setTacicId(4010702);
            break;
          } 
          if (sh.getItemId().intValue() == 79) {
            troopid = 12730001;
            campArmy.setTacicId(4010702);
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 281 && campArmy.getLegendEvoke()) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 36) {
            troopid = 13830001;
            campArmy.setTacicId(4028101);
            break;
          } 
          if (sh.getItemId().intValue() == 80) {
            troopid = 13830002;
            campArmy.setTacicId(4028101);
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 269 && campArmy.getLegendEvoke()) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 40) {
            troopid = 14330001;
            campArmy.setTacicId(4026901);
            break;
          } 
          if (sh.getItemId().intValue() == 78) {
            troopid = 14330002;
            campArmy.setTacicId(4026901);
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 201 && campArmy.getLegendEvoke()) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 37) {
            troopid = 14930001;
            campArmy.setTacicId(4020101);
            break;
          } 
          if (sh.getItemId().intValue() == 81) {
            troopid = 881492;
            campArmy.setTacicId(4020101);
            break;
          } 
        }  
    } 
    Troop troop = dataGetter.getTroopCache().getTroop(troopid, player.getPlayerId().intValue());
    getTerrainValue(bat.terrainVal, troop, batSide, campArmy);
    campArmy.setTroopId(troop.getId().intValue());
    campArmy.setTroopSerial(troop.getSerial().intValue());
    campArmy.setTroopType(troop.getType().intValue());
    campArmy.setTroopName(troop.getName());
    campArmy.setBdEffect(pgm.getLv().intValue());
    Map<Integer, String> ycbweffectMap = dataGetter.getBattleDataCache().getYcbwMap(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
    campArmy.setPingKan(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(10))).intValue());
    campArmy.setPingKanDef(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(11))).intValue());
    campArmy.setYcbwHujia(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(12))).intValue());
    campArmy.setYcbwPojia(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(13))).intValue());
    campArmy.setKaiShan(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(14))).intValue());
    campArmy.setDingJun(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(15))).intValue());
    campArmy.setYbTx(ycbweffectMap.get(Integer.valueOf(19)));
    campArmy.setYubaoEffect(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(20))).intValue());
    campArmy.setLeader(campArmy.getLeader() + Integer.valueOf(ycbweffectMap.get(Integer.valueOf(4))).intValue());
    campArmy.setStrength(campArmy.getStrength() + Integer.valueOf(ycbweffectMap.get(Integer.valueOf(5))).intValue());
    int yubaonaijiu = Integer.valueOf(ycbweffectMap.get(Integer.valueOf(16))).intValue();
    if (pgm.getGodWeapon() != null && pgm.getGodWeapon().intValue() > 0)
      campArmy.setWsb(pgm.getGodWeapon().intValue()); 
    if (pgm.getGeneralId().intValue() == 280)
      campArmy.setJxType(49); 
    if (pgm.getCarId().intValue() > 0) {
      int carId = pgm.getCarId().intValue();
      PlayerCatapult pcp = dataGetter.getPlayerCatapultDao().getPlayerChariotById(player.getPlayerId().intValue(), carId);
      int realcarId = 0;
      if (pcp.getOpen().intValue() >= 2 && pcp.getRftState().intValue() > 2) {
        realcarId = CatapultUtil.gaojicar[carId - 1].intValue();
      } else {
        realcarId = CatapultUtil.carid[carId - 1].intValue();
      } 
      if (carId <= 10) {
        PlayerCatapultCarpart pccarpart = dataGetter.getPlayerCatapultCarpartDao().getByplayerIdAndCarId(player.getPlayerId().intValue(), carId);
        int armmode = 0;
        if (pccarpart != null) {
          campArmy.setCarArmed(true);
          if (pccarpart.getCarWeapon() != null && !pccarpart.getCarWeapon().equals("")) {
            armmode++;
            String[] weaponlist = pccarpart.getCarWeapon().split(":");
            String[] array;
            int length = (array = weaponlist).length;
            int i = 0;
            while (i < length) {
              String partstr = array[i];
              PlayerCatapultElement pcele = dataGetter.getPlayerCatapultElementDao().read(Integer.valueOf(partstr).intValue());
              if (pcele != null && pcele.getElementId().intValue() == 1) {
                campArmy.setLieYanHuiXiang(1);
                int chongzhubeishu = pcele.getRecast().intValue();
                if (chongzhubeishu > 2)
                  chongzhubeishu = 2; 
                campArmy.setLieyandamage(2000 * (pcele.getElementLevel().intValue() + chongzhubeishu * 10));
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 7) {
                campArmy.setIsFanShang(1);
                if (pcele.getElementLevel().intValue() >= 5) {
                  campArmy.setDuoChongShaRen(pcele.getElementLevel().intValue());
                  campArmy.setShaRenRecastNum(pcele.getRecast().intValue());
                  campArmy.setCarPoDunNum(0);
                } 
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 8) {
                campArmy.setsjznLevel(pcele.getElementLevel().intValue());
                campArmy.setsjznType(1);
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 9) {
                campArmy.setIsFlower(1);
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 11) {
                String damage = pcele.getElementAttribute().split("=")[1];
                campArmy.setFiveShuiDamage(campArmy.getFiveShuiDamage() + Integer.valueOf(damage).intValue());
                break;
              } 
              i++;
            } 
          } 
          if (pccarpart.getCarBody() != null && !pccarpart.getCarBody().equals(""))
            armmode++; 
          if (pccarpart.getCarBottom() != null && !pccarpart.getCarBottom().equals("")) {
            armmode++;
            String[] bottomlist = pccarpart.getCarBottom().split(":");
            String[] array2;
            for (int length2 = (array2 = bottomlist).length, j = 0; j < length2; j++) {
              String partstr = array2[j];
              PlayerCatapultElement pcele = dataGetter.getPlayerCatapultElementDao().read(Integer.valueOf(partstr).intValue());
              if (pcele != null && pcele.getElementId().intValue() == 3) {
                campArmy.setLonglin(1);
                break;
              } 
            } 
          } 
          if (pccarpart.getCarChuanDong() != null && !pccarpart.getCarChuanDong().equals("")) {
            armmode++;
            String[] chuandonglist = pccarpart.getCarChuanDong().split(":");
            String[] array3;
            for (int length3 = (array3 = chuandonglist).length, l = 0; l < length3; l++) {
              String cdstr = array3[l];
              PlayerCatapultElement pcele = dataGetter.getPlayerCatapultElementDao().read(Integer.valueOf(cdstr).intValue());
              if (pcele != null && pcele.getElementId().intValue() == 10) {
                campArmy.setIsFlower(1);
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 12) {
                String damage = pcele.getElementAttribute().split("=")[1];
                campArmy.setFiveShuiDamage(campArmy.getFiveShuiDamage() + Integer.valueOf(damage).intValue());
                break;
              } 
            } 
          } 
          if (pcp.getOpen().intValue() >= 2 && armmode >= 3)
            armmode++; 
          if (armmode <= 0)
            armmode = 1; 
          if (armmode >= 4)
            armmode = 4; 
          realcarId = CatapultUtil.armEquipcar[carId - 1][armmode - 1].intValue();
        } 
      } 
      List<PlayerCatapultDriver> cardriverList = dataGetter.getPlayerCatapultDriverDao().getDriverListByplayerIdAndCarId(player.getPlayerId().intValue(), carId);
      if (cardriverList != null && !cardriverList.isEmpty()) {
        int driverId = ((PlayerCatapultDriver)cardriverList.get(0)).getDriverId().intValue();
        campArmy.setCarQudong(driverId);
        if (driverId > 10000)
          driverId = CatapultUtil.driversId.length; 
        realcarId = CatapultUtil.drivewaiguan[driverId - 1].intValue();
      } 
      campArmy.setCarId(realcarId);
      campArmy.setCarModel(carId);
      if (carId == 2)
        campArmy.setDefence(1); 
      int hujia = CatapultUtil.getHujiaByCarIdAndLv(carId, pcp.getHujiaLv().intValue()) + campArmy.getYcbwHujia();
      int naijiu = CatapultUtil.getEnduranceByCarIdAndLv(carId, pcp.getHujiaLv().intValue()) + yubaonaijiu;
      campArmy.setBigGzNum(hujia);
      campArmy.setCarHp(hujia * naijiu);
      campArmy.setCarMaxHp(hujia * naijiu);
      campArmy.setAttcoe(CatapultUtil.getHuoliByCarIdAndLv(carId, pcp.getHuoliLv().intValue()));
      campArmy.setHujia(hujia * naijiu);
      if (carId == 4)
        if (pcp.getRftState().intValue() >= 3) {
          campArmy.setSiCheHuJia(hujia * naijiu);
          campArmy.setSiCheGeZi(hujia);
        } else {
          campArmy.setSiCheHuJia(3 * naijiu);
          campArmy.setSiCheGeZi(3);
        }  
      campArmy.setNaijiu(naijiu);
      String gzstr = pcp.getRftLv();
      if (gzstr != null && !gzstr.equals("")) {
        String[] rftlevel = gzstr.split(":");
        int totallevel = 0;
        String[] array4;
        for (int length4 = (array4 = rftlevel).length, n = 0; n < length4; n++) {
          String dj = array4[n];
          totallevel += Integer.valueOf(dj).intValue();
        } 
        campArmy.setCarGzLevel(totallevel);
      } 
      if (carId < -2) {
        campArmy.setPojia(CatapultUtil.getPojiaByCarIdAndLv(carId, pcp.getPojiaLv().intValue()) + dataGetter.getBattleDataCache().getPlayerPojia(player.getPlayerId().intValue(), carId));
      } else {
        campArmy.setPojia(CatapultUtil.getPojiaByCarIdAndLv(carId, pcp.getPojiaLv().intValue()));
      } 
      if (carId == 1) {
        campArmy.setBaoji(CatapultUtil.getCoreByCarIdAndLv(carId, pcp.getCoreLv().intValue()));
      } else if (carId == 2) {
        campArmy.setQiangGong(CatapultUtil.getCoreByCarIdAndLv(carId, pcp.getCoreLv().intValue()));
      } else if (carId == 3) {
        campArmy.setXueLiang(CatapultUtil.getCoreByCarIdAndLv(carId, pcp.getCoreLv().intValue()));
      } 
      if (dataGetter.getPlayerCatapultDao().getOpen(player.getPlayerId().intValue(), carId).intValue() > 1)
        campArmy.setCatapultSkill(carId); 
    } 
    if (pgm != null) {
      StoreHouse sh2 = dataGetter.getStoreHouseDao().getByGeneralIdAndType(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 36, 36);
      if (sh2 != null)
        campArmy.setJueEquip(1); 
    } 
    if (pgm != null && pgm.getFormationId() != null && pgm.getFormationId().intValue() > 0) {
      campArmy.setFormationType(pgm.getFormationId().intValue());
      List baguabooks = dataGetter.getPlayerStrategicsBookDao().getFormationBooksUpLevel(player.getPlayerId().intValue(), pgm.getFormationId().intValue(), 10);
      if (baguabooks != null && !baguabooks.isEmpty())
        campArmy.setBaGuaLevel(baguabooks.size()); 
      PlayerStrategics ps = dataGetter.getPlayerStrategicsDao().getByPlayerIdAndFormationId(player.getPlayerId().intValue(), pgm.getFormationId().intValue());
      if (ps != null) {
        campArmy.setFormationLevel(ps.getFormationLevel().intValue());
        if (ps.getState().intValue() >= 3) {
          int hasbigskill = 1;
          int bz = 0;
          int uplv = 0;
          if (ps.getFormationLevel().intValue() >= 1000) {
            hasbigskill = 5;
            bz = 6;
            uplv = 3;
          } 
          if (ps.getFormationLevel().intValue() >= 800) {
            hasbigskill = 5;
            bz = 5;
            uplv = 2;
          } 
          if (ps.getFormationLevel().intValue() >= 600) {
            hasbigskill = 4;
            bz = 4;
            uplv = 2;
          } 
          if (ps.getFormationLevel().intValue() >= 400) {
            hasbigskill = 4;
            bz = 3;
            uplv = 1;
          } 
          if (ps.getFormationLevel().intValue() >= 200) {
            hasbigskill = 4;
            bz = 2;
            uplv = 1;
          } 
          if (ps.getFormationLevel().intValue() >= 80) {
            hasbigskill = 3;
          } else if (ps.getFormationLevel().intValue() >= 60) {
            hasbigskill = 2;
          } 
          campArmy.setHasbigFormationskill(hasbigskill);
          campArmy.setBzStatus(bz);
          campArmy.setIsZhenFaLvUp(uplv);
          if (ps.getFormationId().intValue() == 3)
            campArmy.setFyzShield(1); 
          if (ps.getFormationId().intValue() == 6)
            if (ps.getFormationLevel().intValue() >= 70) {
              campArmy.setFuBingNum(4);
            } else if (ps.getFormationLevel().intValue() >= 50) {
              campArmy.setFuBingNum(3);
            } else if (ps.getFormationLevel().intValue() >= 30) {
              campArmy.setFuBingNum(2);
            } else if (ps.getFormationLevel().intValue() >= 20) {
              campArmy.setFuBingNum(1);
            }  
        } 
      } 
    } 
    if (pgm != null && pgm.getFormationId1() != null && pgm.getFormationId1().intValue() > 0) {
      PlayerStrategics1 ps1 = dataGetter.getPlayerStrategicsDao1().getByPlayerIdAndforceId(player.getPlayerId().intValue(), pgm.getFormationId1().intValue());
      if (ps1 != null) {
        int bingfu = 0;
        if (ps1.getForceId().intValue() == 1 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 1; 
        if (ps1.getForceId().intValue() == 2 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 2; 
        if (ps1.getForceId().intValue() == 3 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 3; 
        if (ps1.getForceId().intValue() == 4 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 4; 
        if (ps1.getForceId().intValue() == 5 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 5; 
        campArmy.setBzStatus1(bingfu);
        campArmy.setFuBingNum1(1);
      } 
    } 
    if (pgm.getHelpGeneral().intValue() == 402) {
      campArmy.setMeiXian(5);
      campArmy.setMeiXianUpper(4);
      if (pgm.getGeneralId().intValue() == 277 && campArmy.getUnionState() > 0) {
        campArmy.setMeiXian(4);
        campArmy.setMeiXianUpper(7);
        campArmy.setSsxMa(1);
      } 
      if (pgm.getGeneralId().intValue() == 416 && campArmy.getChapterId() > 0) {
        campArmy.setMeiXian(4);
        campArmy.setMeiXianUpper(7);
        campArmy.setSsxMa(1);
      } 
      if (campArmy.getHorseType() == 4) {
        campArmy.setMeiXianUpper(8);
        campArmy.setSsxMa(1);
      } 
    } 
    if (pgm.getHelpGeneral().intValue() > 0) {
      campArmy.setHelpGeneral(pgm.getHelpGeneral().intValue());
      PlayerGeneralEvoke helppge = dataGetter.getPlayerGeneralEvokeDao().getPlayerGeneralEvoke(player.getPlayerId().intValue(), pgm.getHelpGeneral().intValue());
      if (helppge != null && helppge.getEvokeSkillFinal().intValue() > 0) {
        campArmy.setHelpIsJuexing(1);
        if (pgm.getHelpGeneral().intValue() == 402)
          campArmy.setMhxx(1); 
      } 
      if (pgm.getHelpGeneral().intValue() == 403)
        campArmy.setHuangGaiZhanFa(1); 
      if (pgm.getHelpGeneral().intValue() == 404)
        campArmy.setBaiYi(1); 
    } 
    PlayerEpic playerepic = dataGetter.getPlayerEpicDao().getPlayerEpic(player.getPlayerId().intValue(), 1);
    if (playerepic != null && playerepic.getBigSkill().intValue() > 0)
      campArmy.setEpicLevel(1); 
    if (pgm.getState().intValue() == 1 || pgm.getAuto().intValue() == 1)
      campArmy.setInRecruit(true); 
    campArmy.setUpdateDB(true);
    campArmy.setId(bat.campNum.getAndIncrement());
    dataGetter.getGeneralService().sendGmStateSet(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), battleType);
    int forces = dataGetter.getBattleDataCache().getMaxHp(pgm);
    int remainder = forces % 3;
    forces -= remainder;
    campArmy.setArmyHp(forces);
    campArmy.setArmyHpOrg(forces);
    getAttDefHp(dataGetter, campArmy);
    if (pba != null && pba.getSupportTime() != null && pba.getSupportTime().getTime() > System.currentTimeMillis())
      if (pba.getType().intValue() == 1) {
        campArmy.setRewardDoubleType(1);
        campArmy.setRewardDouble(1.5D);
      } else if (pba.getType().intValue() == 2) {
        campArmy.setRewardDoubleType(2);
        campArmy.setRewardDouble(2.0D);
      }  
    if (batSide == 1) {
      campArmy.setStrategies((int[])troop.getStrategyMap().get(Integer.valueOf(bat.terrainVal)));
    } else {
      campArmy.setStrategies((int[])troop.getStrategyDefMap().get(Integer.valueOf(bat.terrainVal)));
    } 
    SpecialGeneral sp = new SpecialGeneral((general.getGeneralSpecialInfo()).generalType, (general.getGeneralSpecialInfo()).param, (general.getGeneralSpecialInfo()).param2);
    campArmy.setSpecialGeneral(sp);
    if (general.getTacticId().intValue() > 0 && pgm.getForces().intValue() >= campArmy.getMaxForces()) {
      campArmy.setTacticVal(1);
      if ((campArmy.getSpecialGeneral()).generalType == 7)
        campArmy.setTacticVal((int)(campArmy.getSpecialGeneral()).param); 
    } 
    Map<Integer, CampArmy> generalmap = null;
    if (campArmy.getPlayerId() > 0 && !campArmy.isPhantom) {
      if (bat.getGeneralMap().containsKey(Integer.valueOf(campArmy.getPlayerId()))) {
        generalmap = (Map<Integer, CampArmy>)bat.getGeneralMap().get(Integer.valueOf(campArmy.getPlayerId()));
      } else {
        generalmap = new HashMap<>();
        bat.getGeneralMap().put(Integer.valueOf(campArmy.getPlayerId()), generalmap);
      } 
      generalmap.put(Integer.valueOf(campArmy.getGeneralId()), campArmy);
    } 
    return campArmy;
  }
  
  public CampArmy copyArmyFromPhantom(IDataGetter dataGetter, Battle bat, PlayerGeneralMilitaryPhantom phantom, int batSide) {
    CampArmy campArmy = new CampArmy();
    Player player = dataGetter.getPlayerDao().read(phantom.getPlayerId().intValue());
    General general = (General)dataGetter.getGeneralCache().get(phantom.getGeneralId());
    if (general == null)
      ErrorSceneLog.getInstance().appendErrorMsg("sdata general武将表缺少武将:" + phantom.getGeneralId()); 
    SpecialGeneral sg = new SpecialGeneral((general.getGeneralSpecialInfo()).generalType, (general.getGeneralSpecialInfo()).param, (general.getGeneralSpecialInfo()).param2);
    if ((general.getGeneralSpecialInfo()).generalType == 2)
      sg.param = ((WorldCity)dataGetter.getWorldCityCache().get(Integer.valueOf(bat.getDefBaseInfo().getId()))).getDistance(player.getForceId().intValue()); 
    campArmy.setSpecialGeneral(sg);
    campArmy.isPhantom = true;
    campArmy.updateDB = true;
    campArmy.setId(bat.campNum.getAndIncrement());
    campArmy.setPgmVId(phantom.getVId().intValue());
    campArmy.setArmyName(general.getName());
    campArmy.setPlayerLv(phantom.getPlayerLv().intValue());
    campArmy.setPlayerId(phantom.getPlayerId().intValue());
    campArmy.setPayTotal(player.getPayTotal().intValue());
    campArmy.setForceId(player.getForceId().intValue());
    campArmy.setPlayerName(player.getPlayerName());
    campArmy.setActivityAddExp(dataGetter.getActivityService().getAddBatValue(player.getPlayerId().intValue(), player.getPlayerLv().intValue()));
    campArmy.setSex(general.getSex().intValue());
    campArmy.setGeneralId(phantom.getGeneralId().intValue());
    campArmy.setGeneralLv(phantom.getGeneralLv().intValue());
    if (phantom.getType().intValue() > 0) {
      if (phantom.getType().intValue() == 1) {
        campArmy.setGeneralName(String.valueOf(String.valueOf(String.valueOf(general.getName()))) + "突击军");
      } else if (phantom.getType().intValue() == 2) {
        campArmy.setGeneralName(String.valueOf(String.valueOf(String.valueOf(general.getName()))) + "单挑军");
      } else if (phantom.getType().intValue() == 4) {
        campArmy.setGeneralName(String.valueOf(String.valueOf(String.valueOf(general.getName()))) + "聚力军");
      } else if (phantom.getType().intValue() == 5) {
        campArmy.setGeneralName(String.valueOf(String.valueOf(String.valueOf(general.getName()))) + "陷阵营");
      } else if (phantom.getType().intValue() == 20) {
        campArmy.setGeneralName(String.valueOf(String.valueOf(String.valueOf(general.getName()))) + "虎豹骑");
      } else if (phantom.getType().intValue() == 21) {
        campArmy.setGeneralName(String.valueOf(String.valueOf(String.valueOf(general.getName()))) + "武神骑");
      } else if (phantom.getType().intValue() == 24) {
        campArmy.setGeneralName(String.valueOf(general.getName()) + "无双骑");
      } else {
        campArmy.setGeneralName(String.valueOf(String.valueOf(String.valueOf(general.getName()))) + LocalMessages.PGM_PHANTOM_SUFFIX);
      } 
    } else {
      campArmy.setGeneralName(String.valueOf(String.valueOf(String.valueOf(general.getName()))) + LocalMessages.PGM_PHANTOM_SUFFIX);
    } 
    campArmy.setGeneralPic(general.getPic());
    campArmy.setQuality(general.getQuality().intValue());
    campArmy.setTacicId(general.getTacticId().intValue());
    campArmy.setStrength(phantom.getStrength().intValue());
    campArmy.setLeader(phantom.getLeader().intValue());
    campArmy.setBdEffect(phantom.getPlayerLv().intValue());
    campArmy.setCopyType(phantom.getType().intValue());
    if (phantom.getType().intValue() == 1 || phantom.getType().intValue() == 20)
      campArmy.setIsChongFeng(1); 
    PlayerAttribute pa = dataGetter.getPlayerAttributeDao().read(player.getPlayerId().intValue());
    if (pa != null && pa.getMountRank().intValue() > 0)
      campArmy.setZuoQiSkill(pa.getMountRank().intValue()); 
    if (player.getMoonCard().intValue() > 0 && player.getMoonCardTime() != null && player.getMoonCardTime().after(new Date()))
      campArmy.setIsMoonCard(true); 
    PlayerGeneralEvoke pge = dataGetter.getPlayerGeneralEvokeDao().getPlayerGeneralEvoke(player.getPlayerId().intValue(), phantom.getGeneralId().intValue());
    boolean uniontroop = false;
    boolean legend_281 = false;
    if (pge != null) {
      if (pge.getEvokeSkillFinal().intValue() > 0 || pge.getUnionEvoke().intValue() > 0) {
        campArmy.setIsJuexing(1);
        if (pge.getGeneralId().intValue() == 402)
          campArmy.setMhxx(1); 
        if (phantom.getGeneralId().intValue() == 204)
          campArmy.setChiZhanFa(1); 
      } 
      if (pge.getEvokeSkillFinal().intValue() > 0 || pge.getUnionEvoke().intValue() > 0) {
        EvokeGeneral egr = dataGetter.getEvokeGeneralCache().getEvokeGeneral(phantom.getGeneralId().intValue());
        campArmy.setTacicId(egr.getTacticId().intValue());
        campArmy.setGeneralPic(egr.getPic());
        if (pge.getUnionEvoke().intValue() > 0 && phantom.getGeneralId().intValue() == 103 && phantom.getUnionState().intValue() > 0) {
          campArmy.setTacicId(1321);
          campArmy.setGeneralName("赤壁奇谋");
          campArmy.setGeneralPic("zhouyujx_zhugeliangjx");
          campArmy.setUnionRank(pge.getUnionRank().intValue());
          campArmy.setDeputy(0);
          campArmy.setUnionState(1);
          uniontroop = true;
        } 
      } 
      int zsjqskill = dataGetter.getBattleDataCache().getGeneralZsjqSkillLevel(player.getPlayerId().intValue(), phantom.getGeneralId().intValue());
      campArmy.setZsJqSkillLevel(zsjqskill);
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 204) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic[curChapter - 1]);
        campArmy.setTacicId(4020401);
        campArmy.setLegendEvoke(true);
      } else if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 107) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName2[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic2[curChapter - 1]);
        campArmy.setTacicId(4010701);
        campArmy.setLegendEvoke(true);
      } else if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 281) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName3[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic3[curChapter - 1]);
        campArmy.setTacicId(4028101);
        campArmy.setLegendEvoke(true);
        legend_281 = true;
      } else if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 269) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName4[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic4[curChapter - 1]);
        campArmy.setTacicId(4026901);
        campArmy.setLegendEvoke(true);
        legend_281 = true;
      } else if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 201) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName5[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic5[curChapter - 1]);
        campArmy.setTacicId(4020101);
        campArmy.setLegendEvoke(true);
      } else if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 416) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName6[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic6[curChapter - 1]);
        campArmy.setTacicId(9991309);
        campArmy.setLegendEvoke(true);
      } 
    } 
    int troopid = general.getTroop().intValue();
    if (campArmy.getIsJuexing() <= 0 && phantom.getGeneralId().intValue() == 204)
      troopid = 34; 
    if (campArmy.getIsJuexing() > 0) {
      for (int k = 0; k < GeneralUtils.jxwulist.length; k++) {
        if (phantom.getGeneralId().intValue() == GeneralUtils.jxwulist[k].intValue()) {
          troopid = GeneralUtils.jxtroop[k].intValue();
          break;
        } 
      } 
      if (phantom.getGeneralId().intValue() == 204) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 122; 
      } else if (phantom.getGeneralId().intValue() == 107) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 127; 
      } else if (phantom.getGeneralId().intValue() == 281) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 128; 
      } else if (phantom.getGeneralId().intValue() == 269) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 143; 
      } else if (phantom.getGeneralId().intValue() == 201) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 149; 
      } else if (phantom.getGeneralId().intValue() == 416) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 881681; 
      } 
    } 
    PlayerGeneralMilitary pgm = dataGetter.getPlayerGeneralMilitaryDao().getMilitary(phantom.getPlayerId().intValue(), phantom.getGeneralId().intValue());
    int yubaonaijiu = 0;
    if (pgm != null && pgm.getDeputyId() != null && pgm.getDeputyId().intValue() > 0)
      campArmy.setDeputy(pgm.getDeputyId().intValue()); 
    if (pgm != null && pgm.getIsDeputy() != null && pgm.getIsDeputy().intValue() > 0)
      campArmy.setIsDeputy(1); 
    if (pgm != null && pgm.getLordId() != null && pgm.getLordId().intValue() > 0) {
      campArmy.setIsDeputy(1);
      campArmy.setZhuJiangId(pgm.getLordId().intValue());
    } 
    if (pgm != null) {
      Map<Integer, String> ycbweffectMap = dataGetter.getBattleDataCache().getYcbwMap(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
      campArmy.setPingKan(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(10))).intValue());
      campArmy.setPingKanDef(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(11))).intValue());
      campArmy.setYcbwHujia(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(12))).intValue());
      campArmy.setYcbwPojia(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(13))).intValue());
      campArmy.setKaiShan(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(14))).intValue());
      campArmy.setDingJun(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(15))).intValue());
      campArmy.setYbTx(ycbweffectMap.get(Integer.valueOf(19)));
      campArmy.setYubaoEffect(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(20))).intValue());
      campArmy.setLeader(campArmy.getLeader() + Integer.valueOf(ycbweffectMap.get(Integer.valueOf(4))).intValue());
      campArmy.setStrength(campArmy.getStrength() + Integer.valueOf(ycbweffectMap.get(Integer.valueOf(5))).intValue());
      yubaonaijiu = Integer.valueOf(ycbweffectMap.get(Integer.valueOf(16))).intValue();
      if (pgm.getGodWeapon() != null && pgm.getGodWeapon().intValue() > 0)
        campArmy.setWsb(pgm.getGodWeapon().intValue()); 
      if (pge != null && pge.getUnionEvoke().intValue() > 0 && pgm.getGeneralId().intValue() == 103 && pgm.getDeputyId().intValue() == 269) {
        campArmy.setTacicId(1321);
        campArmy.setGeneralName("赤壁奇谋幻影");
        campArmy.setGeneralPic("zhouyujx_zhugeliangjx");
        campArmy.setUnionRank(pge.getUnionRank().intValue());
        if (phantom.getType().intValue() == 1) {
          campArmy.setGeneralName("赤壁奇谋突击军");
        } else if (phantom.getType().intValue() == 2) {
          campArmy.setGeneralName("赤壁奇谋单挑军");
        } else if (phantom.getType().intValue() == 4) {
          campArmy.setGeneralName("赤壁奇谋聚力军");
        } else if (phantom.getType().intValue() == 5) {
          campArmy.setGeneralName("赤壁奇谋陷阵营");
        } else if (phantom.getType().intValue() == 20) {
          campArmy.setGeneralName("赤壁奇谋虎豹骑");
        } else if (phantom.getType().intValue() == 21) {
          campArmy.setGeneralName("赤壁奇谋武神骑");
        } else if (phantom.getType().intValue() == 24) {
          campArmy.setGeneralName("赤壁奇谋无双骑");
        } 
        campArmy.setDeputy(0);
        campArmy.setUnionState(1);
        troopid = 75;
      } 
      if (pge != null) {
        if (pgm.getGeneralId().intValue() == 277 && pge.getUnionEvoke().intValue() > 0) {
          troopid = 80;
          campArmy.setTacicId(1755);
          campArmy.setGeneralPic("liuguanzhang");
          campArmy.setUnionRank(pge.getUnionRank().intValue());
          campArmy.setDeputy(0);
          campArmy.setUnionState(1);
          campArmy.setGeneralName("桃园之誓幻影");
          if (phantom.getType().intValue() == 1) {
            campArmy.setGeneralName("桃园之誓突击军");
          } else if (phantom.getType().intValue() == 2) {
            campArmy.setGeneralName("桃园之誓单挑军");
          } else if (phantom.getType().intValue() == 4) {
            campArmy.setGeneralName("桃园之誓聚力军");
          } else if (phantom.getType().intValue() == 5) {
            campArmy.setGeneralName("桃园之誓陷阵营");
          } else if (phantom.getType().intValue() == 20) {
            campArmy.setGeneralName("桃园之誓虎豹骑");
          } else if (phantom.getType().intValue() == 21) {
            campArmy.setGeneralName("桃园之誓武神骑");
          } else if (phantom.getType().intValue() == 24) {
            campArmy.setGeneralName("桃园之誓无双骑");
          } 
        } 
        if (pgm.getGeneralId().intValue() == 202 && pge.getShenJiang().intValue() > 0) {
          troopid = 79;
          campArmy.setTacicId(3101);
        } 
        if (pgm.getGeneralId().intValue() == 201 && pge.getUnionEvoke().intValue() > 0 && pgm.getDeputyId().intValue() == 266) {
          troopid = 89;
          campArmy.setTacicId(1614);
          campArmy.setGeneralPic("lvbudiaochanjx");
          campArmy.setUnionRank(pge.getUnionRank().intValue());
          campArmy.setDeputy(0);
          campArmy.setUnionState(1);
          campArmy.setGeneralName("乱世眷侣幻影");
          if (phantom.getType().intValue() == 1) {
            campArmy.setGeneralName("乱世眷侣突击军");
          } else if (phantom.getType().intValue() == 2) {
            campArmy.setGeneralName("乱世眷侣单挑军");
          } else if (phantom.getType().intValue() == 4) {
            campArmy.setGeneralName("乱世眷侣聚力军");
          } else if (phantom.getType().intValue() == 5) {
            campArmy.setGeneralName("乱世眷侣陷阵营");
          } else if (phantom.getType().intValue() == 20) {
            campArmy.setGeneralName("乱世眷侣虎豹骑");
          } else if (phantom.getType().intValue() == 21) {
            campArmy.setGeneralName("乱世眷侣武神骑");
          } else if (phantom.getType().intValue() == 24) {
            campArmy.setGeneralName("乱世眷侣无双骑");
          } 
        } 
        if (pgm.getGeneralId().intValue() == 204 && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("")) {
          JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
          String chapterstr = (String)legendobj.get("chapterInfo");
          String[] chapterinfo = chapterstr.split(":");
          int curChapter = legendobj.getIntValue("chapterId");
          campArmy.setTacicId(4020401);
          campArmy.setChapterId(curChapter - 1);
          campArmy.setLegendEvoke(true);
          campArmy.setGeneralPic(GeneralUtils.chapterpic[curChapter - 1]);
          campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName[curChapter - 1]) + "幻影");
          if (phantom.getType().intValue() == 1) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName[curChapter - 1]) + "突击军");
          } else if (phantom.getType().intValue() == 2) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName[curChapter - 1]) + "单挑军");
          } else if (phantom.getType().intValue() == 4) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName[curChapter - 1]) + "聚力军");
          } else if (phantom.getType().intValue() == 5) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName[curChapter - 1]) + "陷阵营");
          } else if (phantom.getType().intValue() == 20) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName[curChapter - 1]) + "虎豹骑");
          } else if (phantom.getType().intValue() == 21) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName[curChapter - 1]) + "武神骑");
          } else if (phantom.getType().intValue() == 24) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName[curChapter - 1]) + "无双骑");
          } 
        } 
        if (pgm.getGeneralId().intValue() == 107 && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("")) {
          JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
          String chapterstr = (String)legendobj.get("chapterInfo");
          String[] chapterinfo = chapterstr.split(":");
          int curChapter = legendobj.getIntValue("chapterId");
          campArmy.setTacicId(4010701);
          campArmy.setChapterId(curChapter - 1);
          campArmy.setLegendEvoke(true);
          campArmy.setGeneralPic(GeneralUtils.chapterpic2[curChapter - 1]);
          campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName2[curChapter - 1]) + "幻影");
          if (phantom.getType().intValue() == 1) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName2[curChapter - 1]) + "突击军");
          } else if (phantom.getType().intValue() == 2) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName2[curChapter - 1]) + "单挑军");
          } else if (phantom.getType().intValue() == 4) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName2[curChapter - 1]) + "聚力军");
          } else if (phantom.getType().intValue() == 5) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName2[curChapter - 1]) + "陷阵营");
          } else if (phantom.getType().intValue() == 20) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName2[curChapter - 1]) + "虎豹骑");
          } else if (phantom.getType().intValue() == 21) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName2[curChapter - 1]) + "武神骑");
          } else if (phantom.getType().intValue() == 24) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName2[curChapter - 1]) + "无双骑");
          } 
        } 
        if (pgm.getGeneralId().intValue() == 281 && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("")) {
          JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
          String chapterstr = (String)legendobj.get("chapterInfo");
          String[] chapterinfo = chapterstr.split(":");
          int curChapter = legendobj.getIntValue("chapterId");
          campArmy.setTacicId(4028101);
          campArmy.setChapterId(curChapter - 1);
          campArmy.setLegendEvoke(true);
          campArmy.setGeneralPic(GeneralUtils.chapterpic3[curChapter - 1]);
          campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName3[curChapter - 1]) + "幻影");
          if (phantom.getType().intValue() == 1) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName3[curChapter - 1]) + "突击军");
          } else if (phantom.getType().intValue() == 2) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName3[curChapter - 1]) + "单挑军");
          } else if (phantom.getType().intValue() == 4) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName3[curChapter - 1]) + "聚力军");
          } else if (phantom.getType().intValue() == 5) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName3[curChapter - 1]) + "陷阵营");
          } else if (phantom.getType().intValue() == 20) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName3[curChapter - 1]) + "虎豹骑");
          } else if (phantom.getType().intValue() == 21) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName3[curChapter - 1]) + "武神骑");
          } else if (phantom.getType().intValue() == 24) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName3[curChapter - 1]) + "无双骑");
          } 
        } 
        if (pgm.getGeneralId().intValue() == 269 && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("")) {
          JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
          String chapterstr = (String)legendobj.get("chapterInfo");
          String[] chapterinfo = chapterstr.split(":");
          int curChapter = legendobj.getIntValue("chapterId");
          campArmy.setTacicId(4026901);
          campArmy.setChapterId(curChapter - 1);
          campArmy.setLegendEvoke(true);
          campArmy.setGeneralPic(GeneralUtils.chapterpic4[curChapter - 1]);
          campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName4[curChapter - 1]) + "幻影");
          if (phantom.getType().intValue() == 1) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName4[curChapter - 1]) + "突击军");
          } else if (phantom.getType().intValue() == 2) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName4[curChapter - 1]) + "单挑军");
          } else if (phantom.getType().intValue() == 4) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName4[curChapter - 1]) + "聚力军");
          } else if (phantom.getType().intValue() == 5) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName4[curChapter - 1]) + "陷阵营");
          } else if (phantom.getType().intValue() == 20) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName4[curChapter - 1]) + "虎豹骑");
          } else if (phantom.getType().intValue() == 21) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName4[curChapter - 1]) + "武神骑");
          } else if (phantom.getType().intValue() == 24) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName4[curChapter - 1]) + "无双骑");
          } 
        } 
        if (pgm.getGeneralId().intValue() == 201 && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("")) {
          JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
          String chapterstr = (String)legendobj.get("chapterInfo");
          String[] chapterinfo = chapterstr.split(":");
          int curChapter = legendobj.getIntValue("chapterId");
          campArmy.setTacicId(4020101);
          campArmy.setChapterId(curChapter - 1);
          campArmy.setLegendEvoke(true);
          campArmy.setGeneralPic(GeneralUtils.chapterpic5[curChapter - 1]);
          campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName5[curChapter - 1]) + "幻影");
          if (phantom.getType().intValue() == 1) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName5[curChapter - 1]) + "突击军");
          } else if (phantom.getType().intValue() == 2) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName5[curChapter - 1]) + "单挑军");
          } else if (phantom.getType().intValue() == 4) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName5[curChapter - 1]) + "聚力军");
          } else if (phantom.getType().intValue() == 5) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName5[curChapter - 1]) + "陷阵营");
          } else if (phantom.getType().intValue() == 20) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName5[curChapter - 1]) + "虎豹骑");
          } else if (phantom.getType().intValue() == 21) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName5[curChapter - 1]) + "武神骑");
          } else if (phantom.getType().intValue() == 24) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName5[curChapter - 1]) + "无双骑");
          } 
        } 
        if (pgm.getGeneralId().intValue() == 416 && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("")) {
          JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
          String chapterstr = (String)legendobj.get("chapterInfo");
          String[] chapterinfo = chapterstr.split(":");
          int curChapter = legendobj.getIntValue("chapterId");
          campArmy.setTacicId(9991309);
          campArmy.setChapterId(curChapter - 1);
          campArmy.setLegendEvoke(true);
          campArmy.setGeneralPic(GeneralUtils.chapterpic6[curChapter - 1]);
          campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName6[curChapter - 1]) + "幻影");
          if (phantom.getType().intValue() == 1) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName6[curChapter - 1]) + "突击军");
          } else if (phantom.getType().intValue() == 2) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName6[curChapter - 1]) + "单挑军");
          } else if (phantom.getType().intValue() == 4) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName6[curChapter - 1]) + "聚力军");
          } else if (phantom.getType().intValue() == 5) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName6[curChapter - 1]) + "陷阵营");
          } else if (phantom.getType().intValue() == 20) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName6[curChapter - 1]) + "虎豹骑");
          } else if (phantom.getType().intValue() == 21) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName6[curChapter - 1]) + "武神骑");
          } else if (phantom.getType().intValue() == 24) {
            campArmy.setGeneralName(String.valueOf(GeneralUtils.chapterName6[curChapter - 1]) + "无双骑");
          } 
        } 
        if (pgm.getGeneralId().intValue() == 270 && pge.getUnionEvoke().intValue() > 0 && pgm.getDeputyId().intValue() == 273) {
          troopid = 103;
          campArmy.setTacicId(1802);
          campArmy.setGeneralPic("xiahoudun_xiahouyuanjx1");
          campArmy.setUnionRank(pge.getUnionRank().intValue());
          campArmy.setDeputy(0);
          campArmy.setUnionState(1);
          campArmy.setGeneralName("夏侯兄弟幻影");
          if (phantom.getType().intValue() == 1) {
            campArmy.setGeneralName("夏侯兄弟突击军");
          } else if (phantom.getType().intValue() == 2) {
            campArmy.setGeneralName("夏侯兄弟单挑军");
          } else if (phantom.getType().intValue() == 4) {
            campArmy.setGeneralName("夏侯兄弟聚力军");
          } else if (phantom.getType().intValue() == 5) {
            campArmy.setGeneralName("夏侯兄弟陷阵营");
          } else if (phantom.getType().intValue() == 20) {
            campArmy.setGeneralName("夏侯兄弟虎豹骑");
          } else if (phantom.getType().intValue() == 21) {
            campArmy.setGeneralName("夏侯兄弟武神骑");
          } 
        } 
        if (pgm.getGeneralId().intValue() == 232 && pge.getUnionEvoke().intValue() > 0 && pgm.getDeputyId().intValue() == 274) {
          troopid = 108;
          campArmy.setTacicId(3601);
          campArmy.setGeneralPic("nanzhongzhizhu");
          campArmy.setUnionRank(pge.getUnionRank().intValue());
          campArmy.setDeputy(0);
          campArmy.setUnionState(1);
          campArmy.setGeneralName("南中之主幻影");
          if (phantom.getType().intValue() == 1) {
            campArmy.setGeneralName("南中之主突击军");
          } else if (phantom.getType().intValue() == 2) {
            campArmy.setGeneralName("南中之主单挑军");
          } else if (phantom.getType().intValue() == 4) {
            campArmy.setGeneralName("南中之主聚力军");
          } else if (phantom.getType().intValue() == 5) {
            campArmy.setGeneralName("南中之主陷阵营");
          } else if (phantom.getType().intValue() == 20) {
            campArmy.setGeneralName("南中之主虎豹骑");
          } else if (phantom.getType().intValue() == 21) {
            campArmy.setGeneralName("南中之主武神骑");
          } 
        } 
      } 
    } 
    StoreHouse generalTreasure = dataGetter.getStoreHouseDao().getByGeneralIdAndType(player.getPlayerId().intValue(), phantom.getGeneralId().intValue(), 2, 3);
    if (generalTreasure != null) {
      int baowuid = generalTreasure.getItemId().intValue();
      if (pgm.getGeneralId().intValue() == 107 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1075)
        troopid = 881442; 
      if (pgm.getGeneralId().intValue() == 204 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1074)
        troopid = 881222; 
      if (pgm.getGeneralId().intValue() == 281 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1073)
        troopid = 881281; 
      if (pgm.getGeneralId().intValue() == 269 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1072)
        troopid = 881434; 
      if (pgm.getGeneralId().intValue() == 201 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1071)
        troopid = 881492; 
      if ((baowuid == 81 || generalTreasure.getPiFu().intValue() == 81) && phantom.getGeneralId().intValue() == 201 && (campArmy.getUnionState() <= 0 || pgm == null || (pgm != null && pgm.getDeputyId().intValue() != 266))) {
        troopid = 87571;
      } else if ((baowuid == 82 || generalTreasure.getPiFu().intValue() == 82) && phantom.getGeneralId().intValue() == 267) {
        troopid = 87621;
      } else if ((baowuid == 83 || generalTreasure.getPiFu().intValue() == 83) && phantom.getGeneralId().intValue() == 211) {
        troopid = 87671;
      } else if ((baowuid == 84 || generalTreasure.getPiFu().intValue() == 84) && phantom.getGeneralId().intValue() == 275) {
        troopid = 87601;
      } else if ((baowuid == 85 || generalTreasure.getPiFu().intValue() == 85) && phantom.getGeneralId().intValue() == 103 && campArmy.getUnionState() > 0 && pgm != null && pgm.getDeputyId().intValue() == 269) {
        troopid = 87751;
      } else if ((baowuid == 86 || generalTreasure.getPiFu().intValue() == 86) && phantom.getGeneralId().intValue() == 277 && campArmy.getUnionState() > 0) {
        troopid = 87801;
      } else if ((baowuid == 87 || generalTreasure.getPiFu().intValue() == 87) && phantom.getGeneralId().intValue() == 224) {
        troopid = 87551;
      } else if ((baowuid == 113 || generalTreasure.getPiFu().intValue() == 113) && phantom.getGeneralId().intValue() == 201 && campArmy.getUnionState() > 0 && pgm != null && pgm.getDeputyId().intValue() == 266) {
        troopid = 87893;
        campArmy.setGeneralPic("lvbudiaochanjx2");
      } else if ((baowuid == 111 || generalTreasure.getPiFu().intValue() == 111) && phantom.getGeneralId().intValue() == 201 && (campArmy.getUnionState() <= 0 || pgm == null || (pgm != null && pgm.getDeputyId().intValue() != 266))) {
        troopid = 87572;
      } else if ((baowuid == 112 || generalTreasure.getPiFu().intValue() == 112) && phantom.getGeneralId().intValue() == 266) {
        troopid = 87711;
      } else if ((baowuid == 116 || generalTreasure.getPiFu().intValue() == 116) && phantom.getGeneralId().intValue() == 103 && campArmy.getUnionState() > 0 && pgm != null && pgm.getDeputyId().intValue() == 269) {
        troopid = 88751;
      } 
      if (baowuid >= 1003) {
        campArmy.setTouXian(baowuid);
        campArmy.setTitle(baowuid);
        campArmy.setTitle1(WeaponUtils.kuangshipic1[baowuid - 1003]);
      } 
    } 
    if (phantom.getGeneralId().intValue() == 211) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), phantom.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 34) {
            troopid = 87672;
            break;
          } 
        }  
    } else if (phantom.getGeneralId().intValue() == 281) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), phantom.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 66) {
            troopid = 88961;
            break;
          } 
        }  
    } else if (phantom.getGeneralId().intValue() == 107) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), phantom.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 68) {
            troopid = 88781;
            break;
          } 
        }  
    } else if (phantom.getGeneralId().intValue() == 277 && campArmy.getUnionState() > 0) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), phantom.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 65) {
            troopid = 88801;
            break;
          } 
        }  
    } else if (phantom.getGeneralId().intValue() == 201 && campArmy.getUnionState() > 0 && pgm != null && pgm.getDeputyId().intValue() == 266) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), phantom.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 67) {
            troopid = 88891;
            break;
          } 
        }  
    } else if (phantom.getGeneralId().intValue() == 270 && campArmy.getUnionState() > 0 && pgm != null && pgm.getDeputyId().intValue() == 273) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 69) {
            troopid = 881031;
            break;
          } 
          if (sh.getItemId().intValue() == 70) {
            troopid = 881032;
            break;
          } 
        }  
    } else if (phantom.getGeneralId().intValue() == 232 && campArmy.getUnionState() > 0 && pgm != null && pgm.getDeputyId().intValue() == 274) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 71) {
            troopid = 881081;
            break;
          } 
          if (sh.getItemId().intValue() == 72) {
            troopid = 881082;
            break;
          } 
        }  
    } else if (phantom.getGeneralId().intValue() == 204 && campArmy.getLegendEvoke() && pgm != null) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 73) {
            troopid = 881221;
            campArmy.setTacicId(4020402);
            break;
          } 
          if (sh.getItemId().intValue() == 74) {
            troopid = 881223;
            campArmy.setTacicId(4020403);
            break;
          } 
          if (sh.getItemId().intValue() == 121) {
            troopid = 881224;
            campArmy.setTacicId(4020403);
            break;
          } 
        }  
    } else if (phantom.getGeneralId().intValue() == 107 && campArmy.getLegendEvoke() && pgm != null) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 35) {
            troopid = 881273;
            campArmy.setTacicId(4010702);
            break;
          } 
          if (sh.getItemId().intValue() == 79) {
            troopid = 12730001;
            campArmy.setTacicId(4010702);
            break;
          } 
        }  
    } else if (phantom.getGeneralId().intValue() == 281 && campArmy.getLegendEvoke() && pgm != null) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 36) {
            troopid = 13830001;
            campArmy.setTacicId(4028101);
            break;
          } 
          if (sh.getItemId().intValue() == 80) {
            troopid = 13830002;
            campArmy.setTacicId(4028101);
            break;
          } 
        }  
    } else if (phantom.getGeneralId().intValue() == 269 && campArmy.getLegendEvoke() && pgm != null) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 40) {
            troopid = 14330001;
            campArmy.setTacicId(4026901);
            break;
          } 
          if (sh.getItemId().intValue() == 78) {
            troopid = 14330002;
            campArmy.setTacicId(4026901);
            break;
          } 
        }  
    } else if (phantom.getGeneralId().intValue() == 201 && campArmy.getLegendEvoke() && pgm != null) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 37) {
            troopid = 14930001;
            campArmy.setTacicId(4020101);
            break;
          } 
          if (sh.getItemId().intValue() == 81) {
            troopid = 881492;
            campArmy.setTacicId(4020101);
            break;
          } 
        }  
    } 
    Troop troop = dataGetter.getTroopCache().getTroop(troopid, player.getPlayerId().intValue());
    getTerrainValue(bat.terrainVal, troop, batSide, campArmy);
    campArmy.setTroopId(troop.getId().intValue());
    campArmy.setTroopSerial(troop.getSerial().intValue());
    campArmy.setTroopType(troop.getType().intValue());
    campArmy.setTroopName(troop.getName());
    if (phantom.getGeneralId().intValue() == 280)
      campArmy.setJxType(49); 
    if (pgm != null && pgm.getCarId().intValue() > 0) {
      int carId = pgm.getCarId().intValue();
      PlayerCatapult pcp = dataGetter.getPlayerCatapultDao().getPlayerChariotById(player.getPlayerId().intValue(), carId);
      int realcarId = 0;
      if (pcp.getOpen().intValue() >= 2 && pcp.getRftState().intValue() > 2) {
        realcarId = CatapultUtil.gaojicar[carId - 1].intValue();
      } else {
        realcarId = CatapultUtil.carid[carId - 1].intValue();
      } 
      if (carId <= 10) {
        PlayerCatapultCarpart pccarpart = dataGetter.getPlayerCatapultCarpartDao().getByplayerIdAndCarId(player.getPlayerId().intValue(), carId);
        int armmode = 0;
        if (pccarpart != null) {
          campArmy.setCarArmed(true);
          if (pccarpart.getCarWeapon() != null && !pccarpart.getCarWeapon().equals("")) {
            armmode++;
            String[] weaponlist = pccarpart.getCarWeapon().split(":");
            String[] array;
            int length = (array = weaponlist).length;
            int i = 0;
            while (i < length) {
              String partstr = array[i];
              PlayerCatapultElement pcele = dataGetter.getPlayerCatapultElementDao().read(Integer.valueOf(partstr).intValue());
              if (pcele != null && pcele.getElementId().intValue() == 1) {
                campArmy.setLieYanHuiXiang(1);
                int chongzhubeishu = pcele.getRecast().intValue();
                if (chongzhubeishu > 2)
                  chongzhubeishu = 2; 
                campArmy.setLieyandamage(2000 * (pcele.getElementLevel().intValue() + chongzhubeishu * 10));
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 7) {
                campArmy.setIsFanShang(1);
                if (pcele.getElementLevel().intValue() >= 5) {
                  campArmy.setDuoChongShaRen(pcele.getElementLevel().intValue());
                  campArmy.setShaRenRecastNum(pcele.getRecast().intValue());
                  campArmy.setCarPoDunNum(0);
                } 
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 8) {
                campArmy.setsjznLevel(pcele.getElementLevel().intValue());
                campArmy.setsjznType(1);
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 9) {
                campArmy.setIsFlower(1);
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 11) {
                String damage = pcele.getElementAttribute().split("=")[1];
                campArmy.setFiveShuiDamage(campArmy.getFiveShuiDamage() + Integer.valueOf(damage).intValue());
                break;
              } 
              i++;
            } 
          } 
          if (pccarpart.getCarBody() != null && !pccarpart.getCarBody().equals(""))
            armmode++; 
          if (pccarpart.getCarBottom() != null && !pccarpart.getCarBottom().equals("")) {
            armmode++;
            String[] bottomlist = pccarpart.getCarBottom().split(":");
            String[] array2;
            for (int length2 = (array2 = bottomlist).length, j = 0; j < length2; j++) {
              String partstr = array2[j];
              PlayerCatapultElement pcele = dataGetter.getPlayerCatapultElementDao().read(Integer.valueOf(partstr).intValue());
              if (pcele != null && pcele.getElementId().intValue() == 3) {
                campArmy.setLonglin(1);
                break;
              } 
            } 
          } 
          if (pccarpart.getCarChuanDong() != null && !pccarpart.getCarChuanDong().equals("")) {
            armmode++;
            String[] chuandonglist = pccarpart.getCarChuanDong().split(":");
            String[] array3;
            for (int length3 = (array3 = chuandonglist).length, l = 0; l < length3; l++) {
              String cdstr = array3[l];
              PlayerCatapultElement pcele = dataGetter.getPlayerCatapultElementDao().read(Integer.valueOf(cdstr).intValue());
              if (pcele != null && pcele.getElementId().intValue() == 10) {
                campArmy.setIsFlower(1);
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 12) {
                String damage = pcele.getElementAttribute().split("=")[1];
                campArmy.setFiveShuiDamage(campArmy.getFiveShuiDamage() + Integer.valueOf(damage).intValue());
                break;
              } 
            } 
          } 
          if (pcp.getOpen().intValue() >= 2 && armmode >= 3)
            armmode++; 
          if (armmode <= 0)
            armmode = 1; 
          if (armmode >= 4)
            armmode = 4; 
          realcarId = CatapultUtil.armEquipcar[carId - 1][armmode - 1].intValue();
        } 
      } 
      List<PlayerCatapultDriver> cardriverList = dataGetter.getPlayerCatapultDriverDao().getDriverListByplayerIdAndCarId(player.getPlayerId().intValue(), carId);
      if (cardriverList != null && !cardriverList.isEmpty()) {
        int driverId = ((PlayerCatapultDriver)cardriverList.get(0)).getDriverId().intValue();
        campArmy.setCarQudong(driverId);
        if (driverId > 10000)
          driverId = CatapultUtil.driversId.length; 
        realcarId = CatapultUtil.drivewaiguan[driverId - 1].intValue();
      } 
      campArmy.setCarId(realcarId);
      campArmy.setCarModel(carId);
      if (carId == 2)
        campArmy.setDefence(1); 
      int hujia = CatapultUtil.getHujiaByCarIdAndLv(carId, pcp.getHujiaLv().intValue()) + campArmy.getYcbwHujia();
      int naijiu = CatapultUtil.getEnduranceByCarIdAndLv(carId, pcp.getHujiaLv().intValue()) + yubaonaijiu;
      campArmy.setBigGzNum(hujia);
      campArmy.setCarHp(hujia * naijiu);
      campArmy.setCarMaxHp(hujia * naijiu);
      campArmy.setAttcoe(CatapultUtil.getHuoliByCarIdAndLv(carId, pcp.getHuoliLv().intValue()));
      campArmy.setHujia(hujia * naijiu);
      if (carId == 4)
        if (pcp.getRftState().intValue() >= 3) {
          campArmy.setSiCheHuJia(hujia * naijiu);
          campArmy.setSiCheGeZi(hujia);
        } else {
          campArmy.setSiCheHuJia(3 * naijiu);
          campArmy.setSiCheGeZi(3);
        }  
      campArmy.setNaijiu(naijiu);
      String gzstr = pcp.getRftLv();
      if (gzstr != null && !gzstr.equals("")) {
        String[] rftlevel = gzstr.split(":");
        int totallevel = 0;
        String[] array4;
        for (int length4 = (array4 = rftlevel).length, n = 0; n < length4; n++) {
          String dj = array4[n];
          totallevel += Integer.valueOf(dj).intValue();
        } 
        campArmy.setCarGzLevel(totallevel);
      } 
      if (carId <= 2) {
        campArmy.setPojia(CatapultUtil.getPojiaByCarIdAndLv(carId, pcp.getPojiaLv().intValue()) + dataGetter.getBattleDataCache().getPlayerPojia(player.getPlayerId().intValue(), carId));
      } else {
        campArmy.setPojia(CatapultUtil.getPojiaByCarIdAndLv(carId, pcp.getPojiaLv().intValue()));
      } 
      if (carId == 1) {
        campArmy.setBaoji(CatapultUtil.getCoreByCarIdAndLv(carId, pcp.getCoreLv().intValue()));
      } else if (carId == 2) {
        campArmy.setQiangGong(CatapultUtil.getCoreByCarIdAndLv(carId, pcp.getCoreLv().intValue()));
      } else if (carId == 3) {
        campArmy.setXueLiang(CatapultUtil.getCoreByCarIdAndLv(carId, pcp.getCoreLv().intValue()));
      } 
      if (dataGetter.getPlayerCatapultDao().getOpen(player.getPlayerId().intValue(), carId).intValue() > 1)
        campArmy.setCatapultSkill(carId); 
    } 
    if (pgm != null) {
      StoreHouse sh = dataGetter.getStoreHouseDao().getByGeneralIdAndType(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 36, 36);
      if (sh != null)
        campArmy.setJueEquip(1); 
    } 
    int zhenbao = dataGetter.getSilkService().getPlayerSilkTreasureLevel(player.getPlayerId().intValue());
    campArmy.setTenZhenBao(zhenbao);
    if (zhenbao >= 10) {
      campArmy.setZbAllTimes(5);
      campArmy.setZbTimes(0);
    } 
    if (zhenbao >= 9) {
      campArmy.setJiuZhenbao(1);
      campArmy.setzfShield(2);
    } 
    if (zhenbao >= 7)
      campArmy.setQiZhenbao(2); 
    if (zhenbao >= 4)
      campArmy.setSiZhenbao(4000); 
    if (zhenbao >= 3)
      campArmy.setSanZhenbao(4000); 
    if (zhenbao >= 2)
      campArmy.setErZhenBao(4000); 
    if (pgm != null && pgm.getFormationId() != null && pgm.getFormationId().intValue() > 0) {
      campArmy.setFormationType(pgm.getFormationId().intValue());
      List baguabooks = dataGetter.getPlayerStrategicsBookDao().getFormationBooksUpLevel(player.getPlayerId().intValue(), pgm.getFormationId().intValue(), 10);
      if (baguabooks != null && !baguabooks.isEmpty())
        campArmy.setBaGuaLevel(baguabooks.size()); 
      PlayerStrategics ps = dataGetter.getPlayerStrategicsDao().getByPlayerIdAndFormationId(player.getPlayerId().intValue(), pgm.getFormationId().intValue());
      if (ps != null) {
        campArmy.setFormationLevel(ps.getFormationLevel().intValue());
        if (ps.getState().intValue() >= 3) {
          int hasbigskill = 1;
          int bz = 0;
          int uplv = 0;
          if (ps.getFormationLevel().intValue() >= 1000) {
            hasbigskill = 5;
            bz = 6;
            uplv = 3;
          } 
          if (ps.getFormationLevel().intValue() >= 800) {
            hasbigskill = 5;
            bz = 5;
            uplv = 2;
          } 
          if (ps.getFormationLevel().intValue() >= 600) {
            hasbigskill = 4;
            bz = 4;
            uplv = 2;
          } 
          if (ps.getFormationLevel().intValue() >= 400) {
            hasbigskill = 4;
            bz = 3;
            uplv = 1;
          } 
          if (ps.getFormationLevel().intValue() >= 200) {
            hasbigskill = 4;
            bz = 2;
            uplv = 1;
          } 
          if (ps.getFormationLevel().intValue() >= 80) {
            hasbigskill = 3;
          } else if (ps.getFormationLevel().intValue() >= 60) {
            hasbigskill = 2;
          } 
          campArmy.setHasbigFormationskill(hasbigskill);
          campArmy.setBzStatus(bz);
          campArmy.setIsZhenFaLvUp(uplv);
          if (ps.getFormationId().intValue() == 3)
            campArmy.setFyzShield(1); 
          if (ps.getFormationId().intValue() == 6)
            if (ps.getFormationLevel().intValue() >= 70) {
              campArmy.setFuBingNum(4);
            } else if (ps.getFormationLevel().intValue() >= 50) {
              campArmy.setFuBingNum(3);
            } else if (ps.getFormationLevel().intValue() >= 30) {
              campArmy.setFuBingNum(2);
            } else if (ps.getFormationLevel().intValue() >= 20) {
              campArmy.setFuBingNum(1);
            }  
        } 
      } 
    } 
    if (pgm != null && pgm.getFormationId1() != null && pgm.getFormationId1().intValue() > 0) {
      PlayerStrategics1 ps1 = dataGetter.getPlayerStrategicsDao1().getByPlayerIdAndforceId(player.getPlayerId().intValue(), pgm.getFormationId1().intValue());
      if (ps1 != null) {
        int bingfu = 0;
        if (ps1.getForceId().intValue() == 1 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 1; 
        if (ps1.getForceId().intValue() == 2 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 2; 
        if (ps1.getForceId().intValue() == 3 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 3; 
        if (ps1.getForceId().intValue() == 4 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 4; 
        if (ps1.getForceId().intValue() == 5 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 5; 
        campArmy.setBzStatus1(bingfu);
        campArmy.setFuBingNum1(1);
      } 
    } 
    if (pgm != null) {
      List<StoreHouse> horselist = dataGetter.getStoreHouseDao().getHorseByGeneral(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
      if (horselist != null && !horselist.isEmpty()) {
        int horsetype = ((StoreHouse)horselist.get(0)).getItemId().intValue() - 4000;
        campArmy.setHorseType(horsetype);
        if (horsetype == 1)
          campArmy.setZsMyMa(1); 
      } 
    } 
    if (pgm != null && pgm.getHelpGeneral().intValue() == 402) {
      campArmy.setMeiXian(5);
      campArmy.setMeiXianUpper(4);
      if (pgm.getGeneralId().intValue() == 277 && campArmy.getUnionState() > 0) {
        campArmy.setMeiXian(4);
        campArmy.setMeiXianUpper(7);
      } 
      if (pgm.getGeneralId().intValue() == 416 && campArmy.getChapterId() > 0) {
        campArmy.setMeiXian(4);
        campArmy.setMeiXianUpper(7);
      } 
      if (campArmy.getHorseType() == 4) {
        campArmy.setMeiXianUpper(8);
        campArmy.setSsxMa(1);
      } 
    } 
    if (pgm != null && pgm.getHelpGeneral().intValue() > 0) {
      campArmy.setHelpGeneral(pgm.getHelpGeneral().intValue());
      PlayerGeneralEvoke helppge = dataGetter.getPlayerGeneralEvokeDao().getPlayerGeneralEvoke(player.getPlayerId().intValue(), pgm.getHelpGeneral().intValue());
      if (helppge != null && helppge.getEvokeSkillFinal().intValue() > 0) {
        campArmy.setHelpIsJuexing(1);
        if (pgm.getHelpGeneral().intValue() == 402)
          campArmy.setMhxx(1); 
      } 
      if (pgm.getHelpGeneral().intValue() == 403)
        campArmy.setHuangGaiZhanFa(1); 
      if (pgm.getHelpGeneral().intValue() == 404)
        campArmy.setBaiYi(1); 
    } 
    PlayerEpic playerepic = dataGetter.getPlayerEpicDao().getPlayerEpic(player.getPlayerId().intValue(), 1);
    if (playerepic != null && playerepic.getBigSkill().intValue() > 0)
      campArmy.setEpicLevel(1); 
    List<PlayerWarBeast> warbeastList = dataGetter.getPlayerWarBeastDao().getWarBeastListByplayerId(player.getPlayerId().intValue());
    if (warbeastList != null)
      campArmy.setYongYouBeast(true); 
    int forces = phantom.getHp().intValue();
    int remainder = forces % 3;
    forces -= remainder;
    campArmy.setArmyHp(forces);
    campArmy.setArmyHpOrg(forces);
    campArmy.setAttEffect(phantom.getAtt().intValue());
    campArmy.setDefEffect(phantom.getDef().intValue());
    campArmy.setMaxForces(phantom.getHpMax().intValue());
    campArmy.setColumn(phantom.getColumnNum().intValue());
    campArmy.setTroopHp(phantom.getHpMax().intValue() / phantom.getColumnNum().intValue());
    campArmy.setAttDef_B(new AttDef_B());
    (campArmy.getAttDef_B()).ATT_B = phantom.getAttB().intValue();
    (campArmy.getAttDef_B()).DEF_B = phantom.getDefB().intValue();
    campArmy.setTACTIC_ATT(phantom.getTacticAtt().intValue());
    campArmy.setTACTIC_DEF(phantom.getTacticDef().intValue());
    if (general.getTacticId().intValue() > 0 && phantom.getHp().equals(phantom.getHpMax())) {
      campArmy.setTacticVal(1);
      if ((campArmy.getSpecialGeneral()).generalType == 7)
        campArmy.setTacticVal((int)(campArmy.getSpecialGeneral()).param); 
    } 
    if (batSide == 1) {
      campArmy.setStrategies((int[])troop.getStrategyMap().get(Integer.valueOf(bat.terrainVal)));
    } else {
      campArmy.setStrategies((int[])troop.getStrategyDefMap().get(Integer.valueOf(bat.terrainVal)));
    } 
    return campArmy;
  }
  
  public static int getBattleStat(IDataGetter dataGetter, int battleType, int defId, int campNum) {
    if (battleType == 3)
      return dataGetter.getBattleStatCache().getWorldPvp(campNum); 
    if (battleType == 2 && ((Armies)dataGetter.getArmiesCache().get(Integer.valueOf(defId))).getType().intValue() == 3)
      return dataGetter.getBattleStatCache().getTimePve(campNum); 
    return 1;
  }
  
  public boolean initDefCamp(IDataGetter dataGetter, BattleAttacker battleAttacker, int defId, Battle bat) {
    Armies defLegion = (Armies)dataGetter.getArmiesCache().get(Integer.valueOf(defId));
    if (defLegion == null)
      return false; 
    int defForceId = defLegion.getChief().intValue();
    int defNum = 0;
    int id = 0;
    CampArmy campArmy = null;
    Integer[] defNpcs = defLegion.getArmiesId();
    if (defNpcs != null)
      for (int i = 0; i < defNpcs.length; i++) {
        Integer npc = defNpcs[i];
        if (npc.intValue() > 0) {
          id = bat.campNum.getAndIncrement();
          campArmy = copyArmyFromCach(null, npc.intValue(), dataGetter, id, bat.terrainVal, defLegion.getLevel().intValue());
          if (npc.intValue() == 20291) {
            PlayerPower playerPowerdw = dataGetter.getPlayerPowerDao().getPlayerPower(battleAttacker.attPlayerId, 33);
            if (playerPowerdw != null) {
              String dwstr = playerPowerdw.getCCjxInfo();
              if (dwstr == null || dwstr.equals("") || Integer.valueOf(dwstr).intValue() <= 0) {
                campArmy.setAttEffect(1690000);
                campArmy.setDefEffect(1690000);
                campArmy.setBdEffect(1690000);
                campArmy.setTroopHp(11000000);
                campArmy.setArmyHp(11000000);
                campArmy.setArmyHpOrg(11000000);
                campArmy.setMaxForces(11000000);
                campArmy.setColumn(1);
              } 
            } 
          } 
          defNum += campArmy.getArmyHpOrg();
          bat.defCamp.add(campArmy);
        } 
      }  
    id = bat.campNum.getAndIncrement();
    campArmy = copyArmyFromCach(null, defLegion.getChief().intValue(), dataGetter, id, bat.terrainVal, defLegion.getLevel().intValue());
    defNum += campArmy.getArmyHpOrg();
    bat.defCamp.add(campArmy);
    BattleSceneLog.getInstance().info("#batId:" + bat.getBattleId() + "_" + bat.getStartTime() + "#add:init#side:def" + "#playerId:" + campArmy.getPlayerId() + ":" + campArmy.isPhantom + "#general:" + campArmy.getGeneralId() + "#defSize:" + bat.defCamp.size());
    bat.defBaseInfo.setAllNum(bat.defBaseInfo.getAllNum() + defNum);
    if (defNum < 0)
      ErrorSceneLog.getInstance().appendErrorMsg("兵力小于0,battle 1684行"); 
    bat.defBaseInfo.setNum(bat.defBaseInfo.getNum() + defNum);
    bat.defBaseInfo.setForceId(defForceId);
    return false;
  }
  
  public static CampArmy copyArmyFromCach(Player player, int npc, IDataGetter dataGetter, int id, int terrainType, int npcLv) {
    CampArmy campArmy = new CampArmy();
    Army armyCach = (Army)dataGetter.getArmyCache().get(Integer.valueOf(npc));
    if (player == null) {
      campArmy.setPlayerId(-1);
      campArmy.setPlayerName("NPC");
      campArmy.setForceId(0);
      campArmy.setPlayerLv(npcLv);
    } else {
      campArmy.setPlayerId(player.getPlayerId().intValue());
      campArmy.setPayTotal(player.getPayTotal().intValue());
      campArmy.setPlayerName(player.getPlayerName());
      campArmy.setForceId(player.getForceId().intValue());
      campArmy.setPlayerLv(player.getPlayerLv().intValue());
    } 
    campArmy.setId(id);
    campArmy.setUpdateDB(false);
    campArmy.setPgmVId(0);
    campArmy.setArmyName(armyCach.getName());
    if (armyCach.getGeneralId().intValue() == 3101001 || armyCach.getGeneralId().intValue() == 3105002) {
      campArmy.setGeneralId(107);
    } else if (armyCach.getGeneralId().intValue() == 3102001 || armyCach.getGeneralId().intValue() == 3105003) {
      campArmy.setGeneralId(204);
    } else if (armyCach.getGeneralId().intValue() == 3103001 || armyCach.getGeneralId().intValue() == 3105004) {
      campArmy.setGeneralId(269);
    } else if (armyCach.getGeneralId().intValue() == 3104001 || armyCach.getGeneralId().intValue() == 3105005) {
      campArmy.setGeneralId(281);
    } else if (armyCach.getGeneralId().intValue() == 3105001) {
      campArmy.setGeneralId(201);
    } else if (armyCach.getGeneralId().intValue() == 3106001) {
      campArmy.setGeneralId(416);
    } else {
      campArmy.setGeneralId(armyCach.getGeneralId().intValue());
    } 
    campArmy.setGeneralName(armyCach.getName());
    campArmy.setGeneralLv(armyCach.getGeneralLv().intValue());
    General general = (General)dataGetter.getGeneralCache().get(armyCach.getGeneralId());
    campArmy.setSpecialGeneral(new SpecialGeneral((general.getGeneralSpecialInfo()).generalType, (general.getGeneralSpecialInfo()).param, (general.getGeneralSpecialInfo()).param2));
    campArmy.setGeneralPic(general.getPic());
    campArmy.setQuality(general.getQuality().intValue());
    campArmy.setStrength(general.getStrength().intValue());
    campArmy.setLeader(general.getLeader().intValue());
    campArmy.setTacicId(general.getTacticId().intValue());
    if (general.getTacticId().intValue() > 0) {
      campArmy.setTacticVal(1);
      if ((campArmy.getSpecialGeneral()).generalType == 7)
        campArmy.setTacticVal((int)(campArmy.getSpecialGeneral()).param); 
    } 
    campArmy.setSex(general.getSex().intValue());
    Troop troop = (Troop)dataGetter.getTroopCache().get(general.getTroop());
    campArmy.setTroopId(troop.getId().intValue());
    campArmy.setTroopSerial(troop.getSerial().intValue());
    campArmy.setTroopType(troop.getType().intValue());
    campArmy.setTroopName(troop.getName());
    campArmy.setTroopDropType(BattleDrop.getDropType(troop.getDrop()));
    campArmy.setTroopDrop(troop.getTroopDrop());
    campArmy.setAttEffect(armyCach.getAtt());
    campArmy.setDefEffect(armyCach.getDef());
    campArmy.setBdEffect(armyCach.getBd());
    campArmy.setTroopHp(armyCach.getTroopHp().intValue());
    int armyHp = armyCach.getArmyHp().intValue();
    int remainder = armyHp % 3;
    armyHp -= remainder;
    campArmy.setArmyHp(armyHp);
    campArmy.setArmyHpOrg(armyHp);
    campArmy.setMaxForces(armyHp);
    campArmy.setColumn(armyCach.getArmyHp().intValue() / armyCach.getTroopHp().intValue());
    campArmy.setStrategies((int[])troop.getStrategyDefMap().get(Integer.valueOf(terrainType)));
    campArmy.setBuff(armyCach.getBuff());
    campArmy.setIsJuexing(armyCach.getJx());
    campArmy.setIsBeatMonster(armyCach.getIsBeatMonster());
    int carId = armyCach.getCar();
    if (carId > 0) {
      campArmy.setCarId(CatapultUtil.carid[carId - 1].intValue());
      campArmy.setCarModel(carId);
      if (armyCach.getCar() == 2)
        campArmy.setDefence(1); 
      campArmy.setBigGzNum(5);
      campArmy.setCarHp(50);
      campArmy.setCarMaxHp(50);
      campArmy.setAttcoe(CatapultUtil.getHuoliByCarIdAndLv(carId, 10));
      campArmy.setHujia(50);
      if (carId == 4) {
        campArmy.setSiCheHuJia(30);
        campArmy.setSiCheGeZi(3);
      } 
      campArmy.setNaijiu(10);
      campArmy.setPojia(CatapultUtil.getPojiaByCarIdAndLv(carId, 10));
      if (carId == 1) {
        campArmy.setBaoji(CatapultUtil.getCoreByCarIdAndLv(carId, 10));
      } else if (carId == 2) {
        campArmy.setQiangGong(CatapultUtil.getCoreByCarIdAndLv(carId, 10));
      } else if (carId == 3) {
        campArmy.setXueLiang(CatapultUtil.getCoreByCarIdAndLv(carId, 10));
      } 
      campArmy.setCatapultSkill(carId);
    } 
    return campArmy;
  }
  
  public static boolean canAddBattleArmyList(List<BattleArmy> attList) {
    return (attList.size() < 6);
  }
  
  public static void onceAddQueues(List<BattleArmy> attAddQlist, List<BattleArmy> batList, List<CampArmy> batCamp, int battleSide, AtomicInteger batQNum, BaseInfo baseInfo, Map<Integer, PlayerInfo> inBattlePlayers, RoundInfo roundInfo, Battle bat, IDataGetter dataGetter) {
    CampArmy campArmy = null;
    Set<CampArmy> caSet = new HashSet<>();
    while (canAddBattleArmyList(batList)) {
      if (campArmy == null || campArmy.getArmyHp() < 3) {
        campArmy = null;
        for (CampArmy ca : batCamp) {
          if (ca.armyHp >= 3) {
            campArmy = ca;
            break;
          } 
          if (roundInfo == null)
            continue; 
          roundInfo.needPushReport13 = true;
        } 
        if (campArmy == null)
          break; 
      } 
      caSet.add(campArmy);
      campArmy.setOnQueues(true);
      if (campArmy.playerId > 0) {
        PlayerInfo playerInfo = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(campArmy.playerId));
        if (playerInfo != null)
          playerInfo.battleMode = 2; 
      } 
      addQueues(bat, attAddQlist, batList, campArmy, battleSide, batQNum);
      if ((!campArmy.isPhantom || bat.getBattleType() != 13) && campArmy.getArmyHp() < 3 && campArmy.getArmyHp() >= 0) {
        CampArmy fujiangCamp = bat.checkfujiang(dataGetter, battleSide, campArmy);
        if (fujiangCamp != null) {
          batCamp.add(batCamp.indexOf(campArmy) + 1, fujiangCamp);
          baseInfo.setAllNum(baseInfo.getAllNum() + fujiangCamp.getArmyHp());
          baseInfo.setNum(baseInfo.getNum() + fujiangCamp.getArmyHp());
        } 
      } 
      if (campArmy.getGeneralId() == 402)
        campArmy.setSunShangXiangZs(1); 
    } 
    for (CampArmy ca : caSet) {
      if (ca.getPlayerId() > 0 && !ca.isPhantom && !bat.inSceneSet.contains(Integer.valueOf(ca.getPlayerId())) && ca.updateDB) {
        JsonDocument doc2 = new JsonDocument();
        doc2.startObject();
        doc2.createElement("onQueuesGId", Integer.valueOf(ca.getGeneralId()));
        doc2.endObject();
        Players.push(ca.getPlayerId(), PushCommand.PUSH_GENERAL_INFO2, doc2.toByte());
      } 
    } 
  }
  
  public static BattleArmy addQueues(Battle battle, List<BattleArmy> attAddQlist, List<BattleArmy> attList, CampArmy campArmy, int battleSide, AtomicInteger batQNum) {
    int perRow = campArmy.troopHp;
    if (perRow > campArmy.armyHp)
      perRow = campArmy.armyHp; 
    if (campArmy.generalId == 204 && campArmy.isjuexing > 0 && !campArmy.getLegendEvoke()) {
      perRow = campArmy.armyHp;
      campArmy.setIsMain(1);
    } 
    perRow /= 3;
    if (perRow <= 0)
      perRow = 1; 
    boolean youzhanche = false;
    int leftrow = campArmy.armyHp / campArmy.troopHp;
    if (campArmy.generalId == 204 && campArmy.isjuexing > 0 && !campArmy.legendEvoke)
      leftrow = 1; 
    int totalrow = campArmy.armyHpOrg / campArmy.troopHp;
    boolean zuihousiche = false;
    if (campArmy.getCarModel() > 0) {
      if ((campArmy.generalId == 204 || campArmy.getTroopType() == 43) && campArmy.isjuexing > 0 && !campArmy.legendEvoke)
        youzhanche = true; 
      if ((campArmy.getCarModel() == 1 || campArmy.getCarModel() == 2 || campArmy.getCarModel() == 4 || campArmy.getCarModel() == 5) && totalrow == leftrow)
        youzhanche = true; 
      if ((campArmy.getCarModel() == 7 || campArmy.getCarModel() == 8 || campArmy.getCarModel() == 9 || campArmy.getCarModel() == 6 || campArmy.getCarModel() == 10) && totalrow == leftrow)
        youzhanche = true; 
      if ((campArmy.getCarModel() == 3 || campArmy.getCarModel() == 4) && campArmy.armyHp <= perRow * 3) {
        youzhanche = true;
        if (campArmy.getCarModel() == 4)
          zuihousiche = true; 
      } 
    } 
    boolean hushou = false;
    boolean ybzs = false;
    if (totalrow == leftrow) {
      ybzs = true;
      hushou = true;
    } 
    if (totalrow - 1 == leftrow)
      hushou = true; 
    if (campArmy.generalId == 204 && campArmy.isjuexing > 0 && !campArmy.legendEvoke) {
      campArmy.setArmyHp(0);
      ybzs = false;
    } else {
      campArmy.setArmyHp(campArmy.armyHp - perRow * 3);
    } 
    if (campArmy.getLegendSkill() != null && campArmy.getLegendSkill().containsKey("dili") && ((Integer)campArmy.getLegendSkill().get("dili")).intValue() > 0) {
      int dilibeishu = totalrow - leftrow;
      if (dilibeishu <= 0)
        dilibeishu = 0; 
      campArmy.setAttEffect(campArmy.getAttEffect() * (100 + dilibeishu * 25) / 100);
      campArmy.setDefEffect(campArmy.getDefEffect() * (100 + dilibeishu * 25) / 100);
    } 
    if (campArmy.getLegendSkill() != null && campArmy.getLegendSkill().containsKey("maolu") && ((Integer)campArmy.getLegendSkill().get("maolu")).intValue() > 0)
      campArmy.setDefEffect(campArmy.getDefEffect() + (int)((campArmy.getTroopHp() / 15) * 0.15D)); 
    BattleArmy battleArmy = new BattleArmy();
    battleArmy.setCampArmy(campArmy);
    if (ybzs)
      if (campArmy.getKaiShan() > 160) {
        battleArmy.setKaiShan(160);
      } else {
        battleArmy.setKaiShan(campArmy.getKaiShan());
      }  
    if ((totalrow == leftrow && campArmy.isDeputy <= 0) || (campArmy.generalId == 204 && campArmy.isjuexing > 0 && !campArmy.legendEvoke)) {
      battleArmy.setTitle(campArmy.getTitle());
      battleArmy.setTouXian(campArmy.getTouXian());
      battleArmy.setTitle(campArmy.getTitle());
      battleArmy.setTitle1(campArmy.getTitle1());
    } 
    if (youzhanche) {
      battleArmy.setHaveZhanche(true);
      battleArmy.setCarGzLevel(campArmy.getCarGzLevel());
      battleArmy.setLieYanHuiXiang(campArmy.getLieYanHuiXiang());
      battleArmy.setLonglin(campArmy.getLonglin());
      battleArmy.setCarPoDunNum(campArmy.getCarPoDunNum());
      battleArmy.setNaiJiu(campArmy.getNaijiu());
      if (zuihousiche) {
        battleArmy.setSiCheDier(1);
        battleArmy.setHuJia(campArmy.getSiCheHuJia());
        int carhp = campArmy.getSiCheGeZi() * campArmy.getNaijiu();
        if (carhp > perRow)
          carhp = perRow; 
        battleArmy.setCarHp(carhp);
        battleArmy.setCarMaxHp(campArmy.getSiCheGeZi() * campArmy.getNaijiu());
        battleArmy.setBigGzNum(campArmy.getSiCheGeZi());
      } else {
        int carhp = campArmy.getHujia();
        if (carhp > perRow)
          carhp = perRow; 
        battleArmy.setHuJia(carhp);
        battleArmy.setCarHp(carhp);
        battleArmy.setCarMaxHp(campArmy.getCarMaxHp());
        battleArmy.setBigGzNum(campArmy.getBigGzNum());
      } 
    } else if (campArmy.catapultskill == 2) {
      battleArmy.setZhanchedun(1);
      int carhp = campArmy.getCarHp();
      if (campArmy.generalId == 275 && campArmy.isjuexing > 0 && (battle.terrainVal == 1 || battle.terrainVal == 4)) {
        if (carhp > perRow)
          carhp = perRow; 
        battleArmy.setZCdunHp(carhp);
      } else {
        if (carhp > perRow)
          carhp = perRow; 
        battleArmy.setMaxShield(campArmy.getCarHp());
        battleArmy.setShield(carhp);
        battleArmy.setShiledType(2);
      } 
      battleArmy.setNaiJiu(campArmy.getNaijiu());
      battleArmy.setCarHp(carhp);
      battleArmy.setCarMaxHp(campArmy.getCarMaxHp());
      battleArmy.setBigGzNum(campArmy.getBigGzNum());
    } 
    battleArmy.setCatapultSkill(campArmy.getCatapultSkill());
    battleArmy.setPosition(batQNum.getAndIncrement());
    for (int i = 0; i < 3; i++)
      battleArmy.setBloodOrg(battleArmy.getTroopHp()[i] = perRow); 
    int curStrategy = 0;
    if (campArmy.isPhantom) {
      if (campArmy.curStrategy == 0) {
        curStrategy = campArmy.getStrategies()[WebUtil.nextInt((campArmy.getStrategies()).length)];
        campArmy.curStrategy = curStrategy;
      } else {
        curStrategy = campArmy.curStrategy;
      } 
    } else {
      curStrategy = campArmy.getStrategies()[WebUtil.nextInt((campArmy.getStrategies()).length)];
    } 
    if (campArmy.sanzhenbao > 0 && campArmy.armyHp <= perRow && campArmy.isDeputy <= 0)
      if (campArmy.qizhenbao > 0) {
        battleArmy.setIsDajiang(2);
      } else {
        battleArmy.setIsDajiang(1);
      }  
    if (campArmy.generalId == 273 && campArmy.isjuexing <= 0)
      battleArmy.setZhenXiaHouYuan(3); 
    battleArmy.setStrategy(curStrategy);
    if (campArmy.generalId == 230 && campArmy.isjuexing > 0 && battle.getTerrainVal() == 3)
      battleArmy.setGlShuiBao(1); 
    if (campArmy.hasbigformationskill > 0 && campArmy.formationtype == 3)
      if (leftrow >= 5) {
        battleArmy.setZhenFaJianShang(1.0D);
      } else if (leftrow >= 4) {
        if (campArmy.formationLevel >= 100) {
          battleArmy.setZhenFaJianShang(0.9D);
        } else if (campArmy.formationLevel >= 800) {
          battleArmy.setZhenFaJianShang(0.9D);
        } else if (campArmy.formationLevel >= 500) {
          battleArmy.setZhenFaJianShang(0.9D);
        } else if (campArmy.formationLevel >= 100) {
          battleArmy.setZhenFaJianShang(0.9D);
        } else if (campArmy.formationLevel >= 80) {
          battleArmy.setZhenFaJianShang(0.9D);
        } else if (campArmy.formationLevel >= 50) {
          battleArmy.setZhenFaJianShang(0.7D);
        } else if (campArmy.formationLevel >= 20) {
          battleArmy.setZhenFaJianShang(0.6D);
        } 
      } else if (leftrow >= 3) {
        if (campArmy.formationLevel >= 100) {
          battleArmy.setZhenFaJianShang(0.9D);
        } else if (campArmy.formationLevel >= 800) {
          battleArmy.setZhenFaJianShang(0.9D);
        } else if (campArmy.formationLevel >= 500) {
          battleArmy.setZhenFaJianShang(0.9D);
        } else if (campArmy.formationLevel >= 100) {
          battleArmy.setZhenFaJianShang(0.9D);
        } else if (campArmy.formationLevel >= 80) {
          battleArmy.setZhenFaJianShang(0.9D);
        } else if (campArmy.formationLevel >= 50) {
          battleArmy.setZhenFaJianShang(0.7D);
        } else if (campArmy.formationLevel >= 20) {
          battleArmy.setZhenFaJianShang(0.6D);
        } 
      } else if (leftrow >= 2) {
        if (campArmy.formationLevel >= 100) {
          battleArmy.setZhenFaJianShang(0.9D);
        } else if (campArmy.formationLevel >= 800) {
          battleArmy.setZhenFaJianShang(0.9D);
        } else if (campArmy.formationLevel >= 500) {
          battleArmy.setZhenFaJianShang(0.9D);
        } else if (campArmy.formationLevel >= 100) {
          battleArmy.setZhenFaJianShang(0.9D);
        } else if (campArmy.formationLevel >= 80) {
          battleArmy.setZhenFaJianShang(0.9D);
        } else if (campArmy.formationLevel >= 50) {
          battleArmy.setZhenFaJianShang(0.7D);
        } else if (campArmy.formationLevel >= 20) {
          battleArmy.setZhenFaJianShang(0.6D);
        } 
      } else {
        battleArmy.setZhenFaJianShang(0.1D);
      }  
    if (campArmy.generalId == 211 && campArmy.isjuexing > 0)
      battleArmy.setBaiBuChuanYang(1); 
    if (battleArmy.getIsDajiang() > 0 || campArmy.ismain > 0) {
      battleArmy.setZfShiled(campArmy.getzfShield());
      battleArmy.setQiZhenBao(campArmy.getQiZhenbao());
    } 
    if (campArmy.getGeneralId() == 208 && campArmy.getIsJuexing() > 0 && !battleArmy.getHaveZhanChe()) {
      battleArmy.setShield(battleArmy.getTroopHp()[0]);
      battleArmy.setMaxShield(battleArmy.getTroopHp()[0]);
      battleArmy.setShiledType(1);
    } 
    if (campArmy.getGeneralId() == 281 && campArmy.getSunceYubao1() && campArmy.getLegendEvoke())
      battleArmy.setHuShou(1); 
    battleArmy.setYubaoEffect(campArmy.getYubaoEffect());
    boolean isssx = false;
    if (campArmy.getGeneralId() == 402 && campArmy.getIsJuexing() > 0)
      isssx = true; 
    if (campArmy.getHelpGeneral() == 402 && campArmy.getHelpIsJuexing() > 0)
      isssx = true; 
    if (isssx && hushou) {
      battleArmy.setYubaoEffect(2);
      battleArmy.setHuShou(2);
      campArmy.setSdqs(1);
    } 
    attAddQlist.add(battleArmy);
    attList.add(battleArmy);
    campArmy.setXinBingShangZhen(1);
    if (campArmy.getGeneralId() == 276 && campArmy.getHelpGeneral() == 403)
      campArmy.tacticVal++; 
    return battleArmy;
  }
  
  public boolean canAddQueues(List<BattleArmy[]> attList, CampArmy campArmy) {
    if (campArmy.armyHp >= campArmy.maxForces * 0.05D) {
      for (BattleArmy[] bas : attList) {
        if (bas[0].getCampArmy().getId() == campArmy.getId())
          return false; 
      } 
      return true;
    } 
    return false;
  }
  
  public boolean canAddQueuesForDef(List<BattleArmy[]> battleList, CampArmy campArmy) {
    if (campArmy.armyHp >= campArmy.troopHp * 0.2D) {
      for (BattleArmy[] bas : battleList) {
        if (bas[0].getCampArmy().getId() == campArmy.getId())
          return false; 
      } 
      return true;
    } 
    return false;
  }
  
  public static void allFrocesToString(StringBuilder battleMsg, int reportType, String battleSide, BaseInfo baseInfo) {
    battleMsg.append(reportType).append("|").append(battleSide).append(";");
    battleMsg.append(baseInfo.num).append("|").append(baseInfo.allNum).append("#");
  }
  
  public static void getCurBattleTroop(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    roundInfo.troopData = new TroopData[2][3];
    copyAttCurBattleInfo(dataGetter, bat, roundInfo.troopData[0], roundInfo.attCampArmy, roundInfo.defCampArmy, roundInfo.attBattleArmy, bat.all_damage_e_att, !(!roundInfo.defCampArmy.isBarPhantom && !roundInfo.defCampArmy.isBarEA));
    copyDefCurBattleInfo(dataGetter, bat, roundInfo.troopData[1], roundInfo.attCampArmy, roundInfo.defCampArmy, roundInfo.defBattleArmy, bat.all_damage_e_def, !(!roundInfo.attCampArmy.isBarPhantom && !roundInfo.defCampArmy.isBarEA));
    if (bat.world_frontLine_buff_att_def_e_side == 1) {
      for (int i = 0; i < 3; i++)
        (roundInfo.troopData[0][i]).world_weaken_frontLine_buff = bat.world_frontLine_buff_att_def_e; 
    } else if (bat.world_frontLine_buff_att_def_e_side == 2) {
      for (int i = 0; i < 3; i++)
        (roundInfo.troopData[1][i]).world_weaken_frontLine_buff = bat.world_frontLine_buff_att_def_e; 
    } 
  }
  
  public static void copyAttCurBattleInfo(IDataGetter dataGetter, Battle bat, TroopData[] troopData, CampArmy attCampArmy, CampArmy defCampArmy, BattleArmy battleArmy, double all_damage_e, boolean vsSideIsBarPhantom) {
    int chariotAttack = 0;
    if (attCampArmy.getPlayerId() > 0)
      chariotAttack = dataGetter.getBattleDataCache().getChariotAttack(attCampArmy.getPlayerId()); 
    for (int i = 0; i < 3; i++) {
      TroopData tempData = new TroopData();
      tempData.troop_id = battleArmy.getCampArmy().getId();
      tempData.hp = battleArmy.getTroopHp()[i];
      tempData.att = attCampArmy.getAttEffect() + bat.att_gongji_base_add;
      tempData.def = attCampArmy.getDefEffect() + bat.att_fangyu_base_add;
      tempData.base_damage = attCampArmy.getBdEffect();
      tempData.generalId = attCampArmy.getGeneralId();
      tempData.attcoe = attCampArmy.getAttcoe();
      tempData.hujia = battleArmy.getHuJia();
      tempData.naijiu = attCampArmy.getNaijiu();
      tempData.pojia = attCampArmy.getPojia();
      tempData.baoji = attCampArmy.getBaoji();
      tempData.qianggong = attCampArmy.getQiangGong();
      tempData.xueliang = attCampArmy.getXueLiang();
      tempData.havezhanche = battleArmy.getHaveZhanChe();
      tempData.carskill = attCampArmy.getCatapultSkill();
      tempData.carid = attCampArmy.getCarId();
      tempData.zcdun = battleArmy.getZCdunHp();
      tempData.shield = battleArmy.getShield();
      tempData.chizhanfa = attCampArmy.getChiZhanFa();
      tempData.isjuexing = attCampArmy.getIsJuexing();
      tempData.yzdq = battleArmy.getYzdq();
      tempData.sex = attCampArmy.getSex();
      tempData.zfshield = battleArmy.getZfShiled();
      tempData.zsjqskilllevel = attCampArmy.getZsJqSkillLevel();
      tempData.kaishan = battleArmy.getKaiShan();
      tempData.dingjun = attCampArmy.getDingJun();
      tempData.ycbwpojia = attCampArmy.getYcbwPojia();
      tempData.zfbi = attCampArmy.getZhanFaBiLi();
      tempData.pingkan = attCampArmy.getPingKan();
      tempData.pingkandef = attCampArmy.getPingKanDef();
      tempData.resispercentage = attCampArmy.getResistePercentage().doubleValue();
      tempData.formationType = attCampArmy.getFormationType();
      tempData.formationBigSkill = attCampArmy.getHasbigFormationskill();
      tempData.lieyanhuixiang = battleArmy.getLieYanHuiXiang();
      tempData.lieyandamage = attCampArmy.getLieyandamage();
      tempData.defenseDown = attCampArmy.getDefenseDown();
      tempData.shanbigailv = attCampArmy.getShanBiGailv();
      tempData.yixuegailv = attCampArmy.getYiXueGaiLv();
      tempData.sangdantype = battleArmy.getSangDanType();
      tempData.wsb = attCampArmy.getWsb();
      tempData.czshinum = attCampArmy.getczshiNum();
      tempData.czshiround = attCampArmy.getczshiRound();
      tempData.missnum = attCampArmy.getMissNum();
      tempData.immunoNum = attCampArmy.getImmunoNum();
      tempData.isfanshang = attCampArmy.getIsFanShang();
      tempData.dikang = attCampArmy.getDiKang();
      tempData.tuchengatt = bat.getTuCheng();
      tempData.sunshangxiangzs = attCampArmy.getSunShangXiangZs();
      tempData.horsetype = attCampArmy.getHorseType();
      tempData.hushou = battleArmy.getHuShou();
      tempData.helpgeneral = attCampArmy.getHelpGeneral();
      if ((attCampArmy.getGeneralId() == 402 && attCampArmy.getIsJuexing() > 0) || (attCampArmy.getHelpGeneral() == 402 && attCampArmy.getHelpIsJuexing() > 0))
        tempData.sdqs = 1; 
      tempData.machaofrank = 1 + attCampArmy.getFormationLevel() / 20;
      tempData.glshuibao = battleArmy.getGlShuiBao();
      tempData.erzhenbao = attCampArmy.getErZhenBao();
      tempData.sanzhenbao = attCampArmy.getSanZhenbao();
      tempData.sizhenbao = attCampArmy.getSiZhenbao();
      if (battleArmy.getIsDajiang() > 0 || attCampArmy.getIsMain() > 0)
        tempData.qizhenbao = battleArmy.getQiZhenBao(); 
      tempData.jiuzhenbao = attCampArmy.getJiuZhenbao();
      tempData.tenzhenbao = attCampArmy.getTenZhenBao();
      if (attCampArmy.getAttDef_B() != null) {
        tempData.ATT_B = (attCampArmy.getAttDef_B()).ATT_B;
        tempData.DEF_B = (attCampArmy.getAttDef_B()).DEF_B;
      } 
      tempData.Str = attCampArmy.getStrength();
      tempData.Lea = attCampArmy.getLeader();
      tempData.max_hp = attCampArmy.getTroopHp() / 3;
      if (defCampArmy.specialGeneral.generalType == 11) {
        tempData.terrain_effect = 0.0D;
      } else {
        tempData.terrain_effect = attCampArmy.getTerrain();
      } 
      tempData.all_damage_e = all_damage_e;
      tempData.world_legion_e = attCampArmy.getTeamEffect();
      if (attCampArmy.specialGeneral.generalType == 2) {
        tempData.isFS = true;
        tempData.world_fs_d = (int)attCampArmy.specialGeneral.param;
        if (tempData.world_fs_d <= 0)
          tempData.isFS = false; 
      } else {
        tempData.isFS = false;
        tempData.world_fs_d = 0;
      } 
      if (attCampArmy.specialGeneral.generalType == 3 && vsSideIsBarPhantom) {
        tempData.isMz = true;
        tempData.world_mz_e = attCampArmy.specialGeneral.param;
      } else {
        tempData.isMz = false;
        tempData.world_mz_e = 0.0D;
      } 
      if (attCampArmy.specialGeneral.generalType == 6 && (bat.getBattleType() == 3 || bat.getBattleType() == 13)) {
        tempData.isBS = true;
        tempData.BS_My = bat.attCamp.size();
        tempData.BS_Your = bat.defCamp.size();
      } 
      tempData.attackLevel = attCampArmy.getAttackLevel();
      tempData.buqu = attCampArmy.getBuQu();
      Map<Integer, Double> playerGemAttribute = dataGetter.getBattleDataCache().getGemAttribute(attCampArmy.getPlayerId());
      if (playerGemAttribute == null || playerGemAttribute.isEmpty()) {
        troopData[i] = tempData;
      } else {
        if (bat.getBattleType() == 13 || bat.getBattleType() == 15 || bat.getBattleType() == 19)
          tempData.JS_SKILL_dt = ((Double)playerGemAttribute.get(Integer.valueOf(5))).doubleValue(); 
        tempData.JS_SKILL_ms = ((Double)playerGemAttribute.get(Integer.valueOf(1))).doubleValue();
        tempData.JS_SKILL_bj = ((Double)playerGemAttribute.get(Integer.valueOf(2))).doubleValue();
        tempData.JS_SKILL_att = ((Double)playerGemAttribute.get(Integer.valueOf(7))).doubleValue();
        troopData[i] = tempData;
      } 
      if (defCampArmy.troopSerial == 5) {
        tempData.bubingdamage = attCampArmy.bubingdamage;
      } else if (defCampArmy.troopSerial == 6) {
        tempData.qibingdamage = attCampArmy.qibingdamage;
      } else if (defCampArmy.troopSerial == 7) {
        tempData.gongbingdamage = attCampArmy.gongbingdamage;
      } 
      if (bat.terrainVal == 1) {
        tempData.pingyuandamage = attCampArmy.pingyuandamage;
      } else if (bat.terrainVal == 2) {
        tempData.shandidamage = attCampArmy.shandidamage;
      } else if (bat.terrainVal == 3) {
        tempData.shuiyudamage = attCampArmy.shuiyudamage;
      } 
      tempData.zhenfajianshang = battleArmy.getZhenFaJianShang();
      tempData.baqi1 = attCampArmy.getBaQi1();
      tempData.baqi2 = attCampArmy.getBaQi2();
      tempData.baqi3 = attCampArmy.getBaQi3();
      tempData.baqi = attCampArmy.getBaQiNum();
      tempData.buff = attCampArmy.getBuff();
      tempData.pos = battleArmy.getPosition();
      tempData.paytotal = attCampArmy.getPayTotal();
      tempData.shiledtype = battleArmy.getShiledType();
      tempData.unionrank = attCampArmy.getUnionRank();
      tempData.baojigailv = attCampArmy.getBaoJiGaiLv();
      tempData.hunluan = battleArmy.getSpecial();
      tempData.qincheng = battleArmy.getQingCheng();
      tempData.havezscy = attCampArmy.getHaveZscy();
      tempData.huwei = battleArmy.getHuWei();
      tempData.baguaattack = battleArmy.getBaGuaAttack();
      tempData.baguabaoji = battleArmy.getBaGuaBaoji();
      tempData.baguafangyu = battleArmy.getBaGuaFangYu();
      tempData.baguadun = battleArmy.getBaGuaDun();
      tempData.cardebuff = battleArmy.getCardebuff();
      tempData.defense = attCampArmy.getDefence();
      tempData.isbeatmonster = attCampArmy.getIsBeatMonster();
      tempData.dwnum = attCampArmy.getDwNum();
      tempData.yongmeng = attCampArmy.getAttack();
      tempData.zynum = battleArmy.getZyNum();
      tempData.legendSkill = attCampArmy.getLegendSkill();
      tempData.juejingzhilong = attCampArmy.getJueJingZhiLong();
      tempData.troopType = attCampArmy.getTroopType();
      tempData.hpOrg = attCampArmy.getArmyHpOrg();
      tempData.legeneEvoke = attCampArmy.getLegendEvoke();
      tempData.chariotAttack = chariotAttack;
    } 
  }
  
  public static void copyDefCurBattleInfo(IDataGetter dataGetter, Battle bat, TroopData[] troopData, CampArmy attCampArmy, CampArmy defCampArmy, BattleArmy battleArmy, double all_damage_e, boolean vsSideIsBarPhantom) {
    int chariotAttack = 0;
    if (defCampArmy.getPlayerId() > 0)
      chariotAttack = dataGetter.getBattleDataCache().getChariotAttack(defCampArmy.getPlayerId()); 
    for (int i = 0; i < 3; i++) {
      TroopData tempData = new TroopData();
      tempData.troop_id = battleArmy.getCampArmy().getId();
      tempData.hp = battleArmy.getTroopHp()[i];
      tempData.att = defCampArmy.getAttEffect() + bat.def_gongji_base_add;
      tempData.def = defCampArmy.getDefEffect() + bat.def_fangyu_base_add;
      tempData.base_damage = defCampArmy.getBdEffect();
      tempData.generalId = defCampArmy.getGeneralId();
      if (defCampArmy.getAttDef_B() != null) {
        tempData.ATT_B = (defCampArmy.getAttDef_B()).ATT_B;
        tempData.DEF_B = (defCampArmy.getAttDef_B()).DEF_B;
      } 
      tempData.attcoe = defCampArmy.getAttcoe();
      tempData.hujia = battleArmy.getHuJia();
      tempData.naijiu = defCampArmy.getNaijiu();
      tempData.pojia = defCampArmy.getPojia();
      tempData.baoji = defCampArmy.getBaoji();
      tempData.qianggong = defCampArmy.getQiangGong();
      tempData.xueliang = defCampArmy.getXueLiang();
      tempData.havezhanche = battleArmy.getHaveZhanChe();
      tempData.carskill = defCampArmy.getCatapultSkill();
      tempData.carid = defCampArmy.getCarId();
      tempData.zcdun = battleArmy.getZCdunHp();
      tempData.shield = battleArmy.getShield();
      tempData.chizhanfa = defCampArmy.getChiZhanFa();
      tempData.isjuexing = defCampArmy.getIsJuexing();
      tempData.yzdq = battleArmy.getYzdq();
      tempData.sex = defCampArmy.getSex();
      tempData.zfshield = battleArmy.getZfShiled();
      tempData.zsjqskilllevel = defCampArmy.getZsJqSkillLevel();
      tempData.kaishan = battleArmy.getKaiShan();
      tempData.dingjun = defCampArmy.getDingJun();
      tempData.ycbwpojia = defCampArmy.getYcbwPojia();
      tempData.zfbi = defCampArmy.getZhanFaBiLi();
      tempData.pingkan = defCampArmy.getPingKan();
      tempData.pingkandef = defCampArmy.getPingKanDef();
      tempData.resispercentage = defCampArmy.getResistePercentage().doubleValue();
      tempData.formationType = defCampArmy.getFormationType();
      tempData.formationBigSkill = defCampArmy.getHasbigFormationskill();
      tempData.lieyanhuixiang = battleArmy.getLieYanHuiXiang();
      tempData.lieyandamage = defCampArmy.getLieyandamage();
      tempData.defenseDown = defCampArmy.getDefenseDown();
      tempData.shanbigailv = defCampArmy.getShanBiGailv();
      tempData.yixuegailv = defCampArmy.getYiXueGaiLv();
      tempData.sangdantype = battleArmy.getSangDanType();
      tempData.wsb = defCampArmy.getWsb();
      tempData.czshinum = defCampArmy.getczshiNum();
      tempData.czshiround = defCampArmy.getczshiRound();
      tempData.missnum = defCampArmy.getMissNum();
      tempData.immunoNum = defCampArmy.getImmunoNum();
      tempData.isfanshang = defCampArmy.getIsFanShang();
      tempData.dikang = defCampArmy.getDiKang();
      tempData.sunshangxiangzs = defCampArmy.getSunShangXiangZs();
      tempData.horsetype = defCampArmy.getHorseType();
      tempData.hushou = battleArmy.getHuShou();
      tempData.helpgeneral = defCampArmy.getHelpGeneral();
      if ((defCampArmy.getGeneralId() == 402 && defCampArmy.getIsJuexing() > 0) || (defCampArmy.getHelpGeneral() == 402 && defCampArmy.getHelpIsJuexing() > 0))
        tempData.sdqs = 1; 
      tempData.machaofrank = 1 + defCampArmy.getFormationLevel() / 20;
      tempData.glshuibao = battleArmy.getGlShuiBao();
      tempData.erzhenbao = defCampArmy.getErZhenBao();
      tempData.sanzhenbao = defCampArmy.getSanZhenbao();
      tempData.sizhenbao = defCampArmy.getSiZhenbao();
      if (battleArmy.getIsDajiang() > 0 || defCampArmy.getIsMain() > 0)
        tempData.qizhenbao = battleArmy.getQiZhenBao(); 
      tempData.jiuzhenbao = defCampArmy.getJiuZhenbao();
      tempData.tenzhenbao = defCampArmy.getTenZhenBao();
      tempData.Str = defCampArmy.getStrength();
      tempData.Lea = defCampArmy.getLeader();
      tempData.max_hp = defCampArmy.getTroopHp() / 3;
      if (attCampArmy.specialGeneral.generalType == 11) {
        tempData.terrain_effect = 0.0D;
      } else {
        tempData.terrain_effect = defCampArmy.getTerrain();
      } 
      tempData.all_damage_e = all_damage_e;
      tempData.world_weaken_besiege = bat.world_weaken_besiege_e;
      tempData.world_legion_e = defCampArmy.getTeamEffect();
      if (defCampArmy.specialGeneral.generalType == 2) {
        tempData.isFS = true;
        tempData.world_fs_d = (int)defCampArmy.specialGeneral.param;
        if (tempData.world_fs_d <= 0)
          tempData.isFS = false; 
      } else {
        tempData.isFS = false;
        tempData.world_fs_d = 0;
      } 
      if (defCampArmy.specialGeneral.generalType == 3 && vsSideIsBarPhantom) {
        tempData.isMz = true;
        tempData.world_mz_e = defCampArmy.specialGeneral.param;
      } else {
        tempData.isMz = false;
        tempData.world_mz_e = 0.0D;
      } 
      if (defCampArmy.specialGeneral.generalType == 6 && (bat.getBattleType() == 3 || bat.getBattleType() == 13)) {
        tempData.isBS = true;
        tempData.BS_My = bat.defCamp.size();
        tempData.BS_Your = bat.attCamp.size();
      } 
      tempData.attackLevel = defCampArmy.getAttackLevel();
      tempData.buqu = defCampArmy.getBuQu();
      Map<Integer, Double> playerGemAttribute = dataGetter.getBattleDataCache().getGemAttribute(defCampArmy.getPlayerId());
      if (playerGemAttribute == null || playerGemAttribute.isEmpty()) {
        troopData[i] = tempData;
      } else {
        if (bat.getBattleType() == 13 || bat.getBattleType() == 15 || bat.getBattleType() == 19)
          tempData.JS_SKILL_dt = ((Double)playerGemAttribute.get(Integer.valueOf(5))).doubleValue(); 
        tempData.JS_SKILL_ms = ((Double)playerGemAttribute.get(Integer.valueOf(1))).doubleValue();
        tempData.JS_SKILL_bj = ((Double)playerGemAttribute.get(Integer.valueOf(2))).doubleValue();
        tempData.JS_SKILL_def = ((Double)playerGemAttribute.get(Integer.valueOf(6))).doubleValue();
        troopData[i] = tempData;
      } 
      if (attCampArmy.troopSerial == 5) {
        tempData.bubingdamage = defCampArmy.bubingdamage;
      } else if (attCampArmy.troopSerial == 6) {
        tempData.qibingdamage = defCampArmy.qibingdamage;
      } else if (attCampArmy.troopSerial == 7) {
        tempData.gongbingdamage = defCampArmy.gongbingdamage;
      } 
      if (bat.terrainVal == 1) {
        tempData.pingyuandamage = defCampArmy.pingyuandamage;
      } else if (bat.terrainVal == 2) {
        tempData.shandidamage = defCampArmy.shandidamage;
      } else if (bat.terrainVal == 3) {
        tempData.shuiyudamage = defCampArmy.shuiyudamage;
      } 
      tempData.zhenfajianshang = battleArmy.getZhenFaJianShang();
      tempData.baqi1 = defCampArmy.getBaQi1();
      tempData.baqi2 = defCampArmy.getBaQi2();
      tempData.baqi3 = defCampArmy.getBaQi3();
      tempData.baqi = defCampArmy.getBaQiNum();
      tempData.buff = defCampArmy.getBuff();
      tempData.pos = battleArmy.getPosition();
      tempData.paytotal = defCampArmy.getPayTotal();
      tempData.shiledtype = battleArmy.getShiledType();
      tempData.unionrank = defCampArmy.getUnionRank();
      tempData.baojigailv = defCampArmy.getBaoJiGaiLv();
      tempData.hunluan = battleArmy.getSpecial();
      tempData.qincheng = battleArmy.getQingCheng();
      tempData.havezscy = defCampArmy.getHaveZscy();
      tempData.huwei = battleArmy.getHuWei();
      tempData.baguaattack = battleArmy.getBaGuaAttack();
      tempData.baguabaoji = battleArmy.getBaGuaBaoji();
      tempData.baguafangyu = battleArmy.getBaGuaFangYu();
      tempData.baguadun = battleArmy.getBaGuaDun();
      tempData.cardebuff = battleArmy.getCardebuff();
      tempData.defense = defCampArmy.getDefence();
      tempData.isbeatmonster = defCampArmy.getIsBeatMonster();
      tempData.dwnum = defCampArmy.getDwNum();
      tempData.yongmeng = defCampArmy.getAttack();
      tempData.zynum = battleArmy.getZyNum();
      tempData.legendSkill = defCampArmy.getLegendSkill();
      tempData.juejingzhilong = defCampArmy.getJueJingZhiLong();
      tempData.troopType = defCampArmy.getTroopType();
      tempData.hpOrg = defCampArmy.getArmyHpOrg();
      tempData.legeneEvoke = defCampArmy.getLegendEvoke();
      tempData.chariotAttack = chariotAttack;
    } 
  }
  
  public int isBattleEnd(IDataGetter dataGetter, Battle bat) {
    int aQLsize = bat.attList.size();
    int dQLsize = bat.defList.size();
    if (aQLsize < 1 && dQLsize < 1)
      return 4; 
    if (aQLsize < 1)
      return 2; 
    if (dQLsize < 1)
      return 3; 
    return 1;
  }
  
  public void sendBattleCityEndInfo(IDataGetter dataGetter, Battle bat) {}
  
  public String getAttTargetName(IDataGetter dataGetter, Battle bat) {
    Armies armies = (Armies)dataGetter.getArmiesCache().get(Integer.valueOf(bat.getDefBaseInfo().getId()));
    return armies.getName();
  }
  
  public int battleRewardSave(boolean attWin, int playerId, PlayerInfo pi, Date date, IDataGetter dataGetter, BattleResult battleResult, Battle bat) {
    PlayerBattleReward pbr = new PlayerBattleReward();
    pbr.setPlayerId(Integer.valueOf(playerId));
    pbr.setGainTime(date);
    pbr.setGExp(Integer.valueOf(0));
    if (bat.getBattleType() == 2 || bat.getBattleType() == 5) {
      pbr.setType(Integer.valueOf(1));
    } else {
      pbr.setType(Integer.valueOf(bat.getBattleType()));
    } 
    pbr.setAttLost(Integer.valueOf(pi.lostTotal));
    pbr.setDefLost(Integer.valueOf(pi.killTotal));
    pbr.setWinSide(Integer.valueOf(2));
    if (pi.isAttSide && attWin)
      pbr.setWinSide(Integer.valueOf(1)); 
    if (!pi.isAttSide && !attWin)
      pbr.setWinSide(Integer.valueOf(1)); 
    pbr.setDefId(Integer.valueOf(bat.getDefBaseInfo().getId()));
    pbr.setAttForceId(Integer.valueOf(bat.getAttBaseInfo().getForceId()));
    if (bat.isNpc) {
      pbr.setDefForceId(Integer.valueOf(0));
    } else {
      pbr.setDefForceId(Integer.valueOf(bat.getDefBaseInfo().getForceId()));
    } 
    pbr.setTerrain(Integer.valueOf(bat.terrain));
    pbr.setMaxKillGnum(Integer.valueOf(pi.maxKillG));
    StringBuilder rbReward = new StringBuilder();
    rbReward.append(pi.rbType).append("#").append(pi.rbTotal).append("#").append(pi.rbTop);
    pbr.setRbReward(rbReward.toString());
    pbr.setGeneralIds("");
    dataGetter.getPlayerBattleRewardDao().create(pbr);
    return pbr.getVId().intValue();
  }
  
  public void getExReward(boolean attWin, IDataGetter dataGetter, PlayerInfo pi, Battle bat) {}
  
  public String getDefName(IDataGetter dataGetter, int defId) {
    return "null";
  }
  
  public static void getReportType13(Battle battle, StringBuilder battleMsg) {
    List<CampArmy> attCaList = new ArrayList<>();
    List<CampArmy> defCaList = new ArrayList<>();
    Set<CampArmy> attOnQueueSet = new HashSet<>();
    Set<CampArmy> defOnQueueSet = new HashSet<>();
    Set<CampArmy> newlyJoinSet = new HashSet<>();
    for (BattleArmy ba : battle.attList) {
      CampArmy ca = ba.getCampArmy();
      if (!attOnQueueSet.contains(ca)) {
        attOnQueueSet.add(ca);
        if (ca.getIsDeputy() > 0)
          continue; 
        attCaList.add(ba.getCampArmy());
      } 
    } 
    for (BattleArmy ba : battle.defList) {
      CampArmy ca = ba.getCampArmy();
      if (!defOnQueueSet.contains(ca)) {
        defOnQueueSet.add(ca);
        if (ca.getIsDeputy() > 0)
          continue; 
        defCaList.add(ca);
      } 
    } 
    boolean attNeedPush = false;
    boolean defNeedPush = false;
    int attListSize = battle.getAttList().size();
    int defListSize = battle.getDefList().size();
    int lastAttOnQueuePos = 0;
    int lastDefOnQueuePos = 0;
    if (attListSize > 0)
      lastAttOnQueuePos = ((BattleArmy)battle.attList.get(attListSize - 1)).getPosition(); 
    if (defListSize > 0)
      lastDefOnQueuePos = ((BattleArmy)battle.defList.get(defListSize - 1)).getPosition(); 
    if (lastAttOnQueuePos != battle.lastAttOnQueuePosId) {
      battle.lastAttOnQueuePosId = lastAttOnQueuePos;
      attNeedPush = true;
    } 
    if (lastDefOnQueuePos != battle.lastDefOnQueuePosId) {
      battle.lastDefOnQueuePosId = lastDefOnQueuePos;
      defNeedPush = true;
    } 
    for (CampArmy ca2 : battle.attCamp) {
      if (ca2.getArmyHp() > 0 && !attOnQueueSet.contains(ca2) && ca2.getIsDeputy() <= 0)
        attCaList.add(ca2); 
    } 
    for (CampArmy ca2 : battle.defCamp) {
      if (ca2.getArmyHp() > 0 && !defOnQueueSet.contains(ca2) && ca2.getIsDeputy() <= 0)
        defCaList.add(ca2); 
    } 
    newlyJoinSet = battle.newlyJoinSet;
    battle.newlyJoinSet = new HashSet();
    if (attOnQueueSet.size() > 0 || defOnQueueSet.size() > 0 || newlyJoinSet.size() > 0) {
      battleMsg.append(13).append("|");
      if (attOnQueueSet.size() > 0 && attNeedPush) {
        int i = 0;
        for (CampArmy ca3 : attOnQueueSet) {
          int playerId = ca3.getPlayerId();
          if (ca3.isPhantom)
            playerId = -playerId; 
          battleMsg.append(i + 1).append(",").append(playerId).append(",").append(ca3.getPlayerName()).append(",").append(ca3.getGeneralName()).append(",").append(ca3.getQuality()).append(",").append(1).append(",").append(0).append(",").append(0).append(",").append(ca3.isPhantom() ? 1 : 0).append(",").append(ca3.getForceId()).append(";");
          i++;
        } 
        battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "|");
      } else {
        battleMsg.append("null").append("|");
      } 
      int j = 0;
      if (defOnQueueSet.size() > 0 && defNeedPush) {
        for (CampArmy ca3 : defOnQueueSet) {
          int playerId = ca3.getPlayerId();
          if (ca3.isPhantom)
            playerId = -playerId; 
          battleMsg.append(j + 1).append(",").append(playerId).append(",").append(ca3.getPlayerName()).append(",").append(ca3.getGeneralName()).append(",").append(ca3.getQuality()).append(",").append(1).append(",").append(0).append(",").append(1).append(",").append(ca3.isPhantom() ? 1 : 0).append(",").append(ca3.getForceId()).append(";");
          j++;
        } 
        battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "|");
      } else {
        battleMsg.append("null").append("|");
      } 
      if (newlyJoinSet.size() > 0) {
        int k = 0;
        for (CampArmy ca4 : newlyJoinSet) {
          int playerId2 = ca4.getPlayerId();
          int isPhantom = 0;
          if (ca4.isPhantom) {
            playerId2 = -playerId2;
            isPhantom = 1;
          } 
          int isDef = 0;
          if (ca4.getForceId() == battle.getDefBaseInfo().getForceId())
            isDef = 1; 
          battleMsg.append(k + 1).append(",").append(playerId2).append(",").append(ca4.getPlayerName()).append(",").append(ca4.getGeneralName()).append(",").append(ca4.getQuality()).append(",").append(0).append(",").append(1).append(",").append(isDef).append(",").append(isPhantom).append(",").append(ca4.getForceId()).append(";");
          k++;
        } 
        battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "|");
      } else {
        battleMsg.append("null").append("|");
      } 
      battleMsg.append(attCaList.size()).append("|").append(defCaList.size()).append("#");
    } 
  }
  
  public void updateGeneralDB(IDataGetter dataGetter, Battle bat, CampArmy ca, boolean attWin) {
    int state = 1;
    dataGetter.getPlayerGeneralMilitaryDao().restartRecruit(ca.getPlayerId(), ca.getGeneralId(), 1, new Date());
    dataGetter.getGeneralService().sendGmUpdate(ca.getPlayerId(), ca.getGeneralId(), bat.inSceneSet.contains(Integer.valueOf(ca.getPlayerId())));
  }
  
  public void endCampsDeal(IDataGetter dataGetter, Battle bat, BattleResult battleResult, boolean attWin) {
    int i = 1;
    for (CampArmy ca : bat.attCamp) {
      BattleSceneLog.getInstance().info("#batId:" + bat.getBattleId() + "_" + bat.getStartTime() + "#quit:" + (attWin ? "win" : "loss") + "#side:att" + "#playerId:" + ca.getPlayerId() + ":" + ca.isPhantom + "#general:" + ca.getGeneralId() + "#attSize:" + (bat.attCamp.size() - i));
      i++;
      endQuitNewBattle(ca, 1, bat);
      if (!bat.inBattlePlayers.containsKey(Integer.valueOf(ca.getPlayerId())))
        continue; 
      PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(ca.getPlayerId()));
      if (pi != null && ca.killGeneral > pi.maxKillG)
        pi.maxKillG = ca.killGeneral; 
      if (!ca.inBattle)
        continue; 
      if (ca.armyHp <= -1)
        continue; 
      updateGeneralDB(dataGetter, bat, ca, attWin);
    } 
    i = 1;
    for (CampArmy ca : bat.defCamp) {
      BattleSceneLog.getInstance().info("#batId:" + bat.getBattleId() + "_" + bat.getStartTime() + "#quit:" + (attWin ? "loss" : "win") + "#side:att" + "#playerId:" + ca.getPlayerId() + ":" + ca.isPhantom + "#general:" + ca.getGeneralId() + "#defSize:" + (bat.defCamp.size() - i));
      i++;
    } 
  }
  
  public void endBattle(int winSide, IDataGetter dataGetter, Battle bat) {
    boolean attWin = (winSide == 3);
    if (bat.battleType != 14)
      if (attWin && bat.getDefBaseInfo().getNum() != 0) {
        ErrorSceneLog.getInstance().appendErrorMsg("att Win，守方兵力不为0").appendClassName("Builder").appendMethodName("endBattle").append("battleId", bat.getBattleId()).append("defLeftForce", Integer.valueOf(bat.getDefBaseInfo().getNum())).flush();
      } else if (!attWin && bat.getAttBaseInfo().getNum() != 0) {
        ErrorSceneLog.getInstance().appendErrorMsg("def Win，攻方兵力不为0  ").appendClassName("Builder").appendMethodName("endBattle").append("battleId", bat.getBattleId()).append("attLeftForce", Integer.valueOf(bat.getAttBaseInfo().getNum())).flush();
      }  
    BattleResult battleResult = new BattleResult();
    gainExReward(attWin, battleResult, bat, dataGetter);
    countNpcReward(attWin, dataGetter, bat, battleResult);
    try {
      if (bat.getBattleType() != 3) {
        dataGetter.getBattleService().dealNextNpc(this, attWin, dataGetter, bat, battleResult);
      } else {
        dataGetter.getBattleService().dealNextNpcBuidler(this, attWin, dataGetter, bat, battleResult);
      } 
    } catch (Exception e) {
      ErrorSceneLog.getInstance().appendErrorMsg("dealNextNpc Exception").appendClassName(getClass().getName()).appendMethodName("dealNextNpc").append("attWin", Boolean.valueOf(attWin)).flush();
      ErrorSceneLog.getInstance().error("dealNextNpc Exception", e);
    } 
    endCampsDeal(dataGetter, bat, battleResult, attWin);
    try {
      dealTaskAfterWin(attWin, dataGetter, bat, battleResult);
    } catch (Exception e) {
      ErrorSceneLog.getInstance().error("dealTaskAfterWin Exception", e);
    } 
    endBattleMsg(attWin, battleResult, bat, dataGetter);
    deleteBattleInfo(dataGetter, bat);
    afterBat(attWin, dataGetter, bat);
    if (bat.getBattleType() == 3)
      dataGetter.getJobService().addJob("autoBattleService", "stopAutoBattleAfterBattleEnded", bat.getDefBaseInfo().getId(), System.currentTimeMillis(), false); 
    if (bat.getBattleType() == 3 || bat.getBattleType() == 13) {
      if (bat.getAttList().size() > 0 && ((BattleArmy)bat.getAttList().get(0)).getCampArmy().getIsBeatMonster() > 0 && ((BattleArmy)bat.getAttList().get(0)).getCampArmy().getBeastId() > 0 && attWin)
        dataGetter.getPlayerWarBeastDao().updateWarBeastStateAndCD(((BattleArmy)bat.getAttList().get(0)).getCampArmy().getPlayerId(), ((BattleArmy)bat.getAttList().get(0)).getCampArmy().getBeastId(), 0, new Date(System.currentTimeMillis() + 1800000L), new Date(System.currentTimeMillis())); 
      if (bat.getDefList().size() > 0 && ((BattleArmy)bat.getDefList().get(0)).getCampArmy().getIsBeatMonster() > 0 && ((BattleArmy)bat.getDefList().get(0)).getCampArmy().getBeastId() > 0 && !attWin)
        dataGetter.getPlayerWarBeastDao().updateWarBeastStateAndCD(((BattleArmy)bat.getDefList().get(0)).getCampArmy().getPlayerId(), ((BattleArmy)bat.getDefList().get(0)).getCampArmy().getBeastId(), 0, new Date(System.currentTimeMillis() + 1800000L), new Date(System.currentTimeMillis())); 
    } 
  }
  
  public void dealTaskAfterWin(boolean attWin, IDataGetter dataGetter, Battle bat, BattleResult battleResult) {}
  
  public void deleteBattleInfo(IDataGetter dataGetter, Battle bat) {
    dataGetter.getBattleService().dealTokenBattle(bat.getBattleId(), 0);
    dataGetter.getBattleInfoService().deleteBattle(bat);
  }
  
  public void afterBat(boolean attWin, IDataGetter dataGetter, Battle bat) {}
  
  public void dealNextNpc(boolean attWin, IDataGetter dataGetter, Battle bat, BattleResult battleResult) {
    Iterator<Integer> iterator = bat.inBattlePlayers.keySet().iterator();
    while (iterator.hasNext()) {
      int playerId = ((Integer)iterator.next()).intValue();
      PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(playerId));
      if (pi.isAttSide) {
        Armies curArmies = (Armies)dataGetter.getArmiesCache().get(Integer.valueOf(bat.defBaseInfo.getId()));
        if (attWin) {
          PlayerArmy pa = dataGetter.getPlayerArmyDao().getPlayerArmy(playerId, curArmies.getId().intValue());
          if (pa.getWinNum().intValue() < 1) {
            dealStuffAfterFirstWin(dataGetter, playerId, curArmies, pa);
            if (pa.getArmyId().intValue() >= 254 && pa.getArmyId().intValue() < 263) {
              String powerinfo = dataGetter.getPowerService().createBaiYiMap();
              powerinfo = String.valueOf(String.valueOf(powerinfo)) + "#" + "1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1" + "#" + "2,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0";
              dataGetter.getPlayerPowerDao().updatePowerInfo(playerId, 37, powerinfo);
              dataGetter.getPlayerBattleAttributeDao().reduceWhiteLine(playerId);
            } 
          } else {
            dataGetter.getPlayerArmyDao().updateAttackWinNum(playerId, curArmies.getId().intValue(), 1, 1);
          } 
          Armies nextArmies = dataGetter.getArmiesCache().getNextArmies(bat.defBaseInfo.getId());
          if (nextArmies != null)
            dataGetter.getPlayerArmyDao().updateAttackable(playerId, nextArmies.getId().intValue(), 1); 
          if (dataGetter.getArmiesCache().isLastArmies(bat.defBaseInfo.getId())) {
            Power power = (Power)dataGetter.getPowerCache().get(curArmies.getPowerId());
            dataGetter.getPlayerPowerDao().updateRewardState(playerId, curArmies.getPowerId().intValue(), 1);
            PlayerPower pp = dataGetter.getPlayerPowerDao().getPlayerPower(playerId, power.getNextPower().intValue());
            if (pp != null && pp.getAttackable().intValue() != 1)
              dataGetter.getPlayerPowerDao().updateAttackable(playerId, power.getNextPower().intValue(), 1); 
          } 
          TaskMessageHelper.sendBattleWinTaskMessage(playerId, bat.defBaseInfo.getId());
          dataGetter.getPlayerAttributeDao().addBattleWinTimes(playerId);
          Map<Integer, BattleDrop> dropMap = curArmies.getDropMap();
          if (dropMap == null)
            continue; 
          for (BattleDrop battleDrop : dropMap.values()) {
            if (battleDrop.type > 200 && battleDrop.type < 800) {
              Items dropItem = (Items)dataGetter.getItemsCache().get(Integer.valueOf(battleDrop.id));
              if (dropItem.getType().intValue() == 2) {
                if (pa.getDropCount().intValue() + battleDrop.num > battleDrop.limit)
                  continue; 
                int taskId = 0;
                String targrtPrefix = "collect," + battleDrop.id;
                for (Task task : dataGetter.getTaskCache().getModels()) {
                  if (task.getTarget().contains(targrtPrefix))
                    taskId = task.getId().intValue(); 
                } 
                PlayerTask playerTask = dataGetter.getPlayerTaskDao().getCurMainTask(playerId);
                if (playerTask == null || playerTask.getTaskId().intValue() != taskId)
                  continue; 
                if (WebUtil.nextDouble() >= battleDrop.pro)
                  continue; 
                dataGetter.getPlayerArmyDao().addDropCount(playerId, curArmies.getId().intValue(), battleDrop.num);
                dataGetter.getStoreHouseService().gainItems(playerId, battleDrop.num, battleDrop.id, LocalMessages.T_LOG_ITEM_1);
                pi.dropMap.put(Integer.valueOf(battleDrop.type), new BattleDrop(battleDrop));
                TaskMessageHelper.sendItemCollectTaskMessage(playerId, battleDrop.id);
                continue;
              } 
              if (dropItem.getType().intValue() != 3 && dropItem.getType().intValue() != 4)
                continue; 
              if (pa.getDropCount().intValue() + battleDrop.num > battleDrop.limit)
                continue; 
              try {
                if (WebUtil.nextDouble() >= battleDrop.pro)
                  continue; 
                dataGetter.getPlayerArmyDao().addDropCount(playerId, curArmies.getId().intValue(), battleDrop.num);
                dataGetter.getStoreHouseService().gainItems(playerId, battleDrop.num, battleDrop.id, LocalMessages.T_LOG_ITEM_1);
                pi.dropMap.put(Integer.valueOf(battleDrop.type), new BattleDrop(battleDrop));
              } catch (Exception e) {
                ErrorSceneLog.getInstance().appendErrorMsg("StoreHouseService gainItems Exception").appendClassName("Builder").appendMethodName("dealNextNpc").append("playerId", Integer.valueOf(playerId)).append("curArmies", curArmies.getName()).flush();
                ErrorSceneLog.getInstance().error("builder dealNextNpc 1 ", e);
              } 
              continue;
            } 
            if (battleDrop.type < 800)
              continue; 
            BuildingDrawing draw = (BuildingDrawing)dataGetter.getBuildingDrawingCache().get(Integer.valueOf(battleDrop.id));
            if (draw == null)
              continue; 
            try {
              if (!dataGetter.getBuildingService().dropBluePrintById(playerId, draw.getId().intValue()))
                continue; 
              pi.dropMap.put(Integer.valueOf(battleDrop.type), new BattleDrop(battleDrop));
            } catch (Exception e) {
              ErrorSceneLog.getInstance().appendErrorMsg("BuildingService dropBluePrintById Exception").appendClassName("Builder").appendMethodName("dealNextNpc").append("playerId", Integer.valueOf(playerId)).append("curArmies", curArmies.getName()).append("BuildingDrawing", draw.getId()).flush();
              ErrorSceneLog.getInstance().error("builder dealNextNpc 2 ", e);
            } 
          } 
          continue;
        } 
        dataGetter.getPlayerArmyDao().updateAttNum(playerId, curArmies.getId().intValue(), 1);
      } 
    } 
  }
  
  public void dealStuffAfterFirstWin(IDataGetter dataGetter, int playerId, Armies curArmies, PlayerArmy pa) {
    if (curArmies.getType().intValue() == 2)
      dataGetter.getCourtesyService().addPlayerEvent(playerId, 4, 0); 
    dataGetter.getPlayerArmyDao().updateAttackWin(playerId, curArmies.getId().intValue(), 1, 1, 1);
    if (curArmies.getId().intValue() == 1000105) {
      PlayerDto playerDto = new PlayerDto(playerId);
      playerDto.playerLv = 200;
      dataGetter.getTreasureService().tryGetGeneralTreasure(playerDto, 104, false, 0, 0, true, "副本活动获得青钢剑");
    } 
    if (curArmies != null && dataGetter.getArmiesCache().getHasGold().contains(curArmies.getId()))
      dataGetter.getPlayerArmyDao().updateGoldReward(playerId, curArmies.getId().intValue(), 1); 
    dataGetter.getPlayerDao().updateMaxLv(playerId, curArmies.getLevel().intValue() + 10);
    if (pa.getArmyId().intValue() == 31) {
      dataGetter.getPlayerBattleAttributeDao().updateArmiesAutoCount(playerId, 5);
    } else if (pa.getArmyId().intValue() == 41) {
      dataGetter.getPlayerBattleAttributeDao().updateArmiesAutoCount(playerId, 10);
    } else if (pa.getArmyId().intValue() == 50) {
      dataGetter.getPlayerBattleAttributeDao().updateArmiesAutoCount(playerId, 99);
    } 
    Map<Integer, BattleDrop> dropMap = curArmies.getDropMap();
    if (dropMap != null) {
      BattleDrop battleDrop = dropMap.get(Integer.valueOf(103));
      int rewardNpcId = 0;
      if (battleDrop != null)
        rewardNpcId = battleDrop.id; 
      if (rewardNpcId != 0) {
        PlayerArmyReward playerArmyReward = dataGetter.getPlayerArmyRewardDao().getPlayerArmyRewardByArmyId(playerId, rewardNpcId);
        if (playerArmyReward == null) {
          playerArmyReward = new PlayerArmyReward();
          playerArmyReward.setPlayerId(Integer.valueOf(playerId));
          playerArmyReward.setPowerId(curArmies.getPowerId());
          playerArmyReward.setArmyId(Integer.valueOf(rewardNpcId));
          playerArmyReward.setFirst(Integer.valueOf(1));
          int miniuteNum = ((ArmiesReward)dataGetter.getArmiesRewardCache().get(Integer.valueOf(rewardNpcId))).getTime().intValue();
          playerArmyReward.setExpireTime(new Date(System.currentTimeMillis() + miniuteNum * 60000L));
          playerArmyReward.setNpcLost(null);
          int num = OneVsRewardNpcBuilder.getMaxHp(dataGetter, rewardNpcId);
          playerArmyReward.setHp(Integer.valueOf(num));
          playerArmyReward.setHpMax(Integer.valueOf(num));
          playerArmyReward.setState(Integer.valueOf(0));
          playerArmyReward.setBuyCount(Integer.valueOf(0));
          playerArmyReward.setFirstWin(Integer.valueOf(0));
          playerArmyReward.setWinCount(Integer.valueOf(0));
          playerArmyReward.setFreeCount("");
          dataGetter.getPlayerArmyRewardDao().create(playerArmyReward);
        } 
      } 
      battleDrop = dropMap.get(Integer.valueOf(104));
      int extraPowerId = 0;
      if (battleDrop != null)
        extraPowerId = battleDrop.id; 
      if (extraPowerId != 0)
        dealExtraPower(dataGetter, playerId, extraPowerId); 
      battleDrop = dropMap.get(Integer.valueOf(102));
      int techId = 0;
      if (battleDrop != null)
        techId = battleDrop.id; 
      if (techId != 0)
        try {
          dataGetter.getTechService().dropTech(playerId, techId);
        } catch (Exception e) {
          ErrorSceneLog.getInstance().appendErrorMsg("TechService dropTech Exception").appendClassName("Builder").appendMethodName("dealStuffAfterFirstWin").append("playerId", Integer.valueOf(playerId)).append("techId", Integer.valueOf(techId)).flush();
          ErrorSceneLog.getInstance().error("dealStuffAfterFirstWin 1", e);
        }  
      battleDrop = dropMap.get(Integer.valueOf(105));
      int juBenId = 0;
      if (battleDrop != null)
        juBenId = battleDrop.id; 
      if (juBenId != 0)
        try {
          dataGetter.getJuBenService().openNextJuBen(playerId, juBenId);
        } catch (Exception e2) {
          ErrorSceneLog.getInstance().appendErrorMsg("JuBenService openNextJuBen Exception").appendClassName("Builder").appendMethodName("dealStuffAfterFirstWin").append("playerId", Integer.valueOf(playerId)).append("juBenId", Integer.valueOf(juBenId)).flush();
          ErrorSceneLog.getInstance().error("dealStuffAfterFirstWin 2", e2);
        }  
      Armies nextArmies = dataGetter.getArmiesCache().getNextArmies(curArmies.getId().intValue());
      if (nextArmies != null && nextArmies.getType().intValue() != 1)
        try {
          dataGetter.getBroadCastUtil().sendWinNPCBroadCast(playerId, curArmies.getName());
        } catch (Exception e3) {
          ErrorSceneLog.getInstance().appendErrorMsg("BroadCastUtil WinNPCBroadCast Exception").appendClassName("Builder").appendMethodName("dealNextNpc").append("playerId", Integer.valueOf(playerId)).append("curArmies", curArmies.getName()).flush();
          ErrorSceneLog.getInstance().error("dealStuffAfterFirstWin 2", e3);
        }  
    } 
  }
  
  public static void dealExtraPower(IDataGetter dataGetter, int playerId, int extraPowerId) {
    PlayerPower playerPower = dataGetter.getPlayerPowerDao().getPlayerPower(playerId, extraPowerId);
    if (playerPower == null) {
      playerPower = new PlayerPower();
      playerPower.setPlayerId(Integer.valueOf(playerId));
      playerPower.setPowerId(Integer.valueOf(extraPowerId));
      playerPower.setAttackable(Integer.valueOf(1));
      playerPower.setComplete(Integer.valueOf(0));
      playerPower.setReward(Integer.valueOf(0));
      playerPower.setExpireTime(new Date(System.currentTimeMillis() + 86400000L));
      playerPower.setState(Integer.valueOf(-1));
      playerPower.setBuyCount(Integer.valueOf(0));
      playerPower.setCCjxInfo(null);
      dataGetter.getPlayerPowerDao().create(playerPower);
      List<PlayerArmyExtra> PlayerArmiesExtraList = dataGetter.getPlayerArmyExtraDao().getArmiesByPowerId(playerId, extraPowerId);
      if (PlayerArmiesExtraList != null && PlayerArmiesExtraList.size() > 0) {
        ErrorSceneLog.getInstance().appendErrorMsg("power_extra购买,PlayerPower无记录,PlayerArmyExtra已经有记录.").appendClassName("PowerService").appendMethodName("buyPowerExtra").append("playerId", Integer.valueOf(playerId)).append("extraPowerId", Integer.valueOf(extraPowerId)).flush();
        return;
      } 
      List<ArmiesExtra> armiesExtraList = dataGetter.getArmiesExtraCache().getArmiesExtraByPowerId(extraPowerId);
      for (int i = 0; i < armiesExtraList.size(); i++) {
        ArmiesExtra armiesExtra = armiesExtraList.get(i);
        PlayerArmyExtra playerArmyExtra = new PlayerArmyExtra();
        playerArmyExtra.setPlayerId(Integer.valueOf(playerId));
        playerArmyExtra.setPowerId(armiesExtra.getPowerId());
        playerArmyExtra.setArmyId(armiesExtra.getId());
        playerArmyExtra.setAttackable(Integer.valueOf(0));
        if (i == 0)
          playerArmyExtra.setAttackable(Integer.valueOf(1)); 
        playerArmyExtra.setAttNum(Integer.valueOf(0));
        playerArmyExtra.setFirstOpen(Integer.valueOf(1));
        playerArmyExtra.setFirstWin(Integer.valueOf(0));
        playerArmyExtra.setWinNum(Integer.valueOf(0));
        int num = OneVsExtraBuilder.getMaxHp(dataGetter, armiesExtra.getId().intValue());
        playerArmyExtra.setHp(Integer.valueOf(num));
        playerArmyExtra.setHpMax(Integer.valueOf(num));
        playerArmyExtra.setNpcLost(null);
        dataGetter.getPlayerArmyExtraDao().create(playerArmyExtra);
      } 
    } 
  }
  
  public void countNpcReward(boolean attWin, IDataGetter dataGetter, Battle bat, BattleResult battleResult) {
    Armies armies = (Armies)dataGetter.getArmiesCache().get(Integer.valueOf(bat.defBaseInfo.getId()));
    Map<Integer, BattleDrop> dropMap = armies.getDropMap();
    BattleDrop battleDrop = null;
    if (dropMap != null)
      battleDrop = dropMap.get(Integer.valueOf(101)); 
    if (battleDrop != null) {
      General general = (General)dataGetter.getGeneralCache().get(Integer.valueOf(battleDrop.id));
      if (general != null) {
        Iterator<Integer> iterator = bat.inBattlePlayers.keySet().iterator();
        while (iterator.hasNext()) {
          int playerId = ((Integer)iterator.next()).intValue();
          PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(playerId));
          if (((pi.isAttSide && attWin) || (!pi.isAttSide && !attWin)) && WebUtil.nextDouble() < battleDrop.pro) {
            String gId = general.getId() + ",";
            PlayerTavern playerTavern = dataGetter.getPlayerTavernDao().read(playerId);
            if (playerTavern == null)
              return; 
            if (general.getType().intValue() == 1) {
              if (playerTavern.getCivilInfo() != null && playerTavern.getCivilInfo().contains(gId))
                continue; 
              dataGetter.getPlayerTavernDao().updateCivilInfo(playerId, gId);
            } else {
              if (playerTavern.getMilitaryInfo() != null && playerTavern.getMilitaryInfo().contains(gId))
                continue; 
              dataGetter.getPlayerTavernDao().updateMilitaryInfo(playerId, gId);
            } 
            battleResult.dropGId = general.getId().intValue();
            battleResult.dropGName = general.getName();
            battleResult.dropGPic = general.getPic();
            battleResult.dropGQuality = general.getQuality().intValue();
            battleResult.dropGType = general.getType().intValue();
            if (general.getType().intValue() == 1) {
              battleResult.gTroopName = LocalMessages.T_CIVIL_NAME;
              battleResult.gTroopQuality = 1;
            } else {
              Troop troop = dataGetter.getTroopCache().getTroop(general.getTroop().intValue(), playerId);
              battleResult.gTroopName = troop.getName();
              battleResult.gTroopQuality = troop.getQuality().intValue();
            } 
            if (general.getId().intValue() != 225)
              continue; 
            if (!dataGetter.getTavernService().recruitGeneralDirect(playerId, general.getId().intValue(), true))
              continue; 
            battleResult.dropGget = 1;
          } 
        } 
      } 
    } 
  }
  
  public static void sendMsgToAll(Battle bat, StringBuilder battleMsg) {
    String headInfo = " battleId " + bat.getBattleId() + " 发送给所有人   battleMsg:";
    String saveReport = Configuration.getProperty("gcld.battle.report.save");
    if (saveReport.equals("1"))
      getLog(battleMsg.toString(), headInfo); 
    String quickMode = Configuration.getProperty("gcld.battle.quick");
    if (bat.getQuickBattle() <= 0 || bat.getShuaiQiInUse() || bat.getQuickType() > 0)
      for (Integer playerId : bat.inSceneSet) {
        if (NewBattleManager.getInstance().isWatchBattle(playerId.intValue(), bat.getBattleId()))
          sendMsgToOne(playerId.intValue(), battleMsg); 
      }  
  }
  
  public static void sendMsgToAllExcludeOne(Battle bat, StringBuilder battleMsg, int excludePlayerId) {
    String headInfo = " battleId " + bat.getBattleId() + " 发送给其他人  battleMsg:";
    String saveReport = Configuration.getProperty("gcld.battle.report.save");
    if (saveReport.equals("1"))
      getLog(battleMsg.toString(), headInfo); 
    String quickMode = Configuration.getProperty("gcld.battle.quick");
    if (bat.getQuickBattle() <= 0)
      for (Integer playerId : bat.inSceneSet) {
        if (playerId.intValue() == excludePlayerId)
          continue; 
        if (!NewBattleManager.getInstance().isWatchBattle(playerId.intValue(), bat.getBattleId()))
          continue; 
        sendMsgToOne(playerId.intValue(), battleMsg);
      }  
  }
  
  public static void sendMsgToSingle(Battle bat, StringBuilder msgToCurrentPlayer, int playerId, String SingleHeadInfo, String backN) {
    String saveReport = Configuration.getProperty("gcld.battle.report.save");
    if (saveReport.equals("1"))
      if (backN == null) {
        getLog(msgToCurrentPlayer.toString(), SingleHeadInfo);
      } else {
        getLog(String.valueOf(String.valueOf(String.valueOf(backN))) + msgToCurrentPlayer.toString(), SingleHeadInfo);
      }  
    String quickMode = Configuration.getProperty("gcld.battle.quick");
    if (bat.getQuickBattle() <= 0)
      sendMsgToOne(playerId, msgToCurrentPlayer); 
  }
  
  public static void sendMsgToOne(int playerId, StringBuilder battleMsg) {
    Session session = Players.getSession(Integer.valueOf(playerId));
    if (session != null) {
      byte[] bytes = JsonBuilder.getJson(JsonBuilder.getJson(State.PUSH, PushCommand.PUSH_BATTLE_DOBATTLE.getModule(), battleMsg));
      session.write(WrapperUtil.wrapper(PushCommand.PUSH_BATTLE_DOBATTLE.getCommand(), 0, bytes));
    } 
  }
  
  public static void getReportType47(StringBuilder battleMsg, List<BattleArmy> battleList, String battleSide, BaseInfo baseInfo) {
    int i = 0;
    if (battleList != null && !battleList.isEmpty()) {
      battleMsg.append(47).append("|").append(battleSide).append(";");
      while (i < battleList.size()) {
        BattleArmy battleArmy = battleList.get(i);
        CampArmy campArmy = battleArmy.getCampArmy();
        battleMsg.append(battleArmy.getPosition()).append("|");
        int troopHpMax = campArmy.getTroopHp() / 3;
        boolean diyihang = battleArmy.getHaveZhanChe();
        for (int j = 0; j < 3; j++) {
          int shield = battleArmy.getShield();
          int maxshield = battleArmy.getMaxShield();
          int shiledtype = battleArmy.getShiledType();
          if (diyihang) {
            battleMsg.append(battleArmy.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(shield).append("*").append(maxshield).append("*").append(campArmy.getAttack()).append("*").append(campArmy.getDefence()).append("*").append(battleArmy.getZfShiled()).append("*").append(battleArmy.getHuJia()).append("*").append(battleArmy.getCarMaxHp()).append("*").append(shiledtype).append("*").append(campArmy.getDefenseDow()).append("*");
          } else if (battleArmy.getZhanchedun() > 0) {
            battleMsg.append(battleArmy.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(shield).append("*").append(maxshield).append("*").append(campArmy.getAttack()).append("*").append(campArmy.getDefence()).append("*").append(battleArmy.getZfShiled()).append("*").append(battleArmy.getZCdunHp()).append("*").append(battleArmy.getCarMaxHp()).append("*").append(shiledtype).append("*").append(campArmy.getDefenseDow()).append("*");
          } else {
            battleMsg.append(battleArmy.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(shield).append("*").append(maxshield).append("*").append(campArmy.getAttack()).append("*").append(campArmy.getDefence()).append("*").append(battleArmy.getZfShiled()).append("*").append(0).append("*").append(0).append("*").append(shiledtype).append("*").append(campArmy.getDefenseDow()).append("*");
          } 
          if (diyihang) {
            int carid = campArmy.getCarId();
            battleMsg.append(carid).append("*").append(battleArmy.getBigGzNum()).append(",");
          } else if (battleArmy.getZhanchedun() > 0) {
            int carid = 0;
            if (campArmy.getCatapultSkill() == 2 && campArmy.getGeneralId() == 275) {
              carid = 999;
            } else if (campArmy.getCatapultSkill() == 4 && campArmy.getGeneralId() == 275) {
              carid = 879992;
            } 
            if (carid > 0) {
              battleMsg.append(carid).append("*").append(battleArmy.getBigGzNum()).append(",");
            } else {
              battleMsg.append(carid).append("*").append(0).append(",");
            } 
          } else {
            battleMsg.append(0).append("*").append(0).append(",");
          } 
        } 
        battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), ";");
        i++;
      } 
      battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "#");
    } 
  }
  
  public static void getReportType10(StringBuilder battleMsg, List<BattleArmy> battleList, String battleSide, BaseInfo baseInfo) {
    int i = 0;
    if (baseInfo.foreWin)
      i = 1; 
    if (battleList.size() > i) {
      battleMsg.append(10).append("|").append(battleSide).append(";");
      while (i < battleList.size()) {
        BattleArmy battleArmy = battleList.get(i);
        CampArmy campArmy = battleArmy.getCampArmy();
        boolean diyihang = battleArmy.getHaveZhanChe();
        int specialType = (campArmy.getTeamGenreal() == null) ? 0 : ((campArmy.getTeamEffect() > 0.0D) ? 2 : 1);
        if (battleArmy.getTD_defense_e() > 0.0D)
          specialType = 3; 
        battleMsg.append(battleArmy.getPosition()).append("|").append(campArmy.getPlayerId()).append("|").append(campArmy.getTroopSerial()).append("|").append(campArmy.getTroopType()).append("|").append(campArmy.getTroopName()).append("|").append(campArmy.getTroopDropType()).append("|").append(battleArmy.getStrategy()).append("|").append(specialType).append("|");
        battleMsg.append(campArmy.getIsJuexing()).append("|").append(campArmy.getIsChongFeng()).append("|").append(battleArmy.getIsDajiang()).append("|").append(campArmy.getCopyType()).append("|").append(campArmy.getJueEquip()).append("|").append(campArmy.getAttack()).append("|").append(campArmy.getDefence()).append("|").append(campArmy.getResistePercentage()).append("|");
        if (diyihang) {
          int carid = campArmy.getCarId();
          battleMsg.append(carid).append("|").append(battleArmy.getBigGzNum()).append("|");
        } else if (battleArmy.getZhanchedun() > 0) {
          int carid = 0;
          if (campArmy.getCatapultSkill() == 2 && campArmy.getGeneralId() == 275) {
            carid = 999;
          } else if (campArmy.getCatapultSkill() == 4 && campArmy.getGeneralId() == 275) {
            carid = 879992;
          } 
          if (carid > 0) {
            battleMsg.append(carid).append("|").append(battleArmy.getBigGzNum()).append("|");
          } else {
            battleMsg.append(carid).append("|").append(0).append("|");
          } 
        } else {
          battleMsg.append(0).append("|").append(0).append("|");
        } 
        battleMsg.append(campArmy.getbsPro()).append("|").append(battleArmy.getZfShiled()).append("|").append(battleArmy.getSpecial()).append("|").append(campArmy.getWeiweiHuaide()).append("|").append(battleArmy.getYubaoEffect()).append("|").append(campArmy.getFormationType()).append("|").append(campArmy.getHasbigFormationskill()).append("|").append(campArmy.getFyzShield()).append("|").append(campArmy.getLgdcBuff()).append("|").append(campArmy.getIsBurn()).append("|").append(campArmy.getSex()).append("|").append(campArmy.getIsDeputy()).append("|").append(campArmy.getJxType()).append("|").append(campArmy.getYbTx()).append("|").append(campArmy.getWsb()).append("|").append(battleArmy.getTouXian()).append("|").append("0|").append(battleArmy.getLonglin()).append("|").append(battleArmy.getSangDanType()).append("|0|").append(campArmy.getMissNum()).append("|").append(campArmy.getImmunoNum()).append("|").append(campArmy.getCarPoDunNum()).append("|").append(campArmy.getIsFanShang()).append("|").append(campArmy.getIsBmy()).append("|").append(campArmy.getZhsNum()).append("|").append(campArmy.getMfFire()).append("|").append(battleArmy.getCardebuff()).append("|").append(battleArmy.getQingCheng()).append("|").append(battleArmy.getCarGzLevel()).append("|").append(battleArmy.getHuWei()).append("|").append(battleArmy.getCarTsBj()).append("|").append(battleArmy.getpose()).append("|").append(campArmy.getSneer()).append("|").append(campArmy.getIsBeatMonster()).append("|").append(campArmy.getBeastStar()).append("|").append("0|").append(campArmy.getFkbhHpPro()).append("|").append(campArmy.getIsZhenFaLvUp()).append("|").append(campArmy.getIsFlower()).append("|").append(campArmy.getSunShangXiangZs()).append("|").append(campArmy.getZsMyMa()).append("|").append(campArmy.getSsxMa()).append("|").append(battleArmy.getHuShou()).append("|").append(battleArmy.getFengDao()).append("|").append(battleArmy.getZyNum()).append("|");
        battleMsg.append(campArmy.getHuoYi()).append("|").append(campArmy.getZhaXiang()).append("|").append(campArmy.getHasZh()).append("|").append(campArmy.getLjNum()).append("|null|").append(campArmy.getLeblMa()).append("|").append(campArmy.guzhu).append("|").append(campArmy.getTuiShou()).append("|").append(campArmy.getFuBingNum1()).append("|0|0|").append(campArmy.getJxBuff1()).append("|").append(campArmy.getJxBuff1()).append("|0|0|0|0|").append(campArmy.getTitle1()).append("|0|0|0|").append(campArmy.getTitle()).append("|0|0|0|0|0|0|0|0|0|0|0|0|0|0|0|");
        int troopHpMax = campArmy.getTroopHp() / 3;
        for (int j = 0; j < 3; j++) {
          if (diyihang) {
            battleMsg.append(battleArmy.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(battleArmy.getHuJia()).append("*").append(battleArmy.getCarMaxHp()).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } else if (battleArmy.getZhanchedun() > 0) {
            battleMsg.append(battleArmy.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(battleArmy.getZCdunHp()).append("*").append(battleArmy.getCarMaxHp()).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } else {
            battleMsg.append(battleArmy.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(0).append("*").append(0).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } 
        } 
        battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), ";");
        i++;
      } 
      battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "#");
    } 
  }
  
  public Terrain getTerrain(int playerId, int defId, IDataGetter dataGetter) {
    Armies armies = (Armies)dataGetter.getArmiesCache().get(Integer.valueOf(defId));
    return new Terrain(armies.getTerrain().intValue(), armies.getTerrainEffectType().intValue(), armies.getTerrain().intValue());
  }
  
  public void inBattleInfo(int playerId, boolean inBattle) {
    NewBattleManager.inPveBattle(playerId, inBattle);
  }
  
  public void addInSceneSet(Battle bat, int playerId) {
    if (!bat.auto && playerId > 0) {
      bat.inSceneSet.add(Integer.valueOf(playerId));
      NewBattleManager.getInstance().setPlayerWatchBattle(playerId, bat);
    } 
  }
  
  public int getGeneralState() {
    return 2;
  }
  
  public void sendTaskMessage(int playerId, int defId, IDataGetter dataGetter) {}
  
  public int getBattleSide(IDataGetter dataGetter, Player player, int defId) {
    return 1;
  }
  
  public int getBattleSide(IDataGetter dataGetter, Player player, Battle battle) {
    return 1;
  }
  
  public Battle getPlayerBattleInfo(int playerId, int battleType, int generalId) {
    Battle bat = null;
    if (generalId > 0) {
      bat = NewBattleManager.getInstance().getBattleByGId(playerId, generalId);
      if (bat != null)
        return bat; 
    } 
    bat = NewBattleManager.getInstance().getBattleByBatType(playerId, battleType);
    if (bat != null)
      return bat; 
    if (battleType == 1) {
      Map<Integer, Battle> battles = NewBattleManager.getInstance().getBattleByPid(playerId);
      for (Map.Entry<Integer, Battle> entry : battles.entrySet()) {
        if (((Integer)entry.getKey()).intValue() == 1)
          return entry.getValue(); 
        if (((Integer)entry.getKey()).intValue() == 2)
          return entry.getValue(); 
        if (((Integer)entry.getKey()).intValue() == 11)
          return entry.getValue(); 
        if (((Integer)entry.getKey()).intValue() == 12)
          return entry.getValue(); 
      } 
    } 
    return bat;
  }
  
  public void sendBattleInfo(IDataGetter dataGetter, Battle bat, BattleAttacker battleAttacker) {}
  
  public LinkedList<CampArmy> addAttNpc(IDataGetter dataGetter, int num, BaseInfo attbaseInfo, List<CampArmy> camps, AtomicInteger campNum, Battle bat) {
    return null;
  }
  
  public LinkedList<CampArmy> addDefNpc(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    return null;
  }
  
  public void systemSinglePK(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {}
  
  public void dealBuilderBattleTask(IDataGetter dataGetter, int playerId, int cityId) {}
  
  public void getGeneralForce(IDataGetter dataGetter, Battle bat, StringBuilder battleMsg, AtomicInteger ticket) {
    int sn = ticket.incrementAndGet();
    battleMsg.append(sn).append("#");
    CampArmy campArmy = ((BattleArmy)bat.attList.get(0)).getCampArmy();
    battleMsg.append(18).append("|").append("att").append("|").append(campArmy.armyHpOrg - campArmy.armyHpLoss).append("|").append(campArmy.armyHpOrg).append("#");
    campArmy = ((BattleArmy)bat.defList.get(0)).getCampArmy();
    battleMsg.append(18).append("|").append("def").append("|").append(campArmy.armyHpOrg - campArmy.armyHpLoss).append("|").append(campArmy.armyHpOrg).append("#");
  }
  
  public void initJoinPlayer(List<PlayerGeneralMilitary> pgmList, IDataGetter dataGetter, Player player, Battle bat, BaseInfo baseInfo, List<CampArmy> campMap, List<CampArmy> campChange, int battleSide, TeamInfo teamInfo) {
    CampArmy campArmy = null;
    int num = 0;
    for (int i = 0; i < pgmList.size(); i++) {
      PlayerGeneralMilitary pgm = pgmList.get(i);
      campArmy = copyArmyFromPlayerTable(player, pgm, dataGetter, getGeneralState(), bat, battleSide);
      if (campArmy != null) {
        num += campArmy.getArmyHpOrg();
        campMap.add(campArmy);
        BattleSceneLog.getInstance().info("#batId:" + bat.getBattleId() + "_" + bat.getStartTime() + "#add:join#side:" + ((battleSide == 1) ? "att" : "def") + "#playerId:" + campArmy.getPlayerId() + ":" + campArmy.isPhantom + "#general:" + campArmy.getGeneralId() + "#" + ((battleSide == 1) ? "att" : "def") + "Size:" + campMap.size());
        campChange.add(campArmy);
      } 
    } 
    if (baseInfo.getNum() + num < 0)
      ErrorSceneLog.getInstance().appendErrorMsg("兵力小于0,battle 3072行"); 
    baseInfo.setNum(baseInfo.getNum() + num);
    baseInfo.setAllNum(baseInfo.getAllNum() + num);
  }
  
  public boolean conSumeFood(int playerId, int defId, IDataGetter dataGetter) {
    return true;
  }
  
  public static boolean containsCityId(String strs, int defId) {
    if (StringUtils.isBlank(strs))
      return false; 
    String[] ids = strs.split(",");
    int cityId = 0;
    for (int i = 0; i < ids.length; i++) {
      String str = ids[i];
      cityId = Integer.valueOf(str).intValue();
      if (cityId == defId)
        return true; 
    } 
    return false;
  }
  
  public static void getCurCampInfo(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    roundInfo.attBattleArmy = bat.attList.get(0);
    roundInfo.defBattleArmy = bat.defList.get(0);
    roundInfo.attCampArmy = roundInfo.attBattleArmy.getCampArmy();
    roundInfo.defCampArmy = roundInfo.defBattleArmy.getCampArmy();
    if (roundInfo.attBattleArmy.getHaveZhanChe() && roundInfo.attBattleArmy.getHuJia() > 0)
      roundInfo.attorignhujia = roundInfo.attBattleArmy.getHuJia(); 
    if (roundInfo.defBattleArmy.getHaveZhanChe() && roundInfo.defBattleArmy.getHuJia() > 0)
      roundInfo.deforignhujia = roundInfo.defBattleArmy.getHuJia(); 
    if (bat.attList.size() > 1)
      roundInfo.nextAttBattleArmy = bat.attList.get(1); 
    if (bat.defList.size() > 1)
      roundInfo.nextDefBattleArmy = bat.defList.get(1); 
    if (roundInfo.attCampArmy.playerId > 0 && ActivityService.setActivityLv.contains(Integer.valueOf(roundInfo.attCampArmy.playerLv)))
      roundInfo.attCampArmy.activityAddExp = dataGetter.getActivityService().getAddBatValue(roundInfo.attCampArmy.playerId, roundInfo.attCampArmy.playerLv); 
    if (roundInfo.defCampArmy.playerId > 0 && ActivityService.setActivityLv.contains(Integer.valueOf(roundInfo.defCampArmy.playerLv)))
      roundInfo.defCampArmy.activityAddExp = dataGetter.getActivityService().getAddBatValue(roundInfo.defCampArmy.playerId, roundInfo.defCampArmy.playerLv); 
    if (roundInfo.attCampArmy.zballtimes > 0) {
      CampArmy attCampArmy = roundInfo.attCampArmy;
      attCampArmy.zbtimes++;
    } 
    if (roundInfo.defCampArmy.zballtimes > 0) {
      CampArmy defCampArmy = roundInfo.defCampArmy;
      defCampArmy.zbtimes++;
    } 
    boolean shhy = false;
    if (roundInfo.attCampArmy.generalId == 203 && roundInfo.attCampArmy.isjuexing > 0 && roundInfo.attCampArmy.tacticVal > 0)
      if (roundInfo.attCampArmy.getFuBingType() > 0 || roundInfo.attCampArmy.getIsDeputy() > 0 || roundInfo.defCampArmy.getUnionRank() > 0) {
        if (RandomUtils.nextInt(100) > 90) {
          roundInfo.attCampArmy.setShenHunHeYi(1);
          shhy = true;
        } 
      } else if (RandomUtils.nextInt(100) > 60) {
        roundInfo.attCampArmy.setShenHunHeYi(1);
        shhy = true;
      }  
    if (roundInfo.defCampArmy.generalId == 203 && roundInfo.defCampArmy.isjuexing > 0 && roundInfo.defCampArmy.tacticVal > 0)
      if (roundInfo.defCampArmy.getFuBingType() > 0 || roundInfo.defCampArmy.getIsDeputy() > 0 || roundInfo.attCampArmy.getUnionRank() > 0) {
        if (RandomUtils.nextInt(100) > 90) {
          roundInfo.defCampArmy.setShenHunHeYi(1);
          shhy = true;
        } 
      } else if (RandomUtils.nextInt(100) > 60) {
        roundInfo.defCampArmy.setShenHunHeYi(1);
        shhy = true;
      }  
    if (shhy)
      roundInfo.battleMsg.append("36|guanyujx#"); 
    if (roundInfo.attCampArmy.generalId == 205 && roundInfo.attCampArmy.isjuexing > 0) {
      int attmachaotime = roundInfo.attCampArmy.machaotimes;
      if (roundInfo.attCampArmy.armyHpLoss >= roundInfo.attCampArmy.armyHpOrg)
        attmachaotime = -1; 
      roundInfo.battleMsg.append("65|3,").append(attmachaotime).append(",").append(1 + roundInfo.attCampArmy.formationLevel / 20).append(";");
      if (roundInfo.defCampArmy.generalId == 205 && roundInfo.defCampArmy.isjuexing > 0) {
        int defmachaotime = roundInfo.defCampArmy.machaotimes;
        if (roundInfo.defCampArmy.armyHpLoss >= roundInfo.defCampArmy.armyHpOrg)
          defmachaotime = -1; 
        roundInfo.battleMsg.append("3,").append(defmachaotime).append(",").append(1 + roundInfo.defCampArmy.formationLevel / 20).append("#");
      } else {
        roundInfo.battleMsg.append("null#");
      } 
    } else if (roundInfo.defCampArmy.generalId == 205 && roundInfo.defCampArmy.isjuexing > 0) {
      int defmachaotime2 = roundInfo.defCampArmy.machaotimes;
      if (roundInfo.defCampArmy.armyHpLoss >= roundInfo.defCampArmy.armyHpOrg)
        defmachaotime2 = -1; 
      roundInfo.battleMsg.append("65|null;3,").append(defmachaotime2).append(",").append(1 + roundInfo.defCampArmy.formationLevel / 20).append("#");
    } 
    if (roundInfo.attCampArmy.generalId == 280 && roundInfo.attCampArmy.isjuexing > 0) {
      roundInfo.battleMsg.append("65|9,").append(roundInfo.attCampArmy.czshinum).append(",").append(roundInfo.attCampArmy.czshiround).append(";");
      if (roundInfo.defCampArmy.generalId == 280 && roundInfo.defCampArmy.isjuexing > 0) {
        roundInfo.battleMsg.append("9,").append(roundInfo.defCampArmy.czshinum).append(",").append(roundInfo.defCampArmy.czshiround).append("#");
      } else {
        roundInfo.battleMsg.append("null#");
      } 
    } else if (roundInfo.defCampArmy.generalId == 280 && roundInfo.defCampArmy.isjuexing > 0) {
      roundInfo.battleMsg.append("65|null;9,").append(roundInfo.defCampArmy.czshinum).append(",").append(roundInfo.defCampArmy.czshiround).append("#");
    } 
    if (roundInfo.attCampArmy.generalId == 280 && roundInfo.attCampArmy.isjuexing > 0) {
      roundInfo.battleMsg.append(85).append("|");
      int cztype = 1;
      if (roundInfo.attCampArmy.czshinum % 3 == 0)
        cztype = 2; 
      roundInfo.battleMsg.append(cztype).append("|att|");
      for (BattleArmy ba : bat.attList) {
        if (ba.getCampArmy() == roundInfo.attCampArmy) {
          roundInfo.battleMsg.append(ba.getPosition()).append(",");
          if (cztype == 1) {
            roundInfo.battleMsg.append(roundInfo.attCampArmy.missNum).append(";");
            continue;
          } 
          roundInfo.battleMsg.append(roundInfo.attCampArmy.immunoNum).append(";");
        } 
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
    } 
    if (roundInfo.defCampArmy.generalId == 280 && roundInfo.defCampArmy.isjuexing > 0) {
      roundInfo.battleMsg.append(85).append("|");
      int cztype = 1;
      if (roundInfo.defCampArmy.czshinum % 3 == 0)
        cztype = 2; 
      roundInfo.battleMsg.append(cztype).append("|def|");
      for (BattleArmy ba : bat.defList) {
        if (ba.getCampArmy() == roundInfo.defCampArmy) {
          roundInfo.battleMsg.append(ba.getPosition()).append(",");
          if (cztype == 1) {
            roundInfo.battleMsg.append(roundInfo.defCampArmy.missNum).append(";");
            continue;
          } 
          roundInfo.battleMsg.append(roundInfo.defCampArmy.immunoNum).append(";");
        } 
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
    } 
    if (roundInfo.attCampArmy.generalId == 232 && roundInfo.attCampArmy.isjuexing > 0 && roundInfo.attCampArmy.mfbuff >= 0 && roundInfo.attCampArmy.unionstate <= 0) {
      roundInfo.battleMsg.append("65|10,").append(roundInfo.attCampArmy.mfbuff).append(",0;");
      if (roundInfo.defCampArmy.generalId == 232 && roundInfo.defCampArmy.isjuexing > 0 && roundInfo.defCampArmy.mfbuff >= 0) {
        roundInfo.battleMsg.append("10,").append(roundInfo.defCampArmy.mfbuff).append(",0#");
      } else {
        roundInfo.battleMsg.append("null#");
      } 
    } else if (roundInfo.defCampArmy.generalId == 232 && roundInfo.defCampArmy.isjuexing > 0 && roundInfo.defCampArmy.mfbuff >= 0 && roundInfo.defCampArmy.unionstate <= 0) {
      roundInfo.battleMsg.append("65|null;10,").append(roundInfo.defCampArmy.mfbuff).append(",0#");
    } 
    if (roundInfo.attCampArmy.formationtype == 1 && roundInfo.attCampArmy.formationLevel > 1000 && roundInfo.attCampArmy.JxBuff >= 0) {
      roundInfo.battleMsg.append("65|80,").append(roundInfo.attCampArmy.JxBuff).append(",").append(1 + roundInfo.attCampArmy.formationLevel / 20).append(";");
      if (roundInfo.defCampArmy.formationtype == 1 && roundInfo.defCampArmy.formationLevel > 1000 && roundInfo.defCampArmy.JxBuff >= 0) {
        roundInfo.battleMsg.append("80,").append(roundInfo.defCampArmy.JxBuff).append(",").append(1 + roundInfo.attCampArmy.formationLevel / 20).append(";");
      } else {
        roundInfo.battleMsg.append("null#");
      } 
    } else if (roundInfo.defCampArmy.formationtype == 1 && roundInfo.defCampArmy.formationLevel > 1000 && roundInfo.defCampArmy.JxBuff >= 0) {
      roundInfo.battleMsg.append("65|null;80,").append(roundInfo.defCampArmy.JxBuff).append(",0#");
    } 
    if (roundInfo.attCampArmy.formationtype == 2 && roundInfo.attCampArmy.formationLevel > 1000 && roundInfo.attCampArmy.JxBuff >= 0) {
      roundInfo.battleMsg.append("65|80,").append(roundInfo.attCampArmy.JxBuff).append(",").append(1 + roundInfo.attCampArmy.formationLevel / 20).append(";");
      if (roundInfo.defCampArmy.formationtype == 2 && roundInfo.defCampArmy.formationLevel > 1000 && roundInfo.defCampArmy.JxBuff >= 0) {
        roundInfo.battleMsg.append("80,").append(roundInfo.defCampArmy.JxBuff).append(",").append(1 + roundInfo.attCampArmy.formationLevel / 20).append(";");
      } else {
        roundInfo.battleMsg.append("null#");
      } 
    } else if (roundInfo.defCampArmy.formationtype == 2 && roundInfo.defCampArmy.formationLevel > 1000 && roundInfo.defCampArmy.JxBuff >= 0) {
      roundInfo.battleMsg.append("65|null;80,").append(roundInfo.defCampArmy.JxBuff).append(",0#");
    } 
    if (roundInfo.attCampArmy.formationtype == 3 && roundInfo.attCampArmy.formationLevel > 1000 && roundInfo.attCampArmy.JxBuff >= 0) {
      roundInfo.battleMsg.append("65|25,").append(roundInfo.attCampArmy.JxBuff).append(",").append(1 + roundInfo.attCampArmy.formationLevel / 20).append(";");
      if (roundInfo.defCampArmy.formationtype == 3 && roundInfo.defCampArmy.formationLevel > 1000 && roundInfo.defCampArmy.JxBuff >= 0) {
        roundInfo.battleMsg.append("25,").append(roundInfo.defCampArmy.JxBuff).append(",").append(1 + roundInfo.attCampArmy.formationLevel / 20).append(";");
      } else {
        roundInfo.battleMsg.append("null#");
      } 
    } else if (roundInfo.defCampArmy.formationtype == 3 && roundInfo.defCampArmy.formationLevel > 1000 && roundInfo.defCampArmy.JxBuff >= 0) {
      roundInfo.battleMsg.append("65|null;25,").append(roundInfo.defCampArmy.JxBuff).append(",0#");
    } 
    if (roundInfo.attCampArmy.formationtype == 6 && roundInfo.attCampArmy.formationLevel > 1000 && roundInfo.attCampArmy.JxBuff >= 0) {
      roundInfo.battleMsg.append("65|80,").append(roundInfo.attCampArmy.JxBuff).append(",").append(1 + roundInfo.attCampArmy.formationLevel / 20).append(";");
      if (roundInfo.defCampArmy.formationtype == 6 && roundInfo.defCampArmy.formationLevel > 1000 && roundInfo.defCampArmy.JxBuff >= 0) {
        roundInfo.battleMsg.append("80,").append(roundInfo.defCampArmy.JxBuff).append(",").append(1 + roundInfo.attCampArmy.formationLevel / 20).append(";");
      } else {
        roundInfo.battleMsg.append("null#");
      } 
    } else if (roundInfo.defCampArmy.formationtype == 6 && roundInfo.defCampArmy.formationLevel > 1000 && roundInfo.defCampArmy.JxBuff >= 0) {
      roundInfo.battleMsg.append("65|null;80,").append(roundInfo.defCampArmy.JxBuff).append(",0#");
    } 
    if (roundInfo.attCampArmy.getGeneralId() == 201 && roundInfo.attCampArmy.isjuexing > 0 && roundInfo.attCampArmy.JxBuff >= 0) {
      roundInfo.battleMsg.append("65|30,").append(roundInfo.attCampArmy.JxBuff).append(",").append(1 + roundInfo.attCampArmy.formationLevel / 20).append(";");
      if (roundInfo.defCampArmy.getGeneralId() == 201 && roundInfo.defCampArmy.isjuexing > 0 && roundInfo.defCampArmy.JxBuff >= 0) {
        roundInfo.battleMsg.append("30,").append(roundInfo.defCampArmy.JxBuff).append(",").append(1 + roundInfo.attCampArmy.formationLevel / 20).append(";");
      } else {
        roundInfo.battleMsg.append("null#");
      } 
    } else if (roundInfo.defCampArmy.getGeneralId() == 201 && roundInfo.defCampArmy.isjuexing > 0 && roundInfo.defCampArmy.JxBuff >= 0) {
      roundInfo.battleMsg.append("65|null;30,").append(roundInfo.defCampArmy.JxBuff).append(",0#");
    } 
    if (roundInfo.attBattleArmy.getHaveZhanChe() && roundInfo.attCampArmy.getCarModel() == 5 && roundInfo.attBattleArmy.getHuJia() > 0) {
      int huihe = 3 - bat.getRoundNum().get() % 4;
      roundInfo.battleMsg.append("65|1,").append(huihe).append(",").append(4 - huihe).append(";");
      if (roundInfo.defBattleArmy.getHaveZhanChe() && roundInfo.attCampArmy.getCarModel() == 5 && roundInfo.defBattleArmy.getHuJia() > 0) {
        roundInfo.battleMsg.append("1,").append(huihe).append(",0#");
      } else {
        roundInfo.battleMsg.append("null#");
      } 
    } else if (roundInfo.defBattleArmy.getHaveZhanChe() && roundInfo.defCampArmy.getCarModel() == 5 && roundInfo.defBattleArmy.getHuJia() > 0) {
      int huihe = 3 - bat.getRoundNum().get() % 4;
      roundInfo.battleMsg.append("65|null;1,").append(huihe).append(",").append(4 - huihe).append("#");
    } 
    if (roundInfo.attCampArmy.generalId == 270 && roundInfo.defCampArmy.unionrank >= 2) {
      int attmachaotime = roundInfo.attCampArmy.machaotimes;
      if (roundInfo.attCampArmy.armyHpLoss >= roundInfo.attCampArmy.armyHpOrg)
        attmachaotime = -1; 
      roundInfo.battleMsg.append("65|17,").append(attmachaotime).append(",").append(1 + roundInfo.attCampArmy.formationLevel / 20).append(";");
      if (roundInfo.defCampArmy.generalId == 270 && roundInfo.defCampArmy.unionrank >= 2) {
        int defmachaotime = roundInfo.defCampArmy.machaotimes;
        if (roundInfo.defCampArmy.armyHpLoss >= roundInfo.defCampArmy.armyHpOrg)
          defmachaotime = -1; 
        roundInfo.battleMsg.append("17,").append(defmachaotime).append(",").append(1 + roundInfo.defCampArmy.formationLevel / 20).append("#");
      } else {
        roundInfo.battleMsg.append("null#");
      } 
    } else if (roundInfo.defCampArmy.generalId == 205 && roundInfo.defCampArmy.isjuexing > 0) {
      int defmachaotime2 = roundInfo.defCampArmy.machaotimes;
      if (roundInfo.defCampArmy.armyHpLoss >= roundInfo.defCampArmy.armyHpOrg)
        defmachaotime2 = -1; 
      roundInfo.battleMsg.append("65|null;3,").append(defmachaotime2).append(",").append(1 + roundInfo.defCampArmy.formationLevel / 20).append("#");
    } 
    if (roundInfo.attCampArmy.getGeneralId() == 201 && roundInfo.attCampArmy.getUnionRank() > 0) {
      roundInfo.battleMsg.append("65|12,1,0;");
      if (roundInfo.defCampArmy.getGeneralId() == 201 && roundInfo.defCampArmy.getUnionRank() > 0) {
        roundInfo.battleMsg.append("12,1,0#");
      } else {
        roundInfo.battleMsg.append("null#");
      } 
    } else if (roundInfo.defCampArmy.getGeneralId() == 201 && roundInfo.defCampArmy.getUnionRank() > 0) {
      roundInfo.battleMsg.append("65|null;12,1,0#");
    } 
    if (roundInfo.attCampArmy.getGeneralId() == 201 && roundInfo.attCampArmy.getUnionRank() >= 3 && !roundInfo.attCampArmy.getZscyShangzhen()) {
      roundInfo.attCampArmy.setZscy(5);
      roundInfo.attCampArmy.setZscyShangzhen(true);
      roundInfo.attCampArmy.setHaveZscy(true);
    } 
    if (roundInfo.defCampArmy.getGeneralId() == 201 && roundInfo.defCampArmy.getUnionRank() >= 3 && !roundInfo.defCampArmy.getZscyShangzhen()) {
      roundInfo.defCampArmy.setZscy(5);
      roundInfo.defCampArmy.setZscyShangzhen(true);
      roundInfo.defCampArmy.setHaveZscy(true);
    } 
    if (roundInfo.attCampArmy.getHaveZscy()) {
      int attzsnum = roundInfo.attCampArmy.getZscy();
      roundInfo.battleMsg.append("65|11,").append(0).append(",").append(attzsnum).append(";");
      if (roundInfo.defCampArmy.getHaveZscy()) {
        int defzsnum = roundInfo.defCampArmy.getZscy();
        roundInfo.battleMsg.append("11,").append(0).append(",").append(defzsnum).append("#");
      } else {
        roundInfo.battleMsg.append("null#");
      } 
    } else if (roundInfo.defCampArmy.getHaveZscy()) {
      int defzsnum2 = roundInfo.defCampArmy.getZscy();
      roundInfo.battleMsg.append("65|null;11,").append(0).append(",").append(defzsnum2).append("#");
    } 
    if (bat.getBattleType() == 3)
      if (roundInfo.attCampArmy.getMeiXianUpper() > 0) {
        int attzsnum = roundInfo.attCampArmy.getMeiXian();
        int mxtype = (roundInfo.attCampArmy.getMeiXianUpper() >= 7) ? 1 : 0;
        roundInfo.battleMsg.append("65|20,").append(attzsnum).append(",").append(roundInfo.attCampArmy.getMeiXianUpper()).append(",").append(mxtype).append(";");
        if (roundInfo.defCampArmy.getMeiXianUpper() > 0) {
          int defzsnum3 = roundInfo.defCampArmy.getMeiXian();
          int deftype = (roundInfo.attCampArmy.getMeiXianUpper() >= 7) ? 1 : 0;
          roundInfo.battleMsg.append("20,").append(defzsnum3).append(",").append(roundInfo.defCampArmy.getMeiXianUpper()).append(",").append(deftype).append("#");
        } else {
          roundInfo.battleMsg.append("null#");
        } 
      } else if (roundInfo.defCampArmy.getMeiXianUpper() > 0) {
        int defzsnum2 = roundInfo.defCampArmy.getMeiXian();
        int deftype2 = (roundInfo.attCampArmy.getMeiXianUpper() >= 7) ? 1 : 0;
        roundInfo.battleMsg.append("65|null;20,").append(defzsnum2).append(",").append(roundInfo.defCampArmy.getMeiXianUpper()).append(",").append(deftype2).append("#");
      }  
    getReportType16(dataGetter, bat, roundInfo.battleMsg, roundInfo.attCampArmy, "att", false, false);
    getReportType16(dataGetter, bat, roundInfo.battleMsg, roundInfo.defCampArmy, "def", false, false);
  }
  
  public static void fight(RoundInfo roundInfo, int terrainValue) {
    saveFightDetailBefore(roundInfo);
    roundInfo.reports = Fight.fight(roundInfo.troopData[0], roundInfo.troopData[1], terrainValue);
    saveFightDetailAfter(roundInfo);
    int numMax = 0;
    int num = 0;
    if (roundInfo.reports != null)
      for (int i = 0; i < roundInfo.reports.length; i++) {
        String s = roundInfo.reports[i];
        num = (s.split(";")).length - 1;
        if (num > numMax)
          numMax = num; 
      }  
    roundInfo.nextMinExeTime += 600 + numMax * 800;
    roundInfo.timePredicationBuffer.append("fight:").append(600 + numMax * 800).append("|");
  }
  
  public static void saveTacticDetailBefore(RoundInfo roundInfo, TroopData[] attacker, TroopData[][] defenders) {
    String debug = Configuration.getProperty("gcld.battle.caculate.debug");
    if (debug.equals("1")) {
      roundInfo.caculateDebugBuffer.append("Before Tactic Attacker.").append("\n\t").append("hp:").append((attacker[0]).hp).append(" | ").append("max_hp:").append((attacker[0]).max_hp).append(" | ").append("att:").append((attacker[0]).att).append(" | ").append("def:").append((attacker[0]).def).append(" | ").append("TACTIC_ATT:").append((attacker[0]).TACTIC_ATT).append(" | ").append("TACTIC_DEF:").append((attacker[0]).TACTIC_DEF).append(" | ").append("ATT_B:").append((attacker[0]).ATT_B).append(" | ").append("DEF_B:").append((attacker[0]).DEF_B).append(" | ").append("Str:").append((attacker[0]).Str).append(" | ").append("Lea:").append((attacker[0]).Lea).append(" | ").append("tech_yingyong_damage_e:").append((attacker[0]).tech_yingyong_damage_e).append(" | ").append("tactic_id:").append((attacker[0]).tactic_id).append(" | ").append("tactic_damage_e:").append((attacker[0]).tactic_damage_e).append(" | ").append("tactic_range:").append((attacker[0]).tactic_range).append(" | ").append("world_weaken_frontLine_buff:").append((attacker[0]).world_weaken_frontLine_buff).append(" | ").append("isCityAttacker:").append((attacker[0]).isCityAttacker).append(" | ").append("isBS:").append((attacker[0]).isBS).append(" | ").append("BS_My:").append((attacker[0]).BS_My).append(" | ").append("BS_Your:").append((attacker[0]).BS_Your).append(" | ").append("isYX:").append((attacker[0]).isYX).append(" | ").append("YX_cur_Blood:").append((attacker[0]).YX_cur_Blood).append(" | ").append("YX_max_Blood:").append((attacker[0]).YX_max_Blood).append(" | ").append("\n\t");
      roundInfo.caculateDebugBuffer.append("Before Tactic Defenders.").append("\n\t");
      for (int i = 0; i < defenders.length; i++)
        roundInfo.caculateDebugBuffer.append("hp:").append((defenders[i][0]).hp).append(" | ").append("max_hp:").append((defenders[i][0]).max_hp).append(" | ").append("att:").append((defenders[i][0]).att).append(" | ").append("def:").append((defenders[i][0]).def).append(" | ").append("TACTIC_ATT:").append((defenders[i][0]).TACTIC_DEF).append(" | ").append("TACTIC_DEF:").append((defenders[i][0]).TACTIC_DEF).append(" | ").append("ATT_B:").append((defenders[i][0]).ATT_B).append(" | ").append("DEF_B:").append((defenders[i][0]).DEF_B).append(" | ").append("Str:").append((defenders[i][0]).Str).append(" | ").append("Lea:").append((defenders[i][0]).Lea).append(" | ").append("isTD:").append((defenders[i][0]).isTD).append(" | ").append("TD_defense_e:").append((defenders[i][0]).TD_defense_e).append(" | ").append("\n\t"); 
    } 
  }
  
  public static void saveTacticDetailAfter(RoundInfo roundInfo, TacticInfo tacticInfo, TroopData[] attacker, TroopData[][] defenders) {
    String debug = Configuration.getProperty("gcld.battle.caculate.debug");
    if (debug.equals("1")) {
      String[] Result = tacticInfo.tacticStr.split(";");
      roundInfo.caculateDebugBuffer.append("Tactic Reports.").append("\n\t");
      for (int i = 0; i < Result.length; i++) {
        String result = Result[i];
        roundInfo.caculateDebugBuffer.append(result).append("\n\t");
      } 
    } 
  }
  
  public static void saveFightDetailBefore(RoundInfo roundInfo) {
    String debug = Configuration.getProperty("gcld.battle.caculate.debug");
    if (debug.equals("1")) {
      roundInfo.caculateDebugBuffer.append("Before Fight Att.").append("\n\t");
      roundInfo.caculateDebugBuffer.append("hp:").append((roundInfo.troopData[0][0]).hp).append(" | ").append("max_hp:").append((roundInfo.troopData[0][0]).max_hp).append(" | ").append("att:").append((roundInfo.troopData[0][0]).att).append(" | ").append("def:").append((roundInfo.troopData[0][0]).def).append(" | ").append("ATT_B:").append((roundInfo.troopData[0][0]).ATT_B).append(" | ").append("DEF_B:").append((roundInfo.troopData[0][0]).DEF_B).append(" | ").append("Str:").append((roundInfo.troopData[0][0]).Str).append(" | ").append("Lea:").append((roundInfo.troopData[0][0]).Lea).append(" | ").append("terrain_effect:").append((roundInfo.troopData[0][0]).terrain_effect).append(" | ").append("all_damage_e:").append((roundInfo.troopData[0][0]).all_damage_e).append(" | ").append("world_weaken_besiege:").append((roundInfo.troopData[0][0]).world_weaken_besiege).append(" | ").append("world_weaken_frontLine_buff:").append((roundInfo.troopData[0][0]).world_weaken_frontLine_buff).append("\n\t");
      roundInfo.caculateDebugBuffer.append("Before Fight Def.").append("\n\t");
      roundInfo.caculateDebugBuffer.append("hp:").append((roundInfo.troopData[1][0]).hp).append(" | ").append("max_hp:").append((roundInfo.troopData[1][0]).max_hp).append(" | ").append("att:").append((roundInfo.troopData[1][0]).att).append(" | ").append("def:").append((roundInfo.troopData[1][0]).def).append(" | ").append("ATT_B:").append((roundInfo.troopData[1][0]).ATT_B).append(" | ").append("DEF_B:").append((roundInfo.troopData[1][0]).DEF_B).append(" | ").append("Str:").append((roundInfo.troopData[1][0]).Str).append(" | ").append("Lea:").append((roundInfo.troopData[1][0]).Lea).append(" | ").append("terrain_effect:").append((roundInfo.troopData[1][0]).terrain_effect).append(" | ").append("all_damage_e:").append((roundInfo.troopData[1][0]).all_damage_e).append(" | ").append("world_weaken_besiege:").append((roundInfo.troopData[1][0]).world_weaken_besiege).append(" | ").append("world_weaken_frontLine_buff:").append((roundInfo.troopData[1][0]).world_weaken_frontLine_buff).append("\n\t");
    } 
  }
  
  public static void saveFightDetailAfter(RoundInfo roundInfo) {
    String debug = Configuration.getProperty("gcld.battle.caculate.debug");
    if (debug.equals("1")) {
      roundInfo.caculateDebugBuffer.append("Fight Reports.").append("\n\t");
      for (int i = 0; i < roundInfo.reports.length; i++) {
        String report = roundInfo.reports[i];
        roundInfo.caculateDebugBuffer.append(report).append("\n\t");
      } 
      roundInfo.caculateDebugBuffer.append("After Fight Att.").append("\n\t");
      roundInfo.caculateDebugBuffer.append("hp:").append((roundInfo.troopData[0][0]).hp).append(" | ").append("max_hp:").append((roundInfo.troopData[0][0]).max_hp).append("\n\t");
      roundInfo.caculateDebugBuffer.append("After Fight Def.").append("\n\t");
      roundInfo.caculateDebugBuffer.append("hp:").append((roundInfo.troopData[1][0]).hp).append(" | ").append("max_hp:").append((roundInfo.troopData[1][0]).max_hp).append("\n\t");
    } 
  }
  
  protected static boolean exeTactic(IDataGetter dataGetter, int batSide, Tactic tactic, TacticInfo tacticInfo, CampArmy campA, CampArmy campB, Battle bat, List<BattleArmy> killedList, RoundInfo roundInfo, List<BattleArmy> baListB, boolean isRebound, boolean iszhugeliang, boolean zuoqiskill) {
    if (!iszhugeliang) {
      roundInfo.nextMinExeTime += tactic.getPlayertime().intValue() + 3000;
      roundInfo.timePredicationBuffer.append("tactic:").append(tactic.getPlayertime().intValue() + 3000).append("|");
      tacticInfo.tacticId = tactic.getId().intValue();
      tacticInfo.tacticDisplayId = tactic.getDisplayId().intValue();
      tacticInfo.tacticNameId = tactic.getPic().intValue();
      tacticInfo.tacticBasicPic = tactic.getBasicPic();
      tacticInfo.specialType = tactic.getSpecialType();
    } else {
      roundInfo.nextMinExeTime += 4500;
      roundInfo.timePredicationBuffer.append("tactic:").append(4500).append("|");
    } 
    boolean firstRowKilled = false;
    List<BattleArmy> listA = bat.attList;
    List<BattleArmy> listB = bat.defList;
    List<CampArmy> campsB = bat.defCamp;
    if (batSide == 0) {
      listA = bat.defList;
      listB = bat.attList;
      campsB = bat.attCamp;
    } 
    TroopData[] attacker = new TroopData[3];
    if (isRebound) {
      copyTacticBattleInfo(listB.get(0), campB, attacker, tactic, dataGetter, !(!(((BattleArmy)listB.get(0)).getCampArmy()).isBarPhantom && !(((BattleArmy)listB.get(0)).getCampArmy()).isBarEA));
    } else {
      copyTacticBattleInfo(listA.get(0), campA, attacker, tactic, dataGetter, !(!(((BattleArmy)listB.get(0)).getCampArmy()).isBarPhantom && !(((BattleArmy)listB.get(0)).getCampArmy()).isBarEA));
    } 
    double world_frontLine_buff_att_def_e = 0.0D;
    int yingYong = 0;
    boolean isCityAttacker = false;
    boolean isBS = false;
    if ((batSide == 1 && bat.world_frontLine_buff_att_def_e_side == 1) || (batSide == 0 && bat.world_frontLine_buff_att_def_e_side == 2))
      world_frontLine_buff_att_def_e = bat.world_frontLine_buff_att_def_e; 
    if (campA.playerId > 0)
      yingYong = dataGetter.getTechEffectCache().getTechEffect(campA.playerId, 10); 
    if ((bat.battleType == 3 || bat.battleType == 13) && batSide == 1 && bat.getTerrainVal() == 4 && (tactic == null || !tactic.getSpecialEffect().equalsIgnoreCase("siege_gun")))
      isCityAttacker = true; 
    int attackerBSNum = 0;
    int defenderBSNum = 0;
    if ((bat.getBattleType() == 3 || bat.getBattleType() == 13) && tactic != null && tactic.getSpecialEffect().equalsIgnoreCase("bs")) {
      isBS = true;
      Battle battleBSTemp = bat;
      if (bat.getBattleType() == 13) {
        battleBSTemp = NewBattleManager.getInstance().getBattleByDefId(3, bat.defBaseInfo.id);
        if (battleBSTemp == null)
          battleBSTemp = bat; 
      } 
      attackerBSNum = battleBSTemp.attCamp.size();
      defenderBSNum = battleBSTemp.defCamp.size();
      if (batSide == 0) {
        attackerBSNum = battleBSTemp.defCamp.size();
        defenderBSNum = battleBSTemp.attCamp.size();
      } 
    } 
    boolean isYX = false;
    int YX_cur_Blood = 0;
    int YX_max_Blood = 0;
    if ((campA.getSpecialGeneral()).generalType == 9) {
      isYX = true;
      YX_cur_Blood = campA.getArmyHpOrg() - campA.getArmyHpLoss();
      YX_max_Blood = campA.getArmyHpOrg();
    } 
    for (int i = 0; i < attacker.length; i++) {
      (attacker[i]).world_weaken_frontLine_buff = world_frontLine_buff_att_def_e;
      (attacker[i]).tech_yingyong_damage_e = yingYong;
      (attacker[i]).isCityAttacker = isCityAttacker;
      (attacker[i]).isBS = isBS;
      (attacker[i]).BS_My = attackerBSNum;
      (attacker[i]).BS_Your = defenderBSNum;
      (attacker[i]).isYX = isYX;
      (attacker[i]).YX_cur_Blood = YX_cur_Blood;
      (attacker[i]).YX_max_Blood = YX_max_Blood;
    } 
    TroopData[][] defenders = new TroopData[listB.size()][3];
    copyTacticBattleInfo(campsB, listB, defenders, dataGetter, !(!(((BattleArmy)listA.get(0)).getCampArmy()).isBarPhantom && !(((BattleArmy)listA.get(0)).getCampArmy()).isBarEA));
    if (campB.playerId > 0) {
      int jianren = dataGetter.getTechEffectCache().getTechEffect(campB.playerId, 13);
      for (int j = 0; j < listB.size(); j++) {
        for (int k = 0; k < 3; k++)
          (defenders[j][k]).tech_jianren_damage_e = jianren; 
      } 
    } 
    saveTacticDetailBefore(roundInfo, attacker, defenders);
    if (bat.tucheng && batSide == 1) {
      int direnlen = defenders.length;
      if (direnlen > 5)
        direnlen = 5; 
      String report = "";
      for (int l = 0; l < direnlen; l++) {
        TroopData[] direnrow = defenders[l];
        for (int m = 0; m < direnrow.length; m++) {
          TroopData diren = direnrow[m];
          int damage = diren.hp;
          if (damage < 0)
            damage = 0; 
          report = String.valueOf(String.valueOf(report)) + damage;
          if (m < direnrow.length - 1)
            report = String.valueOf(String.valueOf(report)) + ","; 
        } 
        if (l < direnlen - 1)
          report = String.valueOf(String.valueOf(report)) + ";"; 
      } 
      tacticInfo.tacticStr = report;
    } else if ((attacker[0]).generalId >= 101003 && (attacker[0]).generalId <= 101006) {
      int direnlen = defenders.length;
      if (direnlen > 5)
        direnlen = 5; 
      String report = "";
      boolean zhaoyunchidiao = false;
      for (int i2 = 1; i2 < direnlen; i2++) {
        TroopData[] direnrow2 = defenders[i2];
        int damage2 = 2000;
        if (zhaoyunchidiao) {
          damage2 = 1;
        } else if ((direnrow2[0]).chizhanfa > 0) {
          damage2 *= direnlen - i2;
          zhaoyunchidiao = true;
        } 
        for (int j2 = 0; j2 < direnrow2.length; j2++) {
          TroopData diren2 = direnrow2[j2];
          if (damage2 > diren2.hp)
            damage2 = diren2.hp; 
          if (diren2.havezhanche && diren2.hujia > 0 && damage2 > 0) {
            report = String.valueOf(String.valueOf(report)) + "1";
            TroopData troopData = diren2;
            troopData.hujia--;
          } else if (diren2.carskill > 1 && diren2.zcdun > 0 && damage2 > 0) {
            report = String.valueOf(String.valueOf(report)) + "1";
            TroopData troopData2 = diren2;
            troopData2.zcdun--;
          } else if (diren2.shield > 0 && damage2 > 0) {
            if (diren2.shiledtype == 2) {
              report = String.valueOf(String.valueOf(report)) + "1";
              TroopData troopData3 = diren2;
              troopData3.shield--;
            } else {
              if (damage2 > diren2.shield && damage2 > 0)
                damage2 = diren2.shield; 
              report = String.valueOf(String.valueOf(report)) + damage2;
              TroopData troopData4 = diren2;
              troopData4.shield -= damage2;
            } 
          } else {
            report = String.valueOf(String.valueOf(report)) + damage2;
          } 
          if (j2 < direnrow2.length - 1)
            report = String.valueOf(String.valueOf(report)) + ","; 
        } 
        if (i2 < direnlen - 1)
          report = String.valueOf(String.valueOf(report)) + ";"; 
      } 
      tacticInfo.tacticStr = report;
    } else if ((attacker[0]).generalId == 203 && (attacker[0]).tactic_id == 1112 && !zuoqiskill) {
      int direnlen = defenders.length;
      if (direnlen > 3)
        direnlen = 3; 
      String report = "";
      for (int l = 0; l < direnlen; l++) {
        TroopData[] direnrow = defenders[l];
        boolean zhaoyunmian = false;
        for (int j3 = 0; j3 < direnrow.length; j3++) {
          TroopData diren3 = direnrow[j3];
          int damage3 = diren3.hp - 1;
          if (diren3.generalId == 73051 || diren3.isbeatmonster > 0 || (diren3.generalId == 232 && diren3.unionrank > 0) || diren3.legeneEvoke) {
            damage3 = (attacker[0]).att - diren3.def + (attacker[0]).TACTIC_ATT - diren3.TACTIC_DEF;
            if (damage3 <= 0)
              damage3 = 1; 
          } 
          if (damage3 < 0)
            damage3 = 0; 
          if (diren3.havezhanche && diren3.hujia > 0) {
            report = String.valueOf(String.valueOf(report)) + diren3.naijiu;
            TroopData troopData5 = diren3;
            troopData5.hujia -= diren3.naijiu;
          } else if (diren3.carskill > 1 && diren3.zcdun > 0) {
            report = String.valueOf(String.valueOf(report)) + diren3.naijiu;
            TroopData troopData6 = diren3;
            troopData6.zcdun -= diren3.naijiu;
          } else if (diren3.shield > 0) {
            if (diren3.shiledtype == 2) {
              report = String.valueOf(String.valueOf(report)) + diren3.naijiu;
              TroopData troopData7 = diren3;
              troopData7.shield -= diren3.naijiu;
            } else {
              report = String.valueOf(String.valueOf(report)) + diren3.shield;
              diren3.shield = 0;
            } 
          } else if (diren3.generalId == 204 && diren3.sanzhenbao > 0) {
            report = String.valueOf(String.valueOf(report)) + (diren3.hp / 3);
            zhaoyunmian = true;
          } else {
            report = String.valueOf(String.valueOf(report)) + damage3;
          } 
          if (j3 < direnrow.length - 1)
            report = String.valueOf(String.valueOf(report)) + ","; 
        } 
        if (zhaoyunmian)
          break; 
        if (l < direnlen - 1)
          report = String.valueOf(String.valueOf(report)) + ";"; 
      } 
      tacticInfo.tacticStr = report;
    } else if ((attacker[0]).generalId == 269 && (attacker[0]).troopType == 47 && !zuoqiskill) {
      int gailv1 = RandomUtils.nextInt(100);
      if (gailv1 <= 30) {
        if (batSide == 1) {
          roundInfo.attzgl = 2;
        } else {
          roundInfo.defzgl = 2;
        } 
      } else {
        int gailv2 = RandomUtils.nextInt(100);
        if (gailv2 <= 50) {
          if (batSide == 1) {
            roundInfo.attzgl = 1;
          } else {
            roundInfo.defzgl = 1;
          } 
        } else if (gailv2 <= 90) {
          if (batSide == 1) {
            roundInfo.attzgl = 4;
            roundInfo.attzglNum = 2;
          } else {
            roundInfo.defzgl = 4;
            roundInfo.defzglNum = 2;
          } 
          int direnlen2 = defenders.length;
          if (direnlen2 > 4)
            direnlen2 = 4; 
          String report2 = "";
          boolean zhaoyunchidiao2 = false;
          for (int i3 = 0; i3 < direnlen2; i3++) {
            TroopData[] direnrow3 = defenders[i3];
            for (int j4 = 0; j4 < direnrow3.length; j4++) {
              TroopData diren4 = direnrow3[j4];
              int damage4 = Fight.getOneDamage(attacker[0], direnrow3[0], false, 0, 4);
              if (zhaoyunchidiao2) {
                damage4 = 1;
              } else if (diren4.chizhanfa > 0) {
                damage4 *= direnlen2 - i3;
                zhaoyunchidiao2 = true;
              } 
              if (damage4 > diren4.hp)
                damage4 = diren4.hp; 
              if (damage4 < 0)
                damage4 = 0; 
              if (diren4.havezhanche && diren4.hujia > 0 && damage4 > 0) {
                if (damage4 >= diren4.pojia) {
                  report2 = String.valueOf(String.valueOf(report2)) + diren4.naijiu;
                  TroopData troopData8 = diren4;
                  troopData8.hujia -= diren4.naijiu;
                } else {
                  report2 = String.valueOf(String.valueOf(report2)) + '\001';
                  TroopData troopData9 = diren4;
                  troopData9.hujia--;
                } 
              } else if (diren4.carskill > 1 && diren4.zcdun > 0 && damage4 > 0) {
                if (damage4 >= diren4.pojia / 2) {
                  report2 = String.valueOf(String.valueOf(report2)) + diren4.naijiu;
                  TroopData troopData10 = diren4;
                  troopData10.zcdun -= diren4.naijiu;
                } else {
                  report2 = String.valueOf(String.valueOf(report2)) + '\001';
                  TroopData troopData11 = diren4;
                  troopData11.zcdun--;
                } 
              } else if (diren4.shield > 0 && damage4 > 0) {
                if (diren4.shiledtype == 2) {
                  if (damage4 >= diren4.pojia / 2) {
                    report2 = String.valueOf(String.valueOf(report2)) + diren4.naijiu;
                    TroopData troopData12 = diren4;
                    troopData12.shield -= diren4.naijiu;
                  } else {
                    report2 = String.valueOf(String.valueOf(report2)) + '\001';
                    TroopData troopData13 = diren4;
                    troopData13.shield--;
                  } 
                } else {
                  if (damage4 > diren4.shield)
                    damage4 = diren4.shield; 
                  report2 = String.valueOf(String.valueOf(report2)) + damage4;
                  TroopData troopData14 = diren4;
                  troopData14.shield -= damage4;
                } 
              } else {
                report2 = String.valueOf(String.valueOf(report2)) + damage4;
              } 
              if (j4 < direnrow3.length - 1)
                report2 = String.valueOf(String.valueOf(report2)) + ","; 
            } 
            if (i3 < direnlen2 - 1)
              report2 = String.valueOf(String.valueOf(report2)) + ";"; 
          } 
          tacticInfo.tacticStr = report2;
        } else {
          if (batSide == 1) {
            roundInfo.attzgl = 4;
            roundInfo.attzglNum = 1;
          } else {
            roundInfo.defzgl = 4;
            roundInfo.defzglNum = 1;
          } 
          int direnlen2 = defenders.length;
          if (direnlen2 >= 1) {
            String report2 = "";
            TroopData[] direnrow2 = defenders[0];
            for (int j3 = 0; j3 < direnrow2.length; j3++) {
              TroopData diren3 = direnrow2[j3];
              int damage3 = diren3.hp;
              if (diren3.generalId == 73051 || diren3.isbeatmonster > 0 || (diren3.generalId == 232 && diren3.unionrank > 0) || diren3.legeneEvoke)
                damage3 = (attacker[0]).att - diren3.def + (attacker[0]).TACTIC_ATT - diren3.TACTIC_DEF; 
              if (damage3 < 0)
                damage3 = 0; 
              if (diren3.havezhanche && diren3.hujia > 0) {
                report2 = String.valueOf(String.valueOf(report2)) + diren3.naijiu;
                TroopData troopData15 = diren3;
                troopData15.hujia -= diren3.naijiu;
              } else if (diren3.carskill > 1 && diren3.zcdun > 0) {
                report2 = String.valueOf(String.valueOf(report2)) + diren3.naijiu;
                TroopData troopData16 = diren3;
                troopData16.zcdun -= diren3.naijiu;
              } else if (diren3.shield > 0) {
                if (diren3.shiledtype == 2) {
                  report2 = String.valueOf(String.valueOf(report2)) + diren3.naijiu;
                  TroopData troopData17 = diren3;
                  troopData17.shield -= diren3.naijiu;
                } else {
                  if (damage3 > diren3.shield)
                    damage3 = diren3.shield; 
                  report2 = String.valueOf(String.valueOf(report2)) + diren3.shield;
                  TroopData troopData18 = diren3;
                  troopData18.shield -= damage3;
                } 
              } else if (diren3.generalId == 204 && diren3.isjuexing > 0) {
                report2 = String.valueOf(String.valueOf(report2)) + (damage3 / 2);
              } else {
                report2 = String.valueOf(String.valueOf(report2)) + damage3;
              } 
              if (j3 < direnrow2.length - 1)
                report2 = String.valueOf(String.valueOf(report2)) + ","; 
            } 
            tacticInfo.tacticStr = report2;
          } 
        } 
      } 
      if (tacticInfo.tacticStr == null)
        tacticInfo.tacticStr = ""; 
    } else {
      tacticInfo.tacticStr = Tactic.tacticAttack(attacker, defenders, bat.terrainVal);
    } 
    if (campA.getGeneralId() == 278 && campA.getIsJuexing() > 0 && !zuoqiskill)
      if (batSide == 1) {
        roundInfo.attBattleArmy.setYzdq(1);
        getReportType60(roundInfo.battleMsg, "att", roundInfo.attBattleArmy.getPosition());
      } else {
        roundInfo.defBattleArmy.setYzdq(1);
        getReportType60(roundInfo.battleMsg, "def", roundInfo.defBattleArmy.getPosition());
      }  
    if (tacticInfo.tacticStr.equalsIgnoreCase("SP")) {
      tacticInfo.beStop = true;
      roundInfo.timePredicationBuffer.append("tactic is stoped:").append(0).append("|");
      BattleSceneLog.getInstance().appendLogMsg("tactic is stoped.");
      return firstRowKilled;
    } 
    General generalA = null;
    if (isRebound) {
      generalA = (General)dataGetter.getGeneralCache().get(Integer.valueOf(campB.getGeneralId()));
    } else {
      generalA = (General)dataGetter.getGeneralCache().get(Integer.valueOf(campA.getGeneralId()));
    } 
    if (generalA != null && generalA.getGeneralSpecialInfo() != null && (generalA.getGeneralSpecialInfo()).generalType == 10) {
      int wuShenFuTiLimit = (generalA.getGeneralSpecialInfo()).rowNum;
      if (listA.size() < wuShenFuTiLimit)
        wuShenFuTiLimit = listA.size(); 
      for (int l2 = 0; l2 < wuShenFuTiLimit; l2++) {
        ((BattleArmy)listA.get(l2)).setIsTd(true);
        ((BattleArmy)listA.get(l2)).setTD_defense_e((generalA.getGeneralSpecialInfo()).param2);
      } 
    } 
    if ((tactic != null && (tactic.getId().intValue() == 1757 || tactic.getId().intValue() == 17571)) || tactic.getId().intValue() == 9991306)
      for (int q = 0; q < listA.size(); q++) {
        ((BattleArmy)listA.get(q)).setIsTd(true);
        ((BattleArmy)listA.get(q)).setTD_defense_e(0.8D);
      }  
    if (tactic != null && tactic.getId().intValue() == 3604 && listB.size() > 0)
      ((BattleArmy)listB.get(0)).getCampArmy().setHuoYi(1); 
    if (tacticInfo.specialType > 0) {
      if (tacticInfo.specialType == 2) {
        tacticInfo.specialEffect = tactic.getSpecialEffect();
        tacticInfo.reward = tactic.getReward();
        RewardInfo ri = tacticInfo.reward.getReward(dataGetter, campA.getPlayerId(), Integer.valueOf(campA.getGeneralId()));
        if (ri != null) {
          tacticInfo.tacticDrop = new BattleDrop();
          tacticInfo.tacticDrop.type = ri.getType();
          tacticInfo.tacticDrop.num = ri.getAddValue();
        } 
        roundInfo.nextMinExeTime += 25000;
        roundInfo.timePredicationBuffer.append("rob food tactic:").append(25000).append("|");
        return firstRowKilled;
      } 
      int hunluangailv = RandomUtils.nextInt(100);
      if (tacticInfo.specialType == 1) {
        int range = tactic.getRange().intValue();
        StringBuilder sb = new StringBuilder();
        for (int m2 = 0; m2 < range && baListB.size() > m2; m2++) {
          if (hunluangailv >= ((BattleArmy)baListB.get(m2)).getCampArmy().getMianYiGaiLv()) {
            ((BattleArmy)baListB.get(m2)).setSpecial(1);
            sb.append(((BattleArmy)baListB.get(m2)).getPosition()).append(",");
          } 
        } 
        tacticInfo.columnStr = sb.toString();
      } 
    } 
    saveTacticDetailAfter(roundInfo, tacticInfo, attacker, defenders);
    if (!StringUtils.isEmpty(tacticInfo.tacticStr)) {
      roundInfo.nextMinExeTime += 1500;
      roundInfo.timePredicationBuffer.append("tactic reduce:").append(1500).append("|");
      String[] tacs = tacticInfo.tacticStr.split(";");
      Map<CampArmy, Integer> reduceMap = new HashMap<>();
      int campBId = campB.getId();
      boolean needreport52 = false;
      int shalejipai = 0;
      int qianarmyid = 0;
      int zyrow = -1;
      if (tacticInfo.tacticId == 3601)
        zyrow = RandomUtils.nextInt(tacs.length); 
      for (int i4 = 0; i4 < tacs.length; i4++) {
        if (tacs[i4].contains("jsBJ"))
          tacticInfo.zfBJ = true; 
        if (tacs[i4].contains("jsJB"))
          tacticInfo.zfJB = true; 
        String[] tempArr = tacs[i4].split("\\|");
        String tempStr = tempArr[tempArr.length - 1];
        String[] tacStr = tempStr.split(",");
        BattleArmy batArmy = listB.get(i4);
        CampArmy defendCa = batArmy.getCampArmy();
        int reduce = 0;
        if (i4 == zyrow)
          batArmy.setZyNum(batArmy.getZyNum() + 1); 
        int perReduce = Integer.valueOf(tacStr[0]).intValue();
        int reallost = (defenders[i4][0]).reallostHp;
        if (perReduce < 0) {
          perReduce = 0;
          if (campB.getGeneralId() == 201 && campB.getUnionRank() >= 2)
            campB.setNeedFgyj(true); 
        } 
        if (campA.generalId == 266 && campA.isjuexing > 0 && tactic.getId().intValue() == 1702 && i4 == 0 && !batArmy.getHaveZhanChe() && !zuoqiskill && listB.size() > 1 && defendCa.generalId != 204 && defendCa.isjuexing <= 0) {
          roundInfo.needreport43 = true;
          reallost = batArmy.getTroopHp()[0];
          roundInfo.dcss = batArmy.getTroopHp()[0];
          CampArmy tempcamp = new CampArmy();
          tempcamp.setPlayerId(campA.getPlayerId());
          tempcamp.setPayTotal(campA.getPayTotal());
          tempcamp.setPlayerName(campA.getPlayerName());
          tempcamp.setForceId(campA.getForceId());
          tempcamp.setPlayerLv(campA.getPlayerLv());
          tempcamp.setId(bat.campNum.getAndIncrement());
          tempcamp.setUpdateDB(false);
          tempcamp.setPgmVId(0);
          tempcamp.setArmyName(defendCa.getArmyName());
          tempcamp.setGeneralId(defendCa.getGeneralId());
          tempcamp.setGeneralName(defendCa.getGeneralName());
          tempcamp.setGeneralLv(defendCa.getGeneralLv());
          tempcamp.setSpecialGeneral(defendCa.getSpecialGeneral());
          tempcamp.setGeneralPic(defendCa.getGeneralPic());
          tempcamp.setQuality(defendCa.getQuality());
          tempcamp.setStrength(defendCa.getStrength());
          tempcamp.setLeader(defendCa.getLeader());
          tempcamp.setTacicId(defendCa.getTacicId());
          int zfcishu = defendCa.getTacticVal();
          tempcamp.setTacticVal(zfcishu);
          if (zfcishu > 0)
            defendCa.setTacticVal(zfcishu - 1); 
          tempcamp.setTroopId(defendCa.getTroopId());
          tempcamp.setTroopSerial(defendCa.getTroopSerial());
          tempcamp.setTroopType(defendCa.getTroopType());
          tempcamp.setTroopName(defendCa.getTroopName());
          tempcamp.setTroopDropType(defendCa.getTroopDropType());
          tempcamp.setTroopDrop(defendCa.getTroopDrop());
          tempcamp.setAttEffect(defendCa.getAttEffect());
          tempcamp.setDefEffect(defendCa.getDefEffect());
          tempcamp.setBdEffect(defendCa.getBdEffect());
          tempcamp.setTroopHp(defendCa.getTroopHp());
          tempcamp.setArmyHp(0);
          tempcamp.setArmyHpOrg(defendCa.getArmyHpOrg());
          tempcamp.setArmyHpLoss(0);
          tempcamp.setMaxForces(defendCa.getMaxForces());
          tempcamp.setColumn(defendCa.getColumn());
          tempcamp.setStrategies(defendCa.getStrategies());
          tempcamp.setIsJuexing(defendCa.getIsJuexing());
          tempcamp.setZsJqSkillLevel(defendCa.getZsJqSkillLevel());
          tempcamp.setSex(defendCa.getSex());
          tempcamp.setBuQu(defendCa.getBuQu());
          tempcamp.setCopyType(defendCa.getCopyType());
          tempcamp.setJueEquip(defendCa.getJueEquip());
          tempcamp.setDefence(defendCa.getDefence());
          tempcamp.setCarId(defendCa.getCarId());
          tempcamp.setCarModel(defendCa.getCarModel());
          tempcamp.setBigGzNum(defendCa.getBigGzNum());
          tempcamp.setzfShield(defendCa.getzfShield());
          tempcamp.setCarHp(defendCa.getCarHp());
          tempcamp.setCarMaxHp(defendCa.getCarMaxHp());
          tempcamp.setJxType(defendCa.getJxType());
          tempcamp.setHujia(defendCa.getHujia());
          tempcamp.setSiCheHuJia(defendCa.getSiCheHuJia());
          tempcamp.setNaijiu(defendCa.getNaijiu());
          tempcamp.setPojia(defendCa.getPojia());
          tempcamp.setCatapultSkill(defendCa.getCatapultSkill());
          tempcamp.setPingKan(defendCa.getPingKan());
          tempcamp.setPingKanDef(defendCa.getPingKanDef());
          tempcamp.setYcbwHujia(defendCa.getYcbwHujia());
          tempcamp.setYcbwPojia(defendCa.getYcbwPojia());
          tempcamp.setDingJun(defendCa.getDingJun());
          tempcamp.setKaiShan(defendCa.getKaiShan());
          tempcamp.setYbTx(defendCa.getYbTx());
          tempcamp.setWsb(defendCa.getWsb());
          tempcamp.setUnionRank(defendCa.getUnionRank());
          tempcamp.setUnionState(defendCa.getUnionState());
          tempcamp.setAttackLevel(defendCa.getAttackLevel());
          BattleArmy tempbatArmy = new BattleArmy();
          tempbatArmy.setCampArmy(tempcamp);
          for (int i5 = 0; i5 < 3; i5++)
            tempbatArmy.getTroopHp()[i5] = batArmy.getTroopHp()[0]; 
          tempbatArmy.setIsDajiang(batArmy.getIsDajiang());
          tempbatArmy.setZhenXiaHouYuan(batArmy.getZhenXiaHouYuan());
          tempbatArmy.setStrategy(batArmy.getStrategy());
          tempbatArmy.setZhenFaJianShang(batArmy.getZhenFaJianShang());
          tempbatArmy.setShield(batArmy.getShield());
          tempbatArmy.setZCdunHp(batArmy.getZCdunHp());
          tempbatArmy.setMaxShield(batArmy.getMaxShield());
          tempbatArmy.setShiledType(batArmy.getShiledType());
          tempbatArmy.setYzdq(batArmy.getYzdq());
          tempbatArmy.setZhanchedun(batArmy.getZhanchedun());
          tempbatArmy.setZfShiled(batArmy.getZfShiled());
          tempbatArmy.setTouXian(batArmy.getTouXian());
          tempbatArmy.setTitle(batArmy.getTitle());
          tempbatArmy.setTitle1(batArmy.getTitle1());
          tempbatArmy.setFuBingNum1(batArmy.getFuBingNum1());
          tempbatArmy.setSangDanType(batArmy.getSangDanType());
          tempbatArmy.setHaveZhanche(batArmy.getHaveZhanChe());
          tempbatArmy.setNaiJiu(batArmy.getNaiJiu());
          tempbatArmy.setSiCheDier(batArmy.getSiCheDier());
          tempbatArmy.setHuJia(batArmy.getHuJia());
          tempbatArmy.setCarHp(batArmy.getCarHp());
          tempbatArmy.setCarMaxHp(batArmy.getCarMaxHp());
          tempbatArmy.setBigGzNum(batArmy.getBigGzNum());
          tempbatArmy.setCatapultSkill(batArmy.getCatapultSkill());
          tempbatArmy.setZhenXiaHouYuan(batArmy.getZhenXiaHouYuan());
          tempbatArmy.setStrategy(batArmy.getStrategy());
          tempbatArmy.setGlShuiBao(batArmy.getGlShuiBao());
          tempbatArmy.setZhenFaJianShang(batArmy.getZhenFaJianShang());
          tempbatArmy.setBaiBuChuanYang(batArmy.getBaiBuChuanYang());
          tempbatArmy.setBloodOrg(batArmy.getBloodOrg());
          if (batSide == 1) {
            bat.attCamp.add(0, tempcamp);
            tempbatArmy.setPosition(bat.attQNum.getAndIncrement());
            bat.attList.add(0, tempbatArmy);
            bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() + batArmy.getTroopHp()[0] * (batArmy.getTroopHp()).length);
            bat.getAttBaseInfo().setAllNum(bat.getAttBaseInfo().getAllNum() + batArmy.getTroopHp()[0] * (batArmy.getTroopHp()).length);
          } else {
            bat.defCamp.add(0, tempcamp);
            tempbatArmy.setPosition(bat.defQNum.getAndIncrement());
            bat.defList.add(0, tempbatArmy);
            bat.getDefBaseInfo().setNum(bat.getDefBaseInfo().getNum() + batArmy.getTroopHp()[0] * (batArmy.getTroopHp()).length);
            bat.getDefBaseInfo().setAllNum(bat.getDefBaseInfo().getAllNum() + batArmy.getTroopHp()[0] * (batArmy.getTroopHp()).length);
          } 
          roundInfo.needreport47 = true;
        } 
        if (reallost >= batArmy.getTroopHp()[0]) {
          reallost = batArmy.getTroopHp()[0];
          killedList.add(batArmy);
          if (i4 == 0) {
            firstRowKilled = true;
            if (batSide == 0) {
              roundInfo.win = 2;
            } else {
              roundInfo.win = 1;
            } 
          } 
          shalejipai++;
        } 
        if (defendCa.getGeneralId() == 204 && defendCa.getIsJuexing() > 0 && !zuoqiskill && !defendCa.getLegendEvoke()) {
          double oldxue = batArmy.getTroopHp()[0] * 100.0D / defendCa.getMaxForces();
          double xinxue = (batArmy.getTroopHp()[0] - perReduce) * 100.0D / defendCa.getMaxForces();
          if ((oldxue > 80.0D && xinxue <= 80.0D) || (oldxue > 50.0D && xinxue <= 50.0D) || (oldxue > 20.0D && xinxue <= 20.0D))
            defendCa.setZhaoYunQijinQiChu(true); 
        } 
        if ((defendCa.generalId == 224 && defendCa.isjuexing > 0) || (defendCa.generalId == 416 && defendCa.getChapterId() >= 1 && !zuoqiskill && defendCa.buqu < 20)) {
          CampArmy campArmy = defendCa;
          campArmy.buqu += 4;
          needreport52 = true;
        } 
        if (batArmy.getHuJia() > (defenders[i4][0]).hujia)
          batArmy.setHuJia((defenders[i4][0]).hujia); 
        if (batArmy.getZCdunHp() > (defenders[i4][0]).zcdun)
          batArmy.setZCdunHp((defenders[i4][0]).zcdun); 
        if (batArmy.getShield() > (defenders[i4][0]).shield)
          batArmy.setShield((defenders[i4][0]).shield); 
        if (batArmy.getZfShiled() > (defenders[i4][0]).zfshield)
          batArmy.setZfShiled((defenders[i4][0]).zfshield); 
        if (batArmy.getCampArmy().getMissNum() > (defenders[i4][0]).missnum)
          batArmy.getCampArmy().setMissNum((defenders[i4][0]).missnum); 
        if (batArmy.getCampArmy().getDiKang() > (defenders[i4][0]).dikang)
          batArmy.getCampArmy().setDiKang((defenders[i4][0]).dikang); 
        if (batArmy.getCampArmy().getDefence() > (defenders[i4][0]).defense)
          batArmy.getCampArmy().setDefence((defenders[i4][0]).defense); 
        if (i4 == 0 && batArmy.getCampArmy().getImmunoNum() > (defenders[i4][0]).immunoNum)
          batArmy.getCampArmy().setImmunoNum((defenders[i4][0]).immunoNum); 
        for (int j5 = 0; j5 < (batArmy.getTroopHp()).length; j5++) {
          int[] troopHp2 = batArmy.getTroopHp(), troopHp = troopHp2;
          int n = j5;
          troopHp2[n] = troopHp2[n] - reallost;
          reduce += reallost;
        } 
        if (tactic != null && (tactic.getId().intValue() == 3101 || tactic.getId().intValue() == 1756 || tactic.getId().intValue() == 400126 || tactic.getId().intValue() == 17561) && (batArmy.getCampArmy().getGeneralId() != 280 || batArmy.getCampArmy().getIsJuexing() <= 0 || batArmy.getCampArmy().getFormationType() != 2) && (batArmy.getIsDajiang() <= 0 || !batArmy.getCampArmy().getLegendEvoke() || !batArmy.getCampArmy().getLegendSkill().containsKey("bainiao") || ((Integer)batArmy.getCampArmy().getLegendSkill().get("bainiao")).intValue() <= 0))
          batArmy.setSangDanType(1); 
        if (tactic != null && tactic.getId().intValue() == 1614 && ((batSide == 1 && roundInfo.attCampArmy.getUnionRank() >= 3) || (batSide == 0 && roundInfo.defCampArmy.getUnionRank() >= 3)))
          batArmy.setQingCheng(1); 
        if (defendCa.getId() == campBId)
          tacticInfo.firstCReduce += reduce; 
        tacticInfo.allCReduce += reduce;
        if (defendCa.isBarPhantom)
          tacticInfo.allBarbarainReduce += reduce; 
        CampArmy campArmy2 = defendCa;
        campArmy2.armyHpLoss += reduce;
        if (defendCa.armyHpLoss >= defendCa.armyHpOrg) {
          campA.killGeneral++;
          roundInfo.needPushReport13 = true;
          roundInfo.nextMinExeTime += 1000;
          roundInfo.timePredicationBuffer.append("tactic cheers:").append(0).append("|");
          defendCa.armyHp = -1;
          if (((BattleArmy)listB.get(0)).getCampArmy().getId() == defendCa.getId()) {
            if (batSide == 0) {
              roundInfo.killAttG = true;
              if (campA.generalId == 204 && campA.isjuexing > 0 && !zuoqiskill)
                campA.zhaoyunjineng = true; 
            } else {
              roundInfo.killDefG = true;
              if (campA.generalId == 204 && campA.isjuexing > 0 && !zuoqiskill)
                campA.zhaoyunjineng = true; 
            } 
            if (bat.attList.size() > 0 && bat.defList.size() > 0)
              bat.setBattleRoundBuff(dataGetter, ((BattleArmy)bat.attList.get(0)).getCampArmy(), ((BattleArmy)bat.defList.get(0)).getCampArmy()); 
          } 
          PlayerInfo playerInfo = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(campA.getPlayerId()));
          if (playerInfo != null && campA.killGeneral > playerInfo.maxKillG)
            playerInfo.maxKillG = campA.killGeneral; 
          if (campA.isPhantom && campA.copytype == 20) {
            campA.hbqkillnum++;
            Player player = dataGetter.getPlayerDao().read(campA.playerId);
            JsonDocument doc1 = new JsonDocument();
            doc1.startObject();
            int hbqkill = 1;
            String attside = "att";
            if (batSide == 0) {
              attside = "def";
              if (bat.getDefHbqKillInfos().containsKey(Integer.valueOf(campA.playerId))) {
                hbqkill = ((Integer)bat.getDefHbqKillInfos().get(Integer.valueOf(campA.playerId))).intValue() + 1;
                bat.getDefHbqKillInfos().put(Integer.valueOf(campA.playerId), Integer.valueOf(hbqkill));
              } else {
                bat.getDefHbqKillInfos().put(Integer.valueOf(campA.playerId), Integer.valueOf(1));
              } 
            } else {
              attside = "att";
              if (bat.getAttHbqKillInfos().containsKey(Integer.valueOf(campA.playerId))) {
                hbqkill = ((Integer)bat.getAttHbqKillInfos().get(Integer.valueOf(campA.playerId))).intValue() + 1;
                bat.getAttHbqKillInfos().put(Integer.valueOf(campA.playerId), Integer.valueOf(hbqkill));
              } else {
                bat.getAttHbqKillInfos().put(Integer.valueOf(campA.playerId), Integer.valueOf(1));
              } 
            } 
            doc1.startObject(attside);
            doc1.createElement("kills", Integer.valueOf(hbqkill));
            doc1.createElement("playerName", (player == null) ? "我方" : player.getPlayerName());
            doc1.endObject();
            doc1.endObject();
            for (Integer playerId : bat.inSceneSet)
              Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_HBQ, doc1.toByte()); 
          } 
          if (campA.isPhantom && campA.copytype == 5) {
            campA.xianzhenkillnum++;
            Player player = dataGetter.getPlayerDao().read(campA.playerId);
            JsonDocument doc1 = new JsonDocument();
            doc1.startObject();
            String attside2 = "att";
            int xianzhenkill = 1;
            if (batSide == 0) {
              attside2 = "def";
              if (bat.getDefXianZhenKillInfos().containsKey(Integer.valueOf(campA.playerId))) {
                xianzhenkill = ((Integer)bat.getDefXianZhenKillInfos().get(Integer.valueOf(campA.playerId))).intValue() + 1;
                bat.getDefXianZhenKillInfos().put(Integer.valueOf(campA.playerId), Integer.valueOf(xianzhenkill));
              } else {
                bat.getDefXianZhenKillInfos().put(Integer.valueOf(campA.playerId), Integer.valueOf(1));
              } 
            } else {
              attside2 = "att";
              if (bat.getAttXianZhenKillInfos().containsKey(Integer.valueOf(campA.playerId))) {
                xianzhenkill = ((Integer)bat.getAttXianZhenKillInfos().get(Integer.valueOf(campA.playerId))).intValue() + 1;
                bat.getAttXianZhenKillInfos().put(Integer.valueOf(campA.playerId), Integer.valueOf(xianzhenkill));
              } else {
                bat.getAttXianZhenKillInfos().put(Integer.valueOf(campA.playerId), Integer.valueOf(1));
              } 
            } 
            doc1.startObject(attside2);
            doc1.createElement("dants", Integer.valueOf(xianzhenkill));
            doc1.createElement("playerName", (player == null) ? "我方" : player.getPlayerName());
            doc1.endObject();
            doc1.endObject();
            for (Integer playerId : bat.inSceneSet)
              Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_XIANZHEN, doc1.toByte()); 
          } 
          if (campA.isPhantom && campA.copytype == 21) {
            campA.wsqkillnum++;
            Player player = dataGetter.getPlayerDao().read(campA.playerId);
            JsonDocument doc1 = new JsonDocument();
            doc1.startObject();
            int wsqkill = 1;
            String attside = "att";
            if (batSide == 0) {
              attside = "def";
              if (bat.getDefWsqKillInfos().containsKey(Integer.valueOf(campA.playerId))) {
                wsqkill = ((Integer)bat.getDefWsqKillInfos().get(Integer.valueOf(campA.playerId))).intValue() + 1;
                bat.getDefWsqKillInfos().put(Integer.valueOf(campA.playerId), Integer.valueOf(wsqkill));
              } else {
                bat.getDefWsqKillInfos().put(Integer.valueOf(campA.playerId), Integer.valueOf(1));
              } 
            } else {
              attside = "att";
              if (bat.getAttWsqKillInfos().containsKey(Integer.valueOf(campA.playerId))) {
                wsqkill = ((Integer)bat.getAttWsqKillInfos().get(Integer.valueOf(campA.playerId))).intValue() + 1;
                bat.getAttWsqKillInfos().put(Integer.valueOf(campA.playerId), Integer.valueOf(wsqkill));
              } else {
                bat.getAttWsqKillInfos().put(Integer.valueOf(campA.playerId), Integer.valueOf(1));
              } 
            } 
            doc1.startObject(attside);
            doc1.createElement("kills", Integer.valueOf(wsqkill));
            doc1.createElement("playerName", (player == null) ? "我方" : player.getPlayerName());
            doc1.endObject();
            doc1.endObject();
            for (Integer playerId : bat.inSceneSet)
              Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_WSQ, doc1.toByte()); 
          } 
        } 
        PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defendCa.getPlayerId()));
        if (pi != null) {
          PlayerInfo playerInfo3 = pi, playerInfo = playerInfo3;
          playerInfo3.lostTotal += reduce;
        } 
        if (reduceMap.containsKey(defendCa)) {
          reduceMap.put(defendCa, Integer.valueOf(((Integer)reduceMap.get(defendCa)).intValue() + reduce));
        } else {
          reduceMap.put(defendCa, Integer.valueOf(reduce));
        } 
      } 
      if (campA.generalId == 211 && campA.isjuexing > 0 && campA.ganninglimit > 0 && shalejipai >= 5 && !zuoqiskill) {
        campA.ganninglimit--;
        campA.tacticVal++;
      } 
      if (campA.generalId == 208 && campA.isjuexing > 0 && !isRebound) {
        campA.dwnum++;
        for (BattleArmy attackarmy : listA) {
          if (attackarmy.getHaveZhanChe() && attackarmy.getHuJia() > 0)
            continue; 
          if (attackarmy.getCampArmy().getId() != campA.getId())
            continue; 
          int addshield = 50000;
          if (campA.dwnum > 0)
            addshield *= campA.dwnum; 
          int curshield = attackarmy.getShield() + addshield;
          if (curshield > 1000000)
            curshield = 1000000; 
          attackarmy.setShield(curshield);
          if (attackarmy.getMaxShield() >= curshield)
            continue; 
          attackarmy.setMaxShield(curshield);
        } 
      } 
      if (needreport52)
        getReportType52(dataGetter, bat, roundInfo.battleMsg, roundInfo); 
      tacticInfo.reduceMap = reduceMap;
      campA.armyHpKill += tacticInfo.allCReduce;
      campA.barbarainHpKill += tacticInfo.allBarbarainReduce;
      PlayerInfo piA = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(campA.getPlayerId()));
      if (piA != null) {
        PlayerInfo playerInfo4 = piA, playerInfo2 = playerInfo4;
        playerInfo4.killTotal += tacticInfo.allCReduce;
      } 
    } 
    return firstRowKilled;
  }
  
  protected static void copyTacticBattleInfo(List<CampArmy> camps, List<BattleArmy> queues, TroopData[][] troopData, IDataGetter dataGetter, boolean vsSideIsBarPhantom) {
    for (int i = 0; i < queues.size(); i++) {
      BattleArmy battleArmy = queues.get(i);
      CampArmy campArmy = battleArmy.getCampArmy();
      TroopData[] troop = new TroopData[3];
      copyTacticBattleInfo(battleArmy, campArmy, troop, null, dataGetter, vsSideIsBarPhantom);
      troopData[i] = troop;
    } 
  }
  
  protected static void copyTacticBattleInfo(BattleArmy battleArmy, CampArmy campArmy, TroopData[] troopData, Tactic tactic, IDataGetter dataGetter, boolean vsSideIsBarPhantom) {
    int att = campArmy.getAttEffect();
    int def = campArmy.getDefEffect();
    int chariotAttack = 0;
    if (campArmy.getPlayerId() > 0) {
      Troop troop = (Troop)dataGetter.getTroopCache().get(Integer.valueOf(campArmy.getTroopId()));
      if (troop == null)
        troop = dataGetter.getTroopCache().getTroopOfGeneral(campArmy.getTroopId()); 
      att = dataGetter.getBattleDataCache().getAtt(campArmy.getPlayerId(), campArmy.getGeneralId(), troop, campArmy.getGeneralLv(), campArmy.getIsDeputy(), campArmy.getZhuJiangId());
      def = dataGetter.getBattleDataCache().getDef(campArmy.getPlayerId(), campArmy.getGeneralId(), troop, campArmy.getGeneralLv(), campArmy.getIsDeputy(), campArmy.getZhuJiangId());
      chariotAttack = dataGetter.getBattleDataCache().getChariotAttack(campArmy.getPlayerId());
    } 
    for (int i = 0; i < (battleArmy.getTroopHp()).length; i++) {
      TroopData tempData = new TroopData();
      tempData.troop_id = battleArmy.getCampArmy().getId();
      tempData.hp = battleArmy.getTroopHp()[i];
      tempData.max_hp = campArmy.getTroopHp() / 3;
      tempData.att = att;
      tempData.def = def;
      tempData.base_damage = campArmy.getBdEffect();
      tempData.Lea = campArmy.getLeader();
      tempData.Str = campArmy.getStrength();
      tempData.general_quality = campArmy.getQuality();
      tempData.TACTIC_ATT = campArmy.getTACTIC_ATT();
      tempData.TACTIC_DEF = campArmy.getTACTIC_DEF();
      tempData.generalId = campArmy.getGeneralId();
      tempData.attcoe = campArmy.getAttcoe();
      tempData.hujia = battleArmy.getHuJia();
      tempData.naijiu = campArmy.getNaijiu();
      tempData.pojia = campArmy.getPojia();
      tempData.baoji = campArmy.getBaoji();
      tempData.qianggong = campArmy.getQiangGong();
      tempData.xueliang = campArmy.getXueLiang();
      tempData.havezhanche = battleArmy.getHaveZhanChe();
      tempData.carskill = campArmy.getCatapultSkill();
      tempData.carid = campArmy.getCarId();
      tempData.zcdun = battleArmy.getZCdunHp();
      tempData.shield = battleArmy.getShield();
      tempData.chizhanfa = campArmy.getChiZhanFa();
      tempData.isjuexing = campArmy.getIsJuexing();
      tempData.yzdq = battleArmy.getYzdq();
      tempData.sex = campArmy.getSex();
      tempData.zfshield = battleArmy.getZfShiled();
      tempData.zsjqskilllevel = campArmy.getZsJqSkillLevel();
      tempData.kaishan = battleArmy.getKaiShan();
      tempData.dingjun = campArmy.getDingJun();
      tempData.ycbwpojia = campArmy.getYcbwPojia();
      tempData.zfbi = campArmy.getZhanFaBiLi();
      tempData.pingkan = campArmy.getPingKan();
      tempData.pingkandef = campArmy.getPingKanDef();
      tempData.resispercentage = campArmy.getResistePercentage().doubleValue();
      tempData.formationType = campArmy.getFormationType();
      tempData.formationBigSkill = campArmy.getHasbigFormationskill();
      tempData.lieyanhuixiang = battleArmy.getLieYanHuiXiang();
      tempData.lieyandamage = campArmy.getLieyandamage();
      tempData.defenseDown = campArmy.getDefenseDown();
      tempData.shanbigailv = campArmy.getShanBiGailv();
      tempData.yixuegailv = campArmy.getYiXueGaiLv();
      tempData.sangdantype = battleArmy.getSangDanType();
      tempData.wsb = campArmy.getWsb();
      tempData.czshinum = campArmy.getczshiNum();
      tempData.czshiround = campArmy.getczshiRound();
      tempData.missnum = campArmy.getMissNum();
      tempData.immunoNum = campArmy.getImmunoNum();
      tempData.isfanshang = campArmy.getIsFanShang();
      tempData.dikang = campArmy.getDiKang();
      tempData.sunshangxiangzs = campArmy.getSunShangXiangZs();
      tempData.horsetype = campArmy.getHorseType();
      tempData.hushou = battleArmy.getHuShou();
      tempData.helpgeneral = campArmy.getHelpGeneral();
      if ((campArmy.getGeneralId() == 402 && campArmy.getIsJuexing() > 0) || (campArmy.getHelpGeneral() == 402 && campArmy.getHelpIsJuexing() > 0))
        tempData.sdqs = 1; 
      tempData.machaofrank = 1 + campArmy.getFormationLevel() / 20;
      tempData.glshuibao = battleArmy.getGlShuiBao();
      tempData.erzhenbao = campArmy.getErZhenBao();
      tempData.sanzhenbao = campArmy.getSanZhenbao();
      tempData.sizhenbao = campArmy.getSiZhenbao();
      if (battleArmy.getIsDajiang() > 0 || campArmy.getIsMain() > 0)
        tempData.qizhenbao = battleArmy.getQiZhenBao(); 
      tempData.jiuzhenbao = campArmy.getJiuZhenbao();
      tempData.tenzhenbao = campArmy.getTenZhenBao();
      if (tactic != null) {
        tempData.tactic_id = tactic.getId().intValue();
        tempData.tactic_damage_e = tactic.getDamageE().doubleValue();
        tempData.tactic_range = tactic.getRange().intValue();
      } 
      if (campArmy.specialGeneral.generalType == 2) {
        tempData.isFS = true;
        tempData.world_fs_d = (int)campArmy.specialGeneral.param;
        if (tempData.world_fs_d <= 0)
          tempData.isFS = false; 
      } else {
        tempData.isFS = false;
        tempData.world_fs_d = 0;
      } 
      if (campArmy.specialGeneral.generalType == 3 && vsSideIsBarPhantom) {
        tempData.isMz = true;
        tempData.world_mz_e = campArmy.specialGeneral.param;
      } else {
        tempData.isMz = false;
        tempData.world_mz_e = 0.0D;
      } 
      tempData.isTD = battleArmy.getIsTd();
      tempData.TD_defense_e = battleArmy.getTD_defense_e();
      tempData.attackLevel = campArmy.getAttackLevel();
      tempData.buqu = campArmy.getBuQu();
      tempData.zhenfajianshang = battleArmy.getZhenFaJianShang();
      tempData.baqi1 = campArmy.getBaQi1();
      tempData.baqi2 = campArmy.getBaQi2();
      tempData.baqi3 = campArmy.getBaQi3();
      tempData.baqi = campArmy.getBaQiNum();
      tempData.buff = campArmy.getBuff();
      tempData.pos = battleArmy.getPosition();
      tempData.ismooncard = campArmy.getIsMoonCard();
      tempData.paytotal = campArmy.getPayTotal();
      tempData.shiledtype = battleArmy.getShiledType();
      tempData.unionrank = campArmy.getUnionRank();
      tempData.baojigailv = campArmy.getBaoJiGaiLv();
      tempData.hunluan = battleArmy.getSpecial();
      tempData.qincheng = battleArmy.getQingCheng();
      tempData.havezscy = campArmy.getHaveZscy();
      tempData.huwei = battleArmy.getHuWei();
      tempData.baguaattack = battleArmy.getBaGuaAttack();
      tempData.baguabaoji = battleArmy.getBaGuaBaoji();
      tempData.baguafangyu = battleArmy.getBaGuaFangYu();
      tempData.baguadun = battleArmy.getBaGuaDun();
      tempData.cardebuff = battleArmy.getCardebuff();
      tempData.defense = campArmy.getDefence();
      tempData.isbeatmonster = campArmy.getIsBeatMonster();
      tempData.dwnum = campArmy.getDwNum();
      tempData.yongmeng = campArmy.getAttack();
      tempData.zynum = battleArmy.getZyNum();
      tempData.legendSkill = campArmy.getLegendSkill();
      tempData.juejingzhilong = campArmy.getJueJingZhiLong();
      tempData.troopType = campArmy.getTroopType();
      tempData.hpOrg = campArmy.getArmyHpOrg();
      tempData.legeneEvoke = campArmy.getLegendEvoke();
      tempData.chariotAttack = chariotAttack;
      Map<Integer, Double> playerGemAttribute = dataGetter.getBattleDataCache().getGemAttribute(campArmy.getPlayerId());
      if (playerGemAttribute == null || playerGemAttribute.isEmpty()) {
        troopData[i] = tempData;
      } else {
        tempData.JS_SKILL_zfbj = ((Double)playerGemAttribute.get(Integer.valueOf(3))).doubleValue();
        tempData.JS_SKILL_zfjb = ((Double)playerGemAttribute.get(Integer.valueOf(4))).doubleValue();
        troopData[i] = tempData;
      } 
    } 
  }
  
  private void zhenfajianyu(Battle bat, RoundInfo roundInfo) {
    CampArmy attArmy = roundInfo.attCampArmy;
    CampArmy defArmy = roundInfo.defCampArmy;
    if (attArmy.hasbigformationskill > 0 && attArmy.formationtype == 2) {
      double shanghaixishu = 0.8D;
      if (attArmy.formationLevel >= 1000) {
        shanghaixishu = 5.0D;
      } else if (attArmy.formationLevel >= 800) {
        shanghaixishu = 4.0D;
      } else if (attArmy.formationLevel >= 500) {
        shanghaixishu = 3.0D;
      } else if (attArmy.formationLevel >= 100) {
        shanghaixishu = 2.0D;
      } else if (attArmy.formationLevel >= 80) {
        shanghaixishu = 1.4D;
      } else if (attArmy.formationLevel >= 50) {
        shanghaixishu = 1.0D;
      } 
      int lost = (int)((attArmy.getAttEffect() - defArmy.getDefEffect() + (attArmy.getAttDef_B()).ATT_B - (defArmy.getAttDef_B()).DEF_B) * shanghaixishu);
      if (lost <= 0)
        lost = (attArmy.getAttDef_B()).ATT_B; 
      if (lost < 1000)
        lost = 1000; 
      StringBuilder zhanfastr = new StringBuilder();
      BattleArmy bta = roundInfo.defBattleArmy;
      zhanfastr.append("61|2|def|").append(bta.getPosition()).append(",");
      int xinlost = lost;
      int reduce = 0;
      boolean realdamage = false;
      if (bta.getHaveZhanChe() && bta.getHuJia() > 0) {
        if (lost < bta.getCampArmy().getPojia()) {
          xinlost = 1;
        } else {
          xinlost = bta.getCampArmy().getNaijiu();
        } 
        bta.setHuJia(bta.getHuJia() - xinlost);
      } else if (bta.getZCdunHp() > 0) {
        if (lost < bta.getCampArmy().getPojia()) {
          xinlost = 1;
        } else {
          xinlost = bta.getCampArmy().getNaijiu();
        } 
        bta.setZCdunHp(bta.getZCdunHp() - xinlost);
      } else if (bta.getShield() > 0) {
        if (bta.getShiledType() == 2) {
          if (bta.getZhanchedun() > 0) {
            if (lost < bta.getCampArmy().getPojia()) {
              xinlost = 1;
            } else {
              xinlost = bta.getCampArmy().getNaijiu();
            } 
          } else {
            xinlost = -1;
          } 
        } else {
          if (xinlost > bta.getShield())
            xinlost = bta.getShield(); 
          realdamage = true;
        } 
        bta.setShield(bta.getShield() - ((xinlost < 0) ? 0 : xinlost));
      } 
      for (int j = 0; j < 3; j++) {
        if (!realdamage) {
          if (xinlost >= bta.getTroopHp()[j])
            xinlost = bta.getTroopHp()[j] - 3; 
          bta.getTroopHp()[j] = bta.getTroopHp()[j] - ((xinlost < 0) ? 0 : xinlost);
          reduce += (xinlost < 0) ? 0 : xinlost;
        } 
        if (j == 0)
          zhanfastr.append(xinlost).append(",").append(bta.getTroopHp()[j]).append(",0,0#"); 
      } 
      CampArmy campArmy = bta.getCampArmy();
      campArmy.armyHpLoss += reduce;
      if (bta.getTroopHp()[0] <= 0)
        roundInfo.defKilledList.add(bta); 
      PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(bta.getCampArmy().getPlayerId()));
      if (pi != null) {
        PlayerInfo playerInfo3 = pi, playerInfo = playerInfo3;
        playerInfo3.lostTotal += reduce;
      } 
      if ((bta.getCampArmy()).isBarPhantom) {
        CampArmy attCampArmy = roundInfo.attCampArmy;
        attCampArmy.barbarainHpKill += reduce;
      } 
      CampArmy attCampArmy2 = roundInfo.attCampArmy;
      attCampArmy2.armyHpKill += reduce;
      if (!realdamage)
        roundInfo.defBeiDongLost += reduce; 
      PlayerInfo piA = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.attCampArmy.getPlayerId()));
      if (piA != null) {
        PlayerInfo playerInfo4 = piA, playerInfo2 = playerInfo4;
        playerInfo4.killTotal += reduce;
      } 
      if (!realdamage)
        bat.getDefBaseInfo().setNum(bat.getDefBaseInfo().getNum() - reduce); 
      roundInfo.battleMsg.append(zhanfastr.toString());
    } 
    if (defArmy.hasbigformationskill > 0 && defArmy.formationtype == 2) {
      double shanghaixishu = 0.8D;
      if (defArmy.formationLevel >= 1000) {
        shanghaixishu = 5.0D;
      } else if (defArmy.formationLevel >= 800) {
        shanghaixishu = 4.0D;
      } else if (defArmy.formationLevel >= 500) {
        shanghaixishu = 3.0D;
      } else if (defArmy.formationLevel >= 100) {
        shanghaixishu = 2.0D;
      } else if (defArmy.formationLevel >= 80) {
        shanghaixishu = 1.4D;
      } else if (defArmy.formationLevel >= 50) {
        shanghaixishu = 1.0D;
      } 
      int lost = (int)((defArmy.getAttEffect() - attArmy.getDefEffect() + (defArmy.getAttDef_B()).ATT_B - (attArmy.getAttDef_B()).DEF_B) * shanghaixishu);
      if (lost <= 0)
        lost = (defArmy.getAttDef_B()).ATT_B; 
      if (lost < 1000)
        lost = 1000; 
      StringBuilder zhanfastr = new StringBuilder();
      BattleArmy bta = roundInfo.attBattleArmy;
      zhanfastr.append("61|2|att|").append(bta.getPosition()).append(",");
      int xinlost = lost;
      int reduce = 0;
      boolean realdamage = false;
      if (bta.getHaveZhanChe() && bta.getHuJia() > 0) {
        if (lost < bta.getCampArmy().getPojia()) {
          xinlost = 1;
        } else {
          xinlost = bta.getCampArmy().getNaijiu();
        } 
        bta.setHuJia(bta.getHuJia() - xinlost);
      } else if (bta.getZCdunHp() > 0) {
        if (lost < bta.getCampArmy().getPojia()) {
          xinlost = 1;
        } else {
          xinlost = bta.getCampArmy().getNaijiu();
        } 
        bta.setZCdunHp(bta.getZCdunHp() - xinlost);
      } else if (bta.getShield() > 0) {
        if (bta.getShiledType() == 2) {
          if (bta.getZhanchedun() > 0) {
            if (lost < bta.getCampArmy().getPojia()) {
              xinlost = 1;
            } else {
              xinlost = bta.getCampArmy().getNaijiu();
            } 
          } else {
            xinlost = -1;
          } 
        } else {
          if (xinlost > bta.getShield())
            xinlost = bta.getShield(); 
          realdamage = true;
        } 
        bta.setShield(bta.getShield() - ((xinlost < 0) ? 0 : xinlost));
      } 
      for (int j = 0; j < 3; j++) {
        if (!realdamage) {
          if (xinlost >= bta.getTroopHp()[j])
            xinlost = bta.getTroopHp()[j] - 3; 
          bta.getTroopHp()[j] = bta.getTroopHp()[j] - ((xinlost < 0) ? 0 : xinlost);
          reduce += (xinlost < 0) ? 0 : xinlost;
        } 
        if (j == 0)
          zhanfastr.append(xinlost).append(",").append(bta.getTroopHp()[j]).append(",0,0#"); 
      } 
      CampArmy campArmy2 = bta.getCampArmy();
      campArmy2.armyHpLoss += reduce;
      if (bta.getTroopHp()[0] <= 0)
        roundInfo.attKilledList.add(bta); 
      PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(bta.getCampArmy().getPlayerId()));
      if (pi != null) {
        PlayerInfo playerInfo5 = pi, playerInfo = playerInfo5;
        playerInfo5.lostTotal += reduce;
      } 
      if ((bta.getCampArmy()).isBarPhantom) {
        CampArmy defCampArmy = roundInfo.defCampArmy;
        defCampArmy.barbarainHpKill += reduce;
      } 
      CampArmy defCampArmy2 = roundInfo.defCampArmy;
      defCampArmy2.armyHpKill += reduce;
      if (!realdamage)
        roundInfo.attBeiDongLost += reduce; 
      PlayerInfo piA = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.defCampArmy.getPlayerId()));
      if (piA != null) {
        PlayerInfo playerInfo6 = piA, playerInfo2 = playerInfo6;
        playerInfo6.killTotal += reduce;
      } 
      if (!realdamage)
        bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - reduce); 
      roundInfo.battleMsg.append(zhanfastr.toString());
    } 
  }
  
  private void zhancheshanghai(Battle bat, RoundInfo roundInfo) {
    TroopData attTroop = roundInfo.troopData[0][0];
    TroopData defTroop = roundInfo.troopData[1][0];
    if (attTroop == null || defTroop == null) {
      System.out.println("错误，战斗一方为空");
      return;
    } 
    boolean attiszhenxiahoudun = false;
    boolean defiszhenxiahoudun = false;
    boolean attishuangyueying = false;
    boolean defishuangyueying = false;
    boolean attzsjq = false;
    boolean defzsjq = false;
    boolean attcaozhi = false;
    boolean defcaozhi = false;
    boolean attsunjian = false;
    boolean defsunjian = false;
    boolean attlenyan = false;
    boolean deflenyan = false;
    boolean attzhaoyun = false;
    boolean defzhaoyun = false;
    double zsshxs = 0.2D;
    double attshanghaixishu = 0.2D;
    double defshanghaixishu = 0.2D;
    int attrows = 1;
    int defrows = 1;
    boolean canyunxing = false;
    if (attTroop.generalId == 280 && attTroop.isjuexing > 0) {
      attrows = 4;
      attshanghaixishu = 0.2D;
      canyunxing = true;
      attcaozhi = true;
    } else if ((attTroop.carskill == 1 || attTroop.carskill == 2 || attTroop.carskill == 3) && attTroop.havezhanche) {
      if (attTroop.carid > 87000) {
        attrows = 5;
      } else {
        attrows = 4;
      } 
      attshanghaixishu = 0.4D;
      canyunxing = true;
      if (roundInfo.attCampArmy.getCarQudong() == 10001)
        attlenyan = true; 
    } else if (attTroop.generalId == 270) {
      attiszhenxiahoudun = true;
      attrows = 4;
      attshanghaixishu = 0.3D;
      canyunxing = true;
    } else if (attTroop.generalId == 275) {
      attishuangyueying = true;
      attrows = 2;
      attshanghaixishu = 1.0D;
      if (bat.getTerrainVal() == 1 || bat.getTerrainVal() == 4)
        attrows = 4; 
      canyunxing = true;
    } else if (attTroop.generalId == 282) {
      attrows = 4;
      attshanghaixishu = 1.0D;
      canyunxing = true;
      attsunjian = true;
    } 
    if (attTroop.legendSkill != null && attTroop.legendSkill.containsKey("gudan") && ((Integer)attTroop.legendSkill.get("gudan")).intValue() > 0) {
      attrows = 2 + attTroop.juejingzhilong;
      if (attrows > 5)
        attrows = 5; 
      attzhaoyun = true;
      canyunxing = true;
    } 
    if (attTroop.zsjqskilllevel > 0 && attTroop.generalId != 280) {
      attzsjq = true;
      if (++attrows >= 6)
        attrows = 5; 
      int zsjqxuhao = attTroop.zsjqskilllevel;
      if (zsjqxuhao > 5)
        zsjqxuhao = 5; 
      int zsjqbili = GeneralUtils.jssh_lgz[zsjqxuhao - 1].intValue();
      if (attshanghaixishu < zsjqbili / 100.0D)
        attshanghaixishu = zsjqbili / 100.0D; 
      canyunxing = true;
    } 
    if (defTroop.generalId == 280 && defTroop.isjuexing > 0) {
      defrows = 4;
      defshanghaixishu = 0.1D;
      canyunxing = true;
      defcaozhi = true;
    } else if ((defTroop.carskill == 1 || defTroop.carskill == 2 || defTroop.carskill == 3) && defTroop.havezhanche) {
      if (defTroop.carid > 87000) {
        defrows = 5;
      } else {
        defrows = 4;
      } 
      defshanghaixishu = 0.4D;
      canyunxing = true;
      if (roundInfo.defCampArmy.getCarQudong() == 10001)
        deflenyan = true; 
    } else if (defTroop.generalId == 270) {
      defiszhenxiahoudun = true;
      defrows = 4;
      defshanghaixishu = 0.3D;
      canyunxing = true;
    } else if (defTroop.generalId == 275) {
      defishuangyueying = true;
      defrows = 2;
      defshanghaixishu = 1.0D;
      if (bat.getTerrainVal() == 1 || bat.getTerrainVal() == 4)
        defrows = 4; 
      canyunxing = true;
    } else if (defTroop.generalId == 282) {
      defrows = 4;
      defshanghaixishu = 1.0D;
      canyunxing = true;
      defsunjian = true;
    } 
    if (defTroop.legendSkill != null && defTroop.legendSkill.containsKey("gudan") && ((Integer)defTroop.legendSkill.get("gudan")).intValue() > 0) {
      defrows = 2 + defTroop.juejingzhilong;
      if (defrows > 5)
        defrows = 5; 
      defzhaoyun = true;
      canyunxing = true;
    } 
    if (defTroop.zsjqskilllevel > 0 && defTroop.generalId != 280) {
      defzsjq = true;
      if (++defrows >= 6)
        defrows = 5; 
      int zsjqxuhao = defTroop.zsjqskilllevel;
      if (zsjqxuhao > 5)
        zsjqxuhao = 5; 
      int zsjqbili = GeneralUtils.jssh_lgz[zsjqxuhao - 1].intValue();
      if (defshanghaixishu < zsjqbili / 100.0D)
        defshanghaixishu = zsjqbili / 100.0D; 
      canyunxing = true;
    } 
    if (!canyunxing)
      return; 
    StringBuilder huoyancar = new StringBuilder();
    List<Integer> attcardebuflist = new ArrayList<>();
    List<Integer> defcardebuflist = new ArrayList<>();
    if ((defTroop.carskill == 1 && defTroop.havezhanche) || defiszhenxiahoudun || defishuangyueying || defzsjq || defcaozhi || defsunjian || defzhaoyun) {
      int lost = (int)(attTroop.lost_hp * defshanghaixishu);
      List<BattleArmy> listB = bat.attList;
      if (listB != null) {
        int defpos = roundInfo.attBattleArmy.getPosition() + 1;
        boolean youhuo = false;
        boolean zhaoyunchidiao = false;
        if (defrows > listB.size())
          defrows = listB.size(); 
        for (int i = 1; i < defrows; i++) {
          boolean feidun = false;
          int curpos = ((BattleArmy)listB.get(i)).getPosition();
          if (i - 2 >= 0 && Math.abs(((BattleArmy)listB.get(i - 2)).getPosition() - curpos) <= 2 && ((BattleArmy)listB.get(i - 2)).getHaveZhanChe() && ((BattleArmy)listB.get(i - 2)).getHuJia() > 0 && ((BattleArmy)listB.get(i - 2)).getCatapultSkill() == 4) {
            feidun = true;
          } else if (i - 1 >= 0 && Math.abs(((BattleArmy)listB.get(i - 1)).getPosition() - curpos) <= 2 && ((BattleArmy)listB.get(i - 1)).getHaveZhanChe() && ((BattleArmy)listB.get(i - 1)).getHuJia() > 0 && ((BattleArmy)listB.get(i - 1)).getCatapultSkill() == 4) {
            feidun = true;
          } else if (i + 1 < defrows && Math.abs(((BattleArmy)listB.get(i + 1)).getPosition() - curpos) <= 2 && ((BattleArmy)listB.get(i + 1)).getHaveZhanChe() && ((BattleArmy)listB.get(i + 1)).getHuJia() > 0 && ((BattleArmy)listB.get(i + 1)).getCatapultSkill() == 4) {
            feidun = true;
          } else if (i + 2 < defrows && Math.abs(((BattleArmy)listB.get(i + 2)).getPosition() - curpos) <= 2 && ((BattleArmy)listB.get(i + 2)).getHaveZhanChe() && ((BattleArmy)listB.get(i + 2)).getHuJia() > 0 && ((BattleArmy)listB.get(i + 2)).getCatapultSkill() == 4) {
            feidun = true;
          } else if (((BattleArmy)listB.get(i)).getHaveZhanChe() && ((BattleArmy)listB.get(i)).getHuJia() > 0) {
            ((BattleArmy)listB.get(i)).getCatapultSkill();
          } 
          youhuo = true;
          int xinlost = lost;
          int reduce = 0;
          BattleArmy bta = listB.get(i);
          boolean realdamage = false;
          if (zhaoyunchidiao) {
            xinlost = 1;
          } else if (bta.getCampArmy().getChiZhanFa() > 0) {
            xinlost = lost * (defrows - i);
            zhaoyunchidiao = true;
          } 
          if (feidun) {
            xinlost = -5;
          } else if (bta.getHaveZhanChe() && bta.getHuJia() > 0 && xinlost > 0) {
            if (lost < bta.getCampArmy().getPojia()) {
              xinlost = 1;
            } else {
              xinlost = bta.getCampArmy().getNaijiu();
            } 
            bta.setHuJia(bta.getHuJia() - xinlost);
          } else if (bta.getZCdunHp() > 0 && xinlost > 0) {
            if (lost < bta.getCampArmy().getPojia()) {
              xinlost = 1;
            } else {
              xinlost = bta.getCampArmy().getNaijiu();
            } 
            bta.setZCdunHp(bta.getZCdunHp() - xinlost);
          } else if (bta.getShield() > 0 && xinlost > 0) {
            if (bta.getShiledType() == 2) {
              if (bta.getZhanchedun() > 0) {
                if (lost < bta.getCampArmy().getPojia()) {
                  xinlost = 1;
                } else {
                  xinlost = bta.getCampArmy().getNaijiu();
                } 
              } else {
                xinlost = -1;
              } 
            } else {
              if (xinlost > bta.getShield())
                xinlost = bta.getShield(); 
              realdamage = true;
            } 
            bta.setShield(bta.getShield() - ((xinlost < 0) ? 0 : xinlost));
          } 
          if (xinlost >= bta.getTroopHp()[0])
            xinlost = bta.getTroopHp()[0] - 1; 
          huoyancar.append(defpos).append(",");
          for (int j = 0; j < 3; j++) {
            if (!realdamage) {
              bta.getTroopHp()[j] = bta.getTroopHp()[j] - ((xinlost < 0) ? 0 : xinlost);
              reduce += (xinlost < 0) ? 0 : xinlost;
            } 
            huoyancar.append(xinlost).append(",").append(bta.getTroopHp()[j]).append(";");
          } 
          if (deflenyan) {
            bta.setCardebuff(1);
            attcardebuflist.add(Integer.valueOf(bta.getPosition()));
          } 
          CampArmy campArmy = ((BattleArmy)listB.get(i)).getCampArmy();
          campArmy.armyHpLoss += reduce;
          huoyancar.replace(huoyancar.length() - 1, huoyancar.length(), "*");
          defpos++;
          if (bta.getTroopHp()[0] <= 0)
            roundInfo.attKilledList.add(bta); 
          PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(bta.getCampArmy().getPlayerId()));
          if (pi != null) {
            PlayerInfo playerInfo3 = pi, playerInfo = playerInfo3;
            playerInfo3.lostTotal += reduce;
          } 
          if ((bta.getCampArmy()).isBarPhantom) {
            CampArmy defCampArmy = roundInfo.defCampArmy;
            defCampArmy.barbarainHpKill += reduce;
          } 
          CampArmy defCampArmy2 = roundInfo.defCampArmy;
          defCampArmy2.armyHpKill += reduce;
          if (!realdamage)
            roundInfo.attBeiDongLost += reduce; 
          PlayerInfo piA = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.defCampArmy.getPlayerId()));
          if (piA != null) {
            PlayerInfo playerInfo4 = piA, playerInfo2 = playerInfo4;
            playerInfo4.killTotal += reduce;
          } 
          if (!realdamage)
            bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - reduce); 
          if (defsunjian && (RandomUtils.nextInt(100) > 50 || defTroop.helpgeneral == 403))
            bta.setHuWei(bta.getHuWei() + 1); 
        } 
        if (!youhuo)
          huoyancar.append("null*"); 
        huoyancar.replace(huoyancar.length() - 1, huoyancar.length(), ":");
      } 
    } else {
      huoyancar.append("null:");
    } 
    if ((attTroop.carskill == 1 && attTroop.havezhanche) || attiszhenxiahoudun || attishuangyueying || attzsjq || attcaozhi || attsunjian || attzhaoyun) {
      int lost = (int)(defTroop.lost_hp * attshanghaixishu);
      List<BattleArmy> listB = bat.defList;
      if (listB != null) {
        int defpos = roundInfo.defBattleArmy.getPosition() + 1;
        boolean youhuo = false;
        boolean zhaoyunchidiao = false;
        if (attrows > listB.size())
          attrows = listB.size(); 
        for (int i = 1; i < attrows; i++) {
          boolean feidun = false;
          int curpos = ((BattleArmy)listB.get(i)).getPosition();
          if (i - 2 >= 0 && Math.abs(((BattleArmy)listB.get(i - 2)).getPosition() - curpos) <= 2 && ((BattleArmy)listB.get(i - 2)).getHaveZhanChe() && ((BattleArmy)listB.get(i - 2)).getHuJia() > 0 && ((BattleArmy)listB.get(i - 2)).getCatapultSkill() == 4) {
            feidun = true;
          } else if (i - 1 >= 0 && Math.abs(((BattleArmy)listB.get(i - 1)).getPosition() - curpos) <= 2 && ((BattleArmy)listB.get(i - 1)).getHaveZhanChe() && ((BattleArmy)listB.get(i - 1)).getHuJia() > 0 && ((BattleArmy)listB.get(i - 1)).getCatapultSkill() == 4) {
            feidun = true;
          } else if (i + 1 < attrows && Math.abs(((BattleArmy)listB.get(i + 1)).getPosition() - curpos) <= 2 && ((BattleArmy)listB.get(i + 1)).getHaveZhanChe() && ((BattleArmy)listB.get(i + 1)).getHuJia() > 0 && ((BattleArmy)listB.get(i + 1)).getCatapultSkill() == 4) {
            feidun = true;
          } else if (i + 2 < attrows && Math.abs(((BattleArmy)listB.get(i + 2)).getPosition() - curpos) <= 2 && ((BattleArmy)listB.get(i + 2)).getHaveZhanChe() && ((BattleArmy)listB.get(i + 2)).getHuJia() > 0 && ((BattleArmy)listB.get(i + 2)).getCatapultSkill() == 4) {
            feidun = true;
          } else if (((BattleArmy)listB.get(i)).getHaveZhanChe() && ((BattleArmy)listB.get(i)).getHuJia() > 0) {
            ((BattleArmy)listB.get(i)).getCatapultSkill();
          } 
          youhuo = true;
          int xinlost = lost;
          BattleArmy bta2 = listB.get(i);
          boolean realdamage2 = false;
          if (zhaoyunchidiao) {
            xinlost = 1;
          } else if (bta2.getCampArmy().getChiZhanFa() > 0) {
            xinlost = lost * (attrows - i);
            zhaoyunchidiao = true;
          } 
          int reduce2 = 0;
          if (feidun) {
            xinlost = -5;
          } else if (bta2.getHaveZhanChe() && bta2.getHuJia() > 0 && xinlost > 0) {
            if (lost < bta2.getCampArmy().getPojia()) {
              xinlost = 1;
            } else {
              xinlost = bta2.getCampArmy().getNaijiu();
            } 
            bta2.setHuJia(bta2.getHuJia() - xinlost);
          } else if (bta2.getZCdunHp() > 0 && xinlost > 0) {
            if (lost < bta2.getCampArmy().getPojia()) {
              xinlost = 1;
            } else {
              xinlost = bta2.getCampArmy().getNaijiu();
            } 
            bta2.setZCdunHp(bta2.getZCdunHp() - xinlost);
          } else if (bta2.getShield() > 0 && xinlost > 0) {
            if (bta2.getShiledType() == 2) {
              if (bta2.getZhanchedun() > 0) {
                if (lost < bta2.getCampArmy().getPojia()) {
                  xinlost = 1;
                } else {
                  xinlost = bta2.getCampArmy().getNaijiu();
                } 
              } else {
                xinlost = -1;
              } 
            } else {
              if (xinlost > bta2.getShield())
                xinlost = bta2.getShield(); 
              realdamage2 = true;
            } 
            bta2.setShield(bta2.getShield() - ((xinlost < 0) ? 0 : xinlost));
          } 
          if (xinlost >= bta2.getTroopHp()[0])
            xinlost = bta2.getTroopHp()[0] - 1; 
          huoyancar.append(defpos).append(",");
          for (int j = 0; j < 3; j++) {
            if (!realdamage2) {
              bta2.getTroopHp()[j] = bta2.getTroopHp()[j] - ((xinlost < 0) ? 0 : xinlost);
              reduce2 += (xinlost < 0) ? 0 : xinlost;
            } 
            huoyancar.append(xinlost).append(",").append(bta2.getTroopHp()[j]).append(";");
          } 
          if (attlenyan) {
            bta2.setCardebuff(1);
            defcardebuflist.add(Integer.valueOf(bta2.getPosition()));
          } 
          CampArmy campArmy2 = bta2.getCampArmy();
          campArmy2.armyHpLoss += reduce2;
          huoyancar.replace(huoyancar.length() - 1, huoyancar.length(), "*");
          defpos++;
          if (bta2.getTroopHp()[0] <= 0)
            roundInfo.defKilledList.add(bta2); 
          PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(bta2.getCampArmy().getPlayerId()));
          if (pi != null) {
            PlayerInfo playerInfo5 = pi, playerInfo = playerInfo5;
            playerInfo5.lostTotal += reduce2;
          } 
          if ((bta2.getCampArmy()).isBarPhantom) {
            CampArmy attCampArmy = roundInfo.attCampArmy;
            attCampArmy.barbarainHpKill += reduce2;
          } 
          CampArmy attCampArmy2 = roundInfo.attCampArmy;
          attCampArmy2.armyHpKill += reduce2;
          if (!realdamage2) {
            roundInfo.defBeiDongLost += reduce2;
            PlayerInfo piA = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.attCampArmy.getPlayerId()));
            if (piA != null) {
              PlayerInfo playerInfo6 = piA, playerInfo2 = playerInfo6;
              playerInfo6.killTotal += reduce2;
            } 
            bat.getDefBaseInfo().setNum(bat.getDefBaseInfo().getNum() - reduce2);
          } 
          if (attsunjian && (RandomUtils.nextInt(100) > 50 || attTroop.helpgeneral == 403))
            bta2.setHuWei(bta2.getHuWei() + 1); 
        } 
        if (!youhuo)
          huoyancar.append("null*"); 
        huoyancar.replace(huoyancar.length() - 1, huoyancar.length(), "=");
      } 
    } else {
      huoyancar.append("null=");
    } 
    roundInfo.carskilleffect = huoyancar;
    if (attcardebuflist.size() > 0 || defcardebuflist.size() > 0) {
      roundInfo.battleMsg.append("10002|");
      if (attcardebuflist.size() > 0) {
        for (int k = 0; k < attcardebuflist.size(); k++)
          roundInfo.battleMsg.append(attcardebuflist.get(k)).append(","); 
      } else {
        roundInfo.battleMsg.append("null,");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), ":");
      if (defcardebuflist.size() > 0) {
        for (int k = 0; k < defcardebuflist.size(); k++)
          roundInfo.battleMsg.append(defcardebuflist.get(k)).append(","); 
      } else {
        roundInfo.battleMsg.append("null,");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
    } 
  }
  
  private void lvbuzhuisha(Battle bat, RoundInfo roundInfo, int side, boolean shifoudiaocan) {
    CampArmy fangyufang = roundInfo.defCampArmy;
    CampArmy gongjiCamp = roundInfo.attCampArmy;
    List<BattleArmy> deflist = bat.defList;
    if (side == 2) {
      gongjiCamp = roundInfo.defCampArmy;
      fangyufang = roundInfo.attCampArmy;
      deflist = bat.attList;
    } 
    if (deflist == null || (deflist.size() < 2 && !shifoudiaocan) || (shifoudiaocan && deflist.isEmpty()))
      return; 
    int attfirstrow = roundInfo.attBattleArmy.getPosition();
    int deffirstrow = roundInfo.defBattleArmy.getPosition();
    BattleArmy bta = deflist.get(0);
    if (!shifoudiaocan)
      bta = deflist.get(1); 
    boolean busi = false;
    if (shifoudiaocan) {
      if (deflist.size() <= 1)
        busi = true; 
    } else if (deflist.size() <= 2) {
      busi = true;
    } 
    CampArmy defendCa1 = bta.getCampArmy();
    int damage = gongjiCamp.getAttEffect() - defendCa1.getDefEffect() + bat.att_gongji_base_add + (gongjiCamp.getAttDef_B()).ATT_B - (defendCa1.getAttDef_B()).DEF_B;
    damage *= 2;
    boolean rowkilled = false;
    boolean killgeneral = false;
    if (damage < 0)
      damage = 1; 
    int xinlost = damage;
    boolean realdamage = false;
    if (bta.getHaveZhanChe() && bta.getHuJia() > 0) {
      if (damage < defendCa1.getPojia()) {
        xinlost = 1;
      } else {
        xinlost = defendCa1.getNaijiu();
      } 
      bta.setHuJia(bta.getHuJia() - xinlost);
    } else if (bta.getZCdunHp() > 0) {
      if (damage < defendCa1.getPojia()) {
        xinlost = 1;
      } else {
        xinlost = defendCa1.getNaijiu();
      } 
      bta.setZCdunHp(bta.getZCdunHp() - xinlost);
    } else if (bta.getShield() > 0) {
      if (bta.getShiledType() == 2) {
        if (bta.getZhanchedun() > 0) {
          if (damage < bta.getCampArmy().getPojia()) {
            xinlost = 1;
          } else {
            xinlost = bta.getCampArmy().getNaijiu();
          } 
        } else {
          xinlost = -1;
        } 
      } else {
        if (xinlost > bta.getShield())
          xinlost = bta.getShield(); 
        realdamage = true;
      } 
      bta.setShield(bta.getShield() - ((xinlost < 0) ? 0 : xinlost));
    } 
    if (xinlost >= bta.getTroopHp()[0])
      if (busi) {
        xinlost = bta.getTroopHp()[0] - 1;
      } else {
        xinlost = bta.getTroopHp()[0];
        rowkilled = true;
      }  
    int reduce = 0;
    for (int j = 0; j < 3; j++) {
      if (!realdamage) {
        bta.getTroopHp()[j] = bta.getTroopHp()[j] - ((xinlost < 0) ? 0 : xinlost);
        reduce += (xinlost < 0) ? 0 : xinlost;
      } 
    } 
    CampArmy campArmy = defendCa1;
    campArmy.armyHpLoss += reduce;
    PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defendCa1.getPlayerId()));
    if (pi != null) {
      PlayerInfo playerInfo5 = pi, playerInfo = playerInfo5;
      playerInfo5.lostTotal += reduce;
    } 
    if (defendCa1.isBarPhantom) {
      CampArmy campArmy2 = gongjiCamp;
      campArmy2.barbarainHpKill += reduce;
    } 
    CampArmy campArmy3 = gongjiCamp;
    campArmy3.armyHpKill += reduce;
    PlayerInfo piA = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(gongjiCamp.getPlayerId()));
    if (piA != null) {
      PlayerInfo playerInfo6 = piA, playerInfo2 = playerInfo6;
      playerInfo6.killTotal += reduce;
    } 
    if (!realdamage)
      if (side == 2) {
        bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - reduce);
        roundInfo.attBeiDongLost += reduce;
      } else {
        bat.getDefBaseInfo().setNum(bat.getDefBaseInfo().getNum() - reduce);
        roundInfo.defBeiDongLost += reduce;
      }  
    if (bta.getTroopHp()[0] <= 0) {
      if (side == 2) {
        roundInfo.attKilledList.add(bta);
      } else {
        roundInfo.defKilledList.add(bta);
      } 
      roundInfo.needreport47 = true;
      if (defendCa1.armyHpLoss >= defendCa1.armyHpOrg) {
        CampArmy campArmy4 = gongjiCamp;
        campArmy4.killGeneral++;
        defendCa1.armyHp = -1;
        if (side == 2) {
          roundInfo.killAttG = true;
          bat.attCamp.remove(defendCa1);
          quitNewBattle(defendCa1, 1, bat);
          if (gongjiCamp.getPlayerId() > 0 && !gongjiCamp.isPhantom) {
            PlayerInfo pidef = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(gongjiCamp.getPlayerId()));
            if (pidef != null && gongjiCamp.killGeneral > pidef.maxKillG)
              pidef.maxKillG = gongjiCamp.killGeneral; 
          } 
        } else {
          roundInfo.killDefG = true;
          bat.defCamp.remove(defendCa1);
          quitNewBattle(defendCa1, 0, bat);
          if (gongjiCamp.getPlayerId() > 0 && !gongjiCamp.isPhantom) {
            PlayerInfo pidef = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(gongjiCamp.getPlayerId()));
            if (pidef != null && gongjiCamp.killGeneral > pidef.maxKillG)
              pidef.maxKillG = gongjiCamp.killGeneral; 
          } 
        } 
        killgeneral = true;
      } 
    } 
    String camp = "att";
    if (side == 2)
      camp = "def"; 
    int zsid = 44;
    int fjid = 45;
    if (gongjiCamp.generalId == 266) {
      zsid = 56;
      fjid = 57;
    } 
    roundInfo.battleMsg.append(54).append("|").append(camp).append(";").append(zsid).append(";0;").append(gongjiCamp.getGeneralPic()).append(";").append(bta.getPosition()).append(",").append(xinlost).append(",").append(bta.getTroopHp()[0]).append(",0,0#");
    roundInfo.nextMinExeTime += 3000;
    boolean zhaoyunchidiao = false;
    if (rowkilled) {
      roundInfo.battleMsg.append(54).append("|").append(camp).append(";").append(fjid).append(";0;").append(gongjiCamp.getGeneralPic()).append(";");
      int starthang = 2;
      int endhang = 5;
      if (shifoudiaocan) {
        starthang = 1;
        endhang = 4;
      } 
      boolean zuihoubusi = false;
      for (int i = starthang; i < endhang && i < deflist.size(); i++) {
        if (i == deflist.size() - 1)
          zuihoubusi = true; 
        BattleArmy batArmy = deflist.get(i);
        CampArmy defendCa2 = batArmy.getCampArmy();
        int damage2 = gongjiCamp.getAttEffect() - defendCa2.getDefEffect() + bat.att_gongji_base_add + (gongjiCamp.getAttDef_B()).ATT_B - (defendCa2.getAttDef_B()).DEF_B;
        damage2 *= 2;
        int reduce2 = 0;
        if (damage2 < 0)
          damage2 = 1; 
        if (zhaoyunchidiao) {
          damage2 = 1;
        } else if (batArmy.getCampArmy().getChiZhanFa() > 0) {
          damage2 *= endhang - starthang;
          zhaoyunchidiao = true;
        } 
        if (damage2 >= batArmy.getTroopHp()[0])
          if (zuihoubusi) {
            damage2 = batArmy.getTroopHp()[0] - 1;
          } else {
            damage2 = batArmy.getTroopHp()[0];
          }  
        boolean realdamage2 = false;
        if (batArmy.getHaveZhanChe() && batArmy.getHuJia() > 0 && damage2 > 0) {
          damage2 = defendCa2.getNaijiu();
          batArmy.setHuJia(batArmy.getHuJia() - defendCa2.naijiu);
        } else if (batArmy.getCatapultSkill() > 1 && batArmy.getZCdunHp() > 0 && damage2 > 0) {
          damage2 = defendCa2.getNaijiu();
          batArmy.setZCdunHp(batArmy.getZCdunHp() - damage2);
        } else if (batArmy.getShield() > 0 && damage2 > 0) {
          if (batArmy.getShiledType() == 2) {
            if (batArmy.getZhanchedun() > 0) {
              damage2 = defendCa2.getNaijiu();
            } else {
              damage2 = -1;
            } 
          } else {
            damage2 = batArmy.getShield();
            realdamage2 = true;
          } 
          batArmy.setShield(batArmy.getShield() - ((damage2 < 0) ? 0 : damage2));
        } 
        for (int j2 = 0; j2 < (batArmy.getTroopHp()).length; j2++) {
          int[] troopHp = batArmy.getTroopHp();
          if (!realdamage2) {
            troopHp[j2] = troopHp[j2] - ((damage2 < 0) ? 0 : damage2);
            reduce2 += (damage2 < 0) ? 0 : damage2;
          } 
        } 
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",").append(damage2).append(",").append(batArmy.getTroopHp()[0]).append(",0,0*");
        CampArmy campArmy5 = defendCa2;
        campArmy5.armyHpLoss += reduce2;
        PlayerInfo pi2 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defendCa2.getPlayerId()));
        if (pi2 != null) {
          PlayerInfo playerInfo7 = pi2, playerInfo3 = playerInfo7;
          playerInfo7.lostTotal += reduce2;
        } 
        if (defendCa2.isBarPhantom) {
          CampArmy campArmy6 = gongjiCamp;
          campArmy6.barbarainHpKill += reduce2;
        } 
        CampArmy campArmy7 = gongjiCamp;
        campArmy7.armyHpKill += reduce2;
        PlayerInfo piA2 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(gongjiCamp.getPlayerId()));
        if (piA2 != null) {
          PlayerInfo playerInfo8 = piA2, playerInfo4 = playerInfo8;
          playerInfo8.killTotal += reduce2;
        } 
        if (!realdamage2)
          if (side == 2) {
            bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - reduce2);
            roundInfo.attBeiDongLost += reduce2;
          } else {
            bat.getDefBaseInfo().setNum(bat.getDefBaseInfo().getNum() - reduce2);
            roundInfo.defBeiDongLost += reduce2;
          }  
        if (batArmy.getTroopHp()[0] <= 0) {
          if (side == 2) {
            roundInfo.attKilledList.add(batArmy);
          } else {
            roundInfo.defKilledList.add(batArmy);
          } 
          roundInfo.needreport47 = true;
          if (defendCa2.armyHpLoss >= defendCa2.armyHpOrg) {
            CampArmy campArmy8 = gongjiCamp;
            campArmy8.killGeneral++;
            defendCa2.armyHp = -1;
            if (side == 2) {
              roundInfo.killAttG = true;
              bat.attCamp.remove(defendCa2);
              quitNewBattle(defendCa2, 1, bat);
              if (gongjiCamp.getPlayerId() > 0 && !gongjiCamp.isPhantom) {
                PlayerInfo pidef2 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(gongjiCamp.getPlayerId()));
                if (pidef2 != null && gongjiCamp.killGeneral > pidef2.maxKillG)
                  pidef2.maxKillG = gongjiCamp.killGeneral; 
              } 
            } else {
              roundInfo.killDefG = true;
              bat.defCamp.remove(defendCa2);
              quitNewBattle(defendCa2, 0, bat);
              if (gongjiCamp.getPlayerId() > 0 && !gongjiCamp.isPhantom) {
                PlayerInfo pidef2 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(gongjiCamp.getPlayerId()));
                if (pidef2 != null && gongjiCamp.killGeneral > pidef2.maxKillG)
                  pidef2.maxKillG = gongjiCamp.killGeneral; 
              } 
            } 
            killgeneral = true;
          } 
        } 
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (killgeneral)
      getReportType20(bat, roundInfo.battleMsg, roundInfo); 
  }
  
  private void zhanchetoushi(Battle bat, RoundInfo roundInfo) {
    TroopData attTroop = roundInfo.troopData[0][0];
    TroopData defTroop = roundInfo.troopData[1][0];
    BattleArmy attbattleArmy = roundInfo.attBattleArmy;
    BattleArmy defbattleArmy = roundInfo.defBattleArmy;
    CampArmy attCampArmy = roundInfo.attCampArmy;
    CampArmy defCampArmy = roundInfo.defCampArmy;
    if (attTroop == null || defTroop == null) {
      System.out.println("错误，战斗一方为空");
      return;
    } 
    if (attCampArmy.catapultskill != 3 && defCampArmy.catapultskill != 3)
      return; 
    boolean xuyao56report = false;
    StringBuilder huoyancar = new StringBuilder();
    boolean youhuo = false;
    StringBuilder deftsbjList = new StringBuilder();
    if (!attbattleArmy.getHaveZhanChe() && attCampArmy.catapultskill == 3) {
      int attzctsrow = 0;
      int gongjirow = 3;
      if (attCampArmy.carid == 87532 || attCampArmy.getCarArmed())
        gongjirow = 4; 
      for (int i = 0; i < bat.attList.size(); i++) {
        if (((BattleArmy)bat.attList.get(i)).getHaveZhanChe() && ((BattleArmy)bat.attList.get(i)).getCatapultSkill() == 3) {
          attzctsrow = ((BattleArmy)bat.attList.get(i)).getPosition();
          break;
        } 
      } 
      int lost = (int)(defTroop.lost_hp * 0.6D);
      List<BattleArmy> listB = bat.defList;
      if (listB != null) {
        huoyancar.append(attzctsrow).append(":");
        boolean zhaoyunchidiao = false;
        for (int j = 1; j < gongjirow && 
          j + 1 <= listB.size(); j++) {
          youhuo = true;
          BattleArmy bta = listB.get(j);
          if (bta.getTroopHp()[0] > 0) {
            lost = (int)(lost * (1.0D + bta.getCarTsBj() * 0.5D));
            if (bta.getCampArmy().getLegendSkill().containsKey("yanmi") && ((Integer)bta.getCampArmy().getLegendSkill().get("yanmi")).intValue() > 0)
              lost = lost * 40 / 100; 
            if (roundInfo.attCampArmy.getCatapultSkill() == 3 && roundInfo.attCampArmy.getCarArmed())
              if (bta.getCarTsBj() < 3) {
                bta.setCarTsBj(bta.getCarTsBj() + 1);
              } else {
                bta.setCarTsBj(0);
              }  
            deftsbjList.append(bta.getPosition()).append(",").append(bta.getCarTsBj()).append("*");
            int xinlost = lost;
            if (zhaoyunchidiao) {
              xinlost = 1;
            } else if (bta.getCampArmy().getChiZhanFa() > 0) {
              xinlost = lost * (3 - j);
              zhaoyunchidiao = true;
            } 
            boolean realdamage = false;
            int reduce = 0;
            if (bta.getHaveZhanChe() && bta.getHuJia() > 0 && xinlost > 0) {
              if (lost < bta.getCampArmy().getPojia()) {
                xinlost = 1;
              } else {
                xinlost = bta.getCampArmy().getNaijiu();
              } 
              bta.setHuJia(bta.getHuJia() - xinlost);
            } else if (bta.getZCdunHp() > 0 && xinlost > 0) {
              if (lost < bta.getCampArmy().getPojia()) {
                xinlost = 1;
              } else {
                xinlost = bta.getCampArmy().getNaijiu();
              } 
              bta.setZCdunHp(bta.getZCdunHp() - xinlost);
            } else if (bta.getShield() > 0 && xinlost > 0) {
              if (bta.getShiledType() == 2) {
                if (bta.getZhanchedun() > 0) {
                  if (lost < bta.getCampArmy().getPojia()) {
                    xinlost = 1;
                  } else {
                    xinlost = bta.getCampArmy().getNaijiu();
                  } 
                } else {
                  xinlost = -1;
                } 
              } else {
                if (xinlost > bta.getShield())
                  xinlost = bta.getShield(); 
                realdamage = true;
              } 
              bta.setShield(bta.getShield() - ((xinlost < 0) ? 0 : xinlost));
            } 
            if (xinlost >= bta.getTroopHp()[0])
              xinlost = bta.getTroopHp()[0] - 1; 
            huoyancar.append(bta.getPosition()).append(",");
            for (int k = 0; k < 3; k++) {
              if (!realdamage) {
                bta.getTroopHp()[k] = bta.getTroopHp()[k] - ((xinlost < 0) ? 0 : xinlost);
                reduce += (xinlost < 0) ? 0 : xinlost;
              } 
              huoyancar.append(xinlost).append(",").append(bta.getTroopHp()[k]).append(",").append(bta.getShield()).append(",0,");
            } 
            CampArmy campArmy = bta.getCampArmy();
            campArmy.armyHpLoss += reduce;
            huoyancar.replace(huoyancar.length() - 1, huoyancar.length(), "*");
            xuyao56report = true;
            if (bta.getTroopHp()[0] <= 0)
              roundInfo.defKilledList.add(bta); 
            PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(bta.getCampArmy().getPlayerId()));
            if (pi != null) {
              PlayerInfo playerInfo5 = pi, playerInfo = playerInfo5;
              playerInfo5.lostTotal += reduce;
            } 
            if ((bta.getCampArmy()).isBarPhantom) {
              CampArmy campArmy2 = attCampArmy;
              campArmy2.barbarainHpKill += reduce;
            } 
            CampArmy campArmy3 = attCampArmy;
            campArmy3.armyHpKill += reduce;
            if (!realdamage)
              roundInfo.defBeiDongLost += reduce; 
            PlayerInfo piA = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(attCampArmy.getPlayerId()));
            if (piA != null) {
              PlayerInfo playerInfo6 = piA, playerInfo2 = playerInfo6;
              playerInfo6.killTotal += reduce;
            } 
            if (!realdamage)
              bat.getDefBaseInfo().setNum(bat.getDefBaseInfo().getNum() - reduce); 
          } 
        } 
      } 
    } 
    if (youhuo) {
      huoyancar.replace(huoyancar.length() - 1, huoyancar.length(), ":");
      huoyancar.append("null:");
      if (roundInfo.attCampArmy.getCarArmed() && roundInfo.attCampArmy.getCatapultSkill() == 3) {
        huoyancar.append(deftsbjList.toString());
        huoyancar.replace(huoyancar.length() - 1, huoyancar.length(), ":");
      } else {
        huoyancar.append("null:");
      } 
    } 
    huoyancar.append("null*");
    huoyancar.deleteCharAt(huoyancar.length() - 1);
    huoyancar.append(";");
    youhuo = false;
    StringBuilder atttsbjList = new StringBuilder();
    if (!defbattleArmy.getHaveZhanChe() && defCampArmy.catapultskill == 3) {
      int attzctsrow2 = 0;
      int defrow = 3;
      if (defCampArmy.carid == 87532 || defCampArmy.getCarArmed())
        defrow = 4; 
      for (int l = 0; l < bat.defList.size(); l++) {
        if (((BattleArmy)bat.defList.get(l)).getHaveZhanChe() && ((BattleArmy)bat.defList.get(l)).getCatapultSkill() == 3) {
          attzctsrow2 = ((BattleArmy)bat.defList.get(l)).getPosition();
          break;
        } 
      } 
      int lost2 = (int)(attTroop.lost_hp * 0.6D);
      List<BattleArmy> listB2 = bat.attList;
      if (listB2 != null) {
        huoyancar.append(attzctsrow2).append(":");
        boolean zhaoyunchidiao2 = false;
        for (int m = 1; m < defrow && 
          m + 1 <= listB2.size(); m++) {
          youhuo = true;
          BattleArmy bta2 = listB2.get(m);
          if (bta2.getTroopHp()[0] > 0) {
            lost2 = (int)(lost2 * (1.0D + bta2.getCarTsBj() * 0.5D));
            if (bta2.getCampArmy().getLegendSkill().containsKey("yanmi") && ((Integer)bta2.getCampArmy().getLegendSkill().get("yanmi")).intValue() > 0)
              lost2 = lost2 * 40 / 100; 
            if (roundInfo.defCampArmy.getCatapultSkill() == 3 && roundInfo.defCampArmy.getCarArmed()) {
              if (bta2.getCarTsBj() < 3) {
                bta2.setCarTsBj(bta2.getCarTsBj() + 1);
              } else {
                bta2.setCarTsBj(0);
              } 
              atttsbjList.append(bta2.getPosition()).append(",").append(bta2.getCarTsBj()).append("*");
            } 
            int xinlost2 = lost2;
            int reduce = 0;
            if (zhaoyunchidiao2) {
              xinlost2 = 1;
            } else if (bta2.getCampArmy().getChiZhanFa() > 0) {
              xinlost2 = lost2 * (3 - m);
              zhaoyunchidiao2 = true;
            } 
            boolean realdamage2 = false;
            if (bta2.getHaveZhanChe() && bta2.getHuJia() > 0 && xinlost2 > 0) {
              if (lost2 < bta2.getCampArmy().getPojia()) {
                xinlost2 = 1;
              } else {
                xinlost2 = bta2.getCampArmy().getNaijiu();
              } 
              bta2.setHuJia(bta2.getHuJia() - 1);
            } else if (bta2.getZCdunHp() > 0 && xinlost2 > 0) {
              if (lost2 < bta2.getCampArmy().getPojia()) {
                xinlost2 = 1;
              } else {
                xinlost2 = bta2.getCampArmy().getNaijiu();
              } 
              bta2.setZCdunHp(bta2.getZCdunHp() - xinlost2);
            } else if (bta2.getShield() > 0 && xinlost2 > 0) {
              if (bta2.getShiledType() == 2) {
                if (bta2.getZhanchedun() > 0) {
                  if (lost2 < bta2.getCampArmy().getPojia()) {
                    xinlost2 = 1;
                  } else {
                    xinlost2 = bta2.getCampArmy().getNaijiu();
                  } 
                } else {
                  xinlost2 = -1;
                } 
              } else {
                if (xinlost2 > bta2.getShield())
                  xinlost2 = bta2.getShield(); 
                realdamage2 = true;
              } 
              bta2.setShield(bta2.getShield() - ((xinlost2 < 0) ? 0 : xinlost2));
            } 
            if (xinlost2 >= bta2.getTroopHp()[0])
              xinlost2 = bta2.getTroopHp()[0] - 1; 
            huoyancar.append(bta2.getPosition()).append(",");
            for (int j2 = 0; j2 < 3; j2++) {
              if (!realdamage2) {
                bta2.getTroopHp()[j2] = bta2.getTroopHp()[j2] - ((xinlost2 < 0) ? 0 : xinlost2);
                reduce += (xinlost2 < 0) ? 0 : xinlost2;
              } 
              huoyancar.append(xinlost2).append(",").append(bta2.getTroopHp()[j2]).append(",").append(bta2.getShield()).append(",0,");
            } 
            CampArmy campArmy4 = ((BattleArmy)listB2.get(m)).getCampArmy();
            campArmy4.armyHpLoss += reduce;
            huoyancar.replace(huoyancar.length() - 1, huoyancar.length(), "*");
            xuyao56report = true;
            if (bta2.getTroopHp()[0] <= 0)
              roundInfo.attKilledList.add(bta2); 
            PlayerInfo pi2 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(bta2.getCampArmy().getPlayerId()));
            if (pi2 != null) {
              PlayerInfo playerInfo7 = pi2, playerInfo3 = playerInfo7;
              playerInfo7.lostTotal += reduce;
            } 
            if ((bta2.getCampArmy()).isBarPhantom) {
              CampArmy campArmy5 = defCampArmy;
              campArmy5.barbarainHpKill += reduce;
            } 
            CampArmy campArmy6 = defCampArmy;
            campArmy6.armyHpKill += reduce;
            if (!realdamage2)
              roundInfo.attBeiDongLost += reduce; 
            PlayerInfo piA2 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defCampArmy.getPlayerId()));
            if (piA2 != null) {
              PlayerInfo playerInfo8 = piA2, playerInfo4 = playerInfo8;
              playerInfo8.killTotal += reduce;
            } 
            if (!realdamage2)
              bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - reduce); 
          } 
        } 
      } 
    } 
    if (!youhuo) {
      huoyancar.append("null*");
    } else {
      huoyancar.replace(huoyancar.length() - 1, huoyancar.length(), ":");
      huoyancar.append("null:");
      if (roundInfo.defCampArmy.getCarArmed() && roundInfo.defCampArmy.getCatapultSkill() == 3) {
        huoyancar.append(atttsbjList.toString());
        huoyancar.replace(huoyancar.length() - 1, huoyancar.length(), ":");
      } else {
        huoyancar.append("null:");
      } 
      huoyancar.append("null*");
    } 
    huoyancar.deleteCharAt(huoyancar.length() - 1);
    if (xuyao56report)
      roundInfo.zhanchetoushistr = huoyancar; 
  }
  
  public void dealFight(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    TroopData attTroop = null;
    TroopData defTroop = null;
    int attsunshi = 0;
    int defsunshi = 0;
    for (int i = 0; i < 3; i++) {
      attTroop = roundInfo.troopData[0][i];
      defTroop = roundInfo.troopData[1][i];
      if (attTroop != null) {
        attsunshi = attTroop.lost_hp;
        roundInfo.attLost += attTroop.lost_hp;
        if (roundInfo.attBattleArmy.getCampArmy().getGeneralId() == 204 && roundInfo.attBattleArmy.getCampArmy().getIsJuexing() > 0 && !roundInfo.attBattleArmy.getCampArmy().getLegendEvoke()) {
          double oldxue = roundInfo.attBattleArmy.getTroopHp()[i] * 100.0D / roundInfo.attBattleArmy.getCampArmy().getMaxForces();
          double xinxue = (roundInfo.attBattleArmy.getTroopHp()[i] - attTroop.lost_hp) * 100.0D / roundInfo.attBattleArmy.getCampArmy().getMaxForces();
          if ((oldxue > 80.0D && xinxue <= 80.0D) || (oldxue > 50.0D && xinxue <= 50.0D) || (oldxue > 20.0D && xinxue <= 20.0D))
            roundInfo.attBattleArmy.getCampArmy().setZhaoYunQijinQiChu(true); 
        } 
        int[] troopHp = roundInfo.attBattleArmy.getTroopHp();
        int n = i;
        troopHp[n] = troopHp[n] - attTroop.lost_hp;
        if (roundInfo.attBattleArmy.getTroopHp()[i] < 0)
          roundInfo.attBattleArmy.getTroopHp()[i] = 0; 
        roundInfo.attRemain = roundInfo.attBattleArmy.getTroopHp()[i];
        roundInfo.attBattleArmy.setHuJia(attTroop.hujia);
        roundInfo.attBattleArmy.setZCdunHp(attTroop.zcdun);
        roundInfo.attBattleArmy.setShield(attTroop.shield);
        roundInfo.attBattleArmy.getCampArmy().setImmunoNum(attTroop.immunoNum);
        roundInfo.attBattleArmy.setQiZhenBao(attTroop.qizhenbao);
      } 
      if (defTroop != null) {
        roundInfo.defLost += defTroop.lost_hp;
        defsunshi = defTroop.lost_hp;
        if (roundInfo.defBattleArmy.getCampArmy().getGeneralId() == 204 && roundInfo.defBattleArmy.getCampArmy().getIsJuexing() > 0 && !roundInfo.defBattleArmy.getCampArmy().getLegendEvoke()) {
          double oldxue = roundInfo.defBattleArmy.getTroopHp()[i] * 100.0D / roundInfo.defBattleArmy.getCampArmy().getMaxForces();
          double xinxue = (roundInfo.defBattleArmy.getTroopHp()[i] - attTroop.lost_hp) * 100.0D / roundInfo.defBattleArmy.getCampArmy().getMaxForces();
          if ((oldxue > 80.0D && xinxue <= 80.0D) || (oldxue > 50.0D && xinxue <= 50.0D) || (oldxue > 20.0D && xinxue <= 20.0D))
            roundInfo.defBattleArmy.getCampArmy().setZhaoYunQijinQiChu(true); 
        } 
        int[] troopHp2 = roundInfo.defBattleArmy.getTroopHp();
        int n2 = i;
        troopHp2[n2] = troopHp2[n2] - defTroop.lost_hp;
        if (roundInfo.defBattleArmy.getTroopHp()[i] < 0)
          roundInfo.defBattleArmy.getTroopHp()[i] = 0; 
        roundInfo.defRemain = roundInfo.defBattleArmy.getTroopHp()[i];
        roundInfo.defBattleArmy.setHuJia(defTroop.hujia);
        roundInfo.defBattleArmy.setZCdunHp(defTroop.zcdun);
        roundInfo.defBattleArmy.setShield(defTroop.shield);
        roundInfo.defBattleArmy.getCampArmy().setImmunoNum(defTroop.immunoNum);
        roundInfo.defBattleArmy.setQiZhenBao(defTroop.qizhenbao);
      } 
    } 
    attTroop = roundInfo.troopData[0][0];
    if (attTroop != null && roundInfo.attCampArmy.getBaGuaLevel() >= 6 && roundInfo.reports != null) {
      int reportlen = roundInfo.reports.length;
      if (reportlen > 0) {
        String baogaoatt = roundInfo.reports[0].replace(";", ",");
        String[] bjarr = baogaoatt.split("\\|");
        if (bjarr[2].startsWith("bj:")) {
          String bgstr = "";
          for (int attxuhao = 0; attxuhao < bat.getAttList().size(); attxuhao++) {
            if (attxuhao != 0) {
              BattleArmy attarmy = bat.getAttList().get(attxuhao);
              if (attarmy.getTroopHp()[0] > 0) {
                int curattshiled = attarmy.getShield();
                if (curattshiled >= 20000)
                  break; 
                int addshiled = curattshiled + defsunshi;
                if (addshiled > 20000)
                  addshiled = 20000; 
                if (addshiled > 0) {
                  attarmy.setShield(addshiled);
                  attarmy.setMaxShield(addshiled);
                  attarmy.setShiledType(1);
                  bgstr = String.valueOf(String.valueOf(bgstr)) + attarmy.getPosition() + "," + addshiled + "*";
                  break;
                } 
              } 
            } 
          } 
          if (bgstr.length() > 2) {
            roundInfo.battleMsg.append("95|att|").append(bgstr);
            roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
          } 
        } 
      } 
    } 
    defTroop = roundInfo.troopData[1][0];
    if (defTroop != null && roundInfo.defCampArmy.getBaGuaLevel() >= 6 && roundInfo.reports != null) {
      int reportlen = roundInfo.reports.length;
      if (reportlen > 0) {
        String baogaodef = roundInfo.reports[0].replace(";", ",");
        String[] bjarr = baogaodef.split("\\|");
        if (bjarr[1].startsWith("bj:")) {
          String bgstr = "";
          for (int defxuhao = 0; defxuhao < bat.getDefList().size(); defxuhao++) {
            if (defxuhao != 0) {
              BattleArmy defarmy = bat.getDefList().get(defxuhao);
              if (defarmy.getTroopHp()[0] > 0) {
                int curdefshiled = defarmy.getShield();
                if (curdefshiled >= 20000)
                  break; 
                int addshiled = curdefshiled + attsunshi;
                if (addshiled > 20000)
                  addshiled = 20000; 
                if (addshiled > 0) {
                  defarmy.setShield(addshiled);
                  defarmy.setMaxShield(addshiled);
                  defarmy.setShiledType(1);
                  bgstr = String.valueOf(String.valueOf(bgstr)) + defarmy.getPosition() + "," + addshiled + "*";
                  break;
                } 
              } 
            } 
          } 
          if (bgstr.length() > 2) {
            roundInfo.battleMsg.append("95|def|").append(bgstr);
            roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
          } 
        } 
      } 
    } 
    zhancheshanghai(bat, roundInfo);
    zhanchetoushi(bat, roundInfo);
    roundInfo.attRemain = roundInfo.attBattleArmy.getTroopHp()[0];
    roundInfo.defRemain = roundInfo.defBattleArmy.getTroopHp()[0];
    BattleSceneLog.getInstance().appendLogMsg("fight lost_hp").appendBattleId(bat.getBattleId()).append("attTroop.lost_hp", Integer.valueOf((roundInfo.troopData[0][0]).lost_hp)).append("defTroop.lost_hp", Integer.valueOf((roundInfo.troopData[1][0]).lost_hp)).appendMethodName("dealFight").flush();
    if (roundInfo.defBattleArmy.getTroopHp()[0] <= 0 && roundInfo.attCampArmy.generalId == 103 && roundInfo.attCampArmy.isjuexing > 0 && roundInfo.attCampArmy.getUnionState() <= 0)
      roundInfo.attCampArmy.xuyaochiyan = true; 
    if ((roundInfo.attCampArmy.generalId == 270 && roundInfo.attCampArmy.isjuexing > 0) || (roundInfo.attCampArmy.generalId == 204 && roundInfo.attCampArmy.getChapterId() > 3) || (roundInfo.attCampArmy.generalId == 201 && roundInfo.attCampArmy.getChapterId() > 1) || (roundInfo.attCampArmy.generalId == 416 && roundInfo.attCampArmy.getChapterId() > 1))
      if (roundInfo.attCampArmy.getUnionRank() >= 1) {
        if (roundInfo.attCampArmy.getAttack() < 3)
          roundInfo.attCampArmy.setAttack(roundInfo.attCampArmy.getAttack() + 1); 
        if (roundInfo.attCampArmy.getAttack() >= 3) {
          roundInfo.attCampArmy.setDiKang(roundInfo.attCampArmy.getDiKang() + 1);
          getReportType104(roundInfo.battleMsg, bat.attList, "att");
        } 
        if (roundInfo.defCampArmy.getAttack() > -3 && (roundInfo.defCampArmy.getGeneralId() != 280 || roundInfo.defCampArmy.getIsJuexing() <= 0 || roundInfo.defCampArmy.getFormationType() != 2))
          roundInfo.defCampArmy.setAttack(roundInfo.defCampArmy.getAttack() - 1); 
      } else if (roundInfo.attCampArmy.getUnionState() <= 0) {
        if (roundInfo.attCampArmy.getAttackLevel() < 5)
          roundInfo.attCampArmy.setAttackLevel(roundInfo.attCampArmy.getAttackLevel() + 1); 
        if (roundInfo.defCampArmy.getAttackLevel() > -5 && (roundInfo.defCampArmy.getGeneralId() != 280 || roundInfo.defCampArmy.getIsJuexing() <= 0 || roundInfo.defCampArmy.getFormationType() != 2) && roundInfo.defCampArmy.getGeneralId() != 404 && roundInfo.defCampArmy.helpGeneral != 404 && (!roundInfo.defCampArmy.getLegendEvoke() || !roundInfo.defCampArmy.getLegendSkill().containsKey("bainiao") || ((Integer)roundInfo.defCampArmy.getLegendSkill().get("bainiao")).intValue() <= 0))
          roundInfo.defCampArmy.setAttackLevel(roundInfo.defCampArmy.getAttackLevel() - 1); 
      }  
    if ((roundInfo.defCampArmy.generalId == 270 && roundInfo.defCampArmy.isjuexing > 0) || (roundInfo.defCampArmy.generalId == 204 && roundInfo.defCampArmy.getChapterId() > 3) || (roundInfo.defCampArmy.generalId == 201 && roundInfo.defCampArmy.getChapterId() > 1) || (roundInfo.defCampArmy.generalId == 416 && roundInfo.defCampArmy.getChapterId() > 1))
      if (roundInfo.defCampArmy.getUnionRank() >= 1) {
        if (roundInfo.defCampArmy.getAttack() < 3)
          roundInfo.defCampArmy.setAttack(roundInfo.defCampArmy.getAttack() + 1); 
        if (roundInfo.defCampArmy.getAttack() >= 3) {
          roundInfo.defCampArmy.setDiKang(roundInfo.defCampArmy.getDiKang() + 1);
          getReportType104(roundInfo.battleMsg, bat.defList, "def");
        } 
        if (roundInfo.attCampArmy.getAttack() > -5 && (roundInfo.attCampArmy.getGeneralId() != 280 || roundInfo.attCampArmy.getIsJuexing() <= 0 || roundInfo.attCampArmy.getFormationType() != 2) && roundInfo.attCampArmy.generalId != 404 && roundInfo.attCampArmy.helpGeneral != 404)
          roundInfo.attCampArmy.setAttack(roundInfo.attCampArmy.getAttack() - 1); 
      } else if (roundInfo.defCampArmy.getUnionState() <= 0) {
        if (roundInfo.defCampArmy.getAttackLevel() < 5)
          roundInfo.defCampArmy.setAttackLevel(roundInfo.defCampArmy.getAttackLevel() + 1); 
        if (roundInfo.attCampArmy.getAttackLevel() > -5 && (roundInfo.attCampArmy.getGeneralId() != 280 || roundInfo.attCampArmy.getIsJuexing() <= 0 || roundInfo.attCampArmy.getFormationType() != 2) && (!roundInfo.attCampArmy.getLegendEvoke() || !roundInfo.attCampArmy.getLegendSkill().containsKey("bainiao") || ((Integer)roundInfo.attCampArmy.getLegendSkill().get("bainiao")).intValue() <= 0))
          roundInfo.attCampArmy.setAttackLevel(roundInfo.attCampArmy.getAttackLevel() - 1); 
      }  
    boolean needreport52 = false;
    if ((roundInfo.attCampArmy.generalId == 224 && roundInfo.attCampArmy.isjuexing > 0) || (roundInfo.attCampArmy.generalId == 416 && roundInfo.attCampArmy.getChapterId() >= 1 && roundInfo.attCampArmy.buqu < 20)) {
      CampArmy attCampArmy5 = roundInfo.attCampArmy;
      attCampArmy5.buqu += 4;
      needreport52 = true;
    } 
    if ((roundInfo.defCampArmy.generalId == 224 && roundInfo.defCampArmy.isjuexing > 0) || (roundInfo.defCampArmy.generalId == 416 && roundInfo.defCampArmy.getChapterId() >= 1 && roundInfo.defCampArmy.buqu < 20)) {
      CampArmy defCampArmy5 = roundInfo.defCampArmy;
      defCampArmy5.buqu += 4;
      needreport52 = true;
    } 
    if (roundInfo.attCampArmy.getGeneralId() == 277 && roundInfo.attCampArmy.getUnionState() > 0)
      roundInfo.attCampArmy.setZhanShuXuanZe(roundInfo.attCampArmy.getZhanShuXuanZe() + 1); 
    if (roundInfo.defCampArmy.getGeneralId() == 277 && roundInfo.defCampArmy.getUnionState() > 0)
      roundInfo.defCampArmy.setZhanShuXuanZe(roundInfo.defCampArmy.getZhanShuXuanZe() + 1); 
    if (roundInfo.attCampArmy.generalId == 416 && roundInfo.attCampArmy.getChapterId() >= 1)
      roundInfo.attCampArmy.setZhanShuXuanZe(roundInfo.attCampArmy.getZhanShuXuanZe() + 1); 
    if (roundInfo.defCampArmy.generalId == 416 && roundInfo.defCampArmy.getChapterId() >= 1)
      roundInfo.defCampArmy.setZhanShuXuanZe(roundInfo.defCampArmy.getZhanShuXuanZe() + 1); 
    roundInfo.killDefG = isKillGeneral(roundInfo.defRemain, bat.defList, roundInfo.nextDefBattleArmy);
    if (roundInfo.killDefG) {
      if (bat.attList.size() > 0 && bat.defList.size() > 0)
        bat.setBattleRoundBuff(dataGetter, ((BattleArmy)bat.attList.get(0)).getCampArmy(), ((BattleArmy)bat.defList.get(0)).getCampArmy()); 
      CampArmy attCampArmy6 = roundInfo.attCampArmy, attCampArmy = attCampArmy6;
      attCampArmy6.killGeneral++;
      roundInfo.needPushReport13 = true;
      roundInfo.nextMinExeTime += 1000;
      roundInfo.timePredicationBuffer.append("fight att cheers:").append(0).append("|");
      roundInfo.defCampArmy.armyHp = -1;
      if (attCampArmy.generalId == 204 && attCampArmy.isjuexing > 0)
        attCampArmy.zhaoyunjineng = true; 
      if (roundInfo.defCampArmy.generalId == 268 && roundInfo.defCampArmy.isjuexing > 0)
        roundInfo.battleMsg.append("70|def|-1#"); 
      bat.defCamp.remove(roundInfo.defCampArmy);
      quitNewBattle(roundInfo.defCampArmy, 0, bat);
      if (roundInfo.attCampArmy.getPlayerId() > 0 && !roundInfo.attCampArmy.isPhantom) {
        PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.attCampArmy.getPlayerId()));
        if (pi != null && roundInfo.attCampArmy.killGeneral > pi.maxKillG)
          pi.maxKillG = roundInfo.attCampArmy.killGeneral; 
      } 
      if (roundInfo.defCampArmy.huoshaolianying >= 0 && roundInfo.nextDefBattleArmy != null)
        (roundInfo.nextDefBattleArmy.getCampArmy()).huoshaolianying = roundInfo.defCampArmy.huoshaolianying; 
      if (attCampArmy.isPhantom && attCampArmy.copytype == 20) {
        CampArmy campArmy = attCampArmy;
        campArmy.hbqkillnum++;
        Player player = dataGetter.getPlayerDao().read(attCampArmy.playerId);
        JsonDocument doc1 = new JsonDocument();
        doc1.startObject();
        doc1.startObject("att");
        int hbqkill = 1;
        if (bat.getAttHbqKillInfos().containsKey(Integer.valueOf(attCampArmy.playerId))) {
          hbqkill = ((Integer)bat.getAttHbqKillInfos().get(Integer.valueOf(attCampArmy.playerId))).intValue() + 1;
          bat.getAttHbqKillInfos().put(Integer.valueOf(attCampArmy.playerId), Integer.valueOf(hbqkill));
        } else {
          bat.getAttHbqKillInfos().put(Integer.valueOf(attCampArmy.playerId), Integer.valueOf(1));
        } 
        doc1.createElement("kills", Integer.valueOf(hbqkill));
        doc1.createElement("playerName", (player == null) ? "我方" : player.getPlayerName());
        doc1.endObject();
        doc1.endObject();
        for (Integer playerId : bat.inSceneSet)
          Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_HBQ, doc1.toByte()); 
      } 
      if (attCampArmy.isPhantom && attCampArmy.copytype == 5) {
        CampArmy campArmy2 = attCampArmy;
        campArmy2.xianzhenkillnum++;
        Player player = dataGetter.getPlayerDao().read(attCampArmy.playerId);
        JsonDocument doc1 = new JsonDocument();
        doc1.startObject();
        doc1.startObject("att");
        int xianzhenkill = 1;
        if (bat.getAttXianZhenKillInfos().containsKey(Integer.valueOf(attCampArmy.playerId))) {
          xianzhenkill = ((Integer)bat.getAttXianZhenKillInfos().get(Integer.valueOf(attCampArmy.playerId))).intValue() + 1;
          bat.getAttXianZhenKillInfos().put(Integer.valueOf(attCampArmy.playerId), Integer.valueOf(xianzhenkill));
        } else {
          bat.getAttXianZhenKillInfos().put(Integer.valueOf(attCampArmy.playerId), Integer.valueOf(1));
        } 
        doc1.createElement("dants", Integer.valueOf(xianzhenkill));
        doc1.createElement("playerName", (player == null) ? "我方" : player.getPlayerName());
        doc1.endObject();
        doc1.endObject();
        for (Integer playerId : bat.inSceneSet)
          Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_XIANZHEN, doc1.toByte()); 
      } 
      if (attCampArmy.isPhantom && attCampArmy.copytype == 21) {
        CampArmy campArmy3 = attCampArmy;
        campArmy3.wsqkillnum++;
        Player player = dataGetter.getPlayerDao().read(attCampArmy.playerId);
        JsonDocument doc1 = new JsonDocument();
        doc1.startObject();
        doc1.startObject("att");
        int wsqkill = 1;
        if (bat.getAttWsqKillInfos().containsKey(Integer.valueOf(attCampArmy.playerId))) {
          wsqkill = ((Integer)bat.getAttWsqKillInfos().get(Integer.valueOf(attCampArmy.playerId))).intValue() + 1;
          bat.getAttWsqKillInfos().put(Integer.valueOf(attCampArmy.playerId), Integer.valueOf(wsqkill));
        } else {
          bat.getAttWsqKillInfos().put(Integer.valueOf(attCampArmy.playerId), Integer.valueOf(1));
        } 
        doc1.createElement("kills", Integer.valueOf(wsqkill));
        doc1.createElement("playerName", (player == null) ? "我方" : player.getPlayerName());
        doc1.endObject();
        doc1.endObject();
        for (Integer playerId : bat.inSceneSet)
          Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_WSQ, doc1.toByte()); 
      } 
    } 
    if (roundInfo.attBattleArmy.getTroopHp()[0] <= 0 && roundInfo.defCampArmy.generalId == 103 && roundInfo.defCampArmy.isjuexing > 0 && roundInfo.defCampArmy.getUnionState() <= 0)
      roundInfo.defCampArmy.xuyaochiyan = true; 
    roundInfo.killAttG = isKillGeneral(roundInfo.attRemain, bat.attList, roundInfo.nextAttBattleArmy);
    if (roundInfo.killAttG) {
      if (bat.attList.size() > 0 && bat.defList.size() > 0)
        bat.setBattleRoundBuff(dataGetter, ((BattleArmy)bat.attList.get(0)).getCampArmy(), ((BattleArmy)bat.defList.get(0)).getCampArmy()); 
      CampArmy defCampArmy6 = roundInfo.defCampArmy, defCampArmy = defCampArmy6;
      defCampArmy6.killGeneral++;
      roundInfo.needPushReport13 = true;
      roundInfo.nextMinExeTime += 1000;
      roundInfo.timePredicationBuffer.append("fight def cheers:").append(0).append("|");
      roundInfo.attCampArmy.armyHp = -1;
      if (defCampArmy.generalId == 204 && defCampArmy.isjuexing > 0)
        defCampArmy.zhaoyunjineng = true; 
      if (roundInfo.attCampArmy.generalId == 268 && roundInfo.attCampArmy.isjuexing > 0)
        roundInfo.battleMsg.append("70|att|-1#"); 
      bat.attCamp.remove(roundInfo.attCampArmy);
      quitNewBattle(roundInfo.attCampArmy, 1, bat);
      if (roundInfo.defCampArmy.getPlayerId() > 0 && !roundInfo.defCampArmy.isPhantom) {
        PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.defCampArmy.getPlayerId()));
        if (pi != null && roundInfo.defCampArmy.killGeneral > pi.maxKillG)
          pi.maxKillG = roundInfo.defCampArmy.killGeneral; 
      } 
      if (roundInfo.attCampArmy.huoshaolianying >= 0 && roundInfo.nextAttBattleArmy != null)
        (roundInfo.nextAttBattleArmy.getCampArmy()).huoshaolianying = roundInfo.attCampArmy.huoshaolianying; 
      if (defCampArmy.isPhantom && defCampArmy.copytype == 20) {
        CampArmy campArmy4 = defCampArmy;
        campArmy4.hbqkillnum++;
        Player player = dataGetter.getPlayerDao().read(defCampArmy.playerId);
        JsonDocument doc1 = new JsonDocument();
        doc1.startObject();
        doc1.startObject("def");
        int hbqkill = 1;
        if (bat.getDefHbqKillInfos().containsKey(Integer.valueOf(defCampArmy.playerId))) {
          hbqkill = ((Integer)bat.getDefHbqKillInfos().get(Integer.valueOf(defCampArmy.playerId))).intValue() + 1;
          bat.getDefHbqKillInfos().put(Integer.valueOf(defCampArmy.playerId), Integer.valueOf(hbqkill));
        } else {
          bat.getDefHbqKillInfos().put(Integer.valueOf(defCampArmy.playerId), Integer.valueOf(1));
        } 
        doc1.createElement("kills", Integer.valueOf(hbqkill));
        doc1.createElement("playerName", (player == null) ? "我方" : player.getPlayerName());
        doc1.endObject();
        doc1.endObject();
        for (Integer playerId : bat.inSceneSet)
          Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_HBQ, doc1.toByte()); 
      } 
      if (defCampArmy.isPhantom && defCampArmy.copytype == 5) {
        CampArmy campArmy5 = defCampArmy;
        campArmy5.xianzhenkillnum++;
        Player player = dataGetter.getPlayerDao().read(defCampArmy.playerId);
        JsonDocument doc1 = new JsonDocument();
        doc1.startObject();
        doc1.startObject("def");
        int xianzhenkill = 1;
        if (bat.getDefXianZhenKillInfos().containsKey(Integer.valueOf(defCampArmy.playerId))) {
          xianzhenkill = ((Integer)bat.getDefXianZhenKillInfos().get(Integer.valueOf(defCampArmy.playerId))).intValue() + 1;
          bat.getDefXianZhenKillInfos().put(Integer.valueOf(defCampArmy.playerId), Integer.valueOf(xianzhenkill));
        } else {
          bat.getDefXianZhenKillInfos().put(Integer.valueOf(defCampArmy.playerId), Integer.valueOf(1));
        } 
        doc1.createElement("dants", Integer.valueOf(xianzhenkill));
        doc1.createElement("playerName", (player == null) ? "我方" : player.getPlayerName());
        doc1.endObject();
        doc1.endObject();
        for (Integer playerId : bat.inSceneSet)
          Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_XIANZHEN, doc1.toByte()); 
      } 
      if (defCampArmy.isPhantom && defCampArmy.copytype == 21) {
        CampArmy campArmy6 = defCampArmy;
        campArmy6.wsqkillnum++;
        Player player = dataGetter.getPlayerDao().read(defCampArmy.playerId);
        JsonDocument doc1 = new JsonDocument();
        doc1.startObject();
        doc1.startObject("def");
        int wsqkill = 1;
        if (bat.getDefWsqKillInfos().containsKey(Integer.valueOf(defCampArmy.playerId))) {
          wsqkill = ((Integer)bat.getDefWsqKillInfos().get(Integer.valueOf(defCampArmy.playerId))).intValue() + 1;
          bat.getDefWsqKillInfos().put(Integer.valueOf(defCampArmy.playerId), Integer.valueOf(wsqkill));
        } else {
          bat.getDefWsqKillInfos().put(Integer.valueOf(defCampArmy.playerId), Integer.valueOf(1));
        } 
        doc1.createElement("kills", Integer.valueOf(wsqkill));
        doc1.createElement("playerName", (player == null) ? "我方" : player.getPlayerName());
        doc1.endObject();
        doc1.endObject();
        for (Integer playerId : bat.inSceneSet)
          Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_WSQ, doc1.toByte()); 
      } 
    } 
    bat.attBaseInfo.foreWin = true;
    if (roundInfo.attRemain <= 0) {
      bat.attBaseInfo.foreWin = false;
      roundInfo.win = 2;
      roundInfo.attKilledList.add(roundInfo.attBattleArmy);
      if (roundInfo.defCampArmy.generalId == 211 && roundInfo.defCampArmy.isjuexing > 0 && roundInfo.defCampArmy.ganninglimit > 0) {
        CampArmy defCampArmy7 = roundInfo.defCampArmy;
        defCampArmy7.ganninglimit--;
        CampArmy defCampArmy8 = roundInfo.defCampArmy;
        defCampArmy8.tacticVal++;
      } 
      if ((roundInfo.defCampArmy.generalId == 278 && roundInfo.defCampArmy.isjuexing > 0) || (roundInfo.defCampArmy.generalId == 204 && roundInfo.defCampArmy.getChapterId() > 3 && roundInfo.defBattleArmy.getYzdq() <= 0)) {
        roundInfo.defBattleArmy.setYzdq(1);
        getReportType60(roundInfo.battleMsg, "def", roundInfo.defBattleArmy.getPosition());
      } 
      if (roundInfo.defCampArmy.mfbuff >= 0 && roundInfo.defCampArmy.generalId == 232 && roundInfo.defCampArmy.isjuexing > 0) {
        CampArmy defCampArmy9 = roundInfo.defCampArmy;
        defCampArmy9.mfbuff++;
      } 
      if (roundInfo.defCampArmy.JxBuff >= 0 && roundInfo.defCampArmy.generalId == 201 && roundInfo.defCampArmy.isjuexing > 0 && roundInfo.defCampArmy.chapterId > 0) {
        CampArmy campArmy = roundInfo.defCampArmy;
        campArmy.JxBuff++;
      } 
      if (roundInfo.defCampArmy.JxBuff >= 0 && roundInfo.defCampArmy.formationtype == 1 && roundInfo.defCampArmy.formationLevel > 1000) {
        CampArmy campArmy = roundInfo.defCampArmy;
        campArmy.JxBuff++;
      } 
      if (roundInfo.defCampArmy.JxBuff >= 0 && roundInfo.defCampArmy.formationtype == 2 && roundInfo.defCampArmy.formationLevel > 1000) {
        CampArmy campArmy = roundInfo.defCampArmy;
        campArmy.JxBuff++;
      } 
      if (roundInfo.defCampArmy.JxBuff >= 0 && roundInfo.defCampArmy.formationtype == 3 && roundInfo.defCampArmy.formationLevel > 1000) {
        CampArmy campArmy = roundInfo.defCampArmy;
        campArmy.JxBuff++;
      } 
      if (roundInfo.defCampArmy.JxBuff >= 0 && roundInfo.defCampArmy.formationtype == 6 && roundInfo.defCampArmy.formationLevel > 1000) {
        CampArmy campArmy = roundInfo.defCampArmy;
        campArmy.JxBuff++;
      } 
    } 
    bat.defBaseInfo.foreWin = true;
    if (roundInfo.defRemain <= 0) {
      bat.defBaseInfo.foreWin = false;
      roundInfo.win = 1;
      roundInfo.defKilledList.add(roundInfo.defBattleArmy);
      if (roundInfo.attCampArmy.generalId == 211 && roundInfo.attCampArmy.isjuexing > 0 && roundInfo.attCampArmy.ganninglimit > 0) {
        CampArmy attCampArmy7 = roundInfo.attCampArmy;
        attCampArmy7.ganninglimit--;
        CampArmy attCampArmy8 = roundInfo.attCampArmy;
        attCampArmy8.tacticVal++;
      } 
      if ((roundInfo.attCampArmy.generalId == 278 && roundInfo.attCampArmy.isjuexing > 0) || (roundInfo.attCampArmy.generalId == 204 && roundInfo.attCampArmy.getChapterId() > 3 && roundInfo.attBattleArmy.getYzdq() <= 0)) {
        roundInfo.attBattleArmy.setYzdq(1);
        getReportType60(roundInfo.battleMsg, "att", roundInfo.attBattleArmy.getPosition());
      } 
      if (roundInfo.attCampArmy.mfbuff >= 0 && roundInfo.attCampArmy.generalId == 232 && roundInfo.attCampArmy.isjuexing > 0) {
        CampArmy attCampArmy9 = roundInfo.attCampArmy;
        attCampArmy9.mfbuff++;
      } 
      if (roundInfo.attCampArmy.JxBuff >= 0 && roundInfo.attCampArmy.generalId == 201 && roundInfo.attCampArmy.isjuexing > 0 && roundInfo.attCampArmy.chapterId > 0) {
        CampArmy campArmy = roundInfo.attCampArmy;
        campArmy.JxBuff++;
      } 
      if (roundInfo.attCampArmy.JxBuff >= 0 && roundInfo.attCampArmy.formationtype == 1 && roundInfo.attCampArmy.formationLevel > 1000) {
        CampArmy campArmy = roundInfo.attCampArmy;
        campArmy.JxBuff++;
      } 
      if (roundInfo.attCampArmy.JxBuff >= 0 && roundInfo.attCampArmy.formationtype == 2 && roundInfo.attCampArmy.formationLevel > 1000) {
        CampArmy campArmy = roundInfo.attCampArmy;
        campArmy.JxBuff++;
      } 
      if (roundInfo.attCampArmy.JxBuff >= 0 && roundInfo.attCampArmy.formationtype == 3 && roundInfo.attCampArmy.formationLevel > 1000) {
        CampArmy campArmy = roundInfo.attCampArmy;
        campArmy.JxBuff++;
      } 
      if (roundInfo.attCampArmy.JxBuff >= 0 && roundInfo.attCampArmy.formationtype == 6 && roundInfo.attCampArmy.formationLevel > 1000) {
        CampArmy campArmy = roundInfo.attCampArmy;
        campArmy.JxBuff++;
      } 
    } 
    if (roundInfo.attRemain <= 0 && roundInfo.defRemain <= 0)
      roundInfo.win = 3; 
    CampArmy attCampArmy10 = roundInfo.attCampArmy, attCampArmy2 = attCampArmy10;
    attCampArmy10.armyHpLoss += roundInfo.attLost;
    CampArmy attCampArmy11 = roundInfo.attCampArmy, attCampArmy3 = attCampArmy11;
    attCampArmy11.armyHpKill += roundInfo.defLost;
    if (roundInfo.defCampArmy.isBarPhantom) {
      CampArmy attCampArmy12 = roundInfo.attCampArmy, attCampArmy4 = attCampArmy12;
      attCampArmy12.barbarainHpKill += roundInfo.defLost;
    } 
    PlayerInfo piAtt = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.attBattleArmy.getCampArmy().getPlayerId()));
    if (piAtt != null) {
      PlayerInfo playerInfo5 = piAtt, playerInfo = playerInfo5;
      playerInfo5.lostTotal += roundInfo.attLost;
      PlayerInfo playerInfo6 = piAtt, playerInfo2 = playerInfo6;
      playerInfo6.killTotal += roundInfo.defLost;
    } 
    CampArmy defCampArmy10 = roundInfo.defCampArmy, defCampArmy2 = defCampArmy10;
    defCampArmy10.armyHpLoss += roundInfo.defLost;
    CampArmy defCampArmy11 = roundInfo.defCampArmy, defCampArmy3 = defCampArmy11;
    defCampArmy11.armyHpKill += roundInfo.attLost;
    if (roundInfo.attCampArmy.isBarPhantom) {
      CampArmy defCampArmy12 = roundInfo.defCampArmy, defCampArmy4 = defCampArmy12;
      defCampArmy12.barbarainHpKill += roundInfo.attLost;
    } 
    PlayerInfo piDef = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.defBattleArmy.getCampArmy().getPlayerId()));
    if (piDef != null) {
      PlayerInfo playerInfo7 = piDef, playerInfo3 = playerInfo7;
      playerInfo7.lostTotal += roundInfo.defLost;
      PlayerInfo playerInfo8 = piDef, playerInfo4 = playerInfo8;
      playerInfo8.killTotal += roundInfo.attLost;
    } 
    if (bat.getAttBaseInfo().getNum() < roundInfo.attLost)
      ErrorSceneLog.getInstance().appendErrorMsg("Builder dealFight att兵力小于0,attbasenum:" + bat.getAttBaseInfo().getNum() + ",attLost:" + roundInfo.attLost + ",builder 5098行"); 
    bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - roundInfo.attLost);
    if (bat.getDefBaseInfo().getNum() < roundInfo.defLost)
      ErrorSceneLog.getInstance().appendErrorMsg("Builder dealFight def兵力小于0,builder 5103行"); 
    bat.getDefBaseInfo().setNum(bat.getDefBaseInfo().getNum() - roundInfo.defLost);
    getReportType56(roundInfo.battleMsg, bat, roundInfo);
    getReportType3(roundInfo.battleMsg, bat, roundInfo);
    getReportType31(roundInfo.battleMsg, roundInfo);
    roundInfo.battleMsg.append(30).append("|");
    if (roundInfo.win != 1) {
      roundInfo.battleMsg.append(roundInfo.attBattleArmy.getPosition()).append("|");
    } else {
      roundInfo.battleMsg.append(-1).append("|");
    } 
    if (roundInfo.win != 2) {
      roundInfo.battleMsg.append(roundInfo.defBattleArmy.getPosition()).append("#");
    } else {
      roundInfo.battleMsg.append(-1).append("#");
    } 
    getReportType20(bat, roundInfo.battleMsg, roundInfo);
    if (roundInfo.killAttG && roundInfo.nextAttBattleArmy != null) {
      if (bat.attList.size() > 1 && bat.defList.size() > 1)
        bat.setBattleRoundBuff(dataGetter, ((BattleArmy)bat.attList.get(1)).getCampArmy(), ((BattleArmy)bat.defList.get(1)).getCampArmy()); 
      getReportType16(dataGetter, bat, roundInfo.battleMsg, roundInfo.nextAttBattleArmy.getCampArmy(), "att", true, false);
    } else {
      getReportType16(dataGetter, bat, roundInfo.battleMsg, roundInfo.attCampArmy, "att", false, false);
    } 
    if (roundInfo.killDefG && roundInfo.nextDefBattleArmy != null) {
      if (bat.attList.size() > 1 && bat.defList.size() > 1)
        bat.setBattleRoundBuff(dataGetter, ((BattleArmy)bat.attList.get(1)).getCampArmy(), ((BattleArmy)bat.defList.get(1)).getCampArmy()); 
      getReportType16(dataGetter, bat, roundInfo.battleMsg, roundInfo.nextDefBattleArmy.getCampArmy(), "def", true, false);
    } else {
      getReportType16(dataGetter, bat, roundInfo.battleMsg, roundInfo.defCampArmy, "def", false, false);
    } 
    if (needreport52)
      getReportType52(dataGetter, bat, roundInfo.battleMsg, roundInfo); 
  }
  
  protected static void getReportType60(StringBuilder battleMsg, String batside, int postion) {
    battleMsg.append(60).append("|").append(batside).append("|").append(postion).append("#");
  }
  
  protected static void getReportType52(IDataGetter dataGetter, Battle bat, StringBuilder battleMsg, RoundInfo roundInfo) {
    if (roundInfo.attCampArmy.buqu > 0) {
      StringBuilder tempb = new StringBuilder();
      boolean atthave = false;
      List<BattleArmy> attList = bat.getAttList();
      if (attList != null && !attList.isEmpty()) {
        tempb.append(52).append("|att*");
        for (int i = 0; i < attList.size(); i++) {
          BattleArmy attbat = attList.get(i);
          if (attbat.getCampArmy().getId() == roundInfo.attCampArmy.id) {
            tempb.append(attbat.getPosition()).append(":").append(roundInfo.attCampArmy.buqu).append(",");
            atthave = true;
          } 
        } 
        tempb.replace(tempb.length() - 1, tempb.length(), "#");
      } 
      if (atthave)
        battleMsg.append(tempb.toString()); 
    } 
    if (roundInfo.defCampArmy.buqu > 0) {
      List<BattleArmy> defList = bat.getDefList();
      StringBuilder tempb2 = new StringBuilder();
      boolean defhave = false;
      if (defList != null && !defList.isEmpty()) {
        tempb2.append(52).append("|def*");
        for (int i = 0; i < defList.size(); i++) {
          BattleArmy defbat = defList.get(i);
          if (defbat.getCampArmy().getId() == roundInfo.defCampArmy.id) {
            tempb2.append(defbat.getPosition()).append(":").append(roundInfo.defCampArmy.buqu).append(",");
            defhave = true;
          } 
        } 
        tempb2.replace(tempb2.length() - 1, tempb2.length(), "#");
      } 
      if (defhave)
        battleMsg.append(tempb2.toString()); 
    } 
  }
  
  protected static boolean isKillGeneral(int remainNum, List<BattleArmy> listQ, BattleArmy nextBattleArmy) {
    if (remainNum <= 0) {
      if (nextBattleArmy == null)
        return true; 
      if (nextBattleArmy.getCampArmy().getId() != ((BattleArmy)listQ.get(0)).getCampArmy().getId())
        return true; 
    } 
    return false;
  }
  
  protected static void getReportType26(StringBuilder battleMsg, RoundInfo roundInfo, Battle battle, IDataGetter dataGetter) {
    battleMsg.append(26).append("|").append(roundInfo.nextMaxExeTime).append("|");
    if (battle.battleType == 3) {
      City city = dataGetter.getCityDao().read(battle.getDefBaseInfo().getId());
      if (city != null && city.getTowerType().intValue() > 0 && city.getTowerHp().intValue() > 0) {
        int maxcd = 12;
        if (city.getTowerType().intValue() == 2) {
          maxcd = 10;
        } else if (city.getTowerType().intValue() == 3) {
          maxcd = 9;
        } 
        int jianshao = city.getTowerHp().intValue() / 20;
        if (jianshao >= 5)
          jianshao = 4; 
        maxcd -= jianshao;
        int shengyu = maxcd - battle.getRoundNum().get() % maxcd;
        if (shengyu == maxcd)
          shengyu = 0; 
        battleMsg.append(shengyu).append("|").append(city.getTowerHp()).append("|").append(maxcd).append("|-1#");
      } else {
        battleMsg.append("-1|-1|-1|-1#");
      } 
    } else {
      battleMsg.append("-1|-1|-1|-1#");
    } 
  }
  
  protected static void getReportType18(StringBuilder battleMsg, CampArmy campArmy, String battleSide) {
    battleMsg.append(18).append("|").append(battleSide).append("|").append(campArmy.armyHpOrg - campArmy.armyHpLoss).append("|").append(campArmy.armyHpOrg).append("#");
  }
  
  protected static void getReportType29(StringBuilder battleMsg, RoundInfo roundInfo, boolean attExeTactic, boolean defExeTactic) {
    if (attExeTactic && defExeTactic) {
      battleMsg.append(29).append("|").append(1).append(";");
      battleMsg.append(100).append("|").append(roundInfo.attTacticInfo.tacticNameId).append("|").append(100).append("|").append(roundInfo.defTacticInfo.tacticNameId).append("#");
    } else if (attExeTactic && !defExeTactic) {
      battleMsg.append(29).append("|").append(1).append(";");
      battleMsg.append(100).append("|").append(roundInfo.attTacticInfo.tacticNameId).append("|").append(roundInfo.defBattleArmy.getStrategy()).append("|").append(FightStrategiesCache.getStrategyPic(roundInfo.defBattleArmy.getStrategy())).append("#");
    } else if (!attExeTactic && defExeTactic) {
      battleMsg.append(29).append("|").append(2).append(";");
      battleMsg.append(roundInfo.attBattleArmy.getStrategy()).append("|").append(FightStrategiesCache.getStrategyPic(roundInfo.attBattleArmy.getStrategy())).append("|").append(100).append("|").append(roundInfo.defTacticInfo.tacticNameId).append("#");
    } else {
      battleMsg.append(29).append("|").append(roundInfo.tacticStrategyResult).append(";");
      battleMsg.append(roundInfo.attBattleArmy.getStrategy()).append("|").append(FightStrategiesCache.getStrategyPic(roundInfo.attBattleArmy.getStrategy())).append("|").append(roundInfo.defBattleArmy.getStrategy()).append("|").append(FightStrategiesCache.getStrategyPic(roundInfo.defBattleArmy.getStrategy())).append("#");
    } 
  }
  
  protected static void getReportType14(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    roundInfo.battleMsg.append(14).append("|").append(roundInfo.tacticStrategyResult).append(";").append(roundInfo.attBattleArmy.getPosition()).append(",").append((roundInfo.attBattleArmy.getCampArmy()).isPhantom ? 0 : roundInfo.attBattleArmy.getCampArmy().getPlayerId()).append("|").append(roundInfo.defBattleArmy.getPosition()).append(",").append((roundInfo.defBattleArmy.getCampArmy()).isPhantom ? 0 : roundInfo.defBattleArmy.getCampArmy().getPlayerId()).append(";");
    if (roundInfo.attTacticInfo != null) {
      int attTacticReduceType = 0;
      int zfBj = 0;
      Tactic tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(roundInfo.attTacticInfo.tacticId));
      if ((bat.battleType == 3 || bat.battleType == 13) && bat.terrainVal == 4 && (tactic == null || !tactic.getSpecialEffect().equalsIgnoreCase("siege_gun")))
        attTacticReduceType = 1; 
      if (roundInfo.attTacticInfo.zfJB)
        attTacticReduceType = 3; 
      if (roundInfo.attTacticInfo.attacked_guanyu)
        attTacticReduceType = 2; 
      if (roundInfo.attTacticInfo.zfBJ)
        zfBj = 1; 
      int stopType = 0;
      if (roundInfo.attRebound && roundInfo.attTacticInfo.beStop) {
        stopType = 3;
      } else if (roundInfo.attRebound) {
        stopType = 2;
      } else if (roundInfo.attTacticInfo.beStop) {
        stopType = 1;
      } 
      roundInfo.battleMsg.append(1).append(",").append(1).append(",").append(roundInfo.attTacticInfo.tacticNameId).append(",").append(stopType).append(",").append(roundInfo.attTacticInfo.tacticDisplayId).append(",").append(roundInfo.attTacticInfo.tacticBasicPic).append(",").append(roundInfo.attBattleArmy.getStrategy()).append(",").append("null").append(",").append(attTacticReduceType).append(",").append(roundInfo.attBattleArmy.getCampArmy().getGeneralPic()).append(",").append(roundInfo.defBattleArmy.getCampArmy().getGeneralPic()).append(",").append(zfBj);
    } else {
      FightStrategies attFT = (FightStrategies)dataGetter.getFightStrategiesCache().get(Integer.valueOf(roundInfo.attBattleArmy.getStrategy()));
      roundInfo.battleMsg.append(2).append(",").append(roundInfo.atthuajie).append(",").append(roundInfo.attBattleArmy.getStrategy()).append(",").append(0).append(",").append(0).append(",").append(0).append(",").append(roundInfo.attBattleArmy.getStrategy()).append(",").append(attFT.getName()).append(",").append(0).append(",").append(0).append(",").append(0);
    } 
    roundInfo.battleMsg.append("|");
    if (roundInfo.defTacticInfo != null) {
      int stopType2 = 0;
      if (roundInfo.defRebound && roundInfo.defTacticInfo.beStop) {
        stopType2 = 3;
      } else if (roundInfo.defRebound) {
        stopType2 = 2;
      } else if (roundInfo.defTacticInfo.beStop) {
        stopType2 = 1;
      } 
      int defTacticReduceType = 0;
      int zfBj2 = 0;
      if (roundInfo.defTacticInfo.zfJB)
        defTacticReduceType = 3; 
      if (roundInfo.defTacticInfo.attacked_guanyu)
        defTacticReduceType = 2; 
      if (roundInfo.defTacticInfo.zfBJ)
        zfBj2 = 1; 
      roundInfo.battleMsg.append(1).append(",").append(roundInfo.defTacticInfo.executed ? 1 : 0).append(",").append(roundInfo.defTacticInfo.tacticNameId).append(",").append(stopType2).append(",").append(roundInfo.defTacticInfo.tacticDisplayId).append(",").append(roundInfo.defTacticInfo.tacticBasicPic).append(",").append(roundInfo.defBattleArmy.getStrategy()).append(",").append("null").append(",").append(defTacticReduceType).append(",").append(roundInfo.attBattleArmy.getCampArmy().getGeneralPic()).append(",").append(roundInfo.defBattleArmy.getCampArmy().getGeneralPic()).append(",").append(zfBj2);
    } else {
      FightStrategies defFT = (FightStrategies)dataGetter.getFightStrategiesCache().get(Integer.valueOf(roundInfo.defBattleArmy.getStrategy()));
      roundInfo.battleMsg.append(2).append(",").append(roundInfo.defhuajie).append(",").append(roundInfo.defBattleArmy.getStrategy()).append(",").append(0).append(",").append(0).append(",").append(0).append(",").append(roundInfo.defBattleArmy.getStrategy()).append(",").append(defFT.getName()).append(",").append(0).append(",").append(0).append(",").append(0);
    } 
    roundInfo.battleMsg.append(";");
    if (roundInfo.defTacticInfo != null) {
      if (StringUtils.isEmpty(roundInfo.defTacticInfo.tacticStr) || roundInfo.defTacticInfo.tacticStr.equalsIgnoreCase("SP")) {
        roundInfo.battleMsg.append("null");
      } else {
        String[] strs = roundInfo.defTacticInfo.tacticStr.split(";");
        for (int i = 0; i < strs.length; i++) {
          roundInfo.battleMsg.append(((BattleArmy)bat.getAttList().get(i)).getPosition()).append(",");
          String[] tempArr = strs[i].split("\\|");
          String tempStr = tempArr[tempArr.length - 1];
          String[] loss = tempStr.split(",");
          for (int j = 0; j < loss.length; j++)
            roundInfo.battleMsg.append(loss[j]).append(",").append(((BattleArmy)bat.getAttList().get(i)).getTroopHp()[j]).append(","); 
          roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "*");
        } 
      } 
    } else if (roundInfo.attStrategyLost > 0) {
      int lost = roundInfo.attStrategyLost / 3;
      roundInfo.battleMsg.append(roundInfo.attBattleArmy.getPosition()).append(",");
      for (int k = 0; k < (roundInfo.attBattleArmy.getTroopHp()).length; k++)
        roundInfo.battleMsg.append(lost).append(",").append(roundInfo.attBattleArmy.getTroopHp()[k]).append(","); 
    } else {
      roundInfo.battleMsg.append("null");
    } 
    roundInfo.battleMsg.append("|");
    if (roundInfo.attTacticInfo != null) {
      if (StringUtils.isEmpty(roundInfo.attTacticInfo.tacticStr) || roundInfo.attTacticInfo.tacticStr.equalsIgnoreCase("SP")) {
        roundInfo.battleMsg.append("null").append(";");
      } else {
        String[] strs = roundInfo.attTacticInfo.tacticStr.split(";");
        for (int i = 0; i < strs.length; i++) {
          roundInfo.battleMsg.append(((BattleArmy)bat.getDefList().get(i)).getPosition()).append(",");
          String[] tempArr = strs[i].split("\\|");
          String tempStr = tempArr[tempArr.length - 1];
          String[] loss = tempStr.split(",");
          for (int j = 0; j < loss.length; j++)
            roundInfo.battleMsg.append(loss[j]).append(",").append(((BattleArmy)bat.getDefList().get(i)).getTroopHp()[j]).append(","); 
          roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), ";");
      } 
    } else if (roundInfo.defStrategyLost > 0) {
      int lost = roundInfo.defStrategyLost / 3;
      roundInfo.battleMsg.append(roundInfo.defBattleArmy.getPosition()).append(",");
      for (int i = 0; i < (roundInfo.defBattleArmy.getTroopHp()).length; i++)
        roundInfo.battleMsg.append(lost).append(",").append(roundInfo.defBattleArmy.getTroopHp()[0]).append(","); 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), ";");
    } else {
      roundInfo.battleMsg.append("null").append(";");
    } 
    if (roundInfo.attTacticInfo != null) {
      if (roundInfo.attTacticInfo.beStop) {
        roundInfo.battleMsg.append("null");
      } else {
        PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.attCampArmy.playerId));
        if (pi != null && pi.rbTop == 0 && roundInfo.attTacticInfo.tacticDrop != null) {
          roundInfo.battleMsg.append(roundInfo.attTacticInfo.tacticDrop.type).append("*").append(roundInfo.attTacticInfo.tacticDrop.num);
        } else {
          roundInfo.battleMsg.append("null");
        } 
      } 
    } else {
      roundInfo.battleMsg.append("null");
    } 
    roundInfo.battleMsg.append("|");
    if (roundInfo.defTacticInfo != null) {
      if (roundInfo.defTacticInfo.beStop) {
        roundInfo.battleMsg.append("null").append(";");
      } else {
        PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.defCampArmy.playerId));
        if (pi != null && pi.rbTop == 0 && roundInfo.defTacticInfo.tacticDrop != null) {
          roundInfo.battleMsg.append(roundInfo.defTacticInfo.tacticDrop.type).append("*").append(roundInfo.defTacticInfo.tacticDrop.num).append(";");
        } else {
          roundInfo.battleMsg.append("null").append(";");
        } 
      } 
    } else {
      roundInfo.battleMsg.append("null").append(";");
    } 
    if (roundInfo.defTacticInfo != null && !roundInfo.defTacticInfo.beStop && roundInfo.defTacticInfo.columnStr != null && roundInfo.defTacticInfo.columnStr != "") {
      roundInfo.battleMsg.append(roundInfo.defTacticInfo.columnStr);
    } else {
      roundInfo.battleMsg.append("null");
    } 
    roundInfo.battleMsg.append("|");
    if (roundInfo.attTacticInfo != null && !roundInfo.attTacticInfo.beStop && roundInfo.attTacticInfo.columnStr != null && roundInfo.attTacticInfo.columnStr != "") {
      roundInfo.battleMsg.append(roundInfo.attTacticInfo.columnStr).append(";");
    } else {
      roundInfo.battleMsg.append("null").append(";");
    } 
    roundInfo.battleMsg.append("null|null;");
    roundInfo.battleMsg.append(roundInfo.attzgl).append(",").append(roundInfo.attzglNum).append(",").append("1|").append(roundInfo.defzgl).append(",").append(roundInfo.defzglNum).append(",1;");
    roundInfo.battleMsg.append("0|0;");
    roundInfo.attshield = "";
    roundInfo.defshield = "";
    String attwwhd = "";
    String defwwhd = "";
    String attssxzs = "";
    String defssxzs = "";
    int l;
    for (l = 0; l < bat.getAttList().size(); l++) {
      BattleArmy attbatarmy = bat.getAttList().get(l);
      if (attbatarmy.getShield() > 0)
        roundInfo.attshield = String.valueOf(String.valueOf(roundInfo.attshield)) + attbatarmy.getPosition() + ":" + attbatarmy.getShield() + ","; 
      if (attbatarmy.getQingCheng() > 0)
        attwwhd = String.valueOf(String.valueOf(attwwhd)) + attbatarmy.getPosition() + "*5,"; 
      if (attbatarmy.getCampArmy().getGeneralId() == 402)
        attssxzs = String.valueOf(String.valueOf(attssxzs)) + attbatarmy.getPosition() + "," + attbatarmy.getCampArmy().getSunShangXiangZs() + "_"; 
    } 
    if (roundInfo.attshield != null && !roundInfo.attshield.equals("")) {
      roundInfo.attshield = roundInfo.attshield.substring(0, roundInfo.attshield.length() - 1);
    } else {
      roundInfo.attshield = null;
    } 
    if (attwwhd != null && !attwwhd.equals("")) {
      attwwhd = attwwhd.substring(0, attwwhd.length() - 1);
    } else {
      attwwhd = null;
    } 
    for (l = 0; l < bat.getDefList().size(); l++) {
      BattleArmy defbatarmy = bat.getDefList().get(l);
      if (defbatarmy.getShield() > 0)
        roundInfo.defshield = String.valueOf(String.valueOf(roundInfo.defshield)) + defbatarmy.getPosition() + ":" + defbatarmy.getShield() + ","; 
      if (defbatarmy.getQingCheng() > 0)
        defwwhd = String.valueOf(String.valueOf(defwwhd)) + defbatarmy.getPosition() + "*5,"; 
      if (defbatarmy.getCampArmy().getGeneralId() == 402)
        defssxzs = String.valueOf(String.valueOf(defssxzs)) + defbatarmy.getPosition() + "," + defbatarmy.getCampArmy().getSunShangXiangZs() + "_"; 
    } 
    if (roundInfo.defshield != null && !roundInfo.defshield.equals("")) {
      roundInfo.defshield = roundInfo.defshield.substring(0, roundInfo.defshield.length() - 1);
    } else {
      roundInfo.defshield = null;
    } 
    if (!defwwhd.equals("")) {
      defwwhd = defwwhd.substring(0, defwwhd.length() - 1);
    } else {
      defwwhd = null;
    } 
    roundInfo.battleMsg.append(roundInfo.attshield).append("|").append(roundInfo.defshield).append(";");
    roundInfo.battleMsg.append("0|0;");
    roundInfo.battleMsg.append(attwwhd).append("|").append(defwwhd).append(";");
    String attpos = (roundInfo.isDefZSCf > 0) ? (new StringBuilder(String.valueOf(roundInfo.attBattleArmy.getPosition()))).toString() : "null";
    String defpos = (roundInfo.isAttZsCf > 0) ? (new StringBuilder(String.valueOf(roundInfo.defBattleArmy.getPosition()))).toString() : "null";
    roundInfo.battleMsg.append(roundInfo.isAttZsCf).append(",").append(attpos).append("|").append(roundInfo.isDefZSCf).append(",").append(defpos).append(";");
    roundInfo.battleMsg.append("null|null;");
    if (roundInfo.attlieyanstr != null && roundInfo.attlieyanstr.length() > 0) {
      roundInfo.battleMsg.append(roundInfo.attlieyanstr);
      roundInfo.attlieyanstr = null;
    } else {
      roundInfo.battleMsg.append("null:");
    } 
    if (roundInfo.deflieyanstr != null && roundInfo.deflieyanstr.length() > 0) {
      roundInfo.battleMsg.append(roundInfo.deflieyanstr);
      roundInfo.deflieyanstr = null;
    } else {
      roundInfo.battleMsg.append("null");
    } 
    roundInfo.battleMsg.append(";null|null;null|null");
    roundInfo.battleMsg.append(";null|null");
    roundInfo.battleMsg.append(";null|null");
    roundInfo.battleMsg.append(";0|0");
    roundInfo.battleMsg.append(";null|null");
    roundInfo.battleMsg.append(";0|0");
    if (!attssxzs.equals(""))
      attssxzs = attssxzs.substring(0, attssxzs.length() - 1); 
    if (!defssxzs.equals(""))
      defssxzs = defssxzs.substring(0, defssxzs.length() - 1); 
    roundInfo.battleMsg.append(";").append(attssxzs).append("|").append(defssxzs).append("#");
  }
  
  protected static void getReportType43(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    roundInfo.battleMsg.append(43).append("|").append(roundInfo.tacticStrategyResult).append(";").append(roundInfo.attBattleArmy.getPosition()).append(",").append((roundInfo.attBattleArmy.getCampArmy()).isPhantom ? 0 : roundInfo.attBattleArmy.getCampArmy().getPlayerId()).append("|").append(roundInfo.defBattleArmy.getPosition()).append(",").append((roundInfo.defBattleArmy.getCampArmy()).isPhantom ? 0 : roundInfo.defBattleArmy.getCampArmy().getPlayerId()).append(";");
    if (roundInfo.attTacticInfo != null) {
      int attTacticReduceType = 0;
      int zfBj = 0;
      Tactic tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(roundInfo.attTacticInfo.tacticId));
      if ((bat.battleType == 3 || bat.battleType == 13) && bat.terrainVal == 4 && (tactic == null || !tactic.getSpecialEffect().equalsIgnoreCase("siege_gun")))
        attTacticReduceType = 1; 
      if (roundInfo.attTacticInfo.zfJB)
        attTacticReduceType = 3; 
      if (roundInfo.attTacticInfo.attacked_guanyu)
        attTacticReduceType = 2; 
      if (roundInfo.attTacticInfo.zfBJ)
        zfBj = 1; 
      int stopType = 0;
      if (roundInfo.attRebound && roundInfo.attTacticInfo.beStop) {
        stopType = 3;
      } else if (roundInfo.attRebound) {
        stopType = 2;
      } else if (roundInfo.attTacticInfo.beStop) {
        stopType = 1;
      } 
      roundInfo.battleMsg.append(1).append(",").append(1).append(",").append(roundInfo.attTacticInfo.tacticNameId).append(",").append(stopType).append(",").append((stopType == 1 || stopType == 3) ? roundInfo.defCampArmy.getcDifyType() : roundInfo.attTacticInfo.tacticDisplayId).append(",").append(roundInfo.attTacticInfo.tacticBasicPic).append(",").append(roundInfo.attBattleArmy.getStrategy()).append(",").append("null").append(",").append(attTacticReduceType).append(",").append(roundInfo.attBattleArmy.getCampArmy().getGeneralPic()).append(",").append(roundInfo.defBattleArmy.getCampArmy().getGeneralPic()).append(",").append(zfBj);
    } else {
      FightStrategies attFT = (FightStrategies)dataGetter.getFightStrategiesCache().get(Integer.valueOf(roundInfo.attBattleArmy.getStrategy()));
      roundInfo.battleMsg.append(2).append(",").append(roundInfo.atthuajie).append(",").append(roundInfo.attBattleArmy.getStrategy()).append(",").append(0).append(",").append(0).append(",").append(0).append(",").append(roundInfo.attBattleArmy.getStrategy()).append(",").append(attFT.getName()).append(",").append(0).append(",").append(0).append(",").append(0);
    } 
    roundInfo.battleMsg.append("|");
    if (roundInfo.defTacticInfo != null) {
      int stopType2 = 0;
      if (roundInfo.defRebound && roundInfo.defTacticInfo.beStop) {
        stopType2 = 3;
      } else if (roundInfo.defRebound) {
        stopType2 = 2;
      } else if (roundInfo.defTacticInfo.beStop) {
        stopType2 = 1;
      } 
      int defTacticReduceType = 0;
      int zfBj2 = 0;
      if (roundInfo.defTacticInfo.zfJB)
        defTacticReduceType = 3; 
      if (roundInfo.defTacticInfo.attacked_guanyu)
        defTacticReduceType = 2; 
      if (roundInfo.defTacticInfo.zfBJ)
        zfBj2 = 1; 
      roundInfo.battleMsg.append(1).append(",").append(roundInfo.defTacticInfo.executed ? 1 : 0).append(",").append(roundInfo.defTacticInfo.tacticNameId).append(",").append(stopType2).append(",").append((stopType2 == 1 || stopType2 == 3) ? roundInfo.attCampArmy.getcDifyType() : roundInfo.defTacticInfo.tacticDisplayId).append(",").append(roundInfo.defTacticInfo.tacticBasicPic).append(",").append(roundInfo.defBattleArmy.getStrategy()).append(",").append("null").append(",").append(defTacticReduceType).append(",").append(roundInfo.attBattleArmy.getCampArmy().getGeneralPic()).append(",").append(roundInfo.defBattleArmy.getCampArmy().getGeneralPic()).append(",").append(zfBj2);
    } else {
      FightStrategies defFT = (FightStrategies)dataGetter.getFightStrategiesCache().get(Integer.valueOf(roundInfo.defBattleArmy.getStrategy()));
      roundInfo.battleMsg.append(2).append(",").append(roundInfo.defhuajie).append(",").append(roundInfo.defBattleArmy.getStrategy()).append(",").append(0).append(",").append(0).append(",").append(0).append(",").append(roundInfo.defBattleArmy.getStrategy()).append(",").append(defFT.getName()).append(",").append(0).append(",").append(0).append(",").append(0);
    } 
    roundInfo.battleMsg.append(";");
    if (roundInfo.defTacticInfo != null) {
      if (StringUtils.isEmpty(roundInfo.defTacticInfo.tacticStr) || roundInfo.defTacticInfo.tacticStr.equalsIgnoreCase("SP")) {
        roundInfo.battleMsg.append("null");
      } else {
        String[] strs = roundInfo.defTacticInfo.tacticStr.split(";");
        for (int i = 0; i < strs.length; i++) {
          roundInfo.battleMsg.append(((BattleArmy)bat.getAttList().get(i)).getPosition()).append(",");
          String[] tempArr = strs[i].split("\\|");
          String tempStr = tempArr[tempArr.length - 1];
          String[] loss = tempStr.split(",");
          for (int j = 0; j < loss.length; j++) {
            if (i == 0) {
              roundInfo.battleMsg.append(roundInfo.dcss).append(",").append(0).append(",");
            } else {
              roundInfo.battleMsg.append(loss[j]).append(",").append(((BattleArmy)bat.getAttList().get(i)).getTroopHp()[j]).append(",");
            } 
          } 
          roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "*");
        } 
        roundInfo.battleMsg.deleteCharAt(roundInfo.battleMsg.length() - 1);
      } 
    } else if (roundInfo.attStrategyLost > 0) {
      int lost = roundInfo.attStrategyLost / 3;
      roundInfo.battleMsg.append(roundInfo.attBattleArmy.getPosition()).append(",");
      for (int k = 0; k < (roundInfo.attBattleArmy.getTroopHp()).length; k++)
        roundInfo.battleMsg.append(lost).append(",").append(roundInfo.attBattleArmy.getTroopHp()[k]).append(","); 
    } else {
      roundInfo.battleMsg.append("null");
    } 
    roundInfo.battleMsg.append("|");
    if (roundInfo.attTacticInfo != null) {
      if (StringUtils.isEmpty(roundInfo.attTacticInfo.tacticStr) || roundInfo.attTacticInfo.tacticStr.equalsIgnoreCase("SP")) {
        roundInfo.battleMsg.append("null").append(";");
      } else {
        String[] strs = roundInfo.attTacticInfo.tacticStr.split(";");
        for (int i = 0; i < strs.length; i++) {
          roundInfo.battleMsg.append(((BattleArmy)bat.getDefList().get(i)).getPosition()).append(",");
          String[] tempArr = strs[i].split("\\|");
          String tempStr = tempArr[tempArr.length - 1];
          String[] loss = tempStr.split(",");
          for (int j = 0; j < loss.length; j++) {
            if (i == 0) {
              roundInfo.battleMsg.append(roundInfo.dcss).append(",").append(0).append(",");
            } else {
              roundInfo.battleMsg.append(loss[j]).append(",").append(((BattleArmy)bat.getDefList().get(i)).getTroopHp()[j]).append(",");
            } 
          } 
          roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), ";");
      } 
    } else if (roundInfo.defStrategyLost > 0) {
      int lost = roundInfo.defStrategyLost / 3;
      roundInfo.battleMsg.append(roundInfo.defBattleArmy.getPosition()).append(",");
      for (int i = 0; i < (roundInfo.defBattleArmy.getTroopHp()).length; i++)
        roundInfo.battleMsg.append(lost).append(",").append(roundInfo.defBattleArmy.getTroopHp()[0]).append(","); 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), ";");
    } else {
      roundInfo.battleMsg.append("null").append(";");
    } 
    roundInfo.battleMsg.append("0:0.0|0:0.0;");
    if (roundInfo.attlieyanstr != null && roundInfo.attlieyanstr.length() > 0) {
      roundInfo.battleMsg.append(roundInfo.attlieyanstr);
      roundInfo.attlieyanstr = null;
    } else {
      roundInfo.battleMsg.append("null:");
    } 
    if (roundInfo.deflieyanstr != null && roundInfo.deflieyanstr.length() > 0) {
      roundInfo.battleMsg.append(roundInfo.deflieyanstr);
      roundInfo.deflieyanstr = null;
    } else {
      roundInfo.battleMsg.append("null");
    } 
    roundInfo.battleMsg.append("#");
  }
  
  public static void getReportType27(StringBuilder battleMsg, RoundInfo roundInfo, Battle bat, IDataGetter dataGetter, long countDown) {
    int attqizhen = 0;
    int attflz = 0;
    int attdzz = 0;
    int defqizhen = 0;
    int defflz = 0;
    int defdzz = 0;
    if (roundInfo == null)
      return; 
    CampArmy attCa = null;
    BattleArmy attBa = null;
    if (bat.getAttList().size() > 0) {
      attBa = bat.getAttList().get(0);
      attCa = ((BattleArmy)bat.getAttList().get(0)).getCampArmy();
    } 
    CampArmy defCa = null;
    BattleArmy defBa = null;
    if (bat.getDefList().size() > 0) {
      defBa = bat.getDefList().get(0);
      defCa = ((BattleArmy)bat.getDefList().get(0)).getCampArmy();
    } 
    boolean attNextChoose = false;
    if (roundInfo.win == 1 && attCa == null) {
      int playerId = attCa.playerId;
      PlayerInfo piDef = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(playerId));
      if (playerId > 0 && attCa.isPhantom && piDef == null && piDef.autoStrategy == 1) {
        FightStragtegyCoe fsc = dataGetter.getFightStragtegyCoeCache().getAttWin(roundInfo.defBattleArmy.getStrategy(), attCa.strategies);
        int canChooseTac = 0;
        if (attBa.getSpecial() > 0) {
          canChooseTac = 1;
        } else if (defCa != null && (defCa.getSpecialGeneral()).generalType == 8) {
          canChooseTac = 3;
        } 
        battleMsg.append(27).append("|")
          .append("att")
          .append("|")
          .append(playerId)
          .append("|")
          .append(attBa
            .getPosition()).append("|")
          .append(attCa.playerName)
          .append("|")
          .append(countDown)
          .append("|")
          .append(1)
          .append(";");
        if (attCa.getLegendEvoke() && attCa.getLegendSkill() != null && attCa.getLegendSkill().containsKey("qizhen") && ((Integer)attCa.getLegendSkill().get("qizhen")).intValue() > 0)
          attqizhen = 1; 
        if (attCa.getLegendEvoke() && attCa.getLegendSkill() != null && attCa.getLegendSkill().containsKey("flz") && ((Integer)attCa.getLegendSkill().get("flz")).intValue() > 0)
          attflz = 2; 
        if (attCa.getLegendEvoke() && attCa.getLegendSkill() != null && attCa.getLegendSkill().containsKey("dzz") && ((Integer)attCa.getLegendSkill().get("dzz")).intValue() > 0)
          attdzz = 3; 
        battleMsg.append(fsc.getAttStrategy()).append("|")
          .append(attCa.strategies[0])
          .append("|")
          .append(((FightStrategies)dataGetter
            .getFightStrategiesCache().get(Integer.valueOf(attCa.strategies[0]))).getName()).append("|0|")
          .append(attCa.strategies[1])
          .append("|")
          .append(((FightStrategies)dataGetter
            .getFightStrategiesCache().get(Integer.valueOf(attCa.strategies[1]))).getName()).append("|0|")
          .append(attCa.strategies[2])
          .append("|")
          .append(((FightStrategies)dataGetter
            .getFightStrategiesCache().get(Integer.valueOf(attCa.strategies[2]))).getName()).append("|0;");
        battleMsg.append(attBa.getPosition()).append("|")
          .append(
            (attBa.getCampArmy().getTacticVal() > 0) ? 1 : 0)
          .append("|")
          .append(attBa
            .getCampArmy().getGeneralPic()).append("|")
          .append(canChooseTac)
          .append("|")
          .append(attBa
            .getSpecial())
          .append("|")
          .append(0)
          .append(";").append((attCa.getBzStatus() > 0) ? 1 : 0).append(";").append(0).append(";");
        if (attqizhen == 1)
          battleMsg.append(attqizhen).append(",").append(attflz).append(",").append(attdzz); 
        battleMsg.append("#");
        attNextChoose = true;
      } 
    } 
    if (attNextChoose && bat.getAttList().size() > 0) {
      battleMsg.append(27).append("|").append("att").append("|")
        .append(attCa.playerId)
        .append("|")
        .append(attBa
          .getPosition()).append("|")
        .append(attCa.playerName)
        .append("|")
        .append(countDown)
        .append("|")
        .append(0)
        .append(";");
      battleMsg.append("null").append(";");
      battleMsg.append("null").append("#");
    } 
    boolean defNextChoose = false;
    if (roundInfo.win == 2 && defCa != null) {
      int playerId2 = defCa.playerId;
      PlayerInfo piAtt = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(playerId2));
      if (playerId2 > 0 && !defCa.isPhantom() && piAtt == null && piAtt.autoStrategy != 1) {
        FightStragtegyCoe fsc2 = dataGetter.getFightStragtegyCoeCache().getAttWin(roundInfo.attBattleArmy.getStrategy(), defCa.strategies);
        int canChooseTac2 = 0;
        if (defBa.getSpecial() > 0) {
          canChooseTac2 = 1;
        } else if (attCa == null && (attCa.getSpecialGeneral()).generalType == 8) {
          canChooseTac2 = 3;
        } else if (bat.surround > 0) {
          canChooseTac2 = 2;
        } 
        if (defCa.getLegendEvoke() && defCa.getLegendSkill() != null && defCa.getLegendSkill().containsKey("qizhen") && (
          (Integer)defCa
          .getLegendSkill().get("qizhen")).intValue() > 0)
          defqizhen = 1; 
        if (defCa.getLegendEvoke() && defCa.getLegendSkill() != null && defCa.getLegendSkill().containsKey("flz") && (
          (Integer)defCa
          .getLegendSkill().get("flz")).intValue() > 0)
          defflz = 2; 
        if (defCa.getLegendEvoke() && defCa.getLegendSkill() != null && defCa.getLegendSkill().containsKey("dzz") && (
          (Integer)defCa
          .getLegendSkill().get("dzz")).intValue() > 0)
          defdzz = 3; 
        battleMsg.append(27).append("|").append("def").append("|")
          .append(playerId2)
          .append("|")
          .append(defBa
            .getPosition()).append("|")
          .append(defCa.playerName)
          .append("|")
          .append(countDown)
          .append("|")
          .append(1)
          .append(";");
        battleMsg.append(fsc2.getDefStrategy()).append("|")
          .append(defCa.strategies[0])
          .append("|")
          .append(((FightStrategies)dataGetter
            .getFightStrategiesCache().get(Integer.valueOf(defCa.strategies[0]))).getName()).append("|0|")
          .append(defCa.strategies[1])
          .append("|")
          .append(((FightStrategies)dataGetter
            .getFightStrategiesCache().get(Integer.valueOf(defCa.strategies[1]))).getName()).append("|0|")
          .append(defCa.strategies[2])
          .append("|")
          .append(((FightStrategies)dataGetter
            .getFightStrategiesCache().get(Integer.valueOf(defCa.strategies[2]))).getName()).append("|0;");
        battleMsg.append(defBa.getPosition()).append("|")
          .append(
            (defBa.getCampArmy().getTacticVal() > 0) ? 1 : 0)
          .append("|")
          .append(defBa
            .getCampArmy().getGeneralPic()).append("|")
          .append(canChooseTac2)
          .append("|")
          .append(defBa
            .getSpecial()).append("|")
          .append(0)
          .append(";").append(defCa.getBzStatus()).append(";").append(0).append(";");
        if (defqizhen == 1)
          battleMsg.append(defqizhen).append(",").append(defflz).append(",").append(defdzz); 
        battleMsg.append("#");
        defNextChoose = true;
      } 
    } 
    if (!defNextChoose && bat.getDefList().size() > 0) {
      battleMsg.append(27).append("|").append("def").append("|")
        .append(defCa.playerId)
        .append("|")
        .append(defBa
          .getPosition()).append("|")
        .append(defCa.playerName)
        .append("|")
        .append(countDown)
        .append("|")
        .append(0)
        .append(";");
      battleMsg.append("null").append(";");
      battleMsg.append("null").append("#");
    } 
  }
  
  protected static void getReportType30(StringBuilder battleMsg, RoundInfo roundInfo) {
    battleMsg.append(30).append("|");
    if (roundInfo.attKilledList.size() > 0) {
      for (BattleArmy ba : roundInfo.attKilledList)
        battleMsg.append(ba.getPosition()).append(","); 
      battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "|");
    } else {
      battleMsg.append(-1).append("|");
    } 
    if (roundInfo.defKilledList.size() > 0) {
      for (BattleArmy ba : roundInfo.defKilledList)
        battleMsg.append(ba.getPosition()).append(","); 
      battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "#");
    } else {
      battleMsg.append(-1).append("#");
    } 
  }
  
  protected static void getReportType31(StringBuilder battleMsg, RoundInfo roundInfo) {
    battleMsg.append(31).append("|").append(roundInfo.win).append("#");
  }
  
  public static void getReportType100(IDataGetter dataGetter, Battle battle, StringBuilder battleMsg) {
    try {
      if (battle.battleType != 3 && battle.battleType != 13)
        return; 
      StringBuilder attPart = new StringBuilder();
      StringBuilder defPart = new StringBuilder();
      CampArmy attCa = null;
      if (battle.getAttList().size() > 0)
        attCa = ((BattleArmy)battle.getAttList().get(0)).getCampArmy(); 
      CampArmy defCa = null;
      if (battle.getDefList().size() > 0)
        defCa = ((BattleArmy)battle.getDefList().get(0)).getCampArmy(); 
      if (attCa == null || defCa == null)
        return; 
      int attForceId = attCa.forceId;
      int defForceId = defCa.forceId;
      int defId = battle.defBaseInfo.id;
      long tryExipreTime = dataGetter.getNationService().getTryTaskCd(attForceId);
      if (tryExipreTime > System.currentTimeMillis())
        attPart.append(1).append(",").append(attForceId).append(",").append(tryExipreTime - System.currentTimeMillis()).append(",").append(0).append(";"); 
      tryExipreTime = dataGetter.getNationService().getTryTaskCd(defForceId);
      if (tryExipreTime > System.currentTimeMillis())
        defPart.append(1).append(",").append(defForceId).append(",").append(tryExipreTime - System.currentTimeMillis()).append(",").append(0).append(";"); 
      ConcurrentHashMap<Integer, ManWangLingObj> map = (ConcurrentHashMap<Integer, ManWangLingObj>)(ManWangLingManager.getInstance()).manWangLingObjMap.get(Integer.valueOf(attForceId));
      if (map != null) {
        ManWangLingObj manWangLingObj = map.get(Integer.valueOf(2));
        if (manWangLingObj != null && battle.battleType == 3 && defId == manWangLingObj.targetCityId && manWangLingObj.expireTime > System.currentTimeMillis())
          attPart.append(2).append(",").append(attForceId).append(",").append(manWangLingObj.expireTime - System.currentTimeMillis()).append(",").append(0).append(";"); 
      } 
      map = (ConcurrentHashMap<Integer, ManWangLingObj>)(ManWangLingManager.getInstance()).manWangLingObjMap.get(Integer.valueOf(defForceId));
      if (map != null) {
        ManWangLingObj manWangLingObj = map.get(Integer.valueOf(2));
        if (manWangLingObj != null && battle.battleType == 3 && defId == manWangLingObj.targetCityId && manWangLingObj.expireTime > System.currentTimeMillis())
          defPart.append(2).append(",").append(defForceId).append(",").append(manWangLingObj.expireTime - System.currentTimeMillis()).append(",").append(0).append(";"); 
      } 
      int BarbarainInvadeRound = (NewBattleManager.getInstance()).BarbarainInvadeRound;
      long BarbarainInvadeCountDown = (NewBattleManager.getInstance()).BarbarainInvadeCountDown;
      if (BarbarainInvadeRound > 0 && BarbarainInvadeCountDown > 0L) {
        attPart.append(3).append(",").append(attForceId).append(",").append(BarbarainInvadeCountDown).append(",").append(BarbarainInvadeRound).append(";");
        defPart.append(3).append(",").append(defForceId).append(",").append(BarbarainInvadeCountDown).append(",").append(BarbarainInvadeRound).append(";");
      } 
      Tuple<Integer, Long> tuple = dataGetter.getRankService().getNextInvadeInfo(attForceId);
      if (tuple != null && ((Long)tuple.right).longValue() > 0L)
        attPart.append(4).append(",").append(attForceId).append(",").append(tuple.right).append(",").append(tuple.left).append(";"); 
      tuple = dataGetter.getRankService().getNextInvadeInfo(defForceId);
      if (tuple != null && ((Long)tuple.right).longValue() > 0L)
        defPart.append(4).append(",").append(defForceId).append(",").append(tuple.right).append(",").append(tuple.left).append(";"); 
      boolean isNTYellowTurbans = dataGetter.getBattleService().isNTYellowTurbansXiangYangDoing(battle.getDefBaseInfo().getId());
      if (isNTYellowTurbans) {
        int jitanNum = RankService.taskInfo.getTempleNum();
        if (jitanNum <= 0)
          jitanNum = 0; 
        attPart.append(6).append(",").append(attForceId).append(",").append(jitanNum).append(",").append(0).append(";");
        defPart.append(6).append(",").append(attForceId).append(",").append(jitanNum).append(",").append(0).append(";");
      } 
      Long shaDiLingExpireTime = battle.getShaDiLingExpireTime(Integer.valueOf(attForceId));
      if (shaDiLingExpireTime != null && shaDiLingExpireTime.longValue() > System.currentTimeMillis())
        attPart.append(5).append(",").append(attForceId).append(",").append(shaDiLingExpireTime.longValue() - System.currentTimeMillis()).append(",").append(0).append(";"); 
      shaDiLingExpireTime = battle.getShaDiLingExpireTime(Integer.valueOf(defForceId));
      if (shaDiLingExpireTime != null && shaDiLingExpireTime.longValue() > System.currentTimeMillis())
        defPart.append(5).append(",").append(defForceId).append(",").append(shaDiLingExpireTime.longValue() - System.currentTimeMillis()).append(",").append(0).append(";"); 
      if (attPart.length() == 0 && defPart.length() == 0)
        return; 
      battleMsg.append(100).append("|").append(attPart).append("|").append(defPart).append("#");
    } catch (Exception e) {
      ErrorSceneLog.getInstance().error("Builder.getReportType100 catch Exception", e);
    } 
  }
  
  protected static void getReportType20(Battle bat, StringBuilder battleMsg, RoundInfo roundInfo) {
    if (roundInfo.killDefG) {
      battleMsg.append(20).append("|").append("att").append(";").append(roundInfo.attCampArmy.id).append(";").append(roundInfo.attCampArmy.killGeneral).append(";").append(roundInfo.attCampArmy.playerId).append(";");
      boolean addNeeded = true;
      int currentCA = roundInfo.attCampArmy.id;
      for (BattleArmy ba : bat.attList) {
        if (ba.getCampArmy().getId() == currentCA) {
          addNeeded = false;
          battleMsg.append(ba.getPosition()).append(",");
        } 
      } 
      if (addNeeded)
        battleMsg.append("null").append("#"); 
      battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "#");
    } 
    if (roundInfo.killAttG) {
      battleMsg.append(20).append("|").append("def").append(";").append(roundInfo.defCampArmy.id).append(";").append(roundInfo.defCampArmy.killGeneral).append(";").append(roundInfo.defCampArmy.playerId).append(";");
      boolean addNeeded = true;
      int currentCA = roundInfo.defCampArmy.id;
      for (BattleArmy ba : bat.defList) {
        if (ba.getCampArmy().getId() == currentCA) {
          addNeeded = false;
          battleMsg.append(ba.getPosition()).append(",");
        } 
      } 
      if (addNeeded)
        battleMsg.append("null").append("#"); 
      battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "#");
    } 
  }
  
  protected static void getReportType69(StringBuilder battleMsg, RoundInfo roundInfo) {
    if ((roundInfo.attCampArmy.generalId == 281 && roundInfo.attCampArmy.isjuexing <= 0) || (roundInfo.attCampArmy.generalId == 416 && roundInfo.attCampArmy.getChapterId() > 2) || roundInfo.attCampArmy.getBuff().equals("baqi"))
      battleMsg.append(69).append("|").append("att").append("|").append(roundInfo.attCampArmy.baqi1).append(",").append(roundInfo.attCampArmy.baqi2).append(",").append(roundInfo.attCampArmy.baqi3).append("#"); 
    if ((roundInfo.defCampArmy.generalId == 281 && roundInfo.defCampArmy.isjuexing <= 0) || (roundInfo.defCampArmy.generalId == 416 && roundInfo.defCampArmy.getChapterId() > 2) || roundInfo.defCampArmy.getBuff().equals("baqi"))
      battleMsg.append(69).append("|").append("def").append("|").append(roundInfo.defCampArmy.baqi1).append(",").append(roundInfo.defCampArmy.baqi2).append(",").append(roundInfo.defCampArmy.baqi3).append("#"); 
  }
  
  protected static void getReportType19(StringBuilder battleMsg, RoundInfo roundInfo) {
    if (roundInfo.attCampArmy.playerId > 0) {
      battleMsg.append(19).append("|").append("att").append(";");
      battleMsg.append(roundInfo.attCampArmy.playerId).append("|").append(roundInfo.attRoundReward.gExp).append("|").append(roundInfo.attRoundReward.mUpLv).append("|").append(roundInfo.attRoundReward.gUpLv).append(";");
      if (roundInfo.attRoundReward.roundDropMap == null || roundInfo.attRoundReward.roundDropMap.size() == 0) {
        battleMsg.append(0).append("*").append(0).append("#");
      } else {
        Map<Integer, Integer> attRoundDrop = new HashMap<>();
        for (BattleDrop battleDrop : roundInfo.attRoundReward.roundDropMap.values()) {
          Integer key = Integer.valueOf(battleDrop.type);
          if (key.intValue() > 1000)
            key = Integer.valueOf(key.intValue() - 1000); 
          if (attRoundDrop.containsKey(key)) {
            int newNum = ((Integer)attRoundDrop.get(key)).intValue() + battleDrop.num;
            if (key.intValue() == 16 || key.intValue() == 1016)
              key = Integer.valueOf(32); 
            attRoundDrop.put(key, Integer.valueOf(newNum));
            continue;
          } 
          if (key.intValue() == 16 || key.intValue() == 1016)
            key = Integer.valueOf(32); 
          attRoundDrop.put(key, Integer.valueOf(battleDrop.num));
        } 
        for (Integer key2 : attRoundDrop.keySet())
          battleMsg.append(key2).append("*").append(attRoundDrop.get(key2)).append("|"); 
        battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "#");
      } 
    } 
    if (roundInfo.defCampArmy.playerId > 0) {
      battleMsg.append(19).append("|").append("def").append(";");
      battleMsg.append(roundInfo.defCampArmy.playerId).append("|").append(roundInfo.defRoundReward.gExp).append("|").append(roundInfo.defRoundReward.mUpLv).append("|").append(roundInfo.defRoundReward.gUpLv).append(";");
      if (roundInfo.defRoundReward.roundDropMap == null || roundInfo.defRoundReward.roundDropMap.size() == 0) {
        battleMsg.append(0).append("*").append(0).append("#");
      } else {
        Map<Integer, Integer> defRoundDrop = new HashMap<>();
        for (BattleDrop battleDrop : roundInfo.defRoundReward.roundDropMap.values()) {
          Integer key = Integer.valueOf(battleDrop.type);
          if (key.intValue() > 1000)
            key = Integer.valueOf(key.intValue() - 1000); 
          if (defRoundDrop.containsKey(key)) {
            int newNum = ((Integer)defRoundDrop.get(key)).intValue() + battleDrop.num;
            if (key.intValue() == 16 || key.intValue() == 1016)
              key = Integer.valueOf(32); 
            defRoundDrop.put(key, Integer.valueOf(newNum));
            continue;
          } 
          if (key.intValue() == 16 || key.intValue() == 1016)
            key = Integer.valueOf(32); 
          defRoundDrop.put(key, Integer.valueOf(battleDrop.num));
        } 
        for (Integer key2 : defRoundDrop.keySet())
          battleMsg.append(key2).append("*").append(defRoundDrop.get(key2)).append("|"); 
        battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "#");
      } 
    } 
  }
  
  protected static void getReportType8(StringBuilder battleMsg, RoundInfo roundInfo) {
    if (roundInfo.killDefG)
      battleMsg.append(8).append("|").append("def").append(";").append(roundInfo.defCampArmy.getId()).append("#"); 
    if (roundInfo.killAttG)
      battleMsg.append(8).append("|").append("att").append(";").append(roundInfo.attCampArmy.getId()).append("#"); 
  }
  
  protected static void getReportType3(StringBuilder battleMsg, Battle bat, RoundInfo roundInfo) {
    int len = roundInfo.reports.length;
    if (len > 0) {
      battleMsg.append(3).append("|").append(bat.battleNum.incrementAndGet()).append("|").append(roundInfo.win).append(";");
      battleMsg.append(roundInfo.attBattleArmy.getPosition()).append("|").append(roundInfo.defBattleArmy.getPosition()).append(";");
      for (int i = 0; i < len; i++) {
        battleMsg.append(roundInfo.reports[i].replace(";", ","));
        if (i < len - 1)
          battleMsg.append("*"); 
      } 
      battleMsg.append(";");
      int[] troopHp = roundInfo.attBattleArmy.getTroopHp();
      for (int j = 0; j < troopHp.length; j++) {
        int left = troopHp[j];
        battleMsg.append(left).append(",");
      } 
      battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "|");
      int[] troopHp2 = roundInfo.defBattleArmy.getTroopHp();
      for (int k = 0; k < troopHp2.length; k++) {
        int left2 = troopHp2[k];
        battleMsg.append(left2).append(",");
      } 
      if (roundInfo.carskilleffect != null && roundInfo.carskilleffect.length() > 0) {
        battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "=");
        battleMsg.append(roundInfo.carskilleffect.toString());
        roundInfo.carskilleffect = null;
      } else {
        battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "=");
        battleMsg.append("null:null=");
      } 
      battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "=");
      int attAttack = roundInfo.attCampArmy.getAttack();
      if (attAttack <= 0)
        attAttack = roundInfo.attCampArmy.getAttackLevel(); 
      int defAttack = roundInfo.defCampArmy.getAttack();
      if (defAttack <= 0)
        defAttack = roundInfo.defCampArmy.getAttackLevel(); 
      battleMsg.append((attAttack == 0) ? null : Integer.valueOf(attAttack)).append(":").append((defAttack == 0) ? null : Integer.valueOf(defAttack)).append("#");
      battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "#");
    } 
  }
  
  protected static void getReportType56(StringBuilder battleMsg, Battle bat, RoundInfo roundInfo) {
    if (roundInfo.zhanchetoushistr != null && roundInfo.zhanchetoushistr.length() > 0) {
      battleMsg.append(56).append("|").append(roundInfo.zhanchetoushistr.toString()).append("#");
      roundInfo.zhanchetoushistr = null;
    } 
  }
  
  protected static void getArrowTowerInfo(IDataGetter dataGetter, Battle bat, StringBuilder battleMsg, int defId, int battleType) {
    int maxcd = 12;
    int shengyu = 8;
    City city = null;
    if (battleType == 3) {
      city = dataGetter.getCityDao().read(defId);
      if (city != null && city.getTowerType().intValue() > 0 && city.getTowerHp().intValue() > 0) {
        maxcd = 12;
        if (city.getTowerType().intValue() == 2) {
          maxcd = 10;
        } else if (city.getTowerType().intValue() == 3) {
          maxcd = 9;
        } 
        int jianshao = city.getTowerHp().intValue() / 20;
        if (jianshao >= 5)
          jianshao = 4; 
        maxcd -= jianshao;
        shengyu = maxcd - bat.getRoundNum().get() % maxcd;
        if (shengyu == maxcd)
          shengyu = 0; 
        battleMsg.append(shengyu).append("|").append(city.getTowerHp()).append("|").append(maxcd).append("|-1#");
      } else {
        battleMsg.append("-1|-1|-1|-1#");
      } 
    } else {
      battleMsg.append("-1|-1|-1|-1#");
    } 
  }
  
  protected static void getReportType16(IDataGetter dataGetter, Battle bat, StringBuilder battleMsg, CampArmy campArmy, String battleSide, boolean campArmyChanged, boolean first) {
    battleMsg.append(16).append("|").append(battleSide).append("|").append(campArmy.generalLv).append("|").append(campArmy.armyHpOrg - campArmy.armyHpLoss).append("|").append(campArmy.armyHpOrg).append("|").append(campArmy.killGeneral).append("|").append(campArmy.zbtimes).append("|").append(campArmy.zballtimes).append(";");
    String playerName = campArmy.playerName;
    if (bat.getBattleType() == 2 || bat.getBattleType() == 4 || bat.getBattleType() == 3)
      playerName = campArmy.playerName; 
    String generalName = campArmy.generalName;
    String generalpic = campArmy.generalPic;
    if (campArmy.generalId == 103 && campArmy.getUnionState() > 0 && campArmy.getDeputy() == 269)
      generalName = "赤壁奇谋"; 
    if (campArmy.generalId == 277 && campArmy.getUnionState() > 0)
      generalName = "桃园之誓"; 
    if (campArmy.generalId == 201 && campArmy.getUnionState() > 0 && campArmy.getDeputy() == 266)
      generalName = "乱世眷侣"; 
    if (campArmy.generalId == 270 && campArmy.getUnionState() > 0 && campArmy.getDeputy() == 273)
      generalName = "桃园之誓"; 
    if (campArmy.generalId == 232 && campArmy.getUnionState() > 0 && campArmy.getDeputy() == 274)
      generalName = "赤壁奇谋"; 
    if (campArmy.legendEvoke) {
      if (campArmy.generalId == 204 && campArmy.getChapterId() > 0) {
        generalpic = GeneralUtils.chapterpic[campArmy.getChapterId() - 1];
        generalName = GeneralUtils.chapterName[campArmy.getChapterId() - 1];
      } 
      if (campArmy.generalId == 107 && campArmy.getChapterId() > 0) {
        generalName = GeneralUtils.chapterName2[campArmy.getChapterId() - 1];
        generalpic = GeneralUtils.chapterpic2[campArmy.getChapterId() - 1];
      } 
      if (campArmy.generalId == 281 && campArmy.getChapterId() > 0) {
        generalName = GeneralUtils.chapterName3[campArmy.getChapterId() - 1];
        generalpic = GeneralUtils.chapterpic3[campArmy.getChapterId() - 1];
      } 
      if (campArmy.generalId == 269 && campArmy.getChapterId() > 0) {
        generalName = GeneralUtils.chapterName4[campArmy.getChapterId() - 1];
        generalpic = GeneralUtils.chapterpic4[campArmy.getChapterId() - 1];
      } 
      if (campArmy.generalId == 201 && campArmy.getChapterId() > 0) {
        generalName = GeneralUtils.chapterName5[campArmy.getChapterId() - 1];
        generalpic = GeneralUtils.chapterpic5[campArmy.getChapterId() - 1];
      } 
      if (campArmy.generalId == 416 && campArmy.getChapterId() > 0) {
        generalName = GeneralUtils.chapterName6[campArmy.getChapterId() - 1];
        generalpic = GeneralUtils.chapterpic6[campArmy.getChapterId() - 1];
      } 
    } 
    battleMsg.append(campArmy.getForceId()).append("|").append(playerName).append("|").append(generalName).append("|").append(campArmy.generalPic).append("|").append(campArmy.quality).append("|").append(campArmy.rewardDoubleType).append("|");
    String teamTips = campArmy.getTeamGenreal();
    if (campArmy.getTeamGenreal() != null && campArmy.getTeamEffect() > 0.0D)
      teamTips = String.valueOf(String.valueOf(String.valueOf(teamTips))) + MessageFormatter.format(LocalMessages.T_TEAM_CONDITION_10037, new Object[] { Double.valueOf(campArmy.getTeamEffect() * 100.0D) }); 
    battleMsg.append(teamTips).append("|").append((campArmy.getTeamEffect() > 0.0D) ? 1 : 0).append("|null|null;");
    boolean thirdPartAdded = false;
    List<Tuple<Integer, String>> reportBuffList = new LinkedList<>();
    if (battleSide.equals("att")) {
      reportBuffList.addAll(bat.attBuffListInit);
      reportBuffList.addAll(bat.attBuffListRound);
    } else {
      reportBuffList.addAll(bat.defBuffListInit);
      reportBuffList.addAll(bat.defBuffListRound);
    } 
    for (int i = reportBuffList.size() - 1; i >= 0; i--) {
      Tuple<Integer, String> buff = reportBuffList.get(i);
      Tactic tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(campArmy.tacicId));
      if (tactic != null && tactic.getSpecialEffect() != null && tactic.getSpecialEffect().equalsIgnoreCase("siege_gun") && ((Integer)buff.left).equals(Integer.valueOf(10)))
        reportBuffList.remove(i); 
    } 
    if (reportBuffList.size() > 0) {
      for (Tuple<Integer, String> buff2 : reportBuffList)
        battleMsg.append(buff2.left).append("*").append((String)buff2.right).append("|"); 
      battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "#");
      thirdPartAdded = true;
    } 
    if (!thirdPartAdded)
      battleMsg.append("null").append("#"); 
  }
  
  protected static void getReportType38(IDataGetter dataGetter, Battle bat, StringBuilder battleMsg, CampArmy campArmy, String battleSide, boolean campArmyChanged, boolean first) {
    battleMsg.append(38).append("|0,1000*0,1000*0,1000*0;0,2000*0,2000*0,2000*0;1,2000*0,2000*0,2000*0;2,2000*0,2000*0,2000*0;3,2000*0,2000*0,2000*0;4,2000*0,2000*0,2000*0|null|null|").append(campArmy.generalId).append(",#");
  }
  
  protected static void getReportType11(StringBuilder battleMsg, BaseInfo baseInfo, String battleSide) {
    battleMsg.append(11).append("|").append(battleSide).append(";").append(baseInfo.num).append("|").append(baseInfo.allNum).append("#");
  }
  
  public void gainExReward(boolean attWin, BattleResult battleResult, Battle bat, IDataGetter dataGetter) {
    PlayerInfo pi = null;
    for (Integer playerId : bat.inBattlePlayers.keySet()) {
      pi = (PlayerInfo)bat.inBattlePlayers.get(playerId);
      if (pi.isAttSide)
        getExReward(attWin, dataGetter, pi, bat); 
    } 
  }
  
  public void endBattleMsg(boolean attWin, BattleResult battleResult, Battle bat, IDataGetter dataGetter) {
    int sn = bat.ticket.incrementAndGet();
    PlayerInfo pi = null;
    for (Integer playerId : bat.inBattlePlayers.keySet()) {
      pi = (PlayerInfo)bat.inBattlePlayers.get(playerId);
      int result = 2;
      if (pi.isAttSide && attWin)
        result = 1; 
      if (!pi.isAttSide && !attWin)
        result = 1; 
      StringBuilder difSb = new StringBuilder();
      difSb.append(sn).append("|").append(bat.getBattleId()).append("#");
      int maxNum = getMaxHpByType(dataGetter, bat);
      int percent = -1;
      if (maxNum > 0) {
        int doneNum = maxNum - bat.defBaseInfo.num;
        percent = doneNum * 100 / maxNum;
      } 
      difSb.append(7).append("|").append(result).append("|").append(percent).append(";");
      difSb.append(pi.killTotal).append("|").append(pi.lostTotal).append("|").append(pi.maxKillG).append("|").append(getDefName(dataGetter, bat.getDefBaseInfo().getId())).append(";");
      if (battleResult.slaveMap != null) {
        SlaveInfo slaveInfo = (SlaveInfo)battleResult.slaveMap.get(playerId);
        if (slaveInfo != null && slaveInfo.getPlayerIdList() != null && slaveInfo.getPlayerIdList().size() > 0) {
          if (slaveInfo.getType() == 1) {
            difSb.append(8);
          } else if (slaveInfo.getType() == 2) {
            difSb.append(9);
          } else if (slaveInfo.getType() == 3) {
            difSb.append(10);
          } 
          difSb.append("*");
          for (Integer pId : slaveInfo.getPlayerIdList())
            difSb.append(dataGetter.getPlayerDao().read(pId.intValue()).getPlayerName()).append(","); 
          difSb.replace(difSb.length() - 1, difSb.length(), "|");
        } 
      } 
      if (pi.dropMap.size() == 0) {
        difSb.append(0).append("*").append(0).append(";");
      } else {
        for (Map.Entry<Integer, BattleDrop> entry : (Iterable<Map.Entry<Integer, BattleDrop>>)pi.dropMap.entrySet()) {
          if (((BattleDrop)entry.getValue()).type > 200 && ((BattleDrop)entry.getValue()).type < 1000) {
            difSb.append(((BattleDrop)entry.getValue()).type).append("*").append(((BattleDrop)entry.getValue()).num).append("*").append(((BattleDrop)entry.getValue()).reserve).append("|");
            continue;
          } 
          difSb.append(((BattleDrop)entry.getValue()).type).append("*").append(((BattleDrop)entry.getValue()).num).append("|");
        } 
        difSb.replace(difSb.length() - 1, difSb.length(), ";");
      } 
      difSb.append(pi.rbType).append("|").append(pi.rbTotal).append("|").append((pi.rbTotal > 0) ? 0 : pi.rbTop).append("|").append(";");
      if (battleResult.mineInfo != null) {
        OccupyMineInfo omi = battleResult.mineInfo;
        difSb.append(omi.type).append("|").append(omi.state).append("|").append(omi.num).append("|").append(omi.outPut).append("|").append(omi.stoneNum).append("|").append(omi.outPutStone).append(";");
      } else {
        difSb.append("null").append(";");
      } 
      if (battleResult.dropGId > 0) {
        difSb.append(battleResult.dropGId).append("|").append(battleResult.dropGName).append("|").append(battleResult.dropGPic).append("|").append(battleResult.dropGQuality).append("|").append(battleResult.dropGget).append("|").append(battleResult.dropGType).append("|").append(battleResult.gTroopName).append("|").append(battleResult.gTroopQuality).append(";");
        JsonDocument doc = new JsonDocument();
        doc.startObject();
        doc.createElement("gainGeneral", Integer.valueOf(battleResult.dropGId));
        doc.createElement("dropGName", battleResult.dropGName);
        doc.createElement("dropGId", Integer.valueOf(battleResult.dropGId));
        doc.createElement("dropGPic", battleResult.dropGPic);
        doc.createElement("dropGQuality", Integer.valueOf(battleResult.dropGQuality));
        doc.createElement("dropGget", Integer.valueOf(battleResult.dropGget));
        doc.createElement("dropGType", Integer.valueOf(battleResult.dropGType));
        General general = (General)dataGetter.getGeneralCache().get(Integer.valueOf(battleResult.dropGId));
        if (general.getType().intValue() == 1) {
          doc.createElement("dropTroopQuality", general.getQuality());
          doc.createElement("dropTroopName", general.getName());
        } else {
          Troop troop = dataGetter.getTroopCache().getTroopOfGeneral(general.getTroop().intValue());
          doc.createElement("dropTroopQuality", troop.getQuality());
          doc.createElement("dropTroopName", troop.getName());
        } 
        doc.endObject();
        Players.push(playerId.intValue(), PushCommand.PUSH_UPDATE, doc.toByte());
      } else {
        difSb.append("null").append(";");
      } 
      if (battleResult.oMap.containsKey(playerId)) {
        difSb.append((String)battleResult.oMap.get(playerId)).append(";");
      } else {
        difSb.append("null").append(";");
      } 
      if (pi.isAttSide && battleResult.cityName != null) {
        difSb.append(battleResult.cityName).append("|").append(battleResult.cType);
      } else {
        difSb.append("null");
      } 
      difSb.append(";");
      String oldBattleId = bat.oldBattleId;
      Battle oldBattle = NewBattleManager.getInstance().getBattleByBatId(oldBattleId);
      if (result == 1 && oldBattle != null) {
        CampArmy winCa = null;
        if (pi.isAttSide) {
          if (bat.attCamp.size() == 0) {
            winCa = null;
          } else {
            winCa = bat.attCamp.get(0);
          } 
        } else if (bat.defCamp.size() == 0) {
          winCa = null;
        } else {
          winCa = bat.defCamp.get(0);
        } 
        if (winCa != null) {
          difSb.append(oldBattle.battleType).append("|").append(oldBattle.defBaseInfo.id).append("|").append(winCa.generalId);
        } else {
          difSb.append("null");
        } 
      } else {
        difSb.append("null");
      } 
      difSb.append("#");
      if (bat.inSceneSet.contains(playerId))
        sendMsgToOne(playerId.intValue(), difSb); 
      String saveReport = Configuration.getProperty("gcld.battle.report.save");
      if (saveReport.equals("1"))
        BattleSceneLog.getInstance().debug(" battleId " + bat.getBattleId() + " 个人结算信息:" + " playerId:" + playerId + " msg:" + difSb); 
      NewBattleManager.getInstance().clearPlayerWatchBattle(playerId.intValue(), bat.getBattleId());
      inBattleInfo(playerId.intValue(), false);
    } 
    com.reign.gcld.battle.scene.Builder builder = BuilderFactory.getInstance().getBuilder(bat.battleType);
    String string = "0|0|0|null;null;0|0|0|;null;null;null;null;null#";
    for (Integer viewPlayerId : bat.inSceneSet) {
      if (bat.inBattlePlayers.get(viewPlayerId) != null)
        continue; 
      Player player = dataGetter.getPlayerDao().read(viewPlayerId.intValue());
      int result2 = builder.getViewPlayer7ReportResult(attWin, bat, player);
      StringBuilder battleMsg = new StringBuilder();
      battleMsg.append(sn).append("|").append(bat.getBattleId()).append("#");
      int maxNum2 = getMaxHpByType(dataGetter, bat);
      int percent2 = -1;
      if (maxNum2 > 0) {
        int doneNum2 = maxNum2 - bat.defBaseInfo.num;
        percent2 = doneNum2 * 100 / maxNum2;
      } 
      battleMsg.append(7).append("|").append(result2).append("|").append(percent2).append(";");
      battleMsg.append("0|0|0|null;null;0|0|0|;null;null;null;null;null#");
      sendMsgToOne(viewPlayerId.intValue(), battleMsg);
      String saveReport2 = Configuration.getProperty("gcld.battle.report.save");
      if (saveReport2.equals("1"))
        BattleSceneLog.getInstance().debug(" battleId " + bat.getBattleId() + " 个人结算信息:" + " playerId:" + viewPlayerId + " msg:" + battleMsg); 
      NewBattleManager.getInstance().clearPlayerWatchBattle(viewPlayerId.intValue(), bat.getBattleId());
    } 
    NewBattleManager.getInstance().deleteBattle(bat.getBattleId());
  }
  
  public int getViewPlayer7ReportResult(boolean attWin, Battle bat, Player player) {
    return 2;
  }
  
  public static int getMaxHpByType(IDataGetter dataGetter, Battle bat) {
    int areaId, battleType = bat.getBattleType();
    int defId = bat.defBaseInfo.id;
    int attForceId = bat.attBaseInfo.forceId;
    switch (battleType) {
      case 11:
        return OneVsRewardNpcBuilder.getMaxHp(dataGetter, defId);
      case 12:
        return OneVsExtraBuilder.getMaxHp(dataGetter, defId);
      case 3:
        return CityBuilder.getMaxHp(dataGetter, defId);
      case 10:
        areaId = dataGetter.getWorldCityCache().getArea(attForceId, defId);
        return CityNpcBuilder.getMaxHp(dataGetter, areaId);
    } 
    return Integer.MIN_VALUE;
  }
  
  protected int getFightRewardCoeId(IDataGetter dataGetter, Battle bat) {
    int battleType = bat.getBattleType();
    if (battleType == 2) {
      Armies armies = (Armies)dataGetter.getArmiesCache().get(Integer.valueOf(bat.getDefBaseInfo().getId()));
      if (armies.getType().intValue() == 3)
        return 333; 
    } else if (battleType >= 18 && battleType <= 20) {
      int jubenId = bat.defBaseInfo.id;
      if (jubenId < 10000)
        return 21; 
    } 
    return bat.getBattleType();
  }
  
  protected static double getTroopDamageCoe(FightRewardCoe frc, double troopFoodA, double troopFoodB) {
    double yita = troopFoodB / (1.0D + troopFoodA);
    if (yita < 0.5D) {
      yita = 0.5D;
    } else if (yita > 2.0D) {
      yita = 2.0D;
    } 
    double selta = 0.5D * (yita - 1.0D);
    if (selta > 0.5D || selta < -0.25D)
      ErrorSceneLog.getInstance().appendErrorMsg("selta error. selta:" + selta + " aLost,bLost,aLv,bLv:" + troopFoodA + "," + troopFoodB).appendClassName("Builder").appendMethodName("getTroopDamageCoe").append("frc", frc.getId()).flush(); 
    double delta = 1.0D + frc.getDelta().intValue() * selta;
    if (delta > 1.5D || delta < 0.75D)
      ErrorSceneLog.getInstance().appendErrorMsg("delta error. delta:" + selta + " selta,frcId:" + selta + "," + frc.getId()).appendClassName("Builder").appendMethodName("getTroopDamageCoe").append("frc", frc.getId()).flush(); 
    return delta;
  }
  
  protected static double getLevelDifferCoe(FightRewardCoe frc, int aLv, int bLv) {
    double l = 0.0D;
    if (aLv > bLv + 5) {
      l = -1.0D;
    } else if (aLv > bLv) {
      l = -0.2D * (aLv - bLv);
    } else {
      l = 0.0D;
    } 
    return 1.0D + frc.getLvCoe().intValue() * l;
  }
  
  protected static double getRoundRewardBase(IDataGetter dataGetter, FightRewardCoe frc, int troopIdA, int TroopIdB, int aLost, int bLost, int aLv, int bLv) {
    double troopFoodConsumeCoeA = ((TroopConscribe)dataGetter.getTroopConscribeCache().get(Integer.valueOf(troopIdA))).getFood().doubleValue();
    double troopFoodConsumeCoeB = ((TroopConscribe)dataGetter.getTroopConscribeCache().get(Integer.valueOf(TroopIdB))).getFood().doubleValue();
    double troopFoodA = troopFoodConsumeCoeA * aLost;
    double troopFoodB = troopFoodConsumeCoeB * bLost;
    double troopDamageCoe = getTroopDamageCoe(frc, troopFoodA, troopFoodB);
    double levelDifferCoe = getLevelDifferCoe(frc, aLv, bLv);
    return troopDamageCoe * levelDifferCoe * troopFoodA;
  }
  
  protected static double getRoundRewardBase(IDataGetter dataGetter, FightRewardCoe frc, int troopIdA, int TroopIdB, long aLost, long bLost, int aLv, int bLv) {
    double troopFoodConsumeCoeA = ((TroopConscribe)dataGetter.getTroopConscribeCache().get(Integer.valueOf(troopIdA))).getFood().doubleValue();
    double troopFoodConsumeCoeB = ((TroopConscribe)dataGetter.getTroopConscribeCache().get(Integer.valueOf(TroopIdB))).getFood().doubleValue();
    double troopFoodA = troopFoodConsumeCoeA * aLost;
    double troopFoodB = troopFoodConsumeCoeB * bLost;
    double troopDamageCoe = getTroopDamageCoe(frc, troopFoodA, troopFoodB);
    double levelDifferCoe = getLevelDifferCoe(frc, aLv, bLv);
    return troopDamageCoe * levelDifferCoe * troopFoodA;
  }
  
  public void roundUpdateDB(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    try {
      roundInfo.attRoundReward = new RoundReward();
      roundInfo.defRoundReward = new RoundReward();
      dealTroopDrop(dataGetter, bat, roundInfo);
      roundCaculateReward(dataGetter, bat, roundInfo);
      roundAddReward(dataGetter, bat, roundInfo, roundInfo.attRoundReward, roundInfo.defRoundReward);
      roundTacticUpdateDB(dataGetter, bat, roundInfo);
      roundReduceTroop(dataGetter, bat, roundInfo);
      dealKillTotalStaff(dataGetter, bat, roundInfo);
      PlayerInfo piAtt = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.attCampArmy.getPlayerId()));
      if (piAtt != null)
        piAtt.addDropMap(roundInfo.attRoundReward.roundDropMap); 
      PlayerInfo piDef = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.defCampArmy.getPlayerId()));
      if (piDef != null)
        piDef.addDropMap(roundInfo.defRoundReward.roundDropMap); 
    } catch (Exception e) {
      ErrorSceneLog.getInstance().error("Builder.roundUpdateDB catch Exception. battleId:" + bat.getBattleId(), e);
    } 
  }
  
  public void dealKillTotalStaff(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {}
  
  public void dealKillrank(boolean isBarbarainInvade, int gKillTotal, Battle bat, IDataGetter dataGetter, int playerId) {}
  
  public int getDefPlayerLevel(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    return roundInfo.defCampArmy.getPlayerLv();
  }
  
  public void roundCaculateReward(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    FightRewardCoe frc = (FightRewardCoe)dataGetter.getFightRewardCoeCache().get(Integer.valueOf(getFightRewardCoeId(dataGetter, bat)));
    if (frc == null) {
      ErrorSceneLog.getInstance().info("FightRewardCoe is null. battle type:" + bat.getBattleType());
      frc = new FightRewardCoe();
    } 
    roundCaculateAttReward(dataGetter, frc, bat, roundInfo);
    roundCaculateDefReward(dataGetter, frc, bat, roundInfo);
  }
  
  public void roundCaculateAttReward(IDataGetter dataGetter, FightRewardCoe frc, Battle bat, RoundInfo roundInfo) {
    String debug = Configuration.getProperty("gcld.battle.caculate.debug");
    if (roundInfo.defTacticInfo != null && roundInfo.defTacticInfo.reduceMap != null && roundInfo.defTacticInfo.reduceMap.size() > 1) {
      int counterLost = 0;
      int counterLv = roundInfo.defCampArmy.playerLv;
      int gCounterLv = roundInfo.defCampArmy.generalLv;
      int counterTroopId = roundInfo.defCampArmy.troopId;
      if (debug.equals("1"))
        roundInfo.caculateDebugBuffer.append("defTacticInfo!=null.").append(" | ").append("FightRewardCoe:" + frc.getId()).append(" | ").append("counterPlayer:" + roundInfo.defCampArmy.playerName).append(" | ").append("counterGeneral:" + roundInfo.defCampArmy.generalName).append(" | ").append("counterLost:0").append(" | ").append("counterLv:" + counterLv).append(" | ").append("gCounterLv:" + gCounterLv).append(" | ").append("counterTroopId:" + counterTroopId).append("\n"); 
      for (CampArmy campArmy : roundInfo.defTacticInfo.reduceMap.keySet()) {
        if (campArmy != roundInfo.attCampArmy && (campArmy.updateDB || campArmy.getBeastId() > 0) && campArmy.playerId > 0) {
          PlayerInfo pInfo = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(campArmy.playerId));
          if (pInfo == null) {
            ErrorSceneLog.getInstance().appendErrorMsg("PlayerInfo is null").appendPlayerName(campArmy.playerName).appendPlayerId(campArmy.playerId).appendGeneralName(campArmy.generalName).appendGeneralId(campArmy.generalId).append("isupdateDB", Boolean.valueOf(campArmy.updateDB)).append("isPhantom", Boolean.valueOf(campArmy.isPhantom)).append("pgmVId", Integer.valueOf(campArmy.pgmVId)).appendBattleId(bat.getBattleId()).appendMethodName("roundCaculateDefReward").flush();
            continue;
          } 
          RoundReward tempRD = new RoundReward();
          int myLost = ((Integer)roundInfo.defTacticInfo.reduceMap.get(campArmy)).intValue();
          int myLv = campArmy.playerLv;
          int gMyLv = campArmy.generalLv;
          int myTroopId = campArmy.troopId;
          double mAttOmega = getRoundRewardBase(dataGetter, frc, myTroopId, counterTroopId, myLost, 0, myLv, counterLv);
          double gAttOmega = getRoundRewardBase(dataGetter, frc, myTroopId, counterTroopId, myLost, 0, gMyLv, gCounterLv);
          if (roundInfo.defCampArmy.playerId < -10000 && mAttOmega < 1000.0D) {
            mAttOmega = 1000.0D;
            gAttOmega = 1000.0D;
          } 
          BattleDrop battleDrop = new BattleDrop();
          int copper = (int)(mAttOmega * frc.getM().doubleValue());
          battleDrop.type = 1;
          battleDrop.num = copper;
          tempRD.roundDropMap.put(Integer.valueOf(1), battleDrop);
          pInfo.addDrop(battleDrop);
          battleDrop = new BattleDrop();
          int mExp = (int)(mAttOmega * frc.getC().doubleValue() * campArmy.rewardDouble);
          double att_world_frontLine_buff_exp_e = 1.0D;
          if (bat.world_frontLine_buff_att_def_e_side == 1)
            att_world_frontLine_buff_exp_e = bat.world_frontLine_buff_exp_e; 
          double attLowLvSCoe = getLowLvSCoe(bat, myLv, counterLv);
          double attTechAddGZJY = 0.0D;
          if (bat.battleType == 3 || bat.battleType == 13) {
            attTechAddGZJY = dataGetter.getTechEffectCache().getTechEffect(campArmy.playerId, 40) / 100.0D;
            double lgzexp = dataGetter.getBattleDataCache().getPlayerExpadd(campArmy.playerId) / 100.0D;
            attTechAddGZJY += lgzexp;
          } 
          double specialGeneralAddExp = 0.0D;
          if ((roundInfo.attCampArmy.getSpecialGeneral()).generalType == 4 && roundInfo.defCampArmy.isPhantom)
            specialGeneralAddExp = (roundInfo.attCampArmy.getSpecialGeneral()).param; 
          if ((roundInfo.attCampArmy.getSpecialGeneral()).generalType == 3 && (roundInfo.defCampArmy.isBarPhantom || roundInfo.defCampArmy.isBarEA))
            specialGeneralAddExp = (roundInfo.attCampArmy.getSpecialGeneral()).param2; 
          double farmBuff = 0.0D;
          if (!campArmy.isPhantom && campArmy.playerId > 0) {
            farmBuff = dataGetter.getWorldFarmService().getBuff(campArmy.playerId, campArmy.generalId);
            farmBuff = farmBuff * 1.0D / 100.0D;
          } 
          double bainianBuff = 0.0D;
          if (!campArmy.isPhantom && campArmy.playerId > 0) {
            bainianBuff = BaiNianEvent.getBuff(campArmy.playerId, dataGetter);
            bainianBuff = bainianBuff * 1.0D / 100.0D;
          } 
          mExp *= (int)(att_world_frontLine_buff_exp_e + attLowLvSCoe + attTechAddGZJY + bat.world_round_ally_buff_att_e + specialGeneralAddExp + roundInfo.attCampArmy.activityAddExp + farmBuff + bainianBuff);
          battleDrop.type = 5;
          battleDrop.num = mExp;
          tempRD.roundDropMap.put(Integer.valueOf(5), battleDrop);
          pInfo.addDrop(battleDrop);
          double gExpAdd = 0.0D;
          gExpAdd = dataGetter.getTechEffectCache().getTechEffect(campArmy.playerId, 16) / 100.0D;
          if (dataGetter.getPlayerDao().getConsumeLv(campArmy.playerId) >= 9)
            gExpAdd += 0.1D; 
          if (dataGetter.getPlayerDao().ismooncard(campArmy.playerId))
            gExpAdd += 0.15D; 
          if (campArmy.playerId > 0) {
            Map<Integer, String> ycbweffectMap = dataGetter.getBattleDataCache().getYcbwMap(campArmy.playerId, campArmy.generalId);
            gExpAdd += Double.valueOf(ycbweffectMap.get(Integer.valueOf(8))).doubleValue() / 100.0D;
          } 
          if (campArmy.playerId > 0) {
            Date firstbufftime = dataGetter.getPlayerAttributeDao().read(campArmy.playerId).getHuiYuanTime();
            if (firstbufftime != null && System.currentTimeMillis() < firstbufftime.getTime() + 7200000L)
              gExpAdd++; 
          } 
          tempRD.gExp = (int)(gAttOmega * frc.getE().doubleValue() * roundInfo.attCampArmy.rewardDouble * (1.0D + gExpAdd + specialGeneralAddExp + roundInfo.attCampArmy.activityAddExp + farmBuff + bainianBuff));
          if (campArmy.playerId == roundInfo.attCampArmy.playerId) {
            roundInfo.attRoundReward.addDropMap(tempRD.roundDropMap);
            try {
              List<UpdateExp> defUpExpList = dataGetter.getGeneralService().updateExpAndGeneralLevel(campArmy.getPlayerId(), campArmy.getGeneralId(), tempRD.gExp);
              if (defUpExpList == null)
                continue; 
              int addGExp = 0;
              for (UpdateExp ue : defUpExpList)
                addGExp += (int)ue.getCurExp(); 
              if (tempRD.gExp != 0 && addGExp == 0)
                campArmy.expTop = 1; 
              tempRD.gUpLv = defUpExpList.size() - 1;
              if (tempRD.gUpLv <= 0)
                continue; 
              PlayerGeneralMilitary pgm = dataGetter.getPlayerGeneralMilitaryDao().getMilitary(campArmy.playerId, campArmy.generalId);
              if (pgm == null)
                continue; 
              campArmy.generalLv = pgm.getLv().intValue();
              dataGetter.getGeneralService().sendGmUpdate1(pgm.getPlayerId().intValue(), pgm.getGeneralId().intValue(), true);
            } catch (Exception e) {
              ErrorSceneLog.getInstance().error("updateExpAndGeneralLevel catch Exception.", e);
              ErrorSceneLog.getInstance().appendErrorMsg("updateExpAndGeneralLevel catch Exception.").appendBattleId(bat.getBattleId()).appendPlayerId(campArmy.playerId).appendPlayerName(campArmy.playerName).appendGeneralId(campArmy.generalId).appendGeneralName(campArmy.generalName).flush();
            } 
            continue;
          } 
          roundAddRewardSingle(dataGetter, campArmy, tempRD);
          if (!debug.equals("1"))
            continue; 
          roundInfo.caculateDebugBuffer.append("Att reward by Def tactic ").append(" | ").append("myPlayer:" + campArmy.playerName).append(" | ").append("myGeneral:" + campArmy.generalName).append(" | ").append("myLost:" + myLost).append(" | ").append("myLv:" + myLv).append(" | ").append("gMyLv:" + gMyLv).append(" | ").append("myTroopId:" + myTroopId).append(" | ").append("mAttOmega:" + mAttOmega).append(" | ").append("gAttOmega:" + gAttOmega).append(" | ").append("rewardDouble:" + campArmy.rewardDouble).append(" | ").append("TECH_KEY_16_LILIAN:" + gExpAdd).append(" | ").append("LowLvSCoe:" + attLowLvSCoe).append(" | ").append("world_frontLine_buff_exp_e:" + att_world_frontLine_buff_exp_e).append(" | ").append("TechAddGZJY:" + attTechAddGZJY).append(" | ").append("world_round_ally_buff_att_e:" + bat.world_round_ally_buff_att_e).append(" | ").append("copper:" + copper).append(" | ").append("mExp:" + mExp).append(" | ").append("gExp:" + tempRD.gExp).append(" \n ");
        } 
      } 
    } 
    int attTacticLost = 0;
    if (roundInfo.defTacticInfo != null)
      attTacticLost = roundInfo.defTacticInfo.firstCReduce; 
    int attLost = roundInfo.attLost + roundInfo.attStrategyLost + attTacticLost + roundInfo.attBeiDongLost;
    int attLv = roundInfo.attCampArmy.getPlayerLv();
    int gAttLv = roundInfo.attCampArmy.getGeneralLv();
    int troopIdAtt = roundInfo.attCampArmy.getTroopId();
    int defTacticLost = 0;
    if (roundInfo.attTacticInfo != null)
      defTacticLost = roundInfo.attTacticInfo.allCReduce; 
    int defLost = roundInfo.defLost + roundInfo.defStrategyLost + defTacticLost + roundInfo.defBeiDongLost;
    int defLv = getDefPlayerLevel(dataGetter, bat, roundInfo);
    int gDefLv = roundInfo.defCampArmy.getGeneralLv();
    int TroopIdDef = roundInfo.defCampArmy.getTroopId();
    dataGetter.getJobService().addJob("autoBattleService", "increaseLost", String.valueOf(String.valueOf(String.valueOf(roundInfo.attCampArmy.getPlayerId()))) + "#" + defLost, System.currentTimeMillis(), false);
    double mAttOmega2 = getRoundRewardBase(dataGetter, frc, troopIdAtt, TroopIdDef, attLost, defLost, attLv, defLv);
    double gAttOmega2 = getRoundRewardBase(dataGetter, frc, troopIdAtt, TroopIdDef, attLost, defLost, gAttLv, gDefLv);
    if (roundInfo.defCampArmy.playerId < -10000 && mAttOmega2 < 1000.0D) {
      mAttOmega2 = 1000.0D;
      gAttOmega2 = 1000.0D;
    } 
    BattleDrop battleDrop2 = new BattleDrop();
    int copper2 = (int)(mAttOmega2 * frc.getM().doubleValue());
    battleDrop2.type = 1;
    battleDrop2.num = copper2;
    roundInfo.attRoundReward.roundDropMap.put(Integer.valueOf(1), battleDrop2);
    battleDrop2 = new BattleDrop();
    int mExp2 = (int)(mAttOmega2 * frc.getC().doubleValue() * roundInfo.attCampArmy.rewardDouble);
    double att_world_frontLine_buff_exp_e2 = 1.0D;
    if (bat.world_frontLine_buff_att_def_e_side == 1)
      att_world_frontLine_buff_exp_e2 = bat.world_frontLine_buff_exp_e; 
    double attLowLvSCoe2 = getLowLvSCoe(bat, attLv, defLv);
    double attTechAddGZJY2 = 0.0D;
    if (bat.battleType == 3 || bat.battleType == 13) {
      attTechAddGZJY2 = dataGetter.getTechEffectCache().getTechEffect(roundInfo.attCampArmy.playerId, 40) / 100.0D;
      double lgzexp2 = dataGetter.getBattleDataCache().getPlayerExpadd(roundInfo.attCampArmy.playerId) / 100.0D;
      attTechAddGZJY2 += lgzexp2;
    } 
    double specialGeneralAddExp2 = 0.0D;
    if ((roundInfo.attCampArmy.getSpecialGeneral()).generalType == 4 && roundInfo.defCampArmy.isPhantom)
      specialGeneralAddExp2 = (roundInfo.attCampArmy.getSpecialGeneral()).param; 
    if ((roundInfo.attCampArmy.getSpecialGeneral()).generalType == 3 && (roundInfo.defCampArmy.isBarPhantom || roundInfo.defCampArmy.isBarEA))
      specialGeneralAddExp2 = (roundInfo.attCampArmy.getSpecialGeneral()).param2; 
    double farmBuff2 = 0.0D;
    if (!roundInfo.attCampArmy.isPhantom && roundInfo.attCampArmy.playerId > 0) {
      farmBuff2 = dataGetter.getWorldFarmService().getBuff(roundInfo.attCampArmy.playerId, roundInfo.attCampArmy.generalId);
      farmBuff2 = farmBuff2 * 1.0D / 100.0D;
    } 
    double bainianBuff2 = 0.0D;
    if (!roundInfo.attCampArmy.isPhantom && roundInfo.attCampArmy.playerId > 0) {
      bainianBuff2 = BaiNianEvent.getBuff(roundInfo.attCampArmy.playerId, dataGetter);
      bainianBuff2 = bainianBuff2 * 1.0D / 100.0D;
    } 
    mExp2 *= (int)(att_world_frontLine_buff_exp_e2 + attLowLvSCoe2 + attTechAddGZJY2 + bat.world_round_ally_buff_att_e + specialGeneralAddExp2 + roundInfo.attCampArmy.activityAddExp + farmBuff2 + bainianBuff2);
    battleDrop2.type = 5;
    battleDrop2.num = mExp2;
    roundInfo.attRoundReward.roundDropMap.put(Integer.valueOf(5), battleDrop2);
    double gExpAdd2 = 0.0D;
    gExpAdd2 = dataGetter.getTechEffectCache().getTechEffect(roundInfo.attCampArmy.playerId, 16) / 100.0D;
    if (dataGetter.getPlayerDao().getConsumeLv(roundInfo.attCampArmy.playerId) >= 9)
      gExpAdd2 += 0.1D; 
    if (dataGetter.getPlayerDao().ismooncard(roundInfo.attCampArmy.playerId))
      gExpAdd2 += 0.15D; 
    if (roundInfo.attCampArmy.playerId > 0) {
      Map<Integer, String> ycbweffectMap2 = dataGetter.getBattleDataCache().getYcbwMap(roundInfo.attCampArmy.playerId, roundInfo.attCampArmy.generalId);
      gExpAdd2 += Double.valueOf(ycbweffectMap2.get(Integer.valueOf(8))).doubleValue() / 100.0D;
    } 
    if (roundInfo.attCampArmy.playerId > 0) {
      Date firstbufftime2 = dataGetter.getPlayerAttributeDao().read(roundInfo.attCampArmy.playerId).getHuiYuanTime();
      if (firstbufftime2 != null && System.currentTimeMillis() < firstbufftime2.getTime() + 7200000L)
        gExpAdd2++; 
    } 
    roundInfo.attRoundReward.gExp = (int)(gAttOmega2 * frc.getE().doubleValue() * roundInfo.attCampArmy.rewardDouble * (1.0D + gExpAdd2 + specialGeneralAddExp2 + roundInfo.attCampArmy.activityAddExp + farmBuff2 + bainianBuff2));
    if (debug.equals("1")) {
      roundInfo.caculateDebugBuffer.append("Round.").append(" | ").append("battleId:" + bat.getBattleId()).append(" | ").append("FightRewardCoe:" + frc.getId()).append(" | ").append("attPlayer:" + roundInfo.attCampArmy.playerName).append(" | ").append("defPlayer:" + roundInfo.defCampArmy.playerName).append(" | ").append("attGeneral:" + roundInfo.attCampArmy.generalName).append(" | ").append("defGeneral:" + roundInfo.defCampArmy.generalName).append(" | ").append("attTroopId:" + troopIdAtt).append(" | ").append("defTroopId:" + TroopIdDef).append(" | ").append("attRoundLost:" + roundInfo.attLost).append(" | ").append("defRoundLost:" + roundInfo.defLost).append(" | ").append("attStrategyLost:" + roundInfo.attStrategyLost).append(" | ").append("defStrategyLost:" + roundInfo.defStrategyLost).append(" | ").append("attTacticLost:" + attTacticLost).append(" | ").append("defTacticLost:" + defTacticLost).append(" | ").append("attLostTotal:" + attLost).append(" | ").append("defLostTotal:" + defLost).append(" | ").append("attLv:" + attLv).append(" | ").append("defLv:" + defLv).append(" | ").append("gAttLv:" + gAttLv).append(" | ").append("gDefLv:" + gDefLv).append(" \n ");
      roundInfo.caculateDebugBuffer.append("Att").append(" | ").append("mAttOmega:" + mAttOmega2).append(" | ").append("gAttOmega:" + gAttOmega2).append(" | ").append("rewardDouble:" + roundInfo.attCampArmy.rewardDouble).append(" | ").append("ATT TECH_KEY_16_LILIAN:" + gExpAdd2).append(" | ").append("attLowLvSCoe:" + attLowLvSCoe2).append(" | ").append("att_world_frontLine_buff_exp_e:" + att_world_frontLine_buff_exp_e2).append(" | ").append("attTechAddGZJY:" + attTechAddGZJY2).append(" | ").append("world_round_ally_buff_att_e:" + bat.world_round_ally_buff_att_e).append(" | ").append("copper:" + copper2).append(" | ").append("mExp:" + mExp2).append(" | ").append("gExp:" + roundInfo.attRoundReward.gExp).append(" \n ");
    } 
    roundCaculateHuanYingDanTiaoExpReward(dataGetter, frc, bat, roundInfo);
  }
  
  public void roundCaculateDefReward(IDataGetter dataGetter, FightRewardCoe frc, Battle bat, RoundInfo roundInfo) {
    String debug = Configuration.getProperty("gcld.battle.caculate.debug");
    if (roundInfo.attTacticInfo != null && roundInfo.attTacticInfo.reduceMap != null && roundInfo.attTacticInfo.reduceMap.size() > 1) {
      int counterLost = 0;
      int counterLv = roundInfo.attCampArmy.playerLv;
      int gCounterLv = roundInfo.attCampArmy.generalLv;
      int counterTroopId = roundInfo.attCampArmy.troopId;
      if (debug.equals("1"))
        roundInfo.caculateDebugBuffer.append("attTacticInfo!=null.").append(" | ").append("FightRewardCoe:" + frc.getId()).append(" | ").append("counterPlayer:" + roundInfo.attCampArmy.playerName).append(" | ").append("counterGeneral:" + roundInfo.attCampArmy.generalName).append(" | ").append("counterLost:0").append(" | ").append("counterLv:" + counterLv).append(" | ").append("gCounterLv:" + gCounterLv).append(" | ").append("counterTroopId:" + counterTroopId).append("\n"); 
      for (CampArmy campArmy : roundInfo.attTacticInfo.reduceMap.keySet()) {
        if (campArmy != roundInfo.defCampArmy && (campArmy.updateDB || campArmy.getBeastId() > 0) && campArmy.playerId > 0) {
          PlayerInfo pInfo = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(campArmy.playerId));
          if (pInfo == null) {
            ErrorSceneLog.getInstance().appendErrorMsg("PlayerInfo is null").appendPlayerName(campArmy.playerName).appendPlayerId(campArmy.playerId).appendGeneralName(campArmy.generalName).appendGeneralId(campArmy.generalId).append("isupdateDB", Boolean.valueOf(campArmy.updateDB)).append("isPhantom", Boolean.valueOf(campArmy.isPhantom)).append("pgmVId", Integer.valueOf(campArmy.pgmVId)).appendBattleId(bat.getBattleId()).appendMethodName("roundCaculateDefReward").flush();
            continue;
          } 
          RoundReward tempRD = new RoundReward();
          int myLost = ((Integer)roundInfo.attTacticInfo.reduceMap.get(campArmy)).intValue();
          int myLv = campArmy.playerLv;
          int gMyLv = campArmy.generalLv;
          int myTroopId = campArmy.troopId;
          double mAttOmega = getRoundRewardBase(dataGetter, frc, myTroopId, counterTroopId, myLost, 0, myLv, counterLv);
          double gAttOmega = getRoundRewardBase(dataGetter, frc, myTroopId, counterTroopId, myLost, 0, gMyLv, gCounterLv);
          if (roundInfo.attCampArmy.playerId < -10000 && mAttOmega < 1000.0D) {
            mAttOmega = 1000.0D;
            gAttOmega = 1000.0D;
          } 
          BattleDrop battleDrop = new BattleDrop();
          int copper = (int)(mAttOmega * frc.getM().doubleValue());
          battleDrop.type = 1;
          battleDrop.num = copper;
          tempRD.roundDropMap.put(Integer.valueOf(1), battleDrop);
          pInfo.addDrop(battleDrop);
          battleDrop = new BattleDrop();
          int mExp = (int)(mAttOmega * frc.getC().doubleValue() * campArmy.rewardDouble);
          double att_world_frontLine_buff_exp_e = 1.0D;
          if (bat.world_frontLine_buff_att_def_e_side == 1)
            att_world_frontLine_buff_exp_e = bat.world_frontLine_buff_exp_e; 
          double attLowLvSCoe = getLowLvSCoe(bat, myLv, counterLv);
          double attTechAddGZJY = 0.0D;
          if (bat.battleType == 3 || bat.battleType == 13) {
            attTechAddGZJY = dataGetter.getTechEffectCache().getTechEffect(campArmy.playerId, 40) / 100.0D;
            double lgzexp = dataGetter.getBattleDataCache().getPlayerExpadd(campArmy.playerId) / 100.0D;
            attTechAddGZJY += lgzexp;
          } 
          double specialGeneralAddExp = 0.0D;
          if ((roundInfo.defCampArmy.getSpecialGeneral()).generalType == 4 && roundInfo.attCampArmy.isPhantom)
            specialGeneralAddExp = (roundInfo.defCampArmy.getSpecialGeneral()).param; 
          if ((roundInfo.defCampArmy.getSpecialGeneral()).generalType == 3 && (roundInfo.attCampArmy.isBarPhantom || roundInfo.attCampArmy.isBarEA))
            specialGeneralAddExp = (roundInfo.defCampArmy.getSpecialGeneral()).param2; 
          double farmBuff = 0.0D;
          if (!campArmy.isPhantom && campArmy.playerId > 0) {
            farmBuff = dataGetter.getWorldFarmService().getBuff(campArmy.playerId, campArmy.generalId);
            farmBuff = farmBuff * 1.0D / 100.0D;
          } 
          double bainianBuff = 0.0D;
          if (!campArmy.isPhantom && campArmy.playerId > 0) {
            bainianBuff = BaiNianEvent.getBuff(campArmy.playerId, dataGetter);
            bainianBuff = bainianBuff * 1.0D / 100.0D;
          } 
          mExp *= (int)(att_world_frontLine_buff_exp_e + attLowLvSCoe + attTechAddGZJY + bat.world_round_ally_buff_def_e + specialGeneralAddExp + roundInfo.defCampArmy.activityAddExp + farmBuff + bainianBuff);
          battleDrop.type = 5;
          battleDrop.num = mExp;
          tempRD.roundDropMap.put(Integer.valueOf(5), battleDrop);
          pInfo.addDrop(battleDrop);
          double gExpAdd = 0.0D;
          gExpAdd = dataGetter.getTechEffectCache().getTechEffect(campArmy.playerId, 16) / 100.0D;
          if (dataGetter.getPlayerDao().getConsumeLv(campArmy.playerId) >= 9)
            gExpAdd += 0.1D; 
          if (dataGetter.getPlayerDao().ismooncard(campArmy.playerId))
            gExpAdd += 0.15D; 
          if (campArmy.playerId > 0) {
            Map<Integer, String> ycbweffectMap = dataGetter.getBattleDataCache().getYcbwMap(campArmy.playerId, campArmy.generalId);
            gExpAdd += Double.valueOf(ycbweffectMap.get(Integer.valueOf(8))).doubleValue() / 100.0D;
          } 
          if (campArmy.playerId > 0) {
            Date firstbufftime = dataGetter.getPlayerAttributeDao().read(campArmy.playerId).getHuiYuanTime();
            if (firstbufftime != null && System.currentTimeMillis() < firstbufftime.getTime() + 7200000L)
              gExpAdd++; 
          } 
          tempRD.gExp = (int)(gAttOmega * frc.getE().doubleValue() * roundInfo.attCampArmy.rewardDouble * (1.0D + gExpAdd + specialGeneralAddExp + roundInfo.defCampArmy.activityAddExp + farmBuff + bainianBuff));
          if (campArmy.playerId == roundInfo.defCampArmy.playerId) {
            roundInfo.defRoundReward.addDropMap(tempRD.roundDropMap);
            try {
              List<UpdateExp> defUpExpList = dataGetter.getGeneralService().updateExpAndGeneralLevel(campArmy.getPlayerId(), campArmy.getGeneralId(), tempRD.gExp);
              if (defUpExpList == null)
                continue; 
              int addGExp = 0;
              for (UpdateExp ue : defUpExpList)
                addGExp += (int)ue.getCurExp(); 
              if (tempRD.gExp != 0 && addGExp == 0)
                campArmy.expTop = 1; 
              tempRD.gUpLv = defUpExpList.size() - 1;
              if (tempRD.gUpLv <= 0)
                continue; 
              PlayerGeneralMilitary pgm = dataGetter.getPlayerGeneralMilitaryDao().getMilitary(campArmy.playerId, campArmy.generalId);
              if (pgm == null)
                continue; 
              campArmy.generalLv = pgm.getLv().intValue();
              dataGetter.getGeneralService().sendGmUpdate1(pgm.getPlayerId().intValue(), pgm.getGeneralId().intValue(), true);
            } catch (Exception e) {
              ErrorSceneLog.getInstance().error("updateExpAndGeneralLevel catch Exception.", e);
              ErrorSceneLog.getInstance().appendErrorMsg("updateExpAndGeneralLevel catch Exception.").appendBattleId(bat.getBattleId()).appendPlayerId(campArmy.playerId).appendPlayerName(campArmy.playerName).appendGeneralId(campArmy.generalId).appendGeneralName(campArmy.generalName).flush();
            } 
            continue;
          } 
          roundAddRewardSingle(dataGetter, campArmy, tempRD);
          if (!debug.equals("1"))
            continue; 
          roundInfo.caculateDebugBuffer.append("Def reward by Att tactic ").append(" | ").append("myPlayer:" + campArmy.playerName).append(" | ").append("myGeneral:" + campArmy.generalName).append(" | ").append("mAttOmega:" + mAttOmega).append(" | ").append("gAttOmega:" + gAttOmega).append(" | ").append("rewardDouble:" + campArmy.rewardDouble).append(" | ").append("TECH_KEY_16_LILIAN:" + gExpAdd).append(" | ").append("LowLvSCoe:" + attLowLvSCoe).append(" | ").append("world_frontLine_buff_exp_e:" + att_world_frontLine_buff_exp_e).append(" | ").append("TechAddGZJY:" + attTechAddGZJY).append(" | ").append("world_round_ally_buff_def_e:" + bat.world_round_ally_buff_def_e).append(" | ").append("copper:" + copper).append(" | ").append("mExp:" + mExp).append(" | ").append("gExp:" + tempRD.gExp).append(" \n ");
        } 
      } 
    } 
    int attTacticLost = 0;
    if (roundInfo.defTacticInfo != null)
      attTacticLost = roundInfo.defTacticInfo.allCReduce; 
    int attLost = roundInfo.attLost + roundInfo.attStrategyLost + attTacticLost + roundInfo.attBeiDongLost;
    int attLv = roundInfo.attCampArmy.getPlayerLv();
    int gAttLv = roundInfo.attCampArmy.getGeneralLv();
    int troopIdAtt = roundInfo.attCampArmy.getTroopId();
    int defTacticLost = 0;
    if (roundInfo.attTacticInfo != null)
      defTacticLost = roundInfo.attTacticInfo.firstCReduce; 
    int defLost = roundInfo.defLost + roundInfo.defStrategyLost + defTacticLost + roundInfo.defBeiDongLost;
    int defLv = getDefPlayerLevel(dataGetter, bat, roundInfo);
    int gDefLv = roundInfo.defCampArmy.getGeneralLv();
    int TroopIdDef = roundInfo.defCampArmy.getTroopId();
    dataGetter.getJobService().addJob("autoBattleService", "increaseLost", String.valueOf(String.valueOf(String.valueOf(roundInfo.defCampArmy.getPlayerId()))) + "#" + attLost, System.currentTimeMillis(), false);
    double mDefOmega = getRoundRewardBase(dataGetter, frc, TroopIdDef, troopIdAtt, defLost, attLost, defLv, attLv);
    double gDefOmega = getRoundRewardBase(dataGetter, frc, TroopIdDef, troopIdAtt, defLost, attLost, gDefLv, gAttLv);
    if (roundInfo.attCampArmy.playerId < -10000 && mDefOmega < 1000.0D) {
      mDefOmega = 1000.0D;
      gDefOmega = 1000.0D;
    } 
    BattleDrop battleDrop2 = new BattleDrop();
    int copper2 = (int)(mDefOmega * frc.getM().doubleValue());
    battleDrop2.type = 1;
    battleDrop2.num = copper2;
    roundInfo.defRoundReward.roundDropMap.put(Integer.valueOf(1), battleDrop2);
    battleDrop2 = new BattleDrop();
    int mExp2 = (int)(mDefOmega * frc.getC().doubleValue() * roundInfo.defCampArmy.rewardDouble);
    double def_world_frontLine_buff_exp_e = 1.0D;
    if (bat.world_frontLine_buff_att_def_e_side == 2)
      def_world_frontLine_buff_exp_e = bat.world_frontLine_buff_exp_e; 
    double defLowLvSCoe = getLowLvSCoe(bat, defLv, attLv);
    double defTechAddGZJY = 0.0D;
    if (bat.battleType == 3 || bat.battleType == 13) {
      defTechAddGZJY = dataGetter.getTechEffectCache().getTechEffect(roundInfo.defCampArmy.playerId, 40) / 100.0D;
      double lgzexp2 = dataGetter.getBattleDataCache().getPlayerExpadd(roundInfo.defCampArmy.playerId) / 100.0D;
      defTechAddGZJY += lgzexp2;
    } 
    double specialGeneralAddExp2 = 0.0D;
    if ((roundInfo.defCampArmy.getSpecialGeneral()).generalType == 4 && roundInfo.attCampArmy.isPhantom)
      specialGeneralAddExp2 = (roundInfo.defCampArmy.getSpecialGeneral()).param; 
    if ((roundInfo.defCampArmy.getSpecialGeneral()).generalType == 3 && (roundInfo.attCampArmy.isBarPhantom || roundInfo.attCampArmy.isBarEA))
      specialGeneralAddExp2 = (roundInfo.defCampArmy.getSpecialGeneral()).param2; 
    double farmBuff2 = 0.0D;
    if (!roundInfo.defCampArmy.isPhantom && roundInfo.defCampArmy.playerId > 0) {
      farmBuff2 = dataGetter.getWorldFarmService().getBuff(roundInfo.defCampArmy.playerId, roundInfo.defCampArmy.generalId);
      farmBuff2 = farmBuff2 * 1.0D / 100.0D;
    } 
    double bainianBuff2 = 0.0D;
    if (!roundInfo.defCampArmy.isPhantom && roundInfo.defCampArmy.playerId > 0) {
      bainianBuff2 = BaiNianEvent.getBuff(roundInfo.defCampArmy.playerId, dataGetter);
      bainianBuff2 = bainianBuff2 * 1.0D / 100.0D;
    } 
    mExp2 *= (int)(def_world_frontLine_buff_exp_e + defLowLvSCoe + defTechAddGZJY + bat.world_round_ally_buff_def_e + specialGeneralAddExp2 + roundInfo.defCampArmy.activityAddExp + farmBuff2 + bainianBuff2);
    battleDrop2.type = 5;
    battleDrop2.num = mExp2;
    roundInfo.defRoundReward.roundDropMap.put(Integer.valueOf(5), battleDrop2);
    double gExpAdd2 = dataGetter.getTechEffectCache().getTechEffect(roundInfo.defCampArmy.playerId, 16) / 100.0D;
    if (dataGetter.getPlayerDao().getConsumeLv(roundInfo.defCampArmy.playerId) >= 9)
      gExpAdd2 += 0.1D; 
    if (dataGetter.getPlayerDao().ismooncard(roundInfo.defCampArmy.playerId))
      gExpAdd2 += 0.15D; 
    if (roundInfo.defCampArmy.playerId > 0) {
      Map<Integer, String> ycbweffectMap2 = dataGetter.getBattleDataCache().getYcbwMap(roundInfo.defCampArmy.playerId, roundInfo.defCampArmy.generalId);
      gExpAdd2 += Double.valueOf(ycbweffectMap2.get(Integer.valueOf(8))).doubleValue() / 100.0D;
    } 
    if (roundInfo.defCampArmy.playerId > 0) {
      Date firstbufftime2 = dataGetter.getPlayerAttributeDao().read(roundInfo.defCampArmy.playerId).getHuiYuanTime();
      if (firstbufftime2 != null && System.currentTimeMillis() < firstbufftime2.getTime() + 7200000L)
        gExpAdd2++; 
    } 
    roundInfo.defRoundReward.gExp = (int)(gDefOmega * frc.getE().doubleValue() * roundInfo.defCampArmy.rewardDouble * (1.0D + gExpAdd2 + specialGeneralAddExp2 + roundInfo.defCampArmy.activityAddExp) + farmBuff2 + bainianBuff2);
    if (debug.equals("1"))
      roundInfo.caculateDebugBuffer.append("Def").append(" | ").append("mDefOmega:" + mDefOmega).append(" | ").append("gDefOmega:" + gDefOmega).append(" | ").append("rewardDouble:" + roundInfo.defCampArmy.rewardDouble).append(" | ").append("DEF TECH_KEY_16_LILIAN:" + gExpAdd2).append(" | ").append("defLowLvSCoe:" + defLowLvSCoe).append(" | ").append("def_world_frontLine_buff_exp_e:" + def_world_frontLine_buff_exp_e).append(" | ").append("defTechAddGZJY:" + defTechAddGZJY).append(" | ").append("world_round_ally_buff_def_e:" + bat.world_round_ally_buff_def_e).append(" | ").append("copper:" + copper2).append(" | ").append("mExp:" + mExp2).append(" | ").append("gExp:" + roundInfo.defRoundReward.gExp).append(" \n "); 
    roundCaculateHuanYingDanTiaoKillNumReward(dataGetter, frc, bat, roundInfo);
  }
  
  double getLowLvSCoe(Battle bat, int myLv, int counterLv) {
    if (bat.battleType != 3 && bat.battleType != 13)
      return 0.0D; 
    if (counterLv - myLv >= 25)
      return 1.0D; 
    if (counterLv - myLv >= 15)
      return 0.1D * (counterLv - myLv - 15); 
    return 0.0D;
  }
  
  public void roundBeiDongUpdateDB(IDataGetter dataGetter, Battle bat, Set<CampArmy> deads, TacticInfo tacticInfo, CampArmy campArmyB, int lostA, int lostB) {
    if (deads.size() <= 0)
      return; 
    if (tacticInfo != null && tacticInfo.reduceMap != null)
      for (CampArmy campArmy : tacticInfo.reduceMap.keySet()) {
        if (deads.contains(campArmy))
          deads.remove(campArmy); 
      }  
    if (deads.size() > 0)
      for (CampArmy campArmy : deads)
        roundReduceTroopSingle(dataGetter, bat, campArmy, campArmyB, true, campArmy.getArmyHpOrg(), 0);  
  }
  
  public void roundTacticUpdateDB(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    if (roundInfo.attTacticInfo != null && roundInfo.attTacticInfo.executed) {
      tacticUpdateDB(dataGetter, bat, bat.defCamp, roundInfo.attCampArmy, roundInfo.defCampArmy, roundInfo.attTacticInfo);
      if (roundInfo.attTacticInfo.reduceMap != null)
        for (CampArmy campArmy : roundInfo.attTacticInfo.reduceMap.keySet()) {
          if (campArmy != roundInfo.defCampArmy) {
            int reduce = ((Integer)roundInfo.attTacticInfo.reduceMap.get(campArmy)).intValue();
            roundInfo.defRoundLostTotal += reduce;
          } 
        }  
    } 
    if (roundInfo.defTacticInfo != null && roundInfo.defTacticInfo.executed) {
      tacticUpdateDB(dataGetter, bat, bat.attCamp, roundInfo.defCampArmy, roundInfo.attCampArmy, roundInfo.defTacticInfo);
      if (roundInfo.defTacticInfo.reduceMap != null)
        for (CampArmy campArmy : roundInfo.defTacticInfo.reduceMap.keySet()) {
          if (campArmy != roundInfo.attCampArmy) {
            int reduce = ((Integer)roundInfo.defTacticInfo.reduceMap.get(campArmy)).intValue();
            roundInfo.attRoundLostTotal += reduce;
          } 
        }  
    } 
  }
  
  public void roundAddReward(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo, RoundReward attRoundReward, RoundReward defRoundReward) {
    roundAddRewardSingle(dataGetter, roundInfo.attCampArmy, attRoundReward);
    if ((bat.getBattleType() == 3 || bat.getBattleType() == 13) && !bat.isNpc)
      roundAddRewardSingle(dataGetter, roundInfo.defCampArmy, defRoundReward); 
  }
  
  protected static void roundAddRewardSingle(IDataGetter dataGetter, CampArmy campArmy, RoundReward roundReward) {
    if (campArmy.updateDB || campArmy.getBeastId() > 0) {
      BattleDrop battleDropChiefExp = (BattleDrop)roundReward.roundDropMap.get(Integer.valueOf(5));
      AsynchronousDBOperationManager.getInstance().addBattleDropRetry(campArmy.getPlayerId(), battleDropChiefExp, "战斗获得");
      dataGetter.getJobService().addJob("autoBattleService", "increaseExp", String.valueOf(String.valueOf(String.valueOf(campArmy.getPlayerId()))) + "#" + battleDropChiefExp.num, System.currentTimeMillis(), false);
      AsynchronousDBOperationManager.getInstance().addBattleDropRetry(campArmy.getPlayerId(), (BattleDrop)roundReward.roundDropMap.get(Integer.valueOf(1)), "战斗获得");
      BattleDrop copper = (BattleDrop)roundReward.roundDropMap.get(Integer.valueOf(1));
      if (copper != null) {
        int copperNum = copper.num;
        dataGetter.getIndividualTaskService().sendTaskMessage(new PlayerDto(campArmy.getPlayerId(), campArmy.getForceId()), copperNum, "killyb");
      } 
      try {
        if (roundReward.gExp > 0) {
          AsynchronousDBOperationAddGeneralExp asynchronousDBOperationAddGeneralExp = new AsynchronousDBOperationAddGeneralExp(campArmy.getPlayerId(), campArmy.getGeneralId(), roundReward.gExp, "战斗获得");
          AsynchronousDBOperationManager.getInstance().addDBRetryOperation((IAsynchronousDBOperation)asynchronousDBOperationAddGeneralExp);
        } 
      } catch (Exception e) {
        ErrorSceneLog.getInstance().appendErrorMsg("Builder roundAddRewardSingle 增加武将等级经验经验 Exception").appendClassName("Builder").appendMethodName("roundAddRewardSingle").appendPlayerName(campArmy.playerName).append("PlayerId", Integer.valueOf(campArmy.playerId)).appendGeneralName(campArmy.generalName).appendGeneralId(campArmy.generalId).append("gExp", Integer.valueOf(roundReward.gExp)).flush();
        ErrorSceneLog.getInstance().error("Builder roundAddRewardSingle 增加玩家等级经验 Exception", e);
      } 
    } 
  }
  
  public void tacticUpdateDB(IDataGetter dataGetter, Battle bat, List<CampArmy> campList, CampArmy exeTacticCa, CampArmy firstDefCa, TacticInfo tacticInfoA) {
    if (tacticInfoA.reduceMap != null)
      for (CampArmy campArmy : tacticInfoA.reduceMap.keySet()) {
        if (campArmy != firstDefCa && campArmy.updateDB) {
          int reduce = ((Integer)tacticInfoA.reduceMap.get(campArmy)).intValue();
          if (campArmy.getArmyHpLoss() >= campArmy.getArmyHpOrg()) {
            AsynchronousDBOperationResetGeneralState asynchronousDBOperationResetGeneralState = new AsynchronousDBOperationResetGeneralState(campArmy.getPlayerId(), campArmy.generalId, reduce);
            AsynchronousDBOperationManager.getInstance().addDBOperation((IAsynchronousDBOperation)asynchronousDBOperationResetGeneralState);
          } else {
            AsynchronousDBOperationReduceGeneralHp asynchronousDBOperationReduceGeneralHp = new AsynchronousDBOperationReduceGeneralHp(campArmy.getPlayerId(), campArmy.generalId, reduce);
            AsynchronousDBOperationManager.getInstance().addDBOperation((IAsynchronousDBOperation)asynchronousDBOperationReduceGeneralHp);
          } 
          if (!campArmy.isPhantom())
            dataGetter.getGeneralService().sendGmForcesReduce(campArmy.playerId, campArmy.generalId, reduce, 0, bat.isInSceneSet(campArmy.playerId)); 
          BattleSceneLog.getInstance().appendLogMsg("exe tactic reduce general force").appendPlayerName(campArmy.playerName).appendGeneralName(campArmy.generalName).append("reduce", Integer.valueOf(reduce)).appendClassName("Builder").appendMethodName("tacticUpdateDB").flush();
        } 
      }  
    if (exeTacticCa.updateDB) {
      PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(exeTacticCa.getPlayerId()));
      if (pi == null)
        return; 
      if (tacticInfoA.reward != null) {
        RewardInfo ri = tacticInfoA.reward.rewardPlayer(dataGetter, exeTacticCa.playerId, "特殊战法", Integer.valueOf(exeTacticCa.generalId));
        if (ri.getReward() == 1) {
          pi.rbType = ri.getType();
          PlayerInfo playerInfo2 = pi, playerInfo = playerInfo2;
          playerInfo2.rbTotal += ri.getAddValue();
          tacticInfoA.tacticDrop = new BattleDrop();
          tacticInfoA.tacticDrop.type = ri.getType();
          tacticInfoA.tacticDrop.num = ri.getAddValue();
        } else {
          pi.rbTop = 1;
          exeTacticCa.rbTop = 1;
        } 
      } 
      if (!exeTacticCa.isPhantom())
        dataGetter.getGeneralService().sendGmForcesReduce(exeTacticCa.playerId, exeTacticCa.generalId, 0, tacticInfoA.allCReduce, bat.isInSceneSet(exeTacticCa.playerId)); 
    } 
  }
  
  public int caculateRoundCopper(IDataGetter dataGetter, Battle bat, int playerId, double mAttOmega, FightRewardCoe frc) {
    double copperAdd = dataGetter.getTechEffectCache().getTechEffect(playerId, 15) / 100.0D;
    int copper = (int)(mAttOmega * frc.getM().doubleValue() * (1.0D + copperAdd));
    return copper;
  }
  
  public void roundReduceTroop(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    CampArmy attCa = roundInfo.attCampArmy;
    CampArmy defCa = roundInfo.defCampArmy;
    int attreduce = 0;
    int defreduce = 0;
    if (roundInfo.defTacticInfo != null && roundInfo.defTacticInfo.executed && roundInfo.defTacticInfo.reduceMap != null && roundInfo.defTacticInfo.reduceMap.get(attCa) != null) {
      int attCaTacticReduce = ((Integer)roundInfo.defTacticInfo.reduceMap.get(attCa)).intValue();
      attreduce += attCaTacticReduce;
      BattleSceneLog.getInstance().appendLogMsg("def exe tactic, att reduce general force").appendPlayerName(attCa.playerName).appendGeneralName(attCa.generalName).append("attCaTacticReduce", Integer.valueOf(attCaTacticReduce)).flush();
    } 
    if (roundInfo.attTacticInfo != null && roundInfo.attTacticInfo.executed && roundInfo.attTacticInfo.reduceMap != null && roundInfo.attTacticInfo.reduceMap.get(defCa) != null) {
      int defCaTacticReduce = ((Integer)roundInfo.attTacticInfo.reduceMap.get(defCa)).intValue();
      defreduce += defCaTacticReduce;
      BattleSceneLog.getInstance().appendLogMsg("att exe tactic, def reduce general force").appendPlayerName(defCa.playerName).appendGeneralName(defCa.generalName).append("defCaTacticReduce", Integer.valueOf(defCaTacticReduce)).flush();
    } 
    attreduce += roundInfo.attStrategyLost;
    defreduce += roundInfo.defStrategyLost;
    attreduce = attreduce + roundInfo.attLost + roundInfo.attBeiDongLost;
    defreduce = defreduce + roundInfo.defLost + roundInfo.defBeiDongLost;
    roundInfo.attRoundLostTotal += attreduce;
    roundInfo.defRoundLostTotal += defreduce;
    roundReduceTroopSingle(dataGetter, bat, roundInfo.attCampArmy, roundInfo.defCampArmy, roundInfo.killAttG, attreduce, defreduce);
    roundReduceTroopSingle(dataGetter, bat, roundInfo.defCampArmy, roundInfo.attCampArmy, roundInfo.killDefG, defreduce, attreduce);
  }
  
  public void roundReduceTroopSingle(IDataGetter dataGetter, Battle bat, CampArmy campArmyA, CampArmy campArmyB, boolean isBeKill, int lostA, int lostB) {
    if (campArmyA.updateDB)
      if (isBeKill) {
        AsynchronousDBOperationResetGeneralState asynchronousDBOperationResetGeneralState = new AsynchronousDBOperationResetGeneralState(campArmyA.getPlayerId(), campArmyA.generalId, lostA);
        AsynchronousDBOperationManager.getInstance().addDBOperation((IAsynchronousDBOperation)asynchronousDBOperationResetGeneralState);
        dataGetter.getGeneralService().sendGmForcesReduce(campArmyA.getPlayerId(), campArmyA.generalId, lostA, lostB, bat.inSceneSet.contains(Integer.valueOf(campArmyA.getPlayerId())), campArmyB.playerName, campArmyB.generalName, campArmyB.quality);
      } else {
        if (lostA > 0) {
          AsynchronousDBOperationReduceGeneralHp asynchronousDBOperationReduceGeneralHp = new AsynchronousDBOperationReduceGeneralHp(campArmyA.getPlayerId(), campArmyA.generalId, lostA);
          AsynchronousDBOperationManager.getInstance().addDBOperation((IAsynchronousDBOperation)asynchronousDBOperationReduceGeneralHp);
        } 
        dataGetter.getGeneralService().sendGmForcesReduce(campArmyA.getPlayerId(), campArmyA.generalId, lostA, lostB, bat.inSceneSet.contains(Integer.valueOf(campArmyA.getPlayerId())), campArmyB.playerName, campArmyB.generalName, campArmyB.quality);
      }  
    if (campArmyA.getGeneralId() == 73051 && bat.getDefBaseInfo().getId() >= 264 && bat.getDefBaseInfo().getId() <= 266)
      BattleService.reduceHp(bat.getDefBaseInfo().getId(), lostA); 
  }
  
  public void dealTroopDrop(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {}
  
  public static void getReportType2(StringBuilder battleMsg, List<BattleArmy> addQlist, String battleSide) {
    BattleArmy battleArmy = null;
    if (addQlist.size() > 0) {
      battleMsg.append(2).append("|").append(battleSide).append(";");
      for (int i = 0; i < addQlist.size(); i++) {
        battleArmy = addQlist.get(i);
        CampArmy campArmy = battleArmy.getCampArmy();
        int specialType = (campArmy.getTeamGenreal() == null) ? 0 : ((campArmy.getTeamEffect() > 0.0D) ? 2 : 1);
        if (battleArmy.getTD_defense_e() > 0.0D)
          specialType = 3; 
        int troopHpMax = campArmy.getTroopHp() / 3;
        battleMsg.append(battleArmy.getPosition()).append("|").append(campArmy.getPlayerId()).append("|").append(campArmy.getTroopSerial()).append("|").append(campArmy.getTroopType()).append("|").append(campArmy.getTroopName()).append("|").append(campArmy.getTroopDropType()).append("|").append(battleArmy.getStrategy()).append("|").append(specialType).append("|");
        boolean diyihang = battleArmy.getHaveZhanChe();
        battleMsg.append(campArmy.getIsJuexing()).append("|").append(campArmy.getIsChongFeng()).append("|").append(battleArmy.getIsDajiang()).append("|").append(campArmy.getCopyType()).append("|").append(campArmy.getJueEquip()).append("|").append(campArmy.getAttack()).append("|").append(campArmy.getDefence()).append("|").append(campArmy.getResistePercentage()).append("|");
        if (diyihang) {
          int carid = campArmy.getCarId();
          battleMsg.append(carid).append("|").append(battleArmy.getBigGzNum()).append("|");
        } else if (battleArmy.getZhanchedun() > 0) {
          int carid = 0;
          if (campArmy.getCatapultSkill() == 2 && campArmy.getGeneralId() == 275) {
            carid = 999;
          } else if (campArmy.getCatapultSkill() == 4 && campArmy.getGeneralId() == 275) {
            carid = 879992;
          } 
          if (carid > 0) {
            battleMsg.append(carid).append("|").append(battleArmy.getBigGzNum()).append("|");
          } else {
            battleMsg.append(carid).append("|").append(0).append("|");
          } 
        } else {
          battleMsg.append(0).append("|").append(0).append("|");
        } 
        battleMsg.append(campArmy.getbsPro()).append("|").append(battleArmy.getZfShiled()).append("|").append(battleArmy.getSpecial()).append("|").append(campArmy.getWeiweiHuaide()).append("|").append(battleArmy.getYubaoEffect()).append("|").append(campArmy.getFormationType()).append("|").append(campArmy.getHasbigFormationskill()).append("|").append(campArmy.getFyzShield()).append("|").append(campArmy.getLgdcBuff()).append("|").append(campArmy.getIsBurn()).append("|").append(campArmy.getSex()).append("|").append(campArmy.getIsDeputy()).append("|").append(campArmy.getJxType()).append("|").append(campArmy.getYbTx()).append("|").append(campArmy.getWsb()).append("|").append(battleArmy.getTouXian()).append("|").append("0|").append(battleArmy.getLonglin()).append("|").append(battleArmy.getSangDanType()).append("|0|").append(campArmy.getMissNum()).append("|").append(campArmy.getImmunoNum()).append("|").append(campArmy.getCarPoDunNum()).append("|").append(campArmy.getIsFanShang()).append("|").append(campArmy.getIsBmy()).append("|").append(campArmy.getZhsNum()).append("|").append(campArmy.getMfFire()).append("|").append(battleArmy.getCardebuff()).append("|").append(battleArmy.getQingCheng()).append("|").append(battleArmy.getCarGzLevel()).append("|").append(battleArmy.getHuWei()).append("|").append(battleArmy.getCarTsBj()).append("|").append(battleArmy.getpose()).append("|").append(campArmy.getSneer()).append("|").append(campArmy.getIsBeatMonster()).append("|").append(campArmy.getBeastStar()).append("|").append("0|").append(campArmy.getFkbhHpPro()).append("|").append(campArmy.getIsZhenFaLvUp()).append("|").append(campArmy.getIsFlower()).append("|").append(campArmy.getSunShangXiangZs()).append("|").append(campArmy.getZsMyMa()).append("|").append(campArmy.getSsxMa()).append("|").append(battleArmy.getHuShou()).append("|").append(battleArmy.getFengDao()).append("|").append(battleArmy.getZyNum()).append("|");
        battleMsg.append(campArmy.getHuoYi()).append("|").append(campArmy.getZhaXiang()).append("|").append(campArmy.getHasZh()).append("|").append(campArmy.getLjNum()).append("|null|").append(campArmy.getLeblMa()).append("|").append(campArmy.guzhu).append("|").append(campArmy.getTuiShou()).append("|").append(campArmy.getFuBingNum1()).append("|0|0|").append(campArmy.getJxBuff1()).append("|").append(campArmy.getJxBuff1()).append("|0|0|0|0|").append(campArmy.getTitle1()).append("|0|0|0|").append(campArmy.getTitle()).append("|0|0|0|0|0|0|0|0|0|0|0|0|0|0|0|");
        for (int j = 0; j < 3; j++) {
          if (diyihang) {
            battleMsg.append(battleArmy.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(battleArmy.getCarHp()).append("*").append(battleArmy.getCarMaxHp()).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } else if (battleArmy.getZhanchedun() > 0) {
            battleMsg.append(battleArmy.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(battleArmy.getZCdunHp()).append("*").append(battleArmy.getCarMaxHp()).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } else {
            battleMsg.append(battleArmy.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(0).append("*").append(0).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } 
        } 
        battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), ";");
      } 
      battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "#");
    } 
  }
  
  public int quitUpdateDb(IDataGetter dataGetter, CampArmy ca, Battle bat, PlayerInfo pi) {
    ca.inBattle = false;
    int reduceNum = ca.armyHp;
    ca.armyHp = -1;
    if (pi.isAttSide) {
      bat.attCamp.remove(ca);
      BattleSceneLog.getInstance().info("#batId:" + bat.getBattleId() + "_" + bat.getStartTime() + "#quit:quit#side:att" + "#playerId:" + ca.getPlayerId() + ":" + ca.isPhantom + "#general:" + ca.getGeneralId() + "#attSize:" + bat.attCamp.size());
    } else {
      bat.defCamp.remove(ca);
      BattleSceneLog.getInstance().info("#batId:" + bat.getBattleId() + "_" + bat.getStartTime() + "#quit:quit#side:def" + "#playerId:" + ca.getPlayerId() + ":" + ca.isPhantom + "#general:" + ca.getGeneralId() + "#defSize:" + bat.defCamp.size());
    } 
    if (ca.getPlayerId() > 0 && !ca.isPhantom)
      NewBattleManager.getInstance().quitBattle(bat, ca.getPlayerId(), new int[] { ca.getGeneralId() }); 
    dataGetter.getPlayerGeneralMilitaryDao().restartRecruit(ca.playerId, ca.generalId, ca.isInRecruit ? 1 : 0, new Date());
    dataGetter.getGeneralService().sendGmUpdate(ca.playerId, ca.generalId, true);
    return reduceNum;
  }
  
  public void quit(Battle bat, IDataGetter dataGetter, int playerId, PlayerInfo pi, Set<CampArmy> quitGid, boolean isQuitAll, boolean isTuJin) {
    synchronized (bat.battleId) {
      int reduceNum = 0;
      for (CampArmy ca : quitGid)
        reduceNum += quitUpdateDb(dataGetter, ca, bat, pi); 
      if (pi.isAttSide) {
        if (bat.attBaseInfo.getNum() < reduceNum)
          ErrorSceneLog.getInstance().appendErrorMsg("Builder quit att 兵力小于0,builder 6883行"); 
        bat.attBaseInfo.setNum(bat.attBaseInfo.getNum() - reduceNum);
        bat.attBaseInfo.setAllNum(bat.attBaseInfo.getAllNum() - reduceNum);
      } else {
        if (bat.defBaseInfo.getNum() < reduceNum)
          ErrorSceneLog.getInstance().appendErrorMsg("Builder quit def 兵力小于0,builder 6890行"); 
        bat.defBaseInfo.setNum(bat.defBaseInfo.getNum() - reduceNum);
        bat.defBaseInfo.setAllNum(bat.defBaseInfo.getAllNum() - reduceNum);
      } 
      for (CampArmy ca : quitGid)
        dataGetter.getPlayerGeneralMilitaryDao().updateStateByPidAndGid(ca.playerId, ca.generalId, 1, new Date()); 
      StringBuilder battleMsg = new StringBuilder();
      int sn = bat.ticket.incrementAndGet();
      battleMsg.append(sn).append("|").append(bat.getBattleId()).append("#");
      battleMsg.append(6).append("|").append(pi.isAttSide ? "att" : "def").append(";");
      for (CampArmy ca2 : quitGid)
        battleMsg.append(ca2.getId()).append("|"); 
      battleMsg.append("#");
      if (battleMsg.length() > 0) {
        getReportType13(bat, battleMsg);
        bat.SaveCurReport(dataGetter);
        sendMsgToAll(bat, battleMsg);
      } 
      if (isQuitAll && !isTuJin) {
        StringBuilder myBattleMsg = new StringBuilder();
        sn++;
        myBattleMsg.append(sn).append("#");
        oneQuitBattleMsg(pi, myBattleMsg, playerId, dataGetter, bat);
      } 
    } 
  }
  
  protected void oneQuitBattleMsg(PlayerInfo pbi, StringBuilder battleMsg, int playerId, IDataGetter dataGetter, Battle bat) {
    int result = 3;
    battleMsg.append(7).append("|").append(3).append("|").append(-1).append(";");
    sendMsgToOne(playerId, battleMsg);
    BattleSceneLog.getInstance().debug(" battleId  个人退出结算信息: playerId:" + playerId + " msg:" + battleMsg);
  }
  
  public static void getLog(String battleMsg, String headInfo) {
    try {
      StringBuilder formatInfo = new StringBuilder();
      formatInfo.append(headInfo);
      String[] bats = battleMsg.split("#");
      formatInfo.append("\t").append(bats[0]).append("\n");
      String s = new String();
      int reportId = 0;
      String[] temp = null;
      for (int i = 1; i < bats.length; i++) {
        s = bats[i];
        if (s.length() == 1) {
          formatInfo.append("\t").append(s).append("\n");
        } else if (s.indexOf("|") == -1) {
          formatInfo.append("\t").append(s).append("\n");
        } else {
          reportId = Integer.valueOf(s.substring(0, s.indexOf("|"))).intValue();
          if (reportId == 1 || reportId == 5) {
            temp = bats[i].split(";");
            formatInfo.append("\t").append(temp[0]).append("\n");
            for (int j = 1; j < temp.length; j++)
              formatInfo.append("\t").append("\t").append(temp[j]).append("\n"); 
          } else if (reportId == 2 || reportId == 10) {
            temp = bats[i].split(";");
            formatInfo.append("\t").append(temp[0]).append("\n");
            for (int j = 1; j < temp.length; j++)
              formatInfo.append("\t").append("\t").append(temp[j]).append(";").append("\n"); 
          } else if (reportId == 12) {
            temp = bats[i].split(";");
            formatInfo.append("\t").append(temp[0]).append("\n");
            for (int j = 1; j < temp.length; j++) {
              String g = temp[j];
              formatInfo.append("\t").append("\t").append(g).append(";").append("\n");
            } 
            formatInfo.append("\n");
          } else if (reportId == 13) {
            temp = bats[i].split("\\|");
            formatInfo.append("\t").append(temp[0]).append("\n");
            for (int j = 1; j < temp.length; j++) {
              String[] gList = temp[j].split(";");
              for (int k = 0; k < gList.length; k++) {
                String g2 = gList[k];
                formatInfo.append("\t").append("\t").append(g2).append(";").append("\n");
              } 
              formatInfo.append("\n");
            } 
          } else {
            formatInfo.append("\t").append(bats[i]).append("\n");
          } 
        } 
      } 
      BattleSceneLog.getInstance().debug(formatInfo.toString());
    } catch (Exception e) {
      ErrorSceneLog.getInstance().error("getLog exception", e);
    } 
  }
  
  public void dealUniqueStaff(IDataGetter dataGetter, Battle bat, int playerId, int defId) {}
  
  public boolean dealTacticStrategy(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    boolean exeFight = true;
    boolean attExeTactic = false;
    boolean defExeTactic = false;
    CampArmy attCamp = roundInfo.attCampArmy;
    CampArmy defCamp = roundInfo.defCampArmy;
    boolean attLoss = false;
    boolean defLoss = false;
    int attTacticVal = roundInfo.attCampArmy.tacticVal;
    if ((roundInfo.defCampArmy.getSpecialGeneral()).generalType == 8 && roundInfo.attCampArmy.isjuexing <= 0)
      attTacticVal = 0; 
    int defTacticVal = roundInfo.defCampArmy.tacticVal;
    if ((roundInfo.attCampArmy.getSpecialGeneral()).generalType == 8 && roundInfo.defCampArmy.isjuexing <= 0)
      defTacticVal = 0; 
    roundInfo.tacticStrategyResult = 3;
    boolean zhaoyunattack = false;
    boolean zhaoyundefend = false;
    if (attCamp.generalId == 204 && attCamp.zhaoyunjineng) {
      zhaoyunattack = true;
      attCamp.zhaoyunjineng = false;
      if (defCamp.generalId == 224)
        zhaoyunattack = false; 
    } 
    if (defCamp.generalId == 204 && defCamp.zhaoyunjineng) {
      zhaoyundefend = true;
      defCamp.zhaoyunjineng = false;
      if (attCamp.generalId == 224)
        zhaoyundefend = false; 
    } 
    boolean zglattack = false;
    boolean zgldefend = false;
    if (attCamp.generalId == 269 && attCamp.getTroopType() == 47) {
      zglattack = true;
      roundInfo.attzgl = 1;
    } 
    if (defCamp.generalId == 269 && defCamp.getTroopType() == 47) {
      zgldefend = true;
      roundInfo.defzgl = 1;
    } 
    boolean attxiahouyuan = false;
    boolean defxiahouyuan = false;
    if (attCamp.generalId == 273 && attCamp.isjuexing <= 0 && defCamp.isPhantom && roundInfo.attBattleArmy.getZhenXiaHouYuan() > 0) {
      attxiahouyuan = true;
      roundInfo.attBattleArmy.setZhenXiaHouYuan(roundInfo.attBattleArmy.getZhenXiaHouYuan() - 1);
    } 
    if (defCamp.generalId == 273 && defCamp.isjuexing <= 0 && attCamp.isPhantom && roundInfo.defBattleArmy.getZhenXiaHouYuan() > 0) {
      defxiahouyuan = true;
      roundInfo.defBattleArmy.setZhenXiaHouYuan(roundInfo.defBattleArmy.getZhenXiaHouYuan() - 1);
    } 
    boolean atthunluan = false;
    if (((BattleArmy)bat.attList.get(0)).getSpecial() == 1) {
      atthunluan = true;
      if (attCamp.generalId == 230 && attCamp.isjuexing > 0)
        atthunluan = false; 
    } 
    boolean ismachaoatt = false;
    boolean ismachaodef = false;
    if (attCamp.generalId == 205 && attCamp.isjuexing > 0 && attCamp.machaotimes >= 8) {
      ismachaoatt = true;
      attCamp.machaotimes = 0;
    } 
    if (defCamp.generalId == 205 && defCamp.isjuexing > 0 && defCamp.machaotimes >= 8) {
      ismachaodef = true;
      defCamp.machaotimes = 0;
    } 
    boolean attlgz = false;
    boolean deflgz = false;
    boolean attlgz1 = false;
    boolean deflgz1 = false;
    if (attCamp.getGeneralId() == 277 && attCamp.getUnionState() > 0 && (attCamp.getZhanShuGongJi() == 1 || attCamp.getZhanShuFangYu() == 1 || attCamp.getZhanShuTuJi() == 1))
      attlgz = true; 
    if (defCamp.getGeneralId() == 277 && defCamp.getUnionState() > 0 && (defCamp.getZhanShuGongJi() == 1 || defCamp.getZhanShuFangYu() == 1 || defCamp.getZhanShuTuJi() == 1))
      deflgz = true; 
    if (attCamp.getGeneralId() == 416 && attCamp.getChapterId() > 1 && (attCamp.getZhanShuGongJi() == 1 || attCamp.getZhanShuFangYu() == 1 || attCamp.getZhanShuTuJi() == 1))
      attlgz1 = true; 
    if (defCamp.getGeneralId() == 416 && defCamp.getChapterId() > 1 && (defCamp.getZhanShuGongJi() == 1 || defCamp.getZhanShuFangYu() == 1 || defCamp.getZhanShuTuJi() == 1))
      deflgz1 = true; 
    boolean attunion = false;
    boolean defunion = false;
    if (attCamp.getDongFeng() >= 1) {
      attunion = true;
      attCamp.setDongFeng(0);
    } 
    if (defCamp.getDongFeng() >= 1) {
      defunion = true;
      defCamp.setDongFeng(0);
    } 
    boolean attsmyxishou = false;
    boolean defsmyxishou = false;
    boolean attdw = false;
    boolean defdw = false;
    if (roundInfo.attCampArmy.getGeneralId() == 208 && roundInfo.attCampArmy.getIsJuexing() > 0 && (roundInfo.nextAttBattleArmy == null || roundInfo.nextAttBattleArmy.getCampArmy().getId() != roundInfo.attCampArmy.getId()) && roundInfo.attCampArmy.getDwNum() >= 0) {
      attTacticVal = 1;
      roundInfo.attCampArmy.setDwNum(-10);
      attdw = true;
    } 
    if (roundInfo.defCampArmy.getGeneralId() == 208 && roundInfo.defCampArmy.getIsJuexing() > 0 && (roundInfo.nextDefBattleArmy == null || roundInfo.nextDefBattleArmy.getCampArmy().getId() != roundInfo.defCampArmy.getId()) && roundInfo.defCampArmy.getDwNum() >= 0) {
      defTacticVal = 1;
      roundInfo.defCampArmy.setDwNum(-10);
      defdw = true;
    } 
    if (attCamp.getLegendEvoke() && attCamp.getLegendSkill() != null && roundInfo.attBattleArmy.getIsDajiang() > 0 && attCamp.getLegendSkill().containsKey("bainiao") && ((Integer)attCamp.getLegendSkill().get("bainiao")).intValue() > 0)
      attTacticVal = 1; 
    if (defCamp.getLegendEvoke() && defCamp.getLegendSkill() != null && roundInfo.defBattleArmy.getIsDajiang() > 0 && defCamp.getLegendSkill().containsKey("bainiao") && ((Integer)defCamp.getLegendSkill().get("bainiao")).intValue() > 0)
      defTacticVal = 1; 
    boolean attcanzhanfa = !(!attlgz && !attlgz1 && !attunion && !ismachaoatt && !bat.tucheng && !attxiahouyuan && !attCamp.zhaoyunqijinqichu && !zglattack && !zhaoyunattack && attCamp.huanggaizhanfa <= 0 && (attTacticVal <= 0 || attCamp.getTacicId() <= 0 || (!bat.isAttChooseTactic() && (bat.attList.size() >= 2 || bat.isAttChoose()) && (bat.attList.size() < 2 || ((BattleArmy)bat.attList.get(1)).getCampArmy().getId() == roundInfo.attCampArmy.getId() || bat.isAttChoose()) && (roundInfo.attCampArmy.playerId > 0 || WebUtil.nextInt(roundInfo.attCampArmy.getColumn()) != 0)) || atthunluan));
    boolean attzuoqi = false;
    if (!attcanzhanfa && attCamp.zuoqiskill > 0 && attCamp.isDeputy <= 0)
      attzuoqi = true; 
    if ((attcanzhanfa || attzuoqi) && attCamp.getSneer() <= 0 && attCamp.getTuiShou() <= 0) {
      roundInfo.attTacticInfo = new TacticInfo();
      attExeTactic = true;
      Tactic tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(attCamp.getTacicId()));
      if (attCamp.zhaoyunqijinqichu) {
        tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(1412));
        attCamp.zhaoyunqijinqichu = false;
      } 
      if (attCamp.generalId == 273 && bat.terrainVal == 2 && attCamp.isjuexing <= 0)
        tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(2211)); 
      if (attCamp.juedifanji) {
        tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(1203));
        attCamp.juedifanji = false;
      } 
      if (bat.tucheng && tactic == null)
        tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(203)); 
      if (attCamp.generalId == 203 && attCamp.isjuexing > 0)
        if (attCamp.shenhunheyi == 1) {
          CampArmy campArmy = attCamp;
          campArmy.shenhunheyi++;
        } else {
          tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(1102));
        }  
      if (attunion) {
        tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(1322));
        if (attCamp.troopId >= 90286 && attCamp.troopId <= 90290)
          tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(13221)); 
      } 
      if (attlgz) {
        if (attCamp.getZhanShuGongJi() == 1) {
          tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(1756));
          if (attCamp.troopId >= 90306 && attCamp.troopId <= 90310)
            tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(17561)); 
        } 
        if (attCamp.getZhanShuFangYu() == 1) {
          tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(1755));
          if (attCamp.troopId >= 90306 && attCamp.troopId <= 90310)
            tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(17551)); 
        } 
        if (attCamp.getZhanShuTuJi() == 1) {
          tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(1757));
          if (attCamp.troopId >= 90306 && attCamp.troopId <= 90310)
            tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(17571)); 
        } 
      } 
      if (attlgz1) {
        if (attCamp.getZhanShuGongJi() == 1) {
          tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(400126));
          if (attCamp.troopId >= 904995 && attCamp.troopId <= 904999)
            tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(400126)); 
        } 
        if (attCamp.getZhanShuFangYu() == 1) {
          tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(9991306));
          if (attCamp.troopId >= 904995 && attCamp.troopId <= 904999)
            tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(9991306)); 
        } 
        if (attCamp.getZhanShuTuJi() == 1) {
          tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(9991309));
          if (attCamp.troopId >= 904995 && attCamp.troopId <= 904999)
            tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(9991309)); 
        } 
      } 
      if (attzuoqi) {
        tactic = (Tactic)dataGetter.getTacticCache().get(TechUtils.skills[attCamp.zuoqiskill - 1]);
        attCamp.setZuoQiSkill(0);
      } 
      if (attdw)
        tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(3303)); 
      if (attCamp.getSdqs() > 0)
        tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(3201)); 
      if (attCamp.getZhaXiang() > 0)
        tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(3605)); 
      if (attCamp.getHuangGaiZhanFa() > 0)
        tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(3604)); 
      if (tactic == null && !zglattack)
        ErrorSceneLog.getInstance().appendErrorMsg("tactic is null.").appendClassName("Builder").appendMethodName("dealTacticStrategy").append("TacicId:", Integer.valueOf(attCamp.getTacicId())).append("player id", Integer.valueOf(attCamp.getPlayerId())).append("player name", attCamp.getPlayerName()).append("general name", attCamp.getGeneralName()).flush(); 
      if (attCamp.generalId == 232 && attCamp.isjuexing > 0)
        attCamp.setMfBuff(1); 
      if (attCamp.generalId == 201 && attCamp.isjuexing > 0 && attCamp.chapterId > 0)
        attCamp.setJxBuff(1); 
      if (attCamp.formationtype == 1 && attCamp.formationLevel > 1000)
        attCamp.setJxBuff(5); 
      if (attCamp.formationtype == 2 && attCamp.formationLevel > 1000)
        attCamp.setJxBuff(5); 
      if (attCamp.formationtype == 3 && attCamp.formationLevel > 1000)
        attCamp.setJxBuff(5); 
      if (attCamp.formationtype == 6 && attCamp.formationLevel > 1000)
        attCamp.setJxBuff(5); 
      double deffantangailv = roundInfo.defCampArmy.specialGeneral.param;
      if (roundInfo.attCampArmy.ismooncard && !roundInfo.defCampArmy.ismooncard)
        deffantangailv *= 0.8D; 
      if (roundInfo.attCampArmy.getGeneralId() == 201 && roundInfo.attCampArmy.getUnionRank() >= 2 && tactic != null && tactic.getId().intValue() == 1614) {
        int attzjnum = 1;
        roundInfo.attCampArmy.setHaveZscy(true);
        if (bat.getBattleType() != 13 && bat.getBattleType() != 15 && bat.getBattleType() != 19)
          if (roundInfo.attCampArmy.getUnionRank() == 2 && !roundInfo.attCampArmy.getZscyShangzhen()) {
            attzjnum = 6;
          } else if (RandomUtils.nextInt(100) > 90) {
            attzjnum = 6;
          }  
        roundInfo.attCampArmy.setZscyShangzhen(true);
        roundInfo.attCampArmy.setZscy(roundInfo.attCampArmy.getZscy() + attzjnum);
      } 
      if (roundInfo.defCampArmy.getGeneralId() == 201 && roundInfo.defCampArmy.getUnionRank() >= 2 && tactic != null && tactic.getId().intValue() == 1614) {
        int defzjnum = 1;
        roundInfo.defCampArmy.setHaveZscy(true);
        if (bat.getBattleType() != 13 && bat.getBattleType() != 15 && bat.getBattleType() != 19)
          if (roundInfo.defCampArmy.getUnionRank() == 2 && !roundInfo.defCampArmy.getZscyShangzhen()) {
            defzjnum = 6;
          } else if (RandomUtils.nextInt(100) > 90) {
            defzjnum = 6;
          }  
        roundInfo.defCampArmy.setZscyShangzhen(true);
        roundInfo.defCampArmy.setZscy(roundInfo.defCampArmy.getZscy() + defzjnum);
      } 
      StringBuilder smyinfo = new StringBuilder();
      if (defCamp.getGeneralId() == 268 && defCamp.getIsJuexing() > 0 && tactic != null && bat.attList.size() > 1 && defCamp.smynum < 10) {
        CampArmy campArmy2 = defCamp;
        campArmy2.smynum++;
        defCamp.getSmyRow().add(tactic.getId());
        defsmyxishou = true;
      } 
      if (roundInfo.defCampArmy.specialGeneral.generalType == 5 && WebUtil.nextDouble() < deffantangailv && !zglattack && !bat.tucheng && roundInfo.attCampArmy.getUnionState() <= 0 && !attzuoqi && tactic != null)
        if (roundInfo.attCampArmy.isjuexing > 0) {
          roundInfo.defRebound = false;
        } else if (roundInfo.attCampArmy.generalId == 110 && RandomUtils.nextInt(100) >= 60) {
          roundInfo.defRebound = true;
        } else if (roundInfo.attCampArmy.isBarPhantom) {
          roundInfo.defRebound = false;
        } else if (roundInfo.attCampArmy.getGeneralId() == 201 && defCamp.getUnionState() > 0) {
          roundInfo.defRebound = false;
        } else if (roundInfo.attCampArmy.getIsBeatMonster() > 0) {
          roundInfo.defRebound = false;
        } else {
          roundInfo.defRebound = true;
        }  
      if (!roundInfo.defRebound && tactic != null) {
        for (BattleArmy ba : bat.getDefList()) {
          if (ba.getTD_defense_e() > 0.0D) {
            roundInfo.attTacticInfo.attacked_guanyu = true;
            break;
          } 
        } 
        roundInfo.defFirstRowKilled = exeTactic(dataGetter, 1, tactic, roundInfo.attTacticInfo, attCamp, defCamp, bat, roundInfo.defKilledList, roundInfo, bat.getDefList(), false, zglattack, attzuoqi);
        if (roundInfo.attTacticInfo.firstCReduce > 0)
          defLoss = true; 
        if (bat.getDefBaseInfo().getNum() < roundInfo.attTacticInfo.allCReduce)
          ErrorSceneLog.getInstance().appendErrorMsg("Builder dealTaticStrategy def兵力小于0,buidler 7170行"); 
        bat.getDefBaseInfo().setNum(bat.getDefBaseInfo().getNum() - roundInfo.attTacticInfo.allCReduce);
        roundInfo.tacticStrategyResult = 1;
        if (roundInfo.defFirstRowKilled && attCamp.generalId == 103 && attCamp.isjuexing > 0 && attCamp.unionstate <= 0 && !attzuoqi)
          attCamp.xuyaochiyan = true; 
        if (attCamp.tacicId == 1301 && !attzuoqi)
          roundInfo.defCampArmy.huoshaolianying = 5; 
        if (((attCamp.generalId == 107 && attCamp.tacicId == 1904) || attCamp.tacicId == 1907) && !attzuoqi) {
          StringBuilder hltx = new StringBuilder();
          int adddun = 20000;
          if (attCamp.generalId == 107 && attCamp.generalId == 281 && attCamp.isjuexing > 0) {
            adddun = attCamp.getTroopHp() * 15 / 100;
            if (adddun < 20000)
              adddun = 20000; 
          } 
          for (int i = 0; i < bat.attList.size() && i < 5; i++) {
            BattleArmy batarmy = bat.attList.get(i);
            if (batarmy.getCampArmy().getGeneralId() == attCamp.generalId) {
              if (batarmy.getHaveZhanChe()) {
                if (batarmy.getHuJia() > 0)
                  continue; 
                if (batarmy.getZCdunHp() > 0)
                  continue; 
              } 
              if (!batarmy.getHaveZhanChe() || batarmy.getShiledType() != 2 || batarmy.getShield() <= 0) {
                batarmy.setShield(adddun);
                batarmy.setShiledType(1);
                batarmy.setMaxShield(adddun);
                if (bat.getAttBaseInfo().getNum() + adddun * (batarmy.getTroopHp()).length < 0)
                  ErrorSceneLog.getInstance().appendErrorMsg("Builder caocao att 兵力小于0,builder 7204行"); 
                hltx.append(batarmy.getPosition()).append(":").append(adddun).append(",");
              } 
            } 
            continue;
          } 
          if (hltx.length() > 0) {
            hltx.deleteCharAt(hltx.length() - 1);
            roundInfo.attshield = hltx.toString();
          } 
        } 
        if (bat.getDefCamp().size() > 10 && attCamp.getGeneralId() == 202 && attCamp.getIsJuexing() > 0 && !attCamp.isPhantom() && !roundInfo.attTacticInfo.beStop && !attzuoqi && attCamp.isDeputy <= 0) {
          roundInfo.zfjxNum = dataGetter.getBattleService().jxZhangFeiSkill(attCamp, bat, 1, 0);
          roundInfo.zfjxForceId = defCamp.getForceId();
        } 
        if (attCamp.getGeneralId() == 281 && attCamp.isjuexing > 0 && tactic.getId().intValue() == 3002)
          attCamp.setBaQiNum(10); 
      } else if (tactic != null) {
        roundInfo.attTacticInfo.tacticId = tactic.getId().intValue();
        roundInfo.attTacticInfo.tacticDisplayId = tactic.getDisplayId().intValue();
        roundInfo.attTacticInfo.tacticNameId = tactic.getPic().intValue();
        roundInfo.attTacticInfo.tacticBasicPic = tactic.getBasicPic();
        roundInfo.attTacticInfo.specialType = tactic.getSpecialType();
      } 
      roundInfo.attTacticInfo.executed = true;
      if (!attxiahouyuan && attCamp.tacticVal > 0 && !attzuoqi && attCamp.getSdqs() <= 0 && attCamp.getHuangGaiZhanFa() <= 0) {
        CampArmy campArmy3 = attCamp;
        campArmy3.tacticVal--;
      } 
      if (attCamp.getHuangGaiZhanFa() > 0)
        attCamp.setHuangGaiZhanFa(0); 
      if (attCamp.getSdqs() > 0)
        attCamp.setSdqs(0); 
    } 
    boolean defhunluan = false;
    if (((BattleArmy)bat.defList.get(0)).getSpecial() == 1) {
      defhunluan = true;
      if (defCamp.generalId == 230 && defCamp.isjuexing > 0)
        defhunluan = false; 
    } 
    boolean defendcanzhanfa = !(!deflgz && !deflgz1 && !defunion && !ismachaodef && !defxiahouyuan && !defCamp.zhaoyunqijinqichu && !zgldefend && !zhaoyundefend && defCamp.huanggaizhanfa <= 0 && (defTacticVal <= 0 || defCamp.getTacicId() <= 0 || bat.surround > 0 || (!bat.isDefChooseTactic() && (bat.defList.size() >= 2 || bat.isDefChoose()) && (bat.defList.size() < 2 || ((BattleArmy)bat.defList.get(1)).getCampArmy().getId() == roundInfo.defCampArmy.getId() || bat.isDefChoose()) && roundInfo.defCampArmy.playerId > 0) || defhunluan));
    boolean defzuoqi = false;
    if (!defendcanzhanfa && defCamp.zuoqiskill > 0 && defCamp.isDeputy <= 0)
      defzuoqi = true; 
    if ((defendcanzhanfa || defzuoqi) && defCamp.getSneer() <= 0 && defCamp.getTuiShou() <= 0) {
      defExeTactic = true;
      if (!roundInfo.defFirstRowKilled) {
        roundInfo.defTacticInfo = new TacticInfo();
        Tactic tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(defCamp.getTacicId()));
        if (defCamp.zhaoyunqijinqichu) {
          tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(1412));
          defCamp.zhaoyunqijinqichu = false;
        } 
        if (defCamp.generalId == 273 && bat.terrainVal == 2 && defCamp.isjuexing <= 0)
          tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(2211)); 
        if (defCamp.juedifanji) {
          tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(1203));
          defCamp.juedifanji = false;
        } 
        if (defCamp.generalId == 203 && defCamp.isjuexing > 0)
          if (defCamp.shenhunheyi == 1) {
            CampArmy campArmy4 = defCamp;
            campArmy4.shenhunheyi++;
          } else {
            tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(1102));
          }  
        if (defunion) {
          tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(1322));
          if (defCamp.troopId >= 90286 && defCamp.troopId <= 90290)
            tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(13221)); 
        } 
        if (deflgz) {
          if (defCamp.getZhanShuGongJi() == 1) {
            tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(1756));
            if (defCamp.troopId >= 90306 && defCamp.troopId <= 90310)
              tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(17561)); 
            if (defCamp.troopId >= 904995 && defCamp.troopId <= 904999)
              tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(400126)); 
          } 
          if (defCamp.getZhanShuFangYu() == 1) {
            tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(1755));
            if (defCamp.troopId >= 90306 && defCamp.troopId <= 90310)
              tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(17551)); 
            if (defCamp.troopId >= 904995 && defCamp.troopId <= 904999)
              tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(9991306)); 
          } 
          if (defCamp.getZhanShuTuJi() == 1) {
            tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(1757));
            if (defCamp.troopId >= 90306 && defCamp.troopId <= 90310)
              tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(17571)); 
            if (defCamp.troopId >= 904995 && defCamp.troopId <= 904999)
              tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(9991309)); 
          } 
        } 
        if (deflgz1) {
          if (defCamp.getZhanShuGongJi() == 1) {
            tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(400126));
            if (defCamp.troopId >= 904995 && defCamp.troopId <= 904999)
              tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(400126)); 
          } 
          if (defCamp.getZhanShuFangYu() == 1) {
            tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(9991306));
            if (defCamp.troopId >= 904995 && defCamp.troopId <= 904999)
              tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(9991306)); 
          } 
          if (defCamp.getZhanShuTuJi() == 1) {
            tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(9991309));
            if (defCamp.troopId >= 904995 && defCamp.troopId <= 904999)
              tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(9991309)); 
          } 
        } 
        if (defzuoqi) {
          tactic2 = (Tactic)dataGetter.getTacticCache().get(TechUtils.skills[defCamp.zuoqiskill - 1]);
          defCamp.setZuoQiSkill(0);
        } 
        if (defdw)
          tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(3303)); 
        if (defCamp.getSdqs() > 0)
          tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(3201)); 
        if (defCamp.getZhaXiang() > 0)
          tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(3605)); 
        if (defCamp.getHuangGaiZhanFa() > 0)
          tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(3604)); 
        if (tactic2 == null && !zgldefend)
          ErrorSceneLog.getInstance().appendErrorMsg("tactic is null.").appendClassName("Builder").appendMethodName("dealTacticStrategy").append("TacicId:", Integer.valueOf(defCamp.getTacicId())).append("player id", Integer.valueOf(defCamp.getPlayerId())).append("player name", defCamp.getPlayerName()).append("general name", defCamp.getGeneralName()).flush(); 
        if (defCamp.generalId == 232 && defCamp.isjuexing > 0)
          defCamp.setMfBuff(1); 
        if (defCamp.generalId == 201 && defCamp.isjuexing > 0 && defCamp.chapterId > 0)
          defCamp.setJxBuff(1); 
        if (defCamp.formationtype == 1 && defCamp.formationLevel > 1000)
          defCamp.setJxBuff(5); 
        if (defCamp.formationtype == 2 && defCamp.formationLevel > 1000)
          defCamp.setJxBuff(5); 
        if (defCamp.formationtype == 3 && defCamp.formationLevel > 1000)
          defCamp.setJxBuff(5); 
        if (defCamp.formationtype == 6 && defCamp.formationLevel > 1000)
          defCamp.setJxBuff(5); 
        double attfantangailv = roundInfo.attCampArmy.specialGeneral.param;
        if (roundInfo.defCampArmy.ismooncard && !roundInfo.attCampArmy.ismooncard)
          attfantangailv *= 0.8D; 
        if (attCamp.getGeneralId() == 268 && attCamp.getIsJuexing() > 0 && tactic2 != null && bat.defList.size() > 1 && attCamp.smynum < 10) {
          CampArmy campArmy5 = attCamp;
          campArmy5.smynum++;
          attCamp.getSmyRow().add(tactic2.getId());
          attsmyxishou = true;
        } 
        if (roundInfo.attCampArmy.specialGeneral.generalType == 5 && WebUtil.nextDouble() < attfantangailv && !zgldefend && roundInfo.defCampArmy.getUnionState() <= 0 && !defzuoqi && tactic2 != null)
          if (roundInfo.defCampArmy.isjuexing > 0) {
            roundInfo.attRebound = false;
          } else if (roundInfo.defCampArmy.generalId == 110 && RandomUtils.nextInt(100) >= 60) {
            roundInfo.attRebound = true;
          } else if (roundInfo.defCampArmy.isBarPhantom) {
            roundInfo.attRebound = false;
          } else if (roundInfo.defCampArmy.getGeneralId() == 201 && attCamp.getUnionState() > 0) {
            roundInfo.attRebound = false;
          } else if (roundInfo.defCampArmy.getIsBeatMonster() > 0) {
            roundInfo.attRebound = false;
          } else {
            roundInfo.attRebound = true;
          }  
        if (!roundInfo.attRebound && tactic2 != null) {
          for (BattleArmy ba2 : bat.getAttList()) {
            if (ba2.getTD_defense_e() > 0.0D) {
              roundInfo.defTacticInfo.attacked_guanyu = true;
              break;
            } 
          } 
          roundInfo.attFirstRowKilled = exeTactic(dataGetter, 0, tactic2, roundInfo.defTacticInfo, defCamp, attCamp, bat, roundInfo.attKilledList, roundInfo, bat.getAttList(), false, zgldefend, defzuoqi);
          if (roundInfo.defTacticInfo.firstCReduce > 0)
            attLoss = true; 
          if (bat.getAttBaseInfo().getNum() < roundInfo.defTacticInfo.allCReduce)
            ErrorSceneLog.getInstance().appendErrorMsg("Builder dealTaticStrategy att兵力小于0,builder 7259行"); 
          bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - roundInfo.defTacticInfo.allCReduce);
          roundInfo.tacticStrategyResult = 2;
          if (roundInfo.attFirstRowKilled && defCamp.generalId == 103 && defCamp.isjuexing > 0 && defCamp.unionstate <= 0 && !defzuoqi)
            defCamp.xuyaochiyan = true; 
          if (bat.getAttCamp().size() > 10 && defCamp.getGeneralId() == 202 && defCamp.getIsJuexing() > 0 && !defCamp.isPhantom() && !roundInfo.defTacticInfo.beStop && !defzuoqi && defCamp.isDeputy <= 0) {
            roundInfo.zfjxNum = dataGetter.getBattleService().jxZhangFeiSkill(defCamp, bat, 0, 0);
            roundInfo.zfjxForceId = attCamp.getForceId();
          } 
          if (attCamp.tacicId == 1301 || (attCamp.tacicId == 400106 && !attzuoqi))
            roundInfo.attCampArmy.huoshaolianying = 5; 
          if (((attCamp.generalId == 107 && attCamp.tacicId == 1904) || attCamp.tacicId == 1907 || attCamp.tacicId == 400106 || attCamp.tacicId == 400108 || attCamp.tacicId == 400110 || attCamp.tacicId == 4010701) && !attzuoqi) {
            int adddun2 = 20000;
            if (attCamp.generalId == 107 && attCamp.generalId == 281 && attCamp.isjuexing > 0) {
              adddun2 = attCamp.getTroopHp() * 15 / 100;
              if (adddun2 < 20000)
                adddun2 = 20000; 
            } 
            StringBuilder hltx2 = new StringBuilder();
            for (int j = 0; j < bat.defList.size() && j < 5; j++) {
              BattleArmy batarmy2 = bat.defList.get(j);
              if (batarmy2.getCampArmy().getGeneralId() == defCamp.generalId) {
                if (batarmy2.getHaveZhanChe()) {
                  if (batarmy2.getHuJia() > 0)
                    continue; 
                  if (batarmy2.getZCdunHp() > 0)
                    continue; 
                } 
                if (!batarmy2.getHaveZhanChe() || batarmy2.getShiledType() != 2 || batarmy2.getShield() <= 0) {
                  batarmy2.setShield(adddun2);
                  batarmy2.setShiledType(1);
                  batarmy2.setMaxShield(adddun2);
                  if (bat.getDefBaseInfo().getNum() + adddun2 * (batarmy2.getTroopHp()).length < 0)
                    ErrorSceneLog.getInstance().appendErrorMsg("Builder caocao def 兵力小于0,builder 7350行"); 
                  hltx2.append(batarmy2.getPosition()).append(":").append(adddun2).append(",");
                } 
              } 
              continue;
            } 
            if (hltx2.length() > 0) {
              hltx2.deleteCharAt(hltx2.length() - 1);
              roundInfo.defshield = hltx2.toString();
            } 
          } 
          if ((defCamp.getGeneralId() == 281 && defCamp.isjuexing >= 0 && tactic2.getId().intValue() == 3002) || tactic2.getId().intValue() == 4028101 || tactic2.getId().intValue() == 400108 || tactic2.getId().intValue() == 400110)
            defCamp.setBaQiNum(10); 
          roundInfo.defTacticInfo.executed = true;
        } else if (tactic2 != null) {
          roundInfo.defTacticInfo.tacticId = tactic2.getId().intValue();
          roundInfo.defTacticInfo.tacticDisplayId = tactic2.getDisplayId().intValue();
          roundInfo.defTacticInfo.tacticNameId = tactic2.getPic().intValue();
          roundInfo.defTacticInfo.tacticBasicPic = tactic2.getBasicPic();
          roundInfo.defTacticInfo.specialType = tactic2.getSpecialType();
        } 
        roundInfo.defTacticInfo.executed = true;
        if (!defxiahouyuan && defCamp.tacticVal > 0 && !defzuoqi && defCamp.getSdqs() <= 0 && defCamp.getHuangGaiZhanFa() <= 0) {
          CampArmy campArmy6 = defCamp;
          campArmy6.tacticVal--;
        } 
        if (defCamp.getHuangGaiZhanFa() > 0)
          defCamp.setHuangGaiZhanFa(0); 
        if (defCamp.getSdqs() > 0)
          defCamp.setSdqs(0); 
      } else {
        Tactic tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(defCamp.getTacicId()));
        if (tactic2 != null) {
          roundInfo.defTacticInfo = new TacticInfo();
          roundInfo.defTacticInfo.tacticId = tactic2.getId().intValue();
          roundInfo.defTacticInfo.tacticDisplayId = tactic2.getDisplayId().intValue();
          roundInfo.defTacticInfo.tacticNameId = tactic2.getPic().intValue();
          roundInfo.defTacticInfo.tacticBasicPic = tactic2.getBasicPic();
        } 
      } 
    } 
    if (attsmyxishou || defsmyxishou) {
      StringBuilder smyinfo = new StringBuilder();
      smyinfo.append("65|");
      if (attsmyxishou) {
        smyinfo.append("4,").append(attCamp.smynum).append(",0;");
      } else {
        smyinfo.append("null;");
      } 
      if (defsmyxishou) {
        smyinfo.append("4,").append(defCamp.smynum).append(",0#");
      } else {
        smyinfo.append("null#");
      } 
      roundInfo.smystr = smyinfo;
    } 
    if (roundInfo.attRebound) {
      roundInfo.attTacticInfo = new TacticInfo();
      Tactic tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(defCamp.getTacicId()));
      if (defCamp.generalId == 273 && bat.terrainVal == 2 && defCamp.isjuexing > 0)
        tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(2211)); 
      if (tactic2 != null) {
        roundInfo.nextMinExeTime += tactic2.getPlayertime().intValue() + 3000;
        for (BattleArmy ba : bat.getDefList()) {
          if (ba.getTD_defense_e() > 0.0D) {
            roundInfo.attTacticInfo.attacked_guanyu = true;
            break;
          } 
        } 
        roundInfo.defFirstRowKilled = exeTactic(dataGetter, 1, tactic2, roundInfo.attTacticInfo, attCamp, defCamp, bat, roundInfo.defKilledList, roundInfo, bat.getDefList(), true, zglattack, attzuoqi);
        if (roundInfo.attTacticInfo.firstCReduce > 0)
          defLoss = true; 
        if (bat.getDefBaseInfo().getNum() < roundInfo.attTacticInfo.allCReduce)
          ErrorSceneLog.getInstance().appendErrorMsg("Builder dealTaticStrategy def 1 兵力小于0,builder 7399行"); 
        bat.getDefBaseInfo().setNum(bat.getDefBaseInfo().getNum() - roundInfo.attTacticInfo.allCReduce);
        roundInfo.attTacticInfo.executed = true;
        roundInfo.tacticStrategyResult = 1;
        if (roundInfo.defFirstRowKilled && attCamp.generalId == 103 && attCamp.isjuexing > 0 && attCamp.unionstate <= 0)
          attCamp.xuyaochiyan = true; 
      } else {
        roundInfo.nextMinExeTime += 4500;
      } 
    } 
    if (roundInfo.defRebound) {
      roundInfo.defTacticInfo = new TacticInfo();
      Tactic tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(attCamp.getTacicId()));
      if (attCamp.generalId == 273 && bat.terrainVal == 2 && attCamp.isjuexing > 0)
        tactic2 = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(2211)); 
      if (tactic2 != null) {
        roundInfo.nextMinExeTime += tactic2.getPlayertime().intValue() + 3000;
        for (BattleArmy ba : bat.getAttList()) {
          if (ba.getTD_defense_e() > 0.0D) {
            roundInfo.defTacticInfo.attacked_guanyu = true;
            break;
          } 
        } 
        roundInfo.attFirstRowKilled = exeTactic(dataGetter, 0, tactic2, roundInfo.defTacticInfo, defCamp, attCamp, bat, roundInfo.attKilledList, roundInfo, bat.getAttList(), true, zgldefend, defzuoqi);
        if (roundInfo.defTacticInfo.firstCReduce > 0)
          attLoss = true; 
        if (bat.getAttBaseInfo().getNum() < roundInfo.defTacticInfo.allCReduce)
          ErrorSceneLog.getInstance().appendErrorMsg("Builder dealTaticStrategy att 1 兵力小于0,builder 7439行"); 
        bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - roundInfo.defTacticInfo.allCReduce);
        roundInfo.defTacticInfo.executed = true;
        roundInfo.tacticStrategyResult = 2;
        if (roundInfo.attFirstRowKilled && defCamp.generalId == 103 && defCamp.isjuexing > 0 && defCamp.unionstate <= 0)
          defCamp.xuyaochiyan = true; 
      } else {
        roundInfo.nextMinExeTime += 4500;
        ErrorSceneLog.getInstance().appendErrorMsg("defRebound，tactic==null,tacId:" + attCamp.getTacicId() + ",generalID:" + attCamp.getGeneralId()).flush();
      } 
    } 
    if (zglattack || zgldefend)
      zhenfajianyu(bat, roundInfo); 
    if (!attExeTactic && !defExeTactic) {
      zhenfajianyu(bat, roundInfo);
      dealStrategy(dataGetter, bat, roundInfo);
      if (roundInfo.attStrategyLost > 0)
        attLoss = true; 
      if (roundInfo.defStrategyLost > 0)
        defLoss = true; 
    } 
    lieyanhuixiang(dataGetter, bat, roundInfo, Boolean.valueOf(attLoss), Boolean.valueOf(defLoss));
    bat.defBaseInfo.foreWin = true;
    if (roundInfo.defFirstRowKilled)
      bat.defBaseInfo.foreWin = false; 
    bat.attBaseInfo.foreWin = true;
    if (roundInfo.attFirstRowKilled)
      bat.attBaseInfo.foreWin = false; 
    exeFight = (!roundInfo.attFirstRowKilled && !roundInfo.defFirstRowKilled);
    if (roundInfo.attFirstRowKilled && roundInfo.defFirstRowKilled)
      roundInfo.win = 3; 
    if (roundInfo.needreport43) {
      getReportType43(dataGetter, bat, roundInfo);
      roundInfo.needreport43 = false;
    } else {
      getReportType14(dataGetter, bat, roundInfo);
    } 
    getReportType30(roundInfo.battleMsg, roundInfo);
    if (!exeFight)
      getReportType31(roundInfo.battleMsg, roundInfo); 
    if (!roundInfo.attKilledList.isEmpty())
      if (bat.attList.size() <= 1) {
        roundInfo.nextAttBattleArmy = null;
      } else {
        boolean find = false;
        for (int k = 1; k < bat.attList.size(); k++) {
          find = false;
          for (BattleArmy ba3 : roundInfo.attKilledList) {
            if (((BattleArmy)bat.attList.get(k)).getPosition() == ba3.getPosition()) {
              find = true;
              break;
            } 
          } 
          if (!find && k > 0) {
            roundInfo.nextAttBattleArmy = bat.attList.get(k);
            break;
          } 
        } 
        if (find)
          roundInfo.nextAttBattleArmy = null; 
      }  
    if (!roundInfo.defKilledList.isEmpty())
      if (bat.defList.size() <= 1) {
        roundInfo.nextDefBattleArmy = null;
      } else {
        boolean find = false;
        for (int k = 1; k < bat.defList.size(); k++) {
          find = false;
          for (BattleArmy ba3 : roundInfo.defKilledList) {
            if (((BattleArmy)bat.defList.get(k)).getPosition() == ba3.getPosition()) {
              find = true;
              break;
            } 
          } 
          if (!find) {
            roundInfo.nextDefBattleArmy = bat.defList.get(k);
            break;
          } 
        } 
        if (find)
          roundInfo.nextDefBattleArmy = null; 
      }  
    if (attLoss)
      if (roundInfo.killAttG && roundInfo.nextAttBattleArmy != null) {
        if (bat.attList.size() > 1 && bat.defList.size() > 1)
          bat.setBattleRoundBuff(dataGetter, ((BattleArmy)bat.attList.get(1)).getCampArmy(), ((BattleArmy)bat.defList.get(1)).getCampArmy()); 
        getReportType16(dataGetter, bat, roundInfo.battleMsg, roundInfo.nextAttBattleArmy.getCampArmy(), "att", true, false);
      } else {
        getReportType16(dataGetter, bat, roundInfo.battleMsg, roundInfo.attCampArmy, "att", false, false);
      }  
    if (defLoss)
      if (roundInfo.killDefG && roundInfo.nextDefBattleArmy != null) {
        if (bat.attList.size() > 1 && bat.defList.size() > 1)
          bat.setBattleRoundBuff(dataGetter, ((BattleArmy)bat.attList.get(1)).getCampArmy(), ((BattleArmy)bat.defList.get(1)).getCampArmy()); 
        getReportType16(dataGetter, bat, roundInfo.battleMsg, roundInfo.nextDefBattleArmy.getCampArmy(), "def", true, false);
      } else {
        getReportType16(dataGetter, bat, roundInfo.battleMsg, roundInfo.defCampArmy, "def", false, false);
      }  
    getReportType20(bat, roundInfo.battleMsg, roundInfo);
    return exeFight;
  }
  
  public void lieyanhuixiang(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo, Boolean attLoss, Boolean defLoss) {
    if (!attLoss.booleanValue() && !defLoss.booleanValue())
      return; 
    CampArmy attCamp = roundInfo.attCampArmy;
    CampArmy defCamp = roundInfo.defCampArmy;
    boolean atthuix = (roundInfo.attBattleArmy.getLieYanHuiXiang() > 0 && roundInfo.attBattleArmy.getHuJia() > 0);
    boolean defhuix = (roundInfo.defBattleArmy.getLieYanHuiXiang() > 0 && roundInfo.defBattleArmy.getHuJia() > 0);
    if (atthuix && defhuix)
      return; 
    if (atthuix && defLoss.booleanValue()) {
      List<BattleArmy> listB = bat.defList;
      StringBuilder lieyanstr = new StringBuilder();
      for (int i = 0; i < listB.size() && i < listB.size(); i++) {
        BattleArmy batArmy = listB.get(i);
        if (batArmy.getTroopHp()[0] > 0) {
          CampArmy defendCa = batArmy.getCampArmy();
          int damage = attCamp.getLieyandamage();
          if (defendCa.getLegendSkill().containsKey("yanmi") && ((Integer)defendCa.getLegendSkill().get("yanmi")).intValue() > 0)
            damage = damage * 40 / 100; 
          int reduce = 0;
          if (damage >= batArmy.getTroopHp()[0])
            damage = batArmy.getTroopHp()[0] - 1; 
          boolean realdamage = false;
          if (batArmy.getHaveZhanChe() && batArmy.getHuJia() > 0 && damage > 0) {
            if (damage >= defendCa.getPojia()) {
              damage = defendCa.getNaijiu();
              batArmy.setHuJia(batArmy.getHuJia() - defendCa.naijiu);
            } else {
              damage = 1;
              batArmy.setHuJia(batArmy.getHuJia() - 1);
            } 
          } else if (batArmy.getCatapultSkill() > 1 && batArmy.getZCdunHp() > 0 && damage > 0) {
            if (damage >= defendCa.pojia / 2) {
              damage = defendCa.getNaijiu();
            } else {
              damage = 1;
            } 
            batArmy.setZCdunHp(batArmy.getZCdunHp() - damage);
          } else if (batArmy.getShield() > 0 && damage > 0) {
            if (batArmy.getShiledType() == 2) {
              if (batArmy.getZhanchedun() > 0) {
                if (damage >= defendCa.pojia / 2) {
                  damage = defendCa.getNaijiu();
                } else {
                  damage = 1;
                } 
              } else {
                damage = -1;
              } 
            } else {
              if (damage > batArmy.getShield())
                damage = batArmy.getShield(); 
              realdamage = true;
            } 
            batArmy.setShield(batArmy.getShield() - ((damage < 0) ? 0 : damage));
          } 
          for (int j2 = 0; j2 < (batArmy.getTroopHp()).length; j2++) {
            int[] troopHp = batArmy.getTroopHp();
            if (!realdamage) {
              troopHp[j2] = troopHp[j2] - ((damage < 0) ? 0 : damage);
              reduce += (damage < 0) ? 0 : damage;
            } 
          } 
          lieyanstr.append(batArmy.getPosition()).append(",").append(damage).append(",").append(batArmy.getTroopHp()[0]).append("|");
          CampArmy campArmy = defendCa;
          campArmy.armyHpLoss += reduce;
          if (!realdamage)
            roundInfo.defBeiDongLost += reduce; 
          if (batArmy.getTroopHp()[0] <= 0) {
            roundInfo.defKilledList.add(batArmy);
            if (i == 0) {
              roundInfo.defFirstRowKilled = true;
              roundInfo.win = 1;
            } 
          } 
          PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defendCa.getPlayerId()));
          if (pi != null) {
            PlayerInfo playerInfo3 = pi, playerInfo = playerInfo3;
            playerInfo3.lostTotal += reduce;
          } 
          if (defendCa.isBarPhantom) {
            CampArmy campArmy2 = attCamp;
            campArmy2.barbarainHpKill += reduce;
          } 
          CampArmy campArmy3 = attCamp;
          campArmy3.armyHpKill += reduce;
          PlayerInfo piA = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(attCamp.getPlayerId()));
          if (piA != null) {
            PlayerInfo playerInfo4 = piA, playerInfo2 = playerInfo4;
            playerInfo4.killTotal += reduce;
          } 
          if (!realdamage)
            bat.getDefBaseInfo().setNum(bat.getDefBaseInfo().getNum() - reduce); 
        } 
      } 
      if (lieyanstr.length() > 0) {
        lieyanstr.replace(lieyanstr.length() - 1, lieyanstr.length(), ":");
        roundInfo.nextMinExeTime += 3000;
      } 
      roundInfo.attlieyanstr = lieyanstr;
    } 
    if (defhuix && attLoss.booleanValue()) {
      List<BattleArmy> listB = bat.attList;
      StringBuilder lieyanstr = new StringBuilder();
      for (int i = 0; i < listB.size() && i < listB.size(); i++) {
        BattleArmy batArmy = listB.get(i);
        if (batArmy.getTroopHp()[0] > 0) {
          CampArmy attCa = batArmy.getCampArmy();
          int damage = defCamp.getLieyandamage();
          if (attCa.getLegendSkill().containsKey("yanmi") && ((Integer)attCa.getLegendSkill().get("yanmi")).intValue() > 0)
            damage = damage * 40 / 100; 
          int reduce = 0;
          if (damage >= batArmy.getTroopHp()[0])
            damage = batArmy.getTroopHp()[0] - 1; 
          boolean realdamage = false;
          if (batArmy.getHaveZhanChe() && batArmy.getHuJia() > 0 && damage > 0) {
            if (damage >= attCa.getPojia()) {
              damage = attCa.getNaijiu();
              batArmy.setHuJia(batArmy.getHuJia() - attCa.naijiu);
            } else {
              damage = 1;
              batArmy.setHuJia(batArmy.getHuJia() - 1);
            } 
          } else if (batArmy.getCatapultSkill() > 1 && batArmy.getZCdunHp() > 0 && damage > 0) {
            if (damage >= attCa.pojia / 2) {
              damage = attCa.getNaijiu();
            } else {
              damage = 1;
            } 
            batArmy.setZCdunHp(batArmy.getZCdunHp() - damage);
          } else if (batArmy.getShield() > 0 && damage > 0) {
            if (batArmy.getShiledType() == 2) {
              if (batArmy.getZhanchedun() > 0) {
                if (damage >= attCa.pojia / 2) {
                  damage = attCa.getNaijiu();
                } else {
                  damage = 1;
                } 
              } else {
                damage = -1;
              } 
            } else {
              if (damage > batArmy.getShield())
                damage = batArmy.getShield(); 
              realdamage = true;
            } 
            batArmy.setShield(batArmy.getShield() - ((damage < 0) ? 0 : damage));
          } 
          for (int j2 = 0; j2 < (batArmy.getTroopHp()).length; j2++) {
            int[] troopHp = batArmy.getTroopHp();
            if (!realdamage) {
              troopHp[j2] = troopHp[j2] - ((damage < 0) ? 0 : damage);
              reduce += (damage < 0) ? 0 : damage;
            } 
          } 
          lieyanstr.append(batArmy.getPosition()).append(",").append(damage).append(",").append(batArmy.getTroopHp()[0]).append("|");
          CampArmy campArmy4 = attCa;
          campArmy4.armyHpLoss += reduce;
          if (!realdamage)
            roundInfo.attBeiDongLost += reduce; 
          if (batArmy.getTroopHp()[0] <= 0) {
            roundInfo.attKilledList.add(batArmy);
            if (i == 0) {
              roundInfo.attFirstRowKilled = true;
              roundInfo.win = 2;
            } 
          } 
          PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(attCa.getPlayerId()));
          if (pi != null) {
            PlayerInfo playerInfo5 = pi, playerInfo = playerInfo5;
            playerInfo5.lostTotal += reduce;
          } 
          if (attCa.isBarPhantom) {
            CampArmy campArmy5 = defCamp;
            campArmy5.barbarainHpKill += reduce;
          } 
          CampArmy campArmy6 = defCamp;
          campArmy6.armyHpKill += reduce;
          PlayerInfo piA = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defCamp.getPlayerId()));
          if (piA != null) {
            PlayerInfo playerInfo6 = piA, playerInfo2 = playerInfo6;
            playerInfo6.killTotal += reduce;
          } 
          if (!realdamage)
            bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - reduce); 
        } 
      } 
      if (lieyanstr.length() > 0) {
        lieyanstr.deleteCharAt(lieyanstr.length() - 1);
        roundInfo.nextMinExeTime += 3000;
      } 
      roundInfo.deflieyanstr = lieyanstr;
    } 
  }
  
  public boolean AfterRound(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    boolean needexefight = true;
    CampArmy attCamp = roundInfo.attCampArmy;
    CampArmy defCamp = roundInfo.defCampArmy;
    List<BattleArmy> listA = bat.attList;
    List<BattleArmy> listB = bat.defList;
    boolean attalldie = true;
    boolean defalldie = true;
    for (BattleArmy tempbatArmy : listA) {
      if (tempbatArmy.getTroopHp()[0] > 0) {
        attalldie = false;
        break;
      } 
    } 
    for (BattleArmy tempbatArmy : listB) {
      if (tempbatArmy.getTroopHp()[0] > 0) {
        defalldie = false;
        break;
      } 
    } 
    if (roundInfo.attKilledList.size() > 0 && roundInfo.attCampArmy.generalId == 270 && roundInfo.attCampArmy.getUnionRank() >= 3 && !attalldie) {
      boolean xiahoudie = false;
      for (BattleArmy diearmy : roundInfo.attKilledList) {
        if (diearmy.getCampArmy() == roundInfo.attCampArmy) {
          xiahoudie = true;
          break;
        } 
      } 
      if (xiahoudie) {
        roundInfo.attCampArmy.setMaChaoTimes(roundInfo.attCampArmy.getMaChaoTimes() + 1);
        roundInfo.battleMsg.append("106|0|def|");
        boolean zhaoyunchidiao = false;
        BattleArmy batArmy = roundInfo.defBattleArmy;
        CampArmy defendCa = batArmy.getCampArmy();
        int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (defendCa.getLegendSkill().containsKey("huzhu") && ((Integer)defendCa.getLegendSkill().get("huzhu")).intValue() > 0)
          damage = damage * 60 / 100; 
        if (listB.size() == 1 && damage >= batArmy.getTroopHp()[0])
          damage = batArmy.getTroopHp()[0] - 1; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          zhaoyunchidiao = true;
        } 
        int reduce = 0;
        if (damage < 0)
          damage = 1; 
        if (defendCa.getImmunoNum() > 0) {
          damage = -6;
          CampArmy campArmy = defendCa;
          campArmy.immunoNum--;
        } 
        boolean realdamage = false;
        if (batArmy.getHaveZhanChe() && batArmy.getHuJia() > 0 && damage > 0) {
          damage = defendCa.getNaijiu();
          batArmy.setHuJia(batArmy.getHuJia() - defendCa.naijiu);
        } else if (batArmy.getCatapultSkill() > 1 && batArmy.getZCdunHp() > 0 && damage > 0) {
          damage = defendCa.getNaijiu();
          batArmy.setZCdunHp(batArmy.getZCdunHp() - damage);
        } else if (batArmy.getShield() > 0 && damage > 0) {
          if (batArmy.getShiledType() == 2) {
            if (batArmy.getZhanchedun() > 0) {
              damage = defendCa.getNaijiu();
            } else {
              damage = -1;
            } 
          } else {
            damage = batArmy.getShield();
            realdamage = true;
          } 
          batArmy.setShield(batArmy.getShield() - ((damage < 0) ? 0 : damage));
        } 
        for (int j2 = 0; j2 < (batArmy.getTroopHp()).length; j2++) {
          int[] troopHp = batArmy.getTroopHp();
          if (!realdamage) {
            troopHp[j2] = troopHp[j2] - ((damage < 0) ? 0 : damage);
            reduce += (damage < 0) ? 0 : damage;
          } 
        } 
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",").append(damage).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
        CampArmy campArmy2 = defendCa;
        campArmy2.armyHpLoss += reduce;
        PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defendCa.getPlayerId()));
        if (pi != null) {
          PlayerInfo playerInfo7 = pi, playerInfo = playerInfo7;
          playerInfo7.lostTotal += reduce;
        } 
        if (defendCa.isBarPhantom) {
          CampArmy campArmy3 = attCamp;
          campArmy3.barbarainHpKill += reduce;
        } 
        CampArmy campArmy4 = attCamp;
        campArmy4.armyHpKill += reduce;
        if (!realdamage) {
          roundInfo.defBeiDongLost += reduce;
          PlayerInfo piA = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(attCamp.getPlayerId()));
          if (piA != null) {
            PlayerInfo playerInfo8 = piA, playerInfo2 = playerInfo8;
            playerInfo8.killTotal += reduce;
          } 
          if (bat.getDefBaseInfo().getNum() < reduce)
            ErrorSceneLog.getInstance().appendErrorMsg("Builder AfterRound def 兵力小于0,builder13297行"); 
          bat.getDefBaseInfo().setNum(bat.getDefBaseInfo().getNum() - reduce);
        } 
        if (batArmy.getTroopHp()[0] <= 0) {
          roundInfo.defKilledList.add(batArmy);
          roundInfo.needreport47 = true;
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (roundInfo.defKilledList.size() > 0 && roundInfo.defCampArmy.generalId == 270 && roundInfo.defCampArmy.getUnionRank() >= 3 && !defalldie) {
      boolean xiahoudie = false;
      for (BattleArmy diearmy : roundInfo.defKilledList) {
        if (diearmy.getCampArmy() == roundInfo.defCampArmy) {
          xiahoudie = true;
          break;
        } 
      } 
      if (xiahoudie) {
        roundInfo.defCampArmy.setMaChaoTimes(roundInfo.defCampArmy.getMaChaoTimes() + 1);
        roundInfo.battleMsg.append("106|0|att|");
        boolean zhaoyunchidiao = false;
        BattleArmy batArmy = roundInfo.attBattleArmy;
        CampArmy defendCa = batArmy.getCampArmy();
        int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (defendCa.getLegendSkill().containsKey("huzhu") && ((Integer)defendCa.getLegendSkill().get("huzhu")).intValue() > 0)
          damage = damage * 60 / 100; 
        if (listA.size() == 1 && damage >= batArmy.getTroopHp()[0])
          damage = batArmy.getTroopHp()[0] - 1; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          zhaoyunchidiao = true;
        } 
        int reduce = 0;
        if (damage < 0)
          damage = 1; 
        if (defendCa.getImmunoNum() > 0) {
          damage = -6;
          CampArmy campArmy5 = defendCa;
          campArmy5.immunoNum--;
        } 
        boolean realdamage = false;
        if (batArmy.getHaveZhanChe() && batArmy.getHuJia() > 0 && damage > 0) {
          damage = defendCa.getNaijiu();
          batArmy.setHuJia(batArmy.getHuJia() - defendCa.naijiu);
        } else if (batArmy.getCatapultSkill() > 1 && batArmy.getZCdunHp() > 0 && damage > 0) {
          damage = defendCa.getNaijiu();
          batArmy.setZCdunHp(batArmy.getZCdunHp() - damage);
        } else if (batArmy.getShield() > 0 && damage > 0) {
          if (batArmy.getShiledType() == 2) {
            if (batArmy.getZhanchedun() > 0) {
              damage = defendCa.getNaijiu();
            } else {
              damage = -1;
            } 
          } else {
            damage = batArmy.getShield();
            realdamage = true;
          } 
          batArmy.setShield(batArmy.getShield() - ((damage < 0) ? 0 : damage));
        } 
        for (int j2 = 0; j2 < (batArmy.getTroopHp()).length; j2++) {
          int[] troopHp = batArmy.getTroopHp();
          if (!realdamage) {
            troopHp[j2] = troopHp[j2] - ((damage < 0) ? 0 : damage);
            reduce += (damage < 0) ? 0 : damage;
          } 
        } 
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",").append(damage).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
        CampArmy campArmy6 = defendCa;
        campArmy6.armyHpLoss += reduce;
        PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defendCa.getPlayerId()));
        if (pi != null) {
          PlayerInfo playerInfo9 = pi, playerInfo = playerInfo9;
          playerInfo9.lostTotal += reduce;
        } 
        if (defendCa.isBarPhantom) {
          CampArmy campArmy7 = attCamp;
          campArmy7.barbarainHpKill += reduce;
        } 
        CampArmy campArmy8 = attCamp;
        campArmy8.armyHpKill += reduce;
        if (!realdamage) {
          roundInfo.attBeiDongLost += reduce;
          PlayerInfo piA = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(attCamp.getPlayerId()));
          if (piA != null) {
            PlayerInfo playerInfo10 = piA, playerInfo2 = playerInfo10;
            playerInfo10.killTotal += reduce;
          } 
          if (bat.getAttBaseInfo().getNum() < reduce)
            ErrorSceneLog.getInstance().appendErrorMsg("Builder AfterRound att 兵力小于0,builder13418行"); 
          bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - reduce);
        } 
        if (batArmy.getTroopHp()[0] <= 0) {
          roundInfo.attKilledList.add(batArmy);
          roundInfo.needreport47 = true;
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (bat.getAttNeedZscy()) {
      bat.setAttNeedZscy(false);
      if (listB.isEmpty() || defalldie)
        return needexefight; 
      roundInfo.battleMsg.append("54|att;").append(77).append(";0;").append(attCamp.getGeneralPic()).append(";");
      boolean zhaoyunchidiao2 = false;
      for (int i = 0; i < 5 && i < listB.size(); i++) {
        BattleArmy batArmy = listB.get(i);
        if (batArmy.getTroopHp()[0] > 0) {
          CampArmy defendCa = batArmy.getCampArmy();
          int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage < 1000)
            damage = 1000; 
          if (i == listB.size() - 1 && damage >= batArmy.getTroopHp()[0])
            damage = batArmy.getTroopHp()[0] - 1; 
          if (zhaoyunchidiao2) {
            damage = 1;
          } else if (defendCa.getChiZhanFa() > 0) {
            zhaoyunchidiao2 = true;
          } 
          int reduce = 0;
          if (damage < 0)
            damage = 1; 
          if (defendCa.getImmunoNum() > 0) {
            damage = -6;
            CampArmy campArmy9 = defendCa;
            campArmy9.immunoNum--;
          } 
          boolean realdamage = false;
          if (batArmy.getHaveZhanChe() && batArmy.getHuJia() > 0 && damage > 0) {
            damage = defendCa.getNaijiu();
            batArmy.setHuJia(batArmy.getHuJia() - defendCa.naijiu);
          } else if (batArmy.getCatapultSkill() > 1 && batArmy.getZCdunHp() > 0 && damage > 0) {
            damage = defendCa.getNaijiu();
            batArmy.setZCdunHp(batArmy.getZCdunHp() - damage);
          } else if (batArmy.getShield() > 0 && damage > 0) {
            if (batArmy.getShiledType() == 2) {
              if (batArmy.getZhanchedun() > 0) {
                damage = defendCa.getNaijiu();
              } else {
                damage = -1;
              } 
            } else {
              damage = batArmy.getShield();
              realdamage = true;
            } 
            batArmy.setShield(batArmy.getShield() - ((damage < 0) ? 0 : damage));
          } 
          for (int j2 = 0; j2 < (batArmy.getTroopHp()).length; j2++) {
            int[] troopHp = batArmy.getTroopHp();
            if (!realdamage) {
              troopHp[j2] = troopHp[j2] - ((damage < 0) ? 0 : damage);
              reduce += (damage < 0) ? 0 : damage;
            } 
          } 
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",").append(damage).append(",").append(batArmy.getTroopHp()[0]).append(",0,0*");
          CampArmy campArmy10 = defendCa;
          campArmy10.armyHpLoss += reduce;
          PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defendCa.getPlayerId()));
          if (pi != null) {
            PlayerInfo playerInfo11 = pi, playerInfo = playerInfo11;
            playerInfo11.lostTotal += reduce;
          } 
          if (defendCa.isBarPhantom) {
            CampArmy campArmy11 = attCamp;
            campArmy11.barbarainHpKill += reduce;
          } 
          CampArmy campArmy12 = attCamp;
          campArmy12.armyHpKill += reduce;
          if (!realdamage) {
            roundInfo.defBeiDongLost += reduce;
            PlayerInfo piA = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(attCamp.getPlayerId()));
            if (piA != null) {
              PlayerInfo playerInfo12 = piA, playerInfo2 = playerInfo12;
              playerInfo12.killTotal += reduce;
            } 
            if (bat.getDefBaseInfo().getNum() < reduce)
              ErrorSceneLog.getInstance().appendErrorMsg("Builder AfterRound def 兵力小于0,builder7737行"); 
            bat.getDefBaseInfo().setNum(bat.getDefBaseInfo().getNum() - reduce);
          } 
          if (batArmy.getTroopHp()[0] <= 0) {
            roundInfo.defKilledList.add(batArmy);
            roundInfo.needreport47 = true;
          } 
        } 
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (bat.getDefNeedZscy()) {
      bat.setDefNeedZscy(false);
      if (listA.isEmpty() || attalldie)
        return needexefight; 
      roundInfo.battleMsg.append("54|def;").append(77).append(";0;").append(defCamp.getGeneralPic()).append(";");
      boolean zhaoyunchidiao2 = false;
      for (int i = 0; i < 5 && i < listA.size(); i++) {
        BattleArmy batArmy = listA.get(i);
        if (batArmy.getTroopHp()[0] > 0) {
          CampArmy defendCa = batArmy.getCampArmy();
          int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage < 1000)
            damage = 1000; 
          if (i == listA.size() - 1 && damage >= batArmy.getTroopHp()[0])
            damage = batArmy.getTroopHp()[0] - 1; 
          if (zhaoyunchidiao2) {
            damage = 1;
          } else if (defendCa.getChiZhanFa() > 0) {
            zhaoyunchidiao2 = true;
          } 
          int reduce = 0;
          if (damage < 0)
            damage = 1; 
          if (defendCa.getImmunoNum() > 0) {
            damage = -6;
            CampArmy campArmy13 = defendCa;
            campArmy13.immunoNum--;
          } 
          boolean realdamage = false;
          if (batArmy.getHaveZhanChe() && batArmy.getHuJia() > 0 && damage > 0) {
            damage = defendCa.getNaijiu();
            batArmy.setHuJia(batArmy.getHuJia() - defendCa.naijiu);
          } else if (batArmy.getCatapultSkill() > 1 && batArmy.getZCdunHp() > 0 && damage > 0) {
            damage = defendCa.getNaijiu();
            batArmy.setZCdunHp(batArmy.getZCdunHp() - damage);
          } else if (batArmy.getShield() > 0 && damage > 0) {
            if (batArmy.getShiledType() == 2) {
              if (batArmy.getZhanchedun() > 0) {
                damage = defendCa.getNaijiu();
              } else {
                damage = -1;
              } 
            } else {
              damage = batArmy.getShield();
              realdamage = true;
            } 
            batArmy.setShield(batArmy.getShield() - ((damage < 0) ? 0 : damage));
          } 
          for (int j2 = 0; j2 < (batArmy.getTroopHp()).length; j2++) {
            int[] troopHp = batArmy.getTroopHp();
            if (!realdamage) {
              troopHp[j2] = troopHp[j2] - ((damage < 0) ? 0 : damage);
              reduce += (damage < 0) ? 0 : damage;
            } 
          } 
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",").append(damage).append(",").append(batArmy.getTroopHp()[0]).append(",0,0*");
          CampArmy campArmy14 = defendCa;
          campArmy14.armyHpLoss += reduce;
          if (!realdamage)
            roundInfo.attBeiDongLost += reduce; 
          PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defendCa.getPlayerId()));
          if (pi != null) {
            PlayerInfo playerInfo13 = pi, playerInfo = playerInfo13;
            playerInfo13.lostTotal += reduce;
          } 
          if (defendCa.isBarPhantom) {
            CampArmy campArmy15 = defCamp;
            campArmy15.barbarainHpKill += reduce;
          } 
          CampArmy campArmy16 = defCamp;
          campArmy16.armyHpKill += reduce;
          PlayerInfo piA = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defCamp.getPlayerId()));
          if (piA != null) {
            PlayerInfo playerInfo14 = piA, playerInfo2 = playerInfo14;
            playerInfo14.killTotal += reduce;
          } 
          if (bat.getAttBaseInfo().getNum() < reduce)
            ErrorSceneLog.getInstance().appendErrorMsg("Builder AfterRound att 兵力小于0,builder 7657行"); 
          if (!realdamage)
            bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - reduce); 
          if (batArmy.getTroopHp()[0] <= 0) {
            roundInfo.attKilledList.add(batArmy);
            roundInfo.needreport47 = true;
          } 
        } 
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (roundInfo.attCampArmy.getNeedChongZhen()) {
      roundInfo.attCampArmy.setNeedChongZhen(false);
      roundInfo.battleMsg.append("66|def;").append(4).append("#");
      roundInfo.nextMinExeTime += 1000;
    } 
    if (roundInfo.defCampArmy.getNeedChongZhen()) {
      roundInfo.defCampArmy.setNeedChongZhen(false);
      roundInfo.battleMsg.append("66|att;").append(4).append("#");
      roundInfo.nextMinExeTime += 1000;
    } 
    boolean attbelvbusuicide = false;
    int attchiturow = 0;
    boolean defbelvbusuicide = false;
    int defchiturow = 0;
    if (attCamp.chitubenxi > 0) {
      attbelvbusuicide = true;
      attchiturow = (attCamp.chitubenxi > 5) ? 5 : attCamp.chitubenxi;
      attCamp.chitubenxi = 0;
    } 
    if (defCamp.chitubenxi > 0) {
      defbelvbusuicide = true;
      defchiturow = (defCamp.chitubenxi > 5) ? 5 : defCamp.chitubenxi;
      defCamp.chitubenxi = 0;
    } 
    if (roundInfo.defBattleArmy.getTroopHp()[0] <= 0 && roundInfo.defCampArmy.generalId == 266 && roundInfo.defCampArmy.isjuexing > 0 && !attbelvbusuicide) {
      lvbuzhuisha(bat, roundInfo, 2, true);
    } else if (roundInfo.defBattleArmy.getTroopHp()[0] <= 0 && (roundInfo.attCampArmy.tacicId == 1611 || roundInfo.attCampArmy.tacicId == 400106 || roundInfo.attCampArmy.tacicId == 1614 || roundInfo.attCampArmy.tacicId == 4020101) && !defbelvbusuicide && (roundInfo.attTacticInfo == null || !roundInfo.attTacticInfo.executed)) {
      lvbuzhuisha(bat, roundInfo, 1, false);
    } 
    if (roundInfo.attBattleArmy.getTroopHp()[0] <= 0 && roundInfo.attCampArmy.generalId == 266 && roundInfo.attCampArmy.isjuexing > 0 && !defbelvbusuicide) {
      lvbuzhuisha(bat, roundInfo, 1, true);
    } else if (roundInfo.attBattleArmy.getTroopHp()[0] <= 0 && (roundInfo.defCampArmy.tacicId == 1611 || roundInfo.defCampArmy.tacicId == 400106 || roundInfo.defCampArmy.tacicId == 1614 || roundInfo.attCampArmy.tacicId == 4020101) && !attbelvbusuicide && (roundInfo.defTacticInfo == null || !roundInfo.defTacticInfo.executed)) {
      lvbuzhuisha(bat, roundInfo, 2, false);
    } 
    if (attbelvbusuicide) {
      if (listA.isEmpty() || attalldie)
        return needexefight; 
      roundInfo.battleMsg.append("54|def;").append(10016).append(";1005;null").append(";");
      boolean zhaoyunchidiao3 = false;
      for (int k = 0; k < attchiturow && k < listA.size(); k++) {
        BattleArmy batArmy2 = listA.get(k);
        if (batArmy2.getTroopHp()[0] > 0) {
          CampArmy defendCa2 = batArmy2.getCampArmy();
          int damage2 = batArmy2.getTroopHp()[0];
          if (k == listA.size() - 1)
            damage2 = batArmy2.getTroopHp()[0] - 1; 
          if (batArmy2.getCampArmy().getGeneralId() == 73051 || batArmy2.getCampArmy().getIsBeatMonster() > 0 || (batArmy2.getCampArmy().getGeneralId() == 232 && batArmy2.getCampArmy().getUnionRank() > 0) || batArmy2.getCampArmy().getLegendEvoke()) {
            damage2 = defCamp.attEffect - defendCa2.defEffect + defCamp.TACTIC_ATT - defendCa2.TACTIC_DEF;
            if (damage2 <= 0)
              damage2 = 1; 
          } 
          if (zhaoyunchidiao3) {
            damage2 = 1;
          } else if (defendCa2.getChiZhanFa() > 0) {
            zhaoyunchidiao3 = true;
          } 
          int reduce2 = 0;
          if (damage2 < 0)
            damage2 = 1; 
          if (defendCa2.getImmunoNum() > 0) {
            damage2 = -6;
            CampArmy campArmy17 = defendCa2;
            campArmy17.immunoNum--;
          } 
          boolean realdamage2 = false;
          if (batArmy2.getHaveZhanChe() && batArmy2.getHuJia() > 0 && damage2 > 0) {
            damage2 = defendCa2.getNaijiu();
            batArmy2.setHuJia(batArmy2.getHuJia() - defendCa2.naijiu);
          } else if (batArmy2.getCatapultSkill() > 1 && batArmy2.getZCdunHp() > 0 && damage2 > 0) {
            damage2 = defendCa2.getNaijiu();
            batArmy2.setZCdunHp(batArmy2.getZCdunHp() - damage2);
          } else if (batArmy2.getShield() > 0 && damage2 > 0) {
            if (batArmy2.getShiledType() == 2) {
              if (batArmy2.getZhanchedun() > 0) {
                damage2 = defendCa2.getNaijiu();
              } else {
                damage2 = -1;
              } 
            } else {
              damage2 = batArmy2.getShield();
              realdamage2 = true;
            } 
            batArmy2.setShield(batArmy2.getShield() - ((damage2 < 0) ? 0 : damage2));
          } 
          for (int j3 = 0; j3 < (batArmy2.getTroopHp()).length; j3++) {
            int[] troopHp2 = batArmy2.getTroopHp();
            if (!realdamage2) {
              troopHp2[j3] = troopHp2[j3] - ((damage2 < 0) ? 0 : damage2);
              reduce2 += (damage2 < 0) ? 0 : damage2;
            } 
          } 
          roundInfo.battleMsg.append(batArmy2.getPosition()).append(",").append(damage2).append(",").append(batArmy2.getTroopHp()[0]).append(",0,0*");
          CampArmy campArmy18 = defendCa2;
          campArmy18.armyHpLoss += reduce2;
          if (!realdamage2)
            roundInfo.attBeiDongLost += reduce2; 
          PlayerInfo pi2 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defendCa2.getPlayerId()));
          if (pi2 != null) {
            PlayerInfo playerInfo15 = pi2, playerInfo3 = playerInfo15;
            playerInfo15.lostTotal += reduce2;
          } 
          if (defendCa2.isBarPhantom) {
            CampArmy campArmy19 = defCamp;
            campArmy19.barbarainHpKill += reduce2;
          } 
          CampArmy campArmy20 = defCamp;
          campArmy20.armyHpKill += reduce2;
          PlayerInfo piA2 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defCamp.getPlayerId()));
          if (piA2 != null) {
            PlayerInfo playerInfo16 = piA2, playerInfo4 = playerInfo16;
            playerInfo16.killTotal += reduce2;
          } 
          if (bat.getAttBaseInfo().getNum() < reduce2)
            ErrorSceneLog.getInstance().appendErrorMsg("Builder AfterRound att 兵力小于0,builder 7657行"); 
          if (!realdamage2)
            bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - reduce2); 
          if (batArmy2.getTroopHp()[0] <= 0) {
            roundInfo.attKilledList.add(batArmy2);
            roundInfo.needreport47 = true;
          } 
        } 
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (defbelvbusuicide) {
      if (listB.isEmpty() || defalldie)
        return needexefight; 
      roundInfo.battleMsg.append("54|att;").append(10016).append(";1005;null").append(";");
      boolean zhaoyunchidiao3 = false;
      for (int k = 0; k < defchiturow && k < listB.size(); k++) {
        BattleArmy batArmy2 = listB.get(k);
        if (batArmy2.getTroopHp()[0] > 0) {
          CampArmy defendCa2 = batArmy2.getCampArmy();
          int damage2 = batArmy2.getTroopHp()[0];
          if (k == listB.size() - 1)
            damage2 = batArmy2.getTroopHp()[0] - 1; 
          if (batArmy2.getCampArmy().getGeneralId() == 73051 || batArmy2.getCampArmy().getIsBeatMonster() > 0 || (batArmy2.getCampArmy().getGeneralId() == 232 && batArmy2.getCampArmy().getUnionRank() > 0) || batArmy2.getCampArmy().getLegendEvoke()) {
            damage2 = attCamp.attEffect - defendCa2.defEffect + attCamp.TACTIC_ATT - defendCa2.TACTIC_DEF;
            if (damage2 <= 0)
              damage2 = 1; 
          } 
          if (zhaoyunchidiao3) {
            damage2 = 1;
          } else if (defendCa2.getChiZhanFa() > 0) {
            zhaoyunchidiao3 = true;
          } 
          int reduce2 = 0;
          if (damage2 < 0)
            damage2 = 1; 
          if (defendCa2.getImmunoNum() > 0) {
            damage2 = -6;
            CampArmy campArmy21 = defendCa2;
            campArmy21.immunoNum--;
          } 
          boolean realdamage2 = false;
          if (batArmy2.getHaveZhanChe() && batArmy2.getHuJia() > 0 && damage2 > 0) {
            damage2 = defendCa2.getNaijiu();
            batArmy2.setHuJia(batArmy2.getHuJia() - defendCa2.naijiu);
          } else if (batArmy2.getCatapultSkill() > 1 && batArmy2.getZCdunHp() > 0 && damage2 > 0) {
            damage2 = defendCa2.getNaijiu();
            batArmy2.setZCdunHp(batArmy2.getZCdunHp() - damage2);
          } else if (batArmy2.getShield() > 0 && damage2 > 0) {
            if (batArmy2.getShiledType() == 2) {
              if (batArmy2.getZhanchedun() > 0) {
                damage2 = defendCa2.getNaijiu();
              } else {
                damage2 = -1;
              } 
            } else {
              damage2 = batArmy2.getShield();
              realdamage2 = true;
            } 
            batArmy2.setShield(batArmy2.getShield() - ((damage2 < 0) ? 0 : damage2));
          } 
          for (int j3 = 0; j3 < (batArmy2.getTroopHp()).length; j3++) {
            int[] troopHp2 = batArmy2.getTroopHp();
            if (!realdamage2) {
              troopHp2[j3] = troopHp2[j3] - ((damage2 < 0) ? 0 : damage2);
              reduce2 += (damage2 < 0) ? 0 : damage2;
            } 
          } 
          roundInfo.battleMsg.append(batArmy2.getPosition()).append(",").append(damage2).append(",").append(batArmy2.getTroopHp()[0]).append(",0,0*");
          CampArmy campArmy22 = defendCa2;
          campArmy22.armyHpLoss += reduce2;
          PlayerInfo pi2 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defendCa2.getPlayerId()));
          if (pi2 != null) {
            PlayerInfo playerInfo17 = pi2, playerInfo3 = playerInfo17;
            playerInfo17.lostTotal += reduce2;
          } 
          if (defendCa2.isBarPhantom) {
            CampArmy campArmy23 = attCamp;
            campArmy23.barbarainHpKill += reduce2;
          } 
          CampArmy campArmy24 = attCamp;
          campArmy24.armyHpKill += reduce2;
          if (!realdamage2) {
            roundInfo.defBeiDongLost += reduce2;
            PlayerInfo piA2 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(attCamp.getPlayerId()));
            if (piA2 != null) {
              PlayerInfo playerInfo18 = piA2, playerInfo4 = playerInfo18;
              playerInfo18.killTotal += reduce2;
            } 
            if (bat.getDefBaseInfo().getNum() < reduce2)
              ErrorSceneLog.getInstance().appendErrorMsg("Builder AfterRound def 兵力小于0,builder7737行"); 
            bat.getDefBaseInfo().setNum(bat.getDefBaseInfo().getNum() - reduce2);
          } 
          if (batArmy2.getTroopHp()[0] <= 0) {
            roundInfo.defKilledList.add(batArmy2);
            roundInfo.needreport47 = true;
          } 
        } 
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (attCamp.carBreak && defCamp.getEpicLevel() > 0) {
      attCamp.setCarBreak(false);
      if (listA.isEmpty() || attalldie)
        return needexefight; 
      roundInfo.battleMsg.append("127|att|");
      boolean zhaoyunchidiao3 = false;
      for (int k = 0; k < 4 && k < listA.size(); k++) {
        BattleArmy batArmy2 = listA.get(k);
        if (batArmy2.getTroopHp()[0] > 0) {
          CampArmy defendCa2 = batArmy2.getCampArmy();
          int damage2 = defCamp.attEffect - defendCa2.defEffect + defCamp.TACTIC_ATT - defendCa2.TACTIC_DEF;
          if (damage2 < 1000)
            damage2 = 1000; 
          if (damage2 > batArmy2.getTroopHp()[0])
            damage2 = batArmy2.getTroopHp()[0]; 
          if (k == listA.size() - 1 && damage2 >= batArmy2.getTroopHp()[0])
            damage2 = batArmy2.getTroopHp()[0] - 1; 
          if (zhaoyunchidiao3) {
            damage2 = 1;
          } else if (defendCa2.getChiZhanFa() > 0) {
            zhaoyunchidiao3 = true;
          } 
          int reduce2 = 0;
          if (damage2 < 0)
            damage2 = 1; 
          boolean realdamage2 = false;
          if (batArmy2.getHaveZhanChe() && batArmy2.getHuJia() > 0 && damage2 > 0) {
            damage2 = defendCa2.getNaijiu();
            batArmy2.setHuJia(batArmy2.getHuJia() - defendCa2.naijiu);
          } else if (batArmy2.getCatapultSkill() > 1 && batArmy2.getZCdunHp() > 0 && damage2 > 0) {
            damage2 = defendCa2.getNaijiu();
            batArmy2.setZCdunHp(batArmy2.getZCdunHp() - damage2);
          } else if (batArmy2.getShield() > 0 && damage2 > 0) {
            if (batArmy2.getShiledType() == 2) {
              if (batArmy2.getZhanchedun() > 0) {
                damage2 = defendCa2.getNaijiu();
              } else {
                damage2 = -1;
              } 
            } else {
              damage2 = batArmy2.getShield();
              realdamage2 = true;
            } 
            batArmy2.setShield(batArmy2.getShield() - ((damage2 < 0) ? 0 : damage2));
          } 
          for (int j3 = 0; j3 < (batArmy2.getTroopHp()).length; j3++) {
            int[] troopHp2 = batArmy2.getTroopHp();
            if (!realdamage2) {
              troopHp2[j3] = troopHp2[j3] - ((damage2 < 0) ? 0 : damage2);
              reduce2 += (damage2 < 0) ? 0 : damage2;
            } 
          } 
          roundInfo.battleMsg.append(batArmy2.getPosition()).append(",").append(damage2).append(",").append(batArmy2.getTroopHp()[0]).append(",0,0;");
          CampArmy campArmy25 = defendCa2;
          campArmy25.armyHpLoss += reduce2;
          if (!realdamage2)
            roundInfo.attBeiDongLost += reduce2; 
          PlayerInfo pi2 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defendCa2.getPlayerId()));
          if (pi2 != null) {
            PlayerInfo playerInfo19 = pi2, playerInfo3 = playerInfo19;
            playerInfo19.lostTotal += reduce2;
          } 
          if (defendCa2.isBarPhantom) {
            CampArmy campArmy26 = defCamp;
            campArmy26.barbarainHpKill += reduce2;
          } 
          CampArmy campArmy27 = defCamp;
          campArmy27.armyHpKill += reduce2;
          PlayerInfo piA2 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defCamp.getPlayerId()));
          if (piA2 != null) {
            PlayerInfo playerInfo20 = piA2, playerInfo4 = playerInfo20;
            playerInfo20.killTotal += reduce2;
          } 
          if (bat.getAttBaseInfo().getNum() < reduce2)
            ErrorSceneLog.getInstance().appendErrorMsg("Builder AfterRound att 兵力小于0,builder 7657行"); 
          if (!realdamage2)
            bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - reduce2); 
          if (batArmy2.getTroopHp()[0] <= 0) {
            roundInfo.attKilledList.add(batArmy2);
            roundInfo.needreport47 = true;
          } 
        } 
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (defCamp.carBreak && attCamp.getEpicLevel() > 0) {
      defCamp.setCarBreak(false);
      if (listB.isEmpty() || defalldie)
        return needexefight; 
      roundInfo.battleMsg.append("127|def|");
      boolean zhaoyunchidiao3 = false;
      for (int k = 0; k < 4 && k < listB.size(); k++) {
        BattleArmy batArmy2 = listB.get(k);
        if (batArmy2.getTroopHp()[0] > 0) {
          CampArmy defendCa2 = batArmy2.getCampArmy();
          int damage2 = attCamp.attEffect - defendCa2.defEffect + attCamp.TACTIC_ATT - defendCa2.TACTIC_DEF;
          if (damage2 < 1000)
            damage2 = 1000; 
          if (damage2 > batArmy2.getTroopHp()[0])
            damage2 = batArmy2.getTroopHp()[0]; 
          if (k == listB.size() - 1 && damage2 >= batArmy2.getTroopHp()[0])
            damage2 = batArmy2.getTroopHp()[0] - 1; 
          if (zhaoyunchidiao3) {
            damage2 = 1;
          } else if (defendCa2.getChiZhanFa() > 0) {
            zhaoyunchidiao3 = true;
          } 
          int reduce2 = 0;
          if (damage2 < 0)
            damage2 = 1; 
          boolean realdamage2 = false;
          if (batArmy2.getHaveZhanChe() && batArmy2.getHuJia() > 0 && damage2 > 0) {
            damage2 = defendCa2.getNaijiu();
            batArmy2.setHuJia(batArmy2.getHuJia() - defendCa2.naijiu);
          } else if (batArmy2.getCatapultSkill() > 1 && batArmy2.getZCdunHp() > 0 && damage2 > 0) {
            damage2 = defendCa2.getNaijiu();
            batArmy2.setZCdunHp(batArmy2.getZCdunHp() - damage2);
          } else if (batArmy2.getShield() > 0 && damage2 > 0) {
            if (batArmy2.getShiledType() == 2) {
              if (batArmy2.getZhanchedun() > 0) {
                damage2 = defendCa2.getNaijiu();
              } else {
                damage2 = -1;
              } 
            } else {
              damage2 = batArmy2.getShield();
              realdamage2 = true;
            } 
            batArmy2.setShield(batArmy2.getShield() - ((damage2 < 0) ? 0 : damage2));
          } 
          for (int j3 = 0; j3 < (batArmy2.getTroopHp()).length; j3++) {
            int[] troopHp2 = batArmy2.getTroopHp();
            if (!realdamage2) {
              troopHp2[j3] = troopHp2[j3] - ((damage2 < 0) ? 0 : damage2);
              reduce2 += (damage2 < 0) ? 0 : damage2;
            } 
          } 
          roundInfo.battleMsg.append(batArmy2.getPosition()).append(",").append(damage2).append(",").append(batArmy2.getTroopHp()[0]).append(",0,0;");
          CampArmy campArmy28 = defendCa2;
          campArmy28.armyHpLoss += reduce2;
          PlayerInfo pi2 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defendCa2.getPlayerId()));
          if (pi2 != null) {
            PlayerInfo playerInfo21 = pi2, playerInfo3 = playerInfo21;
            playerInfo21.lostTotal += reduce2;
          } 
          if (defendCa2.isBarPhantom) {
            CampArmy campArmy29 = attCamp;
            campArmy29.barbarainHpKill += reduce2;
          } 
          CampArmy campArmy30 = attCamp;
          campArmy30.armyHpKill += reduce2;
          if (!realdamage2) {
            roundInfo.defBeiDongLost += reduce2;
            PlayerInfo piA2 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(attCamp.getPlayerId()));
            if (piA2 != null) {
              PlayerInfo playerInfo22 = piA2, playerInfo4 = playerInfo22;
              playerInfo22.killTotal += reduce2;
            } 
            if (bat.getDefBaseInfo().getNum() < reduce2)
              ErrorSceneLog.getInstance().appendErrorMsg("Builder AfterRound def 兵力小于0,builder7737行"); 
            bat.getDefBaseInfo().setNum(bat.getDefBaseInfo().getNum() - reduce2);
          } 
          if (batArmy2.getTroopHp()[0] <= 0) {
            roundInfo.defKilledList.add(batArmy2);
            roundInfo.needreport47 = true;
          } 
        } 
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 3000;
    } 
    for (BattleArmy tempbatArmy2 : listA) {
      if (tempbatArmy2.getTroopHp()[0] > 0) {
        attalldie = false;
        break;
      } 
    } 
    for (BattleArmy tempbatArmy2 : listB) {
      if (tempbatArmy2.getTroopHp()[0] > 0) {
        defalldie = false;
        break;
      } 
    } 
    if (attCamp.zbtimes >= 5 && attCamp.zballtimes > 0 && !defalldie && attCamp.armyHpLoss < attCamp.armyHpOrg) {
      attCamp.zbtimes = 0;
      int killrow = 0;
      int chayirow = attCamp.tenzhenbao - defCamp.tenzhenbao;
      if (chayirow >= 7) {
        killrow = 3;
      } else if (chayirow >= 4) {
        killrow = 2;
      } else {
        killrow = 1;
      } 
      int rows = bat.defList.size();
      if (killrow > rows)
        killrow = rows; 
      if (killrow > 0) {
        roundInfo.battleMsg.append("51|att*liuqiuwang*1*");
        boolean zhaoyunchidiao4 = false;
        boolean attmeisha = true;
        boolean attssxandmm = false;
        for (int jishu = 0, l = 0; l < listB.size() && jishu < killrow; l++) {
          BattleArmy batArmy3 = listB.get(l);
          if (batArmy3.getTroopHp()[0] > 0) {
            jishu++;
            int reduce3 = 0;
            CampArmy defendCa3 = batArmy3.getCampArmy();
            int damage3 = batArmy3.getTroopHp()[0];
            if (l == listB.size() - 1)
              damage3 = batArmy3.getTroopHp()[0] - 1; 
            if (batArmy3.getCampArmy().getGeneralId() == 73051 || batArmy3.getCampArmy().getIsBeatMonster() > 0 || (batArmy3.getCampArmy().getGeneralId() == 232 && batArmy3.getCampArmy().getUnionRank() > 0) || batArmy3.getCampArmy().getLegendEvoke()) {
              damage3 = attCamp.attEffect - defendCa3.defEffect + attCamp.TACTIC_ATT - defendCa3.TACTIC_DEF;
              if (damage3 <= 0)
                damage3 = 1; 
            } 
            if (defendCa3.generalId == 204 && defendCa3.isjuexing > 0)
              damage3 = damage3 * 5 / 10; 
            if (batArmy3.getHuShou() > 0)
              attssxandmm = true; 
            if (attssxandmm)
              damage3 = 1; 
            if (zhaoyunchidiao4) {
              damage3 = 1;
            } else if (defendCa3.getChiZhanFa() > 0) {
              damage3 *= rows - l;
              zhaoyunchidiao4 = true;
            } 
            if (damage3 > batArmy3.getTroopHp()[0])
              damage3 = batArmy3.getTroopHp()[0]; 
            boolean realdamage3 = false;
            if (batArmy3.getHaveZhanChe() && batArmy3.getHuJia() > 0 && damage3 > 0) {
              damage3 = batArmy3.getHuJia();
              batArmy3.setHuJia(0);
            } else if (batArmy3.getCatapultSkill() > 1 && batArmy3.getZCdunHp() > 0 && damage3 > 0) {
              damage3 = batArmy3.getZCdunHp();
              batArmy3.setZCdunHp(0);
            } else if (batArmy3.getShield() > 0 && damage3 > 0) {
              if (batArmy3.getShiledType() == 2) {
                if (batArmy3.getZhanchedun() > 0) {
                  damage3 = batArmy3.getShield();
                } else {
                  damage3 = -1;
                } 
              } else {
                damage3 = batArmy3.getShield();
                if (damage3 > 20000)
                  damage3 = 20000; 
                realdamage3 = true;
              } 
              batArmy3.setShield(batArmy3.getShield() - ((damage3 < 0) ? 0 : damage3));
            } 
            if (batArmy3.getCampArmy().getGeneralId() == 204 && batArmy3.getCampArmy().getLegendEvoke() && batArmy3.getCampArmy().getChapterId() > 7 && batArmy3.getCampArmy().getZyMaxRow())
              damage3 = 0; 
            for (int j4 = 0; j4 < (batArmy3.getTroopHp()).length; j4++) {
              int[] troopHp3 = batArmy3.getTroopHp();
              if (!realdamage3) {
                troopHp3[j4] = troopHp3[j4] - ((damage3 < 0) ? 0 : damage3);
                reduce3 += (damage3 < 0) ? 0 : damage3;
              } 
            } 
            roundInfo.battleMsg.append(batArmy3.getPosition()).append(",").append(damage3).append(",").append(batArmy3.getTroopHp()[0]).append(",0,0;");
            attmeisha = false;
            CampArmy campArmy31 = defendCa3;
            campArmy31.armyHpLoss += reduce3;
            if (!realdamage3)
              roundInfo.defBeiDongLost += reduce3; 
            if (batArmy3.getTroopHp()[0] <= 0) {
              roundInfo.defKilledList.add(batArmy3);
              roundInfo.needreport47 = true;
            } 
            PlayerInfo pi3 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defendCa3.getPlayerId()));
            if (pi3 != null) {
              PlayerInfo playerInfo23 = pi3, playerInfo5 = playerInfo23;
              playerInfo23.lostTotal += reduce3;
            } 
            if (defendCa3.isBarPhantom) {
              CampArmy campArmy32 = attCamp;
              campArmy32.barbarainHpKill += reduce3;
            } 
            CampArmy campArmy33 = attCamp;
            campArmy33.armyHpKill += reduce3;
            PlayerInfo piA3 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(attCamp.getPlayerId()));
            if (piA3 != null) {
              PlayerInfo playerInfo24 = piA3, playerInfo6 = playerInfo24;
              playerInfo24.killTotal += reduce3;
            } 
            if (bat.getDefBaseInfo().getNum() < reduce3)
              ErrorSceneLog.getInstance().appendErrorMsg("builder beidongjineng def兵力小于0,builder 7825行"); 
            if (!realdamage3)
              bat.getDefBaseInfo().setNum(bat.getDefBaseInfo().getNum() - reduce3); 
          } 
        } 
        if (attmeisha)
          roundInfo.battleMsg.append("null;"); 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.zbtimes >= 5 && defCamp.zballtimes > 0 && !attalldie && defCamp.armyHpLoss < defCamp.armyHpOrg) {
      defCamp.zbtimes = 0;
      int killrow = 0;
      int chayirow = defCamp.tenzhenbao - attCamp.tenzhenbao;
      if (chayirow >= 7) {
        killrow = 3;
      } else if (chayirow >= 4) {
        killrow = 2;
      } else {
        killrow = 1;
      } 
      int rows = bat.attList.size();
      if (killrow > rows)
        killrow = rows; 
      if (killrow > 0) {
        roundInfo.battleMsg.append("51|def*liuqiuwang*1*");
        boolean zhaoyunchidiao4 = false;
        boolean defmeisha = true;
        boolean defssxandmm = false;
        for (int jishu = 0, l = 0; l < listA.size() && jishu < killrow; l++) {
          BattleArmy batArmy3 = listA.get(l);
          CampArmy attCa = batArmy3.getCampArmy();
          if (batArmy3.getTroopHp()[0] > 0) {
            jishu++;
            int reduce4 = 0;
            int damage3 = batArmy3.getTroopHp()[0];
            if (l == listA.size() - 1)
              damage3 = batArmy3.getTroopHp()[0] - 1; 
            if (batArmy3.getCampArmy().getGeneralId() == 73051 || batArmy3.getCampArmy().getIsBeatMonster() > 0 || (batArmy3.getCampArmy().getGeneralId() == 232 && batArmy3.getCampArmy().getUnionRank() > 0) || batArmy3.getCampArmy().getLegendEvoke()) {
              damage3 = defCamp.attEffect - (batArmy3.getCampArmy()).defEffect + defCamp.TACTIC_ATT - (batArmy3.getCampArmy()).TACTIC_DEF;
              if (damage3 <= 0)
                damage3 = 1; 
            } 
            if (batArmy3.getHuShou() > 0)
              defssxandmm = true; 
            if (defssxandmm)
              damage3 = 1; 
            if (attCa.generalId == 204 && attCa.isjuexing > 0)
              damage3 = damage3 * 5 / 10; 
            if (zhaoyunchidiao4) {
              damage3 = 1;
            } else if (attCa.getChiZhanFa() > 0) {
              damage3 *= rows - l;
              zhaoyunchidiao4 = true;
            } 
            if (damage3 > batArmy3.getTroopHp()[0])
              damage3 = batArmy3.getTroopHp()[0]; 
            boolean realdamage3 = false;
            if (batArmy3.getHaveZhanChe() && batArmy3.getHuJia() > 0 && damage3 > 0) {
              damage3 = batArmy3.getHuJia();
              batArmy3.setHuJia(0);
            } else if (batArmy3.getCatapultSkill() > 1 && batArmy3.getZCdunHp() > 0 && damage3 > 0) {
              damage3 = batArmy3.getZCdunHp();
              batArmy3.setZCdunHp(0);
            } else if (batArmy3.getShield() > 0 && damage3 > 0) {
              if (batArmy3.getShiledType() == 2) {
                if (batArmy3.getZhanchedun() > 0) {
                  damage3 = batArmy3.getShield();
                } else {
                  damage3 = -1;
                } 
              } else {
                damage3 = batArmy3.getShield();
                if (damage3 > 20000)
                  damage3 = 20000; 
                realdamage3 = true;
              } 
              batArmy3.setShield(batArmy3.getShield() - ((damage3 < 0) ? 0 : damage3));
            } 
            if (batArmy3.getCampArmy().getGeneralId() == 204 && batArmy3.getCampArmy().getLegendEvoke() && batArmy3.getCampArmy().getChapterId() > 7 && batArmy3.getCampArmy().getZyMaxRow())
              damage3 = 0; 
            for (int j4 = 0; j4 < (batArmy3.getTroopHp()).length; j4++) {
              int[] troopHp3 = batArmy3.getTroopHp();
              if (!realdamage3) {
                troopHp3[j4] = troopHp3[j4] - ((damage3 < 0) ? 0 : damage3);
                reduce4 += (damage3 < 0) ? 0 : damage3;
              } 
            } 
            roundInfo.battleMsg.append(batArmy3.getPosition()).append(",").append(damage3).append(",").append(batArmy3.getTroopHp()[0]).append(",0,0;");
            defmeisha = false;
            CampArmy campArmy34 = attCa;
            campArmy34.armyHpLoss += reduce4;
            if (!realdamage3)
              roundInfo.attBeiDongLost += reduce4; 
            if (batArmy3.getTroopHp()[0] <= 0) {
              roundInfo.attKilledList.add(batArmy3);
              roundInfo.needreport47 = true;
            } 
            PlayerInfo pi3 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(attCa.getPlayerId()));
            if (pi3 != null) {
              PlayerInfo playerInfo25 = pi3, playerInfo5 = playerInfo25;
              playerInfo25.lostTotal += reduce4;
            } 
            if (attCa.isBarPhantom) {
              CampArmy campArmy35 = defCamp;
              campArmy35.barbarainHpKill += reduce4;
            } 
            CampArmy campArmy36 = defCamp;
            campArmy36.armyHpKill += reduce4;
            PlayerInfo piA3 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defCamp.getPlayerId()));
            if (piA3 != null) {
              PlayerInfo playerInfo26 = piA3, playerInfo6 = playerInfo26;
              playerInfo26.killTotal += reduce4;
            } 
            if (!realdamage3)
              bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - reduce4); 
          } 
        } 
        if (defmeisha)
          roundInfo.battleMsg.append("null;"); 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (roundInfo.attCampArmy.armyHpLoss >= roundInfo.attCampArmy.armyHpOrg)
      roundInfo.killAttG = true; 
    if (roundInfo.defCampArmy.armyHpLoss >= roundInfo.defCampArmy.armyHpOrg)
      roundInfo.killDefG = true; 
    return needexefight;
  }
  
  public boolean checkArrowAttack(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    boolean firstrowkilled = false;
    int maxcd = 12;
    int towertype = 1;
    City city = dataGetter.getCityDao().read(bat.getDefBaseInfo().getId());
    if (city != null && city.getTowerType().intValue() > 0 && city.getTowerHp().intValue() > 0) {
      towertype = city.getTowerType().intValue();
      if (towertype == 2) {
        maxcd = 10;
      } else if (towertype == 3) {
        maxcd = 9;
      } 
      int jianshao = city.getTowerHp().intValue() / 20;
      if (jianshao >= 5)
        jianshao = 4; 
      maxcd -= jianshao;
      int shengyu = bat.getRoundNum().get() % maxcd;
      if (bat.pohuai) {
        bat.pohuai = false;
        int oldhp = city.getTowerHp().intValue() - 10;
        if (oldhp < 0)
          oldhp = 0; 
        dataGetter.getCityDao().updateTowerHp(city.getId().intValue(), oldhp);
        JsonDocument doc1 = new JsonDocument();
        doc1.startObject();
        doc1.createElement("cityId", city.getId());
        doc1.createElement("durability", Integer.valueOf(oldhp));
        doc1.endObject();
        Group group = GroupManager.getInstance().getGroup(ChatType.WORLD.toString());
        if (group != null) {
          byte[] bytes = JsonBuilder.getJson(JsonBuilder.getJson(State.PUSH, PushCommand.PUSH_BATTLETOWER.getModule(), doc1.toByte()));
          group.notify(null, WrapperUtil.wrapper(PushCommand.PUSH_BATTLETOWER.getCommand(), 0, bytes));
        } 
      } else if (shengyu == 0 || bat.paoji) {
        firstrowkilled = ArrowTowerAttack(dataGetter, bat, roundInfo, maxcd, towertype);
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    return firstrowkilled;
  }
  
  public boolean ArrowTowerAttack(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo, int maxcd, int towertype) {
    CampArmy attCamp = roundInfo.attCampArmy;
    CampArmy defCamp = roundInfo.defCampArmy;
    boolean firstrowkilled = true;
    List<BattleArmy> listB = bat.attList;
    int rows = listB.size();
    if (rows <= 0)
      return firstrowkilled; 
    boolean ispaoji = bat.getPaoJi();
    if (ispaoji) {
      bat.setPaoJi(false);
      roundInfo.battleMsg.append(35).append("|").append(bat.getPaoJiName()).append("|6|");
    } else {
      roundInfo.battleMsg.append(32).append("|").append(0).append("|");
    } 
    double bili = 0.3D;
    if (towertype == 2) {
      bili = 0.4D;
    } else if (towertype == 3) {
      bili = 0.5D;
    } 
    for (int i = 0; i < rows; i++) {
      int reduce = 0;
      BattleArmy batArmy = listB.get(i);
      CampArmy defendCa = batArmy.getCampArmy();
      roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
      int damage = Double.valueOf(batArmy.getTroopHp()[0] * bili).intValue();
      if (ispaoji)
        damage = batArmy.getTroopHp()[0] - 1; 
      if (damage >= batArmy.getTroopHp()[0])
        damage = batArmy.getTroopHp()[0] - 1; 
      boolean realdamage = false;
      if (batArmy.getHaveZhanChe() && batArmy.getHuJia() > 0 && damage > 0) {
        if (defendCa.getCarId() > 87000) {
          damage = defendCa.getNaijiu() * 5;
          if (damage > batArmy.getHuJia())
            damage = batArmy.getHuJia(); 
          batArmy.setHuJia(batArmy.getHuJia() - damage);
        } else {
          damage = batArmy.getHuJia();
          batArmy.setHuJia(0);
        } 
      } else if (batArmy.getCatapultSkill() > 1 && batArmy.getZCdunHp() > 0 && damage > 0) {
        damage = batArmy.getZCdunHp();
        if (defendCa.getCarId() > 87000) {
          damage = defendCa.getNaijiu() * 5;
          if (damage > batArmy.getZCdunHp())
            damage = batArmy.getZCdunHp(); 
        } 
        batArmy.setZCdunHp(batArmy.getZCdunHp() - damage);
      } else if (batArmy.getShield() > 0 && damage > 0) {
        if (batArmy.getShiledType() == 2) {
          damage = batArmy.getShield();
          batArmy.setShield(0);
        } else {
          damage = batArmy.getShield();
          if (damage > 20000)
            damage = 20000; 
          batArmy.setShield(batArmy.getShield() - damage);
          realdamage = true;
        } 
      } 
      for (int j2 = 0; j2 < (batArmy.getTroopHp()).length; j2++) {
        int[] troopHp = batArmy.getTroopHp();
        if (!realdamage) {
          troopHp[j2] = troopHp[j2] - ((damage < 0) ? 0 : damage);
          reduce += (damage < 0) ? 0 : damage;
        } 
        roundInfo.battleMsg.append(damage).append("*").append(troopHp[j2]).append(",");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), ";");
      CampArmy campArmy = defendCa;
      campArmy.armyHpLoss += reduce;
      if (!realdamage)
        roundInfo.attBeiDongLost += reduce; 
      if (batArmy.getTroopHp()[0] <= 0) {
        roundInfo.attKilledList.add(batArmy);
        if (i == 0) {
          firstrowkilled = true;
          roundInfo.attFirstRowKilled = true;
          roundInfo.win = 2;
        } 
      } 
      PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defendCa.getPlayerId()));
      if (pi != null) {
        PlayerInfo playerInfo3 = pi, playerInfo = playerInfo3;
        playerInfo3.lostTotal += reduce;
      } 
      if (defendCa.isBarPhantom) {
        CampArmy campArmy2 = defCamp;
        campArmy2.barbarainHpKill += reduce;
      } 
      CampArmy campArmy3 = defCamp;
      campArmy3.armyHpKill += reduce;
      PlayerInfo piA = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defCamp.getPlayerId()));
      if (piA != null) {
        PlayerInfo playerInfo4 = piA, playerInfo2 = playerInfo4;
        playerInfo4.killTotal += reduce;
      } 
      if (!realdamage)
        bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - reduce); 
    } 
    roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
    getReportType16(dataGetter, bat, roundInfo.battleMsg, roundInfo.attCampArmy, "att", false, false);
    roundInfo.battleMsg.append("30|-1|-1#31|").append(roundInfo.win).append("#");
    return firstrowkilled;
  }
  
  public boolean luanshixiaoxiong(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    CampArmy attCamp = roundInfo.attCampArmy;
    CampArmy defCamp = roundInfo.defCampArmy;
    boolean attLoss = false;
    boolean defLoss = false;
    boolean firstRowkilled = false;
    boolean caocaoatt = (attCamp.getGeneralId() == 107 && attCamp.getIsJuexing() > 0 && attCamp.getLuanShi() < 4 && attCamp.getSneer() <= 0);
    boolean caocaodef = (defCamp.getGeneralId() == 107 && defCamp.getIsJuexing() > 0 && defCamp.getLuanShi() < 4 && defCamp.getSneer() <= 0);
    if (caocaoatt && caocaodef)
      return firstRowkilled; 
    if (caocaoatt) {
      CampArmy campArmy, campArmy2, campArmy3, campArmy4;
      int qdchenggong = 0;
      String info = "0";
      switch (attCamp.getLuanShi()) {
        case 0:
          if (defCamp.getZbAllTimes() > 0) {
            qdchenggong = 1;
            defCamp.setZbAllTimes(0);
            defCamp.setZbAllRobed(1);
            if (attCamp.getZbAllTimes() < 0) {
              attCamp.setZbAllTimes(5);
              attCamp.setZbTimes(0);
            } 
          } 
          campArmy = attCamp;
          campArmy.luanshi++;
          info = "1";
          break;
        case 1:
          if (defCamp.getJiuZhenbao() > 0) {
            qdchenggong = 2;
            defCamp.setJiuZhenbao(0);
            defCamp.setzfShield(0);
            roundInfo.defBattleArmy.setZfShiled(0);
            if (attCamp.getzfShield() <= 0) {
              attCamp.setJiuZhenbao(1);
              attCamp.setzfShield(2);
              roundInfo.attBattleArmy.setZfShiled(2);
            } 
          } 
          campArmy2 = attCamp;
          campArmy2.luanshi++;
          info = "1:1";
          break;
        case 2:
          if (defCamp.getPingKan() > 0) {
            qdchenggong = 3;
            if (defCamp.getPingKan() > attCamp.getPingKan())
              attCamp.setPingKan(defCamp.getPingKan()); 
            defCamp.setPingKan(0);
          } 
          if (defCamp.getPingKanDef() > 0) {
            qdchenggong = 3;
            if (defCamp.getPingKanDef() > attCamp.getPingKanDef())
              attCamp.setPingKanDef(defCamp.getPingKanDef()); 
            defCamp.setPingKanDef(0);
          } 
          if (defCamp.getYcbwHujia() > 0) {
            qdchenggong = 3;
            if (defCamp.getYcbwHujia() > attCamp.getYcbwHujia())
              attCamp.setYcbwHujia(defCamp.getYcbwHujia()); 
            defCamp.setYcbwHujia(0);
          } 
          if (defCamp.getYcbwPojia() > 0) {
            qdchenggong = 3;
            if (defCamp.getYcbwPojia() > attCamp.getYcbwPojia())
              attCamp.setYcbwPojia(defCamp.getYcbwPojia()); 
            defCamp.setYcbwPojia(0);
          } 
          if (defCamp.getKaiShan() > 0) {
            qdchenggong = 3;
            if (defCamp.getKaiShan() > attCamp.getKaiShan()) {
              attCamp.setKaiShan(defCamp.getKaiShan());
              roundInfo.attBattleArmy.setKaiShan(defCamp.getKaiShan());
            } 
            defCamp.setKaiShan(0);
            roundInfo.defBattleArmy.setKaiShan(0);
          } 
          if (defCamp.getDingJun() > 0) {
            qdchenggong = 3;
            if (defCamp.getDingJun() > attCamp.getDingJun())
              attCamp.setDingJun(defCamp.getDingJun()); 
            defCamp.setDingJun(0);
          } 
          if (defCamp.getZhanFaBiLi() > 0) {
            qdchenggong = 3;
            if (defCamp.getZhanFaBiLi() > attCamp.getZhanFaBiLi())
              attCamp.setZhanFaBiLi(defCamp.getZhanFaBiLi()); 
            defCamp.setZhanFaBiLi(0);
          } 
          if (qdchenggong > 0 && attCamp.getYbTx().equals(""))
            attCamp.setYbTx(defCamp.getYbTx()); 
          campArmy3 = attCamp;
          campArmy3.luanshi++;
          info = "1:1:1";
          break;
        case 3:
          qdchenggong = 4;
          if (defCamp.getLeader() > attCamp.getLeader())
            attCamp.setLeader(defCamp.getLeader()); 
          if (defCamp.getStrength() > attCamp.getStrength())
            attCamp.setStrength(defCamp.getStrength()); 
          campArmy4 = attCamp;
          campArmy4.luanshi++;
          info = "1:1:1:1";
          break;
      } 
      BattleArmy defbta = roundInfo.defBattleArmy;
      int damage = Double.valueOf((defCamp.getArmyHpOrg() / 18) * 0.2D).intValue();
      if (defCamp.getGeneralId() == 73051 || defCamp.getIsBeatMonster() > 0 || (defCamp.getGeneralId() == 232 && defCamp.getUnionRank() > 0) || defCamp.getLegendEvoke()) {
        damage = attCamp.attEffect - defCamp.defEffect + attCamp.TACTIC_ATT - defCamp.TACTIC_DEF;
        if (damage <= 0)
          damage = 1; 
      } 
      if (qdchenggong <= 0)
        damage *= 2; 
      if (damage < 0)
        damage = 1; 
      int xinlost = damage;
      xinlost = DamageSkill(attCamp, defbta, defbta.getCampArmy(), 1, damage, false, dataGetter, bat, roundInfo, 0);
      if (defbta.getTroopHp()[0] <= 0) {
        firstRowkilled = true;
        roundInfo.defFirstRowKilled = true;
        roundInfo.win = 1;
      } 
      roundInfo.battleMsg.append(54).append("|").append("att").append(";").append(64).append(";0;").append(attCamp.getGeneralPic()).append(";").append(defbta.getPosition()).append(",").append(xinlost).append(",").append(defbta.getTroopHp()[0]).append(",0,0#");
      StringBuilder caocaoinfo = new StringBuilder();
      caocaoinfo.append("65|5,").append(qdchenggong).append(",").append(info).append(",4;null#");
      roundInfo.caocaostr = caocaoinfo;
      roundInfo.nextMinExeTime += 3000;
    } 
    if (caocaodef) {
      CampArmy campArmy5, campArmy6, campArmy7, campArmy8;
      int qdchenggong = 0;
      String info = "0";
      switch (defCamp.getLuanShi()) {
        case 0:
          if (attCamp.getZbAllTimes() > 0) {
            qdchenggong = 1;
            attCamp.setZbAllTimes(0);
            attCamp.setZbAllRobed(1);
            if (defCamp.getZbAllTimes() < 0) {
              defCamp.setZbAllTimes(5);
              defCamp.setZbTimes(0);
            } 
          } 
          campArmy5 = defCamp;
          campArmy5.luanshi++;
          info = "1";
          break;
        case 1:
          if (attCamp.getJiuZhenbao() > 0) {
            qdchenggong = 2;
            attCamp.setJiuZhenbao(0);
            attCamp.setzfShield(0);
            roundInfo.attBattleArmy.setZfShiled(0);
            if (defCamp.getzfShield() <= 0) {
              defCamp.setJiuZhenbao(1);
              defCamp.setzfShield(2);
              roundInfo.defBattleArmy.setZfShiled(2);
            } 
          } 
          campArmy6 = defCamp;
          campArmy6.luanshi++;
          info = "1:1";
          break;
        case 2:
          if (attCamp.getPingKan() > 0) {
            qdchenggong = 3;
            if (attCamp.getPingKan() > defCamp.getPingKan())
              defCamp.setPingKan(attCamp.getPingKan()); 
            attCamp.setPingKan(0);
          } 
          if (attCamp.getPingKanDef() > 0) {
            qdchenggong = 3;
            if (attCamp.getPingKanDef() > defCamp.getPingKanDef())
              defCamp.setPingKanDef(attCamp.getPingKanDef()); 
            attCamp.setPingKanDef(0);
          } 
          if (attCamp.getYcbwHujia() > 0) {
            qdchenggong = 3;
            if (attCamp.getYcbwHujia() > defCamp.getYcbwHujia())
              defCamp.setYcbwHujia(attCamp.getYcbwHujia()); 
            attCamp.setYcbwHujia(0);
          } 
          if (attCamp.getYcbwPojia() > 0) {
            qdchenggong = 3;
            if (attCamp.getYcbwPojia() > defCamp.getYcbwPojia())
              defCamp.setYcbwPojia(attCamp.getYcbwPojia()); 
            attCamp.setYcbwPojia(0);
          } 
          if (attCamp.getKaiShan() > 0) {
            qdchenggong = 3;
            if (attCamp.getKaiShan() > defCamp.getKaiShan()) {
              defCamp.setKaiShan(attCamp.getKaiShan());
              roundInfo.defBattleArmy.setKaiShan(attCamp.getKaiShan());
            } 
            attCamp.setKaiShan(0);
            roundInfo.attBattleArmy.setKaiShan(0);
          } 
          if (attCamp.getDingJun() > 0) {
            qdchenggong = 3;
            if (attCamp.getDingJun() > defCamp.getDingJun())
              defCamp.setDingJun(attCamp.getDingJun()); 
            attCamp.setDingJun(0);
          } 
          if (attCamp.getZhanFaBiLi() > 0) {
            qdchenggong = 3;
            if (attCamp.getZhanFaBiLi() > defCamp.getZhanFaBiLi())
              defCamp.setZhanFaBiLi(attCamp.getZhanFaBiLi()); 
            attCamp.setZhanFaBiLi(0);
          } 
          if (qdchenggong > 0 && defCamp.getYbTx().equals(""))
            defCamp.setYbTx(attCamp.getYbTx()); 
          campArmy7 = defCamp;
          campArmy7.luanshi++;
          info = "1:1:1";
          break;
        case 3:
          qdchenggong = 4;
          if (attCamp.getLeader() > defCamp.getLeader())
            defCamp.setLeader(attCamp.getLeader()); 
          if (attCamp.getStrength() > defCamp.getStrength())
            defCamp.setStrength(attCamp.getStrength()); 
          campArmy8 = defCamp;
          campArmy8.luanshi++;
          info = "1:1:1:1";
          break;
      } 
      BattleArmy attbta = roundInfo.attBattleArmy;
      int damage = Double.valueOf((attCamp.getArmyHpOrg() / 18) * 0.2D).intValue();
      if (attbta.getCampArmy().getGeneralId() == 73051 || attbta.getCampArmy().getIsBeatMonster() > 0 || (attbta.getCampArmy().getGeneralId() == 232 && attbta.getCampArmy().getUnionRank() > 0) || attbta.getCampArmy().getLegendEvoke()) {
        damage = defCamp.attEffect - attCamp.defEffect + defCamp.TACTIC_ATT - attCamp.TACTIC_DEF;
        if (damage <= 0)
          damage = 1; 
      } 
      if (qdchenggong <= 0)
        damage *= 2; 
      if (damage < 0)
        damage = 1; 
      int xinlost = damage;
      xinlost = DamageSkill(defCamp, attbta, attbta.getCampArmy(), 0, damage, false, dataGetter, bat, roundInfo, 0);
      if (attbta.getTroopHp()[0] <= 0) {
        firstRowkilled = true;
        roundInfo.attFirstRowKilled = true;
        roundInfo.win = 2;
      } 
      roundInfo.battleMsg.append(54).append("|").append("def").append(";").append(64).append(";0;").append(attCamp.getGeneralPic()).append(";").append(attbta.getPosition()).append(",").append(xinlost).append(",").append(attbta.getTroopHp()[0]).append(",0,0#");
      StringBuilder caocaoinfo = new StringBuilder();
      caocaoinfo.append("65|null;").append("5,").append(qdchenggong).append(",").append(info).append(",4#");
      roundInfo.caocaostr = caocaoinfo;
      roundInfo.nextMinExeTime += 3000;
    } 
    return firstRowkilled;
  }
  
  public boolean liuguanzhang(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    CampArmy attCamp = roundInfo.attCampArmy;
    CampArmy defCamp = roundInfo.defCampArmy;
    boolean attzhixing = false;
    boolean firstRowkilled = false;
    if (attCamp.getUnionRank() >= 3 && attCamp.getZhanShuXuanZe() >= 3 && attCamp.getHslonghunNum() <= 5 && attCamp.getSneer() <= 0) {
      attCamp.setZhanShuXuanZe(0);
      attzhixing = true;
      roundInfo.battleMsg.append("81|att|");
      for (int i = 0; i < bat.attList.size(); i++) {
        BattleArmy attbattleArmy = bat.attList.get(i);
        if (attbattleArmy.getCampArmy().getId() == attCamp.getId() && 
          attbattleArmy.getTroopHp()[0] > 100) {
          if (attbattleArmy.getHaveZhanChe()) {
            if (attbattleArmy.getHuJia() > 0)
              continue; 
            if (attbattleArmy.getZCdunHp() > 0)
              continue; 
          } 
          if (!attbattleArmy.getHaveZhanChe() || attbattleArmy.getShiledType() != 2 || attbattleArmy.getShield() <= 0) {
            int maxhpadd = attbattleArmy.getCampArmy().getTroopHp() / 3 * 80 / 100;
            int caocaohp = attbattleArmy.getShield();
            if (caocaohp < maxhpadd) {
              int adddun = maxhpadd - caocaohp;
              if (adddun > 0) {
                attbattleArmy.setSpecial(0);
                if (attbattleArmy.getCampArmy().getDefenseDow() > 0) {
                  attbattleArmy.getCampArmy().setDefenseDow(0);
                  attbattleArmy.getCampArmy().setDefenseDown(0.0D);
                } 
                if (attbattleArmy.getSangDanType() > 0)
                  attbattleArmy.setSangDanType(0); 
                if (attbattleArmy.getCampArmy().getAttackLevel() < 0)
                  attbattleArmy.getCampArmy().setAttackLevel(0); 
                if (attbattleArmy.getHuWei() > 0)
                  attbattleArmy.setHuWei(0); 
                if (attbattleArmy.getCardebuff() > 0)
                  attbattleArmy.setCardebuff(0); 
                attbattleArmy.setShield(attbattleArmy.getShield() + adddun);
                attbattleArmy.setMaxShield(attbattleArmy.getShield());
                attbattleArmy.setShiledType(4);
                attCamp.setHslonghunNum(attCamp.getHslonghunNum() + 1);
                roundInfo.battleMsg.append(attbattleArmy.getPosition()).append(",").append(adddun).append(";");
              } 
            } 
          } 
        } 
        continue;
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|0#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (attCamp.getGeneralId() == 416 && attCamp.getChapterId() >= 1 && attCamp.getZhanShuXuanZe() >= 3 && attCamp.getHslonghunNum() <= 5 && attCamp.getSneer() <= 0) {
      attCamp.setZhanShuXuanZe(0);
      attzhixing = true;
      roundInfo.battleMsg.append("81|att|");
      for (int i = 0; i < bat.attList.size(); i++) {
        BattleArmy attbattleArmy = bat.attList.get(i);
        if (attbattleArmy.getCampArmy().getId() == attCamp.getId() && 
          attbattleArmy.getTroopHp()[0] > 100) {
          if (attbattleArmy.getHaveZhanChe()) {
            if (attbattleArmy.getHuJia() > 0)
              continue; 
            if (attbattleArmy.getZCdunHp() > 0)
              continue; 
          } 
          if (!attbattleArmy.getHaveZhanChe() || attbattleArmy.getShiledType() != 2 || attbattleArmy.getShield() <= 0) {
            int maxhpadd = attbattleArmy.getCampArmy().getTroopHp() / 3 * 80 / 100;
            int caocaohp = attbattleArmy.getShield();
            if (caocaohp < maxhpadd) {
              int adddun = maxhpadd - caocaohp;
              if (adddun > 0) {
                attbattleArmy.setSpecial(0);
                if (attbattleArmy.getCampArmy().getDefenseDow() > 0) {
                  attbattleArmy.getCampArmy().setDefenseDow(0);
                  attbattleArmy.getCampArmy().setDefenseDown(0.0D);
                } 
                if (attbattleArmy.getSangDanType() > 0)
                  attbattleArmy.setSangDanType(0); 
                if (attbattleArmy.getCampArmy().getAttackLevel() < 0)
                  attbattleArmy.getCampArmy().setAttackLevel(0); 
                if (attbattleArmy.getHuWei() > 0)
                  attbattleArmy.setHuWei(0); 
                if (attbattleArmy.getCardebuff() > 0)
                  attbattleArmy.setCardebuff(0); 
                attbattleArmy.setShield(attbattleArmy.getShield() + adddun);
                attbattleArmy.setMaxShield(attbattleArmy.getShield());
                attbattleArmy.setShiledType(4);
                attCamp.setHslonghunNum(attCamp.getHslonghunNum() + 1);
                roundInfo.battleMsg.append(attbattleArmy.getPosition()).append(",").append(adddun).append(";");
              } 
            } 
          } 
        } 
        continue;
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|0#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (defCamp.getUnionRank() >= 3 && defCamp.getZhanShuXuanZe() >= 3 && defCamp.getHslonghunNum() <= 5 && defCamp.getSneer() <= 0) {
      defCamp.setZhanShuXuanZe(0);
      attzhixing = true;
      roundInfo.battleMsg.append("81|def|");
      for (int i = 0; i < bat.defList.size(); i++) {
        BattleArmy defbattleArmy = bat.defList.get(i);
        if (defbattleArmy.getCampArmy().getId() == defCamp.getId() && 
          defbattleArmy.getTroopHp()[0] > 100) {
          if (defbattleArmy.getHaveZhanChe()) {
            if (defbattleArmy.getHuJia() > 0)
              continue; 
            if (defbattleArmy.getZCdunHp() > 0)
              continue; 
          } 
          if (!defbattleArmy.getHaveZhanChe() || defbattleArmy.getShiledType() != 2 || defbattleArmy.getShield() <= 0) {
            int maxhpadd = defbattleArmy.getCampArmy().getTroopHp() / 3 * 80 / 100;
            int caocaohp = defbattleArmy.getShield();
            if (caocaohp < maxhpadd) {
              int adddun = maxhpadd - caocaohp;
              if (adddun > 0) {
                defbattleArmy.setSpecial(0);
                if (defbattleArmy.getCampArmy().getDefenseDow() > 0) {
                  defbattleArmy.getCampArmy().setDefenseDow(0);
                  defbattleArmy.getCampArmy().setDefenseDown(0.0D);
                } 
                if (defbattleArmy.getSangDanType() > 0)
                  defbattleArmy.setSangDanType(0); 
                if (defbattleArmy.getCampArmy().getAttackLevel() < 0)
                  defbattleArmy.getCampArmy().setAttackLevel(0); 
                if (defbattleArmy.getHuWei() > 0)
                  defbattleArmy.setHuWei(0); 
                if (defbattleArmy.getCardebuff() > 0)
                  defbattleArmy.setCardebuff(0); 
                defbattleArmy.setShield(defbattleArmy.getShield() + adddun);
                defbattleArmy.setMaxShield(defbattleArmy.getShield());
                defbattleArmy.setShiledType(4);
                defCamp.setHslonghunNum(defCamp.getHslonghunNum() + 1);
                roundInfo.battleMsg.append(defbattleArmy.getPosition()).append(",").append(adddun).append(";");
              } 
            } 
          } 
        } 
        continue;
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|0#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (defCamp.getGeneralId() == 416 && defCamp.getChapterId() >= 1 && defCamp.getZhanShuXuanZe() >= 3 && defCamp.getHslonghunNum() <= 5 && defCamp.getSneer() <= 0) {
      defCamp.setZhanShuXuanZe(0);
      attzhixing = true;
      roundInfo.battleMsg.append("81|def|");
      for (int i = 0; i < bat.defList.size(); i++) {
        BattleArmy defbattleArmy = bat.defList.get(i);
        if (defbattleArmy.getCampArmy().getId() == defCamp.getId() && 
          defbattleArmy.getTroopHp()[0] > 100) {
          if (defbattleArmy.getHaveZhanChe()) {
            if (defbattleArmy.getHuJia() > 0)
              continue; 
            if (defbattleArmy.getZCdunHp() > 0)
              continue; 
          } 
          if (!defbattleArmy.getHaveZhanChe() || defbattleArmy.getShiledType() != 2 || defbattleArmy.getShield() <= 0) {
            int maxhpadd = defbattleArmy.getCampArmy().getTroopHp() / 3 * 80 / 100;
            int caocaohp = defbattleArmy.getShield();
            if (caocaohp < maxhpadd) {
              int adddun = maxhpadd - caocaohp;
              if (adddun > 0) {
                defbattleArmy.setSpecial(0);
                if (defbattleArmy.getCampArmy().getDefenseDow() > 0) {
                  defbattleArmy.getCampArmy().setDefenseDow(0);
                  defbattleArmy.getCampArmy().setDefenseDown(0.0D);
                } 
                if (defbattleArmy.getSangDanType() > 0)
                  defbattleArmy.setSangDanType(0); 
                if (defbattleArmy.getCampArmy().getAttackLevel() < 0)
                  defbattleArmy.getCampArmy().setAttackLevel(0); 
                if (defbattleArmy.getHuWei() > 0)
                  defbattleArmy.setHuWei(0); 
                if (defbattleArmy.getCardebuff() > 0)
                  defbattleArmy.setCardebuff(0); 
                defbattleArmy.setShield(defbattleArmy.getShield() + adddun);
                defbattleArmy.setMaxShield(defbattleArmy.getShield());
                defbattleArmy.setShiledType(4);
                defCamp.setHslonghunNum(defCamp.getHslonghunNum() + 1);
                roundInfo.battleMsg.append(defbattleArmy.getPosition()).append(",").append(adddun).append(";");
              } 
            } 
          } 
        } 
        continue;
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|0#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (attCamp.getUnionRank() >= 2 && attCamp.getZhanShuTuJi() > 1 && !attzhixing && attCamp.getSneer() <= 0) {
      attzhixing = true;
      roundInfo.battleMsg.append("80|def|");
      int range = 5;
      List<BattleArmy> listB = bat.defList;
      if (range > listB.size())
        range = listB.size(); 
      boolean zhaoyunchidiao = false;
      boolean yixue = false;
      int yixuegai = RandomUtils.nextInt(100);
      for (int j = 0; j < range; j++) {
        int reduce = 0;
        BattleArmy batArmy = listB.get(j);
        CampArmy defendCa = batArmy.getCampArmy();
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
        int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (defendCa.playerId < 0 && defendCa.armyName.contains("禁卫军 "))
          damage /= 10; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          damage *= range - j;
          zhaoyunchidiao = true;
        } 
        if (!yixue && yixuegai <= defendCa.getYiXueGaiLv() && j < 3) {
          yixue = true;
          damage = batArmy.getTroopHp()[0] - 1;
        } 
        if (batArmy.getCampArmy().getGeneralId() == 73051 || batArmy.getCampArmy().getIsBeatMonster() > 0 || (batArmy.getCampArmy().getGeneralId() == 232 && batArmy.getCampArmy().getUnionRank() > 0) || batArmy.getCampArmy().getLegendEvoke()) {
          damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 1; 
        } 
        int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, j);
        if (j == 0 && batArmy.getTroopHp()[0] <= 0) {
          firstRowkilled = true;
          roundInfo.defFirstRowKilled = true;
          roundInfo.win = 1;
        } 
        roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|").append(roundInfo.win).append("#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (attCamp.getGeneralId() == 416 && attCamp.getChapterId() >= 3 && attCamp.getZhanShuTuJi() > 1 && !attzhixing && attCamp.getSneer() <= 0) {
      attzhixing = true;
      roundInfo.battleMsg.append("80|def|");
      int range = 5;
      List<BattleArmy> listB = bat.defList;
      if (range > listB.size())
        range = listB.size(); 
      boolean zhaoyunchidiao = false;
      boolean yixue = false;
      int yixuegai = RandomUtils.nextInt(100);
      for (int j = 0; j < range; j++) {
        int reduce = 0;
        BattleArmy batArmy = listB.get(j);
        CampArmy defendCa = batArmy.getCampArmy();
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
        int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (defendCa.playerId < 0 && defendCa.armyName.contains("禁卫军 "))
          damage /= 10; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          damage *= range - j;
          zhaoyunchidiao = true;
        } 
        if (!yixue && yixuegai <= defendCa.getYiXueGaiLv() && j < 3) {
          yixue = true;
          damage = batArmy.getTroopHp()[0] - 1;
        } 
        if (batArmy.getCampArmy().getGeneralId() == 73051 || batArmy.getCampArmy().getIsBeatMonster() > 0 || (batArmy.getCampArmy().getGeneralId() == 232 && batArmy.getCampArmy().getUnionRank() > 0) || batArmy.getCampArmy().getLegendEvoke()) {
          damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 1; 
        } 
        int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, j);
        if (j == 0 && batArmy.getTroopHp()[0] <= 0) {
          firstRowkilled = true;
          roundInfo.defFirstRowKilled = true;
          roundInfo.win = 1;
        } 
        roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|").append(roundInfo.win).append("#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (defCamp.getUnionRank() >= 2 && defCamp.getZhanShuTuJi() > 1 && !attzhixing && defCamp.getSneer() <= 0) {
      attzhixing = true;
      roundInfo.battleMsg.append("80|att|");
      int range = 5;
      List<BattleArmy> listB = bat.attList;
      if (range > listB.size())
        range = listB.size(); 
      boolean zhaoyunchidiao = false;
      boolean yixue = false;
      int yixuegai = RandomUtils.nextInt(100);
      for (int j = 0; j < range; j++) {
        int reduce = 0;
        BattleArmy batArmy = listB.get(j);
        CampArmy defendCa = batArmy.getCampArmy();
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
        int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (defendCa.playerId < 0 && defendCa.armyName.contains("禁卫军 "))
          damage /= 10; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          damage *= range - j;
          zhaoyunchidiao = true;
        } 
        if (!yixue && yixuegai <= defendCa.getYiXueGaiLv() && j < 3) {
          yixue = true;
          damage = batArmy.getTroopHp()[0] - 1;
        } 
        if (batArmy.getCampArmy().getGeneralId() == 73051 || batArmy.getCampArmy().getIsBeatMonster() > 0 || (batArmy.getCampArmy().getGeneralId() == 232 && batArmy.getCampArmy().getUnionRank() > 0) || batArmy.getCampArmy().getLegendEvoke()) {
          damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 1; 
        } 
        int xinlost = DamageSkill(defCamp, batArmy, batArmy.getCampArmy(), 0, damage, false, dataGetter, bat, roundInfo, j);
        if (j == 0 && batArmy.getTroopHp()[0] <= 0) {
          firstRowkilled = true;
          roundInfo.attFirstRowKilled = true;
          roundInfo.win = 2;
        } 
        roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|").append(roundInfo.win).append("#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (firstRowkilled)
      return true; 
    if (defCamp.getGeneralId() == 416 && defCamp.getChapterId() >= 3 && defCamp.getZhanShuTuJi() > 1 && !attzhixing && defCamp.getSneer() <= 0) {
      attzhixing = true;
      roundInfo.battleMsg.append("80|att|");
      int range = 5;
      List<BattleArmy> listB = bat.attList;
      if (range > listB.size())
        range = listB.size(); 
      boolean zhaoyunchidiao = false;
      boolean yixue = false;
      int yixuegai = RandomUtils.nextInt(100);
      for (int j = 0; j < range; j++) {
        int reduce = 0;
        BattleArmy batArmy = listB.get(j);
        CampArmy defendCa = batArmy.getCampArmy();
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
        int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (defendCa.playerId < 0 && defendCa.armyName.contains("禁卫军 "))
          damage /= 10; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          damage *= range - j;
          zhaoyunchidiao = true;
        } 
        if (!yixue && yixuegai <= defendCa.getYiXueGaiLv() && j < 3) {
          yixue = true;
          damage = batArmy.getTroopHp()[0] - 1;
        } 
        if (batArmy.getCampArmy().getGeneralId() == 73051 || batArmy.getCampArmy().getIsBeatMonster() > 0 || (batArmy.getCampArmy().getGeneralId() == 232 && batArmy.getCampArmy().getUnionRank() > 0) || batArmy.getCampArmy().getLegendEvoke()) {
          damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 1; 
        } 
        int xinlost = DamageSkill(defCamp, batArmy, batArmy.getCampArmy(), 0, damage, false, dataGetter, bat, roundInfo, j);
        if (j == 0 && batArmy.getTroopHp()[0] <= 0) {
          firstRowkilled = true;
          roundInfo.attFirstRowKilled = true;
          roundInfo.win = 2;
        } 
        roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|").append(roundInfo.win).append("#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getUnionRank() >= 1 && attCamp.getZhanShuGongJi() > 1 && !attzhixing && attCamp.getSneer() <= 0) {
      attzhixing = true;
      roundInfo.battleMsg.append("83|att|");
      int range = 5;
      List<BattleArmy> listB = bat.defList;
      if (range > listB.size())
        range = listB.size(); 
      boolean zhaoyunchidiao = false;
      boolean yixue = false;
      int yixuegai = RandomUtils.nextInt(100);
      for (int j = 0; j < range; j++) {
        int reduce = 0;
        BattleArmy batArmy = listB.get(j);
        CampArmy defendCa = batArmy.getCampArmy();
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
        int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (defendCa.playerId < 0 && defendCa.armyName.contains("禁卫军 "))
          damage /= 10; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          damage *= range - j;
          zhaoyunchidiao = true;
        } 
        int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, j);
        if (j == 0 && batArmy.getTroopHp()[0] <= 0) {
          firstRowkilled = true;
          roundInfo.defFirstRowKilled = true;
          roundInfo.win = 1;
        } 
        roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|").append(roundInfo.win).append("#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (attCamp.getGeneralId() == 416 && attCamp.getChapterId() >= 2 && attCamp.getZhanShuGongJi() > 1 && !attzhixing && attCamp.getSneer() <= 0) {
      attzhixing = true;
      roundInfo.battleMsg.append("83|att|");
      int range = 5;
      List<BattleArmy> listB = bat.defList;
      if (range > listB.size())
        range = listB.size(); 
      boolean zhaoyunchidiao = false;
      boolean yixue = false;
      int yixuegai = RandomUtils.nextInt(100);
      for (int j = 0; j < range; j++) {
        int reduce = 0;
        BattleArmy batArmy = listB.get(j);
        CampArmy defendCa = batArmy.getCampArmy();
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
        int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (defendCa.playerId < 0 && defendCa.armyName.contains("禁卫军 "))
          damage /= 10; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          damage *= range - j;
          zhaoyunchidiao = true;
        } 
        int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, j);
        if (j == 0 && batArmy.getTroopHp()[0] <= 0) {
          firstRowkilled = true;
          roundInfo.defFirstRowKilled = true;
          roundInfo.win = 1;
        } 
        roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|").append(roundInfo.win).append("#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (defCamp.getUnionRank() >= 1 && defCamp.getZhanShuGongJi() > 1 && !attzhixing && defCamp.getSneer() <= 0) {
      attzhixing = true;
      roundInfo.battleMsg.append("83|def|");
      int range = 5;
      List<BattleArmy> listB = bat.attList;
      if (range > listB.size())
        range = listB.size(); 
      boolean zhaoyunchidiao = false;
      boolean yixue = false;
      int yixuegai = RandomUtils.nextInt(100);
      for (int j = 0; j < range; j++) {
        int reduce = 0;
        BattleArmy batArmy = listB.get(j);
        CampArmy defendCa = batArmy.getCampArmy();
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
        int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (defendCa.playerId < 0 && defendCa.armyName.contains("禁卫军 "))
          damage /= 10; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          damage *= range - j;
          zhaoyunchidiao = true;
        } 
        int xinlost = DamageSkill(defCamp, batArmy, batArmy.getCampArmy(), 0, damage, false, dataGetter, bat, roundInfo, j);
        if (j == 0 && batArmy.getTroopHp()[0] <= 0) {
          firstRowkilled = true;
          roundInfo.attFirstRowKilled = true;
          roundInfo.win = 2;
        } 
        roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|").append(roundInfo.win).append("#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (firstRowkilled)
      return true; 
    if (defCamp.getGeneralId() == 416 && defCamp.getChapterId() >= 2 && defCamp.getZhanShuGongJi() > 1 && !attzhixing && defCamp.getSneer() <= 0) {
      attzhixing = true;
      roundInfo.battleMsg.append("83|def|");
      int range = 5;
      List<BattleArmy> listB = bat.attList;
      if (range > listB.size())
        range = listB.size(); 
      boolean zhaoyunchidiao = false;
      boolean yixue = false;
      int yixuegai = RandomUtils.nextInt(100);
      for (int j = 0; j < range; j++) {
        int reduce = 0;
        BattleArmy batArmy = listB.get(j);
        CampArmy defendCa = batArmy.getCampArmy();
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
        int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (defendCa.playerId < 0 && defendCa.armyName.contains("禁卫军 "))
          damage /= 10; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          damage *= range - j;
          zhaoyunchidiao = true;
        } 
        int xinlost = DamageSkill(defCamp, batArmy, batArmy.getCampArmy(), 0, damage, false, dataGetter, bat, roundInfo, j);
        if (j == 0 && batArmy.getTroopHp()[0] <= 0) {
          firstRowkilled = true;
          roundInfo.attFirstRowKilled = true;
          roundInfo.win = 2;
        } 
        roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|").append(roundInfo.win).append("#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getUnionRank() > 0 && attCamp.getZhanShuFangYu() > 1 && !attzhixing && attCamp.getSneer() <= 0) {
      attzhixing = true;
      roundInfo.battleMsg.append("82|def|");
      for (int i = 0; i < bat.defList.size(); i++) {
        BattleArmy defbattleArmy = bat.defList.get(i);
        defbattleArmy.setSpecial(1);
        roundInfo.battleMsg.append(defbattleArmy.getPosition()).append(";");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "|");
      int range = 5;
      List<BattleArmy> listB = bat.defList;
      if (range > listB.size())
        range = listB.size(); 
      boolean zhaoyunchidiao = false;
      boolean yixue = false;
      int yixuegai = RandomUtils.nextInt(100);
      for (int j = 0; j < range; j++) {
        int reduce = 0;
        BattleArmy batArmy = listB.get(j);
        CampArmy defendCa = batArmy.getCampArmy();
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
        int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (defendCa.playerId < 0 && defendCa.armyName.contains("禁卫军 "))
          damage /= 10; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          damage *= range - j;
          zhaoyunchidiao = true;
        } 
        int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, j);
        if (j == 0 && batArmy.getTroopHp()[0] <= 0) {
          firstRowkilled = true;
          roundInfo.defFirstRowKilled = true;
          roundInfo.win = 1;
        } 
        roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|").append(roundInfo.win).append("#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (attCamp.getGeneralId() == 416 && attCamp.getChapterId() > 1 && attCamp.getZhanShuFangYu() > 1 && !attzhixing && attCamp.getSneer() <= 0) {
      attzhixing = true;
      roundInfo.battleMsg.append("82|def|");
      for (int i = 0; i < bat.defList.size(); i++) {
        BattleArmy defbattleArmy = bat.defList.get(i);
        defbattleArmy.setSpecial(1);
        roundInfo.battleMsg.append(defbattleArmy.getPosition()).append(";");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "|");
      int range = 5;
      List<BattleArmy> listB = bat.defList;
      if (range > listB.size())
        range = listB.size(); 
      boolean zhaoyunchidiao = false;
      boolean yixue = false;
      int yixuegai = RandomUtils.nextInt(100);
      for (int j = 0; j < range; j++) {
        int reduce = 0;
        BattleArmy batArmy = listB.get(j);
        CampArmy defendCa = batArmy.getCampArmy();
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
        int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (defendCa.playerId < 0 && defendCa.armyName.contains("禁卫军 "))
          damage /= 10; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          damage *= range - j;
          zhaoyunchidiao = true;
        } 
        int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, j);
        if (j == 0 && batArmy.getTroopHp()[0] <= 0) {
          firstRowkilled = true;
          roundInfo.defFirstRowKilled = true;
          roundInfo.win = 1;
        } 
        roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|").append(roundInfo.win).append("#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (defCamp.getUnionRank() > 0 && defCamp.getZhanShuFangYu() > 1 && !attzhixing && defCamp.getSneer() <= 0) {
      attzhixing = true;
      roundInfo.battleMsg.append("82|att|");
      for (int i = 0; i < bat.attList.size(); i++) {
        BattleArmy attbattleArmy = bat.attList.get(i);
        attbattleArmy.setSpecial(1);
        roundInfo.battleMsg.append(attbattleArmy.getPosition()).append(";");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "|");
      int range = 5;
      List<BattleArmy> listB = bat.attList;
      if (range > listB.size())
        range = listB.size(); 
      boolean zhaoyunchidiao = false;
      boolean yixue = false;
      int yixuegai = RandomUtils.nextInt(100);
      for (int j = 0; j < range; j++) {
        int reduce = 0;
        BattleArmy batArmy = listB.get(j);
        CampArmy defendCa = batArmy.getCampArmy();
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
        int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (defendCa.playerId < 0 && defendCa.armyName.contains("禁卫军 "))
          damage /= 10; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          damage *= range - j;
          zhaoyunchidiao = true;
        } 
        int xinlost = DamageSkill(defCamp, batArmy, batArmy.getCampArmy(), 0, damage, false, dataGetter, bat, roundInfo, j);
        if (j == 0 && batArmy.getTroopHp()[0] <= 0) {
          firstRowkilled = true;
          roundInfo.attFirstRowKilled = true;
          roundInfo.win = 2;
        } 
        roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|").append(roundInfo.win).append("#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (defCamp.getGeneralId() == 416 && defCamp.getChapterId() > 1 && defCamp.getZhanShuFangYu() > 1 && !attzhixing && defCamp.getSneer() <= 0) {
      attzhixing = true;
      roundInfo.battleMsg.append("82|att|");
      for (int i = 0; i < bat.attList.size(); i++) {
        BattleArmy attbattleArmy = bat.attList.get(i);
        attbattleArmy.setSpecial(1);
        roundInfo.battleMsg.append(attbattleArmy.getPosition()).append(";");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "|");
      int range = 5;
      List<BattleArmy> listB = bat.attList;
      if (range > listB.size())
        range = listB.size(); 
      boolean zhaoyunchidiao = false;
      boolean yixue = false;
      int yixuegai = RandomUtils.nextInt(100);
      for (int j = 0; j < range; j++) {
        int reduce = 0;
        BattleArmy batArmy = listB.get(j);
        CampArmy defendCa = batArmy.getCampArmy();
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
        int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (defendCa.playerId < 0 && defendCa.armyName.contains("禁卫军 "))
          damage /= 10; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          damage *= range - j;
          zhaoyunchidiao = true;
        } 
        int xinlost = DamageSkill(defCamp, batArmy, batArmy.getCampArmy(), 0, damage, false, dataGetter, bat, roundInfo, j);
        if (j == 0 && batArmy.getTroopHp()[0] <= 0) {
          firstRowkilled = true;
          roundInfo.attFirstRowKilled = true;
          roundInfo.win = 2;
        } 
        roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|").append(roundInfo.win).append("#");
      roundInfo.nextMinExeTime += 3000;
    } 
    return firstRowkilled;
  }
  
  public int DamageSkill(CampArmy campA, BattleArmy batArmy, CampArmy campB, int battleSide, int olddamage, boolean jflh, IDataGetter dataGetter, Battle bat, RoundInfo roundInfo, int row) {
    int damage = olddamage;
    int reduce = 0;
    if (campA.getLegendSkill().containsKey("powei") && ((Integer)campA.getLegendSkill().get("powei")).intValue() > 0 && campB.getUnionState() > 0)
      damage = damage * 110 / 100; 
    if (campB.getLegendSkill().containsKey("kangwei") && ((Integer)campB.getLegendSkill().get("kangwei")).intValue() > 0 && campA.getUnionState() > 0)
      damage = damage * 90 / 100; 
    if (campA.getLegendSkill().containsKey("lingjun") && ((Integer)campA.getLegendSkill().get("lingjun")).intValue() > 0)
      damage = damage * 120 / 100; 
    if (campB.getGeneralId() == 201 && campB.getHaveZscy())
      damage = Double.valueOf(damage * 0.2D).intValue(); 
    boolean realdamage = false;
    if (batArmy.getCampArmy().getDiKang() > 0) {
      damage = -3;
      batArmy.getCampArmy().setNeedReduceDiKang(true);
    } else if (batArmy.getHaveZhanChe() && batArmy.getHuJia() > 0 && damage > 0) {
      if (jflh) {
        if (campB.getCarId() > 87000) {
          damage = campB.getNaijiu();
          batArmy.setHuJia(batArmy.getHuJia() - campB.naijiu);
        } else {
          damage = batArmy.getHuJia();
          batArmy.setHuJia(0);
        } 
      } else if (damage >= campB.getPojia()) {
        damage = campB.getNaijiu();
        batArmy.setHuJia(batArmy.getHuJia() - campB.naijiu);
      } else {
        damage = 1;
        batArmy.setHuJia(batArmy.getHuJia() - 1);
      } 
    } else if (batArmy.getCatapultSkill() > 1 && batArmy.getZCdunHp() > 0 && damage > 0) {
      if (jflh) {
        damage = batArmy.getZCdunHp();
      } else if (damage >= campB.pojia / 2) {
        damage = campB.getNaijiu();
      } else {
        damage = 1;
      } 
      batArmy.setZCdunHp(batArmy.getZCdunHp() - damage);
    } else if (batArmy.getShield() > 0 && damage > 0) {
      if (batArmy.getShiledType() == 2) {
        if (jflh) {
          damage = batArmy.getShield();
        } else if (batArmy.getZhanchedun() > 0) {
          if (damage >= campB.pojia / 2) {
            damage = campB.getNaijiu();
          } else {
            damage = 1;
          } 
        } else if (damage >= 0) {
          damage = -1;
        } else if (damage < -6) {
          damage = -6;
        } 
      } else {
        if (damage > batArmy.getShield())
          damage = batArmy.getShield(); 
        if (jflh)
          damage = batArmy.getShield(); 
        if (damage > 20000)
          damage = 20000; 
        realdamage = true;
      } 
      batArmy.setShield(batArmy.getShield() - ((damage < 0) ? 0 : damage));
    } else if (damage >= batArmy.getTroopHp()[0]) {
      if (bat.getRoundNum().get() == 0) {
        damage = batArmy.getTroopHp()[0] - 1;
      } else {
        damage = batArmy.getTroopHp()[0];
      } 
    } 
    for (int j2 = 0; j2 < (batArmy.getTroopHp()).length; j2++) {
      int[] troopHp = batArmy.getTroopHp();
      if (!realdamage) {
        troopHp[j2] = troopHp[j2] - ((damage < 0) ? 0 : damage);
        reduce += (damage < 0) ? 0 : damage;
      } 
    } 
    campB.armyHpLoss += reduce;
    campA.armyHpKill += reduce;
    if (!realdamage)
      if (battleSide == 1) {
        roundInfo.defBeiDongLost += reduce;
        bat.getDefBaseInfo().setNum(bat.getDefBaseInfo().getNum() - reduce);
      } else {
        roundInfo.attBeiDongLost += reduce;
        bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - reduce);
      }  
    if (batArmy.getTroopHp()[0] <= 0)
      if (battleSide == 1) {
        roundInfo.defKilledList.add(batArmy);
      } else {
        roundInfo.attKilledList.add(batArmy);
      }  
    PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(campB.getPlayerId()));
    if (pi != null) {
      PlayerInfo playerInfo3 = pi, playerInfo = playerInfo3;
      playerInfo3.lostTotal += reduce;
    } 
    if (campB.isBarPhantom)
      campA.barbarainHpKill += reduce; 
    PlayerInfo piA = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(campA.getPlayerId()));
    if (piA != null) {
      PlayerInfo playerInfo4 = piA, playerInfo2 = playerInfo4;
      playerInfo4.killTotal += reduce;
    } 
    return damage;
  }
  
  public boolean BeiDongJiNeng(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    boolean firstRowkilled = false;
    CampArmy attCamp = roundInfo.attCampArmy;
    CampArmy defCamp = roundInfo.defCampArmy;
    boolean attLoss = false;
    boolean defLoss = false;
    boolean zhixing = false;
    boolean simayiatt = false;
    boolean simayidef = false;
    if (attCamp.getBzStatus() <= 0 && attCamp.getFormationType() == 1 && attCamp.getBzStatuCode())
      attCamp.cur_index = Integer.valueOf(1); 
    if (defCamp.getBzStatus() > 0 && defCamp.getFormationType() == 1 && defCamp.getBzStatuCode())
      defCamp.cur_index = Integer.valueOf(1); 
    if (attCamp.getGeneralId() == 268 && attCamp.getIsJuexing() > 0 && attCamp.getSmyNum() > 0 && attCamp.getSmyRow().size() > 0 && attCamp.getSneer() <= 0)
      if (bat.getAttList().size() <= 1) {
        simayiatt = true;
      } else if (((BattleArmy)bat.getAttList().get(1)).getCampArmy().getId() != attCamp.getId()) {
        simayiatt = true;
      }  
    if (defCamp.getGeneralId() == 268 && defCamp.getIsJuexing() > 0 && defCamp.getSmyNum() > 0 && defCamp.getSmyRow().size() > 0 && defCamp.getSneer() <= 0)
      if (bat.getDefList().size() <= 1) {
        simayidef = true;
      } else if (((BattleArmy)bat.getDefList().get(1)).getCampArmy().getId() != defCamp.getId()) {
        simayidef = true;
      }  
    if (simayiatt) {
      int tacid = ((Integer)attCamp.getSmyRow().get(0)).intValue();
      Tactic tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(tacid));
      int range = 2;
      if (tactic != null) {
        range = tactic.getRange().intValue();
        tacid = tactic.getDisplayId().intValue();
      } 
      CampArmy campArmy2 = attCamp;
      campArmy2.smynum--;
      attCamp.getSmyRow().remove(0);
      List<BattleArmy> listB = bat.defList;
      if (range > listB.size())
        range = listB.size(); 
      roundInfo.battleMsg.append("54|att;").append(tacid).append(";0;null").append(";");
      boolean zhaoyunchidiao = false;
      for (int i = 0; i < range; i++) {
        int reduce = 0;
        BattleArmy batArmy = listB.get(i);
        CampArmy defendCa = batArmy.getCampArmy();
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
        int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (defendCa.playerId < 0 && defendCa.armyName.contains("禁卫军 "))
          damage /= 10; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          damage *= range - i;
          zhaoyunchidiao = true;
        } 
        int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, i);
        roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0*");
      } 
      firstRowkilled = true;
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (simayidef) {
      int tacid = ((Integer)defCamp.getSmyRow().get(0)).intValue();
      Tactic tactic = (Tactic)dataGetter.getTacticCache().get(Integer.valueOf(tacid));
      int range = 2;
      if (tactic != null) {
        range = tactic.getRange().intValue();
        tacid = tactic.getDisplayId().intValue();
      } 
      CampArmy campArmy3 = defCamp;
      campArmy3.smynum--;
      defCamp.getSmyRow().remove(0);
      List<BattleArmy> listB = bat.attList;
      if (range > listB.size())
        range = listB.size(); 
      roundInfo.battleMsg.append("54|def;").append(tacid).append(";0;null").append(";");
      boolean zhaoyunchidiao = false;
      for (int i = 0; i < range; i++) {
        int reduce = 0;
        BattleArmy batArmy = listB.get(i);
        CampArmy defendCa = batArmy.getCampArmy();
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
        int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (defendCa.playerId < 0 && defendCa.armyName.contains("禁卫军 "))
          damage /= 10; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          damage *= range - i;
          zhaoyunchidiao = true;
        } 
        if (damage >= batArmy.getTroopHp()[0])
          damage = batArmy.getTroopHp()[0]; 
        int xinlost = DamageSkill(defCamp, batArmy, batArmy.getCampArmy(), 0, damage, false, dataGetter, bat, roundInfo, i);
        roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0*");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      firstRowkilled = true;
      roundInfo.nextMinExeTime += 3000;
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getZgMaoLu() && attCamp.getGeneralId() == 269 && attCamp.getLegendEvoke() && ((Integer)roundInfo.attCampArmy.getLegendSkill().get("maolu")).intValue() > 0) {
      StringBuilder longhunattstr = new StringBuilder();
      for (int i = 0; i < bat.attList.size(); i++) {
        BattleArmy attbattleArmy = bat.attList.get(i);
        int maxhpadd = attbattleArmy.getCampArmy().getTroopHp() / 3;
        if (((Integer)roundInfo.attCampArmy.getLegendSkill().get("maolu")).intValue() > 0)
          maxhpadd = (int)((attbattleArmy.getCampArmy().getTroopHp() / 3) * 0.4D); 
        if (((Integer)roundInfo.attCampArmy.getLegendSkill().get("wolong")).intValue() > 0)
          maxhpadd = (int)((attbattleArmy.getCampArmy().getTroopHp() / 3) * 0.8D); 
        if (((Integer)roundInfo.attCampArmy.getLegendSkill().get("ddzy")).intValue() > 0)
          maxhpadd = (int)((attbattleArmy.getCampArmy().getTroopHp() / 3) * 1.2D); 
        int caocaohp = attbattleArmy.getShield();
        if (caocaohp < maxhpadd) {
          int adddun = maxhpadd - caocaohp;
          if (adddun > 0) {
            attbattleArmy.setShield(attbattleArmy.getShield() + adddun);
            attbattleArmy.setMaxShield(attbattleArmy.getShield());
            attbattleArmy.setShiledType(3);
            longhunattstr.append(attbattleArmy.getPosition()).append(":").append(adddun).append(",");
          } 
        } 
      } 
      if (longhunattstr.length() > 0) {
        roundInfo.battleMsg.append("176|att|").append(longhunattstr.toString());
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 1000;
        attCamp.setZgMaoLu(true);
      } 
    } 
    if (defCamp.getZgMaoLu() && defCamp.getGeneralId() == 269 && defCamp.getLegendEvoke() && ((Integer)roundInfo.defCampArmy.getLegendSkill().get("maolu")).intValue() > 0) {
      StringBuilder longhunattstr = new StringBuilder();
      for (int i = 0; i < bat.defList.size(); i++) {
        BattleArmy defbattleArmy = bat.defList.get(i);
        int maxhpadd = defbattleArmy.getCampArmy().getTroopHp() / 3;
        if (((Integer)roundInfo.defCampArmy.getLegendSkill().get("maolu")).intValue() > 0)
          maxhpadd = (int)((defbattleArmy.getCampArmy().getTroopHp() / 3) * 0.4D); 
        if (((Integer)roundInfo.defCampArmy.getLegendSkill().get("wolong")).intValue() > 0)
          maxhpadd = (int)((defbattleArmy.getCampArmy().getTroopHp() / 3) * 0.8D); 
        if (((Integer)roundInfo.defCampArmy.getLegendSkill().get("ddzy")).intValue() > 0)
          maxhpadd = (int)((defbattleArmy.getCampArmy().getTroopHp() / 3) * 1.2D); 
        int caocaohp = defbattleArmy.getShield();
        if (caocaohp < maxhpadd) {
          int adddun = maxhpadd - caocaohp;
          if (adddun > 0) {
            defbattleArmy.setShield(defbattleArmy.getShield() + adddun);
            defbattleArmy.setMaxShield(defbattleArmy.getShield());
            defbattleArmy.setShiledType(3);
            longhunattstr.append(defbattleArmy.getPosition()).append(":").append(adddun).append(",");
          } 
        } 
      } 
      if (longhunattstr.length() > 0) {
        roundInfo.battleMsg.append("176|def|").append(longhunattstr.toString());
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 1000;
        defCamp.setZgMaoLu(true);
      } 
    } 
    if (attCamp.zgDiZz && attCamp.getGeneralId() == 269 && attCamp.getLegendEvoke()) {
      attCamp.zgDiZz = false;
      StringBuilder longhunattstr = new StringBuilder();
      for (int i = 0; i < bat.attList.size(); i++) {
        BattleArmy attbattleArmy = bat.attList.get(i);
        int maxhpadd = attbattleArmy.getCampArmy().getTroopHp() / 3;
        if (((Integer)roundInfo.attCampArmy.getLegendSkill().get("maolu")).intValue() > 0)
          maxhpadd = (int)((attbattleArmy.getCampArmy().getTroopHp() / 3) * 0.4D); 
        if (((Integer)roundInfo.attCampArmy.getLegendSkill().get("wolong")).intValue() > 0)
          maxhpadd = (int)((attbattleArmy.getCampArmy().getTroopHp() / 3) * 0.8D); 
        if (((Integer)roundInfo.attCampArmy.getLegendSkill().get("ddzy")).intValue() > 0)
          maxhpadd = (int)((attbattleArmy.getCampArmy().getTroopHp() / 3) * 1.2D); 
        int caocaohp = attbattleArmy.getShield();
        if (caocaohp < maxhpadd) {
          int adddun = maxhpadd - caocaohp;
          if (adddun > 0) {
            attbattleArmy.setShield(attbattleArmy.getShield() + adddun);
            attbattleArmy.setMaxShield(attbattleArmy.getShield());
            attbattleArmy.setShiledType(3);
            longhunattstr.append(attbattleArmy.getPosition()).append(":").append(adddun).append(",");
          } 
        } 
      } 
      if (longhunattstr.length() > 0) {
        roundInfo.battleMsg.append("176|att|").append(longhunattstr.toString());
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 1000;
        attCamp.setZgMaoLu(true);
      } 
    } 
    if (defCamp.zgDiZz && defCamp.getGeneralId() == 269 && defCamp.getLegendEvoke()) {
      defCamp.zgDiZz = false;
      StringBuilder longhunattstr = new StringBuilder();
      for (int i = 0; i < bat.defList.size(); i++) {
        BattleArmy defbattleArmy = bat.defList.get(i);
        int maxhpadd = defbattleArmy.getCampArmy().getTroopHp() / 3;
        if (((Integer)roundInfo.defCampArmy.getLegendSkill().get("maolu")).intValue() > 0)
          maxhpadd = (int)((defbattleArmy.getCampArmy().getTroopHp() / 3) * 0.4D); 
        if (((Integer)roundInfo.defCampArmy.getLegendSkill().get("wolong")).intValue() > 0)
          maxhpadd = (int)((defbattleArmy.getCampArmy().getTroopHp() / 3) * 0.8D); 
        if (((Integer)roundInfo.defCampArmy.getLegendSkill().get("ddzy")).intValue() > 0)
          maxhpadd = (int)((defbattleArmy.getCampArmy().getTroopHp() / 3) * 1.2D); 
        int caocaohp = defbattleArmy.getShield();
        if (caocaohp < maxhpadd) {
          int adddun = maxhpadd - caocaohp;
          if (adddun > 0) {
            defbattleArmy.setShield(defbattleArmy.getShield() + adddun);
            defbattleArmy.setMaxShield(defbattleArmy.getShield());
            defbattleArmy.setShiledType(3);
            longhunattstr.append(defbattleArmy.getPosition()).append(":").append(adddun).append(",");
          } 
        } 
      } 
      if (longhunattstr.length() > 0) {
        roundInfo.battleMsg.append("176|def|").append(longhunattstr.toString());
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 1000;
        defCamp.setZgMaoLu(true);
      } 
    } 
    if (attCamp.getGeneralId() == 281 && attCamp.getLegendEvoke() && attCamp.getChapterId() > 1 && attCamp.getSunceJs() >= 0 && attCamp.getSunceJs() <= 3 && attCamp.getIsScjs()) {
      attCamp.setIsScjs(false);
      attCamp.setSunceJs(attCamp.getSunceJs() + 1);
      StringBuilder longhunattstr = new StringBuilder();
      for (int i = 0; i < bat.attList.size(); i++) {
        BattleArmy attbattleArmy = bat.attList.get(i);
        int adddun = 5000;
        attbattleArmy.setShield(attbattleArmy.getShield() + adddun);
        attbattleArmy.setMaxShield(attbattleArmy.getShield());
        attbattleArmy.setShiledType(1);
        longhunattstr.append(attbattleArmy.getPosition()).append(",").append(attbattleArmy.getShield()).append("*");
      } 
      if (longhunattstr.length() > 0) {
        roundInfo.battleMsg.append("115|att|").append(longhunattstr.toString());
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.battleMsg.append("31|0#");
        roundInfo.nextMinExeTime += 2000;
        attCamp.setMhxx(0);
      } 
    } 
    if (attCamp.getBzStatus1() == 3) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      range3 = 1;
      jineng = 10090;
      weili = 1;
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|att;").append(jineng).append(";0;null;");
        roundInfo.battleMsg.append("#179|att|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:1006719;");
        boolean zhaoyunchidiao3 = false;
        int xuebili2 = (roundInfo.attBattleArmy.getBloodOrg() - roundInfo.attBattleArmy.getTroopHp()[0]) * 80 / 100;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili2)
            damage6 = xuebili2; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 1 || batArmy6.getCampArmy().getFormationLevel() > 2000) {
            damage6 = attCamp.attEffect - defendCa6.defEffect + attCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(attCamp, batArmy6, defendCa6, 1, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getBzStatus1() == 3) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      range3 = 1;
      jineng = 10090;
      weili = 1;
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.attList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|def;").append(jineng).append(";0;null;");
        roundInfo.battleMsg.append("#179|def|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:1006719;");
        int xuebili3 = (roundInfo.defBattleArmy.getBloodOrg() - roundInfo.defBattleArmy.getTroopHp()[0]) * 80 / 100;
        boolean zhaoyunchidiao5 = false;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili3)
            damage6 = xuebili3; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 1 || batArmy6.getCampArmy().getFormationLevel() > 1000) {
            damage6 = defCamp.attEffect - defendCa6.defEffect + defCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao5) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao5 = true;
          } 
          int xinlost5 = DamageSkill(defCamp, batArmy6, defendCa6, 0, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getGeneralId() == 281 && defCamp.getLegendEvoke() && defCamp.getChapterId() > 1 && defCamp.getSunceJs() >= 0 && defCamp.getSunceJs() <= 3 && 
      defCamp
      .getIsScjs()) {
      defCamp.setIsScjs(false);
      defCamp.setSunceJs(defCamp.getSunceJs() + 1);
      StringBuilder longhunattstr = new StringBuilder();
      for (int i = 0; i < bat.defList.size(); i++) {
        BattleArmy defbattleArmy = bat.defList.get(i);
        int adddun = 5000;
        defbattleArmy.setShield(defbattleArmy.getShield() + adddun);
        defbattleArmy.setMaxShield(defbattleArmy.getShield());
        defbattleArmy.setShiledType(1);
        longhunattstr.append(defbattleArmy.getPosition()).append(",").append(defbattleArmy.getShield()).append("*");
      } 
      if (longhunattstr.length() > 0) {
        roundInfo.battleMsg.append("115|def|").append(longhunattstr.toString());
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.battleMsg.append("31|0#");
        roundInfo.nextMinExeTime += 2000;
        attCamp.setMhxx(0);
      } 
    } 
    if (attCamp.getGeneralId() == 281 && attCamp.getLegendEvoke() && attCamp.getChapterId() >= 2 && attCamp.getScJj1()) {
      attCamp.setScJj1(false);
      StringBuilder longhunattstr = new StringBuilder();
      for (int i = 0; i < bat.attList.size(); i++) {
        BattleArmy attbattleArmy = bat.attList.get(i);
        int maxhpadd = attbattleArmy.getCampArmy().getTroopHp() / 3;
        int caocaohp = attbattleArmy.getShield();
        if (caocaohp < maxhpadd) {
          int adddun = maxhpadd - caocaohp;
          if (adddun > 0) {
            attbattleArmy.setShield(attbattleArmy.getShield() + adddun);
            attbattleArmy.setMaxShield(attbattleArmy.getShield());
            attbattleArmy.setShiledType(1);
            longhunattstr.append(attbattleArmy.getPosition()).append(",").append(adddun).append("*");
          } 
        } 
      } 
      if (longhunattstr.length() > 0) {
        roundInfo.battleMsg.append("115|att|").append(longhunattstr.toString());
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.battleMsg.append("31|0#");
        roundInfo.nextMinExeTime += 2000;
        attCamp.setMhxx(0);
      } 
    } 
    if (defCamp.getGeneralId() == 281 && defCamp.getLegendEvoke() && defCamp.getChapterId() >= 2 && defCamp.getScJj1()) {
      defCamp.setScJj1(false);
      StringBuilder longhunattstr = new StringBuilder();
      for (int i = 0; i < bat.defList.size(); i++) {
        BattleArmy defbattleArmy = bat.defList.get(i);
        int maxhpadd = defbattleArmy.getCampArmy().getTroopHp() / 3;
        int caocaohp = defbattleArmy.getShield();
        if (caocaohp < maxhpadd) {
          int adddun = maxhpadd - caocaohp;
          if (adddun > 0) {
            defbattleArmy.setShield(defbattleArmy.getShield() + adddun);
            defbattleArmy.setMaxShield(defbattleArmy.getShield());
            defbattleArmy.setShiledType(1);
            longhunattstr.append(defbattleArmy.getPosition()).append(",").append(adddun).append("*");
          } 
        } 
      } 
      if (longhunattstr.length() > 0) {
        roundInfo.battleMsg.append("115|def|").append(longhunattstr.toString());
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.battleMsg.append("31|0#");
        roundInfo.nextMinExeTime += 2000;
        defCamp.setMhxx(0);
      } 
    } 
    if (attCamp.getGeneralId() == 281 && attCamp.getLegendEvoke() && attCamp.getChapterId() >= 3 && (attCamp.getDoujiang() || attCamp.getSuncChihu())) {
      attCamp.setDoujiang(false);
      roundInfo.attCampArmy.defEffect = (int)(roundInfo.attCampArmy.defEffect * 0.5D);
      roundInfo.attCampArmy.TACTIC_DEF = (int)(roundInfo.attCampArmy.TACTIC_DEF * 0.5D);
      System.out.println("====>defEffect孙策攻方 " + roundInfo.attCampArmy.defEffect);
      System.out.println("====>TACTIC_DEF孙策攻方 " + roundInfo.attCampArmy.TACTIC_DEF);
      StringBuilder longhunattstr = new StringBuilder();
      for (int i = 0; i < bat.attList.size(); i++) {
        BattleArmy attbattleArmy = bat.attList.get(i);
        int maxhpadd = attbattleArmy.getCampArmy().getTroopHp() / 3;
        int adddun = (int)(maxhpadd * 0.05D);
        if (adddun > 0) {
          attbattleArmy.setShield(attbattleArmy.getShield() + adddun);
          attbattleArmy.setMaxShield(attbattleArmy.getShield());
          attbattleArmy.setShiledType(1);
          longhunattstr.append(attbattleArmy.getPosition()).append(",").append(attbattleArmy.getShield()).append("*");
        } 
      } 
      if (longhunattstr.length() > 0) {
        roundInfo.battleMsg.append("115|att|").append(longhunattstr.toString());
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.battleMsg.append("31|0#");
        roundInfo.nextMinExeTime += 2000;
        attCamp.setMhxx(0);
      } 
    } 
    if (defCamp.getGeneralId() == 281 && defCamp.getLegendEvoke() && defCamp.getChapterId() >= 3 && (defCamp.getDoujiang() || defCamp.getSuncChihu())) {
      defCamp.setScJj1(false);
      StringBuilder longhunattstr = new StringBuilder();
      defCamp.setDoujiang(false);
      roundInfo.defCampArmy.defEffect = (int)(roundInfo.defCampArmy.defEffect * 0.5D);
      roundInfo.defCampArmy.TACTIC_DEF = (int)(roundInfo.defCampArmy.TACTIC_DEF * 0.5D);
      for (int i = 0; i < bat.defList.size(); i++) {
        BattleArmy defbattleArmy = bat.defList.get(i);
        int maxhpadd = defbattleArmy.getCampArmy().getTroopHp() / 3;
        int adddun = (int)(maxhpadd * 0.05D);
        if (adddun > 0) {
          defbattleArmy.setShield(defbattleArmy.getShield() + adddun);
          defbattleArmy.setMaxShield(defbattleArmy.getShield());
          defbattleArmy.setShiledType(1);
          longhunattstr.append(defbattleArmy.getPosition()).append(",").append(defbattleArmy.getShield()).append("*");
        } 
      } 
      if (longhunattstr.length() > 0) {
        roundInfo.battleMsg.append("115|def|").append(longhunattstr.toString());
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.battleMsg.append("31|0#");
        roundInfo.nextMinExeTime += 2000;
        defCamp.setMhxx(0);
      } 
    } 
    if (attCamp.getMhxx() > 0) {
      StringBuilder longhunattstr = new StringBuilder();
      for (int j = 0; j < bat.attList.size(); j++) {
        BattleArmy attbattleArmy = bat.attList.get(j);
        if (attbattleArmy.getCampArmy().getId() == attCamp.getId() && 
          attbattleArmy.getTroopHp()[0] > 100) {
          if (attbattleArmy.getHaveZhanChe()) {
            if (attbattleArmy.getHuJia() > 0)
              continue; 
            if (attbattleArmy.getZCdunHp() > 0)
              continue; 
          } 
          if (!attbattleArmy.getHaveZhanChe() || attbattleArmy.getShiledType() != 2 || attbattleArmy.getShield() <= 0) {
            int maxhpadd = attbattleArmy.getCampArmy().getTroopHp() / 3 * 101 / 100;
            int caocaohp = attbattleArmy.getShield();
            if (caocaohp < maxhpadd) {
              int adddun = maxhpadd - caocaohp;
              if (adddun > 0) {
                attbattleArmy.setShield(attbattleArmy.getShield() + adddun);
                attbattleArmy.setMaxShield(attbattleArmy.getShield());
                attbattleArmy.setShiledType(1);
                longhunattstr.append(attbattleArmy.getPosition()).append(",").append(adddun).append("*");
              } 
            } 
          } 
        } 
        continue;
      } 
      if (longhunattstr.length() > 0) {
        roundInfo.battleMsg.append("115|att|").append(longhunattstr.toString());
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.battleMsg.append("31|0#");
        roundInfo.nextMinExeTime += 2000;
        attCamp.setMhxx(0);
      } 
    } 
    if (defCamp.getMhxx() > 0) {
      StringBuilder longhunattstr = new StringBuilder();
      for (int j = 0; j < bat.defList.size(); j++) {
        BattleArmy defbattleArmy = bat.defList.get(j);
        if (defbattleArmy.getCampArmy().getId() == defCamp.getId() && 
          defbattleArmy.getTroopHp()[0] > 100) {
          if (defbattleArmy.getHaveZhanChe()) {
            if (defbattleArmy.getHuJia() > 0)
              continue; 
            if (defbattleArmy.getZCdunHp() > 0)
              continue; 
          } 
          if (!defbattleArmy.getHaveZhanChe() || defbattleArmy.getShiledType() != 2 || defbattleArmy.getShield() <= 0) {
            int maxhpadd = defbattleArmy.getCampArmy().getTroopHp() / 3 * 101 / 100;
            int caocaohp = defbattleArmy.getShield();
            if (caocaohp < maxhpadd) {
              int adddun = maxhpadd - caocaohp;
              if (adddun > 0) {
                defbattleArmy.setShield(defbattleArmy.getShield() + adddun);
                defbattleArmy.setMaxShield(defbattleArmy.getShield());
                defbattleArmy.setShiledType(1);
                longhunattstr.append(defbattleArmy.getPosition()).append(",").append(adddun).append("*");
              } 
            } 
          } 
        } 
        continue;
      } 
      if (longhunattstr.length() > 0) {
        roundInfo.battleMsg.append("115|def|").append(longhunattstr.toString());
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.battleMsg.append("31|0#");
        roundInfo.nextMinExeTime += 2000;
        defCamp.setMhxx(0);
      } 
    } 
    if (attCamp.getNeedZongHeng()) {
      BattleArmy attbattleArmy2 = roundInfo.attBattleArmy;
      if (attbattleArmy2.getShield() <= 10000) {
        attCamp.setNeedZongHeng(false);
        attCamp.getLegendSkill().put("zongheng", Integer.valueOf(((Integer)attCamp.getLegendSkill().get("zongheng")).intValue() - 1));
        int maxhpadd2 = attCamp.getTroopHp() / 3 * 120 / 100;
        int caocaohp2 = attbattleArmy2.getShield();
        int adddun2 = maxhpadd2 - caocaohp2;
        attbattleArmy2.setSpecial(0);
        if (attbattleArmy2.getCampArmy().getDefenseDow() > 0) {
          attbattleArmy2.getCampArmy().setDefenseDow(0);
          attbattleArmy2.getCampArmy().setDefenseDown(0.0D);
        } 
        if (attbattleArmy2.getSangDanType() > 0)
          attbattleArmy2.setSangDanType(0); 
        if (attbattleArmy2.getCampArmy().getAttackLevel() < 0)
          attbattleArmy2.getCampArmy().setAttackLevel(0); 
        if (attbattleArmy2.getHuWei() > 0)
          attbattleArmy2.setHuWei(0); 
        if (attbattleArmy2.getCardebuff() > 0)
          attbattleArmy2.setCardebuff(0); 
        attbattleArmy2.setShield(attbattleArmy2.getShield() + adddun2);
        attbattleArmy2.setMaxShield(attbattleArmy2.getShield());
        attbattleArmy2.setShiledType(4);
        roundInfo.battleMsg.append("131|att|").append(attbattleArmy2.getPosition()).append(":1:").append(adddun2).append("#");
      } 
    } 
    if (defCamp.getNeedZongHeng()) {
      BattleArmy defbattleArmy2 = roundInfo.defBattleArmy;
      if (defbattleArmy2.getShield() <= 10000) {
        defCamp.setNeedZongHeng(false);
        defCamp.getLegendSkill().put("zongheng", Integer.valueOf(((Integer)defCamp.getLegendSkill().get("zongheng")).intValue() - 1));
        int maxhpadd2 = defCamp.getTroopHp() / 3 * 120 / 100;
        int caocaohp2 = defbattleArmy2.getShield();
        int adddun2 = maxhpadd2 - caocaohp2;
        defbattleArmy2.setSpecial(0);
        if (defbattleArmy2.getCampArmy().getDefenseDow() > 0) {
          defbattleArmy2.getCampArmy().setDefenseDow(0);
          defbattleArmy2.getCampArmy().setDefenseDown(0.0D);
        } 
        if (defbattleArmy2.getSangDanType() > 0)
          defbattleArmy2.setSangDanType(0); 
        if (defbattleArmy2.getCampArmy().getAttackLevel() < 0)
          defbattleArmy2.getCampArmy().setAttackLevel(0); 
        if (defbattleArmy2.getHuWei() > 0)
          defbattleArmy2.setHuWei(0); 
        if (defbattleArmy2.getCardebuff() > 0)
          defbattleArmy2.setCardebuff(0); 
        defbattleArmy2.setShield(defbattleArmy2.getShield() + adddun2);
        defbattleArmy2.setMaxShield(defbattleArmy2.getShield());
        defbattleArmy2.setShiledType(4);
        roundInfo.battleMsg.append("131|def|").append(defbattleArmy2.getPosition()).append(":1:").append(adddun2).append("#");
      } 
    } 
    if (attCamp.getGuDan()) {
      attCamp.setGuDan(false);
      zhixing = true;
      List<BattleArmy> listB2 = bat.defList;
      int range2 = listB2.size();
      BattleArmy battleArmy = null;
      roundInfo.battleMsg.append("66|def;").append(10).append(";");
      for (int k = 0; k < range2; k++) {
        battleArmy = listB2.get(k);
        CampArmy campArmy = battleArmy.getCampArmy();
        int specialType = (campArmy.getTeamGenreal() == null) ? 0 : ((campArmy.getTeamEffect() > 0.0D) ? 2 : 1);
        if (battleArmy.getTD_defense_e() > 0.0D)
          specialType = 3; 
        int troopHpMax = campArmy.getTroopHp() / 3;
        roundInfo.battleMsg.append(battleArmy.getPosition()).append("|").append(campArmy.getPlayerId()).append("|").append(campArmy.getTroopSerial()).append("|").append(campArmy.getTroopType()).append("|").append(campArmy.getTroopName()).append("|").append(campArmy.getTroopDropType()).append("|").append(battleArmy.getStrategy()).append("|").append(specialType).append("|");
        boolean diyihang = battleArmy.getHaveZhanChe();
        roundInfo.battleMsg.append(campArmy.getIsJuexing()).append("|").append(campArmy.getIsChongFeng()).append("|").append(battleArmy.getIsDajiang()).append("|").append(campArmy.getCopyType()).append("|").append(campArmy.getJueEquip()).append("|").append(campArmy.getAttack()).append("|").append(campArmy.getDefence()).append("|").append(campArmy.getResistePercentage()).append("|");
        if (diyihang) {
          int carid = campArmy.getCarId();
          roundInfo.battleMsg.append(carid).append("|").append(battleArmy.getBigGzNum()).append("|");
        } else if (battleArmy.getZhanchedun() > 0) {
          int carid = 0;
          if (campArmy.getCatapultSkill() == 2 && campArmy.getGeneralId() == 275) {
            carid = 999;
          } else if (campArmy.getCatapultSkill() == 4 && campArmy.getGeneralId() == 275) {
            carid = 879992;
          } 
          if (carid > 0) {
            roundInfo.battleMsg.append(carid).append("|").append(battleArmy.getBigGzNum()).append("|");
          } else {
            roundInfo.battleMsg.append(carid).append("|").append(0).append("|");
          } 
        } else {
          roundInfo.battleMsg.append(0).append("|").append(0).append("|");
        } 
        roundInfo.battleMsg.append(campArmy.getbsPro()).append("|").append(battleArmy.getZfShiled()).append("|").append(battleArmy.getSpecial()).append("|").append(campArmy.getWeiweiHuaide()).append("|").append(battleArmy.getYubaoEffect()).append("|").append(campArmy.getFormationType()).append("|").append(campArmy.getHasbigFormationskill()).append("|").append(campArmy.getFyzShield()).append("|").append(campArmy.getLgdcBuff()).append("|").append(campArmy.getIsBurn()).append("|").append(campArmy.getSex()).append("|").append(campArmy.getIsDeputy()).append("|").append(campArmy.getJxType()).append("|").append(campArmy.getYbTx()).append("|").append(campArmy.getWsb()).append("|").append(battleArmy.getTouXian()).append("|").append("0|").append(battleArmy.getLonglin()).append("|").append(battleArmy.getSangDanType()).append("|0|").append(campArmy.getMissNum()).append("|").append(campArmy.getImmunoNum()).append("|").append(campArmy.getCarPoDunNum()).append("|").append(campArmy.getIsFanShang()).append("|").append(campArmy.getIsBmy()).append("|").append(campArmy.getZhsNum()).append("|").append(campArmy.getMfFire()).append("|").append(battleArmy.getCardebuff()).append("|").append(battleArmy.getQingCheng()).append("|").append(battleArmy.getCarGzLevel()).append("|").append(battleArmy.getHuWei()).append("|").append(battleArmy.getCarTsBj()).append("|").append(battleArmy.getpose()).append("|").append(campArmy.getSneer()).append("|").append(campArmy.getIsBeatMonster()).append("|").append(campArmy.getBeastStar()).append("|").append("0|").append(campArmy.getFkbhHpPro()).append("|").append(campArmy.getIsZhenFaLvUp()).append("|").append(campArmy.getIsFlower()).append("|").append(campArmy.getSunShangXiangZs()).append("|").append(campArmy.getZsMyMa()).append("|").append(campArmy.getSsxMa()).append("|").append(battleArmy.getHuShou()).append("|").append(battleArmy.getFengDao()).append("|").append(battleArmy.getZyNum()).append("|");
        roundInfo.battleMsg.append(campArmy.getHuoYi()).append("|").append(campArmy.getZhaXiang()).append("|").append(campArmy.getHasZh()).append("|").append(campArmy.getLjNum()).append("|null|").append(campArmy.getLeblMa()).append("|").append(campArmy.guzhu).append("|").append(campArmy.getTuiShou()).append("|").append(campArmy.getFuBingNum1()).append("|0|0|").append(campArmy.getJxBuff1()).append("|").append(campArmy.getJxBuff1()).append("|0|0|0|0|").append(campArmy.getTitle1()).append("|0|0|0|").append(campArmy.getTitle()).append("|0|0|0|0|0|0|0|0|0|0|0|0|0|0|0|");
        battleArmy.setCarHp(0);
        battleArmy.setZCdunHp(0);
        battleArmy.setShield(0);
        battleArmy.setHuJia(0);
        for (int l = 0; l < 3; l++) {
          if (diyihang) {
            roundInfo.battleMsg.append(battleArmy.getTroopHp()[l]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(battleArmy.getCarHp()).append("*").append(battleArmy.getCarMaxHp()).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } else if (battleArmy.getZhanchedun() > 0) {
            roundInfo.battleMsg.append(battleArmy.getTroopHp()[l]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(battleArmy.getZCdunHp()).append("*").append(battleArmy.getCarMaxHp()).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } else {
            roundInfo.battleMsg.append(battleArmy.getTroopHp()[l]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(0).append("*").append(0).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } 
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), ";");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 2000;
    } 
    if (defCamp.getGuDan()) {
      defCamp.setGuDan(false);
      zhixing = true;
      List<BattleArmy> listB2 = bat.attList;
      int range2 = listB2.size();
      BattleArmy battleArmy = null;
      roundInfo.battleMsg.append("66|att;").append(10).append(";");
      for (int k = 0; k < range2; k++) {
        battleArmy = listB2.get(k);
        CampArmy campArmy = battleArmy.getCampArmy();
        int specialType = (campArmy.getTeamGenreal() == null) ? 0 : ((campArmy.getTeamEffect() > 0.0D) ? 2 : 1);
        if (battleArmy.getTD_defense_e() > 0.0D)
          specialType = 3; 
        int troopHpMax = campArmy.getTroopHp() / 3;
        roundInfo.battleMsg.append(battleArmy.getPosition()).append("|").append(campArmy.getPlayerId()).append("|").append(campArmy.getTroopSerial()).append("|").append(campArmy.getTroopType()).append("|").append(campArmy.getTroopName()).append("|").append(campArmy.getTroopDropType()).append("|").append(battleArmy.getStrategy()).append("|").append(specialType).append("|");
        boolean diyihang = battleArmy.getHaveZhanChe();
        roundInfo.battleMsg.append(campArmy.getIsJuexing()).append("|").append(campArmy.getIsChongFeng()).append("|").append(battleArmy.getIsDajiang()).append("|").append(campArmy.getCopyType()).append("|").append(campArmy.getJueEquip()).append("|").append(campArmy.getAttack()).append("|").append(campArmy.getDefence()).append("|").append(campArmy.getResistePercentage()).append("|");
        if (diyihang) {
          int carid = campArmy.getCarId();
          roundInfo.battleMsg.append(carid).append("|").append(battleArmy.getBigGzNum()).append("|");
        } else if (battleArmy.getZhanchedun() > 0) {
          int carid = 0;
          if (campArmy.getCatapultSkill() == 2 && campArmy.getGeneralId() == 275) {
            carid = 999;
          } else if (campArmy.getCatapultSkill() == 4 && campArmy.getGeneralId() == 275) {
            carid = 879992;
          } 
          if (carid > 0) {
            roundInfo.battleMsg.append(carid).append("|").append(battleArmy.getBigGzNum()).append("|");
          } else {
            roundInfo.battleMsg.append(carid).append("|").append(0).append("|");
          } 
        } else {
          roundInfo.battleMsg.append(0).append("|").append(0).append("|");
        } 
        roundInfo.battleMsg.append(campArmy.getbsPro()).append("|").append(battleArmy.getZfShiled()).append("|").append(battleArmy.getSpecial()).append("|").append(campArmy.getWeiweiHuaide()).append("|").append(battleArmy.getYubaoEffect()).append("|").append(campArmy.getFormationType()).append("|").append(campArmy.getHasbigFormationskill()).append("|").append(campArmy.getFyzShield()).append("|").append(campArmy.getLgdcBuff()).append("|").append(campArmy.getIsBurn()).append("|").append(campArmy.getSex()).append("|").append(campArmy.getIsDeputy()).append("|").append(campArmy.getJxType()).append("|").append(campArmy.getYbTx()).append("|").append(campArmy.getWsb()).append("|").append(battleArmy.getTouXian()).append("|").append("0|").append(battleArmy.getLonglin()).append("|").append(battleArmy.getSangDanType()).append("|0|").append(campArmy.getMissNum()).append("|").append(campArmy.getImmunoNum()).append("|").append(campArmy.getCarPoDunNum()).append("|").append(campArmy.getIsFanShang()).append("|").append(campArmy.getIsBmy()).append("|").append(campArmy.getZhsNum()).append("|").append(campArmy.getMfFire()).append("|").append(battleArmy.getCardebuff()).append("|").append(battleArmy.getQingCheng()).append("|").append(battleArmy.getCarGzLevel()).append("|").append(battleArmy.getHuWei()).append("|").append(battleArmy.getCarTsBj()).append("|").append(battleArmy.getpose()).append("|").append(campArmy.getSneer()).append("|").append(campArmy.getIsBeatMonster()).append("|").append(campArmy.getBeastStar()).append("|").append("0|").append(campArmy.getFkbhHpPro()).append("|").append(campArmy.getIsZhenFaLvUp()).append("|").append(campArmy.getIsFlower()).append("|").append(campArmy.getSunShangXiangZs()).append("|").append(campArmy.getZsMyMa()).append("|").append(campArmy.getSsxMa()).append("|").append(battleArmy.getHuShou()).append("|").append(battleArmy.getFengDao()).append("|").append(battleArmy.getZyNum()).append("|");
        roundInfo.battleMsg.append(campArmy.getHuoYi()).append("|").append(campArmy.getZhaXiang()).append("|").append(campArmy.getHasZh()).append("|").append(campArmy.getLjNum()).append("|null|").append(campArmy.getLeblMa()).append("|").append(campArmy.guzhu).append("|").append(campArmy.getTuiShou()).append("|").append(campArmy.getFuBingNum1()).append("|0|0|").append(campArmy.getJxBuff1()).append("|").append(campArmy.getJxBuff1()).append("|0|0|0|0|").append(campArmy.getTitle1()).append("|0|0|0|").append(campArmy.getTitle()).append("|0|0|0|0|0|0|0|0|0|0|0|0|0|0|0|");
        battleArmy.setCarHp(0);
        battleArmy.setZCdunHp(0);
        battleArmy.setShield(0);
        battleArmy.setHuJia(0);
        for (int l = 0; l < 3; l++) {
          if (diyihang) {
            roundInfo.battleMsg.append(battleArmy.getTroopHp()[l]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(battleArmy.getCarHp()).append("*").append(battleArmy.getCarMaxHp()).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } else if (battleArmy.getZhanchedun() > 0) {
            roundInfo.battleMsg.append(battleArmy.getTroopHp()[l]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(battleArmy.getZCdunHp()).append("*").append(battleArmy.getCarMaxHp()).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } else {
            roundInfo.battleMsg.append(battleArmy.getTroopHp()[l]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(0).append("*").append(0).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } 
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), ";");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 2000;
    } 
    if (firstRowkilled)
      return true; 
    if (((attCamp.getGeneralId() == 404 && attCamp.getIsJuexing() > 0) || attCamp.getHelpGeneral() == 404) && !defCamp.getGuaMuXiangKan()) {
      defCamp.setGuaMuXiangKan(true);
      zhixing = true;
      List<BattleArmy> listB2 = bat.defList;
      int range2 = listB2.size();
      roundInfo.battleMsg.append("54|att;").append(99).append(";106;null;");
      for (int m = 0; m < range2; m++) {
        int reduce2 = 0;
        BattleArmy batArmy2 = listB2.get(m);
        CampArmy defendCa2 = batArmy2.getCampArmy();
        defendCa2.setTuiShou(4);
        roundInfo.battleMsg.append(batArmy2.getPosition()).append(",");
        int damage2 = attCamp.attEffect - defendCa2.defEffect + attCamp.TACTIC_ATT - defendCa2.TACTIC_DEF;
        if (damage2 < 1000)
          damage2 = 1000; 
        int xinlost2 = DamageSkill(attCamp, batArmy2, defendCa2, 1, damage2, false, dataGetter, bat, roundInfo, m);
        if (m == 0 && batArmy2.getTroopHp()[0] <= 0) {
          roundInfo.defFirstRowKilled = true;
          firstRowkilled = true;
          roundInfo.win = 1;
        } 
        roundInfo.battleMsg.append(xinlost2).append(",").append(batArmy2.getTroopHp()[0]).append(",0,0*");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (((defCamp.getGeneralId() == 404 && defCamp.getIsJuexing() > 0) || defCamp.getHelpGeneral() == 404) && !attCamp.getGuaMuXiangKan()) {
      attCamp.setGuaMuXiangKan(true);
      zhixing = true;
      List<BattleArmy> listB2 = bat.attList;
      int range2 = listB2.size();
      roundInfo.battleMsg.append("54|def;").append(99).append(";106;null;");
      for (int m = 0; m < range2; m++) {
        int reduce2 = 0;
        BattleArmy batArmy2 = listB2.get(m);
        CampArmy defendCa2 = batArmy2.getCampArmy();
        defendCa2.setTuiShou(4);
        roundInfo.battleMsg.append(batArmy2.getPosition()).append(",");
        int damage2 = defCamp.attEffect - defendCa2.defEffect + defCamp.TACTIC_ATT - defendCa2.TACTIC_DEF;
        if (damage2 < 1000)
          damage2 = 1000; 
        int xinlost2 = DamageSkill(defCamp, batArmy2, defendCa2, 0, damage2, false, dataGetter, bat, roundInfo, m);
        if (m == 0 && batArmy2.getTroopHp()[0] <= 0) {
          roundInfo.attFirstRowKilled = true;
          firstRowkilled = true;
          roundInfo.win = 2;
        } 
        roundInfo.battleMsg.append(xinlost2).append(",").append(batArmy2.getTroopHp()[0]).append(",0,0*");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getGeneralId() == 232 && attCamp.getUnionRank() >= 2 && attCamp.getXinBingShangZhen() > 0) {
      int sjzyrow = RandomUtils.nextInt(bat.defList.size());
      BattleArmy zyarmy = bat.defList.get(sjzyrow);
      zyarmy.setZyNum(zyarmy.getZyNum() + 1);
    } 
    if (defCamp.getGeneralId() == 232 && defCamp.getUnionRank() >= 2 && defCamp.getXinBingShangZhen() > 0) {
      int sjzyrow = RandomUtils.nextInt(bat.attList.size());
      BattleArmy zyarmy = bat.attList.get(sjzyrow);
      zyarmy.setZyNum(zyarmy.getZyNum() + 1);
    } 
    if (attCamp.getGeneralId() == 270 && attCamp.getUnionRank() >= 2 && (defCamp.getXinBingShangZhen() > 0 || attCamp.getQlrh())) {
      defCamp.setXinBingShangZhen(0);
      attCamp.setQlrh(false);
      int range3 = bat.getDefList().size();
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB3 = bat.defList;
        int rows = listB3.size();
        int baoji = 0;
        if (attCamp.getTroopType() == 881031)
          baoji = 5; 
        roundInfo.battleMsg.append("105|").append(baoji).append("|def|");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range3; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB3.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 1000; 
          if (baoji > 0)
            damage *= baoji; 
          if (zhaoyunchidiao) {
            damage = 1;
          } else if (defendCa.getChiZhanFa() > 0) {
            damage *= rows - i;
            zhaoyunchidiao = true;
          } 
          int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getGeneralId() == 270 && defCamp.getUnionRank() >= 2 && (attCamp.getXinBingShangZhen() > 0 || defCamp.getQlrh())) {
      attCamp.setXinBingShangZhen(0);
      defCamp.setQlrh(false);
      int range3 = bat.attList.size();
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB3 = bat.attList;
        int rows = listB3.size();
        int baoji = 0;
        if (defCamp.getTroopType() == 881031)
          baoji = 5; 
        roundInfo.battleMsg.append("105|").append(baoji).append("|att|");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range3; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB3.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 1000; 
          if (baoji > 0)
            damage *= baoji; 
          if (zhaoyunchidiao) {
            damage = 1;
          } else if (defendCa.getChiZhanFa() > 0) {
            damage *= rows - i;
            zhaoyunchidiao = true;
          } 
          int xinlost = DamageSkill(defCamp, batArmy, defendCa, 0, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getGeneralId() == 232 && attCamp.getUnionState() > 0 && (attCamp.getXinBingShangZhen() > 0 || defCamp.getXinBingShangZhen() > 0)) {
      defCamp.setXinBingShangZhen(0);
      attCamp.setXinBingShangZhen(0);
      int range3 = bat.getDefList().size();
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB3 = bat.defList;
        int rows = listB3.size();
        roundInfo.battleMsg.append("117|def|");
        boolean zhaoyunchidiao2 = false;
        for (int i2 = 0; i2 < range3; i2++) {
          int reduce3 = 0;
          BattleArmy batArmy3 = listB3.get(i2);
          if (i2 <= 0 || batArmy3.getZyNum() > 0) {
            CampArmy defendCa3 = batArmy3.getCampArmy();
            roundInfo.battleMsg.append(batArmy3.getPosition()).append(",");
            int damage3 = attCamp.attEffect - defendCa3.defEffect + attCamp.TACTIC_ATT - defendCa3.TACTIC_DEF;
            if (damage3 <= 0)
              damage3 = 1000; 
            if (zhaoyunchidiao2) {
              damage3 = 1;
            } else if (defendCa3.getChiZhanFa() > 0) {
              damage3 *= rows - i2;
              zhaoyunchidiao2 = true;
            } 
            if (damage3 >= batArmy3.getTroopHp()[0])
              damage3 = batArmy3.getTroopHp()[0] - 1; 
            int xinlost3 = DamageSkill(attCamp, batArmy3, defendCa3, 1, damage3, false, dataGetter, bat, roundInfo, i2);
            if (i2 == 0 && batArmy3.getTroopHp()[0] <= 0) {
              roundInfo.defFirstRowKilled = true;
              firstRowkilled = true;
              roundInfo.win = 1;
            } 
            roundInfo.battleMsg.append(xinlost3).append(",").append(batArmy3.getTroopHp()[0]).append(",0,0;");
          } 
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getGeneralId() == 232 && defCamp.getUnionState() > 0 && (attCamp.getXinBingShangZhen() > 0 || defCamp.getXinBingShangZhen() > 0)) {
      attCamp.setXinBingShangZhen(0);
      defCamp.setXinBingShangZhen(0);
      int range3 = bat.attList.size();
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB3 = bat.attList;
        int rows = listB3.size();
        roundInfo.battleMsg.append("117|att|");
        boolean zhaoyunchidiao2 = false;
        for (int i2 = 0; i2 < range3; i2++) {
          int reduce3 = 0;
          BattleArmy batArmy3 = listB3.get(i2);
          if (i2 <= 0 || batArmy3.getZyNum() > 0) {
            CampArmy defendCa3 = batArmy3.getCampArmy();
            roundInfo.battleMsg.append(batArmy3.getPosition()).append(",");
            int damage3 = defCamp.attEffect - defendCa3.defEffect + defCamp.TACTIC_ATT - defendCa3.TACTIC_DEF;
            if (damage3 <= 0)
              damage3 = 1000; 
            if (zhaoyunchidiao2) {
              damage3 = 1;
            } else if (defendCa3.getChiZhanFa() > 0) {
              damage3 *= rows - i2;
              zhaoyunchidiao2 = true;
            } 
            if (damage3 >= batArmy3.getTroopHp()[0])
              damage3 = batArmy3.getTroopHp()[0] - 1; 
            int xinlost3 = DamageSkill(defCamp, batArmy3, defendCa3, 0, damage3, false, dataGetter, bat, roundInfo, i2);
            if (i2 == 0 && batArmy3.getTroopHp()[0] <= 0) {
              roundInfo.attFirstRowKilled = true;
              firstRowkilled = true;
              roundInfo.win = 2;
            } 
            roundInfo.battleMsg.append(xinlost3).append(",").append(batArmy3.getTroopHp()[0]).append(",0,0,0;");
          } 
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getBzStatus() > 0 && attCamp.getFormationType() == 1 && attCamp.getBzStatuCode()) {
      Random rand = new Random();
      if (attCamp.srpz_range.intValue() == 0)
        attCamp.srpz_range = Integer.valueOf(rand.nextInt(6)); 
      int range2 = 3;
      if (range2 > 0) {
        zhixing = true;
        List<BattleArmy> listB4 = bat.defList;
        if (range2 > listB4.size())
          range2 = listB4.size(); 
        int cur_index = 1;
        if (attCamp.srpz_range.intValue() <= attCamp.cur_index.intValue()) {
          roundInfo.battleMsg.append(113).append("|").append(-attCamp.cur_index.intValue()).append("|").append("def|");
          attCamp.srpz_range = Integer.valueOf(0);
          cur_index = 2;
          attCamp.setBzStatus(attCamp.getBzStatus() - 1);
        } else {
          roundInfo.battleMsg.append(113).append("|").append(attCamp.cur_index).append("|").append("def|");
        } 
        for (int i2 = 0; i2 < range2; i2++) {
          BattleArmy batArmy4 = listB4.get(i2);
          CampArmy defendCa4 = batArmy4.getCampArmy();
          roundInfo.battleMsg.append(batArmy4.getPosition()).append(",");
          int damage4 = (attCamp.attEffect - defendCa4.defEffect + attCamp.TACTIC_ATT - defendCa4.TACTIC_DEF) * cur_index;
          if (damage4 <= 0)
            damage4 = 25000 * cur_index; 
          int xinlost4 = DamageSkill(attCamp, batArmy4, defendCa4, 1, damage4, false, dataGetter, bat, roundInfo, i2);
          if (i2 == 0 && batArmy4.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
          } 
          roundInfo.battleMsg.append(xinlost4).append(",").append(batArmy4.getTroopHp()[0]).append(",0;");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        firstRowkilled = true;
        CampArmy campArmy4 = attCamp;
        campArmy4.cur_index = Integer.valueOf(campArmy4.cur_index.intValue() + 1);
      } 
    } 
    if (defCamp.getBzStatus() > 0 && defCamp.getFormationType() == 1 && defCamp.getBzStatuCode()) {
      Random rand = new Random();
      if (defCamp.srpz_range.intValue() == 0)
        defCamp.srpz_range = Integer.valueOf(rand.nextInt(6)); 
      int range2 = 3;
      if (range2 > 0) {
        zhixing = true;
        List<BattleArmy> listA = bat.attList;
        if (range2 > listA.size())
          range2 = listA.size(); 
        int cur_index = 1;
        if (defCamp.srpz_range.intValue() <= defCamp.cur_index.intValue()) {
          roundInfo.battleMsg.append(113).append("|").append(-defCamp.cur_index.intValue()).append("|").append("att|");
          defCamp.srpz_range = Integer.valueOf(0);
          cur_index = 2;
          defCamp.setBzStatus(attCamp.getBzStatus() - 1);
        } else {
          roundInfo.battleMsg.append(113).append("|").append(defCamp.cur_index).append("|").append("att|");
        } 
        for (int i2 = 0; i2 < range2; i2++) {
          BattleArmy batArmy4 = listA.get(i2);
          CampArmy attendCa = batArmy4.getCampArmy();
          roundInfo.battleMsg.append(batArmy4.getPosition()).append(",");
          int damage4 = (attCamp.attEffect - attendCa.defEffect + attCamp.TACTIC_ATT - attendCa.TACTIC_DEF) * cur_index;
          if (damage4 <= 0)
            damage4 = 25000 * cur_index; 
          int xinlost4 = DamageSkill(attCamp, batArmy4, attendCa, 0, damage4, false, dataGetter, bat, roundInfo, i2);
          if (i2 == 0 && batArmy4.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
          } 
          roundInfo.battleMsg.append(xinlost4).append(",").append(batArmy4.getTroopHp()[0]).append(",0;");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        firstRowkilled = true;
        CampArmy campArmy5 = attCamp;
        campArmy5.cur_index = Integer.valueOf(campArmy5.cur_index.intValue() + 1);
      } 
    } 
    if (defCamp.getBzStatus() > 0 && defCamp.getFormationType() == 1) {
      defCamp.setBzStatus(defCamp.getBzStatus() - 1);
      Random rand = new Random();
      int randomNumber = rand.nextInt(6);
      List<Integer> list_data = new ArrayList<>();
      for (int ir = 0; ir < randomNumber; ir++) {
        if (ir == randomNumber - 1) {
          list_data.add(Integer.valueOf((ir < 0) ? (ir + 1) : (-ir - 1)));
        } else {
          list_data.add(Integer.valueOf(ir + 1));
        } 
      } 
      int range4 = bat.getAttList().size();
      if (range4 > 0) {
        zhixing = true;
        List<BattleArmy> listA2 = bat.attList;
        int rows2 = listA2.size();
        boolean zhaoyunchidiao3 = false;
        for (int ie = 0; ie < randomNumber; ie++) {
          int cur_index2 = (((Integer)list_data.get(ie)).intValue() > 0) ? 2 : 1;
          roundInfo.battleMsg.append(113).append("|").append(list_data.get(ie)).append("|").append("att|");
          for (int i3 = 0; i3 < 3; i3++) {
            BattleArmy batArmy5 = listA2.get(i3);
            CampArmy attendCa2 = batArmy5.getCampArmy();
            roundInfo.battleMsg.append(batArmy5.getPosition()).append(",");
            int damage5 = (defCamp.attEffect - attendCa2.defEffect + defCamp.TACTIC_ATT - attendCa2.TACTIC_DEF) * cur_index2;
            if (damage5 <= 0)
              damage5 = 25000 * cur_index2; 
            int xinlost5 = DamageSkill(attCamp, batArmy5, attendCa2, 1, damage5, false, dataGetter, bat, roundInfo, i3);
            if (i3 == 0 && batArmy5.getTroopHp()[0] <= 0) {
              roundInfo.defFirstRowKilled = true;
              firstRowkilled = true;
              roundInfo.win = 1;
            } 
            roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy5.getTroopHp()[0]).append(",0;");
          } 
          roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        } 
        roundInfo.nextMinExeTime += 1000;
      } 
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getGeneralId() == 107 && attCamp.getLegendEvoke() && attCamp.getChapterId() >= 3 && attCamp.getChaunqiccxu()) {
      attCamp.setChaunqiccxu(false);
      int range = bat.getDefList().size();
      if (range > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows = listB.size();
        roundInfo.battleMsg.append("153|def|");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 40000; 
          int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (attCamp.getGeneralId() == 107 && attCamp.getLegendEvoke() && attCamp.getChapterId() >= 2 && attCamp.getChaunqiccxu()) {
      attCamp.setChaunqiccxu(false);
      int range = bat.getDefList().size();
      if (range > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows = listB.size();
        roundInfo.battleMsg.append("152|def|");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 40000; 
          int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getGeneralId() == 107 && defCamp.getLegendEvoke() && defCamp.getChapterId() >= 2 && defCamp.getChaunqiccxu()) {
      defCamp.setChaunqiccxu(false);
      int range = bat.attList.size();
      if (range > 0) {
        List<BattleArmy> listB = bat.attList;
        int rows = listB.size();
        roundInfo.battleMsg.append("152|att|");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 40000; 
          int xinlost = DamageSkill(defCamp, batArmy, defendCa, 0, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (firstRowkilled)
      return true; 
    if (defCamp.getGeneralId() == 107 && defCamp.getLegendEvoke() && defCamp.getChapterId() >= 3 && defCamp.getChaunqiccxu()) {
      defCamp.setChaunqiccxu(false);
      int range = bat.attList.size();
      if (range > 0) {
        List<BattleArmy> listB = bat.attList;
        int rows = listB.size();
        roundInfo.battleMsg.append("153|att|");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 40000; 
          int xinlost = DamageSkill(defCamp, batArmy, defendCa, 0, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getGeneralId() == 107 && attCamp.getLegendEvoke() && attCamp.getChaunqiccxu()) {
      attCamp.setChaunqiccxu(false);
      int range = (bat.defList.size() >= 3) ? 3 : bat.defList.size();
      if (range > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows = listB.size();
        roundInfo.battleMsg.append("151|def|");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 30000; 
          int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getGeneralId() == 107 && defCamp.getLegendEvoke() && defCamp.getChaunqiccxu()) {
      defCamp.setChaunqiccxu(false);
      int range = (bat.attList.size() >= 3) ? 3 : bat.attList.size();
      if (range > 0) {
        List<BattleArmy> listB = bat.attList;
        int rows = listB.size();
        roundInfo.battleMsg.append("151|att|");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 30000; 
          int xinlost = DamageSkill(defCamp, batArmy, defendCa, 0, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0;");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getGeneralId() == 269 && attCamp.getLegendEvoke() && attCamp.getChapterId() >= 4 && attCamp.getMaifu() >= 1) {
      int range = (bat.defList.size() >= 5) ? 5 : bat.defList.size();
      if (range > 0) {
        List<BattleArmy> listB = bat.defList;
        int rows = listB.size();
        int suiji = 0;
        suiji = RandomUtils.nextInt(100);
        if (suiji > 80 && suiji < 100) {
          roundInfo.battleMsg.append("#244|att|14,4#249|att|14#247|att|1|0,1,2,3,4,5#154|att|16#186|att;122;130;;");
          roundInfo.battleMsg.append("#179|att|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:896576#186|att;122;130;;");
        } 
        if (suiji > 60 && suiji < 80) {
          roundInfo.battleMsg.append("#244|att|14,2#249|att|0#247|att|2|0,1,2,3,4,5#154|att|11*12#54|att;122;130;;");
          roundInfo.battleMsg.append("#179|att|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:896576#186|att;122;130;;");
        } 
        if (suiji > 50 && suiji < 60) {
          roundInfo.battleMsg.append("#244|att|14,2#249|att|4#54|att;122;130;;");
          roundInfo.battleMsg.append("#179|att|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:896576#186|att;122;130;;");
        } 
        if (suiji > 40 && suiji < 50) {
          roundInfo.battleMsg.append("#244|att|14,2#249|att|6#54|att;122;130;;");
          roundInfo.battleMsg.append("#179|att|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:896576#186|att;122;130;;");
        } 
        if (suiji > 30 && suiji < 40) {
          roundInfo.battleMsg.append("#244|att|14,2#249|att|8#54|att;122;130;;");
          roundInfo.battleMsg.append("#179|att|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:896576#186|att;122;130;;");
        } 
        if (suiji > 20 && suiji < 30) {
          roundInfo.battleMsg.append("#244|att|14,2#249|att|10#54|att;122;130;;");
          roundInfo.battleMsg.append("#179|att|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:896576#186|att;122;130;;");
        } 
        if (suiji > 10 && suiji < 20) {
          roundInfo.battleMsg.append("#244|att|14,2#249|att|12#54|att;122;130;;");
          roundInfo.battleMsg.append("#179|att|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:896576#186|att;122;130;;");
        } 
        if (suiji > 0 && suiji < 10) {
          roundInfo.battleMsg.append("#244|att|14,2#249|att|2#54|att;122;130;;");
          roundInfo.battleMsg.append("#179|att|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:896576#186|att;122;130;;");
        } 
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 100000; 
          int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0,1*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), ";null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;0|0;|0;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;0|0;0|0;null|null;null|1,2,3,4,5;null|null;null|null;null|null#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getGeneralId() == 269 && defCamp.getLegendEvoke() && defCamp.getChapterId() >= 4 && defCamp.getMaifu() >= 1) {
      int range = (bat.attList.size() >= 5) ? 5 : bat.attList.size();
      if (range > 0) {
        List<BattleArmy> listB = bat.attList;
        int rows = listB.size();
        int suiji = 0;
        suiji = RandomUtils.nextInt(100);
        if (suiji > 80 && suiji < 100) {
          roundInfo.battleMsg.append("#244|def|14,4#249|def|14#247|def|1|0,1,2,3,4,5#154|def|16#186|def;122;130;;");
          roundInfo.battleMsg.append("#179|def|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:896576#186|def;122;130;;");
        } 
        if (suiji > 60 && suiji < 80) {
          roundInfo.battleMsg.append("#244|def|14,2#249|def|0#247|def|2|0,1,2,3,4,5#154|def|11*12#54|def;122;130;;");
          roundInfo.battleMsg.append("#179|def|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:896576#186|def;122;130;;");
        } 
        if (suiji > 50 && suiji < 60) {
          roundInfo.battleMsg.append("#244|def|14,2#249|def|4#54|def;122;130;;");
          roundInfo.battleMsg.append("#179|def|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:896576#186|def;122;130;;");
        } 
        if (suiji > 40 && suiji < 50) {
          roundInfo.battleMsg.append("#244|def|14,2#249|def|6#54|def;122;130;;");
          roundInfo.battleMsg.append("#179|def|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:896576#186|def;122;130;;");
        } 
        if (suiji > 30 && suiji < 40) {
          roundInfo.battleMsg.append("#244|def|14,2#249|def|8#54|def;122;130;;");
          roundInfo.battleMsg.append("#179|def|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:896576#186|def;122;130;;");
        } 
        if (suiji > 20 && suiji < 30) {
          roundInfo.battleMsg.append("#244|def|14,2#249|def|10#54|def;122;130;;");
          roundInfo.battleMsg.append("#179|def|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:896576#186|def;122;130;;");
        } 
        if (suiji > 10 && suiji < 20) {
          roundInfo.battleMsg.append("#244|def|14,2#249|def|12#54|def;122;130;;");
          roundInfo.battleMsg.append("#179|def|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:896576#186|def;122;130;;");
        } 
        if (suiji > 0 && suiji < 10) {
          roundInfo.battleMsg.append("#244|def|14,2#249|def|2#54|def;122;130;;");
          roundInfo.battleMsg.append("#179|def|1:1006719,2:1006719,3:1006719,4:1006719,5:1006719,6:896576#186|def;122;130;;");
        } 
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = defCamp.attEffect * (int)(defCamp.maifu * 0.5D) - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 50000; 
          int xinlost = DamageSkill(defCamp, batArmy, defendCa, 0, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), ";null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;0|0;|0;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;0|0;0|0;null|null;null|1,2,3,4,5;null|null;null|null;null|null#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (attCamp.getGeneralId() == 269 && attCamp.getLegendEvoke() && attCamp.zgFeiLz) {
      attCamp.zgFeiLz = false;
      attCamp.setMaifu(0);
      int range = (bat.defList.size() >= 5) ? 5 : bat.defList.size();
      if (range > 0) {
        List<BattleArmy> listB = bat.defList;
        int rows = listB.size();
        roundInfo.battleMsg.append("186|att;123;131;;");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 100000; 
          int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0,1*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), ";null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;0|0;|0;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;0|0;0|0;null|null;null|1,2,3,4,5;null|null;null|null;null|null#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getGeneralId() == 269 && defCamp.getLegendEvoke() && defCamp.zgFeiLz) {
      defCamp.zgFeiLz = false;
      defCamp.setMaifu(0);
      int range = (bat.attList.size() >= 5) ? 5 : bat.attList.size();
      if (range > 0) {
        List<BattleArmy> listB = bat.attList;
        int rows = listB.size();
        roundInfo.battleMsg.append("186|def;123;131;;");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 100000; 
          int xinlost = DamageSkill(defCamp, batArmy, defendCa, 0, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), ";null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;0|0;|0;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;0|0;0|0;null|null;null|1,2,3,4,5;null|null;null|null;null|null#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getGeneralId() == 269 && attCamp.getLegendEvoke() && attCamp.zgTianFz) {
      attCamp.zgTianFz = false;
      attCamp.setMaifu((attCamp.getMaifu() < 10) ? (attCamp.getMaifu() + 1) : attCamp.getMaifu());
      int range = (bat.defList.size() >= 5) ? 5 : bat.defList.size();
      if (range > 0) {
        List<BattleArmy> listB = bat.defList;
        int rows = listB.size();
        roundInfo.battleMsg.append("186|att;122;130;;");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = attCamp.attEffect * (int)(attCamp.maifu * 0.5D) - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 50000; 
          int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), ";null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;0|0;|0;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;0|0;0|0;null|null;null|1,2,3,4,5;null|null;null|null;null|null#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getGeneralId() == 269 && defCamp.getLegendEvoke() && defCamp.zgTianFz) {
      defCamp.zgTianFz = false;
      defCamp.setMaifu((defCamp.getMaifu() < 10) ? (defCamp.getMaifu() + 1) : defCamp.getMaifu());
      int range = (bat.attList.size() >= 5) ? 5 : bat.attList.size();
      if (range > 0) {
        List<BattleArmy> listB = bat.attList;
        int rows = listB.size();
        roundInfo.battleMsg.append("186|def;122;130;;");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = defCamp.attEffect * (int)(defCamp.maifu * 0.5D) - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 50000; 
          int xinlost = DamageSkill(defCamp, batArmy, defendCa, 0, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), ";null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;0|0;|0;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;0|0;0|0;null|null;null|1,2,3,4,5;null|null;null|null;null|null#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getGeneralId() == 269 && roundInfo.attBattleArmy.getIsDajiang() >= 1 && roundInfo.attBattleArmy.getShield() <= 100 && attCamp.getLegendEvoke() && attCamp.zgDiZz) {
      attCamp.zgDiZz = false;
      int range = (bat.defList.size() >= 5) ? 5 : bat.defList.size();
      for (int ie = 0; ie < 5; ie++) {
        if (range > 0) {
          List<BattleArmy> listB = bat.defList;
          int rows = listB.size();
          roundInfo.battleMsg.append("186|att;122;130;;");
          for (int i = 0; i < range; i++) {
            BattleArmy batArmy = listB.get(i);
            CampArmy defendCa = batArmy.getCampArmy();
            roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
            int damage = attCamp.attEffect * (int)(attCamp.maifu * 0.5D) - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
            if (damage <= 0)
              damage = 50000; 
            int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, i);
            if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
              roundInfo.defFirstRowKilled = true;
              firstRowkilled = true;
              roundInfo.win = 1;
            } 
            roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0,1*");
          } 
          roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), ";null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;0|0;|0;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;0|0;0|0;null|null;null|1,2,3,4,5;null|null;null|null;null|null#");
          roundInfo.nextMinExeTime += 500;
        } 
      } 
      roundInfo.nextMinExeTime += 500;
    } 
    if (defCamp.getGeneralId() == 269 && roundInfo.defBattleArmy.getIsDajiang() >= 1 && roundInfo.defBattleArmy.getShield() <= 100 && defCamp.getLegendEvoke() && defCamp.zgDiZz) {
      defCamp.zgDiZz = false;
      int range = (bat.attList.size() >= 5) ? 5 : bat.attList.size();
      for (int ie = 0; ie < 5; ie++) {
        if (range > 0) {
          List<BattleArmy> listA = bat.attList;
          int rows = listA.size();
          roundInfo.battleMsg.append("186|def;122;130;;");
          for (int i = 0; i < range; i++) {
            BattleArmy batArmy = listA.get(i);
            CampArmy defendCa = batArmy.getCampArmy();
            roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
            int damage = defCamp.attEffect * (int)(defCamp.maifu * 0.5D) - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
            if (damage <= 0)
              damage = 50000; 
            int xinlost = DamageSkill(defCamp, batArmy, defendCa, 0, damage, false, dataGetter, bat, roundInfo, i);
            if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
              roundInfo.attFirstRowKilled = true;
              firstRowkilled = true;
              roundInfo.win = 2;
            } 
            roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0*");
          } 
          roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), ";null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;0|0;|0;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;null|null;0|0;0|0;null|null;null|1,2,3,4,5;null|null;null|null;null|null#");
          roundInfo.nextMinExeTime += 500;
        } 
      } 
      roundInfo.nextMinExeTime += 1000;
    } 
    if (attCamp.getYfYubao() && !attCamp.getyfYubaoSkill() && attCamp.legendEvoke) {
      StringBuilder longhunattstr = new StringBuilder();
      attCamp.setyfYubaoSkill(true);
      for (int i = 0; i < bat.attList.size(); i++) {
        BattleArmy attbattleArmy = bat.attList.get(i);
        int maxhpadd = attbattleArmy.getCampArmy().getTroopHp() / 3 * 101 / 100;
        int caocaohp = attbattleArmy.getShield();
        if (caocaohp < maxhpadd) {
          int adddun = maxhpadd - caocaohp;
          if (adddun > 0) {
            attbattleArmy.setShield(attbattleArmy.getShield() + adddun);
            attbattleArmy.setMaxShield(attbattleArmy.getShield());
            attbattleArmy.setShiledType(1);
            longhunattstr.append(attbattleArmy.getPosition()).append(",").append(adddun).append("*");
          } 
        } 
      } 
      if (longhunattstr.length() > 0) {
        roundInfo.battleMsg.append("168|att|").append(longhunattstr.toString());
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.battleMsg.append("31|0#");
        roundInfo.nextMinExeTime += 2000;
        attCamp.setMhxx(0);
      } 
    } 
    if (defCamp.getYfYubao() && !defCamp.getyfYubaoSkill() && defCamp.legendEvoke) {
      StringBuilder longhunattstr = new StringBuilder();
      defCamp.setyfYubaoSkill(true);
      for (int i = 0; i < bat.defList.size(); i++) {
        BattleArmy defbattleArmy = bat.defList.get(i);
        int maxhpadd = defbattleArmy.getCampArmy().getTroopHp() / 3 * 101 / 100;
        int caocaohp = defbattleArmy.getShield();
        if (caocaohp < maxhpadd) {
          int adddun = maxhpadd - caocaohp;
          if (adddun > 0) {
            defbattleArmy.setShield(defbattleArmy.getShield() + adddun);
            defbattleArmy.setMaxShield(defbattleArmy.getShield());
            defbattleArmy.setShiledType(1);
            longhunattstr.append(defbattleArmy.getPosition()).append(",").append(adddun).append("*");
          } 
        } 
      } 
      if (longhunattstr.length() > 0) {
        roundInfo.battleMsg.append("168|def|").append(longhunattstr.toString());
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.battleMsg.append("31|0#");
        roundInfo.nextMinExeTime += 2000;
        defCamp.setMhxx(0);
      } 
    } 
    if (attCamp.qiangyiDef <= 0 && attCamp.chapterId >= 4 && attCamp.getGeneralId() == 204) {
      attCamp.qiangyiDef = attCamp.getDefEffect();
      System.out.println("=====>qiangyiDef" + attCamp.qiangyiDef);
    } 
    if (defCamp.qiangyiDef <= 0 && defCamp.chapterId >= 4 && defCamp.getGeneralId() == 204)
      defCamp.qiangyiDef = defCamp.getDefEffect(); 
    if (firstRowkilled)
      return true; 
    if (attCamp.getGeneralId() == 204 && attCamp.getLegendEvoke() && attCamp.getQiangyi() >= 7 && attCamp.chapterId >= 5) {
      attCamp.setZyQt(true);
      int range = (bat.defList.size() >= 3) ? 3 : bat.defList.size();
      if (range > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows = listB.size();
        roundInfo.battleMsg.append("54|att;144;")
          .append(152)
          .append(";;");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 150000; 
          int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 1000;
      } 
    } 
    if (defCamp.getGeneralId() == 204 && defCamp.getLegendEvoke() && defCamp.getQiangyi() >= 7 && defCamp.chapterId >= 5) {
      defCamp.setZyQt(true);
      int range = (bat.attList.size() >= 3) ? 3 : bat.attList.size();
      if (range > 0) {
        List<BattleArmy> listB = bat.attList;
        int rows = listB.size();
        roundInfo.battleMsg.append("54|def;144;")
          .append(152)
          .append(";;");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 150000; 
          int xinlost = DamageSkill(defCamp, batArmy, defendCa, 0, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 1000;
      } 
    } 
    if (attCamp.getZyQt()) {
      StringBuilder longhunattstr = new StringBuilder();
      attCamp.setZyQt(false);
      for (int i = 0; i < bat.attList.size(); i++) {
        BattleArmy attbattleArmy = bat.attList.get(i);
        double maxhpadd = attbattleArmy.getCampArmy().getTroopHp() / 3.0D * 0.5D;
        int caocaohp = attbattleArmy.getShield();
        if (caocaohp < maxhpadd) {
          int adddun = (int)maxhpadd - caocaohp;
          if (adddun > 0) {
            attbattleArmy.setShield(attbattleArmy.getShield() + adddun);
            attbattleArmy.setMaxShield(attbattleArmy.getShield());
            attbattleArmy.setShiledType(1);
            longhunattstr.append(attbattleArmy.getPosition()).append(",").append(adddun).append("*");
          } 
        } 
      } 
      if (longhunattstr.length() > 0) {
        roundInfo.battleMsg.append("168|att|").append(longhunattstr.toString());
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.battleMsg.append("31|0#");
        roundInfo.nextMinExeTime += 2000;
        attCamp.setMhxx(0);
      } 
    } 
    if (defCamp.getZyQt()) {
      StringBuilder longhunattstr = new StringBuilder();
      defCamp.setZyQt(false);
      for (int i = 0; i < bat.defList.size(); i++) {
        BattleArmy defbattleArmy = bat.defList.get(i);
        double maxhpadd = defbattleArmy.getCampArmy().getTroopHp() / 3.0D * 0.5D;
        int caocaohp = defbattleArmy.getShield();
        if (caocaohp < maxhpadd) {
          int adddun = (int)maxhpadd - caocaohp;
          if (adddun > 0) {
            defbattleArmy.setShield(defbattleArmy.getShield() + adddun);
            defbattleArmy.setMaxShield(defbattleArmy.getShield());
            defbattleArmy.setShiledType(1);
            longhunattstr.append(defbattleArmy.getPosition()).append(",").append(adddun).append("*");
          } 
        } 
      } 
      if (longhunattstr.length() > 0) {
        roundInfo.battleMsg.append("168|def|").append(longhunattstr.toString());
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.battleMsg.append("31|0#");
        roundInfo.nextMinExeTime += 2000;
        defCamp.setMhxx(0);
      } 
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getGeneralId() == 204 && attCamp.getLegendEvoke() && attCamp.getQiangyi() >= 15 && attCamp.chapterId >= 6) {
      attCamp.setQiangyi(attCamp.getQiangyi() - 15);
      int range = (bat.defList.size() >= 3) ? 3 : bat.defList.size();
      if (range > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows = listB.size();
        roundInfo.battleMsg.append("54|att;145;")
          .append(153)
          .append(";;");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 300000; 
          int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 1000;
      } 
    } 
    if (defCamp.getGeneralId() == 204 && defCamp.getLegendEvoke() && defCamp.getQiangyi() >= 15 && defCamp.chapterId >= 6) {
      defCamp.setQiangyi(defCamp.qiangyi - 15);
      int range = (bat.attList.size() >= 5) ? 5 : bat.attList.size();
      if (range > 0) {
        List<BattleArmy> listB = bat.attList;
        int rows = listB.size();
        roundInfo.battleMsg.append("54|def;145;")
          .append(153)
          .append(";;");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 300000; 
          int xinlost = DamageSkill(defCamp, batArmy, defendCa, 0, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 1000;
      } 
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getGeneralId() == 281 && attCamp.getScZsWin() && attCamp.legendEvoke && attCamp.chapterId >= 1) {
      attCamp.setScZsWin(false);
      int range = (bat.defList.size() >= 5) ? 5 : bat.defList.size();
      if (range > 0) {
        List<BattleArmy> listB = bat.defList;
        for (int e = 0; e < 2; e++) {
          roundInfo.battleMsg.append("54|att;").append(111).append(";")
            .append(118)
            .append(";;");
          for (int i = 0; i < range; i++) {
            int reduce = 0;
            BattleArmy batArmy = listB.get(i);
            CampArmy defendCa = batArmy.getCampArmy();
            roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
            int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
            if (damage <= 0)
              damage = 5000; 
            int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, i);
            if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
              roundInfo.defFirstRowKilled = true;
              firstRowkilled = true;
              roundInfo.win = 1;
            } 
            roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0,0*");
          } 
          roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        } 
        roundInfo.battleMsg.append(163).append("|").append("att|").append(roundInfo.attBattleArmy.getPosition()).append(",1#");
        roundInfo.nextMinExeTime += 1000;
      } 
    } 
    if (defCamp.getGeneralId() == 281 && defCamp.getScZsWin() && defCamp.legendEvoke && defCamp.chapterId >= 1) {
      defCamp.setScZsWin(false);
      int range = (bat.attList.size() >= 5) ? 5 : bat.attList.size();
      if (range > 0) {
        List<BattleArmy> listB = bat.attList;
        int rows = listB.size();
        roundInfo.battleMsg.append("54|def;").append(111).append(";")
          .append(118)
          .append(";;");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 50000; 
          int xinlost = DamageSkill(defCamp, batArmy, defendCa, 0, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0,0*");
          roundInfo.battleMsg.append(163).append("|").append("def|").append(roundInfo.defBattleArmy.getPosition()).append(",1#");
          roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        } 
        roundInfo.nextMinExeTime += 1000;
      } 
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getGeneralId() == 281 && attCamp.isScCarPo && attCamp.legendEvoke && attCamp.chapterId >= 3) {
      System.out.println("=====>攻方战车" + attCamp.isScCarPo);
      attCamp.isScCarPo = false;
      int range = (bat.defList.size() >= 5) ? 5 : bat.defList.size();
      if (range > 0) {
        List<BattleArmy> listB = bat.defList;
        roundInfo.battleMsg.append("54|att;").append(111).append(";")
          .append(118)
          .append(";;");
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 5000; 
          int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 1000;
      } 
    } 
    if (defCamp.getGeneralId() == 281 && defCamp.isScCarPo && defCamp.legendEvoke && defCamp.chapterId >= 3) {
      System.out.println("=====>防守战车" + attCamp.isScCarPo);
      defCamp.isScCarPo = false;
      int range = (bat.attList.size() >= 5) ? 5 : bat.attList.size();
      if (range > 0) {
        List<BattleArmy> listB = bat.attList;
        int rows = listB.size();
        roundInfo.battleMsg.append("54|def;").append(111).append(";")
          .append(118)
          .append(";;");
        boolean zhaoyunchidiao = false;
        for (int i = 0; i < range; i++) {
          int reduce = 0;
          BattleArmy batArmy = listB.get(i);
          CampArmy defendCa = batArmy.getCampArmy();
          roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
          int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
          if (damage <= 0)
            damage = 50000; 
          int xinlost = DamageSkill(defCamp, batArmy, defendCa, 0, damage, false, dataGetter, bat, roundInfo, i);
          if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
          } 
          roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0,0*");
          roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        } 
        roundInfo.nextMinExeTime += 1000;
      } 
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getGeneralId() == 281 && attCamp.isjuexing > 0 && attCamp.getHuXiao() && attCamp.getSneer() <= 0) {
      attCamp.setHuXiao(false);
      int range = 3;
      int zfdonghua = 84;
      int tacname = 90;
      if (attCamp.getHelpGeneral() == 403) {
        range = 5;
        zfdonghua = 96;
        tacname = 103;
      } 
      zhixing = true;
      List<BattleArmy> listB = bat.defList;
      int rows = listB.size();
      if (range > rows)
        range = rows; 
      roundInfo.battleMsg.append("54|att;").append(zfdonghua).append(";").append(tacname).append(";null").append(";");
      boolean zhaoyunchidiao = false;
      for (int i = 0; i < range; i++) {
        int reduce = 0;
        BattleArmy batArmy = listB.get(i);
        CampArmy defendCa = batArmy.getCampArmy();
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
        int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          damage *= rows - i;
          zhaoyunchidiao = true;
        } 
        int xinlost = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, i);
        if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
          roundInfo.defFirstRowKilled = true;
          firstRowkilled = true;
          roundInfo.win = 1;
        } 
        roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0*");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (defCamp.getGeneralId() == 281 && defCamp.isjuexing > 0 && defCamp.getHuXiao() && defCamp.getSneer() <= 0) {
      defCamp.setHuXiao(false);
      int range = 3;
      int zfdonghua = 84;
      int tacname = 90;
      if (defCamp.getHelpGeneral() == 403) {
        range = 5;
        zfdonghua = 96;
        tacname = 103;
      } 
      zhixing = true;
      List<BattleArmy> listB = bat.attList;
      int rows = listB.size();
      if (range > rows)
        range = rows; 
      roundInfo.battleMsg.append("54|def;").append(zfdonghua).append(";").append(tacname).append(";null").append(";");
      boolean zhaoyunchidiao = false;
      for (int i = 0; i < range; i++) {
        int reduce = 0;
        BattleArmy batArmy = listB.get(i);
        CampArmy defendCa = batArmy.getCampArmy();
        roundInfo.battleMsg.append(batArmy.getPosition()).append(",");
        int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
        if (damage < 1000)
          damage = 1000; 
        if (zhaoyunchidiao) {
          damage = 1;
        } else if (defendCa.getChiZhanFa() > 0) {
          damage *= rows - i;
          zhaoyunchidiao = true;
        } 
        int xinlost = DamageSkill(defCamp, batArmy, defendCa, 0, damage, false, dataGetter, bat, roundInfo, i);
        if (i == 0 && batArmy.getTroopHp()[0] <= 0) {
          roundInfo.attFirstRowKilled = true;
          firstRowkilled = true;
          roundInfo.win = 2;
        } 
        roundInfo.battleMsg.append(xinlost).append(",").append(batArmy.getTroopHp()[0]).append(",0,0*");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getGeneralId() == 201 && attCamp.getIsJuexing() > 0 && attCamp.getChapterId() >= 1) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (attCamp.getJxBuff() >= 1) {
        range3 = 3;
        jineng = 132;
        weili = 10;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|att;").append(jineng).append(";139;null;");
        boolean zhaoyunchidiao3 = false;
        int xuebili2 = (roundInfo.attBattleArmy.getBloodOrg() - roundInfo.attBattleArmy.getTroopHp()[0]) * 80 / 100;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili2)
            damage6 = xuebili2; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getGeneralId() == 201 || batArmy6.getCampArmy().getChapterId() > 0) {
            damage6 = attCamp.attEffect - defendCa6.defEffect + attCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(attCamp, batArmy6, defendCa6, 1, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
            if (jineng == 132 && attCamp.getJxBuff() >= 0)
              attCamp.setJxBuff(attCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (attCamp.getGeneralId() == 201 && attCamp.getIsJuexing() > 0 && attCamp.getChapterId() >= 2) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (attCamp.getJxBuff() >= 2) {
        range3 = 4;
        jineng = 149;
        weili = 20;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|att;").append(jineng).append(";139;null;");
        boolean zhaoyunchidiao3 = false;
        int xuebili2 = (roundInfo.attBattleArmy.getBloodOrg() - roundInfo.attBattleArmy.getTroopHp()[0]) * 80 / 100;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili2)
            damage6 = xuebili2; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getGeneralId() == 201 || batArmy6.getCampArmy().getChapterId() > 0) {
            damage6 = attCamp.attEffect - defendCa6.defEffect + attCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(attCamp, batArmy6, defendCa6, 1, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
            if (jineng == 149 && attCamp.getJxBuff() >= 0)
              attCamp.setJxBuff(attCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (attCamp.getGeneralId() == 201 && attCamp.getIsJuexing() > 0 && attCamp.getChapterId() >= 3) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (attCamp.getJxBuff() >= 3) {
        range3 = 5;
        jineng = 10140;
        weili = 30;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|att;").append(jineng).append(";139;null;");
        boolean zhaoyunchidiao3 = false;
        int xuebili2 = (roundInfo.attBattleArmy.getBloodOrg() - roundInfo.attBattleArmy.getTroopHp()[0]) * 80 / 100;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili2)
            damage6 = xuebili2; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getGeneralId() == 201 || batArmy6.getCampArmy().getChapterId() > 0) {
            damage6 = attCamp.attEffect - defendCa6.defEffect + attCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(attCamp, batArmy6, defendCa6, 1, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
            if (jineng == 10140 && attCamp.getJxBuff() >= 0)
              attCamp.setJxBuff(attCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getGeneralId() == 201 && defCamp.getIsJuexing() > 0 && defCamp.getChapterId() >= 1) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (defCamp.getJxBuff() >= 1) {
        range3 = 3;
        jineng = 132;
        weili = 10;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.attList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|def;").append(jineng).append(";139;null;");
        int xuebili3 = (roundInfo.defBattleArmy.getBloodOrg() - roundInfo.defBattleArmy.getTroopHp()[0]) * 80 / 100;
        boolean zhaoyunchidiao5 = false;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili3)
            damage6 = xuebili3; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getGeneralId() == 201 || batArmy6.getCampArmy().getChapterId() > 0) {
            damage6 = defCamp.attEffect - defendCa6.defEffect + defCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao5) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao5 = true;
          } 
          int xinlost5 = DamageSkill(defCamp, batArmy6, defendCa6, 0, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
            if (jineng == 132 && defCamp.getJxBuff() >= 0)
              defCamp.setJxBuff(defCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getGeneralId() == 201 && defCamp.getIsJuexing() > 0 && defCamp.getChapterId() >= 2) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (defCamp.getJxBuff() >= 2) {
        range3 = 4;
        jineng = 149;
        weili = 20;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.attList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|def;").append(jineng).append(";139;null;");
        int xuebili3 = (roundInfo.defBattleArmy.getBloodOrg() - roundInfo.defBattleArmy.getTroopHp()[0]) * 80 / 100;
        boolean zhaoyunchidiao5 = false;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili3)
            damage6 = xuebili3; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getGeneralId() == 201 || batArmy6.getCampArmy().getChapterId() > 0) {
            damage6 = defCamp.attEffect - defendCa6.defEffect + defCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao5) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao5 = true;
          } 
          int xinlost5 = DamageSkill(defCamp, batArmy6, defendCa6, 0, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
            if (jineng == 149 && defCamp.getJxBuff() >= 0)
              defCamp.setJxBuff(defCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getGeneralId() == 201 && defCamp.getIsJuexing() > 0 && defCamp.getChapterId() >= 3) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (defCamp.getJxBuff() >= 3) {
        range3 = 5;
        jineng = 10140;
        weili = 30;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.attList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|def;").append(jineng).append(";139;null;");
        int xuebili3 = (roundInfo.defBattleArmy.getBloodOrg() - roundInfo.defBattleArmy.getTroopHp()[0]) * 80 / 100;
        boolean zhaoyunchidiao5 = false;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili3)
            damage6 = xuebili3; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getGeneralId() == 201 || batArmy6.getCampArmy().getChapterId() > 0) {
            damage6 = defCamp.attEffect - defendCa6.defEffect + defCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao5) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao5 = true;
          } 
          int xinlost5 = DamageSkill(defCamp, batArmy6, defendCa6, 0, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
            if (jineng == 10140 && defCamp.getJxBuff() >= 0)
              defCamp.setJxBuff(defCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (attCamp.getFormationType() == 1 && attCamp.getFormationLevel() > 1000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (attCamp.getJxBuff() >= 1) {
        range3 = 3;
        jineng = 10029;
        weili = 3;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|att;").append(jineng).append(";1022;null;");
        boolean zhaoyunchidiao3 = false;
        int xuebili2 = (roundInfo.attBattleArmy.getBloodOrg() - roundInfo.attBattleArmy.getTroopHp()[0]) * 80 / 100;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili2)
            damage6 = xuebili2; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 1 || batArmy6.getCampArmy().getFormationLevel() > 1000) {
            damage6 = attCamp.attEffect - defendCa6.defEffect + attCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(attCamp, batArmy6, defendCa6, 1, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
            if (jineng == 10029 && attCamp.getJxBuff() >= 0)
              attCamp.setJxBuff(attCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (attCamp.getFormationType() == 1 && attCamp.getFormationLevel() > 2000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (attCamp.getJxBuff() >= 1) {
        range3 = 5;
        jineng = 10064;
        weili = 6;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|att;").append(jineng).append(";1023;null;");
        boolean zhaoyunchidiao3 = false;
        int xuebili2 = (roundInfo.attBattleArmy.getBloodOrg() - roundInfo.attBattleArmy.getTroopHp()[0]) * 80 / 100;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili2)
            damage6 = xuebili2; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 1 || batArmy6.getCampArmy().getFormationLevel() > 2000) {
            damage6 = attCamp.attEffect - defendCa6.defEffect + attCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(attCamp, batArmy6, defendCa6, 1, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
            if (jineng == 10064 && attCamp.getJxBuff() >= 0)
              attCamp.setJxBuff(attCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getFormationType() == 1 && defCamp.getFormationLevel() > 1000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (defCamp.getJxBuff() >= 1) {
        range3 = 3;
        jineng = 10029;
        weili = 3;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.attList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|def;").append(jineng).append(";1022;null;");
        int xuebili3 = (roundInfo.defBattleArmy.getBloodOrg() - roundInfo.defBattleArmy.getTroopHp()[0]) * 80 / 100;
        boolean zhaoyunchidiao5 = false;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili3)
            damage6 = xuebili3; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 1 || batArmy6.getCampArmy().getFormationLevel() > 1000) {
            damage6 = defCamp.attEffect - defendCa6.defEffect + defCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao5) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao5 = true;
          } 
          int xinlost5 = DamageSkill(defCamp, batArmy6, defendCa6, 0, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
            if (jineng == 10029 && defCamp.getJxBuff() >= 0)
              defCamp.setJxBuff(defCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getFormationType() == 1 && defCamp.getFormationLevel() > 2000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (defCamp.getJxBuff() >= 1) {
        range3 = 5;
        jineng = 10064;
        weili = 6;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.attList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|def;").append(jineng).append(";1023;null;");
        int xuebili3 = (roundInfo.defBattleArmy.getBloodOrg() - roundInfo.defBattleArmy.getTroopHp()[0]) * 80 / 100;
        boolean zhaoyunchidiao5 = false;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili3)
            damage6 = xuebili3; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 1 || batArmy6.getCampArmy().getFormationLevel() > 2000) {
            damage6 = defCamp.attEffect - defendCa6.defEffect + defCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao5) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao5 = true;
          } 
          int xinlost5 = DamageSkill(defCamp, batArmy6, defendCa6, 0, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
            if (jineng == 10064 && defCamp.getJxBuff() >= 0)
              defCamp.setJxBuff(defCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (attCamp.getFormationType() == 2 && attCamp.getFormationLevel() > 1000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (attCamp.getJxBuff() >= 1) {
        range3 = 3;
        jineng = 10071;
        weili = 3;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|att;").append(jineng).append(";1026;null;");
        boolean zhaoyunchidiao3 = false;
        int xuebili2 = (roundInfo.attBattleArmy.getBloodOrg() - roundInfo.attBattleArmy.getTroopHp()[0]) * 80 / 100;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili2)
            damage6 = xuebili2; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 2 || batArmy6.getCampArmy().getFormationLevel() > 1000) {
            damage6 = attCamp.attEffect - defendCa6.defEffect + attCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(attCamp, batArmy6, defendCa6, 1, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
            if (jineng == 10071 && attCamp.getJxBuff() >= 0)
              attCamp.setJxBuff(attCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (attCamp.getFormationType() == 2 && attCamp.getFormationLevel() > 2000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (attCamp.getJxBuff() >= 1) {
        range3 = 5;
        jineng = 10072;
        weili = 6;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|att;").append(jineng).append(";1027;null;");
        boolean zhaoyunchidiao3 = false;
        int xuebili2 = (roundInfo.attBattleArmy.getBloodOrg() - roundInfo.attBattleArmy.getTroopHp()[0]) * 80 / 100;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili2)
            damage6 = xuebili2; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 2 || batArmy6.getCampArmy().getFormationLevel() > 2000) {
            damage6 = attCamp.attEffect - defendCa6.defEffect + attCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(attCamp, batArmy6, defendCa6, 1, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
            if (jineng == 10072 && attCamp.getJxBuff() >= 0)
              attCamp.setJxBuff(attCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getFormationType() == 2 && defCamp.getFormationLevel() > 1000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (defCamp.getJxBuff() >= 1) {
        range3 = 3;
        jineng = 10071;
        weili = 3;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.attList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|def;").append(jineng).append(";1026;null;");
        int xuebili3 = (roundInfo.defBattleArmy.getBloodOrg() - roundInfo.defBattleArmy.getTroopHp()[0]) * 80 / 100;
        boolean zhaoyunchidiao5 = false;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili3)
            damage6 = xuebili3; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 2 || batArmy6.getCampArmy().getFormationLevel() > 1000) {
            damage6 = defCamp.attEffect - defendCa6.defEffect + defCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao5) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao5 = true;
          } 
          int xinlost5 = DamageSkill(defCamp, batArmy6, defendCa6, 0, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
            if (jineng == 10071 && defCamp.getJxBuff() >= 0)
              defCamp.setJxBuff(defCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getFormationType() == 2 && defCamp.getFormationLevel() > 2000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (defCamp.getJxBuff() >= 1) {
        range3 = 5;
        jineng = 10072;
        weili = 6;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.attList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|def;").append(jineng).append(";1027;null;");
        int xuebili3 = (roundInfo.defBattleArmy.getBloodOrg() - roundInfo.defBattleArmy.getTroopHp()[0]) * 80 / 100;
        boolean zhaoyunchidiao5 = false;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili3)
            damage6 = xuebili3; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 2 || batArmy6.getCampArmy().getFormationLevel() > 2000) {
            damage6 = defCamp.attEffect - defendCa6.defEffect + defCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao5) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao5 = true;
          } 
          int xinlost5 = DamageSkill(defCamp, batArmy6, defendCa6, 0, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
            if (jineng == 10072 && defCamp.getJxBuff() >= 0)
              defCamp.setJxBuff(defCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (attCamp.getFormationType() == 3 && attCamp.getFormationLevel() > 1000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (attCamp.getJxBuff() >= 1) {
        range3 = 3;
        jineng = 10104;
        weili = 3;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|att;").append(jineng).append(";1044;null;");
        boolean zhaoyunchidiao3 = false;
        int xuebili2 = (roundInfo.attBattleArmy.getBloodOrg() - roundInfo.attBattleArmy.getTroopHp()[0]) * 80 / 100;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili2)
            damage6 = xuebili2; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 3 || batArmy6.getCampArmy().getFormationLevel() > 1000) {
            damage6 = attCamp.attEffect - defendCa6.defEffect + attCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(attCamp, batArmy6, defendCa6, 1, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
            if (jineng == 10104 && attCamp.getJxBuff() >= 0)
              attCamp.setJxBuff(attCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (attCamp.getFormationType() == 3 && attCamp.getFormationLevel() > 1000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (attCamp.getJxBuff() >= 1) {
        range3 = 3;
        jineng = 10103;
        weili = 3;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|att;").append(jineng).append(";1044;null;");
        boolean zhaoyunchidiao3 = false;
        int xuebili2 = (roundInfo.attBattleArmy.getBloodOrg() - roundInfo.attBattleArmy.getTroopHp()[0]) * 80 / 100;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili2)
            damage6 = xuebili2; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 3 || batArmy6.getCampArmy().getFormationLevel() > 1000) {
            damage6 = attCamp.attEffect - defendCa6.defEffect + attCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(attCamp, batArmy6, defendCa6, 1, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
            if (jineng == 10103 && attCamp.getJxBuff() >= 0)
              attCamp.setJxBuff(attCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (attCamp.getFormationType() == 3 && attCamp.getFormationLevel() > 2000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (attCamp.getJxBuff() >= 1) {
        range3 = 5;
        jineng = 10105;
        weili = 6;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|att;").append(jineng).append(";1042;null;");
        boolean zhaoyunchidiao3 = false;
        int xuebili2 = (roundInfo.attBattleArmy.getBloodOrg() - roundInfo.attBattleArmy.getTroopHp()[0]) * 80 / 100;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili2)
            damage6 = xuebili2; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 3 || batArmy6.getCampArmy().getFormationLevel() > 2000) {
            damage6 = attCamp.attEffect - defendCa6.defEffect + attCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(attCamp, batArmy6, defendCa6, 1, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
            if (jineng == 10105 && attCamp.getJxBuff() >= 0)
              attCamp.setJxBuff(attCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getFormationType() == 3 && defCamp.getFormationLevel() > 1000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (defCamp.getJxBuff() >= 1) {
        range3 = 3;
        jineng = 10104;
        weili = 3;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.attList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|def;").append(jineng).append(";1044;null;");
        int xuebili3 = (roundInfo.defBattleArmy.getBloodOrg() - roundInfo.defBattleArmy.getTroopHp()[0]) * 80 / 100;
        boolean zhaoyunchidiao5 = false;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili3)
            damage6 = xuebili3; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 3 || batArmy6.getCampArmy().getFormationLevel() > 1000) {
            damage6 = defCamp.attEffect - defendCa6.defEffect + defCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao5) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao5 = true;
          } 
          int xinlost5 = DamageSkill(defCamp, batArmy6, defendCa6, 0, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
            if (jineng == 10104 && defCamp.getJxBuff() >= 0)
              defCamp.setJxBuff(defCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getFormationType() == 3 && defCamp.getFormationLevel() > 1000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (defCamp.getJxBuff() >= 1) {
        range3 = 3;
        jineng = 10103;
        weili = 3;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.attList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|def;").append(jineng).append(";1044;null;");
        int xuebili3 = (roundInfo.defBattleArmy.getBloodOrg() - roundInfo.defBattleArmy.getTroopHp()[0]) * 80 / 100;
        boolean zhaoyunchidiao5 = false;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili3)
            damage6 = xuebili3; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 3 || batArmy6.getCampArmy().getFormationLevel() > 1000) {
            damage6 = defCamp.attEffect - defendCa6.defEffect + defCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao5) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao5 = true;
          } 
          int xinlost5 = DamageSkill(defCamp, batArmy6, defendCa6, 0, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
            if (jineng == 10103 && defCamp.getJxBuff() >= 0)
              defCamp.setJxBuff(defCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getFormationType() == 3 && defCamp.getFormationLevel() > 2000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (defCamp.getJxBuff() >= 1) {
        range3 = 5;
        jineng = 10105;
        weili = 6;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.attList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|def;").append(jineng).append(";1042;null;");
        int xuebili3 = (roundInfo.defBattleArmy.getBloodOrg() - roundInfo.defBattleArmy.getTroopHp()[0]) * 80 / 100;
        boolean zhaoyunchidiao5 = false;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili3)
            damage6 = xuebili3; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 3 || batArmy6.getCampArmy().getFormationLevel() > 2000) {
            damage6 = defCamp.attEffect - defendCa6.defEffect + defCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao5) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao5 = true;
          } 
          int xinlost5 = DamageSkill(defCamp, batArmy6, defendCa6, 0, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
            if (jineng == 10105 && defCamp.getJxBuff() >= 0)
              defCamp.setJxBuff(defCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (attCamp.getFormationType() == 6 && attCamp.getFormationLevel() > 1000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (attCamp.getJxBuff() >= 1) {
        range3 = 3;
        jineng = 10079;
        weili = 3;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|att;").append(jineng).append(";1028;null;");
        boolean zhaoyunchidiao3 = false;
        int xuebili2 = (roundInfo.attBattleArmy.getBloodOrg() - roundInfo.attBattleArmy.getTroopHp()[0]) * 80 / 100;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili2)
            damage6 = xuebili2; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 6 || batArmy6.getCampArmy().getFormationLevel() > 1000) {
            damage6 = attCamp.attEffect - defendCa6.defEffect + attCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(attCamp, batArmy6, defendCa6, 1, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
            if (jineng == 10079 && attCamp.getJxBuff() >= 0)
              attCamp.setJxBuff(attCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (attCamp.getFormationType() == 6 && attCamp.getFormationLevel() > 1000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (attCamp.getJxBuff() >= 1) {
        range3 = 3;
        jineng = 10078;
        weili = 3;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|att;").append(jineng).append(";1029;null;");
        boolean zhaoyunchidiao3 = false;
        int xuebili2 = (roundInfo.attBattleArmy.getBloodOrg() - roundInfo.attBattleArmy.getTroopHp()[0]) * 80 / 100;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili2)
            damage6 = xuebili2; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 6 || batArmy6.getCampArmy().getFormationLevel() > 1000) {
            damage6 = attCamp.attEffect - defendCa6.defEffect + attCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(attCamp, batArmy6, defendCa6, 1, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
            if (jineng == 10078 && attCamp.getJxBuff() >= 0)
              attCamp.setJxBuff(attCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (attCamp.getFormationType() == 6 && attCamp.getFormationLevel() > 2000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (attCamp.getJxBuff() >= 1) {
        range3 = 5;
        jineng = 10080;
        weili = 6;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|att;").append(jineng).append(";1031;null;");
        boolean zhaoyunchidiao3 = false;
        int xuebili2 = (roundInfo.attBattleArmy.getBloodOrg() - roundInfo.attBattleArmy.getTroopHp()[0]) * 80 / 100;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili2)
            damage6 = xuebili2; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 6 || batArmy6.getCampArmy().getFormationLevel() > 2000) {
            damage6 = attCamp.attEffect - defendCa6.defEffect + attCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(attCamp, batArmy6, defendCa6, 1, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
            if (jineng == 10080 && attCamp.getJxBuff() >= 0)
              attCamp.setJxBuff(attCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getFormationType() == 6 && defCamp.getFormationLevel() > 1000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (defCamp.getJxBuff() >= 1) {
        range3 = 3;
        jineng = 10079;
        weili = 3;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.attList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|def;").append(jineng).append(";1028;null;");
        int xuebili3 = (roundInfo.defBattleArmy.getBloodOrg() - roundInfo.defBattleArmy.getTroopHp()[0]) * 80 / 100;
        boolean zhaoyunchidiao5 = false;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili3)
            damage6 = xuebili3; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 6 || batArmy6.getCampArmy().getFormationLevel() > 1000) {
            damage6 = defCamp.attEffect - defendCa6.defEffect + defCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao5) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao5 = true;
          } 
          int xinlost5 = DamageSkill(defCamp, batArmy6, defendCa6, 0, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
            if (jineng == 10079 && defCamp.getJxBuff() >= 0)
              defCamp.setJxBuff(defCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getFormationType() == 6 && defCamp.getFormationLevel() > 1000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (defCamp.getJxBuff() >= 1) {
        range3 = 3;
        jineng = 10078;
        weili = 3;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.attList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|def;").append(jineng).append(";1029;null;");
        int xuebili3 = (roundInfo.defBattleArmy.getBloodOrg() - roundInfo.defBattleArmy.getTroopHp()[0]) * 80 / 100;
        boolean zhaoyunchidiao5 = false;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili3)
            damage6 = xuebili3; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 6 || batArmy6.getCampArmy().getFormationLevel() > 1000) {
            damage6 = defCamp.attEffect - defendCa6.defEffect + defCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao5) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao5 = true;
          } 
          int xinlost5 = DamageSkill(defCamp, batArmy6, defendCa6, 0, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
            if (jineng == 10078 && defCamp.getJxBuff() >= 0)
              defCamp.setJxBuff(defCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getFormationType() == 6 && defCamp.getFormationLevel() > 2000) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (defCamp.getJxBuff() >= 1) {
        range3 = 5;
        jineng = 10080;
        weili = 6;
        defCamp.setJxBuff(-1);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.attList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|def;").append(jineng).append(";1031;null;");
        int xuebili3 = (roundInfo.defBattleArmy.getBloodOrg() - roundInfo.defBattleArmy.getTroopHp()[0]) * 80 / 100;
        boolean zhaoyunchidiao5 = false;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili3)
            damage6 = xuebili3; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || batArmy6.getCampArmy().getFormationType() == 6 || batArmy6.getCampArmy().getFormationLevel() > 2000) {
            damage6 = defCamp.attEffect - defendCa6.defEffect + defCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao5) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao5 = true;
          } 
          int xinlost5 = DamageSkill(defCamp, batArmy6, defendCa6, 0, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
            if (jineng == 10080 && defCamp.getJxBuff() >= 0)
              defCamp.setJxBuff(defCamp.getJxBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getCarQudong() == 10001 && roundInfo.attBattleArmy.getHaveZhanChe() && roundInfo.attBattleArmy.getHuJia() > 0 && attCamp.getSneer() <= 0) {
      List<BattleArmy> listB2 = bat.defList;
      int range2 = listB2.size();
      int reduce5 = 0;
      boolean lengyansidiao = false;
      StringBuilder lysd = new StringBuilder();
      lysd.append("10001|def|");
      int lyrow = 0;
      for (int i3 = 0; i3 < range2; i3++) {
        if (lyrow < 4) {
          BattleArmy batArmy = listB2.get(i3);
          CampArmy defendCa = batArmy.getCampArmy();
          if (batArmy.getCardebuff() > 0) {
            int damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
            if (damage <= 0)
              damage = 1; 
            long xuebili = batArmy.getTroopHp()[0] * 100L / batArmy.getBloodOrg();
            if (xuebili < 20L)
              damage = batArmy.getTroopHp()[0]; 
            if (batArmy.getCampArmy().getGeneralId() == 73051 || batArmy.getCampArmy().getIsBeatMonster() > 0 || (batArmy.getCampArmy().getGeneralId() == 232 && batArmy.getCampArmy().getUnionRank() > 0) || batArmy.getCampArmy().getLegendEvoke()) {
              damage = attCamp.attEffect - defendCa.defEffect + attCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
              if (damage <= 0)
                damage = 1; 
            } 
            zhixing = true;
            lengyansidiao = true;
            batArmy.setCardebuff(0);
            lyrow++;
            int xinlost5 = DamageSkill(attCamp, batArmy, defendCa, 1, damage, false, dataGetter, bat, roundInfo, i3);
            if (i3 == 0 && batArmy.getTroopHp()[0] <= 0) {
              roundInfo.defFirstRowKilled = true;
              firstRowkilled = true;
              roundInfo.win = 1;
            } 
            lysd.append(batArmy.getPosition()).append(",").append(xinlost5).append(",").append(batArmy.getTroopHp()[0]).append(",").append(batArmy.getShield()).append(",0;");
          } 
        } 
      } 
      if (lengyansidiao) {
        lysd.replace(lysd.length() - 1, lysd.length(), "#");
        roundInfo.battleMsg.append(lysd.toString());
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getCarQudong() == 10001 && roundInfo.defBattleArmy.getHaveZhanChe() && roundInfo.defBattleArmy.getHuJia() > 0 && defCamp.getSneer() <= 0) {
      List<BattleArmy> listB2 = bat.attList;
      int range2 = listB2.size();
      int reduce5 = 0;
      boolean lengyansidiao = false;
      StringBuilder lysd = new StringBuilder();
      lysd.append("10001|att|");
      int lyrow = 0;
      for (int i3 = 0; i3 < range2; i3++) {
        if (lyrow < 4) {
          BattleArmy batArmy = listB2.get(i3);
          CampArmy defendCa = batArmy.getCampArmy();
          if (batArmy.getCardebuff() > 0) {
            int damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
            if (damage <= 0)
              damage = 1; 
            long xuebili = batArmy.getTroopHp()[0] * 100L / batArmy.getBloodOrg();
            if (xuebili < 20L)
              damage = batArmy.getTroopHp()[0]; 
            if (batArmy.getCampArmy().getGeneralId() == 73051 || batArmy.getCampArmy().getIsBeatMonster() > 0 || (batArmy.getCampArmy().getGeneralId() == 232 && batArmy.getCampArmy().getUnionRank() > 0) || batArmy.getCampArmy().getLegendEvoke()) {
              damage = defCamp.attEffect - defendCa.defEffect + defCamp.TACTIC_ATT - defendCa.TACTIC_DEF;
              if (damage <= 0)
                damage = 1; 
            } 
            zhixing = true;
            lengyansidiao = true;
            batArmy.setCardebuff(0);
            lyrow++;
            int xinlost5 = DamageSkill(defCamp, batArmy, defendCa, 0, damage, false, dataGetter, bat, roundInfo, i3);
            if (i3 == 0 && batArmy.getTroopHp()[0] <= 0) {
              roundInfo.attFirstRowKilled = true;
              firstRowkilled = true;
              roundInfo.win = 2;
            } 
            lysd.append(batArmy.getPosition()).append(",").append(xinlost5).append(",").append(batArmy.getTroopHp()[0]).append(",").append(batArmy.getShield()).append(",0;");
          } 
        } 
      } 
      if (lengyansidiao) {
        lysd.replace(lysd.length() - 1, lysd.length(), "#");
        roundInfo.battleMsg.append(lysd.toString());
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (firstRowkilled)
      return true; 
    baguaformation(dataGetter, bat, roundInfo);
    if (attCamp.getsjznLevel() > 0) {
      int arrowlimit = 1;
      int powermax = 300000;
      if (attCamp.getsjznLevel() >= 10) {
        arrowlimit = 3;
        powermax = 999999999;
      } else if (attCamp.getsjznLevel() >= 9) {
        arrowlimit = 3;
        powermax = 900000;
      } else if (attCamp.getsjznLevel() >= 5) {
        arrowlimit = 2;
        powermax = 600000;
      } 
      boolean canshifang = false;
      if (attCamp.getsjznType() <= arrowlimit) {
        if (attCamp.getsjznPower() >= powermax)
          canshifang = true; 
        if (roundInfo.attBattleArmy.getHaveZhanChe() && attCamp.getsjznType() == 3)
          canshifang = true; 
      } 
      if (canshifang) {
        int range4 = 4;
        zhixing = true;
        List<BattleArmy> listB4 = bat.defList;
        int rows3 = listB4.size();
        if (range4 > rows3)
          range4 = rows3; 
        int zfid = attCamp.getsjznType() + 10043;
        int damage5 = attCamp.getsjznPower();
        attCamp.setsjznType(attCamp.getsjznType() + 1);
        attCamp.setsjznPower(0);
        roundInfo.battleMsg.append("54|att;").append(zfid).append(";0;null;");
        boolean zhaoyunchidiao4 = false;
        for (int i4 = 0; i4 < range4; i4++) {
          int reduce6 = 0;
          BattleArmy batArmy5 = listB4.get(i4);
          CampArmy defendCa5 = batArmy5.getCampArmy();
          roundInfo.battleMsg.append(batArmy5.getPosition()).append(",");
          if (zhaoyunchidiao4) {
            damage5 = 1;
          } else if (defendCa5.getChiZhanFa() > 0) {
            damage5 *= rows3 - i4;
            zhaoyunchidiao4 = true;
          } 
          int xinlost6 = DamageSkill(attCamp, batArmy5, defendCa5, 1, damage5, false, dataGetter, bat, roundInfo, i4);
          if (i4 == 0 && batArmy5.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
          } 
          roundInfo.battleMsg.append(xinlost6).append(",").append(batArmy5.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getsjznLevel() > 0) {
      int arrowlimit = 1;
      int powermax = 300000;
      if (defCamp.getsjznLevel() >= 10) {
        arrowlimit = 3;
        powermax = 999999999;
      } else if (defCamp.getsjznLevel() >= 9) {
        arrowlimit = 3;
        powermax = 900000;
      } else if (defCamp.getsjznLevel() >= 5) {
        arrowlimit = 2;
        powermax = 600000;
      } 
      boolean canshifang = false;
      if (defCamp.getsjznType() <= arrowlimit) {
        if (defCamp.getsjznPower() >= powermax)
          canshifang = true; 
        if (roundInfo.defBattleArmy.getHaveZhanChe() && defCamp.getsjznType() == 3)
          canshifang = true; 
      } 
      if (canshifang) {
        int range4 = 4;
        zhixing = true;
        List<BattleArmy> listB4 = bat.attList;
        int rows3 = listB4.size();
        if (range4 > rows3)
          range4 = rows3; 
        int zfid = defCamp.getsjznType() + 10043;
        int damage5 = defCamp.getsjznPower();
        defCamp.setsjznType(defCamp.getsjznType() + 1);
        defCamp.setsjznPower(0);
        roundInfo.battleMsg.append("54|def;").append(zfid).append(";0;null;");
        boolean zhaoyunchidiao4 = false;
        for (int i4 = 0; i4 < range4; i4++) {
          int reduce6 = 0;
          BattleArmy batArmy5 = listB4.get(i4);
          CampArmy defendCa5 = batArmy5.getCampArmy();
          roundInfo.battleMsg.append(batArmy5.getPosition()).append(",");
          if (zhaoyunchidiao4) {
            damage5 = 1;
          } else if (defendCa5.getChiZhanFa() > 0) {
            damage5 *= rows3 - i4;
            zhaoyunchidiao4 = true;
          } 
          int xinlost6 = DamageSkill(defCamp, batArmy5, defendCa5, 0, damage5, false, dataGetter, bat, roundInfo, i4);
          if (i4 == 0 && batArmy5.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
          } 
          roundInfo.battleMsg.append(xinlost6).append(",").append(batArmy5.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getGeneralId() == 201 && attCamp.getNeedFgyj() && attCamp.getSneer() <= 0) {
      attCamp.setNeedFgyj(false);
      if (attCamp.getHaveZscy() && attCamp.getUnionRank() >= 3)
        attCamp.setZscy(attCamp.getZscy() + 1); 
      int range3 = 3;
      zhixing = true;
      List<BattleArmy> listB3 = bat.defList;
      int rows = listB3.size();
      if (range3 > rows)
        range3 = rows; 
      roundInfo.battleMsg.append("54|att;").append(76).append(";1018;null;");
      boolean zhaoyunchidiao2 = false;
      for (int i2 = 0; i2 < range3; i2++) {
        int reduce3 = 0;
        BattleArmy batArmy3 = listB3.get(i2);
        CampArmy defendCa3 = batArmy3.getCampArmy();
        roundInfo.battleMsg.append(batArmy3.getPosition()).append(",");
        int damage3 = attCamp.attEffect - defendCa3.defEffect + attCamp.TACTIC_ATT - defendCa3.TACTIC_DEF;
        damage3 = Double.valueOf(damage3 * (attCamp.getFgyjBili() + 100.0D) / 100.0D).intValue();
        if (damage3 < 1000)
          damage3 = 1000; 
        if (zhaoyunchidiao2) {
          damage3 = 1;
        } else if (defendCa3.getChiZhanFa() > 0) {
          damage3 *= rows - i2;
          zhaoyunchidiao2 = true;
        } 
        int xinlost3 = DamageSkill(attCamp, batArmy3, defendCa3, 1, damage3, false, dataGetter, bat, roundInfo, i2);
        if (i2 == 0 && batArmy3.getTroopHp()[0] <= 0) {
          roundInfo.defFirstRowKilled = true;
          firstRowkilled = true;
          roundInfo.win = 1;
        } 
        roundInfo.battleMsg.append(xinlost3).append(",").append(batArmy3.getTroopHp()[0]).append(",0,0*");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (defCamp.getGeneralId() == 201 && defCamp.getNeedFgyj() && defCamp.getSneer() <= 0) {
      defCamp.setNeedFgyj(false);
      if (defCamp.getHaveZscy() && defCamp.getUnionRank() >= 3)
        defCamp.setZscy(defCamp.getZscy() + 1); 
      int range3 = 3;
      zhixing = true;
      List<BattleArmy> listB3 = bat.attList;
      int rows = listB3.size();
      if (range3 > rows)
        range3 = rows; 
      roundInfo.battleMsg.append("54|def;").append(76).append(";1018;null;");
      boolean zhaoyunchidiao2 = false;
      for (int i2 = 0; i2 < range3; i2++) {
        int reduce3 = 0;
        BattleArmy batArmy3 = listB3.get(i2);
        CampArmy defendCa3 = batArmy3.getCampArmy();
        roundInfo.battleMsg.append(batArmy3.getPosition()).append(",");
        int damage3 = defCamp.attEffect - defendCa3.defEffect + defCamp.TACTIC_ATT - defendCa3.TACTIC_DEF;
        damage3 = Double.valueOf(damage3 * (defCamp.getFgyjBili() + 100.0D) / 100.0D).intValue();
        if (damage3 < 1000)
          damage3 = 1000; 
        if (zhaoyunchidiao2) {
          damage3 = 1;
        } else if (defendCa3.getChiZhanFa() > 0) {
          damage3 *= rows - i2;
          zhaoyunchidiao2 = true;
        } 
        int xinlost3 = DamageSkill(defCamp, batArmy3, defendCa3, 0, damage3, false, dataGetter, bat, roundInfo, i2);
        if (i2 == 0 && batArmy3.getTroopHp()[0] <= 0) {
          roundInfo.attFirstRowKilled = true;
          firstRowkilled = true;
          roundInfo.win = 2;
        } 
        roundInfo.battleMsg.append(xinlost3).append(",").append(batArmy3.getTroopHp()[0]).append(",0,0*");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (attCamp.getGeneralId() == 232 && attCamp.getIsJuexing() > 0 && attCamp.getSneer() <= 0 && attCamp.getUnionState() <= 0) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (attCamp.getXinBingShangZhen() > 0) {
        range3 = 2;
        jineng = 72;
        attCamp.setXinBingShangZhen(0);
      } 
      if (attCamp.getMfBuff() >= 3) {
        range3 = 4;
        jineng = 73;
        weili = 2;
        attCamp.setMfBuff(0);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.defList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|att;").append(jineng).append(";1019;null;");
        boolean zhaoyunchidiao3 = false;
        int xuebili2 = (roundInfo.attBattleArmy.getBloodOrg() - roundInfo.attBattleArmy.getTroopHp()[0]) * 80 / 100;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili2)
            damage6 = xuebili2; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || (batArmy6.getCampArmy().getGeneralId() == 232 && batArmy6.getCampArmy().getUnionRank() > 0) || batArmy6.getCampArmy().getLegendEvoke()) {
            damage6 = attCamp.attEffect - defendCa6.defEffect + attCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(attCamp, batArmy6, defendCa6, 1, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
            if (jineng == 72 && attCamp.getMfBuff() >= 0)
              attCamp.setMfBuff(attCamp.getMfBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getGeneralId() == 232 && defCamp.getIsJuexing() > 0 && defCamp.getSneer() <= 0 && defCamp.getUnionState() <= 0) {
      int range3 = 0;
      int jineng = 0;
      int weili = 1;
      if (defCamp.getXinBingShangZhen() > 0) {
        range3 = 2;
        jineng = 72;
        defCamp.setXinBingShangZhen(0);
      } 
      if (defCamp.getMfBuff() >= 3) {
        range3 = 4;
        jineng = 73;
        weili = 2;
        defCamp.setMfBuff(0);
      } 
      if (range3 > 0) {
        zhixing = true;
        List<BattleArmy> listB = bat.attList;
        int rows2 = listB.size();
        if (range3 > rows2)
          range3 = rows2; 
        roundInfo.battleMsg.append("54|def;").append(jineng).append(";1019;null;");
        int xuebili3 = (roundInfo.defBattleArmy.getBloodOrg() - roundInfo.defBattleArmy.getTroopHp()[0]) * 80 / 100;
        boolean zhaoyunchidiao5 = false;
        for (int i5 = 0; i5 < range3; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append(",");
          int damage6 = Double.valueOf(batArmy6.getTroopHp()[0] * 0.1D * weili).intValue();
          if (damage6 < xuebili3)
            damage6 = xuebili3; 
          if (batArmy6.getCampArmy().getGeneralId() == 73051 || batArmy6.getCampArmy().getIsBeatMonster() > 0 || (batArmy6.getCampArmy().getGeneralId() == 232 && batArmy6.getCampArmy().getUnionRank() > 0) || batArmy6.getCampArmy().getLegendEvoke()) {
            damage6 = defCamp.attEffect - defendCa6.defEffect + defCamp.TACTIC_ATT - defendCa6.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (zhaoyunchidiao5) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows2 - i5;
            zhaoyunchidiao5 = true;
          } 
          int xinlost5 = DamageSkill(defCamp, batArmy6, defendCa6, 0, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
            if (jineng == 72 && defCamp.getMfBuff() >= 0)
              defCamp.setMfBuff(defCamp.getMfBuff() + 1); 
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy6.getTroopHp()[0]).append(",0,0*");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.getNeedShaRen() > 0) {
      attCamp.setNeedShaRen(0);
      zhixing = true;
      List<BattleArmy> listB2 = bat.defList;
      int rows4 = listB2.size();
      if (rows4 > 4)
        rows4 = 4; 
      roundInfo.battleMsg.append("54|att;71;0;null;");
      boolean zhaoyunchidiao6 = false;
      for (int k = 0; k < rows4; k++) {
        int reduce8 = 0;
        BattleArmy batArmy7 = listB2.get(k);
        CampArmy defendCa7 = batArmy7.getCampArmy();
        roundInfo.battleMsg.append(batArmy7.getPosition()).append(",");
        int recastnum = attCamp.getShaRenRecastNum();
        if (recastnum > 10)
          recastnum = 10; 
        int damage3 = Double.valueOf((defendCa7.getArmyHpOrg() / 15) * (0.02D * recastnum + 0.002D * attCamp.getDuoChongShaRen())).intValue();
        if (batArmy7.getCampArmy().getGeneralId() == 73051 || batArmy7.getCampArmy().getIsBeatMonster() > 0 || (batArmy7.getCampArmy().getGeneralId() == 232 && batArmy7.getCampArmy().getUnionRank() > 0) || batArmy7.getCampArmy().getLegendEvoke()) {
          damage3 = attCamp.attEffect - defendCa7.defEffect + attCamp.TACTIC_ATT - defendCa7.TACTIC_DEF;
          if (damage3 <= 0)
            damage3 = 1; 
        } 
        if (zhaoyunchidiao6) {
          damage3 = 1;
        } else if (defendCa7.getChiZhanFa() > 0) {
          damage3 *= rows4 - k;
          zhaoyunchidiao6 = true;
        } 
        int xinlost3 = DamageSkill(attCamp, batArmy7, defendCa7, 1, damage3, false, dataGetter, bat, roundInfo, k);
        if (k == 0 && batArmy7.getTroopHp()[0] <= 0) {
          roundInfo.defFirstRowKilled = true;
          firstRowkilled = true;
          roundInfo.win = 1;
        } 
        roundInfo.battleMsg.append(xinlost3).append(",").append(batArmy7.getTroopHp()[0]).append(",0,0*");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (defCamp.getNeedShaRen() > 0) {
      defCamp.setNeedShaRen(0);
      zhixing = true;
      List<BattleArmy> listB2 = bat.attList;
      int rows4 = listB2.size();
      if (rows4 > 4)
        rows4 = 4; 
      roundInfo.battleMsg.append("54|def;71;0;null;");
      boolean zhaoyunchidiao6 = false;
      for (int k = 0; k < rows4; k++) {
        int reduce8 = 0;
        BattleArmy batArmy7 = listB2.get(k);
        CampArmy defendCa7 = batArmy7.getCampArmy();
        roundInfo.battleMsg.append(batArmy7.getPosition()).append(",");
        int recastnum = defCamp.getShaRenRecastNum();
        if (recastnum > 10)
          recastnum = 10; 
        int damage3 = Double.valueOf((defendCa7.getArmyHpOrg() / 15) * (0.02D * recastnum + 0.002D * defCamp.getDuoChongShaRen())).intValue();
        if (batArmy7.getCampArmy().getGeneralId() == 73051 || batArmy7.getCampArmy().getIsBeatMonster() > 0 || (batArmy7.getCampArmy().getGeneralId() == 232 && batArmy7.getCampArmy().getUnionRank() > 0) || batArmy7.getCampArmy().getLegendEvoke()) {
          damage3 = defCamp.attEffect - defendCa7.defEffect + defCamp.TACTIC_ATT - defendCa7.TACTIC_DEF;
          if (damage3 <= 0)
            damage3 = 1; 
        } 
        if (zhaoyunchidiao6) {
          damage3 = 1;
        } else if (defendCa7.getChiZhanFa() > 0) {
          damage3 *= rows4 - k;
          zhaoyunchidiao6 = true;
        } 
        int xinlost3 = DamageSkill(defCamp, batArmy7, defendCa7, 0, damage3, false, dataGetter, bat, roundInfo, k);
        if (k == 0 && batArmy7.getTroopHp()[0] <= 0) {
          roundInfo.attFirstRowKilled = true;
          firstRowkilled = true;
          roundInfo.win = 2;
        } 
        roundInfo.battleMsg.append(xinlost3).append(",").append(batArmy7.getTroopHp()[0]).append(",0,0*");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.nextMinExeTime += 3000;
    } 
    if (firstRowkilled)
      return true; 
    firstRowkilled = luanshixiaoxiong(dataGetter, bat, roundInfo);
    if (firstRowkilled)
      return true; 
    firstRowkilled = liuguanzhang(dataGetter, bat, roundInfo);
    if (firstRowkilled)
      return true; 
    if (roundInfo.attBattleArmy.getHaveZhanChe() && (attCamp.getCarModel() == 5 || attCamp.getCarQudong() == 1) && roundInfo.attBattleArmy.getHuJia() > 0 && 3 - bat.getRoundNum().get() % 4 == 0) {
      if (!roundInfo.attBattleArmy.getCampArmy().getCarArmed())
        roundInfo.battleMsg.append("66|def;").append(1).append("#"); 
      defCamp.setAttEffect(defCamp.getAttEffect() / 2);
      defCamp.setDefEffect(defCamp.getDefEffect() / 2);
      if (bat.getDefCamp().size() > 5) {
        int houtui = dataGetter.getBattleService().jxZhangFeiSkill(attCamp, bat, 1, 1);
        if (houtui > 0) {
          JsonDocument doc = new JsonDocument();
          doc.startObject();
          doc.createElement("floodedSide", Integer.valueOf(0));
          doc.startObject("floodInfo");
          doc.createElement("isAtt", Boolean.valueOf(false));
          doc.createElement("num", Integer.valueOf(houtui));
          doc.endObject();
          doc.endObject();
          for (Integer playerId : bat.inSceneSet)
            Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_FLOOD, doc.toByte()); 
        } 
      } 
      if (roundInfo.attBattleArmy.getCampArmy().getCarArmed()) {
        List<BattleArmy> listB2 = bat.defList;
        int rows4 = listB2.size();
        roundInfo.battleMsg.append("121|def|");
        boolean zhaoyunchidiao6 = false;
        for (int k = 0; k < rows4; k++) {
          int reduce8 = 0;
          BattleArmy batArmy7 = listB2.get(k);
          CampArmy defendCa7 = batArmy7.getCampArmy();
          roundInfo.battleMsg.append(batArmy7.getPosition()).append(",");
          int damage5 = attCamp.getFiveShuiDamage();
          if (defendCa7.getLegendSkill().containsKey("yanmi") && ((Integer)defendCa7.getLegendSkill().get("yanmi")).intValue() > 0)
            damage5 = damage5 * 40 / 100; 
          int xinlost7 = DamageSkill(attCamp, batArmy7, defendCa7, 1, damage5, false, dataGetter, bat, roundInfo, k);
          if (k == 0 && batArmy7.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
          } 
          roundInfo.battleMsg.append(xinlost7).append(",").append(batArmy7.getTroopHp()[0]).append(",0,0;");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (roundInfo.defBattleArmy.getHaveZhanChe() && (defCamp.getCarModel() == 5 || defCamp.getCarQudong() == 1) && roundInfo.defBattleArmy.getHuJia() > 0 && 3 - bat.getRoundNum().get() % 4 == 0) {
      if (!roundInfo.defBattleArmy.getCampArmy().getCarArmed())
        roundInfo.battleMsg.append("66|att;").append(1).append("#"); 
      attCamp.setAttEffect(attCamp.getAttEffect() / 2);
      attCamp.setDefEffect(attCamp.getDefEffect() / 2);
      if (bat.getAttCamp().size() > 5) {
        int houtui = dataGetter.getBattleService().jxZhangFeiSkill(defCamp, bat, 0, 1);
        if (houtui > 0) {
          JsonDocument doc = new JsonDocument();
          doc.startObject();
          doc.createElement("floodedSide", Integer.valueOf(1));
          doc.startObject("floodInfo");
          doc.createElement("isAtt", Boolean.valueOf(true));
          doc.createElement("num", Integer.valueOf(houtui));
          doc.endObject();
          doc.endObject();
          for (Integer playerId : bat.inSceneSet)
            Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_FLOOD, doc.toByte()); 
        } 
      } 
      if (roundInfo.defBattleArmy.getCampArmy().getCarArmed()) {
        List<BattleArmy> listB2 = bat.attList;
        int rows4 = listB2.size();
        roundInfo.battleMsg.append("121|att|");
        boolean zhaoyunchidiao6 = false;
        for (int k = 0; k < rows4; k++) {
          int reduce8 = 0;
          BattleArmy batArmy7 = listB2.get(k);
          CampArmy defendCa7 = batArmy7.getCampArmy();
          roundInfo.battleMsg.append(batArmy7.getPosition()).append(",");
          int damage5 = defCamp.getFiveShuiDamage();
          if (defendCa7.getLegendSkill().containsKey("yanmi") && ((Integer)defendCa7.getLegendSkill().get("yanmi")).intValue() > 0)
            damage5 = damage5 * 40 / 100; 
          int xinlost7 = DamageSkill(defCamp, batArmy7, defendCa7, 0, damage5, false, dataGetter, bat, roundInfo, k);
          if (k == 0 && batArmy7.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
          } 
          roundInfo.battleMsg.append(xinlost7).append(",").append(batArmy7.getTroopHp()[0]).append(",0,0;");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (attCamp.xuyaochiyan && attCamp.getSneer() <= 0) {
      zhixing = true;
      List<BattleArmy> listB2 = bat.defList;
      int rows4 = listB2.size();
      if (rows4 > 4)
        rows4 = 4; 
      roundInfo.battleMsg.append("42|def|1313|");
      int first = 1;
      if (attCamp.chiyanmizhen > 0)
        first = 0; 
      roundInfo.battleMsg.append(first).append("|");
      boolean zhaoyunchidiao2 = false;
      for (int i2 = 0; i2 < rows4; i2++) {
        int reduce3 = 0;
        BattleArmy batArmy3 = listB2.get(i2);
        CampArmy defendCa3 = batArmy3.getCampArmy();
        roundInfo.battleMsg.append(batArmy3.getPosition()).append(",");
        int damage3 = Double.valueOf((defendCa3.getArmyHpOrg() / 15) * 0.1D).intValue();
        if (batArmy3.getCampArmy().getGeneralId() == 73051 || batArmy3.getCampArmy().getIsBeatMonster() > 0 || (batArmy3.getCampArmy().getGeneralId() == 232 && batArmy3.getCampArmy().getUnionRank() > 0) || batArmy3.getCampArmy().getLegendEvoke()) {
          damage3 = attCamp.attEffect - defendCa3.defEffect + attCamp.TACTIC_ATT - defendCa3.TACTIC_DEF;
          if (damage3 <= 0)
            damage3 = 1; 
        } 
        if (defendCa3.playerId < 0 && defendCa3.armyName.contains("禁卫军 "))
          damage3 = Double.valueOf((defendCa3.getArmyHpOrg() / 15) * 0.01D).intValue(); 
        if (zhaoyunchidiao2) {
          damage3 = 1;
        } else if (defendCa3.getChiZhanFa() > 0) {
          damage3 *= rows4 - i2;
          zhaoyunchidiao2 = true;
        } 
        int xinlost3 = DamageSkill(attCamp, batArmy3, defendCa3, 1, damage3, false, dataGetter, bat, roundInfo, i2);
        if (i2 == 0 && batArmy3.getTroopHp()[0] <= 0) {
          roundInfo.defFirstRowKilled = true;
          firstRowkilled = true;
          roundInfo.win = 1;
        } 
        roundInfo.battleMsg.append(xinlost3).append(",").append(batArmy3.getTroopHp()[0]).append("*");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "|null#");
      CampArmy campArmy4 = attCamp;
      campArmy4.chiyanmizhen++;
      attCamp.xuyaochiyan = false;
      roundInfo.nextMinExeTime += 3000;
    } 
    if (attCamp.xuyaochiyan && attCamp.getSneer() == 0) {
      List<BattleArmy> listB2 = bat.defList;
      int rows4 = listB2.size();
      if (rows4 > 4)
        rows4 = 4; 
      roundInfo.battleMsg.append("42|def|1313|");
      int first = 1;
      if (attCamp.chiyanmizhen > 0)
        first = 0; 
      roundInfo.battleMsg.append(first).append("|");
      boolean zhaoyunchidiao2 = false;
      for (int i2 = 0; i2 < rows4; i2++) {
        int reduce3 = 0;
        BattleArmy batArmy3 = listB2.get(i2);
        CampArmy defendCa3 = batArmy3.getCampArmy();
        roundInfo.battleMsg.append(batArmy3.getPosition()).append(",");
        int damage3 = Double.valueOf((defendCa3.getArmyHpOrg() / 15) * 0.1D).intValue();
        if (batArmy3.getCampArmy().getGeneralId() == 73051 || batArmy3.getCampArmy().getIsBeatMonster() > 0 || (batArmy3.getCampArmy().getGeneralId() == 232 && batArmy3.getCampArmy().getUnionRank() > 0) || batArmy3.getCampArmy().getLegendEvoke()) {
          damage3 = attCamp.attEffect - defendCa3.defEffect + attCamp.TACTIC_ATT - defendCa3.TACTIC_DEF;
          if (damage3 <= 0)
            damage3 = 1; 
        } 
        if (defendCa3.playerId < 0 && defendCa3.armyName.contains("禁卫军 "))
          damage3 = Double.valueOf((defendCa3.getArmyHpOrg() / 15) * 0.01D).intValue(); 
        if (zhaoyunchidiao2) {
          damage3 = 1;
        } else if (defendCa3.getChiZhanFa() > 0) {
          damage3 *= rows4 - i2;
          zhaoyunchidiao2 = true;
        } 
        int xinlost3 = DamageSkill(attCamp, batArmy3, defendCa3, 1, damage3, false, dataGetter, bat, roundInfo, i2);
        if (i2 == 0 && batArmy3.getTroopHp()[0] <= 0) {
          roundInfo.defFirstRowKilled = true;
          firstRowkilled = true;
          roundInfo.win = 1;
        } 
        roundInfo.battleMsg.append(xinlost3).append(",").append(batArmy3.getTroopHp()[0]).append("*");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "|null#");
      CampArmy campArmy4 = attCamp;
      campArmy4.chiyanmizhen++;
      attCamp.xuyaochiyan = false;
      roundInfo.nextMinExeTime += 3000;
    } 
    if (defCamp.xuyaochiyan && defCamp.getSneer() <= 0) {
      zhixing = true;
      List<BattleArmy> listB2 = bat.attList;
      int rows4 = listB2.size();
      if (rows4 > 4)
        rows4 = 4; 
      roundInfo.battleMsg.append("#42|att|1313|");
      int first = 1;
      if (defCamp.chiyanmizhen > 0)
        first = 0; 
      roundInfo.battleMsg.append(first).append("|");
      boolean zhaoyunchidiao2 = false;
      for (int i2 = 0; i2 < rows4; i2++) {
        int reduce3 = 0;
        BattleArmy batArmy3 = listB2.get(i2);
        CampArmy defendCa3 = batArmy3.getCampArmy();
        roundInfo.battleMsg.append(batArmy3.getPosition()).append(",");
        int damage3 = Double.valueOf((defendCa3.getArmyHpOrg() / 15) * 0.1D).intValue();
        if (batArmy3.getCampArmy().getGeneralId() == 73051 || batArmy3.getCampArmy().getIsBeatMonster() > 0 || (batArmy3.getCampArmy().getGeneralId() == 232 && batArmy3.getCampArmy().getUnionRank() > 0) || batArmy3.getCampArmy().getLegendEvoke()) {
          damage3 = defCamp.attEffect - defendCa3.defEffect + defCamp.TACTIC_ATT - defendCa3.TACTIC_DEF;
          if (damage3 <= 0)
            damage3 = 1; 
        } 
        if (defendCa3.playerId < 0 && defendCa3.armyName.contains("禁卫军 "))
          damage3 = Double.valueOf((defendCa3.getArmyHpOrg() / 15) * 0.01D).intValue(); 
        if (zhaoyunchidiao2) {
          damage3 = 1;
        } else if (defendCa3.getChiZhanFa() > 0) {
          damage3 *= rows4 - i2;
          zhaoyunchidiao2 = true;
        } 
        int xinlost3 = DamageSkill(defCamp, batArmy3, batArmy3.getCampArmy(), 0, damage3, false, dataGetter, bat, roundInfo, i2);
        if (i2 == 0 && batArmy3.getTroopHp()[0] <= 0) {
          roundInfo.attFirstRowKilled = true;
          firstRowkilled = true;
          roundInfo.win = 2;
        } 
        roundInfo.battleMsg.append(xinlost3).append(",").append(batArmy3.getTroopHp()[0]).append("*");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "|null#");
      CampArmy campArmy5 = defCamp;
      campArmy5.chiyanmizhen++;
      defCamp.xuyaochiyan = false;
      roundInfo.nextMinExeTime += 3000;
    } 
    if (firstRowkilled)
      return true; 
    if (defCamp.huoshaolianying >= 0 && defCamp.huoshaolianying <= 5) {
      zhixing = true;
      BattleArmy batArmy8 = roundInfo.defBattleArmy;
      CampArmy defendCa8 = batArmy8.getCampArmy();
      double bili = 0.2D;
      if (defCamp.huoshaolianying >= 4) {
        bili = 0.4D;
      } else if (defCamp.huoshaolianying >= 2) {
        bili = 0.3D;
      } else if (defCamp.huoshaolianying == 0) {
        bili = 0.0D;
      } 
      roundInfo.battleMsg.append("#34|def|").append(defCamp.huoshaolianying).append("|").append(batArmy8.getPosition()).append(",");
      int damage7 = Double.valueOf(batArmy8.getTroopHp()[0] * bili).intValue();
      if (batArmy8.getCampArmy().getGeneralId() == 73051 || batArmy8.getCampArmy().getIsBeatMonster() > 0 || (batArmy8.getCampArmy().getGeneralId() == 232 && batArmy8.getCampArmy().getUnionRank() > 0) || batArmy8.getCampArmy().getLegendEvoke()) {
        damage7 = attCamp.attEffect - defendCa8.defEffect + attCamp.TACTIC_ATT - defendCa8.TACTIC_DEF;
        if (damage7 <= 0)
          damage7 = 1; 
      } 
      int reduce3 = 0;
      int xinlost8 = DamageSkill(attCamp, batArmy8, batArmy8.getCampArmy(), 1, damage7, false, dataGetter, bat, roundInfo, 0);
      roundInfo.battleMsg.append(xinlost8).append(",").append(batArmy8.getTroopHp()[0]).append("#");
      CampArmy campArmy6 = defCamp;
      campArmy6.huoshaolianying--;
      if (batArmy8.getTroopHp()[0] <= 0) {
        roundInfo.defFirstRowKilled = true;
        firstRowkilled = true;
        roundInfo.win = 1;
      } 
      roundInfo.nextMinExeTime += 3000;
    } 
    if (defCamp.huoshaolianying >= 6) {
      zhixing = true;
      BattleArmy batArmy8 = roundInfo.defBattleArmy;
      CampArmy defendCa8 = batArmy8.getCampArmy();
      double bili = 0.2D;
      if (defCamp.huoshaolianying >= 4) {
        bili = 0.9D;
      } else if (defCamp.huoshaolianying >= 2) {
        bili = 0.3D;
      } else if (defCamp.huoshaolianying == 0) {
        bili = 0.0D;
      } 
      roundInfo.battleMsg.append("#34|def|").append(defCamp.huoshaolianying).append("|").append(batArmy8.getPosition()).append(",");
      int damage7 = Double.valueOf(batArmy8.getTroopHp()[0] * bili).intValue();
      if (batArmy8.getCampArmy().getGeneralId() == 73051 || batArmy8.getCampArmy().getIsBeatMonster() > 0 || (batArmy8.getCampArmy().getGeneralId() == 232 && batArmy8.getCampArmy().getUnionRank() > 0) || batArmy8.getCampArmy().getLegendEvoke()) {
        damage7 = attCamp.attEffect - defendCa8.defEffect + attCamp.TACTIC_ATT - defendCa8.TACTIC_DEF;
        if (damage7 <= 0)
          damage7 = 1; 
      } 
      int reduce3 = 0;
      int xinlost8 = DamageSkill(attCamp, batArmy8, batArmy8.getCampArmy(), 1, damage7, false, dataGetter, bat, roundInfo, 0);
      roundInfo.battleMsg.append(xinlost8).append(",").append(batArmy8.getTroopHp()[0]).append("#");
      CampArmy campArmy6 = defCamp;
      campArmy6.huoshaolianying--;
      if (batArmy8.getTroopHp()[0] <= 0) {
        roundInfo.defFirstRowKilled = true;
        firstRowkilled = true;
        roundInfo.win = 1;
      } 
      roundInfo.nextMinExeTime += 3000;
    } 
    if (attCamp.huoshaolianying >= 0 && defCamp.huoshaolianying <= 5) {
      zhixing = true;
      BattleArmy batArmy8 = roundInfo.attBattleArmy;
      CampArmy defendCa8 = batArmy8.getCampArmy();
      double bili = 0.2D;
      if (attCamp.huoshaolianying >= 4) {
        bili = 0.4D;
      } else if (attCamp.huoshaolianying >= 2) {
        bili = 0.3D;
      } else if (attCamp.huoshaolianying == 0) {
        bili = 0.0D;
      } 
      roundInfo.battleMsg.append("#34|att|").append(attCamp.huoshaolianying).append("|").append(batArmy8.getPosition()).append(",");
      int damage7 = Double.valueOf(batArmy8.getTroopHp()[0] * bili).intValue();
      if (batArmy8.getCampArmy().getGeneralId() == 73051 || batArmy8.getCampArmy().getIsBeatMonster() > 0 || (batArmy8.getCampArmy().getGeneralId() == 232 && batArmy8.getCampArmy().getUnionRank() > 0) || batArmy8.getCampArmy().getLegendEvoke()) {
        damage7 = defCamp.attEffect - defendCa8.defEffect + defCamp.TACTIC_ATT - defendCa8.TACTIC_DEF;
        if (damage7 <= 0)
          damage7 = 1; 
      } 
      int xinlost9 = DamageSkill(defCamp, batArmy8, batArmy8.getCampArmy(), 0, damage7, false, dataGetter, bat, roundInfo, 0);
      roundInfo.battleMsg.append(xinlost9).append(",").append(batArmy8.getTroopHp()[0]).append("#");
      if (batArmy8.getTroopHp()[0] <= 0) {
        roundInfo.attFirstRowKilled = true;
        firstRowkilled = true;
        roundInfo.win = 2;
      } 
      CampArmy campArmy7 = attCamp;
      campArmy7.huoshaolianying--;
      roundInfo.nextMinExeTime += 3000;
    } 
    if (attCamp.huoshaolianying >= 6) {
      zhixing = true;
      BattleArmy batArmy8 = roundInfo.attBattleArmy;
      CampArmy defendCa8 = batArmy8.getCampArmy();
      double bili = 0.2D;
      if (attCamp.huoshaolianying >= 4) {
        bili = 0.4D;
      } else if (attCamp.huoshaolianying >= 2) {
        bili = 0.3D;
      } else if (attCamp.huoshaolianying == 0) {
        bili = 0.0D;
      } 
      roundInfo.battleMsg.append("#34|att|").append(attCamp.huoshaolianying).append("|").append(batArmy8.getPosition()).append(",");
      int damage7 = Double.valueOf(batArmy8.getTroopHp()[0] * bili).intValue();
      if (batArmy8.getCampArmy().getGeneralId() == 73051 || batArmy8.getCampArmy().getIsBeatMonster() > 0 || (batArmy8.getCampArmy().getGeneralId() == 232 && batArmy8.getCampArmy().getUnionRank() > 0) || batArmy8.getCampArmy().getLegendEvoke()) {
        damage7 = defCamp.attEffect - defendCa8.defEffect + defCamp.TACTIC_ATT - defendCa8.TACTIC_DEF;
        if (damage7 <= 0)
          damage7 = 1; 
      } 
      int xinlost9 = DamageSkill(defCamp, batArmy8, batArmy8.getCampArmy(), 0, damage7, false, dataGetter, bat, roundInfo, 0);
      roundInfo.battleMsg.append(xinlost9).append(",").append(batArmy8.getTroopHp()[0]).append("#");
      if (batArmy8.getTroopHp()[0] <= 0) {
        roundInfo.attFirstRowKilled = true;
        firstRowkilled = true;
        roundInfo.win = 2;
      } 
      CampArmy campArmy7 = attCamp;
      campArmy7.huoshaolianying--;
      roundInfo.nextMinExeTime += 3000;
    } 
    if (firstRowkilled)
      return true; 
    if (roundInfo.attBattleArmy.getBaiBuChuanYang() > 0) {
      List<BattleArmy> listB2 = bat.defList;
      int rows4 = listB2.size();
      boolean youdajiang = false;
      BattleArmy batArmy9 = null;
      int currow = 0;
      for (int i = 0; i < rows4; i++) {
        if (i != 0) {
          if (i >= 5)
            break; 
          BattleArmy bta = listB2.get(i);
          if (bta.getIsDajiang() > 0 || bta.getCampArmy().getIsMain() > 0) {
            batArmy9 = bta;
            youdajiang = true;
            currow = i;
            break;
          } 
        } 
      } 
      if (youdajiang && batArmy9 != null) {
        zhixing = true;
        roundInfo.attBattleArmy.setBaiBuChuanYang(0);
        roundInfo.battleMsg.append("61|");
        CampArmy defendCa2 = batArmy9.getCampArmy();
        int reduce = 0;
        int damage5 = batArmy9.getTroopHp()[0] - 1;
        if (batArmy9.getCampArmy().getGeneralId() == 73051 || batArmy9.getCampArmy().getIsBeatMonster() > 0 || (batArmy9.getCampArmy().getGeneralId() == 232 && batArmy9.getCampArmy().getUnionRank() > 0) || batArmy9.getCampArmy().getLegendEvoke()) {
          damage5 = attCamp.attEffect - defendCa2.defEffect + attCamp.TACTIC_ATT - defendCa2.TACTIC_DEF;
          if (damage5 <= 0)
            damage5 = 1; 
        } 
        if (defendCa2.generalId == 204 && defendCa2.isjuexing > 0) {
          damage5 = damage5 * 3 / 10;
        } else if (RandomUtils.nextInt() > 60) {
          damage5 = damage5 * 2 / 10;
        } 
        roundInfo.battleMsg.append(1).append("|def|");
        roundInfo.battleMsg.append(batArmy9.getPosition()).append(",");
        int xinlost7 = DamageSkill(attCamp, batArmy9, batArmy9.getCampArmy(), 1, damage5, false, dataGetter, bat, roundInfo, currow);
        roundInfo.battleMsg.append(xinlost7).append(",").append(batArmy9.getTroopHp()[0]).append(",").append(batArmy9.getZfShiled()).append(",0#");
      } 
      roundInfo.nextMinExeTime += 3000;
    } 
    if (roundInfo.defBattleArmy.getBaiBuChuanYang() > 0) {
      List<BattleArmy> listB2 = bat.attList;
      int rows4 = listB2.size();
      boolean youdajiang = false;
      BattleArmy batArmy9 = null;
      int currow = 0;
      for (int i = 0; i < rows4; i++) {
        if (i != 0) {
          if (i >= 5)
            break; 
          BattleArmy bta = listB2.get(i);
          if (bta.getIsDajiang() > 0 || bta.getCampArmy().getIsMain() > 0) {
            batArmy9 = bta;
            youdajiang = true;
            currow = i;
            break;
          } 
        } 
      } 
      if (youdajiang && batArmy9 != null) {
        zhixing = true;
        roundInfo.defBattleArmy.setBaiBuChuanYang(0);
        roundInfo.battleMsg.append("61|");
        CampArmy attCa = batArmy9.getCampArmy();
        int reduce = 0;
        int damage5 = batArmy9.getTroopHp()[0] - 1;
        if (batArmy9.getCampArmy().getGeneralId() == 73051 || batArmy9.getCampArmy().getIsBeatMonster() > 0 || (batArmy9.getCampArmy().getGeneralId() == 232 && batArmy9.getCampArmy().getUnionRank() > 0) || batArmy9.getCampArmy().getLegendEvoke()) {
          damage5 = defCamp.attEffect - attCa.defEffect + defCamp.TACTIC_ATT - attCa.TACTIC_DEF;
          if (damage5 <= 0)
            damage5 = 1; 
        } 
        if (attCa.generalId == 204 && attCa.isjuexing > 0) {
          damage5 = damage5 * 3 / 10;
        } else if (RandomUtils.nextInt() > 60) {
          damage5 = damage5 * 2 / 10;
        } 
        roundInfo.battleMsg.append(1).append("|att|");
        roundInfo.battleMsg.append(batArmy9.getPosition()).append(",");
        int xinlost7 = DamageSkill(defCamp, batArmy9, batArmy9.getCampArmy(), 0, damage5, false, dataGetter, bat, roundInfo, currow);
        roundInfo.battleMsg.append(xinlost7).append(",").append(batArmy9.getTroopHp()[0]).append(",").append(batArmy9.getZfShiled()).append(",0#");
      } 
      roundInfo.nextMinExeTime += 3000;
    } 
    if (attCamp.getUnionState() > 0 && attCamp.getGeneralId() == 103 && attCamp.getSneer() <= 0) {
      zhixing = true;
      List<BattleArmy> listB2 = bat.defList;
      int rows4 = 2;
      boolean jflh = false;
      int chushi = 1;
      int huotype = 0;
      if (attCamp.getJFLH() == 1) {
        rows4 = 4;
        attCamp.setJFLH(2);
        jflh = true;
        chushi = 2;
      } 
      if (rows4 > listB2.size())
        rows4 = listB2.size(); 
      if (attCamp.getUnionRank() >= 1)
        huotype = 1; 
      if (attCamp.getUnionFirst() <= 0) {
        chushi = 3;
        roundInfo.battleMsg.append("67|def|").append(chushi).append("|").append(rows4).append("|").append(huotype).append("#");
        attCamp.setUnionFirst(1);
      } else {
        roundInfo.battleMsg.append("67|def|").append(chushi).append("|").append(rows4).append("|").append(huotype).append("|");
        boolean zhaoyunchidiao3 = false;
        for (int i3 = 0; i3 < rows4; i3++) {
          int reduce4 = 0;
          BattleArmy batArmy4 = listB2.get(i3);
          CampArmy defendCa4 = batArmy4.getCampArmy();
          roundInfo.battleMsg.append(batArmy4.getPosition()).append(",");
          int beishu = 0;
          if (attCamp.getUnionRank() > 0)
            beishu = 1; 
          int damage6 = Double.valueOf(batArmy4.getTroopHp()[0] * 0.05D * (1 + beishu)).intValue();
          if (batArmy4.getCampArmy().getGeneralId() == 73051 || batArmy4.getCampArmy().getIsBeatMonster() > 0 || (batArmy4.getCampArmy().getGeneralId() == 232 && batArmy4.getCampArmy().getUnionRank() > 0) || batArmy4.getCampArmy().getLegendEvoke()) {
            damage6 = attCamp.attEffect - defendCa4.defEffect + attCamp.TACTIC_ATT - defendCa4.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (defendCa4.isPhantom && defendCa4.copytype == 21)
            damage6 = Double.valueOf(batArmy4.getTroopHp()[0] * 0.02D * (1 + beishu)).intValue(); 
          if (defendCa4.playerId < 0 && defendCa4.armyName.contains("禁卫军 "))
            damage6 = Double.valueOf(batArmy4.getTroopHp()[0] * 0.01D * (1 + beishu)).intValue(); 
          if (damage6 < 1000)
            damage6 = 1000; 
          if (attCamp.getUnionRank() >= 2)
            damage6 += damage6 * 10 / 100; 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa4.getChiZhanFa() > 0) {
            damage6 *= 2;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(attCamp, batArmy4, batArmy4.getCampArmy(), 1, damage6, jflh, dataGetter, bat, roundInfo, i3);
          if (i3 == 0 && batArmy4.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy4.getTroopHp()[0]).append(",0,0;");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.getUnionState() > 0 && defCamp.getGeneralId() == 103 && defCamp.getSneer() <= 0) {
      zhixing = true;
      List<BattleArmy> listB2 = bat.attList;
      int rows4 = 2;
      boolean jflh = false;
      int chushi = 1;
      int huotype = 0;
      if (defCamp.getJFLH() == 1) {
        rows4 = 4;
        defCamp.setJFLH(2);
        jflh = true;
        chushi = 2;
      } 
      if (rows4 > listB2.size())
        rows4 = listB2.size(); 
      if (defCamp.getUnionRank() >= 1)
        huotype = 1; 
      if (defCamp.getUnionFirst() <= 0) {
        chushi = 3;
        roundInfo.battleMsg.append("67|att|").append(chushi).append("|").append(rows4).append("|").append(huotype).append("#");
        defCamp.setUnionFirst(1);
      } else {
        roundInfo.battleMsg.append("67|att|").append(chushi).append("|").append(rows4).append("|").append(huotype).append("|");
        boolean zhaoyunchidiao3 = false;
        for (int i3 = 0; i3 < rows4; i3++) {
          int reduce4 = 0;
          BattleArmy batArmy4 = listB2.get(i3);
          CampArmy defendCa4 = batArmy4.getCampArmy();
          roundInfo.battleMsg.append(batArmy4.getPosition()).append(",");
          int beishu = 0;
          if (defCamp.getUnionRank() > 0)
            beishu = 1; 
          int damage6 = Double.valueOf(batArmy4.getTroopHp()[0] * 0.05D * (1 + beishu)).intValue();
          if (batArmy4.getCampArmy().getGeneralId() == 73051 || batArmy4.getCampArmy().getIsBeatMonster() > 0 || (batArmy4.getCampArmy().getGeneralId() == 232 && batArmy4.getCampArmy().getUnionRank() > 0) || batArmy4.getCampArmy().getLegendEvoke()) {
            damage6 = defCamp.attEffect - defendCa4.defEffect + defCamp.TACTIC_ATT - defendCa4.TACTIC_DEF;
            if (damage6 <= 0)
              damage6 = 1; 
          } 
          if (defendCa4.isPhantom && defendCa4.copytype == 21)
            damage6 = Double.valueOf(batArmy4.getTroopHp()[0] * 0.02D * (1 + beishu)).intValue(); 
          if (defendCa4.playerId < 0 && defendCa4.armyName.contains("禁卫军 "))
            damage6 = Double.valueOf(batArmy4.getTroopHp()[0] * 0.01D * (1 + beishu)).intValue(); 
          if (damage6 < 1000)
            damage6 = 1000; 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa4.getChiZhanFa() > 0) {
            damage6 *= 2;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(defCamp, batArmy4, batArmy4.getCampArmy(), 0, damage6, jflh, dataGetter, bat, roundInfo, i3);
          if (i3 == 0 && batArmy4.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
          } 
          roundInfo.battleMsg.append(xinlost5).append(",").append(batArmy4.getTroopHp()[0]).append(",0,0;");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (firstRowkilled)
      return true; 
    if (attCamp.generalId == 273 && attCamp.isjuexing > 0 && attCamp.xiahouyuan < 10 && attCamp.tacticVal <= 0 && attCamp.getSneer() <= 0) {
      List<BattleArmy> listB2 = bat.defList;
      int rows4 = 1;
      int dilietype = 2;
      int diliefirst = 0;
      boolean canzhixing = false;
      if (attCamp.xiahouyuan <= 0)
        diliefirst = 1; 
      if (bat.getRoundNum().get() % 2 == 1) {
        dilietype = 2;
        rows4 = 1;
        canzhixing = true;
      } else if (bat.terrainVal == 2) {
        rows4 = 2;
        dilietype = 1;
        canzhixing = true;
      } 
      CampArmy campArmy8 = attCamp;
      campArmy8.xiahouyuan++;
      if (rows4 > listB2.size())
        rows4 = listB2.size(); 
      if (canzhixing) {
        zhixing = true;
        roundInfo.battleMsg.append("58|att|").append(dilietype).append("|").append(diliefirst).append("|");
        boolean zhaoyunchidiao3 = false;
        int hunluangailv = RandomUtils.nextInt(100);
        for (int i5 = 0; i5 < rows4; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB2.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append("*");
          int damage6 = attCamp.getAttEffect() - defendCa6.getDefEffect() + bat.att_gongji_base_add + (attCamp.getAttDef_B()).ATT_B - (defendCa6.getAttDef_B()).DEF_B;
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows4 - i5;
            zhaoyunchidiao3 = true;
          } 
          if (dilietype == 1 && batArmy6.getSpecial() != 1 && hunluangailv >= defendCa6.getMianYiGaiLv())
            batArmy6.setSpecial(1); 
          int xinlost5 = DamageSkill(attCamp, batArmy6, batArmy6.getCampArmy(), 1, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.defFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 1;
          } 
          roundInfo.battleMsg.append(xinlost5).append("*").append(batArmy6.getTroopHp()[0]).append("*0*0;");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    if (defCamp.generalId == 273 && defCamp.isjuexing > 0 && defCamp.xiahouyuan < 10 && defCamp.tacticVal <= 0 && defCamp.getSneer() <= 0) {
      List<BattleArmy> listB2 = bat.attList;
      int rows4 = 1;
      int dilietype = 2;
      int diliefirst = 0;
      boolean canzhixing = false;
      if (defCamp.xiahouyuan <= 0)
        diliefirst = 1; 
      if (bat.getRoundNum().get() % 2 == 1) {
        dilietype = 2;
        rows4 = 1;
        canzhixing = true;
      } else if (bat.terrainVal == 2) {
        rows4 = 2;
        dilietype = 1;
        canzhixing = true;
      } 
      CampArmy campArmy9 = defCamp;
      campArmy9.xiahouyuan++;
      if (rows4 > listB2.size())
        rows4 = listB2.size(); 
      if (canzhixing) {
        zhixing = true;
        roundInfo.battleMsg.append("58|def|").append(dilietype).append("|").append(diliefirst).append("|");
        boolean zhaoyunchidiao3 = false;
        int hunluangailv = RandomUtils.nextInt(100);
        for (int i5 = 0; i5 < rows4; i5++) {
          int reduce7 = 0;
          BattleArmy batArmy6 = listB2.get(i5);
          CampArmy defendCa6 = batArmy6.getCampArmy();
          roundInfo.battleMsg.append(batArmy6.getPosition()).append("*");
          int damage6 = defCamp.getAttEffect() - defendCa6.getDefEffect() + bat.att_gongji_base_add + (defCamp.getAttDef_B()).ATT_B - (defendCa6.getAttDef_B()).DEF_B;
          if (dilietype == 1 && batArmy6.getSpecial() != 1 && hunluangailv >= defendCa6.getMianYiGaiLv())
            batArmy6.setSpecial(1); 
          if (zhaoyunchidiao3) {
            damage6 = 1;
          } else if (defendCa6.getChiZhanFa() > 0) {
            damage6 *= rows4 - i5;
            zhaoyunchidiao3 = true;
          } 
          int xinlost5 = DamageSkill(defCamp, batArmy6, batArmy6.getCampArmy(), 0, damage6, false, dataGetter, bat, roundInfo, i5);
          if (i5 == 0 && batArmy6.getTroopHp()[0] <= 0) {
            roundInfo.attFirstRowKilled = true;
            firstRowkilled = true;
            roundInfo.win = 2;
          } 
          roundInfo.battleMsg.append(xinlost5).append("*").append(batArmy6.getTroopHp()[0]).append("*0*0;");
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
        roundInfo.nextMinExeTime += 3000;
      } 
    } 
    return firstRowkilled;
  }
  
  public void dealStrategy(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    int attSt = roundInfo.attBattleArmy.getStrategy();
    int defSt = roundInfo.defBattleArmy.getStrategy();
    FightStragtegyCoe fsc = dataGetter.getFightStragtegyCoeCache().getFightStragtegyCoe(defSt, attSt);
    int winnerside = fsc.getWinerSide().intValue();
    double attlost = fsc.getAttLost().doubleValue();
    double deflost = fsc.getDefLost().doubleValue();
    if ((roundInfo.attCampArmy.getGeneralId() == 281 && roundInfo.attCampArmy.isjuexing <= 0) || (roundInfo.attCampArmy.getGeneralId() == 416 && roundInfo.attCampArmy.getChapterId() > 1) || roundInfo.attCampArmy.getBuff().equals("baqi")) {
      int strategyType = attSt % 100 / 10;
      if (strategyType == 1) {
        CampArmy attCampArmy5 = roundInfo.attCampArmy;
        attCampArmy5.baqi1++;
      } else if (strategyType == 2) {
        CampArmy attCampArmy6 = roundInfo.attCampArmy;
        attCampArmy6.baqi2++;
      } else if (strategyType == 3) {
        CampArmy attCampArmy7 = roundInfo.attCampArmy;
        attCampArmy7.baqi3++;
      } 
    } 
    if ((roundInfo.defCampArmy.getGeneralId() == 281 && roundInfo.defCampArmy.isjuexing <= 0) || (roundInfo.defCampArmy.getGeneralId() == 416 && roundInfo.defCampArmy.getChapterId() > 1) || roundInfo.defCampArmy.getBuff().equals("baqi")) {
      int strategyType = defSt % 100 / 10;
      if (strategyType == 1) {
        CampArmy defCampArmy5 = roundInfo.defCampArmy;
        defCampArmy5.baqi1++;
      } else if (strategyType == 2) {
        CampArmy defCampArmy6 = roundInfo.defCampArmy;
        defCampArmy6.baqi2++;
      } else if (strategyType == 3) {
        CampArmy defCampArmy7 = roundInfo.defCampArmy;
        defCampArmy7.baqi3++;
      } 
    } 
    if ((roundInfo.attCampArmy.getGeneralId() == 281 && roundInfo.attCampArmy.isjuexing > 0) || (roundInfo.attCampArmy.getGeneralId() == 416 && roundInfo.attCampArmy.getChapterId() > 2 && roundInfo.attCampArmy.getBaQiNum() >= 0)) {
      int strategyType = attSt % 100 / 10;
      int pose = roundInfo.attBattleArmy.getpose();
      int oldbaqinum = roundInfo.attCampArmy.getBaQiNum();
      if (strategyType == 1 && oldbaqinum >= 8) {
        roundInfo.attCampArmy.setBaQiNum(oldbaqinum - 8);
        roundInfo.attBattleArmy.setpose(2);
        roundInfo.attCampArmy.setHuXiao(true);
        roundInfo.attCampArmy.setDefence(0);
      } else if (strategyType == 2 && oldbaqinum >= 8) {
        roundInfo.attCampArmy.setBaQiNum(oldbaqinum - 8);
        roundInfo.attBattleArmy.setpose(1);
        roundInfo.attCampArmy.setHuXiao(true);
        roundInfo.attCampArmy.setDefence(1);
      } else if (strategyType == 3 && oldbaqinum >= 12) {
        roundInfo.attCampArmy.setBaQiNum(oldbaqinum - 12);
        roundInfo.attBattleArmy.setpose(0);
        roundInfo.attCampArmy.setHuXiao(true);
        roundInfo.attCampArmy.setDefence(0);
        roundInfo.defCampArmy.setSneer(1);
        roundInfo.battleMsg.append("98|def|");
        for (int i = 0; i < bat.defList.size(); i++) {
          BattleArmy defarmy = bat.defList.get(i);
          if (defarmy.getCampArmy() == roundInfo.defCampArmy)
            roundInfo.battleMsg.append(defarmy.getPosition()).append(","); 
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      } 
    } 
    if ((roundInfo.defCampArmy.getGeneralId() == 281 && roundInfo.defCampArmy.isjuexing > 0) || (roundInfo.defCampArmy.getGeneralId() == 416 && roundInfo.defCampArmy.getChapterId() > 2 && roundInfo.defCampArmy.getBaQiNum() >= 0)) {
      int strategyType = defSt % 100 / 10;
      int pose = roundInfo.defBattleArmy.getpose();
      int oldbaqinum = roundInfo.defCampArmy.getBaQiNum();
      if (strategyType == 1 && oldbaqinum >= 8) {
        roundInfo.defCampArmy.setBaQiNum(oldbaqinum - 8);
        roundInfo.defBattleArmy.setpose(2);
        roundInfo.defCampArmy.setHuXiao(true);
        roundInfo.defCampArmy.setDefence(0);
      } else if (strategyType == 2 && oldbaqinum >= 8) {
        roundInfo.defCampArmy.setBaQiNum(oldbaqinum - 8);
        roundInfo.defBattleArmy.setpose(1);
        roundInfo.defCampArmy.setHuXiao(true);
        roundInfo.defCampArmy.setDefence(1);
      } else if (strategyType == 3 && oldbaqinum >= 12) {
        roundInfo.defCampArmy.setBaQiNum(oldbaqinum - 12);
        roundInfo.defBattleArmy.setpose(0);
        roundInfo.defCampArmy.setHuXiao(true);
        roundInfo.defCampArmy.setDefence(0);
        roundInfo.attCampArmy.setSneer(1);
        roundInfo.battleMsg.append("98|att|");
        for (int i = 0; i < bat.attList.size(); i++) {
          BattleArmy attarmy = bat.attList.get(i);
          if (attarmy.getCampArmy() == roundInfo.attCampArmy)
            roundInfo.battleMsg.append(attarmy.getPosition()).append(","); 
        } 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      } 
    } 
    if (roundInfo.attCampArmy.generalId == 204 && roundInfo.attCampArmy.isjuexing > 0)
      return; 
    if (roundInfo.defCampArmy.generalId == 204 && roundInfo.defCampArmy.isjuexing > 0)
      return; 
    if (roundInfo.attCampArmy.duichuangnum == 0 && roundInfo.attCampArmy.hasbigformationskill > 0 && roundInfo.attCampArmy.formationtype == 1) {
      winnerside = 1;
      attlost = 0.02D;
      deflost = 0.3D;
      if (roundInfo.attCampArmy.formationLevel >= 1000) {
        deflost = 4.0D;
      } else if (roundInfo.attCampArmy.formationLevel >= 800) {
        deflost = 3.0D;
      } else if (roundInfo.attCampArmy.formationLevel >= 500) {
        deflost = 2.0D;
      } else if (roundInfo.attCampArmy.formationLevel >= 100) {
        deflost = 1.0D;
      } else if (roundInfo.attCampArmy.formationLevel >= 80) {
        deflost = 0.5D;
      } else if (roundInfo.attCampArmy.formationLevel >= 50) {
        deflost = 0.4D;
      } 
      roundInfo.isAttZsCf = 1;
    } 
    if (roundInfo.defCampArmy.duichuangnum == 0 && roundInfo.defCampArmy.hasbigformationskill > 0 && roundInfo.defCampArmy.formationtype == 1) {
      winnerside = 2;
      deflost = 0.02D;
      attlost = 0.3D;
      if (roundInfo.defCampArmy.formationLevel >= 1000) {
        deflost = 4.0D;
      } else if (roundInfo.defCampArmy.formationLevel >= 800) {
        deflost = 3.0D;
      } else if (roundInfo.defCampArmy.formationLevel >= 500) {
        deflost = 2.0D;
      } else if (roundInfo.defCampArmy.formationLevel >= 100) {
        deflost = 1.0D;
      } else if (roundInfo.defCampArmy.formationLevel >= 80) {
        deflost = 0.5D;
      } else if (roundInfo.defCampArmy.formationLevel >= 50) {
        deflost = 0.4D;
      } 
      roundInfo.isDefZSCf = 1;
    } 
    CampArmy attCampArmy8 = roundInfo.attCampArmy;
    attCampArmy8.duichuangnum++;
    CampArmy defCampArmy8 = roundInfo.defCampArmy;
    defCampArmy8.duichuangnum++;
    roundInfo.tacticStrategyResult = winnerside;
    if (roundInfo.tacticStrategyResult == 1) {
      if (roundInfo.attCampArmy.getGeneralId() == 281 && roundInfo.attCampArmy.getLegendEvoke() && roundInfo.attCampArmy.getChapterId() >= 1)
        roundInfo.attCampArmy.setScZsWin(true); 
      if (roundInfo.attCampArmy.getGeneralId() == 281 && roundInfo.attCampArmy.getLegendEvoke() && roundInfo.attCampArmy.getChapterId() >= 1)
        roundInfo.attCampArmy.setScJj2(true); 
    } 
    if (roundInfo.tacticStrategyResult == 2) {
      if (roundInfo.defCampArmy.getGeneralId() == 281 && roundInfo.defCampArmy.getLegendEvoke() && roundInfo.defCampArmy.getChapterId() >= 1)
        roundInfo.defCampArmy.setScZsWin(true); 
      if (roundInfo.defCampArmy.getGeneralId() == 281 && roundInfo.defCampArmy.getLegendEvoke() && roundInfo.defCampArmy.getChapterId() >= 1)
        roundInfo.defCampArmy.setScJj2(true); 
    } 
    if (roundInfo.tacticStrategyResult == 3) {
      roundInfo.defCampArmy.setScJj1(true);
      roundInfo.attCampArmy.setScJj1(true);
      if (roundInfo.attCampArmy.getGeneralId() == 281 && roundInfo.attCampArmy.getLegendEvoke() && roundInfo.attCampArmy.getChapterId() > 1) {
        roundInfo.attCampArmy.defEffect += (int)(roundInfo.attCampArmy.defEffect * 0.2D);
        roundInfo.attCampArmy.TACTIC_DEF += (int)(roundInfo.attCampArmy.TACTIC_DEF * 0.2D);
      } 
      if (roundInfo.defCampArmy.getGeneralId() == 281 && roundInfo.defCampArmy.getLegendEvoke() && roundInfo.defCampArmy.getChapterId() > 1) {
        roundInfo.defCampArmy.defEffect += (int)(roundInfo.defCampArmy.defEffect * 0.2D);
        roundInfo.defCampArmy.TACTIC_DEF += (int)(roundInfo.defCampArmy.TACTIC_DEF * 0.2D);
      } 
    } 
    if (roundInfo.attCampArmy.tacicId == 1511 && roundInfo.attCampArmy.ganninglimit > 0 && winnerside != 2) {
      CampArmy attCampArmy9 = roundInfo.attCampArmy;
      attCampArmy9.ganninglimit--;
      CampArmy attCampArmy10 = roundInfo.attCampArmy;
      attCampArmy10.tacticVal++;
    } 
    if (roundInfo.defCampArmy.tacicId == 1511 && roundInfo.defCampArmy.ganninglimit > 0 && winnerside != 1) {
      CampArmy defCampArmy9 = roundInfo.defCampArmy;
      defCampArmy9.ganninglimit--;
      CampArmy defCampArmy10 = roundInfo.defCampArmy;
      defCampArmy10.tacticVal++;
    } 
    if (roundInfo.attCampArmy.generalId == 267 && roundInfo.attCampArmy.isjuexing > 0 && roundInfo.attCampArmy.ganninglimit > 0 && winnerside == 1) {
      CampArmy attCampArmy11 = roundInfo.attCampArmy;
      attCampArmy11.ganninglimit--;
      CampArmy attCampArmy12 = roundInfo.attCampArmy;
      attCampArmy12.tacticVal++;
    } 
    if (roundInfo.defCampArmy.generalId == 267 && roundInfo.defCampArmy.isjuexing > 0 && roundInfo.defCampArmy.ganninglimit > 0 && winnerside == 2) {
      CampArmy defCampArmy11 = roundInfo.defCampArmy;
      defCampArmy11.ganninglimit--;
      CampArmy defCampArmy12 = roundInfo.defCampArmy;
      defCampArmy12.tacticVal++;
    } 
    if (roundInfo.attCampArmy.generalId == 267 && roundInfo.attCampArmy.isjuexing > 0 && roundInfo.attCampArmy.ganninglimit > 0 && winnerside == 2) {
      CampArmy attCampArmy13 = roundInfo.attCampArmy;
      attCampArmy13.ganninglimit--;
      CampArmy attCampArmy14 = roundInfo.attCampArmy;
      attCampArmy14.tacticVal++;
      roundInfo.attCampArmy.setJueDiFanJi(true);
    } 
    if (roundInfo.defCampArmy.generalId == 267 && roundInfo.defCampArmy.isjuexing > 0 && roundInfo.defCampArmy.ganninglimit > 0 && winnerside == 1) {
      CampArmy defCampArmy13 = roundInfo.defCampArmy;
      defCampArmy13.ganninglimit--;
      CampArmy defCampArmy14 = roundInfo.defCampArmy;
      defCampArmy14.tacticVal++;
      roundInfo.defCampArmy.setJueDiFanJi(true);
    } 
    boolean lostBlood = false;
    String debug = Configuration.getProperty("gcld.battle.caculate.debug");
    if (debug.equals("1")) {
      roundInfo.caculateDebugBuffer.append("Strategy.").append(" | ").append("attSt:").append(" | ").append(attSt).append(" | ").append("defSt:").append(" | ").append(defSt).append("\n\t");
      roundInfo.caculateDebugBuffer.append("FightStragtegyCoe").append(" | ").append("Id:").append(" | ").append(fsc.getId()).append(" | ").append("Att:").append(" | ").append(fsc.getAttStrategy()).append(" | ").append("Def:").append(" | ").append(fsc.getDefStrategy()).append(" | ").append("Win:").append(" | ").append(winnerside).append(" | ").append("AttLost:").append(" | ").append(attlost).append(" | ").append("DefLost:").append(" | ").append(deflost).append("\n\t");
    } 
    int attHp = roundInfo.attBattleArmy.getTroopHp()[0];
    int defHp = roundInfo.defBattleArmy.getTroopHp()[0];
    if (deflost > 0.0D) {
      FightStrategies fs = (FightStrategies)dataGetter.getFightStrategiesCache().get(Integer.valueOf(attSt));
      int reduceNum = (int)(attHp * deflost);
      if (winnerside == 1)
        reduceNum += fs.getBaseDamage().intValue(); 
      if (roundInfo.attCampArmy.generalId == 204 && roundInfo.attCampArmy.isjuexing > 0 && reduceNum >= defHp)
        reduceNum = defHp - 1; 
      if (roundInfo.defBattleArmy.getCampArmy().getTacicId() == 1202) {
        roundInfo.defhuajie = 1;
        reduceNum /= 5;
      } 
      if (reduceNum < 10)
        reduceNum = 10; 
      boolean realdamage = false;
      if (roundInfo.defBattleArmy.getHaveZhanChe() && roundInfo.defBattleArmy.getHuJia() > 0) {
        reduceNum = 1;
        roundInfo.defBattleArmy.setHuJia(roundInfo.defBattleArmy.getHuJia() - 1);
      } else if (roundInfo.defBattleArmy.getZhanchedun() > 0 && roundInfo.defBattleArmy.getZCdunHp() > 0) {
        reduceNum = 1;
        roundInfo.defBattleArmy.setZCdunHp(roundInfo.defBattleArmy.getZCdunHp() - 1);
      } else if (roundInfo.defBattleArmy.getShield() > 0) {
        if (roundInfo.defBattleArmy.getShiledType() == 2) {
          if (roundInfo.defBattleArmy.getZhanchedun() > 0) {
            reduceNum = 1;
          } else {
            reduceNum = 1;
          } 
        } else {
          if (reduceNum > roundInfo.defBattleArmy.getShield())
            reduceNum = roundInfo.defBattleArmy.getShield(); 
          realdamage = true;
        } 
        roundInfo.defBattleArmy.setShield(roundInfo.defBattleArmy.getShield() - reduceNum);
      } 
      if (!realdamage && reduceNum >= roundInfo.defBattleArmy.getTroopHp()[0]) {
        reduceNum = roundInfo.defBattleArmy.getTroopHp()[0];
        roundInfo.defFirstRowKilled = true;
        roundInfo.defKilledList.add(roundInfo.defBattleArmy);
        roundInfo.win = 1;
        if (roundInfo.attCampArmy.getMfBuff() >= 0 && roundInfo.attCampArmy.getGeneralId() == 232 && roundInfo.attCampArmy.getIsJuexing() > 0)
          roundInfo.attCampArmy.setMfBuff(roundInfo.attCampArmy.getMfBuff() + 1); 
        if (roundInfo.attCampArmy.getJxBuff() >= 0 && roundInfo.attCampArmy.getGeneralId() == 201 && roundInfo.attCampArmy.getChapterId() > 0)
          roundInfo.attCampArmy.setJxBuff(roundInfo.attCampArmy.getJxBuff() + 1); 
        if (roundInfo.attCampArmy.getJxBuff() >= 0 && roundInfo.attCampArmy.getFormationType() == 1 && roundInfo.attCampArmy.getFormationLevel() > 1000)
          roundInfo.attCampArmy.setJxBuff(roundInfo.attCampArmy.getJxBuff() + 1); 
        if (roundInfo.attCampArmy.getJxBuff() >= 0 && roundInfo.attCampArmy.getFormationType() == 2 && roundInfo.attCampArmy.getFormationLevel() > 1000)
          roundInfo.attCampArmy.setJxBuff(roundInfo.attCampArmy.getJxBuff() + 1); 
        if (roundInfo.attCampArmy.getJxBuff() >= 0 && roundInfo.attCampArmy.getFormationType() == 3 && roundInfo.attCampArmy.getFormationLevel() > 1000)
          roundInfo.attCampArmy.setJxBuff(roundInfo.attCampArmy.getJxBuff() + 1); 
        if (roundInfo.attCampArmy.getJxBuff() >= 0 && roundInfo.attCampArmy.getFormationType() == 6 && roundInfo.attCampArmy.getFormationLevel() > 1000)
          roundInfo.attCampArmy.setJxBuff(roundInfo.attCampArmy.getJxBuff() + 1); 
      } 
      if (roundInfo.defCampArmy.getGeneralId() == 204 && roundInfo.defCampArmy.getIsJuexing() > 0 && !roundInfo.defCampArmy.getLegendEvoke()) {
        double oldxue = roundInfo.defBattleArmy.getTroopHp()[0] * 100.0D / roundInfo.defCampArmy.getMaxForces();
        double xinxue = (roundInfo.defBattleArmy.getTroopHp()[0] - reduceNum) * 100.0D / roundInfo.defCampArmy.getMaxForces();
        if ((oldxue > 80.0D && xinxue <= 80.0D) || (oldxue > 50.0D && xinxue <= 50.0D) || (oldxue > 20.0D && xinxue <= 20.0D))
          roundInfo.defCampArmy.setZhaoYunQijinQiChu(true); 
      } 
      boolean defhujia = false;
      for (int j = 0; j < 3; j++) {
        if (!realdamage) {
          int[] troopHp = roundInfo.defBattleArmy.getTroopHp();
          int n = j;
          troopHp[n] = troopHp[n] - reduceNum;
        } 
      } 
      if (!realdamage)
        roundInfo.defStrategyLost += reduceNum * 3; 
      if (debug.equals("1"))
        roundInfo.caculateDebugBuffer.append("Att ST Base:").append(" | ").append(fs.getBaseDamage()).append(" | ").append("AttTroopHp:").append(roundInfo.attBattleArmy.getTroopHp()[0]).append(" | ").append("Def Lost:").append(" | ").append(reduceNum).append(" | ").append("Def Lost All:").append(" | ").append(roundInfo.defStrategyLost).append("\n\t"); 
      if (bat.getDefBaseInfo().getNum() < roundInfo.defStrategyLost)
        ErrorSceneLog.getInstance().appendErrorMsg("Builder dealStrtegy def兵力小于0,basenum:" + bat.getDefBaseInfo().getNum() + ",reduce:" + (reduceNum * 3) + ",defstrategylost:" + roundInfo.defStrategyLost + ",builder 8313行"); 
      bat.getDefBaseInfo().setNum(bat.getDefBaseInfo().getNum() - roundInfo.defStrategyLost);
      lostBlood = true;
      CampArmy defCampArmy15 = roundInfo.defCampArmy, defCampArmy = defCampArmy15;
      defCampArmy15.armyHpLoss += roundInfo.defStrategyLost;
      PlayerInfo piDef = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.defBattleArmy.getCampArmy().getPlayerId()));
      if (piDef != null) {
        PlayerInfo playerInfo5 = piDef, playerInfo = playerInfo5;
        playerInfo5.lostTotal += roundInfo.defStrategyLost;
      } 
      CampArmy attCampArmy15 = roundInfo.attCampArmy, attCampArmy = attCampArmy15;
      attCampArmy15.armyHpKill += roundInfo.defStrategyLost;
      if (roundInfo.defCampArmy.isBarPhantom) {
        CampArmy attCampArmy16 = roundInfo.attCampArmy, attCampArmy2 = attCampArmy16;
        attCampArmy16.barbarainHpKill += roundInfo.defStrategyLost;
      } 
      PlayerInfo piAtt = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.attBattleArmy.getCampArmy().getPlayerId()));
      if (piAtt != null) {
        PlayerInfo playerInfo6 = piAtt, playerInfo2 = playerInfo6;
        playerInfo6.killTotal += roundInfo.defStrategyLost;
      } 
    } 
    if (attlost > 0.0D) {
      FightStrategies fs = (FightStrategies)dataGetter.getFightStrategiesCache().get(Integer.valueOf(defSt));
      int reduceNum = (int)(defHp * attlost);
      if (winnerside == 1)
        reduceNum += fs.getBaseDamage().intValue(); 
      if (roundInfo.defCampArmy.generalId == 204 && roundInfo.defCampArmy.isjuexing > 0 && reduceNum >= attHp)
        reduceNum = attHp - 1; 
      if (roundInfo.attCampArmy.getTacicId() == 1202) {
        roundInfo.atthuajie = 1;
        reduceNum /= 5;
      } 
      if (reduceNum < 10)
        reduceNum = 10; 
      boolean realdamage = false;
      if (roundInfo.attBattleArmy.getHaveZhanChe() && roundInfo.attBattleArmy.getHuJia() > 0) {
        reduceNum = 1;
        roundInfo.attBattleArmy.setHuJia(roundInfo.attBattleArmy.getHuJia() - 1);
      } else if (roundInfo.attBattleArmy.getZhanchedun() > 0 && roundInfo.attBattleArmy.getZCdunHp() > 0) {
        reduceNum = 1;
        roundInfo.attBattleArmy.setZCdunHp(roundInfo.attBattleArmy.getZCdunHp() - 1);
      } else if (roundInfo.attBattleArmy.getShield() > 0) {
        if (roundInfo.attBattleArmy.getShiledType() == 2) {
          if (roundInfo.attBattleArmy.getZhanchedun() > 0) {
            reduceNum = 1;
          } else {
            reduceNum = 1;
          } 
        } else {
          if (reduceNum > roundInfo.attBattleArmy.getShield())
            reduceNum = roundInfo.attBattleArmy.getShield(); 
          realdamage = true;
        } 
        roundInfo.attBattleArmy.setShield(roundInfo.attBattleArmy.getShield() - reduceNum);
      } 
      if (!realdamage && reduceNum >= roundInfo.attBattleArmy.getTroopHp()[0]) {
        reduceNum = roundInfo.attBattleArmy.getTroopHp()[0];
        roundInfo.attFirstRowKilled = true;
        roundInfo.attKilledList.add(roundInfo.attBattleArmy);
        roundInfo.win = 2;
        if (roundInfo.defCampArmy.getMfBuff() >= 0 && roundInfo.defCampArmy.getGeneralId() == 232 && roundInfo.defCampArmy.getIsJuexing() > 0)
          roundInfo.defCampArmy.setMfBuff(roundInfo.defCampArmy.getMfBuff() + 1); 
        if (roundInfo.defCampArmy.getJxBuff() >= 0 && roundInfo.defCampArmy.getGeneralId() == 201 && roundInfo.defCampArmy.getChapterId() > 0)
          roundInfo.defCampArmy.setJxBuff(roundInfo.defCampArmy.getJxBuff() + 1); 
        if (roundInfo.defCampArmy.getJxBuff() >= 0 && roundInfo.defCampArmy.getFormationType() == 1 && roundInfo.defCampArmy.getFormationLevel() > 1000)
          roundInfo.defCampArmy.setJxBuff(roundInfo.defCampArmy.getJxBuff() + 1); 
        if (roundInfo.defCampArmy.getJxBuff() >= 0 && roundInfo.defCampArmy.getFormationType() == 2 && roundInfo.defCampArmy.getFormationLevel() > 1000)
          roundInfo.defCampArmy.setJxBuff(roundInfo.defCampArmy.getJxBuff() + 1); 
        if (roundInfo.defCampArmy.getJxBuff() >= 0 && roundInfo.defCampArmy.getFormationType() == 3 && roundInfo.defCampArmy.getFormationLevel() > 1000)
          roundInfo.defCampArmy.setJxBuff(roundInfo.defCampArmy.getJxBuff() + 1); 
        if (roundInfo.defCampArmy.getJxBuff() >= 0 && roundInfo.defCampArmy.getFormationType() == 6 && roundInfo.defCampArmy.getFormationLevel() > 1000)
          roundInfo.defCampArmy.setJxBuff(roundInfo.defCampArmy.getJxBuff() + 1); 
      } 
      if (roundInfo.attCampArmy.getGeneralId() == 204 && roundInfo.attCampArmy.getIsJuexing() > 0 && !roundInfo.attCampArmy.getLegendEvoke()) {
        double oldxue = roundInfo.attBattleArmy.getTroopHp()[0] * 100.0D / roundInfo.attCampArmy.getMaxForces();
        double xinxue = (roundInfo.attBattleArmy.getTroopHp()[0] - reduceNum) * 100.0D / roundInfo.attCampArmy.getMaxForces();
        if ((oldxue > 80.0D && xinxue <= 80.0D) || (oldxue > 50.0D && xinxue <= 50.0D) || (oldxue > 20.0D && xinxue <= 20.0D))
          roundInfo.attCampArmy.setZhaoYunQijinQiChu(true); 
      } 
      for (int k = 0; k < 3; k++) {
        if (!realdamage) {
          int[] troopHp2 = roundInfo.attBattleArmy.getTroopHp();
          int n2 = k;
          troopHp2[n2] = troopHp2[n2] - reduceNum;
        } 
      } 
      if (!realdamage)
        roundInfo.attStrategyLost += reduceNum * 3; 
      if (debug.equals("1"))
        roundInfo.caculateDebugBuffer.append("Def ST Base:").append(" | ").append(fs.getBaseDamage()).append(" | ").append("DefTroopHp:").append(roundInfo.defBattleArmy.getTroopHp()[0]).append(" | ").append("Att Lost:").append(" | ").append(reduceNum).append(" | ").append("Att Lost All:").append(" | ").append(roundInfo.attStrategyLost).append("\n\t"); 
      if (bat.getAttBaseInfo().getNum() < roundInfo.attStrategyLost)
        ErrorSceneLog.getInstance().appendErrorMsg("Builder dealStrategy att兵力小于0,builder 8408行"); 
      bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - roundInfo.attStrategyLost);
      lostBlood = true;
      CampArmy attCampArmy17 = roundInfo.attCampArmy, attCampArmy3 = attCampArmy17;
      attCampArmy17.armyHpLoss += roundInfo.attStrategyLost;
      PlayerInfo piAtt2 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.attBattleArmy.getCampArmy().getPlayerId()));
      if (piAtt2 != null) {
        PlayerInfo playerInfo7 = piAtt2, playerInfo3 = playerInfo7;
        playerInfo7.lostTotal += roundInfo.attStrategyLost;
      } 
      CampArmy defCampArmy16 = roundInfo.defCampArmy, defCampArmy2 = defCampArmy16;
      defCampArmy16.armyHpKill += roundInfo.attStrategyLost;
      if (roundInfo.attCampArmy.isBarPhantom) {
        CampArmy defCampArmy17 = roundInfo.defCampArmy, defCampArmy3 = defCampArmy17;
        defCampArmy17.barbarainHpKill += roundInfo.attStrategyLost;
      } 
      PlayerInfo piDef2 = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.defBattleArmy.getCampArmy().getPlayerId()));
      if (piDef2 != null) {
        PlayerInfo playerInfo8 = piDef2, playerInfo4 = playerInfo8;
        playerInfo8.killTotal += roundInfo.attStrategyLost;
      } 
    } 
    if (lostBlood) {
      roundInfo.nextMinExeTime += 1500;
      roundInfo.timePredicationBuffer.append("strategy reduce:").append(1500).append("|");
    } 
    if (roundInfo.attCampArmy.armyHpLoss >= roundInfo.attCampArmy.armyHpOrg) {
      CampArmy defCampArmy18 = roundInfo.defCampArmy, defCampArmy4 = defCampArmy18;
      defCampArmy18.killGeneral++;
      roundInfo.needPushReport13 = true;
      roundInfo.nextMinExeTime += 1000;
      roundInfo.timePredicationBuffer.append("strategy att cheers:").append(0).append("|");
      roundInfo.killAttG = true;
      if (defCampArmy4.generalId == 204 && defCampArmy4.isjuexing > 0)
        defCampArmy4.zhaoyunjineng = true; 
      if (defCampArmy4.generalId == 211 && defCampArmy4.isjuexing > 0 && defCampArmy4.ganninglimit > 0) {
        CampArmy campArmy = defCampArmy4;
        campArmy.ganninglimit--;
        CampArmy campArmy2 = defCampArmy4;
        campArmy2.tacticVal++;
      } 
      if (bat.attList.size() > 0 && bat.defList.size() > 0)
        bat.setBattleRoundBuff(dataGetter, ((BattleArmy)bat.attList.get(0)).getCampArmy(), ((BattleArmy)bat.defList.get(0)).getCampArmy()); 
      roundInfo.attCampArmy.armyHp = -1;
      bat.attCamp.remove(roundInfo.attCampArmy);
      BattleSceneLog.getInstance().info("#batId:" + bat.getBattleId() + "_" + bat.getStartTime() + "#quit:strategy#side:att" + "#playerId:" + roundInfo.attCampArmy.getPlayerId() + ":" + roundInfo.attCampArmy.isPhantom + "#general:" + roundInfo.attCampArmy.getGeneralId() + "#attSize:" + bat.attCamp.size());
      quitNewBattle(roundInfo.attCampArmy, 1, bat);
      if (roundInfo.defCampArmy.getPlayerId() > 0 && !roundInfo.defCampArmy.isPhantom) {
        PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.defCampArmy.getPlayerId()));
        if (pi != null && roundInfo.defCampArmy.killGeneral > pi.maxKillG)
          pi.maxKillG = roundInfo.defCampArmy.killGeneral; 
      } 
      if (defCampArmy4.isPhantom && defCampArmy4.copytype == 20) {
        CampArmy campArmy3 = defCampArmy4;
        campArmy3.hbqkillnum++;
        Player player = dataGetter.getPlayerDao().read(defCampArmy4.playerId);
        JsonDocument doc1 = new JsonDocument();
        doc1.startObject();
        int hbqkill = 1;
        if (bat.getDefHbqKillInfos().containsKey(Integer.valueOf(defCampArmy4.playerId))) {
          hbqkill = ((Integer)bat.getDefHbqKillInfos().get(Integer.valueOf(defCampArmy4.playerId))).intValue() + 1;
          bat.getDefHbqKillInfos().put(Integer.valueOf(defCampArmy4.playerId), Integer.valueOf(hbqkill));
        } else {
          bat.getDefHbqKillInfos().put(Integer.valueOf(defCampArmy4.playerId), Integer.valueOf(1));
        } 
        doc1.startObject("def");
        doc1.createElement("kills", Integer.valueOf(hbqkill));
        doc1.createElement("playerName", (player == null) ? "我方" : player.getPlayerName());
        doc1.endObject();
        doc1.endObject();
        for (Integer playerId : bat.inSceneSet)
          Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_HBQ, doc1.toByte()); 
      } 
      if (defCampArmy4.isPhantom && defCampArmy4.copytype == 5) {
        CampArmy campArmy4 = defCampArmy4;
        campArmy4.xianzhenkillnum++;
        Player player = dataGetter.getPlayerDao().read(defCampArmy4.playerId);
        JsonDocument doc1 = new JsonDocument();
        doc1.startObject();
        int xianzhenkill = 1;
        if (bat.getDefXianZhenKillInfos().containsKey(Integer.valueOf(defCampArmy4.playerId))) {
          xianzhenkill = ((Integer)bat.getDefXianZhenKillInfos().get(Integer.valueOf(defCampArmy4.playerId))).intValue() + 1;
          bat.getDefXianZhenKillInfos().put(Integer.valueOf(defCampArmy4.playerId), Integer.valueOf(xianzhenkill));
        } else {
          bat.getDefXianZhenKillInfos().put(Integer.valueOf(defCampArmy4.playerId), Integer.valueOf(1));
        } 
        doc1.startObject("def");
        doc1.createElement("dants", Integer.valueOf(xianzhenkill));
        doc1.createElement("playerName", (player == null) ? "我方" : player.getPlayerName());
        doc1.endObject();
        doc1.endObject();
        for (Integer playerId : bat.inSceneSet)
          Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_XIANZHEN, doc1.toByte()); 
      } 
      if (defCampArmy4.isPhantom && defCampArmy4.copytype == 21) {
        CampArmy campArmy5 = defCampArmy4;
        campArmy5.wsqkillnum++;
        Player player = dataGetter.getPlayerDao().read(defCampArmy4.playerId);
        JsonDocument doc1 = new JsonDocument();
        doc1.startObject();
        int wsqkill = 1;
        if (bat.getDefWsqKillInfos().containsKey(Integer.valueOf(defCampArmy4.playerId))) {
          wsqkill = ((Integer)bat.getDefWsqKillInfos().get(Integer.valueOf(defCampArmy4.playerId))).intValue() + 1;
          bat.getDefWsqKillInfos().put(Integer.valueOf(defCampArmy4.playerId), Integer.valueOf(wsqkill));
        } else {
          bat.getDefWsqKillInfos().put(Integer.valueOf(defCampArmy4.playerId), Integer.valueOf(1));
        } 
        doc1.startObject("def");
        doc1.createElement("kills", Integer.valueOf(wsqkill));
        doc1.createElement("playerName", (player == null) ? "我方" : player.getPlayerName());
        doc1.endObject();
        doc1.endObject();
        for (Integer playerId : bat.inSceneSet)
          Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_WSQ, doc1.toByte()); 
      } 
    } 
    if (roundInfo.defCampArmy.armyHpLoss >= roundInfo.defCampArmy.armyHpOrg) {
      CampArmy attCampArmy18 = roundInfo.attCampArmy, attCampArmy4 = attCampArmy18;
      attCampArmy18.killGeneral++;
      roundInfo.needPushReport13 = true;
      roundInfo.nextMinExeTime += 1000;
      roundInfo.timePredicationBuffer.append("strategy def cheers:").append(0).append("|");
      roundInfo.killDefG = true;
      if (attCampArmy4.generalId == 204 && attCampArmy4.isjuexing > 0)
        attCampArmy4.zhaoyunjineng = true; 
      if (attCampArmy4.generalId == 211 && attCampArmy4.isjuexing > 0 && attCampArmy4.ganninglimit > 0) {
        CampArmy campArmy6 = attCampArmy4;
        campArmy6.ganninglimit--;
        CampArmy campArmy7 = attCampArmy4;
        campArmy7.tacticVal++;
      } 
      if (bat.attList.size() > 0 && bat.defList.size() > 0)
        bat.setBattleRoundBuff(dataGetter, ((BattleArmy)bat.attList.get(0)).getCampArmy(), ((BattleArmy)bat.defList.get(0)).getCampArmy()); 
      roundInfo.defCampArmy.armyHp = -1;
      bat.defCamp.remove(roundInfo.defCampArmy);
      BattleSceneLog.getInstance().info("#batId:" + bat.getBattleId() + "_" + bat.getStartTime() + "#quit:strategy#side:def" + "#playerId:" + roundInfo.defCampArmy.getPlayerId() + ":" + roundInfo.defCampArmy.isPhantom + "#general:" + roundInfo.defCampArmy.getGeneralId() + "#defSize:" + bat.defCamp.size());
      quitNewBattle(roundInfo.defCampArmy, 0, bat);
      if (roundInfo.attCampArmy.getPlayerId() > 0 && !roundInfo.attCampArmy.isPhantom) {
        PlayerInfo pi = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(roundInfo.attCampArmy.getPlayerId()));
        if (pi != null && roundInfo.attCampArmy.killGeneral > pi.maxKillG)
          pi.maxKillG = roundInfo.attCampArmy.killGeneral; 
      } 
      if (attCampArmy4.isPhantom && attCampArmy4.copytype == 20) {
        CampArmy campArmy8 = attCampArmy4;
        campArmy8.hbqkillnum++;
        Player player = dataGetter.getPlayerDao().read(attCampArmy4.playerId);
        JsonDocument doc1 = new JsonDocument();
        doc1.startObject();
        int hbqkill = 1;
        if (bat.getAttHbqKillInfos().containsKey(Integer.valueOf(attCampArmy4.playerId))) {
          hbqkill = ((Integer)bat.getAttHbqKillInfos().get(Integer.valueOf(attCampArmy4.playerId))).intValue() + 1;
          bat.getAttHbqKillInfos().put(Integer.valueOf(attCampArmy4.playerId), Integer.valueOf(hbqkill));
        } else {
          bat.getAttHbqKillInfos().put(Integer.valueOf(attCampArmy4.playerId), Integer.valueOf(1));
        } 
        doc1.startObject("att");
        doc1.createElement("kills", Integer.valueOf(hbqkill));
        doc1.createElement("playerName", (player == null) ? "我方" : player.getPlayerName());
        doc1.endObject();
        doc1.endObject();
        for (Integer playerId : bat.inSceneSet)
          Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_HBQ, doc1.toByte()); 
      } 
      if (attCampArmy4.isPhantom && attCampArmy4.copytype == 5) {
        CampArmy campArmy9 = attCampArmy4;
        campArmy9.xianzhenkillnum++;
        Player player = dataGetter.getPlayerDao().read(attCampArmy4.playerId);
        JsonDocument doc1 = new JsonDocument();
        doc1.startObject();
        int xianzhenkill = 1;
        if (bat.getAttXianZhenKillInfos().containsKey(Integer.valueOf(attCampArmy4.playerId))) {
          xianzhenkill = ((Integer)bat.getAttXianZhenKillInfos().get(Integer.valueOf(attCampArmy4.playerId))).intValue() + 1;
          bat.getAttXianZhenKillInfos().put(Integer.valueOf(attCampArmy4.playerId), Integer.valueOf(xianzhenkill));
        } else {
          bat.getAttXianZhenKillInfos().put(Integer.valueOf(attCampArmy4.playerId), Integer.valueOf(1));
        } 
        doc1.startObject("att");
        doc1.createElement("dants", Integer.valueOf(xianzhenkill));
        doc1.createElement("playerName", (player == null) ? "我方" : player.getPlayerName());
        doc1.endObject();
        doc1.endObject();
        for (Integer playerId : bat.inSceneSet)
          Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_XIANZHEN, doc1.toByte()); 
      } 
      if (attCampArmy4.isPhantom && attCampArmy4.copytype == 21) {
        CampArmy campArmy10 = attCampArmy4;
        campArmy10.wsqkillnum++;
        Player player = dataGetter.getPlayerDao().read(attCampArmy4.playerId);
        JsonDocument doc1 = new JsonDocument();
        doc1.startObject();
        int wsqkill = 1;
        if (bat.getAttWsqKillInfos().containsKey(Integer.valueOf(attCampArmy4.playerId))) {
          wsqkill = ((Integer)bat.getAttWsqKillInfos().get(Integer.valueOf(attCampArmy4.playerId))).intValue() + 1;
          bat.getAttWsqKillInfos().put(Integer.valueOf(attCampArmy4.playerId), Integer.valueOf(wsqkill));
        } else {
          bat.getAttWsqKillInfos().put(Integer.valueOf(attCampArmy4.playerId), Integer.valueOf(1));
        } 
        doc1.startObject("att");
        doc1.createElement("kills", Integer.valueOf(wsqkill));
        doc1.createElement("playerName", (player == null) ? "我方" : player.getPlayerName());
        doc1.endObject();
        doc1.endObject();
        for (Integer playerId : bat.inSceneSet)
          Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_WSQ, doc1.toByte()); 
      } 
    } 
  }
  
  public static void getStrategyInfo(StringBuilder battleMsg, Battle bat, IDataGetter dataGetter) {
    if (bat.getAttList().size() > 0 && bat.getDefList().size() > 0) {
      BattleArmy attBattleArmy = bat.getAttList().get(0);
      BattleArmy defBattleArmy = bat.getDefList().get(0);
      CampArmy attCampArmy = attBattleArmy.getCampArmy();
      CampArmy defCampArmy = defBattleArmy.getCampArmy();
      PlayerInfo piAtt = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(attCampArmy.playerId));
      boolean attNeedPush = (attCampArmy.playerId > 0 && !attCampArmy.isPhantom && piAtt != null && piAtt.autoStrategy != 1);
      PlayerInfo piDef = (PlayerInfo)bat.inBattlePlayers.get(Integer.valueOf(defCampArmy.playerId));
      boolean defNeedPush = (defCampArmy.playerId > 0 && !defCampArmy.isPhantom && piDef != null && piDef.autoStrategy != 1);
      if (attNeedPush) {
        int canChooseTac = 0;
        if (attBattleArmy.getSpecial() > 0) {
          canChooseTac = 1;
        } else if ((defCampArmy.getSpecialGeneral()).generalType == 8) {
          canChooseTac = 3;
        } 
        Troop attTroop = (Troop)dataGetter.getTroopCache().get(Integer.valueOf(attCampArmy.getTroopId()));
        if (attTroop == null)
          attTroop = dataGetter.getTroopCache().getTroopOfGeneral(attCampArmy.getTroopId()); 
        int[] attSts = (int[])attTroop.getStrategyMap().get(Integer.valueOf(bat.getTerrainVal()));
        battleMsg.append(27).append("|").append("att").append("|").append(attCampArmy.playerId).append("|").append(attBattleArmy.getPosition()).append("|").append(attCampArmy.playerName).append("|").append(-1).append("|").append(1).append(";");
        FightStragtegyCoe fsc = dataGetter.getFightStragtegyCoeCache().getAttWin(defBattleArmy.getStrategy(), attSts);
        battleMsg.append((fsc == null) ? attSts[0] : fsc.getAttStrategy().intValue()).append("|").append(attSts[0]).append("|").append(((FightStrategies)dataGetter.getFightStrategiesCache().get(Integer.valueOf(attSts[0]))).getName()).append("|0|").append(attSts[1]).append("|").append(((FightStrategies)dataGetter.getFightStrategiesCache().get(Integer.valueOf(attSts[1]))).getName()).append("|0|").append(attSts[2]).append("|").append(((FightStrategies)dataGetter.getFightStrategiesCache().get(Integer.valueOf(attSts[2]))).getName()).append("|0;");
        battleMsg.append(attCampArmy.getId()).append("|").append(attCampArmy.getTacticVal()).append("|").append(attCampArmy.getGeneralPic()).append("|").append(canChooseTac).append("|").append(attBattleArmy.getSpecial()).append("#");
      } else {
        battleMsg.append(27).append("|").append("att").append("|").append(attCampArmy.playerId).append("|").append(attBattleArmy.getPosition()).append("|").append(attCampArmy.playerName).append("|").append(-1).append("|").append(0).append(";");
        battleMsg.append("null").append(";");
        battleMsg.append("null").append("#");
      } 
      if (defNeedPush) {
        int canChooseTac = 0;
        if (defBattleArmy.getSpecial() > 0) {
          canChooseTac = 1;
        } else if ((attCampArmy.getSpecialGeneral()).generalType == 8) {
          canChooseTac = 3;
        } else if (bat.surround > 0) {
          canChooseTac = 2;
        } 
        Troop defTroop = (Troop)dataGetter.getTroopCache().get(Integer.valueOf(defCampArmy.getTroopId()));
        if (defTroop == null)
          defTroop = dataGetter.getTroopCache().getTroopOfGeneral(defCampArmy.getTroopId()); 
        int[] defSts = (int[])defTroop.getStrategyDefMap().get(Integer.valueOf(bat.getTerrainVal()));
        battleMsg.append(27).append("|").append("def").append("|").append(defCampArmy.playerId).append("|").append(defBattleArmy.getPosition()).append("|").append(defCampArmy.playerName).append("|").append(-1).append("|").append(1).append(";");
        battleMsg.append(defSts[0]).append("|").append(defSts[0]).append("|").append(((FightStrategies)dataGetter.getFightStrategiesCache().get(Integer.valueOf(defSts[0]))).getName()).append("|0|").append(defSts[1]).append("|").append(((FightStrategies)dataGetter.getFightStrategiesCache().get(Integer.valueOf(defSts[1]))).getName()).append("|").append(defSts[2]).append("|0|").append(((FightStrategies)dataGetter.getFightStrategiesCache().get(Integer.valueOf(defSts[2]))).getName()).append("|0;");
        battleMsg.append(defCampArmy.getId()).append("|").append(defCampArmy.getTacticVal()).append("|").append(defCampArmy.getGeneralPic()).append("|").append(canChooseTac).append("|").append(defBattleArmy.getSpecial()).append("#");
      } else {
        battleMsg.append(27).append("|").append("def").append("|").append(defCampArmy.playerId).append("|").append(defBattleArmy.getPosition()).append("|").append(defCampArmy.playerName).append("|").append(-1).append("|").append(0).append(";");
        battleMsg.append("null").append(";");
        battleMsg.append("null").append("#");
      } 
    } 
  }
  
  public static void clearBattleAfterError(IDataGetter dataGetter, int playerId, Battle bat) {
    if (bat == null)
      return; 
    com.reign.gcld.battle.scene.Builder builder = BuilderFactory.getInstance().getBuilder(bat.getBattleType());
    for (CampArmy ca : bat.getAttCamp()) {
      if (ca.isUpdateDB() && ca.isInBattle() && ca.getArmyHp() >= 0 && !ca.isPhantom) {
        int state = ca.isInRecruit() ? 1 : 0;
        dataGetter.getPlayerGeneralMilitaryDao().restartRecruit(ca.getPlayerId(), ca.getGeneralId(), state, new Date());
        BattleSceneLog.getInstance().append("playerId", Integer.valueOf(ca.playerId)).append("playerName", ca.playerName).append("gId", Integer.valueOf(ca.generalId)).append("gName", ca.generalName).append("state", Integer.valueOf(state)).flush();
        if (bat.getBattleType() == 3)
          bat.worldSceneLog.Indent().append("playerId", Integer.valueOf(ca.playerId)).append("playerName", ca.playerName).append("gId", Integer.valueOf(ca.generalId)).append("gName", ca.generalName).append("state", Integer.valueOf(state)).newLine(); 
        dataGetter.getGeneralService().sendGmUpdate(ca.getPlayerId(), ca.getGeneralId(), false);
      } 
    } 
    if (bat.getBattleType() == 3 && !bat.isNpc) {
      BattleSceneLog.getInstance().appendLogMsg("battleStart exception. reset def pgm state").appendClassName("Builder").appendMethodName("clearBattleAfterError").flush();
      bat.worldSceneLog.appendLogMsg("battleStart exception. reset def pgm state").appendClassName("Builder").appendMethodName("clearBattleAfterError").newLine();
      for (CampArmy ca : bat.getDefCamp()) {
        if (ca.isUpdateDB() && ca.isInBattle() && ca.getArmyHp() >= 0 && !ca.isPhantom) {
          int state = ca.isInRecruit() ? 1 : 0;
          dataGetter.getPlayerGeneralMilitaryDao().restartRecruit(ca.getPlayerId(), ca.getGeneralId(), state, new Date());
          BattleSceneLog.getInstance().append("playerId", Integer.valueOf(ca.playerId)).append("playerName", ca.playerName).append("gId", Integer.valueOf(ca.generalId)).append("gName", ca.generalName).append("state", Integer.valueOf(state)).flush();
          bat.worldSceneLog.Indent().append("playerId", Integer.valueOf(ca.playerId)).append("playerName", ca.playerName).append("gId", Integer.valueOf(ca.generalId)).append("gName", ca.generalName).append("state", Integer.valueOf(state)).newLine();
          dataGetter.getGeneralService().sendGmUpdate(ca.getPlayerId(), ca.getGeneralId(), false);
        } 
      } 
    } 
    Map<Integer, PlayerInfo> pisMap = bat.getInBattlePlayers();
    for (PlayerInfo pis : pisMap.values()) {
      NewBattleManager.getInstance().quitBattle(pis.getPlayerId(), bat.getBattleId());
      builder.inBattleInfo(pis.getPlayerId(), false);
    } 
    NewBattleManager.getInstance().deleteBattle(bat.getBattleId());
  }
  
  public static void getReportType28(StringBuilder battleMsg, LinkedList<CampArmy> attCamps, LinkedList<CampArmy> defCamps) {
    Set<Integer> set = new HashSet<>();
    for (CampArmy ca : attCamps) {
      int[] strategies = ca.getStrategies();
      for (int i = 0; i < strategies.length; i++) {
        Integer key = Integer.valueOf(strategies[i]);
        set.add(key);
      } 
    } 
    for (CampArmy ca : defCamps) {
      int[] strategies2 = ca.getStrategies();
      for (int j = 0; j < strategies2.length; j++) {
        Integer key = Integer.valueOf(strategies2[j]);
        set.add(key);
      } 
    } 
    if (set.size() > 0) {
      battleMsg.append(28).append("|").append(28).append(";");
      for (Integer key2 : set)
        battleMsg.append(key2).append("|").append(FightStrategiesCache.getStrategyPic(key2.intValue())).append(";"); 
      battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "#");
    } 
  }
  
  public void saveTimePredicationBuffer(RoundInfo roundInfo) {
    String saveReport = Configuration.getProperty("gcld.battle.report.save");
    if (saveReport.equals("1"))
      BattleSceneLog.getInstance().debug(roundInfo.timePredicationBuffer); 
  }
  
  public void saveCaculateDebugBuffer(RoundInfo roundInfo) {
    String debug = Configuration.getProperty("gcld.battle.caculate.debug");
    if (debug.equals("1"))
      BattleSceneLog.getInstance().debug("\n\t" + roundInfo.caculateDebugBuffer); 
  }
  
  public void quitNewBattle(CampArmy ca, int battleSide, Battle bat) {
    if (ca.getPlayerId() > 0 && !ca.isPhantom)
      NewBattleManager.getInstance().quitBattle(bat, ca.getPlayerId(), new int[] { ca.getGeneralId() }); 
  }
  
  public void endQuitNewBattle(CampArmy ca, int battleSide, Battle bat) {
    if (ca.getPlayerId() > 0 && !ca.isPhantom)
      NewBattleManager.getInstance().quitBattle(bat, ca.getPlayerId(), new int[] { ca.getGeneralId() }); 
  }
  
  public void roundRemoveCamp(Battle battle, RoundInfo roundInfo) {
    Set<CampArmy> attRemoveSet = new HashSet<>();
    for (CampArmy attCa : battle.attCamp) {
      if (attCa.armyHpLoss >= attCa.armyHpOrg) {
        attRemoveSet.add(attCa);
        continue;
      } 
      if (attCa.armyHp == attCa.armyHpOrg)
        break; 
    } 
    for (CampArmy attCa : attRemoveSet) {
      battle.attCamp.remove(attCa);
      if ((attCa.getGeneralId() == 281 && attCa.isjuexing <= 0) || (attCa.getGeneralId() == 416 && attCa.getChapterId() > 2) || attCa.getBuff().equals("baqi"))
        roundInfo.battleMsg.append(69).append("|att|null#"); 
      quitNewBattle(attCa, 1, battle);
    } 
    Set<CampArmy> defRemoveSet = new HashSet<>();
    for (CampArmy defCa : battle.defCamp) {
      if (defCa.armyHpLoss >= defCa.armyHpOrg) {
        defRemoveSet.add(defCa);
        continue;
      } 
      if (defCa.armyHp == defCa.armyHpOrg)
        break; 
    } 
    for (CampArmy defCa : defRemoveSet) {
      battle.defCamp.remove(defCa);
      if ((defCa.getGeneralId() == 281 && defCa.isjuexing <= 0) || (defCa.getGeneralId() == 416 && defCa.getChapterId() > 2) || defCa.getBuff().equals("baqi"))
        roundInfo.battleMsg.append(69).append("|def|null#"); 
      quitNewBattle(defCa, 0, battle);
    } 
  }
  
  public static void getCampArmyLost(IDataGetter dataGetter, StringBuilder sbLost, Battle battle, int armyId, int serialNo) {
    for (CampArmy campArmy : battle.defCamp) {
      if (campArmy.getGeneralId() == armyId && campArmy.getId() == serialNo) {
        int hpMax = ((Army)dataGetter.getArmyCache().get(Integer.valueOf(armyId))).getArmyHp().intValue();
        sbLost.append(hpMax - campArmy.getArmyHpOrg() - campArmy.getArmyHpLoss());
        sbLost.append(";");
        return;
      } 
    } 
    int hpMax2 = ((Army)dataGetter.getArmyCache().get(Integer.valueOf(armyId))).getArmyHp().intValue();
    sbLost.append(hpMax2);
    sbLost.append(";");
  }
  
  public void setSurroundState(IDataGetter dataGetter, Battle bat) {}
  
  public void beginOneToOneBattle(IDataGetter dataGetter, Battle one2Onebattle, Battle mainBattle, CampArmy attCa, CampArmy defCa) {}
  
  public CampArmy copyArmyformBarPhantom(IDataGetter dataGetter, Barbarain barbarain, Battle bat, BarbarainPhantom barPhantom, int batSide) {
    return null;
  }
  
  public CampArmy copyArmyFromNationTaskExpeditionArmy(IDataGetter dataGetter, EfLv efLv, Battle bat, NationTaskExpeditionArmy nationTaskExpeditionArmy, int batSide) {
    return null;
  }
  
  public CampArmy copyArmyFromActivityNpc(IDataGetter dataGetter, Object table, Battle bat, ActivityNpc activityNpc, int battleSide) {
    return null;
  }
  
  public void initAttCampForKf(IDataGetter dataGetter, Player player, List<PlayerGeneralMilitary> pgmList, int defId, Battle bat) {
    int attNum = 0;
    for (int i = 0; i < pgmList.size(); i++) {
      PlayerGeneralMilitary pgm = pgmList.get(i);
      CampArmy campArmy = copyArmyFromPlayerTableForKfwd(player, pgm, dataGetter, getGeneralState(), bat, 1);
      if (campArmy != null) {
        attNum += campArmy.getArmyHpOrg();
        bat.attCamp.add(campArmy);
      } 
    } 
    if (bat.attBaseInfo.getNum() + attNum < 0)
      ErrorSceneLog.getInstance().appendErrorMsg("Builder  att 兵力小于0,builder 8757行"); 
    bat.attBaseInfo.setNum(bat.attBaseInfo.getNum() + attNum);
    bat.attBaseInfo.setAllNum(bat.attBaseInfo.getAllNum() + attNum);
    bat.attBaseInfo.setForceId(player.getForceId().intValue());
  }
  
  public CampArmy copyArmyformExpeditionArmy(IDataGetter dataGetter, EfLv eflv, Battle bat, ExpeditionArmy expeditionArmy, int batSide) {
    return null;
  }
  
  public CampArmy copyArmyformBarExpeditionArmy(IDataGetter dataGetter, WorldPaidB worldPaidB, Battle bat, BarbarainExpeditionArmy expeditionArmy, int batSide) {
    return null;
  }
  
  public void updateChooseTime(Battle bat, RoundInfo roundInfo, boolean attAutoStChoosed, boolean defAutoStChoosed) {
    if ((roundInfo.win != 1 && bat.attList.size() > 0 && ((BattleArmy)bat.attList.get(0)).getCampArmy().getPlayerId() > 0 && !attAutoStChoosed && !(((BattleArmy)bat.attList.get(0)).getCampArmy()).isPhantom && Players.getSession(Integer.valueOf(((BattleArmy)bat.attList.get(0)).getCampArmy().getPlayerId())) != null) || (roundInfo.win != 2 && bat.defList.size() > 0 && ((BattleArmy)bat.defList.get(0)).getCampArmy().getPlayerId() > 0 && !defAutoStChoosed && !(((BattleArmy)bat.defList.get(0)).getCampArmy()).isPhantom && Players.getSession(Integer.valueOf(((BattleArmy)bat.defList.get(0)).getCampArmy().getPlayerId())) != null)) {
      roundInfo.nextMaxExeTime += 6000;
      roundInfo.timePredicationBuffer.append("st choose:").append(6000).append("|");
    } 
  }
  
  public CampArmy copyArmyFromScenarioNpc(IDataGetter dataGetter, Player player, Battle battle, ScenarioNpc scenarioNpc, int battleSide) {
    return null;
  }
  
  public CampArmy copyArmyFromPgmIgnoreState(IDataGetter dataGetter, Player player, PlayerGeneralMilitary pgm, int hp, int gState, Battle bat, int batSide) {
    CampArmy campArmy = new CampArmy();
    General general = (General)dataGetter.getGeneralCache().get(pgm.getGeneralId());
    SpecialGeneral sg = new SpecialGeneral((general.getGeneralSpecialInfo()).generalType, (general.getGeneralSpecialInfo()).param, (general.getGeneralSpecialInfo()).param2);
    campArmy.setSpecialGeneral(sg);
    campArmy.updateDB = true;
    campArmy.setPlayerLv(player.getPlayerLv().intValue());
    campArmy.setPlayerId(player.getPlayerId().intValue());
    campArmy.setPayTotal(player.getPayTotal().intValue());
    campArmy.setPlayerName(player.getPlayerName());
    campArmy.setForceId(pgm.getForceId().intValue());
    campArmy.setActivityAddExp(dataGetter.getActivityService().getAddBatValue(player.getPlayerId().intValue(), player.getPlayerLv().intValue()));
    campArmy.setSex(general.getSex().intValue());
    campArmy.setGeneralId(pgm.getGeneralId().intValue());
    campArmy.setGeneralLv(pgm.getLv().intValue());
    campArmy.setPgmVId(pgm.getVId().intValue());
    int addleader = (general.getLeader() == null) ? 0 : general.getLeader().intValue();
    addleader += dataGetter.getBattleDataCache().getGeneralEvokeLeader(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
    int addstr = (general.getStrength() == null) ? 0 : general.getStrength().intValue();
    addstr += dataGetter.getBattleDataCache().getGeneralEvokeStrength(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
    int horseaddleader = dataGetter.getBattleDataCache().getGeneralHorseLeader(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
    addleader += horseaddleader;
    addstr += horseaddleader;
    campArmy.setStrength(pgm.getStrength(Integer.valueOf(addstr)).intValue());
    campArmy.setLeader(pgm.getLeader(Integer.valueOf(addleader)).intValue());
    campArmy.setArmyName(general.getName());
    campArmy.setGeneralName(general.getName());
    campArmy.setGeneralPic(general.getPic());
    campArmy.setQuality(general.getQuality().intValue());
    campArmy.setTacicId(general.getTacticId().intValue());
    campArmy.setId(bat.campNum.getAndIncrement());
    if (pgm.getDeputyId() != null && pgm.getDeputyId().intValue() > 0)
      campArmy.setDeputy(pgm.getDeputyId().intValue()); 
    if (pgm.getIsDeputy() != null && pgm.getIsDeputy().intValue() > 0)
      campArmy.setIsDeputy(1); 
    if (pgm.getLordId() != null && pgm.getLordId().intValue() > 0) {
      campArmy.setIsDeputy(1);
      campArmy.setZhuJiangId(pgm.getLordId().intValue());
    } 
    int troopid = general.getTroop().intValue();
    PlayerAttribute pa = dataGetter.getPlayerAttributeDao().read(player.getPlayerId().intValue());
    if (pa != null && pa.getMountRank().intValue() > 0)
      campArmy.setZuoQiSkill(pa.getMountRank().intValue()); 
    if (player.getMoonCard().intValue() > 0 && player.getMoonCardTime() != null && player.getMoonCardTime().after(new Date()))
      campArmy.setIsMoonCard(true); 
    boolean uniontroop = false;
    boolean legend_281 = false;
    PlayerGeneralEvoke pge = dataGetter.getPlayerGeneralEvokeDao().getPlayerGeneralEvoke(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
    if (pge != null) {
      if (pge.getEvokeSkillFinal().intValue() > 0 || pge.getUnionEvoke().intValue() > 0) {
        campArmy.setIsJuexing(1);
        if (pge.getGeneralId().intValue() == 402)
          campArmy.setMhxx(1); 
      } 
      if (pge.getEvokeSkillFinal().intValue() > 0 || pge.getUnionEvoke().intValue() > 0) {
        EvokeGeneral egr = dataGetter.getEvokeGeneralCache().getEvokeGeneral(pgm.getGeneralId().intValue());
        campArmy.setTacicId(egr.getTacticId().intValue());
        if (pge.getUnionEvoke().intValue() > 0 && pgm.getGeneralId().intValue() == 103 && pgm.getDeputyId().intValue() == 269) {
          campArmy.setTacicId(1321);
          campArmy.setGeneralName("赤壁奇谋");
          campArmy.setGeneralPic("zhouyujx_zhugeliangjx");
          campArmy.setUnionRank(pge.getUnionRank().intValue());
          campArmy.setDeputy(0);
          campArmy.setUnionState(1);
          uniontroop = true;
        } 
      } 
      int zsjqskill = dataGetter.getBattleDataCache().getGeneralZsjqSkillLevel(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
      campArmy.setZsJqSkillLevel(zsjqskill);
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 204) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setTacicId(4020401);
        campArmy.setGeneralName(GeneralUtils.chapterName[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic[curChapter - 1]);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
      } 
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 107) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setTacicId(4010701);
        campArmy.setGeneralName(GeneralUtils.chapterName2[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic2[curChapter - 1]);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
      } 
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 281) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName3[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic3[curChapter - 1]);
        campArmy.setTacicId(4028101);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
        legend_281 = true;
      } 
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 269) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName4[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic4[curChapter - 1]);
        campArmy.setTacicId(4026901);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
        legend_281 = true;
      } 
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 201) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName5[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic5[curChapter - 1]);
        campArmy.setTacicId(4020101);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
      } 
      if (pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && pge.getGeneralId().intValue() == 416) {
        JSONObject legendobj = JSONObject.parseObject(pge.getLegendInfo());
        String chapterstr = (String)legendobj.get("chapterInfo");
        String[] chapterinfo = chapterstr.split(":");
        int curChapter = legendobj.getIntValue("chapterId");
        campArmy.setGeneralName(GeneralUtils.chapterName6[curChapter - 1]);
        campArmy.setGeneralPic(GeneralUtils.chapterpic6[curChapter - 1]);
        campArmy.setTacicId(9991309);
        campArmy.setLegendEvoke(true);
        campArmy.setChapterId(curChapter - 1);
      } 
    } 
    campArmy.setArmyHp(hp);
    campArmy.setArmyHpOrg(hp);
    if (campArmy.getIsJuexing() <= 0 && pgm.getGeneralId().intValue() == 204)
      troopid = 34; 
    if (campArmy.getIsJuexing() > 0) {
      for (int k = 0; k < GeneralUtils.jxwulist.length; k++) {
        if (pgm.getGeneralId().intValue() == GeneralUtils.jxwulist[k].intValue()) {
          troopid = GeneralUtils.jxtroop[k].intValue();
          break;
        } 
      } 
      if (pgm.getGeneralId().intValue() == 204) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 122; 
      } 
      if (pgm.getGeneralId().intValue() == 107) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 125; 
      } 
      if (pgm.getGeneralId().intValue() == 281) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 128; 
      } 
      if (pgm.getGeneralId().intValue() == 269) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 141; 
      } 
      if (pgm.getGeneralId().intValue() == 201) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 147; 
      } 
      if (pgm.getGeneralId().intValue() == 416) {
        campArmy.setChiZhanFa(1);
        if (pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals(""))
          troopid = 881681; 
      } 
    } 
    if (uniontroop)
      troopid = 75; 
    if (pge != null) {
      if (pgm.getGeneralId().intValue() == 277 && pge.getUnionEvoke().intValue() > 0) {
        troopid = 80;
        campArmy.setTacicId(1755);
        campArmy.setGeneralPic("liuguanzhang");
        campArmy.setUnionRank(pge.getUnionRank().intValue());
        campArmy.setDeputy(0);
        campArmy.setUnionState(1);
      } 
      if (pgm.getGeneralId().intValue() == 202 && pge.getShenJiang().intValue() > 0) {
        troopid = 79;
        campArmy.setTacicId(3101);
      } 
      if (pgm.getGeneralId().intValue() == 201 && pge.getUnionEvoke().intValue() > 0 && pgm.getDeputyId().intValue() == 266) {
        troopid = 89;
        campArmy.setTacicId(1614);
        campArmy.setGeneralPic("lvbudiaochanjx");
        campArmy.setUnionRank(pge.getUnionRank().intValue());
        campArmy.setDeputy(0);
        campArmy.setUnionState(1);
        campArmy.setGeneralName("乱世眷侣");
      } 
      if (pgm.getGeneralId().intValue() == 270 && pge.getUnionEvoke().intValue() > 0 && pgm.getDeputyId().intValue() == 273) {
        troopid = 103;
        campArmy.setTacicId(1802);
        campArmy.setGeneralPic("xiahoudun_xiahouyuanjx1");
        campArmy.setUnionRank(pge.getUnionRank().intValue());
        campArmy.setDeputy(0);
        campArmy.setUnionState(1);
        campArmy.setGeneralName("夏侯兄弟");
      } 
      if (pgm.getGeneralId().intValue() == 232 && pge.getUnionEvoke().intValue() > 0 && pgm.getDeputyId().intValue() == 274) {
        troopid = 108;
        campArmy.setTacicId(3601);
        campArmy.setGeneralPic("nanzhongzhizhu");
        campArmy.setUnionRank(pge.getUnionRank().intValue());
        campArmy.setDeputy(0);
        campArmy.setUnionState(1);
        campArmy.setGeneralName("南中之主");
      } 
    } 
    StoreHouse generalTreasure = dataGetter.getStoreHouseDao().getByGeneralIdAndType(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 2, 3);
    if (generalTreasure != null) {
      int baowuid = generalTreasure.getItemId().intValue();
      if (pgm.getGeneralId().intValue() == 107 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1075)
        troopid = 881442; 
      if (pgm.getGeneralId().intValue() == 204 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1074)
        troopid = 881222; 
      if (pgm.getGeneralId().intValue() == 281 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1073)
        troopid = 881281; 
      if (pgm.getGeneralId().intValue() == 269 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1072)
        troopid = 881434; 
      if (pgm.getGeneralId().intValue() == 201 && pge != null && pge.getLegendInfo() != null && !pge.getLegendInfo().equals("") && 
        baowuid == 1071)
        troopid = 881492; 
      if ((baowuid == 81 || generalTreasure.getPiFu().intValue() == 81) && pgm.getGeneralId().intValue() == 201 && (campArmy.getUnionState() <= 0 || pgm.getDeputyId().intValue() != 266)) {
        troopid = 87571;
      } else if ((baowuid == 82 || generalTreasure.getPiFu().intValue() == 82) && pgm.getGeneralId().intValue() == 267) {
        troopid = 87621;
      } else if ((baowuid == 83 || generalTreasure.getPiFu().intValue() == 83) && pgm.getGeneralId().intValue() == 211) {
        troopid = 87671;
      } else if ((baowuid == 84 || generalTreasure.getPiFu().intValue() == 84) && pgm.getGeneralId().intValue() == 275) {
        troopid = 87601;
      } else if ((baowuid == 85 || generalTreasure.getPiFu().intValue() == 85) && pgm.getGeneralId().intValue() == 103 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 269) {
        troopid = 87751;
      } else if ((baowuid == 86 || generalTreasure.getPiFu().intValue() == 86) && pgm.getGeneralId().intValue() == 277 && campArmy.getUnionState() > 0) {
        troopid = 87801;
      } else if ((baowuid == 87 || generalTreasure.getPiFu().intValue() == 87) && pgm.getGeneralId().intValue() == 224) {
        troopid = 87551;
      } else if ((baowuid == 113 || generalTreasure.getPiFu().intValue() == 113) && pgm.getGeneralId().intValue() == 201 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 266) {
        troopid = 87893;
        campArmy.setGeneralPic("lvbudiaochanjx2");
      } else if ((baowuid == 111 || generalTreasure.getPiFu().intValue() == 111) && pgm.getGeneralId().intValue() == 201 && (campArmy.getUnionState() <= 0 || pgm.getDeputyId().intValue() != 266)) {
        troopid = 87572;
      } else if ((baowuid == 112 || generalTreasure.getPiFu().intValue() == 112) && pgm.getGeneralId().intValue() == 266) {
        troopid = 87711;
      } else if ((baowuid == 116 || generalTreasure.getPiFu().intValue() == 116) && pgm.getGeneralId().intValue() == 103 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 269) {
        troopid = 88751;
      } 
      if (baowuid >= 1003) {
        campArmy.setTouXian(baowuid);
        campArmy.setTitle(baowuid);
        campArmy.setTitle1(WeaponUtils.kuangshipic1[baowuid - 1003]);
      } 
    } 
    if (pgm.getGeneralId().intValue() == 211) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 34) {
            troopid = 87672;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 281) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 66) {
            troopid = 88961;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 107) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 68) {
            troopid = 88781;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 277 && campArmy.getUnionState() > 0) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 65) {
            troopid = 88801;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 201 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 266) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 67) {
            troopid = 88891;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 270 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 273) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 69) {
            troopid = 881031;
            break;
          } 
          if (sh.getItemId().intValue() == 70) {
            troopid = 881032;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 232 && campArmy.getUnionState() > 0 && pgm.getDeputyId().intValue() == 274) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 71) {
            troopid = 881081;
            break;
          } 
          if (sh.getItemId().intValue() == 72) {
            troopid = 881082;
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 204 && campArmy.getLegendEvoke()) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 73) {
            troopid = 881221;
            campArmy.setTacicId(4020402);
            break;
          } 
          if (sh.getItemId().intValue() == 74) {
            troopid = 881223;
            campArmy.setTacicId(4020403);
            break;
          } 
          if (sh.getItemId().intValue() == 121) {
            troopid = 881224;
            campArmy.setTacicId(4020403);
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 107 && campArmy.getLegendEvoke()) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 35) {
            troopid = 881273;
            campArmy.setTacicId(4010702);
            break;
          } 
          if (sh.getItemId().intValue() == 79) {
            troopid = 12730001;
            campArmy.setTacicId(4010702);
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 281 && campArmy.getLegendEvoke()) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 36) {
            troopid = 13830001;
            campArmy.setTacicId(4028101);
            break;
          } 
          if (sh.getItemId().intValue() == 80) {
            troopid = 13830002;
            campArmy.setTacicId(4028101);
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 269 && campArmy.getLegendEvoke()) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 40) {
            troopid = 14330001;
            campArmy.setTacicId(4026901);
            break;
          } 
          if (sh.getItemId().intValue() == 78) {
            troopid = 14330002;
            campArmy.setTacicId(4026901);
            break;
          } 
        }  
    } else if (pgm.getGeneralId().intValue() == 201 && campArmy.getLegendEvoke()) {
      List<StoreHouse> yubaoList = dataGetter.getStoreHouseDao().getGeneralEquipList(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 44);
      if (yubaoList != null && !yubaoList.isEmpty())
        for (StoreHouse sh : yubaoList) {
          if (sh.getItemId().intValue() == 37) {
            troopid = 14930001;
            campArmy.setTacicId(4020101);
            break;
          } 
          if (sh.getItemId().intValue() == 81) {
            troopid = 881492;
            campArmy.setTacicId(4020101);
            break;
          } 
        }  
    } 
    Troop troop = dataGetter.getTroopCache().getTroop(troopid, player.getPlayerId().intValue());
    getTerrainValue(bat.terrainVal, troop, batSide, campArmy);
    campArmy.setTroopId(troop.getId().intValue());
    campArmy.setTroopSerial(troop.getSerial().intValue());
    campArmy.setTroopType(troop.getType().intValue());
    campArmy.setTroopName(troop.getName());
    campArmy.setBdEffect(pgm.getLv().intValue());
    Map<Integer, String> ycbweffectMap = dataGetter.getBattleDataCache().getYcbwMap(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
    campArmy.setPingKan(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(10))).intValue());
    campArmy.setPingKanDef(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(11))).intValue());
    campArmy.setYcbwHujia(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(12))).intValue());
    campArmy.setYcbwPojia(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(13))).intValue());
    campArmy.setKaiShan(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(14))).intValue());
    campArmy.setDingJun(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(15))).intValue());
    campArmy.setYbTx(ycbweffectMap.get(Integer.valueOf(19)));
    campArmy.setYubaoEffect(Integer.valueOf(ycbweffectMap.get(Integer.valueOf(20))).intValue());
    campArmy.setLeader(campArmy.getLeader() + Integer.valueOf(ycbweffectMap.get(Integer.valueOf(4))).intValue());
    campArmy.setStrength(campArmy.getStrength() + Integer.valueOf(ycbweffectMap.get(Integer.valueOf(5))).intValue());
    int yubaonaijiu = Integer.valueOf(ycbweffectMap.get(Integer.valueOf(16))).intValue();
    if (pgm.getGodWeapon() != null && pgm.getGodWeapon().intValue() > 0)
      campArmy.setWsb(pgm.getGodWeapon().intValue()); 
    if (pgm.getGeneralId().intValue() == 280)
      campArmy.setJxType(49); 
    if (pgm.getCarId().intValue() > 0) {
      int carId = pgm.getCarId().intValue();
      PlayerCatapult pcp = dataGetter.getPlayerCatapultDao().getPlayerChariotById(player.getPlayerId().intValue(), carId);
      int realcarId = 0;
      if (pcp.getOpen().intValue() >= 2 && pcp.getRftState().intValue() > 2) {
        realcarId = CatapultUtil.gaojicar[carId - 1].intValue();
      } else {
        realcarId = CatapultUtil.carid[carId - 1].intValue();
      } 
      if (carId <= 10) {
        PlayerCatapultCarpart pccarpart = dataGetter.getPlayerCatapultCarpartDao().getByplayerIdAndCarId(player.getPlayerId().intValue(), carId);
        int armmode = 0;
        if (pccarpart != null) {
          campArmy.setCarArmed(true);
          if (pccarpart.getCarWeapon() != null && !pccarpart.getCarWeapon().equals("")) {
            armmode++;
            String[] weaponlist = pccarpart.getCarWeapon().split(":");
            String[] array;
            int length = (array = weaponlist).length;
            int i = 0;
            while (i < length) {
              String partstr = array[i];
              PlayerCatapultElement pcele = dataGetter.getPlayerCatapultElementDao().read(Integer.valueOf(partstr).intValue());
              if (pcele != null && pcele.getElementId().intValue() == 1) {
                campArmy.setLieYanHuiXiang(1);
                int chongzhubeishu = pcele.getRecast().intValue();
                if (chongzhubeishu > 2)
                  chongzhubeishu = 2; 
                campArmy.setLieyandamage(2000 * (pcele.getElementLevel().intValue() + chongzhubeishu * 10));
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 7) {
                campArmy.setIsFanShang(1);
                if (pcele.getElementLevel().intValue() >= 5) {
                  campArmy.setDuoChongShaRen(pcele.getElementLevel().intValue());
                  campArmy.setShaRenRecastNum(pcele.getRecast().intValue());
                  campArmy.setCarPoDunNum(0);
                } 
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 8) {
                campArmy.setsjznLevel(pcele.getElementLevel().intValue());
                campArmy.setsjznType(1);
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 9) {
                campArmy.setIsFlower(1);
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 11) {
                String damage = pcele.getElementAttribute().split("=")[1];
                campArmy.setFiveShuiDamage(campArmy.getFiveShuiDamage() + Integer.valueOf(damage).intValue());
                break;
              } 
              i++;
            } 
          } 
          if (pccarpart.getCarBody() != null && !pccarpart.getCarBody().equals(""))
            armmode++; 
          if (pccarpart.getCarBottom() != null && !pccarpart.getCarBottom().equals("")) {
            armmode++;
            String[] bottomlist = pccarpart.getCarBottom().split(":");
            String[] array2;
            for (int length2 = (array2 = bottomlist).length, j = 0; j < length2; j++) {
              String partstr = array2[j];
              PlayerCatapultElement pcele = dataGetter.getPlayerCatapultElementDao().read(Integer.valueOf(partstr).intValue());
              if (pcele != null && pcele.getElementId().intValue() == 3) {
                campArmy.setLonglin(1);
                break;
              } 
            } 
          } 
          if (pccarpart.getCarChuanDong() != null && !pccarpart.getCarChuanDong().equals("")) {
            armmode++;
            String[] chuandonglist = pccarpart.getCarChuanDong().split(":");
            String[] array3;
            for (int length3 = (array3 = chuandonglist).length, l = 0; l < length3; l++) {
              String cdstr = array3[l];
              PlayerCatapultElement pcele = dataGetter.getPlayerCatapultElementDao().read(Integer.valueOf(cdstr).intValue());
              if (pcele != null && pcele.getElementId().intValue() == 10) {
                campArmy.setIsFlower(1);
                break;
              } 
              if (pcele != null && pcele.getElementId().intValue() == 12) {
                String damage = pcele.getElementAttribute().split("=")[1];
                campArmy.setFiveShuiDamage(campArmy.getFiveShuiDamage() + Integer.valueOf(damage).intValue());
                break;
              } 
            } 
          } 
          if (pcp.getOpen().intValue() >= 2 && armmode >= 3)
            armmode++; 
          if (armmode <= 0)
            armmode = 1; 
          if (armmode >= 4)
            armmode = 4; 
          realcarId = CatapultUtil.armEquipcar[carId - 1][armmode - 1].intValue();
        } 
      } 
      List<PlayerCatapultDriver> cardriverList = dataGetter.getPlayerCatapultDriverDao().getDriverListByplayerIdAndCarId(player.getPlayerId().intValue(), carId);
      if (cardriverList != null && !cardriverList.isEmpty()) {
        int driverId = ((PlayerCatapultDriver)cardriverList.get(0)).getDriverId().intValue();
        campArmy.setCarQudong(driverId);
        if (driverId > 10000)
          driverId = CatapultUtil.driversId.length; 
        realcarId = CatapultUtil.drivewaiguan[driverId - 1].intValue();
      } 
      campArmy.setCarId(realcarId);
      campArmy.setCarModel(carId);
      if (carId == 2)
        campArmy.setDefence(1); 
      int hujia = CatapultUtil.getHujiaByCarIdAndLv(carId, pcp.getHujiaLv().intValue()) + campArmy.getYcbwHujia();
      int naijiu = CatapultUtil.getEnduranceByCarIdAndLv(carId, pcp.getHujiaLv().intValue()) + yubaonaijiu;
      campArmy.setBigGzNum(hujia);
      campArmy.setCarHp(hujia * naijiu);
      campArmy.setCarMaxHp(hujia * naijiu);
      campArmy.setAttcoe(CatapultUtil.getHuoliByCarIdAndLv(carId, pcp.getHuoliLv().intValue()));
      campArmy.setHujia(hujia * naijiu);
      if (carId == 4)
        if (pcp.getRftState().intValue() >= 3) {
          campArmy.setSiCheHuJia(hujia * naijiu);
          campArmy.setSiCheGeZi(hujia);
        } else {
          campArmy.setSiCheHuJia(3 * naijiu);
          campArmy.setSiCheGeZi(3);
        }  
      campArmy.setNaijiu(naijiu);
      String gzstr = pcp.getRftLv();
      if (gzstr != null && !gzstr.equals("")) {
        String[] rftlevel = gzstr.split(":");
        int totallevel = 0;
        String[] array4;
        for (int length4 = (array4 = rftlevel).length, n = 0; n < length4; n++) {
          String dj = array4[n];
          totallevel += Integer.valueOf(dj).intValue();
        } 
        campArmy.setCarGzLevel(totallevel);
      } 
      if (carId <= 2) {
        campArmy.setPojia(CatapultUtil.getPojiaByCarIdAndLv(carId, pcp.getPojiaLv().intValue()) + dataGetter.getBattleDataCache().getPlayerPojia(player.getPlayerId().intValue(), carId));
      } else {
        campArmy.setPojia(CatapultUtil.getPojiaByCarIdAndLv(carId, pcp.getPojiaLv().intValue()));
      } 
      if (carId == 1) {
        campArmy.setBaoji(CatapultUtil.getCoreByCarIdAndLv(carId, pcp.getCoreLv().intValue()));
      } else if (carId == 2) {
        campArmy.setQiangGong(CatapultUtil.getCoreByCarIdAndLv(carId, pcp.getCoreLv().intValue()));
      } else if (carId == 3) {
        campArmy.setXueLiang(CatapultUtil.getCoreByCarIdAndLv(carId, pcp.getCoreLv().intValue()));
      } 
      if (dataGetter.getPlayerCatapultDao().getOpen(player.getPlayerId().intValue(), carId).intValue() > 1)
        campArmy.setCatapultSkill(carId); 
    } 
    if (pgm != null) {
      StoreHouse sh2 = dataGetter.getStoreHouseDao().getByGeneralIdAndType(player.getPlayerId().intValue(), pgm.getGeneralId().intValue(), 36, 36);
      if (sh2 != null)
        campArmy.setJueEquip(1); 
    } 
    int zhenbao = dataGetter.getSilkService().getPlayerSilkTreasureLevel(player.getPlayerId().intValue());
    campArmy.setTenZhenBao(zhenbao);
    if (zhenbao >= 10) {
      campArmy.setZbAllTimes(5);
      campArmy.setZbTimes(0);
    } 
    if (zhenbao >= 9) {
      campArmy.setJiuZhenbao(1);
      campArmy.setzfShield(2);
    } 
    if (zhenbao >= 7)
      campArmy.setQiZhenbao(2); 
    if (zhenbao >= 4)
      campArmy.setSiZhenbao(4000); 
    if (zhenbao >= 3)
      campArmy.setSanZhenbao(4000); 
    if (zhenbao >= 2)
      campArmy.setErZhenBao(4000); 
    if (pgm != null && pgm.getFormationId() != null && pgm.getFormationId().intValue() > 0) {
      campArmy.setFormationType(pgm.getFormationId().intValue());
      List baguabooks = dataGetter.getPlayerStrategicsBookDao().getFormationBooksUpLevel(player.getPlayerId().intValue(), pgm.getFormationId().intValue(), 10);
      if (baguabooks != null && !baguabooks.isEmpty())
        campArmy.setBaGuaLevel(baguabooks.size()); 
      PlayerStrategics ps = dataGetter.getPlayerStrategicsDao().getByPlayerIdAndFormationId(player.getPlayerId().intValue(), pgm.getFormationId().intValue());
      if (ps != null) {
        campArmy.setFormationLevel(ps.getFormationLevel().intValue());
        if (ps.getState().intValue() >= 3) {
          int hasbigskill = 1;
          int bz = 0;
          int uplv = 0;
          if (ps.getFormationLevel().intValue() >= 1000) {
            hasbigskill = 5;
            bz = 6;
            uplv = 3;
          } 
          if (ps.getFormationLevel().intValue() >= 800) {
            hasbigskill = 5;
            bz = 5;
            uplv = 2;
          } 
          if (ps.getFormationLevel().intValue() >= 600) {
            hasbigskill = 4;
            bz = 4;
            uplv = 2;
          } 
          if (ps.getFormationLevel().intValue() >= 400) {
            hasbigskill = 4;
            bz = 3;
            uplv = 1;
          } 
          if (ps.getFormationLevel().intValue() >= 200) {
            hasbigskill = 4;
            bz = 2;
            uplv = 1;
          } 
          if (ps.getFormationLevel().intValue() >= 80) {
            hasbigskill = 3;
          } else if (ps.getFormationLevel().intValue() >= 60) {
            hasbigskill = 2;
          } 
          campArmy.setHasbigFormationskill(hasbigskill);
          campArmy.setBzStatus(bz);
          campArmy.setIsZhenFaLvUp(uplv);
          if (ps.getFormationId().intValue() == 3)
            campArmy.setFyzShield(1); 
          if (ps.getFormationId().intValue() == 6)
            if (ps.getFormationLevel().intValue() >= 70) {
              campArmy.setFuBingNum(4);
            } else if (ps.getFormationLevel().intValue() >= 50) {
              campArmy.setFuBingNum(3);
            } else if (ps.getFormationLevel().intValue() >= 30) {
              campArmy.setFuBingNum(2);
            } else if (ps.getFormationLevel().intValue() >= 20) {
              campArmy.setFuBingNum(1);
            }  
        } 
      } 
    } 
    if (pgm != null && pgm.getFormationId1() != null && pgm.getFormationId1().intValue() > 0) {
      PlayerStrategics1 ps1 = dataGetter.getPlayerStrategicsDao1().getByPlayerIdAndforceId(player.getPlayerId().intValue(), pgm.getFormationId1().intValue());
      if (ps1 != null) {
        int bingfu = 0;
        if (ps1.getForceId().intValue() == 1 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 1; 
        if (ps1.getForceId().intValue() == 2 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 2; 
        if (ps1.getForceId().intValue() == 3 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 3; 
        if (ps1.getForceId().intValue() == 4 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 4; 
        if (ps1.getForceId().intValue() == 5 && 
          ps1.getFormationLevel().intValue() >= 100)
          bingfu = 5; 
        campArmy.setBzStatus1(bingfu);
        campArmy.setFuBingNum1(1);
      } 
    } 
    List<StoreHouse> horselist = dataGetter.getStoreHouseDao().getHorseByGeneral(player.getPlayerId().intValue(), pgm.getGeneralId().intValue());
    if (horselist != null && !horselist.isEmpty()) {
      int horsetype = ((StoreHouse)horselist.get(0)).getItemId().intValue() - 4000;
      campArmy.setHorseType(horsetype);
      if (horsetype == 1)
        campArmy.setZsMyMa(1); 
    } 
    if (pgm.getHelpGeneral().intValue() == 402) {
      campArmy.setMeiXian(5);
      campArmy.setMeiXianUpper(4);
      if (pgm.getGeneralId().intValue() == 277 && campArmy.getUnionState() > 0) {
        campArmy.setMeiXian(4);
        campArmy.setMeiXianUpper(7);
      } 
      if (pgm.getGeneralId().intValue() == 416 && campArmy.getChapterId() > 0) {
        campArmy.setMeiXian(4);
        campArmy.setMeiXianUpper(7);
      } 
      if (campArmy.getHorseType() == 4) {
        campArmy.setMeiXianUpper(8);
        campArmy.setSsxMa(1);
      } 
    } 
    if (pgm.getHelpGeneral().intValue() > 0) {
      campArmy.setHelpGeneral(pgm.getHelpGeneral().intValue());
      PlayerGeneralEvoke helppge = dataGetter.getPlayerGeneralEvokeDao().getPlayerGeneralEvoke(player.getPlayerId().intValue(), pgm.getHelpGeneral().intValue());
      if (helppge != null && helppge.getEvokeSkillFinal().intValue() > 0) {
        campArmy.setHelpIsJuexing(1);
        if (pgm.getHelpGeneral().intValue() == 402)
          campArmy.setMhxx(1); 
      } 
      if (pgm.getHelpGeneral().intValue() == 403)
        campArmy.setHuangGaiZhanFa(1); 
      if (pgm.getHelpGeneral().intValue() == 404)
        campArmy.setBaiYi(1); 
    } 
    PlayerEpic playerepic = dataGetter.getPlayerEpicDao().getPlayerEpic(player.getPlayerId().intValue(), 1);
    if (playerepic != null && playerepic.getBigSkill().intValue() > 0)
      campArmy.setEpicLevel(1); 
    List<PlayerWarBeast> warbeastList = dataGetter.getPlayerWarBeastDao().getWarBeastListByplayerId(player.getPlayerId().intValue());
    if (warbeastList != null)
      campArmy.setYongYouBeast(true); 
    getAttDefHp(dataGetter, campArmy);
    PlayerBattleAttribute pba = dataGetter.getPlayerBattleAttributeDao().read(player.getPlayerId().intValue());
    if (pba != null && pba.getSupportTime() != null && pba.getSupportTime().getTime() > System.currentTimeMillis())
      if (pba.getType().intValue() == 1) {
        campArmy.setRewardDoubleType(1);
        campArmy.setRewardDouble(1.5D);
      } else if (pba.getType().intValue() == 2) {
        campArmy.setRewardDoubleType(2);
        campArmy.setRewardDouble(2.0D);
      }  
    if (general.getTacticId().intValue() > 0) {
      campArmy.setTacticVal(1);
      if ((campArmy.getSpecialGeneral()).generalType == 7)
        campArmy.setTacticVal((int)(campArmy.getSpecialGeneral()).param); 
    } 
    if (batSide == 1) {
      campArmy.setStrategies((int[])troop.getStrategyMap().get(Integer.valueOf(bat.terrainVal)));
    } else {
      campArmy.setStrategies((int[])troop.getStrategyDefMap().get(Integer.valueOf(bat.terrainVal)));
    } 
    return campArmy;
  }
  
  public void addViewType(Player player, Battle battle, JsonDocument doc) {}
  
  public CampArmy copyArmyformBarPhantom2(IDataGetter dataGetter, KtSdmzS ktSdmzS, Battle battle, BarbarainPhantom barPhantom, int battleSide) {
    return null;
  }
  
  public void setAttDefBaseInfo(IDataGetter dataGetter, Battle battle, BattleAttacker battleAttacker, int battleType, int defId) {
    battle.attBaseInfo.setId(battleAttacker.attPlayerId);
    battle.defBaseInfo.setId(defId);
  }
  
  public void checkErrorAndHandle(IDataGetter dataGetter, Battle battle) {}
  
  public CampArmy copyArmyformBarPhantom3(IDataGetter dataGetter, Barbarain barbarain, Battle battle, BarbarainPhantom barPhantom, int battleSide) {
    return null;
  }
  
  public CampArmy copyArmyformBarPhantom4(IDataGetter dataGetter, Battle battle, BarbarainPhantom barPhantom, int battleSide) {
    return null;
  }
  
  public CampArmy copyArmyfromBarPhantom4(IDataGetter dataGetter, Battle battle, BarbarainPhantom barPhantom, int battleSide) {
    return null;
  }
  
  public void initZhengZhaoLingJoinPlayer(IDataGetter dataGetter, Battle battle, Player player, int battleSide, List<PlayerGeneralMilitary> pgmList, BaseInfo baseInfo, List<CampArmy> campMap, List<CampArmy> campChange, double teamEffect, int attEffect, int defEffect, String playerName) {}
  
  public CampArmy copyArmyfromNationTaskYellowTurbans(IDataGetter dataGetter, Battle battle, YellowTurbans yellowTurbans, int battleSide) {
    return null;
  }
  
  public CampArmy copyArmyfromHuizhanPkRewardNpc(IDataGetter dataGetter, Battle battle, int armyId, int battleSide, int forceId) {
    return null;
  }
  
  public static void fuBing(CampArmy campArmy, List<BattleArmy> attAddQlist, List<BattleArmy> batList, List<CampArmy> batCamp, int battleSide, AtomicInteger batQNum, BaseInfo baseInfo, Map<Integer, PlayerInfo> inBattlePlayers, RoundInfo roundInfo, Battle bat, IDataGetter dataGetter) {
    if (campArmy.armyHpLoss >= campArmy.armyHpOrg || campArmy.getPlayerId() < 0 || campArmy.getFuBingNum() <= 0)
      return; 
    if (campArmy.getUnionState() > 0 && campArmy.getGeneralId() != 232)
      return; 
    if (campArmy.getDeputy() <= 0 && (campArmy.getUnionState() <= 0 || campArmy.getGeneralId() != 232))
      return; 
    int gailv = 100;
    if (campArmy.getFormationLevel() < 30) {
      gailv = 40;
    } else if (campArmy.getFormationLevel() < 50) {
      gailv = 60;
    } 
    if (RandomUtils.nextInt(100) > gailv)
      return; 
    int fjid = campArmy.getDeputy();
    if (campArmy.getUnionState() > 0 && campArmy.getGeneralId() == 232)
      fjid = 274; 
    PlayerGeneralMilitary fjpgm = dataGetter.getPlayerGeneralMilitaryDao().getMilitary(campArmy.getPlayerId(), fjid);
    if (fjpgm == null)
      return; 
    Player player = dataGetter.getPlayerDao().read(campArmy.getPlayerId());
    if (player == null)
      return; 
    com.reign.gcld.battle.scene.Builder builder = BuilderFactory.getInstance().getBuilder(bat.getBattleType());
    CampArmy fujiangCamp = builder.copyArmyFromPlayerTable(player, fjpgm, dataGetter, builder.getGeneralState(), bat, battleSide);
    if (fujiangCamp == null)
      return; 
    if (fujiangCamp != null) {
      fujiangCamp.setIsDeputy(1);
      fujiangCamp.setZhuJiangId(campArmy.getGeneralId());
      fujiangCamp.updateDB = false;
    } 
    if (campArmy.getGeneralId() == 232 && campArmy.getUnionRank() >= 2) {
      fujiangCamp.setCatapultSkill(2);
      fujiangCamp.setBigGzNum(5);
      fujiangCamp.setCarHp(50);
      fujiangCamp.setCarMaxHp(50);
      fujiangCamp.setAttcoe(Double.valueOf(1.0D));
      fujiangCamp.setHujia(50);
      fujiangCamp.setPojia(12000);
      fujiangCamp.setNaijiu(10);
    } 
    boolean havezhanfa = false;
    if (campArmy.getFormationLevel() >= 70 && campArmy.getFuBingNum() == 4) {
      havezhanfa = true;
    } else if (campArmy.getFormationLevel() >= 50 && campArmy.getFuBingNum() == 3) {
      havezhanfa = true;
    } else if (RandomUtils.nextInt(100) < 30) {
      havezhanfa = true;
    } 
    if (havezhanfa) {
      fujiangCamp.tacticVal = 1;
    } else {
      fujiangCamp.tacticVal = 0;
    } 
    fujiangCamp.setFuBingType(1);
    campArmy.fubingNum--;
    batCamp.add(0, fujiangCamp);
    baseInfo.setAllNum(baseInfo.getAllNum() + fujiangCamp.getArmyHp());
    baseInfo.setNum(baseInfo.getNum() + fujiangCamp.getArmyHp());
    List<BattleArmy> attList = new ArrayList<>();
    BattleArmy fjxz = addQueues(bat, attAddQlist, attList, fujiangCamp, battleSide, batQNum);
    batList.add(0, fjxz);
    getReportType64(roundInfo.battleMsg, attAddQlist, (battleSide == 1) ? "att" : "def");
  }
  
  public static void DaZhaoYunBatcamp(CampArmy campArmy, List<BattleArmy> attAddQlist, List<BattleArmy> batList, List<CampArmy> batCamp, int battleSide, AtomicInteger batQNum, BaseInfo baseInfo, Map<Integer, PlayerInfo> inBattlePlayers, RoundInfo roundInfo, Battle bat, IDataGetter dataGetter) {
    if (campArmy.armyHpLoss >= campArmy.armyHpOrg && campArmy.getPlayerId() >= 0 && !campArmy.getZyMaxRow() && 
      campArmy.getGeneralId() == 204 && campArmy.legendEvoke) {
      int gailv = 100;
      if (campArmy.getFormationLevel() < 30) {
        gailv = 40;
      } else if (campArmy.getFormationLevel() < 50) {
        gailv = 60;
      } 
      if (RandomUtils.nextInt(100) <= gailv) {
        System.out.println("=========大赵云 " + campArmy.getZyMaxRow());
        PlayerGeneralMilitary fjpgm = dataGetter.getPlayerGeneralMilitaryDao().getMilitary(campArmy.getPlayerId(), 204);
        if (fjpgm != null) {
          Player player = dataGetter.getPlayerDao().read(campArmy.getPlayerId());
          if (player != null) {
            com.reign.gcld.battle.scene.Builder builder = BuilderFactory.getInstance().getBuilder(bat.getBattleType());
            CampArmy fujiangCamp = builder.copyArmyFromPlayerTable(player, fjpgm, dataGetter, builder.getGeneralState(), bat, battleSide);
            if (fujiangCamp != null) {
              if (fujiangCamp != null) {
                fujiangCamp.setIsDeputy(1);
                fujiangCamp.setZhuJiangId(campArmy.getGeneralId());
                fujiangCamp.updateDB = false;
              } 
              if (campArmy.getGeneralId() == 232 && campArmy.getUnionRank() >= 2) {
                fujiangCamp.setCatapultSkill(2);
                fujiangCamp.setBigGzNum(5);
                fujiangCamp.setCarHp(50);
                fujiangCamp.setCarMaxHp(50);
                fujiangCamp.setAttcoe(Double.valueOf(1.0D));
                fujiangCamp.setHujia(50);
                fujiangCamp.setPojia(12000);
                fujiangCamp.setNaijiu(10);
              } 
              boolean havezhanfa = false;
              if (campArmy.getFormationLevel() >= 70 && campArmy.getFuBingNum() == 4) {
                havezhanfa = true;
              } else if (campArmy.getFormationLevel() >= 50 && campArmy.getFuBingNum() == 3) {
                havezhanfa = true;
              } else if (RandomUtils.nextInt(100) < 30) {
                havezhanfa = true;
              } 
              if (havezhanfa) {
                fujiangCamp.tacticVal = 1;
              } else {
                fujiangCamp.tacticVal = 0;
              } 
              fujiangCamp.setFuBingType(1);
              fujiangCamp.setTroopType(157);
              campArmy.fubingNum--;
              batCamp.add(0, fujiangCamp);
              baseInfo.setAllNum(baseInfo.getAllNum() + fujiangCamp.getArmyHp());
              baseInfo.setNum(baseInfo.getNum() + fujiangCamp.getArmyHp());
              List<BattleArmy> attList = new ArrayList();
              BattleArmy fjxz = MaxZYaddQueues(bat, attAddQlist, attList, fujiangCamp, battleSide, batQNum);
              batList.add(0, fjxz);
              getReportType64(roundInfo.battleMsg, attAddQlist, (battleSide == 1) ? "att" : "def");
            } 
          } 
        } 
      } 
    } 
  }
  
  public static void DaZhaoYunBatcamp2(CampArmy campArmy, List<BattleArmy> attAddQlist, List<BattleArmy> batList, List<CampArmy> batCamp, int battleSide, AtomicInteger batQNum, BaseInfo baseInfo, Map<Integer, PlayerInfo> inBattlePlayers, RoundInfo roundInfo, Battle bat, IDataGetter dataGetter) {
    if (campArmy.armyHpLoss >= campArmy.armyHpOrg && campArmy.getPlayerId() >= 0 && 
      campArmy.getGeneralId() == 204 && campArmy.getChapterId() >= 1) {
      roundInfo.attCampArmy.setZyMaxRow(true);
      roundInfo.defCampArmy.setZyMaxRow(true);
      int gailv = 1000;
      if (RandomUtils.nextInt(100) <= gailv) {
        System.out.println("=========大赵云gailv " + gailv + " armyHpOrg " + RandomUtils.nextInt(100));
        int fjid = 204;
        PlayerGeneralMilitary fjpgm = dataGetter.getPlayerGeneralMilitaryDao().getMilitary(campArmy.getPlayerId(), fjid);
        if (fjpgm != null) {
          Player player = dataGetter.getPlayerDao().read(campArmy.getPlayerId());
          if (player != null) {
            com.reign.gcld.battle.scene.Builder builder = BuilderFactory.getInstance().getBuilder(bat.getBattleType());
            CampArmy fujiangCamp = builder.copyArmyFromPlayerTable(player, fjpgm, dataGetter, builder.getGeneralState(), bat, battleSide);
            System.out.println("=========fujiangCamp " + fujiangCamp + " armyHpOrg " + RandomUtils.nextInt(100));
            if (fujiangCamp != null) {
              if (fujiangCamp != null) {
                fujiangCamp.setIsDeputy(1);
                fujiangCamp.updateDB = false;
              } 
              boolean havezhanfa = true;
              if (havezhanfa) {
                fujiangCamp.tacticVal = 1;
              } else {
                fujiangCamp.tacticVal = 0;
              } 
              batCamp.add(0, fujiangCamp);
              baseInfo.setAllNum(baseInfo.getAllNum() + fujiangCamp.getArmyHp());
              baseInfo.setNum(baseInfo.getNum() + fujiangCamp.getArmyHp());
              List<BattleArmy> attList = new ArrayList();
              BattleArmy fjxz = MaxZYaddQueues(bat, attAddQlist, attList, fujiangCamp, battleSide, batQNum);
              batList.add(0, fjxz);
              getReportType64(roundInfo.battleMsg, attAddQlist, (battleSide == 1) ? "att" : "def");
            } 
          } 
        } 
      } 
    } 
  }
  
  public static BattleArmy MaxZYaddQueues(Battle battle, List<BattleArmy> attAddQlist, List<BattleArmy> attList, CampArmy campArmy, int battleSide, AtomicInteger batQNum) {
    int perRow = campArmy.troopHp * 3;
    System.out.println("=======perRow===> " + perRow);
    if (perRow > campArmy.armyHp * 3)
      perRow = campArmy.armyHp * 3; 
    if (campArmy.generalId == 204 && campArmy.isjuexing > 0 && campArmy.getLegendEvoke()) {
      perRow = campArmy.armyHp * 6;
      campArmy.setIsMain(1);
    } 
    perRow /= 3;
    if (perRow <= 0)
      perRow = 1; 
    boolean youzhanche = false;
    int leftrow = campArmy.armyHp / campArmy.troopHp;
    if (campArmy.generalId == 204 && campArmy.isjuexing > 0 && campArmy.legendEvoke)
      leftrow = 1; 
    int totalrow = campArmy.armyHpOrg / campArmy.troopHp;
    boolean zuihousiche = false;
    if (campArmy.getCarModel() > 0) {
      if ((campArmy.generalId == 204 || campArmy.getTroopType() == 157) && campArmy.isjuexing > 0 && !campArmy.legendEvoke)
        youzhanche = true; 
      if ((campArmy.getCarModel() == 1 || campArmy.getCarModel() == 2 || campArmy.getCarModel() == 4 || campArmy.getCarModel() == 5) && totalrow == leftrow)
        youzhanche = true; 
      if ((campArmy.getCarModel() == 7 || campArmy.getCarModel() == 8 || campArmy.getCarModel() == 9 || campArmy.getCarModel() == 6 || campArmy.getCarModel() == 10) && totalrow == leftrow)
        youzhanche = true; 
      if ((campArmy.getCarModel() == 3 || campArmy.getCarModel() == 4) && campArmy.armyHp <= perRow * 3) {
        youzhanche = true;
        if (campArmy.getCarModel() == 4)
          zuihousiche = true; 
      } 
    } 
    boolean hushou = false;
    boolean ybzs = false;
    if (totalrow == leftrow) {
      ybzs = true;
      hushou = true;
    } 
    if (totalrow - 1 == leftrow)
      hushou = true; 
    if (campArmy.generalId == 204 && campArmy.isjuexing > 0 && campArmy.legendEvoke) {
      campArmy.setArmyHp(0);
      ybzs = false;
    } else {
      campArmy.setArmyHp(campArmy.armyHp - perRow * 3);
    } 
    if (campArmy.getLegendSkill() != null && campArmy.getLegendSkill().containsKey("dili") && ((Integer)campArmy.getLegendSkill().get("dili")).intValue() > 0) {
      int dilibeishu = totalrow - leftrow;
      if (dilibeishu <= 0)
        dilibeishu = 1; 
      campArmy.setAttEffect(campArmy.getAttEffect() + (int)(dilibeishu * campArmy.getAttEffect() * 0.06D / 100.0D));
      campArmy.setDefEffect(campArmy.getDefEffect() + (int)(dilibeishu * campArmy.getDefEffect() * 0.06D / 100.0D));
    } 
    BattleArmy battleArmy = new BattleArmy();
    battleArmy.setCampArmy(campArmy);
    if (ybzs)
      if (campArmy.getKaiShan() > 160) {
        battleArmy.setKaiShan(160);
      } else {
        battleArmy.setKaiShan(campArmy.getKaiShan());
      }  
    if ((totalrow == leftrow && campArmy.isDeputy <= 0) || (campArmy.generalId == 204 && campArmy.isjuexing > 0 && campArmy.legendEvoke))
      battleArmy.setTouXian(campArmy.getTouXian()); 
    if (youzhanche) {
      battleArmy.setHaveZhanche(true);
      battleArmy.setCarGzLevel(campArmy.getCarGzLevel());
      battleArmy.setLieYanHuiXiang(campArmy.getLieYanHuiXiang());
      battleArmy.setLonglin(campArmy.getLonglin());
      battleArmy.setCarPoDunNum(campArmy.getCarPoDunNum());
      battleArmy.setNaiJiu(campArmy.getNaijiu());
      if (zuihousiche) {
        battleArmy.setSiCheDier(1);
        battleArmy.setHuJia(campArmy.getSiCheHuJia());
        int carhp = campArmy.getSiCheGeZi() * campArmy.getNaijiu();
        if (carhp > perRow)
          carhp = perRow; 
        battleArmy.setCarHp(carhp);
        battleArmy.setCarMaxHp(campArmy.getSiCheGeZi() * campArmy.getNaijiu());
        battleArmy.setBigGzNum(campArmy.getSiCheGeZi());
      } else {
        int carhp = campArmy.getHujia();
        if (carhp > perRow)
          carhp = perRow; 
        battleArmy.setHuJia(carhp);
        battleArmy.setCarHp(carhp);
        battleArmy.setCarMaxHp(campArmy.getCarMaxHp());
        battleArmy.setBigGzNum(campArmy.getBigGzNum());
      } 
    } else if (campArmy.catapultskill == 2) {
      battleArmy.setZhanchedun(1);
      int carhp = campArmy.getCarHp();
      if (campArmy.generalId == 275 && campArmy.isjuexing > 0 && (battle.terrainVal == 1 || battle.terrainVal == 4)) {
        if (carhp > perRow)
          carhp = perRow; 
        battleArmy.setZCdunHp(carhp);
      } else {
        if (carhp > perRow)
          carhp = perRow; 
        battleArmy.setMaxShield(campArmy.getCarHp());
        battleArmy.setShield(carhp);
        battleArmy.setShiledType(2);
      } 
      battleArmy.setNaiJiu(campArmy.getNaijiu());
      battleArmy.setCarHp(carhp);
      battleArmy.setCarMaxHp(campArmy.getCarMaxHp());
      battleArmy.setBigGzNum(campArmy.getBigGzNum());
    } 
    battleArmy.setCatapultSkill(campArmy.getCatapultSkill());
    battleArmy.setPosition(batQNum.getAndIncrement());
    for (int i = 0; i < 3; i++) {
      battleArmy.getTroopHp()[i] = perRow;
      battleArmy.setBloodOrg(perRow);
    } 
    int curStrategy = 0;
    if (campArmy.isPhantom) {
      if (campArmy.curStrategy == 0) {
        curStrategy = campArmy.getStrategies()[WebUtil.nextInt((campArmy.getStrategies()).length)];
        campArmy.curStrategy = curStrategy;
      } else {
        curStrategy = campArmy.curStrategy;
      } 
    } else {
      curStrategy = campArmy.getStrategies()[WebUtil.nextInt((campArmy.getStrategies()).length)];
    } 
    if (campArmy.sanzhenbao > 0 && campArmy.armyHp <= perRow && campArmy.isDeputy <= 0)
      if (campArmy.qizhenbao > 0) {
        battleArmy.setIsDajiang(2);
      } else {
        battleArmy.setIsDajiang(1);
      }  
    if (campArmy.generalId == 273 && campArmy.isjuexing <= 0)
      battleArmy.setZhenXiaHouYuan(3); 
    battleArmy.setStrategy(curStrategy);
    if (campArmy.generalId == 230 && campArmy.isjuexing > 0 && battle.getTerrainVal() == 3)
      battleArmy.setGlShuiBao(1); 
    if (campArmy.hasbigformationskill > 0 && campArmy.formationtype == 3)
      if (leftrow >= 5) {
        battleArmy.setZhenFaJianShang(1.0D);
      } else if (leftrow >= 4) {
        if (campArmy.formationLevel >= 80) {
          battleArmy.setZhenFaJianShang(0.9D);
        } else if (campArmy.formationLevel >= 50) {
          battleArmy.setZhenFaJianShang(0.7D);
        } else if (campArmy.formationLevel >= 20) {
          battleArmy.setZhenFaJianShang(0.6D);
        } 
      } else if (leftrow >= 3) {
        if (campArmy.formationLevel >= 80) {
          battleArmy.setZhenFaJianShang(0.6D);
        } else if (campArmy.formationLevel >= 50) {
          battleArmy.setZhenFaJianShang(0.4D);
        } else if (campArmy.formationLevel >= 20) {
          battleArmy.setZhenFaJianShang(0.3D);
        } 
      } else if (leftrow >= 2) {
        if (campArmy.formationLevel >= 80) {
          battleArmy.setZhenFaJianShang(0.3D);
        } else if (campArmy.formationLevel >= 50) {
          battleArmy.setZhenFaJianShang(0.15D);
        } else if (campArmy.formationLevel >= 20) {
          battleArmy.setZhenFaJianShang(0.1D);
        } 
      } else {
        battleArmy.setZhenFaJianShang(0.1D);
      }  
    if (campArmy.generalId == 211 && campArmy.isjuexing > 0)
      battleArmy.setBaiBuChuanYang(1); 
    if (battleArmy.getIsDajiang() > 0 || campArmy.ismain > 0) {
      battleArmy.setZfShiled(campArmy.getzfShield());
      battleArmy.setQiZhenBao(campArmy.getQiZhenbao());
    } 
    if (campArmy.getGeneralId() == 208 && campArmy.getIsJuexing() > 0 && !battleArmy.getHaveZhanChe()) {
      battleArmy.setShield(battleArmy.getTroopHp()[0]);
      battleArmy.setMaxShield(battleArmy.getTroopHp()[0]);
      battleArmy.setShiledType(1);
    } 
    battleArmy.setYubaoEffect(campArmy.getYubaoEffect());
    boolean isssx = false;
    if (campArmy.getGeneralId() == 402 && campArmy.getIsJuexing() > 0)
      isssx = true; 
    if (campArmy.getHelpGeneral() == 402 && campArmy.getHelpIsJuexing() > 0)
      isssx = true; 
    if (isssx && hushou) {
      battleArmy.setYubaoEffect(2);
      battleArmy.setHuShou(2);
      campArmy.setSdqs(1);
    } 
    attAddQlist.add(battleArmy);
    attList.add(battleArmy);
    campArmy.setXinBingShangZhen(1);
    if (campArmy.getGeneralId() == 276 && campArmy.getHelpGeneral() == 403)
      campArmy.tacticVal++; 
    return battleArmy;
  }
  
  public static void getReportType64(StringBuilder battleMsg, List<BattleArmy> addQlist, String battleSide) {
    BattleArmy battleArmy = null;
    if (addQlist.size() > 0) {
      battleMsg.append(64).append("|").append(battleSide).append(";");
      for (int i = 0; i < addQlist.size(); i++) {
        battleArmy = addQlist.get(i);
        CampArmy campArmy = battleArmy.getCampArmy();
        int specialType = (campArmy.getTeamGenreal() == null) ? 0 : ((campArmy.getTeamEffect() > 0.0D) ? 2 : 1);
        if (battleArmy.getTD_defense_e() > 0.0D)
          specialType = 3; 
        int troopHpMax = campArmy.getTroopHp() / 3;
        battleMsg.append(battleArmy.getPosition()).append("|").append(campArmy.getPlayerId()).append("|").append(campArmy.getTroopSerial()).append("|").append(campArmy.getTroopType()).append("|").append(campArmy.getTroopName()).append("|").append(campArmy.getTroopDropType()).append("|").append(battleArmy.getStrategy()).append("|").append(specialType).append("|");
        boolean diyihang = battleArmy.getHaveZhanChe();
        battleMsg.append(campArmy.getIsJuexing()).append("|").append(campArmy.getIsChongFeng()).append("|").append(battleArmy.getIsDajiang()).append("|").append(campArmy.getCopyType()).append("|").append(campArmy.getJueEquip()).append("|").append(campArmy.getAttack()).append("|").append(campArmy.getDefence()).append("|").append(campArmy.getResistePercentage()).append("|");
        if (diyihang) {
          int carid = campArmy.getCarId();
          battleMsg.append(carid).append("|").append(battleArmy.getBigGzNum()).append("|");
        } else if (battleArmy.getZhanchedun() > 0) {
          int carid = 0;
          if (campArmy.getCatapultSkill() == 2 && campArmy.getGeneralId() == 275) {
            carid = 999;
          } else if (campArmy.getCatapultSkill() == 4 && campArmy.getGeneralId() == 275) {
            carid = 879992;
          } 
          if (carid > 0) {
            battleMsg.append(carid).append("|").append(battleArmy.getBigGzNum()).append("|");
          } else {
            battleMsg.append(carid).append("|").append(0).append("|");
          } 
        } else {
          battleMsg.append(0).append("|").append(0).append("|");
        } 
        battleMsg.append(campArmy.getbsPro()).append("|").append(battleArmy.getZfShiled()).append("|").append(battleArmy.getSpecial()).append("|").append(campArmy.getWeiweiHuaide()).append("|").append(battleArmy.getYubaoEffect()).append("|").append(campArmy.getFormationType()).append("|").append(campArmy.getHasbigFormationskill()).append("|").append(campArmy.getFyzShield()).append("|").append(campArmy.getLgdcBuff()).append("|").append(campArmy.getIsBurn()).append("|").append(campArmy.getSex()).append("|").append(campArmy.getIsDeputy()).append("|").append(campArmy.getJxType()).append("|").append(campArmy.getYbTx()).append("|").append(campArmy.getWsb()).append("|").append(battleArmy.getTouXian()).append("|").append("0|").append(battleArmy.getLonglin()).append("|").append(battleArmy.getSangDanType()).append("|0|").append(campArmy.getMissNum()).append("|").append(campArmy.getImmunoNum()).append("|").append(campArmy.getCarPoDunNum()).append("|").append(campArmy.getIsFanShang()).append("|").append(campArmy.getIsBmy()).append("|").append(campArmy.getZhsNum()).append("|").append(campArmy.getMfFire()).append("|").append(battleArmy.getCardebuff()).append("|").append(battleArmy.getQingCheng()).append("|").append(battleArmy.getCarGzLevel()).append("|").append(battleArmy.getHuWei()).append("|").append(battleArmy.getCarTsBj()).append("|").append(battleArmy.getpose()).append("|").append(campArmy.getSneer()).append("|").append(campArmy.getIsBeatMonster()).append("|").append(campArmy.getBeastStar()).append("|").append("0|").append(campArmy.getFkbhHpPro()).append("|").append(campArmy.getIsZhenFaLvUp()).append("|").append(campArmy.getIsFlower()).append("|").append(campArmy.getSunShangXiangZs()).append("|").append(campArmy.getZsMyMa()).append("|").append(campArmy.getSsxMa()).append("|").append(battleArmy.getHuShou()).append("|").append(battleArmy.getFengDao()).append("|").append(battleArmy.getZyNum()).append("|");
        battleMsg.append(campArmy.getHuoYi()).append("|").append(campArmy.getZhaXiang()).append("|").append(campArmy.getHasZh()).append("|").append(campArmy.getLjNum()).append("|null|").append(campArmy.getLeblMa()).append("|").append(campArmy.guzhu).append("|").append(campArmy.getTuiShou()).append("|").append(campArmy.getFuBingNum1()).append("|0|0|").append(campArmy.getJxBuff1()).append("|").append(campArmy.getJxBuff1()).append("|0|0|0|0|").append(campArmy.getTitle1()).append("|0|0|0|").append(campArmy.getTitle()).append("|0|0|0|0|0|0|0|0|0|0|0|0|0|0|0|");
        for (int j = 0; j < 3; j++) {
          if (diyihang) {
            battleMsg.append(battleArmy.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(battleArmy.getCarHp()).append("*").append(battleArmy.getCarMaxHp()).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } else if (battleArmy.getZhanchedun() > 0) {
            battleMsg.append(battleArmy.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(battleArmy.getZCdunHp()).append("*").append(battleArmy.getCarMaxHp()).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } else {
            battleMsg.append(battleArmy.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(0).append("*").append(0).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } 
        } 
        battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), ";");
      } 
      battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "#");
    } 
  }
  
  public void roundCaculateHuanYingDanTiaoExpReward(IDataGetter dataGetter, FightRewardCoe frc, Battle bat, RoundInfo roundInfo) {
    if (roundInfo.hydantiaolostmap == null || roundInfo.hydantiaolostmap.isEmpty())
      return; 
    int attLv = roundInfo.attCampArmy.getPlayerLv();
    int gAttLv = roundInfo.attCampArmy.getGeneralLv();
    int troopIdAtt = roundInfo.attCampArmy.getTroopId();
    int defLv = getDefPlayerLevel(dataGetter, bat, roundInfo);
    int gDefLv = roundInfo.defCampArmy.getGeneralLv();
    int TroopIdDef = roundInfo.defCampArmy.getTroopId();
    for (String biaozhi : roundInfo.hydantiaolostmap.keySet()) {
      String[] arr = biaozhi.split("_");
      int playerId = Integer.valueOf(arr[0]).intValue();
      int generalId = Integer.valueOf(arr[1]).intValue();
      int forceId = Integer.valueOf(arr[2]).intValue();
      long attLost = ((Long)roundInfo.hydantiaolostmap.get(biaozhi)).longValue();
      long defLost = 0L;
      if (roundInfo.hydantiaokillmap != null && roundInfo.hydantiaokillmap.containsKey(biaozhi))
        defLost = ((Long)roundInfo.hydantiaokillmap.get(biaozhi)).longValue(); 
      double mAttOmega2 = getRoundRewardBase(dataGetter, frc, troopIdAtt, TroopIdDef, attLost, defLost, attLv, defLv);
      double gAttOmega2 = getRoundRewardBase(dataGetter, frc, troopIdAtt, TroopIdDef, attLost, defLost, gAttLv, gDefLv);
      BattleDrop battleDrop2 = new BattleDrop();
      int copper2 = (int)(mAttOmega2 * frc.getM().doubleValue());
      if (copper2 > 0) {
        battleDrop2.type = 1;
        battleDrop2.num = copper2;
        AsynchronousDBOperationManager.getInstance().addBattleDropRetry(playerId, battleDrop2, "战斗获得");
        dataGetter.getIndividualTaskService().sendTaskMessage(new PlayerDto(playerId, forceId), copper2, "killyb");
      } 
      double mExp2 = mAttOmega2 * frc.getC().doubleValue() * roundInfo.attCampArmy.rewardDouble;
      double att_world_frontLine_buff_exp_e2 = 1.0D;
      if (bat.world_frontLine_buff_att_def_e_side == 1)
        att_world_frontLine_buff_exp_e2 = bat.world_frontLine_buff_exp_e; 
      double attLowLvSCoe2 = getLowLvSCoe(bat, attLv, defLv);
      double attTechAddGZJY2 = 0.0D;
      if (bat.battleType == 3 || bat.battleType == 13) {
        attTechAddGZJY2 = dataGetter.getTechEffectCache().getTechEffect(playerId, 40) / 100.0D;
        double lgzexp = dataGetter.getBattleDataCache().getPlayerExpadd(playerId) / 100.0D;
        attTechAddGZJY2 += lgzexp;
      } 
      mExp2 *= att_world_frontLine_buff_exp_e2 + attLowLvSCoe2 + attTechAddGZJY2 + bat.world_round_ally_buff_att_e + roundInfo.attCampArmy.activityAddExp;
      if (mExp2 >= 2.147483647E9D)
        mExp2 = 2.147483647E9D; 
      if (mExp2 > 0.0D) {
        battleDrop2.type = 5;
        battleDrop2.num = (int)mExp2;
        AsynchronousDBOperationManager.getInstance().addBattleDropRetry(playerId, battleDrop2, "战斗获得");
      } 
      double gExpAdd2 = 0.0D;
      gExpAdd2 = dataGetter.getTechEffectCache().getTechEffect(playerId, 16) / 100.0D;
      if (dataGetter.getPlayerDao().getConsumeLv(playerId) >= 9)
        gExpAdd2 += 0.1D; 
      if (dataGetter.getPlayerDao().ismooncard(playerId))
        gExpAdd2 += 0.15D; 
      if (playerId > 0) {
        Map<Integer, String> ycbweffectMap = dataGetter.getBattleDataCache().getYcbwMap(playerId, generalId);
        gExpAdd2 += Double.valueOf(ycbweffectMap.get(Integer.valueOf(8))).doubleValue() / 100.0D;
      } 
      int gExp = (int)(gAttOmega2 * frc.getE().doubleValue() * (1.0D + gExpAdd2));
      if (gExp > 0)
        try {
          AsynchronousDBOperationAddGeneralExp asynchronousDBOperationAddGeneralExp = new AsynchronousDBOperationAddGeneralExp(playerId, generalId, gExp, "战斗获得");
          AsynchronousDBOperationManager.getInstance().addDBRetryOperation((IAsynchronousDBOperation)asynchronousDBOperationAddGeneralExp);
        } catch (Exception e) {
          ErrorSceneLog.getInstance().appendErrorMsg("Builder roundAddHuanyingDantiao 增加武将等级经验经验 Exception").appendClassName("Builder").append("PlayerId", Integer.valueOf(playerId)).appendGeneralId(generalId).append("gExp", Integer.valueOf(gExp)).flush();
          ErrorSceneLog.getInstance().error("Builder roundAddHuanyingDantiao 增加玩家等级经验 Exception", e);
        }  
    } 
  }
  
  public void roundCaculateHuanYingDanTiaoKillNumReward(IDataGetter dataGetter, FightRewardCoe frc, Battle bat, RoundInfo roundInfo) {
    if (roundInfo.hydantiaokillmap == null || roundInfo.hydantiaokillmap.isEmpty())
      return; 
    com.reign.gcld.battle.scene.Builder builder = BuilderFactory.getInstance().getBuilder(bat.battleType);
    for (String biaozhi : roundInfo.hydantiaokillmap.keySet()) {
      String[] arr = biaozhi.split("_");
      int playerId = Integer.valueOf(arr[0]).intValue();
      long killnum = ((Long)roundInfo.hydantiaokillmap.get(biaozhi)).longValue();
      if (killnum >= 2147483647L)
        killnum = 2147483647L; 
      builder.dealKillrank(false, (int)killnum, bat, dataGetter, playerId);
      if (roundInfo.hydantiaobarbarkillmap != null && roundInfo.hydantiaobarbarkillmap.containsKey(biaozhi)) {
        long killnumbarbar = ((Long)roundInfo.hydantiaobarbarkillmap.get(biaozhi)).longValue();
        if (killnumbarbar >= 2147483647L)
          killnumbarbar = 2147483647L; 
        builder.dealKillrank(true, (int)killnumbarbar, bat, dataGetter, playerId);
      } 
    } 
  }
  
  public void baguaformation(IDataGetter dataGetter, Battle bat, RoundInfo roundInfo) {
    CampArmy attcamp = roundInfo.attCampArmy;
    CampArmy defcamp = roundInfo.defCampArmy;
    List<BattleArmy> attbatlist = bat.getAttList();
    List<BattleArmy> defbatlist = bat.getAttList();
    if (attcamp.getFormationType() == 4 && attcamp.getFormationLevel() < 2000) {
      int baguazhenLevel = attcamp.getBaGuaLevel();
      int baguazhenLevel2 = attcamp.getFormationLevel();
      int suiji = RandomUtils.nextInt(100);
      int ersui = RandomUtils.nextInt(100);
      roundInfo.battleMsg.append("94|att|1|");
      for (int i = 0; i < attbatlist.size(); i++) {
        BattleArmy attBattleArmy = attbatlist.get(i);
        if (i > 0) {
          attBattleArmy.setBaGuaAttack(0);
          attBattleArmy.setBaGuaBaoji(0);
        } 
        if (baguazhenLevel >= 6) {
          if (i == 0) {
            if (attBattleArmy.getBaGuaAttack() <= 0)
              attBattleArmy.setBaGuaAttack(1); 
            if (attBattleArmy.getBaGuaBaoji() <= 0)
              attBattleArmy.setBaGuaBaoji(1); 
          } else if (attBattleArmy.getBaGuaFangYu() <= 0) {
            attBattleArmy.setBaGuaFangYu(1);
          } 
        } else if (baguazhenLevel >= 4) {
          if (i == 0) {
            if (attBattleArmy.getBaGuaAttack() <= 0)
              attBattleArmy.setBaGuaAttack(1); 
            if (attBattleArmy.getBaGuaBaoji() <= 0)
              attBattleArmy.setBaGuaBaoji(1); 
          } else if (suiji < 40 && attBattleArmy.getBaGuaFangYu() <= 0) {
            attBattleArmy.setBaGuaFangYu(1);
          } 
        } else if (baguazhenLevel >= 2 && suiji <= 30) {
          if (ersui < 50) {
            if (i == 0) {
              if (attBattleArmy.getBaGuaAttack() <= 0)
                attBattleArmy.setBaGuaAttack(1); 
              if (attBattleArmy.getBaGuaBaoji() <= 0)
                attBattleArmy.setBaGuaBaoji(1); 
            } 
          } else if (i > 0 && attBattleArmy.getBaGuaFangYu() <= 0) {
            attBattleArmy.setBaGuaFangYu(0);
          } 
        } 
        roundInfo.battleMsg.append(attBattleArmy.getPosition()).append(",").append(attBattleArmy.getBaGuaAttack()).append(",").append(attBattleArmy.getBaGuaBaoji()).append(",").append(attBattleArmy.getBaGuaFangYu()).append(",0,").append(19).append("*");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
    } 
    if (attcamp.getFormationType() == 4 && attcamp.getFormationLevel() > 2000) {
      int baguazhenLevel = attcamp.getBaGuaLevel();
      int suiji = RandomUtils.nextInt(100);
      int ersui = RandomUtils.nextInt(100);
      for (int i = 0; i < attbatlist.size(); i++) {
        BattleArmy attBattleArmy = attbatlist.get(i);
        if (attcamp.getFormationLevel() > 300)
          if (i == 0 && suiji > 60) {
            roundInfo.battleMsg.append("110|att|land|");
            roundInfo.battleMsg.append("81|att|");
            for (int i1 = 0; i1 < 2; i1++) {
              BattleArmy attbattleArmy = bat.attList.get(i1);
              if (attbattleArmy.getCampArmy().getId() == attcamp.getId() && 
                attbattleArmy.getTroopHp()[0] > 100) {
                if (attbattleArmy.getHaveZhanChe()) {
                  if (attbattleArmy.getHuJia() > 0)
                    continue; 
                  if (attbattleArmy.getZCdunHp() > 0)
                    continue; 
                } 
                if (!attbattleArmy.getHaveZhanChe() || attbattleArmy.getShiledType() != 2 || attbattleArmy.getShield() <= 0) {
                  int maxhpadd = attbattleArmy.getCampArmy().getTroopHp() / 3 * 80 / 100;
                  int caocaohp = attbattleArmy.getShield();
                  if (caocaohp < maxhpadd) {
                    int adddun = maxhpadd - caocaohp;
                    if (adddun > 0) {
                      attbattleArmy.setSpecial(0);
                      if (attbattleArmy.getCampArmy().getDefenseDow() > 0) {
                        attbattleArmy.getCampArmy().setDefenseDow(0);
                        attbattleArmy.getCampArmy().setDefenseDown(0.0D);
                      } 
                      if (attbattleArmy.getSangDanType() > 0)
                        attbattleArmy.setSangDanType(0); 
                      if (attbattleArmy.getCampArmy().getAttackLevel() < 0)
                        attbattleArmy.getCampArmy().setAttackLevel(0); 
                      if (attbattleArmy.getHuWei() > 0)
                        attbattleArmy.setHuWei(0); 
                      if (attbattleArmy.getCardebuff() > 0)
                        attbattleArmy.setCardebuff(0); 
                      attbattleArmy.setShield(attbattleArmy.getShield() + adddun);
                      attbattleArmy.setMaxShield(attbattleArmy.getShield());
                      attbattleArmy.setShiledType(4);
                      attcamp.setHslonghunNum(attcamp.getHslonghunNum() + 1);
                      roundInfo.battleMsg.append("65|19,").append(attbattleArmy.getShield()).append(",").append(attbattleArmy.getShield()).append(",").append(";null#");
                    } 
                  } 
                } 
              } 
              roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
              roundInfo.battleMsg.append("31|0#");
              roundInfo.nextMinExeTime += 3000;
              continue;
            } 
          } else if (i == 0 && suiji > 40) {
            roundInfo.battleMsg.append("110|att|fire|");
            roundInfo.defCampArmy.huoshaolianying = 6;
          } else if (i == 0 && suiji > 20) {
            roundInfo.battleMsg.append("110|att|wind|");
            attcamp.setGuDan(true);
          } else if (i == 0 && suiji > 0) {
            roundInfo.battleMsg.append("110|att|water|");
            roundInfo.battleMsg.append("66|def;").append(1).append("#");
            defcamp.setAttEffect(defcamp.getAttEffect() / 2);
            defcamp.setDefEffect(defcamp.getDefEffect() / 2);
            if (bat.getDefCamp().size() > 5) {
              int houtui = dataGetter.getBattleService().jxZhangFeiSkill(attcamp, bat, 1, 1);
              if (houtui > 0) {
                JsonDocument doc = new JsonDocument();
                doc.startObject();
                doc.createElement("floodedSide", Integer.valueOf(0));
                doc.startObject("floodInfo");
                doc.createElement("isAtt", Boolean.valueOf(false));
                doc.createElement("num", Integer.valueOf(houtui));
                doc.endObject();
                doc.endObject();
                for (Integer playerId : bat.inSceneSet)
                  Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_FLOOD, doc.toByte()); 
              } 
            } 
            List<BattleArmy> listB2 = bat.defList;
            int rows4 = listB2.size();
            roundInfo.battleMsg.append("121|def|");
            boolean zhaoyunchidiao6 = false;
            for (int k = 0; k < rows4; k++) {
              int reduce8 = 0;
              BattleArmy batArmy7 = listB2.get(k);
              CampArmy defendCa7 = batArmy7.getCampArmy();
              roundInfo.battleMsg.append(batArmy7.getPosition()).append(",");
              int damage5 = attcamp.getFiveShuiDamage();
              if (defendCa7.getLegendSkill().containsKey("yanmi") && ((Integer)defendCa7.getLegendSkill().get("yanmi")).intValue() > 0)
                damage5 = damage5 * 40 / 100; 
              int xinlost7 = DamageSkill(attcamp, batArmy7, defendCa7, 1, damage5, false, dataGetter, bat, roundInfo, k);
              if (k == 0 && batArmy7.getTroopHp()[0] <= 0) {
                roundInfo.defFirstRowKilled = true;
                roundInfo.win = 1;
              } 
              roundInfo.battleMsg.append(xinlost7).append(",").append(batArmy7.getTroopHp()[0]).append(",0,0;");
            } 
            roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
            roundInfo.nextMinExeTime += 3000;
          }  
      } 
    } 
    if (defcamp.getFormationType() == 4 && defcamp.getFormationLevel() > 2000) {
      int baguazhenLevel = defcamp.getBaGuaLevel();
      int suiji = RandomUtils.nextInt(100);
      int ersui = RandomUtils.nextInt(100);
      for (int i = 0; i < attbatlist.size(); i++) {
        BattleArmy defBattleArmy = attbatlist.get(i);
        if (defcamp.getFormationLevel() > 2000) {
          if (i == 0 && suiji > 60) {
            roundInfo.battleMsg.append("110|def|land|");
            roundInfo.battleMsg.append("81|def|");
            for (int i1 = 0; i1 < 2; i1++) {
              BattleArmy defbattleArmy = bat.defList.get(i1);
              if (defbattleArmy.getCampArmy().getId() == defcamp.getId() && 
                defbattleArmy.getTroopHp()[0] > 100) {
                if (defbattleArmy.getHaveZhanChe()) {
                  if (defbattleArmy.getHuJia() > 0)
                    continue; 
                  if (defbattleArmy.getZCdunHp() > 0)
                    continue; 
                } 
                if (!defbattleArmy.getHaveZhanChe() || defbattleArmy.getShiledType() != 2 || defbattleArmy.getShield() <= 0) {
                  int maxhpadd = defbattleArmy.getCampArmy().getTroopHp() / 3 * 80 / 100;
                  int caocaohp = defbattleArmy.getShield();
                  if (caocaohp < maxhpadd) {
                    int adddun = maxhpadd - caocaohp;
                    if (adddun > 0) {
                      defbattleArmy.setSpecial(0);
                      if (defbattleArmy.getCampArmy().getDefenseDow() > 0) {
                        defbattleArmy.getCampArmy().setDefenseDow(0);
                        defbattleArmy.getCampArmy().setDefenseDown(0.0D);
                      } 
                      if (defbattleArmy.getSangDanType() > 0)
                        defbattleArmy.setSangDanType(0); 
                      if (defbattleArmy.getCampArmy().getAttackLevel() < 0)
                        defbattleArmy.getCampArmy().setAttackLevel(0); 
                      if (defbattleArmy.getHuWei() > 0)
                        defbattleArmy.setHuWei(0); 
                      if (defbattleArmy.getCardebuff() > 0)
                        defbattleArmy.setCardebuff(0); 
                      defbattleArmy.setShield(defbattleArmy.getShield() + adddun);
                      defbattleArmy.setMaxShield(defbattleArmy.getShield());
                      defbattleArmy.setShiledType(4);
                      defcamp.setHslonghunNum(defcamp.getHslonghunNum() + 1);
                      roundInfo.battleMsg.append("65|null;").append(19).append(",").append(defbattleArmy.getShield()).append(",0").append("#");
                    } 
                  } 
                } 
              } 
              continue;
            } 
            roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
            roundInfo.battleMsg.append("31|0#");
            roundInfo.nextMinExeTime += 3000;
          } 
        } else if (i == 0 && suiji > 40) {
          roundInfo.battleMsg.append("110|def|fire|");
          roundInfo.attCampArmy.huoshaolianying = 6;
        } else if (i == 0 && suiji > 20) {
          roundInfo.battleMsg.append("110|def|wind|");
          roundInfo.battleMsg.append("81|def|");
          defcamp.setGuDan(true);
        } else if (i == 0 && suiji > 0) {
          roundInfo.battleMsg.append("66|att;").append(1).append("#");
          attcamp.setAttEffect(attcamp.getAttEffect() / 2);
          attcamp.setDefEffect(attcamp.getDefEffect() / 2);
          if (bat.getAttCamp().size() > 5) {
            int houtui = dataGetter.getBattleService().jxZhangFeiSkill(defcamp, bat, 0, 1);
            if (houtui > 0) {
              JsonDocument doc = new JsonDocument();
              doc.startObject();
              doc.createElement("floodedSide", Integer.valueOf(1));
              doc.startObject("floodInfo");
              doc.createElement("isAtt", Boolean.valueOf(true));
              doc.createElement("num", Integer.valueOf(houtui));
              doc.endObject();
              doc.endObject();
              for (Integer playerId : bat.inSceneSet)
                Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_FLOOD, doc.toByte()); 
            } 
          } 
          List<BattleArmy> listB2 = bat.attList;
          int rows4 = listB2.size();
          roundInfo.battleMsg.append("121|att|");
          boolean zhaoyunchidiao6 = false;
          for (int k = 0; k < rows4; k++) {
            int reduce8 = 0;
            BattleArmy batArmy7 = listB2.get(k);
            CampArmy defendCa7 = batArmy7.getCampArmy();
            roundInfo.battleMsg.append(batArmy7.getPosition()).append(",");
            int damage5 = defcamp.getFiveShuiDamage();
            if (defendCa7.getLegendSkill().containsKey("yanmi") && ((Integer)defendCa7.getLegendSkill().get("yanmi")).intValue() > 0)
              damage5 = damage5 * 40 / 100; 
            int xinlost7 = DamageSkill(defcamp, batArmy7, defendCa7, 0, damage5, false, dataGetter, bat, roundInfo, k);
            if (k == 0 && batArmy7.getTroopHp()[0] <= 0) {
              roundInfo.attFirstRowKilled = true;
              roundInfo.win = 2;
            } 
            roundInfo.battleMsg.append(xinlost7).append(",").append(batArmy7.getTroopHp()[0]).append(",0,0;");
          } 
          roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
          roundInfo.nextMinExeTime += 3000;
        } 
      } 
    } 
    if (defcamp.getFormationType() == 4 && defcamp.getFormationLevel() < 2000) {
      int baguazhenLevel = defcamp.getBaGuaLevel();
      int suiji = RandomUtils.nextInt(100);
      int ersui = RandomUtils.nextInt(100);
      roundInfo.battleMsg.append("94|def|2|");
      for (int i = 0; i < defbatlist.size(); i++) {
        BattleArmy defBattleArmy = defbatlist.get(i);
        if (i > 0) {
          defBattleArmy.setBaGuaAttack(0);
          defBattleArmy.setBaGuaBaoji(0);
        } 
        if (baguazhenLevel >= 6) {
          if (i == 0) {
            if (defBattleArmy.getBaGuaAttack() <= 0)
              defBattleArmy.setBaGuaAttack(1); 
            if (defBattleArmy.getBaGuaBaoji() <= 0)
              defBattleArmy.setBaGuaBaoji(1); 
          } else if (defBattleArmy.getBaGuaFangYu() <= 0) {
            defBattleArmy.setBaGuaFangYu(1);
          } 
        } else if (baguazhenLevel >= 4) {
          if (i == 0) {
            if (defBattleArmy.getBaGuaAttack() <= 0)
              defBattleArmy.setBaGuaAttack(1); 
            if (defBattleArmy.getBaGuaBaoji() <= 0)
              defBattleArmy.setBaGuaBaoji(1); 
          } else if (suiji < 40 && defBattleArmy.getBaGuaFangYu() <= 0) {
            defBattleArmy.setBaGuaFangYu(1);
          } 
        } else if (baguazhenLevel >= 2 && suiji <= 30) {
          if (ersui < 50) {
            if (i == 0) {
              if (defBattleArmy.getBaGuaAttack() <= 0)
                defBattleArmy.setBaGuaAttack(1); 
              if (defBattleArmy.getBaGuaBaoji() <= 0)
                defBattleArmy.setBaGuaBaoji(1); 
            } 
          } else if (i > 0 && defBattleArmy.getBaGuaFangYu() <= 0) {
            defBattleArmy.setBaGuaFangYu(1);
          } 
        } 
        roundInfo.battleMsg.append(defBattleArmy.getPosition()).append(",").append(defBattleArmy.getBaGuaAttack()).append(",").append(defBattleArmy.getBaGuaBaoji()).append(",").append(defBattleArmy.getBaGuaFangYu()).append(",0,").append(defBattleArmy.getBaGuaDun()).append("*");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
    } 
  }
  
  public static void getReportType66(StringBuilder battleMsg, List<BattleArmy> addQlist, String battleSide) {
    BattleArmy battleArmy = null;
    if (addQlist.size() > 0) {
      battleMsg.append("66|").append(battleSide).append(";5;");
      for (int i = 0; i < addQlist.size(); i++) {
        battleArmy = addQlist.get(i);
        CampArmy campArmy = battleArmy.getCampArmy();
        int specialType = (campArmy.getTeamGenreal() == null) ? 0 : ((campArmy.getTeamEffect() > 0.0D) ? 2 : 1);
        if (battleArmy.getTD_defense_e() > 0.0D)
          specialType = 3; 
        int troopHpMax = campArmy.getTroopHp() / 3;
        battleMsg.append(battleArmy.getPosition()).append("|").append(campArmy.getPlayerId()).append("|").append(campArmy.getTroopSerial()).append("|").append(campArmy.getTroopType()).append("|").append(campArmy.getTroopName()).append("|").append(campArmy.getTroopDropType()).append("|").append(battleArmy.getStrategy()).append("|").append(specialType).append("|");
        boolean diyihang = battleArmy.getHaveZhanChe();
        battleMsg.append(campArmy.getIsJuexing()).append("|").append(campArmy.getIsChongFeng()).append("|").append(battleArmy.getIsDajiang()).append("|").append(campArmy.getCopyType()).append("|").append(campArmy.getJueEquip()).append("|").append(campArmy.getAttack()).append("|").append(campArmy.getDefence()).append("|").append(campArmy.getResistePercentage()).append("|");
        if (diyihang) {
          int carid = campArmy.getCarId();
          battleMsg.append(carid).append("|").append(battleArmy.getBigGzNum()).append("|");
        } else if (battleArmy.getZhanchedun() > 0) {
          int carid = 0;
          if (campArmy.getCatapultSkill() == 2 && campArmy.getGeneralId() == 275) {
            carid = 999;
          } else if (campArmy.getCatapultSkill() == 4 && campArmy.getGeneralId() == 275) {
            carid = 879992;
          } 
          if (carid > 0) {
            battleMsg.append(carid).append("|").append(battleArmy.getBigGzNum()).append("|");
          } else {
            battleMsg.append(carid).append("|").append(0).append("|");
          } 
        } else {
          battleMsg.append(0).append("|").append(0).append("|");
        } 
        battleMsg.append(campArmy.getbsPro()).append("|").append(battleArmy.getZfShiled()).append("|").append(battleArmy.getSpecial()).append("|").append(campArmy.getWeiweiHuaide()).append("|").append(battleArmy.getYubaoEffect()).append("|").append(campArmy.getFormationType()).append("|").append(campArmy.getHasbigFormationskill()).append("|").append(campArmy.getFyzShield()).append("|").append(campArmy.getLgdcBuff()).append("|").append(campArmy.getIsBurn()).append("|").append(campArmy.getSex()).append("|").append(campArmy.getIsDeputy()).append("|").append(campArmy.getJxType()).append("|").append(campArmy.getYbTx()).append("|").append(campArmy.getWsb()).append("|").append(battleArmy.getTouXian()).append("|").append("0|").append(battleArmy.getLonglin()).append("|").append(battleArmy.getSangDanType()).append("|0|").append(campArmy.getMissNum()).append("|").append(campArmy.getImmunoNum()).append("|").append(campArmy.getCarPoDunNum()).append("|").append(campArmy.getIsFanShang()).append("|").append(campArmy.getIsBmy()).append("|").append(campArmy.getZhsNum()).append("|").append(campArmy.getMfFire()).append("|").append(battleArmy.getCardebuff()).append("|").append(battleArmy.getQingCheng()).append("|").append(battleArmy.getCarGzLevel()).append("|").append(battleArmy.getHuWei()).append("|").append(battleArmy.getCarTsBj()).append("|").append(battleArmy.getpose()).append("|").append(campArmy.getSneer()).append("|").append(campArmy.getIsBeatMonster()).append("|").append(campArmy.getBeastStar()).append("|").append("0|").append(campArmy.getFkbhHpPro()).append("|").append(campArmy.getIsZhenFaLvUp()).append("|").append(campArmy.getIsFlower()).append("|").append(campArmy.getSunShangXiangZs()).append("|").append(campArmy.getZsMyMa()).append("|").append(campArmy.getSsxMa()).append("|").append(battleArmy.getHuShou()).append("|").append(battleArmy.getFengDao()).append("|").append(battleArmy.getZyNum()).append("|");
        battleMsg.append(campArmy.getHuoYi()).append("|").append(campArmy.getZhaXiang()).append("|").append(campArmy.getHasZh()).append("|").append(campArmy.getLjNum()).append("|null|").append(campArmy.getLeblMa()).append("|").append(campArmy.guzhu).append("|").append(campArmy.getTuiShou()).append("|").append(campArmy.getFuBingNum1()).append("|0|0|").append(campArmy.getJxBuff1()).append("|").append(campArmy.getJxBuff1()).append("|0|0|0|0|").append(campArmy.getTitle1()).append("|0|0|0|").append(campArmy.getTitle()).append("|0|0|0|0|0|0|0|0|0|0|0|0|0|0|0|");
        for (int j = 0; j < 3; j++) {
          if (diyihang) {
            battleMsg.append(battleArmy.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(battleArmy.getCarHp()).append("*").append(battleArmy.getCarMaxHp()).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } else if (battleArmy.getZhanchedun() > 0) {
            battleMsg.append(battleArmy.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(battleArmy.getZCdunHp()).append("*").append(battleArmy.getCarMaxHp()).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } else {
            battleMsg.append(battleArmy.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(battleArmy.getShield()).append("*").append(battleArmy.getMaxShield()).append("*").append(0).append("*").append(0).append("*").append(battleArmy.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
          } 
        } 
        battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), ";");
      } 
      battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "#");
    } 
  }
  
  public static void getReportType104(StringBuilder battleMsg, List<BattleArmy> addQlist, String battleSide) {
    if (addQlist.size() > 0) {
      battleMsg.append(104).append("|").append(battleSide).append("|");
      for (int i = 0; i < addQlist.size(); i++) {
        BattleArmy battleArmy = addQlist.get(i);
        CampArmy campArmy = battleArmy.getCampArmy();
        battleMsg.append(battleArmy.getPosition()).append(",").append(campArmy.getDiKang()).append("*");
      } 
      battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "#");
    } 
  }
}
